using System;
using System.Data;
using System.Collections;
using System.Web.UI.WebControls;
using System.Data.SqlClient;	// This is the library with the SQL types we're using below

namespace gchang_inventory
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	
	public class Bahamas : System.Web.UI.Page 
	{
		// Connection Strings
		protected string strSqlString = "server=128.208.1.31; uid=gychang; pwd=inventory; database=gchang_inventory";
		protected string strSqlStringBill = "server=128.208.1.31; uid=gychang; pwd=inventory; database=bpearl_billing";
		protected string strSqlStringShip = "server=128.208.1.31; uid=arw82; pwd=shipping; database=arw82_shipping";
		
		protected SqlConnection sqlConn;	// Declare a connection object
		protected SqlConnection sqlConnBill;	// Declare a connection object
		protected SqlConnection sqlConnShip;	// Declare a connection object

		protected SqlCommand sqlCom;		  // Declare a command object
		protected SqlDataReader sqlRdr;	  // Declare a reader to read the query result		

		// Format string for currency
		protected string currencyFormat = "{0:$#,##0.00;($#,##0.00)}";

		protected Bahamas()
		{
			sqlConn = new SqlConnection(strSqlString);
			sqlConnBill = new SqlConnection(strSqlStringBill);
			sqlConnShip = new SqlConnection(strSqlStringShip);
		}

		// Execute a query using an OPEN sqlconnection
		protected void executeQuery(SqlConnection sqlConn, string strSql, DataGrid dgrData)
		{		
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			// Get the answer from the reader and write it to the label.
			if (sqlRdr.HasRows) 
			{
				dgrData.Visible = true;
				dgrData.DataSource = sqlRdr;
				dgrData.DataBind();		
			}

			sqlRdr.Close();
		}

		// Execute a stored proc using an OPEN sqlconnection. Returns an SqlDataReader
		protected SqlDataReader executeStoredProcReader(SqlConnection sqlConn, string strSPName, SqlParameter[] sqlParams)
		{		
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSPName, sqlConn);	
			sqlCom.CommandType = CommandType.StoredProcedure;

			if (sqlParams != null)
			{
				for (int i = 0; i < sqlParams.Length; i++)
				{
					SqlParameter s = sqlCom.Parameters.Add(sqlParams[i]);
				}
			}            

			// Execute the command
			return sqlCom.ExecuteReader();
		}

		// Execute a stored proc using an OPEN sqlconnection. Returns an SqlDataAdapter
		protected SqlDataAdapter executeStoredProcAdapter(SqlConnection sqlConn, string strSPName, SqlParameter[] sqlParams)
		{		
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSPName, sqlConn);	
			sqlCom.CommandType = CommandType.StoredProcedure;

			if (sqlParams != null)
			{
				for (int i = 0; i < sqlParams.Length; i++)
				{
					SqlParameter s = sqlCom.Parameters.Add(sqlParams[i]);
				}
			}            

			SqlDataAdapter da = new SqlDataAdapter(sqlCom);
            
			// Return data adapter
			return da;
		}

		// Execute a stored proc that does an update or an insert using an OPEN sqlconnection.
		protected void executeStoredProcNonQuery(SqlConnection sqlConn, string strSPName, SqlParameter[] sqlParams)
		{		
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSPName, sqlConn);	
			sqlCom.CommandType = CommandType.StoredProcedure;

			if (sqlParams != null)
			{
				for (int i = 0; i < sqlParams.Length; i++)
				{
					SqlParameter s = sqlCom.Parameters.Add(sqlParams[i]);
				}
			}		

			sqlCom.ExecuteNonQuery();
		}

		
		// Executes a stored proc and returns the first datarow
		protected DataRow executeStoredProcDataRow(SqlConnection sqlConn, string strSPName, SqlParameter[] sqlParams)
		{
			DataSet ds = new DataSet();
			SqlDataAdapter sAdapter = executeStoredProcAdapter(sqlConn, strSPName, sqlParams);
			sAdapter.Fill(ds);
			DataTable dt = ds.Tables[0];
			DataRow dr = dt.Rows[0];			
			return dr;

		}

		// Removes duplicate entries in a data table based on a particular column
		protected DataTable removeDuplicates(DataTable dt, string strColumnName)
		{			
			DataTable dtTemp = dt.Clone();

			Hashtable keys = new Hashtable();

			foreach(DataRow row in dt.Rows)
			{
				if (!keys.ContainsKey(row[strColumnName]))
				{
					DataRow rowNew = dtTemp.NewRow();
                
					for (int iColumn=0; iColumn < dt.Columns.Count; iColumn++)
					{					
						rowNew[iColumn] = row[iColumn];
					}

					keys.Add(row["productID"], null);
					dtTemp.Rows.Add(rowNew);
				}
			}

			return dtTemp;
		}

		// Check's if a productID is a book. False if Disc.		
		protected bool checkIsBook(int productID)
		{
			SqlParameter[] sqlParams = new SqlParameter[1];
			sqlParams[0] = new SqlParameter("@productID", productID);			

			sqlConn.Open();
			SqlDataReader sqlReader = executeStoredProcReader(sqlConn, "sps_isBook", sqlParams);

			bool isBook = true;

			if (sqlReader.HasRows)
			{
				sqlReader.Read();			
				isBook = !(sqlReader.IsDBNull(0));				
			}			

			sqlReader.Close();
			sqlConn.Close();

			return isBook;
		}	

	}
}


