using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;	// This is the library with the SQL types we're using below
using System.Xml;
namespace gchang_inventory
{
	/// <summary>
	/// Summary description for ShoppingCart.
	/// </summary>
	public class Confirmation : Bahamas
	{	
		
		protected System.Web.UI.WebControls.DataGrid dgrDiscCart;
		protected System.Web.UI.HtmlControls.HtmlForm frmShoppingCart;		
		protected System.Web.UI.WebControls.DataGrid dgrBookCart;		
		protected System.Web.UI.WebControls.Button btnCancel;			
		protected System.Web.UI.WebControls.Button btnConfirm;		
		protected System.Web.UI.HtmlControls.HtmlGenericControl lblSubTotal;
		protected System.Web.UI.HtmlControls.HtmlGenericControl lblShipTotal;
		protected System.Web.UI.HtmlControls.HtmlGenericControl lblTotal;

		private int quantity;		
		private Hashtable hash;
		private string productID;
		private System.DateTime datetime;
		
		double bookTotal;
		double discTotal;
		protected System.Web.UI.WebControls.RadioButton Radiobutton1;
		protected System.Web.UI.WebControls.RadioButton Radiobutton2;
		double shipTotal;		
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			bookTotal = 0;
			discTotal = 0;
			shipTotal = 0;

			productID = Request.QueryString["productID"];
			quantity = Convert.ToInt32(Request.QueryString["quantity"]);
			
			// Customer is not logged in
			if (Session["customer#"] == null)
			{
				// Redirect accordingly
				if(productID != null)				
					Response.Redirect("Login.aspx?productID="+productID+"&quantity="+quantity);
				
				else
					Response.Redirect("Login.aspx");
				return;
			}			
			else		// Customer is logged in
			{			
				// Check that we have the necessary session variables
				if (Session["cart"] == null) 
				{
					Response.Redirect("home.aspx");				
				}				
				else
				{
					hash = (Hashtable)Session["cart"];
				}
			}

			// If not a postback (first load)
			if (!IsPostBack)
			{	
				// Get items currently in the shopping cart
				// Need to make a query string that returns all rows
				if(hash.Count > 0)
				{							
					// Book Query / Bind
					ICollection books = GetCartData(0);
					ICollection discs = GetCartData(1);
					
					dgrBookCart.DataSource = books;
					dgrBookCart.DataBind();

					// Discs Query / Bind
					dgrDiscCart.DataSource = discs;
					dgrDiscCart.DataBind();

					dgrBookCart.Visible = true;
					dgrDiscCart.Visible = true;					

					
					// Get the ship price
					Hashtable htShip = (Hashtable)Session["companyShip"];

					sqlConnShip.Open();

					foreach (string company in htShip.Keys)
					{
						SqlParameter[] sqlParams = new SqlParameter[2];
						sqlParams[0] = new SqlParameter("@methodid", Int32.Parse(htShip[company].ToString()));
						sqlParams[1] = new SqlParameter("@company", company);

						SqlDataReader sqlReader = executeStoredProcReader(sqlConnShip, "sps_getShipPrice", sqlParams);
						
						sqlReader.Read();
						shipTotal += Double.Parse(sqlReader.GetValue(0).ToString());
						sqlReader.Close();
					}

					sqlConnShip.Close();

					lblSubTotal.InnerHtml = String.Format(currencyFormat, discTotal + bookTotal);
					lblShipTotal.InnerHtml = String.Format(currencyFormat, shipTotal);
					lblTotal.InnerHtml = String.Format(currencyFormat, discTotal + bookTotal + shipTotal);
				}
				else
				{
					// There are no items in your shopping cart
					Response.Write("<font size='3' class='t1'><b>Your shopping cart is currently empty.</b></font>");
				}
			}
		}

		// CreateDataSource takes 0 for BOOK query and 1 for CD query
		private ICollection CreateDataSource(int type, Hashtable IDs)
		{
			DataTable dt = new DataTable();
			DataRow dr;
			
			dt.Columns.Add(new DataColumn("ProductID", typeof(string)));
			dt.Columns.Add(new DataColumn("price", typeof(double)));

			if(type ==0)
			{
				dt.Columns.Add(new DataColumn("title", typeof(string)));
			}
			else
			{
				dt.Columns.Add(new DataColumn("albumname", typeof(string)));
			}
			dt.Columns.Add(new DataColumn("delete", typeof(string)));
			string strType, strTitle, strID;
			
			if(type == 0)
			{
				strType = "books";
				strTitle = "title";
				strID = "bookID";
			}
			else
			{
				strType = "discs";
				strTitle = "albumname";
				strID = "discID";
			}
			string tempSql;
			
			// Query books or discs for each row and store the quantity
			foreach(string name in IDs.Keys) 
			{
				dr = dt.NewRow();
				
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	
				tempSql = "SELECT price, "+strTitle+", discount FROM products, " + strType +
					" WHERE productID = "+name+ 
					" AND products."+strID + "=" + strType + "."+strID;
				
				sqlCom = new SqlCommand(tempSql, sqlConn);	
				sqlRdr = sqlCom.ExecuteReader();
				sqlRdr.Read();				
				dr["ProductID"] = name;

				double listprice = (double)(sqlRdr.GetDecimal(0));
				double discount = (double)(sqlRdr.GetDecimal(2));

				dr["price"] = listprice - discount;

				if(type ==0)
				{
					dr["title"] = sqlRdr.GetString(1);
				}
				else
				{
					dr["albumname"] = sqlRdr.GetString(1);
				}
				dr["delete"] = "<a class='MAINLINK' href=\"ShoppingCart.aspx?delete="+name+"\">Delete</a>"; 

				dt.Rows.Add(dr);
			}
			sqlConn.Close(); // Close the connection..
			DataView dv = new DataView(dt);
			return dv;

		}	

		private ICollection GetCartData(int type)
		{
			string tempSql;
			//Book
			if(type == 0)
			{
				tempSql = "SELECT * FROM products WHERE bookID IS NOT NULL AND(";
			}
				//Disc
			else
			{
				tempSql = "SELECT * FROM products WHERE discID IS NOT NULL AND(";
			}
			// Query to return productIDs for each disc in teh cart
			int count = 0;
			foreach (string name in hash.Keys) 
			{
				if(count++ == 0)
				{
					tempSql+= " productID = " + name;
				}
				else
				{
					tempSql+= " OR productID = " + name;
				}
			}
			tempSql += ") ";

			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();		
			sqlCom = new SqlCommand(tempSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();
			// Bind query results to datagrid
			Hashtable IDs = new Hashtable();
			int tempID;
			int tempQuant;
			for(int i = 0; sqlRdr.Read(); i++)
			{
				tempID = sqlRdr.GetInt32(0);
				// Find product id and quantity match
				tempQuant = Convert.ToInt32(hash[""+tempID]);
				IDs[""+tempID] = "" +tempQuant;
			}
			sqlRdr.Close();
			if(IDs.Count > 0)
			{
				return CreateDataSource(type, IDs);
			}
			else
			{
				return null;
			}
			
		}


		#region Web Form Designer generated code

		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{			
			this.btnConfirm.Click += new System.EventHandler(this.btnConfirm_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion		

		private void createXMLDoc()
		{
			string strOrderDate;
			DateTime today = DateTime.Now;
			Hashtable allCompanies;
			allCompanies = (Hashtable)Session["allCompanies"];
			strOrderDate = today.Month + "-" + today.Day + "-" + today.Year +
				"-" + today.Hour + "-" + today.Minute+ "-" + today.Millisecond;
			foreach(string name in allCompanies.Keys)
			{
				XmlElement root, xmlCompIssue, xmlCompPartner, xmlProd;
				XmlText xmlText;
				// XML Doc Generation
				XmlDocument docXML = new XmlDataDocument();
				//Create root node
				root =  docXML.CreateElement("order");
				docXML.AppendChild(root);
				//Create issueCompany node
				xmlCompIssue = docXML.CreateElement("issuingCompany");
				xmlText = docXML.CreateTextNode("444a");
				xmlCompIssue.AppendChild(xmlText);
				root.AppendChild(xmlCompIssue);
				//Add partnerCompany
				xmlCompPartner = docXML.CreateElement("partnerCompany");
				xmlText = docXML.CreateTextNode(name);
				xmlCompPartner.AppendChild(xmlText);
				root.AppendChild(xmlCompPartner);
				Hashtable company = (Hashtable)allCompanies[name];
				foreach(string product in company.Keys)
				{
					sqlConn = new SqlConnection( strSqlString );
					string prodType, prodIdentifier, prodName, prodQuantity;
					XmlElement xmlType, xmlIdentifier, xmlName, xmlQuantity;
					
					SqlParameter[] sqlParams = new SqlParameter[1];
					sqlParams[0] = new SqlParameter("@productID", product);
					//Add product node
					xmlProd = docXML.CreateElement("product");
					root.AppendChild(xmlProd);

					//Query inventory to get type, id, name
					//Is a book?
					if(checkIsBook(Convert.ToInt32(product)))
					{
						prodType = "book";
						sqlConn.Open();
						SqlDataReader sqlRdr = executeStoredProcReader(sqlConn, "sps_getBookInfo", sqlParams);
						sqlRdr.Read();
						prodIdentifier = sqlRdr.GetString(0);
						prodName = sqlRdr.GetString(1);	
						sqlConn.Close();
					}
					else
					{
						prodType = "music";
						sqlConn.Open();
						SqlDataReader sqlRdr = executeStoredProcReader(sqlConn, "sps_getDiscInfo", sqlParams);
						sqlRdr.Read();
						prodIdentifier = sqlRdr.GetInt32(0).ToString();
						prodName = sqlRdr.GetString(1);
						sqlConn.Close();
					}
					
					//Add type
					xmlType = docXML.CreateElement("type");
					xmlText = docXML.CreateTextNode(prodType);
					xmlType.AppendChild(xmlText);
					xmlProd.AppendChild(xmlType);
					//Add identifier
					xmlIdentifier = docXML.CreateElement("identifier");
					xmlText = docXML.CreateTextNode(prodIdentifier);
					xmlIdentifier.AppendChild(xmlText);
					xmlProd.AppendChild(xmlIdentifier);
					//Add name
					xmlName = docXML.CreateElement("name");
					xmlText = docXML.CreateTextNode(prodName);
					xmlName.AppendChild(xmlText);
					xmlProd.AppendChild(xmlName);
					//Add quantity
					xmlQuantity = docXML.CreateElement("quantity");
					xmlText = docXML.CreateTextNode(company[product].ToString());
					xmlQuantity.AppendChild(xmlText);
					xmlProd.AppendChild(xmlQuantity);

					
						
				}
				string custAddress, custCity, custState, custZip, custTel;
				XmlElement xmlShip, xmlDest, xmlAddr, xmlCity, xmlState, xmlZip, xmlContact, xmlTel, xmlFax;
				//Add shippingMethod
				xmlShip = docXML.CreateElement("shippingMethod");
				xmlText = docXML.CreateTextNode(((Hashtable)Session["companyShip"])[name].ToString());
				xmlShip.AppendChild(xmlText);
				root.AppendChild(xmlShip);
				//Add desination
				xmlDest = docXML.CreateElement("destination");
				root.AppendChild(xmlDest);

				SqlParameter[] sqlParamsBill = new SqlParameter[1];
				if(Session["shippingCust#"]!=null)
				{
					sqlParamsBill[0] = new SqlParameter("@customer#", Convert.ToInt32(Session["shippingCust#"]));
				}
				else
				{
					sqlParamsBill[0] = new SqlParameter("@customer#", Convert.ToInt32(Session["customer#"]));
				}
				sqlConn = new SqlConnection(strSqlStringBill);

				// Query Customer Information
				sqlConn.Open();
				SqlDataReader sqlRdr2 = executeStoredProcReader(sqlConn, "sps_getXMLCustomerInfo", sqlParamsBill);
				sqlRdr2.Read();
				// Returned Columns: ad_street, ad_city, ad_state, ad_zip, phone
				custAddress = sqlRdr2.GetString(0);
				custCity = sqlRdr2.GetString(1);
				custState = sqlRdr2.GetString(2);
				custZip = sqlRdr2.GetInt32(3).ToString();
				custTel = sqlRdr2.GetInt64(4).ToString();
				sqlConn.Close();

				//Add address
				xmlAddr = docXML.CreateElement("address");
				xmlText = docXML.CreateTextNode(custAddress);
				xmlAddr.AppendChild(xmlText);
				xmlDest.AppendChild(xmlAddr);
				//Add city
				xmlCity = docXML.CreateElement("city");
				xmlText = docXML.CreateTextNode(custCity);
				xmlCity.AppendChild(xmlText);
				xmlDest.AppendChild(xmlCity);
				//Add state
				xmlState = docXML.CreateElement("state");
				xmlText = docXML.CreateTextNode(custState);
				xmlState.AppendChild(xmlText);
				xmlDest.AppendChild(xmlState);
				//Add zip
				xmlZip = docXML.CreateElement("zip");
				xmlText = docXML.CreateTextNode(custZip);
				xmlZip.AppendChild(xmlText);
				xmlDest.AppendChild(xmlZip);
				//Add contact
				xmlContact = docXML.CreateElement("contact");
				xmlDest.AppendChild(xmlContact);
				//Add tel
				xmlTel = docXML.CreateElement("tel");
				xmlText = docXML.CreateTextNode(custTel);
				xmlTel.AppendChild(xmlText);
				xmlContact.AppendChild(xmlTel);
				//Add fax
				xmlFax = docXML.CreateElement("fax");
				xmlContact.AppendChild(xmlFax);

				
				string s = Server.MapPath(".\\orders\\") +"cust-"+Convert.ToString(Session["customer#"])+"_comp-"+name+"_date-"+strOrderDate+".xml";

				// Only generate xml's for partner companies
				if (name != "444a") docXML.Save(s);

				// End XML Doc Generation
			}
			

			

		}
		protected void btnConfirm_Click(object sender, System.EventArgs e)
		{
			// Create XML File if a product is ordered from a partner
			if(Session["allCompanies"] != null)
				createXMLDoc();			

			// Redirect to thank you page and clear session.
			int customer = Int32.Parse(Session["customer#"].ToString());
            
			Session.Clear();
			Session.Add("customer#", customer);
			Response.Redirect("ThankYou.aspx");
			
			return;


			int iInvoice_num, iBuyer_cust_num, iReceiver_cust_num, iProductID;
			double dPrice, dDiscount, dTax, dTotal;
			string strDate, strTitle, strWarehouse1, strWarehouse2, strWarehouse3, strExp_delivery, tempSql;			
		
			
			tempSql = "SELECT i_id from invoices WHERE i_id >= ALL (SELECT i_id from invoices)";
			sqlConn = new SqlConnection( strSqlStringBill );
			sqlConn.Open();	
			sqlCom = new SqlCommand(tempSql, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();


			// Initialize billing variables
			iBuyer_cust_num = Convert.ToInt32(Session["customer#"]);
			datetime = System.DateTime.Today;
			//strDate = datetime.Day + "/"+datetime.Month + "/" +datetime.Year;
			strDate = "2/18/05";
			//strDate = datetime.ToShortDateString();

			if(Session["shippingCust#"] !=null)
			{
				iReceiver_cust_num = Convert.ToInt32(Session["shippingCust#"]);
			}
			else
			{
				iReceiver_cust_num = iBuyer_cust_num;
			}
            
			if (sqlRdr.Read()) 
			{
				iInvoice_num = 1+sqlRdr.GetInt32(0);
			}
			else
			{
				iInvoice_num = 1;
			}
			sqlConn.Close();
			
			dTax = 0;
			dDiscount = 0;
			dPrice = 0;
			dTotal = 0;
			strTitle = "blank";

			Hashtable hash = (Hashtable)Session["cart"];
			sqlConnBill.Open();
			foreach(string name in hash.Keys)
			{
				SqlParameter[] sqlParamBillInvoice = new SqlParameter[10];		
				SqlParameter[] sqlParamBillItem = new SqlParameter[5];	
				SqlParameter[] sqlParamBillDelivery = new SqlParameter[6];	
				sqlParamBillInvoice[0] = new SqlParameter("@invoice", iInvoice_num);
				sqlParamBillInvoice[1] = new SqlParameter("@order_date", strDate);
				sqlParamBillInvoice[2] = new SqlParameter("@buyer_cust#", iBuyer_cust_num);
				sqlParamBillInvoice[3] = new SqlParameter("@receiver_cust#", iReceiver_cust_num);
				sqlParamBillInvoice[4] = new SqlParameter("@shipping_type", "Ground");
				sqlParamBillInvoice[5] = new SqlParameter("@price", dPrice);
				sqlParamBillInvoice[6] = new SqlParameter("@tax", dTax);
				sqlParamBillInvoice[7] = new SqlParameter("@discount", dDiscount);
				sqlParamBillInvoice[8] = new SqlParameter("@total", dTotal);
				// Must set the productID within the foreach loop - DONE

				// ProductID set within the foreach loop
				sqlParamBillItem[1] = new SqlParameter("@invoice#", iInvoice_num);
				sqlParamBillItem[2] = new SqlParameter("@name", strTitle);
				// Quantity is set within the foreach loop
				// Price is set withint the foreach loop

				sqlParamBillDelivery[0] = new SqlParameter("@invoice", iInvoice_num);
				sqlParamBillDelivery[1] = new SqlParameter("@warehouse1", "1");
				sqlParamBillDelivery[2] = new SqlParameter("@warehouse2", "");
				sqlParamBillDelivery[3] = new SqlParameter("@warehouse3", "");
				//sqlParamBillDelivery[2] = new SqlParameter("@warehouse2", strWarehouse2);
				//sqlParamBillDelivery[3] = new SqlParameter("@warehouse3", strWarehouse3);
				sqlParamBillDelivery[4] = new SqlParameter("@exp_delivery", iInvoice_num);
				// Product ID will be set within the foreach loop

				// if everything ok
				// Add 1 entry to deliveries
				// For each item in the cart add to invoices, items
				//Hashtable hash = (Hashtable)Session["cart"];
				/*
				sqlConnBill.Open();
				foreach(string name in hash.Keys)
				{*/
				
				// insert into invoices
				sqlParamBillInvoice[9] = new SqlParameter("@productID", name);
				
				// insert into items
				sqlParamBillItem[0] = new SqlParameter("@productID", name);
				sqlParamBillItem[3] = new SqlParameter("@quant", Convert.ToString(hash[name]));
				sqlParamBillItem[4] = new SqlParameter("@price", Convert.ToDecimal("0"));

				// insert into billing delivery 
				sqlParamBillDelivery[5] = new SqlParameter("@productID", name);

				// deduct from inventory
				sqlConn.Open();
				/* sqlParamsInv[] = new SqlParameter[3];
				sqlParamsInv[0] = new SqlParameter("@productID", name);
				sqlParamsInv[1] = new SqlParameter("@warehouse", name); */

				
				// insert into items
				sqlParamBillItem[0] = new SqlParameter("@productID", name);
				sqlParamBillItem[3] = new SqlParameter("@quant", Convert.ToString(hash[name]));
				sqlParamBillItem[4] = new SqlParameter("@price", Convert.ToDecimal("0"));
				//executeStoredProcNonQuery(sqlConnBill, "spi_insertInvoice", sqlParamBillInvoice);
				sqlConn.Close();

				//insert into warehouses

				
				executeStoredProcNonQuery(sqlConnBill, "spi_insertInvoice", sqlParamBillInvoice);
				executeStoredProcNonQuery(sqlConnBill, "spi_insertItem", sqlParamBillItem);
				executeStoredProcNonQuery(sqlConnBill, "spi_insertDelivery", sqlParamBillDelivery);
			}
			sqlConnBill.Close();


			// AARON'S INSERT

			//Hashtable packhash = (Hashtable)Session["package"];

			SqlParameter[] methodparam = new SqlParameter[1];
			SqlParameter[] methodparam2 = new SqlParameter[1];

			SqlParameter[] custparam = new SqlParameter[1];
			custparam[0] = new SqlParameter("@customer#", iReceiver_cust_num);

			DataRow dr;
			sqlConnBill.Open();
			dr = (executeStoredProcDataRow(sqlConnBill, "sps_getCustomerInfo", custparam));
			sqlConnBill.Close();

			/* foreach(string x in packhash.Keys)
			{
				SqlParameter[] sqlParamShip = new SqlParameter[13];

				methodparam[0] = new SqlParameter("@methodid2", ((ArrayList)packhash[x])[1]);
				methodparam2[0] = new SqlParameter("@methodid3", ((ArrayList)packhash[x])[1]);

				sqlParamShip[0]  = new SqlParameter("@invoice", iInvoice_num);
				sqlParamShip[1]  = new SqlParameter("@items", ((ArrayList)packhash[x])[0] );
				sqlParamShip[2]  = new SqlParameter("@methodid", ((ArrayList)packhash[x])[1] );
				sqlConnShip.Open();
				sqlParamShip[3]  = new SqlParameter("@shipvendor", (executeStoredProcDataRow(sqlConnShip, "sps_getShipVendor", methodparam))[0].ToString());
				if (Session["specialShip"] == null)
					sqlParamShip[4]  = new SqlParameter("@instructions", "");
				else
					sqlParamShip[4]  = new SqlParameter("@instructions", Session["specialShip"]);
				sqlParamShip[5]  = new SqlParameter("@warehouseid", Convert.ToInt32(x));
				sqlParamShip[6]  = new SqlParameter("@personname", dr[0].ToString() + " " +	dr[1].ToString());
				sqlParamShip[7]  = new SqlParameter("@address", dr[2].ToString());
				sqlParamShip[8]  = new SqlParameter("@city", dr[3].ToString());
				sqlParamShip[9]  = new SqlParameter("@state", dr[4].ToString());
				sqlParamShip[10] = new SqlParameter("@zip", dr[5].ToString());
				sqlParamShip[11] = new SqlParameter("@phone", dr[6].ToString());
				//sqlParamShip[12] = new SqlParameter("@maxarrival", datetime.ToShortDateString() + (executeStoredProcSingleValue(sqlConnShip, "sps_getShipMaxTime", methodparam2))[0].ToString());
				//sqlParamShip[12] = new SqlParameter("@maxarrival", (executeStoredProcSingleValue(sqlConnShip, "sps_getShipMaxTime", methodparam2))[0].ToString());
				sqlParamShip[12] = new SqlParameter("@maxarrival", "3/8/05");
				executeStoredProcNonQuery(sqlConnShip, "spi_InsertPackage", sqlParamShip);
				sqlConnShip.Close();
				// END OF AARON'S INSERT
			} */
			
			

		}

		protected void btnCancel_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("home.aspx");
		}

		protected void dgrBookCart_ItemDataBound(Object sender, DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				// Set the title to be a link to details
				e.Item.Cells[1].Text = "<a href='search.aspx?productID=" + e.Item.Cells[0].Text + "' class='mainlink'>" + e.Item.Cells[1].Text + "</a>";
				
				// Set the correct quantity in the text box
				string tempProductID = e.Item.Cells[0].Text;
				string tempQuantity = (string)hash[tempProductID];
				((Label)e.Item.FindControl("lblBookQuantity")).Text = tempQuantity;
				
				double unit = Double.Parse(e.Item.Cells[3].Text);
				double total = Double.Parse(tempQuantity) * Double.Parse(e.Item.Cells[4].Text);

				bookTotal += total;
				
				e.Item.Cells[3].Text = "<font class='TXT' size='2'>" + String.Format(currencyFormat, unit) + "</font>";
				e.Item.Cells[4].Text = "<font class='TXT' size='2'><b>" + String.Format(currencyFormat, total) + "</b></font>";
			}
			else if (e.Item.ItemType == ListItemType.Footer)
			{
				e.Item.Cells[4].Text = String.Format(currencyFormat, bookTotal);
			}
		}
		
		protected void dgrDiscCart_ItemDataBound(Object sender, DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				// Set the title to be a link to details
				e.Item.Cells[1].Text = "<a href='search.aspx?productID=" + e.Item.Cells[0].Text + "' class='mainlink'>" + e.Item.Cells[1].Text + "</a>";
				
				// Set the correct quantity in the text box
				string tempProductID = e.Item.Cells[0].Text;
				string tempQuantity = (string)hash[tempProductID];
				((Label)e.Item.FindControl("lblDiscQuantity")).Text = tempQuantity;
				
				double unit = Double.Parse(e.Item.Cells[3].Text);
				double total = Double.Parse(tempQuantity) * Double.Parse(e.Item.Cells[4].Text);

				discTotal += total;
				
				e.Item.Cells[3].Text = "<font class='TXT' size='2'>" + String.Format(currencyFormat, unit) + "</font>";
				e.Item.Cells[4].Text = "<font class='TXT' size='2'><b>" + String.Format(currencyFormat, total) + "</b></font>";
			}
			else if (e.Item.ItemType == ListItemType.Footer)
			{
				e.Item.Cells[4].Text = String.Format(currencyFormat, discTotal);
			}
			
		}
	}
}
