using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace gchang_inventory
{
	/// <summary>
	/// Summary description for EditAccount.
	/// </summary>
	public class EditAccount : Bahamas
	{
		protected System.Web.UI.WebControls.TextBox oldpassword;
		protected System.Web.UI.WebControls.TextBox pw1;
		protected System.Web.UI.WebControls.TextBox pw2;
		protected System.Web.UI.WebControls.TextBox fname;
		protected System.Web.UI.WebControls.TextBox lname;
		protected System.Web.UI.WebControls.TextBox ad_street;
		protected System.Web.UI.WebControls.TextBox ad_city;
		protected System.Web.UI.WebControls.TextBox ad_state;
		protected System.Web.UI.WebControls.TextBox ad_zip;
		protected System.Web.UI.WebControls.TextBox phone1;
		protected System.Web.UI.WebControls.TextBox phone2;
		protected System.Web.UI.WebControls.TextBox phone3;
		protected System.Web.UI.WebControls.TextBox email1;
		protected System.Web.UI.WebControls.TextBox email2;
		protected System.Web.UI.WebControls.TextBox cc;
		protected System.Web.UI.WebControls.DropDownList gender;		
		protected System.Web.UI.WebControls.Button Submit;
		protected System.Web.UI.WebControls.Button btnCancel;

		protected string customer;
		

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Get customer from session
			if (Session["customer#"] == null) 
				Response.Redirect("Login.aspx");
			else
				customer = Session["customer#"].ToString();
			
			// Put user code to initialize the page here
			if (!IsPostBack)
			{	
				SqlParameter[] sqlParams = new SqlParameter[1];
				sqlParams[0] = new SqlParameter("@customer#", Int32.Parse(customer));
				
				sqlConnBill.Open();
				
				SqlDataReader sqlReader = executeStoredProcReader(sqlConnBill, "sps_getCustomerInfo", sqlParams);			
				
				if (sqlReader.Read())
				{					

					fname.Text = sqlReader.GetString(0);
					lname.Text = sqlReader.GetString(1);
					ad_street.Text = sqlReader.GetString(2);
					ad_city.Text = sqlReader.GetString(3);
					ad_state.Text = sqlReader.GetString(4);
					ad_zip.Text = sqlReader.GetInt32(5).ToString();

					string phoneno = sqlReader.GetInt64(6).ToString();
					phone1.Text = phoneno.Substring(0, 3);
					phone2.Text = phoneno.Substring(3, 3);
					phone3.Text = phoneno.Substring(6, 4);
					
					email1.Text = sqlReader.GetString(7);

					cc.Text = sqlReader.GetInt64(8).ToString();
					
					string genderChar = sqlReader.GetString(9);

					if (genderChar.ToString().ToUpper() == "M")
						gender.SelectedIndex = 0;
					else
						gender.SelectedIndex = 1;                    
				}

				sqlConnBill.Close();
			}
		}

		protected void btnCancel_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("home.aspx");
		}

		protected void btnSubmit_Click(object sender, System.EventArgs e)
		{			
			// Get the current password
			sqlConnBill.Open();	

			SqlParameter[] sqlParams = new SqlParameter[1];
			sqlParams[0] = new SqlParameter("@customer#", Int32.Parse(customer));
			
			sqlRdr = executeStoredProcReader(sqlConnBill, "sps_getPassword", sqlParams);

			string oldPass = "";
			
			if(sqlRdr.Read())
				oldPass = sqlRdr.GetString(0);

            sqlConnBill.Close();
			
			// Do some error checking
			if (oldPass != oldpassword.Text)
			{
				Response.Write("<font size='3' class='t1'><b>Current password does not match our records.</b></font>");
				return;
			}

			if (pw1.Text != pw2.Text)
			{
				Response.Write("<font size='3' class='t1'><b>New passwords do not match.</b></font>");
				return;
			}

			if (email1.Text != email2.Text)
			{
				Response.Write("<font size='3' class='t1'><b>Email addresses do not match.</b></font>");
				return;
			}

			// We're through! 
			string genderstring = "";
			
			if (gender.SelectedIndex == 0)
				genderstring = "M";
			else
				genderstring = "F";

			long phone = Int64.Parse(phone1.Text + phone2.Text + phone3.Text);
			
			sqlParams = new SqlParameter[12];
			sqlParams[0] = new SqlParameter("@customer#", Int32.Parse(customer));
			sqlParams[1] = new SqlParameter("@password", pw1.Text);			
			sqlParams[2] = new SqlParameter("@fname", fname.Text);
			sqlParams[3] = new SqlParameter("@lname", lname.Text);
			sqlParams[4] = new SqlParameter("@ad_street", ad_street.Text);
			sqlParams[5] = new SqlParameter("@ad_city", ad_city.Text);
			sqlParams[6] = new SqlParameter("@ad_state", ad_state.Text);
			sqlParams[7] = new SqlParameter("@ad_zip", Int64.Parse(ad_zip.Text));
			sqlParams[8] = new SqlParameter("@phone", phone);
			sqlParams[9] = new SqlParameter("@email", email1.Text);
			sqlParams[10] = new SqlParameter("@creditcard", Int64.Parse(cc.Text));
			sqlParams[11] = new SqlParameter("@gender", genderstring);

			sqlConnBill.Open();
			executeStoredProcNonQuery(sqlConnBill, "spu_customerInfo", sqlParams);
			sqlConnBill.Close();

			Response.Redirect("EditAccountOK.aspx");
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}




