using System;
using System.Globalization;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;	// This is the library with the SQL types we're using below

namespace gchang_inventory
{
	/// <summary>
	/// Summary description for Login.
	/// </summary>
	public class Login : Bahamas
	{
		protected System.Web.UI.WebControls.TextBox txtUsername;
		protected System.Web.UI.WebControls.TextBox txtPassword;
		protected System.Web.UI.WebControls.Button btnSubmit;
		protected System.Web.UI.WebControls.RadioButton rdbNewUser;

		private string productID;
		private int quantity;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			productID = Request.QueryString["productID"];
			quantity = Convert.ToInt32(Request.QueryString["quantity"]);

			if (this.IsPostBack)
			{
				// *** Must handle case where user is 'auto-submitting'
				//     without clicking the button.
				if (Request.Form["btnSubmit"] == null) this.btnSubmit_Click(this, null);
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{  			
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		protected void btnSubmit_Click(object sender, System.EventArgs e)
		{
			if (rdbNewUser.Checked == true)
			{
				Response.Redirect("CreateAccount.aspx?username=" + System.Web.HttpUtility.UrlEncode(txtUsername.Text) + "&" + Request.QueryString.ToString());
				return;
			}

			SqlParameter[] sqlParams = new SqlParameter[1];
			sqlParams[0] = new SqlParameter("@username", txtUsername.Text);
			
			sqlConnBill.Open();	
			
			SqlDataReader sqlReader = executeStoredProcReader(sqlConnBill, "sps_getLoginInfo", sqlParams);

			int customer_num;
			if (sqlReader.Read())
			{
				// Login OK
				if (txtPassword.Text == sqlReader.GetString(1))
				{
					customer_num = sqlReader.GetInt32(2);
					sqlConnBill.Close();

					// Clear the session
					Session.Clear();
					
					// Set the session
					Session.Add("customer#", customer_num);					

					// Redirect accordingly
					if(Request.QueryString["home"] != null)
						Response.Redirect("home.aspx");
				
					else if(Request.QueryString["productID"] != null && Request.QueryString["quantity"] != null)
						Response.Redirect("ShoppingCart.aspx?productID="+productID+"&quantity="+quantity);

					else				
						Response.Redirect("ShoppingCart.aspx");

					return;
				}
				
			}
			
			// Login Failed
			sqlConnBill.Close();
			Response.Write("<font class='T1' size=3><b>The login name and password you entered do not match any accounts on record.</b></font>");
		}
	}
}
