using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;	// This is the library with the SQL types we're using below


namespace gchang_inventory
{
	/// <summary>
	/// Summary description for browse.
	/// </summary>
	
	public class Search : Bahamas
	{
		protected System.Web.UI.HtmlControls.HtmlForm frmBrowse;
		protected System.Web.UI.WebControls.TextBox txtSearch;
		protected System.Web.UI.WebControls.DropDownList ddlSearch;
		protected System.Web.UI.WebControls.ImageButton btnSearch;
		protected System.Web.UI.WebControls.Button btnViewDiscs;
		protected System.Web.UI.WebControls.Button btnViewBooks;
		protected System.Web.UI.WebControls.Button btnViewAll;
		protected System.Web.UI.HtmlControls.HtmlGenericControl fraResults;
			
		private void Page_Load(object sender, System.EventArgs e)
		{						
			txtSearch.Attributes.Add("onFocus", "txtSearch_focus();");

			if (this.IsPostBack)
			{
				// *** Must handle case where user is 'auto-submitting'
				//     without clicking the button.
				if (Request.Form["btnSearch"] == null) this.btnSearch_Click(this, null);
			}
			else
			{
				string productID = Request.QueryString.Get("productID");
				if (productID != null && productID != "")
				{
					fraResults.Attributes.Add("src", "details.aspx?productID=" + productID);
					return;
				}
				
				string action = Request.QueryString.Get("action");
				
				switch (action)
				{
					case "1":
						btnViewDiscs_Click(null, null);
						break;

					case "2":
						btnViewBooks_Click(null, null);
						break;

					case "3":
						btnViewAll_Click(null, null);
						break;
				}
			}
		}   
	
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{  			
			btnViewDiscs.Click += new System.EventHandler(this.btnViewDiscs_Click);
			btnViewBooks.Click += new System.EventHandler(this.btnViewBooks_Click);
			btnViewAll.Click += new System.EventHandler(this.btnViewAll_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		protected void btnSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e) 
		{			
			fraResults.Attributes.Add("src", "Results.aspx?action=0&index=" + ddlSearch.SelectedIndex + "&search=" + System.Web.HttpUtility.UrlEncode(txtSearch.Text));
		}

		protected void btnViewDiscs_Click(object sender, System.EventArgs e) 
		{
			fraResults.Attributes.Add("src", "Results.aspx?action=1");
		}

		protected void btnViewBooks_Click(object sender, System.EventArgs e) 
		{
			fraResults.Attributes.Add("src", "Results.aspx?action=2");
		}

		protected void btnViewAll_Click(object sender, System.EventArgs e) 
		{
			fraResults.Attributes.Add("src", "Results.aspx?action=3");
		}
        
	}
}
