using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace gchang_inventory
{
	/// <summary>
	/// Summary description for shipping.
	/// </summary>
	public class shipping : Bahamas
	{
		protected DataGrid dgrShip;		

		Hashtable htShip;
		Hashtable htShipText;
		Hashtable htShipValue;

		private void Page_Load(object sender, System.EventArgs e)
		{
			htShip = (Hashtable)Session["companyShip"];
			
			if (!IsPostBack)
			{				
				
				htShipText = new Hashtable();
				htShipValue = new Hashtable();				

				htShipText = new Hashtable();
				htShipValue = new Hashtable();

				string city = Session["city"].ToString();

				// Get available shipping methods for each company
				sqlConnShip.Open();
			
				foreach (string company in htShip.Keys)
				{				
					// Execute stored procedure
					SqlParameter[] sqlParams = new SqlParameter[2];
					sqlParams[0] = new SqlParameter("@city", city);
					sqlParams[1] = new SqlParameter("@company", company);
				
					SqlDataReader sqlReader = executeStoredProcReader(sqlConnShip, "sps_getShippingMethods", sqlParams);

					// Store the method name and method id in parallel arraylists
					ArrayList shipText = new ArrayList();
					ArrayList shipValue = new ArrayList();

					while (sqlReader.Read())
					{
						shipValue.Add(sqlReader["shipid"]);
						shipText.Add(sqlReader["methodname"].ToString() + " - " + String.Format(currencyFormat, Double.Parse(sqlReader["price"].ToString())));
					}

					sqlReader.Close();

					htShipText.Add(company, shipText);
					htShipValue.Add(company, shipValue);
				}
			
				sqlConnShip.Close();

				DataTable dtShip = new DataTable();
				DataColumn colCompany = new DataColumn("company", typeof(string));
				DataColumn colMethod = new DataColumn("method");

				dtShip.Columns.Add(colCompany);
				dtShip.Columns.Add(colMethod);

				foreach (string name in htShip.Keys)
				{
					DataRow row = dtShip.NewRow();
					row["company"] = name;
					row["method"] = null;

					dtShip.Rows.Add(row);
				}

				dgrShip.DataSource = dtShip;
				dgrShip.DataBind();
			}
		}
			

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		/* protected void ddlShip_SelectedIndexChanged(Object sender, System.EventArgs e)
		{
			DropDownList ddlShip = (DropDownList)sender;

			TableCell cell = ddlShip.Parent as TableCell;
			DataGridItem item = ddlShip.Parent as DataGridItem;

			string company = item.Cells[0].Text;

			sqlConnShip.Open();

			SqlParameter[] sqlParams = new SqlParameter[2];
			sqlParams[0] = new SqlParameter("@methodid", Int32.Parse(htShip[company].ToString()));
			sqlParams[1] = new SqlParameter("@company", company);				

			SqlDataReader sqlReader = executeStoredProcReader(sqlConnShip, "sps_getShipPrice", sqlParams);
						
			sqlReader.Read();
			double shipCost = Double.Parse(sqlReader.GetValue(0).ToString());
			sqlReader.Close();
			
			sqlConnShip.Close();
			
			item.Cells[2].Text = "<font class='TXT' size='2'>" + String.Format(currencyFormat, shipCost) + "</font>";
		} */

		protected void dgrExternalShip_ItemDataBound(Object sender, DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				string company = e.Item.Cells[0].Text;
				
				DropDownList ddlShip = (DropDownList)e.Item.Cells[1].FindControl("ddlShip");				
                
				ArrayList valueList = ((ArrayList)htShipValue[company]);
				ArrayList textList = ((ArrayList)htShipText[company]);
				
				for (int i = 0; i < valueList.Count; i++)
				{
					ddlShip.Items.Add(new ListItem(textList[i].ToString(), valueList[i].ToString()));
				}
			}
		}

		protected void btnContinue_Click(object sender, System.EventArgs e)
		{	
			// Iterate through each company and store their ship option
			foreach(DataGridItem i in dgrShip.Items)
			{				
				if (i.ItemType == ListItemType.Item || i.ItemType == ListItemType.AlternatingItem)
				{
					DropDownList ddlShip = (DropDownList)i.Cells[1].FindControl("ddlShip");
					htShip[i.Cells[0].Text] = ddlShip.SelectedValue;
				}
			}

			Session["companyShip"] = htShip;
			
			Response.Redirect("Confirmation.aspx");
		}
	}
}


