using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;	// This is the library with the SQL types we're using below

namespace gchang_inventory
{
	/// <summary>
	/// Summary description for ShoppingCart.
	/// </summary>
	public class ShoppingCart : Bahamas
	{	
		
		protected System.Web.UI.WebControls.DataGrid dgrDiscCart;
		protected System.Web.UI.HtmlControls.HtmlForm frmShoppingCart;
		protected System.Web.UI.HtmlControls.HtmlForm frmReturn;
		protected System.Web.UI.WebControls.DataGrid dgrBookCart;
		protected System.Web.UI.WebControls.Button btnUpdate;
		protected System.Web.UI.WebControls.Button btnCheckout;			
		protected System.Web.UI.WebControls.Button btnOK;
		protected System.Web.UI.HtmlControls.HtmlGenericControl lblSubTotal;

		private int quantity;		
		private Hashtable hash;
		private string productID;

		protected double discTotal;
		protected double bookTotal;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			discTotal = 0;
			bookTotal = 0;

			frmReturn.Visible = false;

			productID = Request.QueryString["productID"];
			quantity = Convert.ToInt32(Request.QueryString["quantity"]);
			
			// Customer is not logged in
			if (Session["customer#"] == null)
			{
				// Redirect accordingly
				if(productID != null)				
					Response.Redirect("Login.aspx?productID="+productID+"&quantity="+quantity);
				
				else
					Response.Redirect("Login.aspx");
				return;
			}			
			else		// Customer is logged in
			{			
				// Get the current cart if any
				if (Session["cart"] == null)				
					hash = new Hashtable();
				
				else				
					hash = (Hashtable)Session["cart"];				
			}

			// Remove item from the cart if a delete was requested
			if(Request.QueryString["delete"]!=null)
			{				
				string tempID = Convert.ToString(Request.QueryString["delete"]);
				hash.Remove(tempID);
				Session["cart"] = hash;
				Hashtable companyShip = (Hashtable)Session["companyShip"];
				Hashtable allCompanies = (Hashtable)Session["allCompanies"];
				foreach(string company in allCompanies.Keys)
				{
					Hashtable curComp = (Hashtable)allCompanies[company];
					if(curComp.Contains(tempID))
					{
						curComp.Remove(tempID);
						if(curComp.Count == 0)
						{
							allCompanies.Remove(company);
							companyShip.Remove(company);
						}
						break;
					}
				}
			}

			// If not a postback (first load)
			if (!IsPostBack)
			{			
				// Is an item being added to the shopping cart?
				if(productID != null)
				{
					// See if item exists in shopping cart
					if(hash.Contains(productID))
					{
						// Add new quantity to total
						int total = Convert.ToInt32(hash[productID]);
						total += quantity;
						hash[productID] = ""+total;
					}
					else
					{
						// Add new product to the cart
						hash.Add(productID, ""+quantity); // Store ID, Quantity as strings
					}
					Session["cart"] = hash;
				}
			
				// Get items currently in the shopping cart
				// Need to make a query string that returns all rows
				if(hash.Count > 0)
				{							
					// Book Query / Bind
					ICollection books = GetCartData(0);
					ICollection discs = GetCartData(1);
					
					dgrBookCart.DataSource = books;
					dgrBookCart.DataBind();

					// Discs Query / Bind
					dgrDiscCart.DataSource = discs;
					dgrDiscCart.DataBind();

					dgrBookCart.Visible = true;
					dgrDiscCart.Visible = true;	
				
					lblSubTotal.InnerHtml = String.Format(currencyFormat, discTotal + bookTotal);
				}
				else
				{
					// There are no items in your shopping cart
					Response.Write("<font size='3' class='t1'><b>Your shopping cart is currently empty.</b></font>");					
					frmShoppingCart.Visible = false;					
					frmReturn.Visible = true;
				}
			}
		}

		// CreateDataSource takes 0 for BOOK query and 1 for CD query
		private ICollection CreateDataSource(int type, Hashtable IDs)
		{
			DataTable dt = new DataTable();
			DataRow dr;
			
			dt.Columns.Add(new DataColumn("ProductID", typeof(string)));
			dt.Columns.Add(new DataColumn("price", typeof(double)));
			dt.Columns.Add(new DataColumn("company", typeof(string)));

			if(type ==0)
			{
				dt.Columns.Add(new DataColumn("title", typeof(string)));
			}
			else
			{
				dt.Columns.Add(new DataColumn("albumname", typeof(string)));
			}
			dt.Columns.Add(new DataColumn("delete", typeof(string)));
			string strType, strTitle, strID;
			
			if(type == 0)
			{
				strType = "books";
				strTitle = "title";
				strID = "bookID";
			}
			else
			{
				strType = "discs";
				strTitle = "albumname";
				strID = "discID";
			}
			string tempSql;
			
			// Query books or discs for each row and store the quantity
			foreach(string name in IDs.Keys) 
			{
				dr = dt.NewRow();
				
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	
				/*tempSql = "SELECT price, "+strTitle+", discount FROM products, " + strType +
					" WHERE productID = "+name+ 
					" AND products."+strID + "=" + strType + "."+strID;
				*/
				 //Query that also returns the companyName column
				tempSql = "SELECT price, "+strTitle+", discount, companyName FROM products, " + strType +
				" WHERE productID = "+name+ 
				" AND products."+strID + "=" + strType + "."+strID;
				
				
				sqlCom = new SqlCommand(tempSql, sqlConn);	
				sqlRdr = sqlCom.ExecuteReader();
				sqlRdr.Read();				
				dr["ProductID"] = name;

				double listprice = (double)(sqlRdr.GetDecimal(0));
				double discount = (double)(sqlRdr.GetDecimal(2));
				// add partner companies to the company AL
				
				string company = (string)(sqlRdr.GetString(3));
				//if(company != "444a")
				//{
					// add partner companies
					Hashtable companyShip, companyCart, allCompanies;
					if(Session["companyShip"] == null)
					{
						companyShip = new Hashtable();
					}
					else
					{
						companyShip = (Hashtable)Session["companyShip"];
					}
					if(!companyShip.Contains(company))
						companyShip.Add(company, "");
					Session["companyShip"] = companyShip;

					// See if allCompanies exists
					if(Session["allCompanies"] == null)
					{
						allCompanies = new Hashtable();
					}
					else
					{
						allCompanies = (Hashtable)Session["allCompanies"];
					}
					
					// See if company exists within allCompanies
					if(!allCompanies.Contains(company))
					{
						companyCart = new Hashtable();
					}
					else
					{
						companyCart = (Hashtable)allCompanies[company];
					}
					// Update the quantity 
					if(companyCart.Contains(name))
					{
						companyCart.Remove(name);
						companyCart.Add(name, IDs[name]);
					}
					else
					{
						companyCart.Add(name, IDs[name]);
					}
					// Add the product and quantity key/value to the companyCart
					if(!allCompanies.Contains(company))
					{
						allCompanies.Add(company, companyCart);
					}
					Session["allCompanies"] = allCompanies;
				//}

				
				dr["price"] = listprice - discount;
				dr["company"] = company;

				if(type == 0)
				{
					dr["title"] = sqlRdr.GetString(1);
				}
				else
				{
					dr["albumname"] = sqlRdr.GetString(1);
				}
				dr["delete"] = "<a class='MAINLINK' href=\"ShoppingCart.aspx?delete="+name+"\">Delete</a>"; 

				dt.Rows.Add(dr);
			}
			sqlConn.Close(); // Close the connection..
			DataView dv = new DataView(dt);
			return dv;

		}	

		private ICollection GetCartData(int type)
		{
			string tempSql;
			//Book
			if(type == 0)
			{
				tempSql = "SELECT * FROM products WHERE bookID IS NOT NULL AND(";
			}
			//Disc
			else
			{
				tempSql = "SELECT * FROM products WHERE discID IS NOT NULL AND(";
			}
			// Query to return productIDs for each disc in teh cart
			int count = 0;
			foreach (string name in hash.Keys) 
			{
				if(count++ == 0)
				{
					tempSql+= " productID = " + name;
				}
				else
				{
					tempSql+= " OR productID = " + name;
				}
			}
			tempSql += ") ";

			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();		
			sqlCom = new SqlCommand(tempSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();
			// Bind query results to datagrid
			Hashtable IDs = new Hashtable();
			int tempID;
			int tempQuant;
			for(int i = 0; sqlRdr.Read(); i++)
			{
				tempID = sqlRdr.GetInt32(0);
				// Find product id and quantity match
				tempQuant = Convert.ToInt32(hash[""+tempID]);
				IDs[""+tempID] = "" +tempQuant;
			}
			sqlRdr.Close();
			if(IDs.Count > 0)
			{
				return CreateDataSource(type, IDs);
			}
			else
			{
				return null;
			}
			
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{			
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		// Grab the quantity from each row and store it into the shopping cart
		protected void btnUpdate_Click(object sender, System.EventArgs e)
		{
			string tempProductID, tempQuantity;
			
			foreach(DataGridItem dataGridItem in dgrDiscCart.Items)
			{
				tempProductID = dataGridItem.Cells[0].Text;
				tempQuantity = ((TextBox)dataGridItem.FindControl("quant1")).Text;
				hash[tempProductID] = tempQuantity;
				Session["cart"]=hash;
				//Response.Write(tempProductID + " " + tempQuantity);
			}

			foreach(DataGridItem dataGridItem in dgrBookCart.Items)
			{
				tempProductID = dataGridItem.Cells[0].Text;
				tempQuantity = ((TextBox)dataGridItem.FindControl("quant1")).Text;
				hash[tempProductID] = tempQuantity;
				Session["cart"]=hash;
				//Response.Write(tempProductID + " " + tempQuantity);  // Output to the browser
			}
			
			dgrBookCart.DataSource = GetCartData(0);
			dgrDiscCart.DataSource = GetCartData(1);

			dgrBookCart.DataBind();
			dgrDiscCart.DataBind();

			lblSubTotal.InnerHtml = String.Format(currencyFormat, discTotal + bookTotal);
		}

		protected void btnCheckout_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("Checkout.aspx");			
		}

		protected void btnOK_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("home.aspx");
		}

		protected void dgrBookCart_ItemDataBound(Object sender, DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				if (e.Item.Cells[6].Text != "444a") e.Item.Cells[1].Text = e.Item.Cells[1].Text + " <i>(Provided by " + e.Item.Cells[6].Text + ")</i>";				
				
				// Set the title to be a link to details
				e.Item.Cells[1].Text = "<a href='search.aspx?productID=" + e.Item.Cells[0].Text + "' class='mainlink'>" + e.Item.Cells[1].Text + "</a>";
				
				// Set the correct quantity in the text box
				string tempProductID = e.Item.Cells[0].Text;
				string tempQuantity = (string)hash[tempProductID];
				((TextBox)e.Item.FindControl("quant1")).Text = tempQuantity;
				
				double unit = Double.Parse(e.Item.Cells[3].Text);
				double total = Double.Parse(tempQuantity) * Double.Parse(e.Item.Cells[5].Text);

				bookTotal += total;
				
				e.Item.Cells[3].Text = "<font class='TXT' size='2'>" + String.Format(currencyFormat, unit) + "</font>";
				e.Item.Cells[5].Text = "<font class='TXT' size='2'><b>" + String.Format(currencyFormat, total) + "</b></font>";
			}
			else if (e.Item.ItemType == ListItemType.Footer)
			{
				e.Item.Cells[5].Text = String.Format(currencyFormat, bookTotal);
			}
		}
		
		protected void dgrDiscCart_ItemDataBound(Object sender, DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				if (e.Item.Cells[6].Text != "444a") e.Item.Cells[1].Text = e.Item.Cells[1].Text + " <i>(Provided by " + e.Item.Cells[6].Text + ")</i>";				
				
				// Set the title to be a link to details
				e.Item.Cells[1].Text = "<a href='search.aspx?productID=" + e.Item.Cells[0].Text + "' class='mainlink'>" + e.Item.Cells[1].Text + "</a>";
				
				// Set the correct quantity in the text box
				string tempProductID = e.Item.Cells[0].Text;
				string tempQuantity = (string)hash[tempProductID];
				((TextBox)e.Item.FindControl("quant1")).Text = tempQuantity;
				
				double unit = Double.Parse(e.Item.Cells[3].Text);
				double total = Double.Parse(tempQuantity) * Double.Parse(e.Item.Cells[5].Text);

				discTotal += total;
				
				e.Item.Cells[3].Text = "<font class='TXT' size='2'>" + String.Format(currencyFormat, unit) + "</font>";
				e.Item.Cells[5].Text = "<font class='TXT' size='2'><b>" + String.Format(currencyFormat, total) + "</b></font>";
			}
			else if (e.Item.ItemType == ListItemType.Footer)
			{
				e.Item.Cells[5].Text = String.Format(currencyFormat, discTotal);
			}
			
		}		
	}
}
