using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace gchang_inventory
{
	/// <summary>
	/// Summary description for details.
	/// </summary>
	public class Details : Bahamas
	{
		protected HtmlGenericControl lblTitle;
		protected HtmlGenericControl lblBy;
		protected HtmlGenericControl lblListPrice;
		protected HtmlGenericControl lblPrice;
		protected HtmlGenericControl lblDiscount;
		protected HtmlGenericControl lblStock;
		protected HtmlGenericControl lblID;
		protected HtmlGenericControl lblIDID;		
		protected HtmlGenericControl lblPublisherID;
		protected HtmlGenericControl lblPublisher;	
		protected HtmlGenericControl lblGenre;		
		protected HtmlGenericControl lblRelatedBooks;
		protected HyperLink lnkAddToCart;		
		protected HtmlGenericControl lblRelatedDiscs;		

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Get product ID from query string
			int productID = System.Int16.Parse(Request.QueryString.Get("productID"));

			lnkAddToCart.NavigateUrl = "ShoppingCart.aspx?productID=" + productID.ToString() + "&quantity=1";

			// Determine whether or not product ID is book or disc
			bool isBook = checkIsBook(productID);
			
			// Create SqlParameter objects (Need one for each query)
			SqlParameter[] sqlParams = new SqlParameter[1];
			sqlParams[0] = new SqlParameter("@productID", productID);

			SqlParameter[] sqlParams2 = new SqlParameter[1];
			sqlParams2[0] = new SqlParameter("@productID", productID);
	
			SqlParameter[] sqlParams3 = new SqlParameter[1];
			sqlParams3[0] = new SqlParameter("@productID", productID);

			SqlParameter[] sqlParams4 = new SqlParameter[1];
			sqlParams4[0] = new SqlParameter("@productID", productID);
			
			SqlParameter[] sqlParams5 = new SqlParameter[1];
			sqlParams5[0] = new SqlParameter("@productID", productID);

			SqlDataAdapter sqlAdapter;
			
			// Create DataTables to store query results
			
			// Will store product information
			DataTable dtBookInfo = new DataTable();
			DataTable dtDiscInfo = new DataTable();

			// Will store by information
			DataTable dtAuthors = new DataTable();
			DataTable dtArtists = new DataTable();

			// Will store related items information
			DataTable dtRelatedBooks = new DataTable();
			DataTable dtRelatedDiscs = new DataTable();
			
			if (isBook)
			{				
				sqlConn.Open();			// Connect to the database 
				
				// Get all information about a product
				sqlAdapter = executeStoredProcAdapter(sqlConn, "sps_getBookInfo", sqlParams);
				sqlAdapter.Fill(dtBookInfo);

				// Get all authors for this book
				sqlAdapter = executeStoredProcAdapter(sqlConn, "sps_getAuthors", sqlParams2);
				sqlAdapter.Fill(dtAuthors);

				// Get all related books for this book
				sqlAdapter = executeStoredProcAdapter(sqlConn, "sps_getRelatedBooks", sqlParams3);
				sqlAdapter.Fill(dtRelatedBooks);
				
				// Get all related discs for this book
				sqlAdapter = executeStoredProcAdapter(sqlConn, "sps_getRelatedDiscs", sqlParams4);
				sqlAdapter.Fill(dtRelatedDiscs);

				DataTable dtBooksCommonKeyword = new DataTable();
				
				// Get all books with a common keyword
				sqlAdapter = executeStoredProcAdapter(sqlConn, "sps_getBooksCommonKeyword", sqlParams5);
				sqlAdapter.Fill(dtBooksCommonKeyword);
				
				sqlConn.Close();		// Close connection

				// No information returned!
				if (dtBookInfo.Rows.Count == 0)
				{
					Response.Write("Invalid ProductID");
					Response.Flush();
					Response.End();
					return;
				}

				foreach (DataRow a in dtBooksCommonKeyword.Rows)				
					dtRelatedBooks.ImportRow(a);				

				// Build author string
				string authors = "by ";
				for (int i = 0; i < dtAuthors.Rows.Count; i++)
				{					
					authors += "<a class='MAINLINK' href='results.aspx?action=4&authorID=" + dtAuthors.Rows[i]["authorID"] + "'>" + dtAuthors.Rows[i]["name"] + "</a>";
					
					if (i < dtAuthors.Rows.Count - 1) authors += ", ";
				}				

				// Get product information
				DataRow row = dtBookInfo.Rows[0];
				
				string isbn = row["isbn"].ToString();
				string title = row["title"].ToString();
				string publisher = row["publisher"].ToString();
				string genre = row["genre"].ToString();
				double listPrice = Double.Parse(row["price"].ToString());
				double discount = Double.Parse(row["discount"].ToString());
				double price = listPrice - discount;				
				int quantity = 0;
				
				if (row["quantity"].ToString() != "") quantity = Int32.Parse(row["quantity"].ToString());

				// Get related items
				string[] relItems = buildRelatedItems(dtRelatedBooks, dtRelatedDiscs);

				lblTitle.InnerHtml = title;
				lblBy.InnerHtml = authors;
				lblListPrice.InnerHtml = String.Format(currencyFormat, listPrice);
				lblPrice.InnerHtml = String.Format(currencyFormat, price);
				lblDiscount.InnerHtml = String.Format(currencyFormat, discount) + "&nbsp;(" + (int)((discount / listPrice) * 100) + "%)" ;
				lblStock.InnerHtml = quantity.ToString();
				lblID.InnerHtml = isbn;
				lblIDID.InnerHtml = "ISBN";
				lblPublisher.InnerHtml = publisher;
				lblGenre.InnerHtml = genre;
				lblPublisherID.InnerHtml = "Publisher";
				lblRelatedBooks.InnerHtml = relItems[0];
				lblRelatedDiscs.InnerHtml = relItems[1];
			}
			else
			{
				sqlConn.Open();			// Connect to the database 
				
				// Get all information about a product
				sqlAdapter = executeStoredProcAdapter(sqlConn, "sps_getDiscInfo", sqlParams);
				sqlAdapter.Fill(dtDiscInfo);

				// Get all authors for this book
				sqlAdapter = executeStoredProcAdapter(sqlConn, "sps_getArtists", sqlParams2);
				sqlAdapter.Fill(dtArtists);

				// Get all related books for this book
				sqlAdapter = executeStoredProcAdapter(sqlConn, "sps_getRelatedBooks", sqlParams3);
				sqlAdapter.Fill(dtRelatedBooks);

				// Get all related discs for this book
				sqlAdapter = executeStoredProcAdapter(sqlConn, "sps_getRelatedDiscs", sqlParams4);
				sqlAdapter.Fill(dtRelatedDiscs);
				
				sqlConn.Close();		// Close connection

				// No information returned!
				if (dtDiscInfo.Rows.Count == 0)
				{
					Response.Write("Invalid ProductID");
					Response.Flush();
					Response.End();
					return;
				}

				// Build artist string
				string artists = "by ";
				for (int i = 0; i < dtArtists.Rows.Count; i++)
				{
					artists += "<a class='MAINLINK' href='results.aspx?action=5&artistID=" + dtArtists.Rows[i]["artistID"] + "'>" + dtArtists.Rows[i]["artist"] + "</a>";
					
					if (i < dtArtists.Rows.Count - 1) artists += ", ";
				}				

				// Get product information
				DataRow row = dtDiscInfo.Rows[0];				
				
				string album = row["albumname"].ToString() + " (" + row["type"].ToString() + ")";
				double listPrice = Double.Parse(row["price"].ToString());
				double discount = Double.Parse(row["discount"].ToString());
				double price = listPrice - discount;				
				string recordLabel = row["recordlabel"].ToString();
				string genre = row["genre"].ToString();
				int quantity = 0;
				
				if (row["quantity"].ToString() != "") quantity = Int32.Parse(row["quantity"].ToString());

				// Get related items
				string[] relItems = buildRelatedItems(dtRelatedBooks, dtRelatedDiscs);

				lblTitle.InnerHtml = album;
				lblBy.InnerHtml = artists;
				lblListPrice.InnerHtml = String.Format(currencyFormat, listPrice);
				lblPrice.InnerHtml = String.Format(currencyFormat, price);
				lblDiscount.InnerHtml = String.Format(currencyFormat, discount) + "&nbsp;(" + (int)((discount / listPrice) * 100) + "%)" ;
				lblStock.InnerHtml = quantity.ToString();
				lblID.InnerHtml = row["discID"].ToString();
				lblIDID.InnerHtml = "Disc ID";
				lblPublisher.InnerHtml = recordLabel;
				lblPublisherID.InnerHtml = "Record Label";
				lblGenre.InnerHtml = genre;
				lblRelatedBooks.InnerHtml = relItems[0];
				lblRelatedDiscs.InnerHtml = relItems[1];
			}
		}

		// Will return HTML string for related items. Books in [0], Discs in [1].
		protected string[] buildRelatedItems(DataTable dtRelatedBooks, DataTable dtRelatedDiscs)
		{
			string[] retVal = new String[2];			

			// Will store the related items table with names stripped, then duplicates removed
			DataTable dtRelatedBooksStripped;
			DataTable dtRelatedDiscsStripped;			

			// Build related books by removing the "name" column and then removing duplicate entries
			dtRelatedBooksStripped = dtRelatedBooks.Copy();				
			dtRelatedBooksStripped.Columns.Remove("name");				
			dtRelatedBooksStripped = removeDuplicates(dtRelatedBooksStripped, "productID");

			string relatedBooks = "<ul>";
				
			foreach (DataRow row in dtRelatedBooksStripped.Rows)
			{
				relatedBooks += "<li><a class='MAINLINK' href='details.aspx?productID=" + row["productID"] + "'>" + row["title"].ToString() + "</a> by ";
				
				DataRow[] authors = dtRelatedBooks.Select("productID = " + row["productID"]);
				
				// Remove duplicates in authors. Occurs because we append the results of sps_getBooksCommonKeywords to the results of sps_getRelatedBooks
				Hashtable ht = new Hashtable();
				ArrayList authorsList = new ArrayList();
                
				for (int i = 0; i < authors.Length; i++)
				{
					if (!ht.ContainsKey(authors[i]["authorID"]))
					{
						ht.Add(authors[i]["authorID"], null);
						authorsList.Add(authors[i]);
					}
				}                				
				
				// Now that we have a distinct list of authors, add them to the string
				for (int i = 0; i < authorsList.Count; i++)
				{					
					DataRow authorRow = (DataRow)authorsList[i];
					relatedBooks += "<a class='MAINLINK' href='results.aspx?action=4&authorID=" + authorRow["authorID"] + "'>" + authorRow["name"] + "</a>";
										
					if (i < authorsList.Count - 1)
					{
						if (i > 3)
						{
							relatedBooks += ", <a href='details.aspx?productID=" + authorRow["productID"] + "' class='mainlink'><font size='1'>(more)</font></a>";							
							break;
						}
						else							
							relatedBooks += ", ";
					}
				}

				relatedBooks += "</li>";			
			}

			relatedBooks += "</ul>";

			if (dtRelatedBooksStripped.Rows.Count == 0) relatedBooks = "<i>No related titles found</i><p/>";

			// Build related discs by removing the "name" column and then removing duplicate entries
			dtRelatedDiscsStripped = dtRelatedDiscs.Copy();				
			dtRelatedDiscsStripped.Columns.Remove("name");				
			dtRelatedDiscsStripped = removeDuplicates(dtRelatedDiscsStripped, "productID");

			string relatedDiscs = "<ul>";
				
			foreach (DataRow row in dtRelatedDiscsStripped.Rows)			
			{
				relatedDiscs += "<li><a class='MAINLINK' href='details.aspx?productID=" + row["productID"] + "'>" + row["albumname"] + " (" + row["type"] + ")</a> by ";
				
				DataRow[] artists = dtRelatedDiscs.Select("productID = " + row["productID"]);
				
				for (int i = 0; i < artists.Length; i++)
				{
					//relatedDiscs += artists[i]["name"].ToString();
					relatedDiscs += "<a class='MAINLINK' href='results.aspx?action=5&artistID=" + artists[i]["artistID"] + "'>" + artists[i]["name"] + "</a>";
					
					if (i < artists.Length - 1)
					{
						if (i > 3)
						{
							//relatedDiscs += "...";
							relatedDiscs += ", <a href='details.aspx?productID=" + artists[i]["productID"] + "' class='mainlink'><font size='1'>(more)</font></a>";							
							break;
						}
						else
							relatedDiscs += ", ";
					}
				}

				relatedDiscs += "</li>";			
			}
			relatedDiscs += "</ul>";

			if (dtRelatedDiscsStripped.Rows.Count == 0) relatedDiscs = "<i>No related albums found</i>";

			retVal[0] = relatedBooks;
			retVal[1] = relatedDiscs;

            return retVal;
		}		

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{	
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
		
	}
}


