using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;	// This is the library with the SQL types we're using below


namespace gchang_inventory
{
	/// <summary>
	/// Summary description for browse.
	/// </summary>
	
	public class Results : Bahamas
	{
		protected System.Web.UI.HtmlControls.HtmlForm frmResults;
		protected System.Web.UI.WebControls.DataGrid dgrBooks;
		protected System.Web.UI.WebControls.DataGrid dgrDiscs;		
		protected System.Web.UI.HtmlControls.HtmlGenericControl lblBookTitle;
		protected System.Web.UI.HtmlControls.HtmlGenericControl lblDiscTitle;
		protected System.Web.UI.WebControls.Label lblIntro;

		protected DataSet dsBooks;
		protected DataSet dsDiscs;
		protected DataTable dtBooks;
		protected DataTable dtDiscs;
			
		private void Page_Load(object sender, System.EventArgs e)
		{			
			if (Request.QueryString.Count > 0) lblIntro.Text = "";
			
			// Get the correct action from Query String
			string action = Request.QueryString.Get("action");

			switch (action)
			{

				case "0":		// Search
					search();
					break;

				case "1":		// View All Discs
					viewDiscs();
					break;

				case "2":		// View All Books
					viewBooks();					
					break;

				case "3":		// View All Products
					viewAll();
					break;
				
				case "4":		// View All Products by Artist
					viewBooksByAuthor();
					break;

				case "5":
					viewDiscsByArtist();
					break;

			}			
			
		}   
	
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		protected void search()
		{
			// Get selected index of search type and search string from query string
			string index = Request.QueryString.Get("index");
			string strSearch = System.Web.HttpUtility.UrlDecode(Request.QueryString.Get("search"));

			// If no search string, display all products
			if (strSearch == null || strSearch == "") 
			{
				viewAll();
				return;
			}

			int numBookResults;
			int numDiscResults;
			
			SqlParameter[] sqlParam = new SqlParameter[1];			

			switch (index)
			{
				case "0":		// By Title
					sqlParam[0] = new SqlParameter("@title", strSearch);	
					numBookResults = updateBookGrid("sps_getBooksByName", sqlParam);

					sqlParam[0] = new SqlParameter("@albumname", strSearch);					
					numDiscResults = updateDiscGrid("sps_getDiscsByName", sqlParam);
					
					lblBookTitle.InnerHtml = numBookResults + " books matching title <font class='t2'>" + strSearch + "</font> :";
					lblDiscTitle.InnerHtml = numDiscResults + " discs matching title <font class='t2'>" + strSearch + "</font> :";

					break;

				case "1":		// By author/artist name
					sqlParam[0] = new SqlParameter("@authorname", strSearch);
					numBookResults = updateBookGrid("sps_getBooksByAuthorName", sqlParam);
		
					sqlParam[0] = new SqlParameter("@artistname", strSearch);						
					numDiscResults = updateDiscGrid("sps_getDiscsByArtistName", sqlParam);

					lblBookTitle.InnerHtml = numBookResults + " books matching author <font class='t2'>" + strSearch + "</font> :";
					lblDiscTitle.InnerHtml = numDiscResults + " discs matching artist <font class='t2'>" + strSearch + "</font> :";

					break;

				case "2":		// By book keyword 

					sqlParam[0] = new SqlParameter("@keyword", strSearch);						
					numBookResults = updateBookGrid("sps_getBooksByKeyword", sqlParam);
					
					lblBookTitle.InnerHtml = numBookResults + " books matching keyword <font class='t2'>" + strSearch + "</font> :";				

					break;

				default:
					Response.Write("Invalid Index");
					Response.Flush();
					Response.End();

					break;
			}
		} 

		protected void viewAll()
		{
			int numBookResults = updateBookGrid("sps_getAllBooks", null);
			int numDiscResults = updateDiscGrid("sps_getAllDiscs", null);			
			
			lblBookTitle.InnerHtml = numBookResults + " books in catalog :";
			lblDiscTitle.InnerHtml = numDiscResults + " discs in catalog :";
		}
		

		protected void viewBooks()
		{
			int numBookResults = updateBookGrid("sps_getAllBooks", null);
			lblBookTitle.InnerHtml = numBookResults + " books in catalog :";			
		}

		protected void viewDiscs()
		{
			int numDiscResults = updateDiscGrid("sps_getAllDiscs", null);			
			lblDiscTitle.InnerHtml = numDiscResults + " discs in catalog :";
		}

		protected void viewBooksByAuthor()
		{
			string strAuthorID = Request.QueryString.Get("authorID");

			if (strAuthorID == null || strAuthorID == "")
			{
				Response.Write("Invalid authorID: " + strAuthorID);
				Response.Flush();
				Response.End();				
			}

			int authorID = System.Int32.Parse(strAuthorID);			
			
			SqlParameter[] sqlParam = new SqlParameter[1];			
			sqlParam[0] = new SqlParameter("@authorID", authorID);

			int numBookResults = updateBookGrid("sps_getBooksByAuthorID", sqlParam);

			if (dsBooks.Tables[0].Rows.Count == 0)
			{
				Response.Write("Invalid authorID: " + strAuthorID);
				Response.Flush();
				Response.End();				
			}

			lblBookTitle.InnerHtml = numBookResults + " books by <font class='t2'>" + dsBooks.Tables[0].Select("authorID=" + strAuthorID)[0]["name"].ToString() + "</font> :";				
		}

		protected void viewDiscsByArtist()
		{
			string strArtistID = Request.QueryString.Get("artistID");

			if (strArtistID == null || strArtistID == "")
			{
				Response.Write("Invalid artistID: " + strArtistID);
				Response.Flush();
				Response.End();				
			}

			int artistID = System.Int32.Parse(strArtistID);			
			
			SqlParameter[] sqlParam = new SqlParameter[1];			
			sqlParam[0] = new SqlParameter("@artistID", artistID);

			int numDiscResults = updateDiscGrid("sps_getDiscsByArtistID", sqlParam);

			if (dsDiscs.Tables[0].Rows.Count == 0)
			{
				Response.Write("Invalid artistID: " + strArtistID);
				Response.Flush();
				Response.End();				
			}

			lblDiscTitle.InnerHtml = numDiscResults + " discs by <font class='t2'>" + dsDiscs.Tables[0].Select("artistID=" + strArtistID)[0]["name"].ToString() + "</font> :";
		}

		// Update the book data grid with results from a stored procedure
		protected int updateBookGrid(string spName, SqlParameter[] sqlParams)
		{
			sqlConn.Open();	// Open the connection
			
			// Fill the books DataSet with results of the query
			dsBooks= new DataSet();
			SqlDataAdapter sqlDA = executeStoredProcAdapter(sqlConn, spName, sqlParams);
			sqlDA.Fill(dsBooks);
			
			sqlConn.Close();	// Close the connection
			
			if (dsBooks.Tables[0] == null)
			{
				dgrBooks.DataSource = "";
			}
			else
			{
				// Create the books table by removing the authors column and removing duplicate entries
				dtBooks = dsBooks.Tables[0].Copy();
				dtBooks.Columns.Remove("name");
				
				dtBooks = removeDuplicates(dtBooks, "productID");

				dgrBooks.DataSource = dtBooks;
			}
			
			dgrBooks.DataBind();

			return dgrBooks.Items.Count;
		}

		
		// Update the Disc data grid with results from a stored procedure
		protected int updateDiscGrid(string spName, SqlParameter[] sqlParams)
		{
			sqlConn.Open();	// Open the connection
			
			// Fill the discs DataSet with results of the query
			dsDiscs = new DataSet();
			SqlDataAdapter sqlDA = executeStoredProcAdapter(sqlConn, spName, sqlParams);
			sqlDA.Fill(dsDiscs);
			
			sqlConn.Close();	// Close the connection

			if (dsDiscs.Tables[0] == null)
			{
				dgrDiscs.DataSource = "";
			}
			else
			{			
				// Create the discs table by removing the artists column and removing duplicate entries
				dtDiscs = dsDiscs.Tables[0].Copy();
				dtDiscs.Columns.Remove("name");			
				
				dtDiscs = removeDuplicates(dtDiscs, "productID");

				dgrDiscs.DataSource = dtDiscs;
			}

			dgrDiscs.DataBind();

			return dgrDiscs.Items.Count;
		}

		protected void dgrBooks_ItemCreated(Object sender, DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				// Retrieve the Label control
				Label lblAuthor = (Label)e.Item.FindControl("lblAuthor");

				string strAuthor = "";

				DataRow[] books = dsBooks.Tables[0].Select("productID = " + dtBooks.Rows[e.Item.DataSetIndex]["productID"]);

				for (int i = 0; i < books.Length; i++)
				{
					DataRow row = books[i];
					strAuthor += "<a class='MAINLINK' href='results.aspx?action=4&authorID=" + row["authorID"] + "'>" + row["name"] + "</a>";

					if (i < books.Length - 1)
					{
						if (i > 2)
						{
							strAuthor += ", <a href='details.aspx?productID=" + row["productID"] + "' class='mainlink'><font size='1'>(more)</font></a>";
							break;
						}
						strAuthor += ", ";
					}
				}
				
				lblAuthor.Text = strAuthor;

				// Retrieve the Label control 
				Label lblPrice= (Label)e.Item.FindControl("lblBookPrice");
				
				double price = (Double.Parse(books[0]["price"].ToString()) - Double.Parse(books[0]["discount"].ToString()));
				lblPrice.Text = String.Format(currencyFormat, price);
			}
		}
		
		protected void dgrDiscs_ItemCreated(Object sender, DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{	
				// Retrieve the Label control
				Label lblArtist = (Label)e.Item.FindControl("lblArtist");

				string strArtist = "";

				DataRow[] discs = dsDiscs.Tables[0].Select("productID = " + dtDiscs.Rows[e.Item.DataSetIndex]["productID"]);

				for (int i = 0; i < discs.Length; i++)
				{
					DataRow row = discs[i];
					strArtist += "<a class='MAINLINK' href='results.aspx?action=5&artistID=" + row["artistID"] + "'>" + row["name"] + "</a>";

					if (i < discs.Length - 1)
					{
						if (i > 2)
						{
							strArtist += ", <a href='details.aspx?productID=" + row["productID"] + "' class='mainlink'><font size='1'>(more)</font></a>";
							break;
						}
						strArtist += ", ";
					}					
				}
				
				lblArtist.Text = strArtist;

				// Retrieve the Label control 
				Label lblPrice= (Label)e.Item.FindControl("lblDiscPrice");
				
				double price = (Double.Parse(discs[0]["price"].ToString()) - Double.Parse(discs[0]["discount"].ToString()));
				lblPrice.Text = String.Format(currencyFormat, price);
			}
		}

		protected void dgrDiscs_ItemDataBound(Object sender, DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				e.Item.Cells[2].Text = "<a href='details.aspx?productID=" + e.Item.Cells[0].Text + "' class='mainlink'>" + e.Item.Cells[2].Text + " (" + dtDiscs.Rows[e.Item.DataSetIndex]["type"] + ")</a>";
			}
		}

		protected void dgrBooks_ItemDataBound(Object sender, DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{	
				e.Item.Cells[2].Text = "<a href='details.aspx?productID=" + e.Item.Cells[0].Text + "' class='mainlink'>" + e.Item.Cells[2].Text + "</a>";
			}
		}
	}
}
