using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using System.Data.SqlClient; 

namespace proj1
{
	/// <summary>
	/// Summary description for genxml.
	/// </summary>
	public class genxml : System.Web.UI.Page
	{
		public string bConnString = "server=IISQLSRV.cs.washington.edu; uid=bkk; pwd=mydbpw; database=gheocr_inventory";
		public string sConnString = "server=IISQLSRV.cs.washington.edu; uid=bkk; pwd=mydbpw; database=shen321_shipping";
		private void Page_Load(object sender, System.EventArgs e)
		{
			SqlConnection conn = new SqlConnection(bConnString);		
			conn.Open();

			string file = Server.MapPath(".\\xml\\") + "products2.xml";
			TextWriter tw = new StreamWriter(file);
			tw.WriteLine("<companyInfo>");
			tw.WriteLine("\t<companyName>we have a name?</companyName>");
			tw.WriteLine("\t<products>");

			// now write books
			SqlCommand cmdBooks = new SqlCommand("SELECT B.isbn, B.title, DATEPART(yyyy, P.releasedate) AS year, " +
				"	B.genre AS categories, B.author, B.publisher, " +
				"	P.price, P.price - P.discount AS discountPrice, " +
				"	(SELECT SUM(quantity) FROM availability " +
				"		WHERE productID=P.storeid) AS quantity, " +
				"	P.aboutproduct AS description " +
				"FROM product P, books B " +
				"WHERE P.productnumber = B.isbn AND P.isbook=1", conn);
			SqlDataReader rBooks = cmdBooks.ExecuteReader();

			string[] categories;
			string[] authorName;
			string fn,ln;
			int i;
			while (rBooks.Read()) 
			{
				tw.WriteLine("\t\t<book>");
				tw.WriteLine("\t\t\t<isbn>" + rBooks.GetString(0) + "</isbn>");
				tw.WriteLine("\t\t\t<title>" + rBooks.GetString(1).Trim() + "</title>");
				tw.WriteLine("\t\t\t<year>" + rBooks.GetInt32(2) + "</year>");
				// separate genre
				categories = rBooks.GetString(3).Split('/');
				for (i = 0; i < categories.Length; i++) 
				{
					tw.WriteLine("\t\t\t<category>" + categories[i].Trim() + "</category>");
				}
				// separate author
				authorName = rBooks.GetString(4).Split(' ');
				ln = authorName[authorName.Length - 1];
				fn = authorName[0];
				tw.WriteLine("\t\t\t<author><fn>" + fn + "</fn> <ln>" + ln + "</ln></author>");

				tw.WriteLine("\t\t\t<publisher>" + rBooks.GetString(5).Trim() + "</publisher>");
				// no keywords
				tw.WriteLine("\t\t\t<price>" + String.Format("{0:c}", rBooks.GetSqlMoney(6).ToDouble()).Substring(1) + "</price>");
				tw.WriteLine("\t\t\t<discountPrice>" + String.Format("{0:c}", rBooks.GetSqlMoney(7).ToDouble()).Substring(1) + "</discountPrice>");
				tw.WriteLine("\t\t\t<quantity>" + rBooks.GetInt32(8) + "</quantity>");
				// problem with html code
				// tw.WriteLine("\t\t\t<description>" + rBooks.GetString(9) + "</description>");
				tw.WriteLine("\t\t</book>");
			}

			rBooks.Close();

			// now write music


			SqlCommand cmdMusic = new SqlCommand("SELECT M.albumid, M.albumname, M.genre, M.artist, M.company, " +
				"	P.price, P.price-P.discount AS discountPrice, " +
				"	(SELECT SUM(quantity) FROM availability " +
				"		WHERE productID=P.storeid) AS quantity, " +
				"	P.aboutproduct AS description " +
				"FROM product P, music M " +
				"WHERE P.productnumber = M.albumid AND P.isbook=0", conn);
			rBooks = cmdMusic.ExecuteReader();
			
			string seps = "/,";
			char[] sepChar = seps.ToCharArray();
	
			while (rBooks.Read()) 
			{
				tw.WriteLine("\t\t<music>");
				tw.WriteLine("\t\t\t<id>" + rBooks.GetString(0) + "</id>");
				tw.WriteLine("\t\t\t<albumName>" + rBooks.GetString(1).Trim() + "</albumName>");
				// separate genre
				categories = rBooks.GetString(2).Split(sepChar);
				for (i = 0; i < categories.Length; i++) 
				{
					tw.WriteLine("\t\t\t<genre>" + categories[i].Trim() + "</genre>");
				}
				
				tw.WriteLine("\t\t\t<artist>" + rBooks.GetString(3).Trim() + "</artist>");
				tw.WriteLine("\t\t\t<recordingCompany>" + rBooks.GetString(4).Trim() + "</recordingCompany>");
				// no keywords
				tw.WriteLine("\t\t\t<price>" + String.Format("{0:c}", rBooks.GetSqlMoney(5).ToDouble()).Substring(1) + "</price>");
				tw.WriteLine("\t\t\t<discountPrice>" + String.Format("{0:c}", rBooks.GetSqlMoney(6).ToDouble()).Substring(1) + "</discountPrice>");
				tw.WriteLine("\t\t\t<quantity>" + rBooks.GetInt32(7) + "</quantity>");
				// problem with html code
				// tw.WriteLine("\t\t\t<description>" + rBooks.GetString(9) + "</description>");
				tw.WriteLine("\t\t</music>");
			}

			rBooks.Close();

			tw.WriteLine("\t</products>");
			conn.Close();

			conn = new SqlConnection(sConnString);
			conn.Open();
			SqlConnection conn2 = new SqlConnection(sConnString);
			conn2.Open();

			tw.WriteLine("\t<shipping>");

			// now write shipping info
			SqlCommand cmdVendor = new SqlCommand("SELECT VENDORID, VENDORNAME,URL,PhoneNumber FROM ShippingVendor", conn);
			SqlDataReader rVendor = cmdVendor.ExecuteReader();

			SqlCommand cmdMethods;
			SqlDataReader rMethod;

			while(rVendor.Read()) 
			{
				tw.WriteLine("\t\t<vendor>");
				tw.WriteLine("\t\t\t<name>" + rVendor.GetString(1) + "</name>");
				tw.WriteLine("\t\t\t<url>" + rVendor.GetString(2) + "</url>");
				tw.WriteLine("\t\t\t<toll-free>" + rVendor.GetString(3) + "</toll-free>");

				cmdMethods = new SqlCommand("SELECT A.vendorshippingoptionid, ShippingOptionName, B.UnitOfPricing,B.PricePerUnit,B.MaximumWeight, " +
					"B.MaximumNumberOfItems, B.RestrictedCities " +
					"FROM VendorShippingOption as A, bkk.VendorShippingOptionDetail as B, ShippingOption as C  " +
					"where A.vendorid=" + rVendor.GetInt32(0) + " AND B.VendorShippingOptionID = A.VendorShippingOptionID AND  " +
					"C.ShippingOptionID = A.ShippingOptionID", conn2);
				rMethod = cmdMethods.ExecuteReader();

				while (rMethod.Read()) 
				{
					tw.WriteLine("\t\t\t<method id=\"" + rMethod.GetInt32(0) + "\">");
					tw.WriteLine("\t\t\t\t<option>" + rMethod.GetString(1) + "</option>");
					tw.WriteLine("\t\t\t\t<price>");
					switch(rMethod.GetString(2)) 
					{
						case "Item":
							tw.WriteLine("\t\t\t\t\t<perUnit>" + String.Format("{0:c}", rMethod.GetSqlMoney(3).ToDouble()).Substring(1) + "</perUnit>");
							break;
						case "Weight":
							tw.WriteLine("\t\t\t\t\t<perPound>" + String.Format("{0:c}", rMethod.GetSqlMoney(3).ToDouble()).Substring(1) + "</perPound>");
							break;
						case "Flat":
							tw.WriteLine("\t\t\t\t\t<flat>" + String.Format("{0:c}", rMethod.GetSqlMoney(3).ToDouble()).Substring(1) + "</flat>");
							break;
						default:
							Response.Write("error");
							break;
					}
					tw.WriteLine("\t\t\t\t</price>");
					tw.WriteLine("\t\t\t\t<restrictions>");
					tw.WriteLine("\t\t\t\t\t<maximumWeight>" + rMethod.GetDouble(4) + "</maximumWeight>");
					tw.WriteLine("\t\t\t\t\t<maximumitems>" + rMethod.GetInt32(5) + "</maximumitems>");
					if (rMethod.GetString(6) != "") 
					{
						tw.WriteLine("\t\t\t\t\t<cities>" + rMethod.GetString(6) + "</cities>");
					}
					tw.WriteLine("\t\t\t\t</restrictions>");
					tw.WriteLine("\t\t\t</method>");
				}

				rMethod.Close();
				tw.WriteLine("\t\t</vendor>");
			}

			tw.WriteLine("\t</shipping>");

			tw.WriteLine("</companyInfo>");
			tw.Close();

			Response.Write("done and stuff.");
			conn2.Close();
			conn.Close();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
