using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace proj1
{
	/// <summary>
	/// Summary description for _default.
	/// </summary>
	public class _default : System.Web.UI.Page
	{
		public System.Web.UI.WebControls.DataList listInvoices;
		public System.Web.UI.WebControls.DataList productList;
		public System.Web.UI.WebControls.RadioButtonList queryFilter;
		public System.Web.UI.WebControls.TextBox filterVar;
		public System.Web.UI.WebControls.TextBox cityName;
		public System.Web.UI.WebControls.Button clearProduct;

		private void Page_Load(object sender, System.EventArgs e)
		{
			string sqlInvoices = "SELECT i.invoiceID, i.invoiceDate, c.FirstName, c.LastName, p.PaymentAmount," +
				"SUM(ii.Quantity) AS productCount, " +
				"SUM(((ii.unitPrice - ii.discountAmount) - (ii.unitPrice * ii.discountPercent)) * ii.Quantity) AS subTotal " +
				"FROM Invoice i, Customer c, Payment_CreditCard p, Invoice_Item ii " +
				"WHERE i.Buyer = c.customerID AND i.paymentID = p.paymentID AND ii.invoiceID = i.invoiceID ";

			if (queryFilter.SelectedValue == "2") 
			{
				if (filterVar.Text == "") filterVar.Text = "0";
				
			} 
			else if (queryFilter.SelectedValue == "3") 
			{
				if (filterVar.Text == "") filterVar.Text = "0";

			} 
			else if (queryFilter.SelectedValue == "4") 
			{
				if (filterVar.Text == "0") filterVar.Text = "";
			} 
			else 
			{
				filterVar.Text = "";
			}

		sqlInvoices += "GROUP BY i.invoiceID, i.invoiceDate, c.FirstName, c.LastName, p.PaymentAmount ";

			switch (queryFilter.SelectedValue) 
			{
				case "1":
					sqlInvoices += "HAVING MAX(ii.ShipDate) < GETDATE()"; break;
				case "2":
					sqlInvoices += "HAVING SUM(ii.Quantity) >= " + filterVar.Text; break;
				case "3":
					sqlInvoices += "HAVING COUNT(DISTINCT ii.ShipWarehouse) >= " + filterVar.Text; break;
				case "4":
					sqlInvoices += "HAVING c.LastName LIKE '%" + filterVar.Text + "%'"; break;
			}

			sqlInvoices += " ORDER BY invoiceDate DESC";
			SqlConnection conn = new SqlConnection("server=IISQLSRV.cs.washington.edu; uid=bkk; pwd=mydbpw; database=bkrell_billing");
			conn.Open();
			SqlCommand cmd = new SqlCommand(sqlInvoices, conn);

			SqlDataReader dr = cmd.ExecuteReader();
			
			listInvoices.DataSource = dr;
			listInvoices.DataBind();

			dr.Close();

			if (cityName.Text != "") 
			{
				// only access and bind data if we're querying a city
				productList.Visible = true;

				string sqlItems = "SELECT it.itemID, it.itemName, SUM(ii.Quantity) AS shipCount " +
					"FROM Items it, Customer_Address ca, Invoice i, Invoice_Item ii " +
					"WHERE i.ShipTo = ca.addressID AND ii.invoiceID = i.invoiceID " +
					"AND ii.itemID = it.itemID " +
					"AND ca.city LIKE '%" + cityName.Text + "%' " +
					"GROUP BY it.itemID, it.itemName " +
					"ORDER BY shipCount DESC";

				SqlCommand cmdItem = new SqlCommand(sqlItems, conn);
				SqlDataReader dri = cmdItem.ExecuteReader();

				productList.DataSource = dri;
				productList.DataBind();
				
				dri.Close();
			} 
			else 
			{
				productList.Visible = false;
			}

			conn.Close();
		}

		public void clearProductList(Object sender, EventArgs e) 
		{
			cityName.Text = "";
			productList.Visible = false;
		}


		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
