using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Data.SqlTypes;

namespace DatabaseProj
{
	/// <summary>
	/// Summary description for Checkout.
	/// </summary>
	public class Checkout : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label LabelBillTo;
		protected System.Web.UI.WebControls.TextBox TextBoxFirstName;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorFirstName;
		protected System.Web.UI.WebControls.TextBox TextBoxLastName;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorLastName;
		protected System.Web.UI.WebControls.TextBox TextBoxStreetAddress;
		protected System.Web.UI.WebControls.TextBox TextBoxApartmentAddress;
		protected System.Web.UI.WebControls.TextBox TextBoxCity;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorCity;
		protected System.Web.UI.WebControls.TextBox TextBoxState;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorState;
		protected System.Web.UI.WebControls.TextBox TextBoxZip;
		protected System.Web.UI.WebControls.TextBox TextBoxZipExtended;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorZipCode;
		protected System.Web.UI.WebControls.TextBox TextBoxAreaCode;
		protected System.Web.UI.WebControls.TextBox TextBoxPhonePrefix;
		protected System.Web.UI.WebControls.TextBox TextBoxPhoneEnd;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorStreetAddress;
		protected System.Web.UI.WebControls.Button ButtonContinue;
		protected System.Web.UI.WebControls.CustomValidator CustomValidatorPhone;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorPhoneEnd;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorPhonePrefix;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorAreaCode;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorZipCodeExtFormat;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorZipCodeFormat;
		protected System.Web.UI.WebControls.CheckBox CheckBoxShipToBill;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here

			string customerID = (string) Session["customerID"];
			/*if(customerID == null) 
			{
				Session.Clear();
				Response.Redirect("index.aspx");
			}*/


			DataRow billTo = Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spGetCustomer",
				new SqlParameter("@custID", customerID)).Tables[0].Rows[0];

			Session.Add("Destination", ((string) billTo["city"]));

			// display BillTo Info
			string text = ((string) billTo["firstName"]) + " " + ((string) billTo["lastName"]) + "<br>" + // name
				((string) billTo["streetAddress"]) + "<br>"; // 1st address line
			if(! billTo["aptAddress"].GetType().ToString().Equals("System.DBNull"))
				text += ((string) billTo["aptAddress"]) + "<br>";  // 2nd address line
			text += ((string) billTo["city"]) + ", " + ((string) billTo["state"]) + " " + ((string) billTo["zipCode"]);
			if(! billTo["extZipCode"].GetType().ToString().Equals("System.DBNull"))
				text += "-" + ((string) billTo["extZipCode"]); // extended zip code
			text += "<br>";
			if(! billTo["phoneNumber"].GetType().ToString().Equals("System.DBNull"))
				text += "<br>Phone: " + ((string) billTo["phoneNumber"]); // formatted phone number
					
			LabelBillTo.Text = text;


			/*DataSet customerTables = Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spGetCustomer",
				new SqlParameter("@custID", Session["customerID"]));

			DataRow customer = customerTables.Tables[0].Rows[0];

			string text = customer[0] + " " + customer[1] + "<br>" + // name
				customer[3] + "<br>"; // 1st address line
			if(customer[4].ToString() != String.Empty)
				text += customer[4] + "<br>";  // 2nd address line
			text += customer[5] + ", " + customer[6] + " " + customer[7];
			if(customer[8].ToString() != String.Empty)
				text += "-" + customer[8]; // extended zip code
			text += "<br>";
			if(customer[2].ToString() != String.Empty)
				text += "<br>Phone: " + customer[2]; // formatted phone number
					
			LabelBillTo.Text = text;*/
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.CheckBoxShipToBill.CheckedChanged += new System.EventHandler(this.CheckBoxShipToBill_CheckedChanged);
			this.CustomValidatorPhone.ServerValidate += new System.Web.UI.WebControls.ServerValidateEventHandler(this.CustomValidatorPhone_ServerValidate);
			this.ButtonContinue.Click += new System.EventHandler(this.ButtonContinue_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void CheckBoxShipToBill_CheckedChanged(object sender, System.EventArgs e)
		{
			if(CheckBoxShipToBill.Checked) 
			{
				TextBoxFirstName.Enabled = false;
				TextBoxLastName.Enabled = false;
				TextBoxStreetAddress.Enabled = false;
				TextBoxApartmentAddress.Enabled = false;
				TextBoxCity.Enabled = false;
				TextBoxState.Enabled = false;
				TextBoxZip.Enabled = false;
				TextBoxZipExtended.Enabled = false;
				TextBoxAreaCode.Enabled = false;
				TextBoxPhonePrefix.Enabled = false;
				TextBoxPhoneEnd.Enabled = false;
				

				RequiredFieldValidatorFirstName.Enabled = false;
				RequiredFieldValidatorLastName.Enabled = false;
				RequiredFieldValidatorCity.Enabled = false;
				RequiredFieldValidatorState.Enabled = false;
				RequiredFieldValidatorZipCode.Enabled = false;
				RegularExpressionValidatorPhoneEnd.Enabled = false;
				RegularExpressionValidatorPhonePrefix.Enabled = false;
				RegularExpressionValidatorAreaCode.Enabled = false;
				RegularExpressionValidatorZipCodeExtFormat.Enabled = false;
				RegularExpressionValidatorZipCodeFormat.Enabled = false;
				RequiredFieldValidatorStreetAddress.Enabled = false;
				
			}
			else
			{
				TextBoxFirstName.Enabled = true;
				TextBoxLastName.Enabled = true;
				TextBoxStreetAddress.Enabled = true;
				TextBoxApartmentAddress.Enabled = true;
				TextBoxCity.Enabled = true;
				TextBoxState.Enabled = true;
				TextBoxZip.Enabled = true;
				TextBoxZipExtended.Enabled = true;
				TextBoxAreaCode.Enabled = true;
				TextBoxPhonePrefix.Enabled = true;
				TextBoxPhoneEnd.Enabled = true;
				

				RequiredFieldValidatorFirstName.Enabled = true;
				RequiredFieldValidatorLastName.Enabled = true;
				RequiredFieldValidatorCity.Enabled = true;
				RequiredFieldValidatorState.Enabled = true;
				RequiredFieldValidatorZipCode.Enabled = true;
				RegularExpressionValidatorPhoneEnd.Enabled = true;
				RegularExpressionValidatorPhonePrefix.Enabled = true;
				RegularExpressionValidatorAreaCode.Enabled = true;
				RegularExpressionValidatorZipCodeExtFormat.Enabled = true;
				RegularExpressionValidatorZipCodeFormat.Enabled = true;
				RequiredFieldValidatorStreetAddress.Enabled = true;
			}
		}

		private void ButtonContinue_Click(object sender, System.EventArgs e)
		{
			string customerID = (string) Session["customerID"];
			if(Page.IsValid) 
			{	
				DataRow billTo = Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spGetCustomer",
					new SqlParameter("@custID", customerID)).Tables[0].Rows[0];

				

				Guid newInvoiceID = (Guid) Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spGenUid").Tables[0].Rows[0]["nUid"];

				DataTable cdPurchases = (DataTable) Session["CDPurchases"];
				DataTable bookPurchases = (DataTable) Session["BookPurchases"];

				string sqlStr = "SELECT * FROM plincoln_billing.dbo.invoice WHERE 1=2";
				SqlDataAdapter daInvoice = new SqlDataAdapter(sqlStr, Common.ConnectionString);
				SqlCommandBuilder cbInvoice = new SqlCommandBuilder(daInvoice);
				DataTable dtInvoice = new DataTable("invoice");
				daInvoice.Fill(dtInvoice);


				double subTotal = 0.0;
				for(int i = 0; i < cdPurchases.Rows.Count; i++) 
				{
					//Response.Write(cdPurchases.Rows[i]["unitPrice"].GetType().ToString());
					//return;
					subTotal += (double) (((Decimal) cdPurchases.Rows[i]["unitPrice"]) * ((Int32) cdPurchases.Rows[i]["quantity"]));
					cdPurchases.Rows[i]["invoiceID"] = newInvoiceID;
				}
				
				for(int i = 0; i < bookPurchases.Rows.Count; i++) 
				{
					//Response.Write(bookPurchases.Rows[i]["unitPrice"].GetType().ToString());
					//return ;
					subTotal += (double) (((Decimal) bookPurchases.Rows[i]["unitPrice"]) * ((Int32) bookPurchases.Rows[i]["quantity"]));
					bookPurchases.Rows[i]["invoiceID"] = newInvoiceID;
				}

				DataRow invoice = dtInvoice.NewRow();
				invoice.BeginEdit();
				invoice["invoiceID"] = newInvoiceID;
				invoice["subTotalCost"] = Decimal.Parse(subTotal.ToString());
				invoice["taxCost"] = Decimal.Parse((0.085 * subTotal).ToString());
				invoice["billTo"] = new Guid((string) Session["customerID"]);
				if(this.CheckBoxShipToBill.Checked) 
				{
					invoice["shipTo"] = new Guid((string) Session["customerID"]);
					Session.Remove("ShipTo");
					Session.Remove("ShipToAdapter");

					Session.Add("Destination", ((string) billTo["city"]));
				}
				else
				{
					string phoneNumber = this.TextBoxAreaCode.Text + this.TextBoxPhonePrefix.Text + this.TextBoxPhoneEnd.Text;
					string aptAddress = this.TextBoxApartmentAddress.Text.Trim();
					string extZipCode = this.TextBoxZipExtended.Text;

					Guid newShipToID = (Guid) Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spGenUid").Tables[0].Rows[0]["nUid"];
					invoice["shipTo"] = newShipToID;


					sqlStr = "SELECT * FROM plincoln_billing.dbo.customer WHERE 1=2";
					SqlDataAdapter daCustomer = new SqlDataAdapter(sqlStr, Common.ConnectionString);
					SqlCommandBuilder cbCustomer = new SqlCommandBuilder(daCustomer);
					DataTable dtCustomer = new DataTable("customer");
					daCustomer.Fill(dtCustomer);

					DataRow shipTo = dtCustomer.NewRow();
					shipTo.BeginEdit();
					shipTo["customerID"] = newShipToID;
					shipTo["firstName"] = this.TextBoxFirstName.Text;
					shipTo["lastName"] = this.TextBoxLastName.Text;
					if(phoneNumber != "")
						shipTo["phoneNumber"] = phoneNumber;
					shipTo["streetAddress"] = this.TextBoxStreetAddress.Text;
					if(aptAddress != "")
						shipTo["aptAddress"] = aptAddress;
					shipTo["city"] = this.TextBoxCity.Text;
					shipTo["state"] = this.TextBoxState.Text;
					shipTo["zipCode"] = this.TextBoxZip.Text;
					if(extZipCode != "")
						shipTo["extZipCode"] = extZipCode;
					shipTo.EndEdit();

					Session.Add("Destination", this.TextBoxCity.Text);

					dtCustomer.Rows.Add(shipTo);

					Session.Add("ShipTo", dtCustomer);
					Session.Add("ShipToAdapter", daCustomer);
				}

				invoice.EndEdit();
				dtInvoice.Rows.Add(invoice);

				Session.Add("Invoice", dtInvoice);
				Session.Add("InvoiceAdapter", daInvoice);

				Response.Redirect("ProcessingShipping.aspx");
			}
		}

		private void ButtonBack_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("ShoppingCart.aspx");
		}

		private void CustomValidatorPhone_ServerValidate(object source, System.Web.UI.WebControls.ServerValidateEventArgs args)
		{
			args.IsValid = (this.RegularExpressionValidatorAreaCode.IsValid
				&& this.RegularExpressionValidatorPhonePrefix.IsValid
				&& this.RegularExpressionValidatorPhoneEnd.IsValid);
		}
	}
}
