using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using System.IO;

namespace DatabaseProj
{
	/// <summary>
	/// Summary description for Confirmation.
	/// </summary>
	public class Confirmation : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label LabelTotal;
		protected System.Web.UI.WebControls.Label LabelShipping;
		protected System.Web.UI.WebControls.Label LabelTax;
		protected System.Web.UI.WebControls.Label LabelSubtotal;
		protected System.Web.UI.WebControls.DataGrid GridBooksPurchased;
		protected System.Web.UI.WebControls.Label LabelCCInfo;
		protected System.Web.UI.WebControls.Label LabelPaymentType;
		protected System.Web.UI.WebControls.Label LabelBillTo;
		protected System.Web.UI.WebControls.Label LabelShipTo;
		protected System.Web.UI.HtmlControls.HtmlForm Form1;
		protected System.Web.UI.WebControls.Button ButtonSubmit;
		protected System.Web.UI.WebControls.Button ButtonCancel;
		protected System.Web.UI.WebControls.Label LabelOrderDate;
		protected System.Web.UI.WebControls.DataGrid DataGridCDsPurchased;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			DataRow mainInfo = ((DataTable) Session["Invoice"]).Rows[0];
			DataTable bookPurchases = (DataTable) Session["BookPurchases"];
			DataTable cdPurchases = (DataTable) Session["CDPurchases"];
			DataRow billTo = Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spGetCustomer",
				new SqlParameter("@custID", ((string) Session["customerID"]))).Tables[0].Rows[0];
			DataTable dtShipTo = (DataTable) Session["ShipTo"];
			DataRow shipTo = (dtShipTo == null) ? billTo : dtShipTo.Rows[0];
			
			DataTable dtCC = ((DataTable) Session["CC"]);
			DataRow CC = (dtCC == null) ? null : dtCC.Rows[0];

			//this.LabelInvoiceName.Text	= invoiceID;

			mainInfo.BeginEdit();
			mainInfo["orderDate"] = System.DateTime.Now;
			mainInfo.EndEdit();

			// Display main info
			this.LabelOrderDate.Text	= mainInfo["orderDate"].ToString();
			//this.LabelShipDate.Text		= (string) mainInfo["expectedShipDate"];
			this.LabelSubtotal.Text		= ((Decimal) mainInfo["subTotalCost"]).ToString("F2");
			this.LabelTax.Text			= ((Decimal) mainInfo["taxCost"]).ToString("F2");
			this.LabelShipping.Text		= ((Decimal) mainInfo["shippingCost"]).ToString("F2");
			//this.LabelShippingType.Text	= (string) mainInfo["shippingMethod"];
			this.LabelPaymentType.Text	= (string) mainInfo["paymentType"];
			double totalCost = double.Parse(LabelSubtotal.Text) + double.Parse(LabelTax.Text) + double.Parse(LabelShipping.Text);
			this.LabelTotal.Text		= totalCost.ToString("F2");

			if(! mainInfo["CCNumber"].GetType().ToString().Equals("System.DBNull"))
			{
				// A credit card was used, so display that information too

				string CCstr = (string) mainInfo["CCnumber"];

				// obscure the start of the CC
				if(CCstr.Length == 15)
					CCstr = "XXXXX XXX XXX " + CCstr.Substring(11, 4);
				else if(CCstr.Length == 16)
					CCstr = "XXXX XXXX XXXX " + CCstr.Substring(12, 4);

				LabelCCInfo.Visible = true;
				LabelCCInfo.Text = "<h4>Credit Card Information:</h4>" +
					"<TABLE id=\"Table1\" cellSpacing=\"3\" cellPadding=\"3\" border=\"0\">" +
					"<TR>" +
					"<TD><STRONG>Number:</STRONG></TD>" +
					"<TD>" + CCstr + "</TD>" +
					"</TR>" +
					"<TR>" +
					"<TD><STRONG>Exp. Date:</STRONG></TD>" +
					"<TD>" + mainInfo["CCexpMonth"].ToString() + "/" + mainInfo["CCexpYear"].ToString() + "</TD>" +
					"</TR>" +
					"<TR>" +
					"<TD><STRONG>Type:</STRONG></TD>" +
					"<TD>" + CC["Type"].ToString() + "</TD>" +
					"</TR>" +
					"</TABLE>";
			}

			// display BillTo Info
			string text = ((string) billTo["firstName"]) + " " + ((string) billTo["lastName"]) + "<br>" + // name
				((string) billTo["streetAddress"]) + "<br>"; // 1st address line
			if(! billTo["aptAddress"].GetType().ToString().Equals("System.DBNull"))
				text += ((string) billTo["aptAddress"]) + "<br>";  // 2nd address line
			text += ((string) billTo["city"]) + ", " + ((string) billTo["state"]) + " " + ((string) billTo["zipCode"]);
			if(! billTo["extZipCode"].GetType().ToString().Equals("System.DBNull"))
				text += "-" + ((string) billTo["extZipCode"]); // extended zip code
			text += "<br>";
			if(! billTo["phoneNumber"].GetType().ToString().Equals("System.DBNull"))
				text += "<br>Phone: " + ((string) billTo["phoneNumber"]); // formatted phone number
					
			LabelBillTo.Text = text;

			text = "";

			// display ShipTo Info
			text = ((string) shipTo["firstName"]) + " " + ((string) shipTo["lastName"]) + "<br>" + // name
				((string) shipTo["streetAddress"]) + "<br>"; // 1st address line
			if(! shipTo["aptAddress"].GetType().ToString().Equals("System.DBNull"))
				text += ((string) shipTo["aptAddress"]) + "<br>";  // 2nd address line
			text += ((string) shipTo["city"]) + ", " + ((string) shipTo["state"]) + " " + ((string) shipTo["zipCode"]);
			if(! shipTo["extZipCode"].GetType().ToString().Equals("System.DBNull"))
				text += "-" + ((string) shipTo["extZipCode"]); // extended zip code
			text += "<br>";
			if(! shipTo["phoneNumber"].GetType().ToString().Equals("System.DBNull"))
				text += "<br>Phone: " + ((string) shipTo["phoneNumber"]); // formatted phone number
					
			LabelShipTo.Text = text;

			// Display purchase info
			this.GridBooksPurchased.DataSource = bookPurchases;
			this.GridBooksPurchased.DataBind();
			if(bookPurchases.Rows.Count == 0)
				GridBooksPurchased.Visible = false;

			this.DataGridCDsPurchased.DataSource = cdPurchases;
			this.DataGridCDsPurchased.DataBind();
			if(cdPurchases.Rows.Count == 0)
				DataGridCDsPurchased.Visible = false;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ButtonSubmit.Click += new System.EventHandler(this.ButtonSubmit_Click);
			this.ButtonCancel.Click += new System.EventHandler(this.ButtonCancel_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ButtonCancel_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("Payment.aspx");
		}

		private void ButtonSubmit_Click(object sender, System.EventArgs e)
		{
			SqlDataAdapter   ShipToAdapter = (SqlDataAdapter) Session[  "ShipToAdapter"];
			SqlDataAdapter       CCAdapter = (SqlDataAdapter) Session[      "CCAdapter"];
			SqlDataAdapter  InvoiceAdapter = (SqlDataAdapter) Session[ "InvoiceAdapter"];
			SqlDataAdapter BookDataAdapter = (SqlDataAdapter) Session["BookDataAdapter"];
			SqlDataAdapter   CDDataAdapter = (SqlDataAdapter) Session[  "CDDataAdapter"];
			SqlDataAdapter  PackageAdapter = (SqlDataAdapter) Session[ "PackageAdapter"];

			DataTable   ShipTo = (DataTable) Session[  "ShipTo"];
			DataTable       CC = (DataTable) Session[      "CC"];
			DataTable  Invoice = (DataTable) Session[ "Invoice"];
			DataTable BookData = Common.GetBookShoppingCart(this.Session);
			DataTable   CDData = Common.GetCDShoppingCart(this.Session);
			DataTable  Package = (DataTable) Session[ "PackageTable"];
			
			DataTable ForeignOrders = (DataTable) Session["ForeignOrders"];
			DataTable ForeignProducts = (DataTable) Session["ForeignProducts"];

			int ShipToUpdateCount = 0;
			int CCUpdateCount = 0;
			int InvoiceUpdateCount = 0;
			int BookDataUpdateCount = 0;
			int CDDataUpdateCount = 0;
			int PackageUpdateCount = 0;

			this.GenerateOrderXMLs(ForeignOrders, ForeignProducts);

			if(ShipToAdapter != null)
				ShipToUpdateCount = ShipToAdapter.Update(ShipTo);

			try 
			{
				if(CCAdapter != null)
					CCUpdateCount = CCAdapter.Update(CC);
			} 
			catch(SqlException) 
			{
			}

			InvoiceUpdateCount = InvoiceAdapter.Update(Invoice);

			BookDataUpdateCount = BookDataAdapter.Update(BookData);
			CDDataUpdateCount = CDDataAdapter.Update(CDData);

			PackageUpdateCount = PackageAdapter.Update(Package);
			
			/*if(((ShipToAdapter != null) && (ShipToUpdateCount == 1))
				&& ((CCAdapter != null) && ((CCUpdateCount == 0) ||(CCUpdateCount == 1)))
				&& (InvoiceUpdateCount == 1)
				&& (BookDataUpdateCount == BookData.Rows.Count)
				&& (CDDataUpdateCount == CDData.Rows.Count)
				&& (PackageUpdateCount == Package.Rows.Count))
			{*/
				// update the database with all the new quantities
				this.UpdateInventoryDatabase();

				//
				// TO DO: CLEAR OUT ALL OF THE SESSION STUFF AND REINIT IT
				//
				string customerID = this.Session["customerID"].ToString();
				this.Session.Clear();
				this.Session.Add("customerID", customerID);
				Common.InitializeShoppingCart(this.Session);

				Response.Redirect("OrderCompletionStatus.aspx?status=S&invoiceID=" + ((Guid) Invoice.Rows[0]["invoiceID"]).ToString());
			/*}
			else
			{
				Response.Redirect("OrderCompletionStatus.aspx?status=F");
			}*/
		}

		private void UpdateInventoryDatabase()
		{
			string invoiceID = ((DataTable) this.Session["Invoice"]).Rows[0]["invoiceID"].ToString();
			Common.RunStoredProcedure(Common.ConnectionString, "RemoveInventoryItemsByInvoiceID", new SqlParameter("@invoiceID", invoiceID)); 
		}

		private void GenerateOrderXMLs(DataTable ForeignOrder, DataTable ForeignProducts)
		{
			/* ForeignOrders(PartnerCompany (GUID), shippingMethod (int), destination info...)
			   ForeignProducts(PartnerCompany (GUID), type, identifier, name, quantity)
			   */

			foreach (DataRow order in ForeignOrder.Rows)
			{
				string partnerCompanyName = Common.RunStoredProcedure(Common.ConnectionString, "cgillum_inventory.dbo.spGetCompanyByID",
						  new SqlParameter("@companyID", order["partnerCompany"])).Tables[0].Rows[0]["CompanyName"].ToString();

				string filename = Server.MapPath(".\\orders\\") + partnerCompanyName + "_" + Guid.NewGuid().ToString() + ".xml";
				StreamWriter output = new StreamWriter(filename);
				
				// output our company name
				string openingLine = "<order><issuingCompany>DCP Inc.</issuingCompany>";
				output.Write(openingLine);

				// output foreign company name
				string partnerCompanyLine = "<partnerCompany>"
						  + partnerCompanyName
						  + "</partnerCompany>";
				output.Write(partnerCompanyLine);

				// output products
				DataRow[] orderProducts = ForeignProducts.Select("partnerCompany = '" + order["partnerCompany"].ToString() + "'");
				foreach (DataRow product in orderProducts) 
				{
					string startProductLine = "<product>";
					output.Write(startProductLine);

					string productLine = "<type>" + product["type"].ToString() + "</type>";
					productLine += "<identifier>" + product["identifier"].ToString() + "</identifier>";
					productLine += "<name>" + product["name"].ToString() + "</name>";
					productLine += "<quantity>" + product["quantity"].ToString() + "</quantity>";
					output.Write(productLine);

					string endProductLine = "</product>";
					output.Write(endProductLine);
				}
				
				// output shipping method
				string shippingMethodLine = "<shippingMethod>" + order["shippingMethod"].ToString() + "</shippingMethod>";
				output.Write(shippingMethodLine);

				// output customer information
				string customerInfoLine = "<destination><address>" + order["address"].ToString() + "</address>";
				customerInfoLine += "<city>" + order["city"].ToString() + "</city>";
				customerInfoLine += "<state>" + order["state"].ToString() + "</state>";
				customerInfoLine += "<zip>" + order["zip"].ToString() + "</zip>";
				
				string tel = (order["tel"] == DBNull.Value)
					? null
					: "<tel>" + order["tel"].ToString() + "</tel>";
				string fax = (order["fax"] == DBNull.Value)
					? null
					: "<fax>" + order["fax"].ToString() + "</fax>";

				if((tel != null) && (fax != null))
				{
					customerInfoLine += "<contact>" + tel + fax + "</contact>";
				} 
				else if((tel == null) && (fax != null))
				{
					customerInfoLine += "<contact>" + fax + "</contact>";
				}
				else if((tel != null) && (fax == null))
				{
					customerInfoLine += "<contact>" + tel + "</contact>";
				}

				customerInfoLine += "</destination></order>";

				output.Write(customerInfoLine);

				output.Close();
			}


		}
	}
}
