using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace DatabaseProj
{
	/// <summary>
	/// Summary description for CreateUser.
	/// </summary>
	public class CreateUser : System.Web.UI.Page
	{
        protected System.Web.UI.WebControls.TextBox txtUserID;
        protected System.Web.UI.WebControls.TextBox txtPassword;
        protected System.Web.UI.WebControls.TextBox txtConfirmPassword;
        protected System.Web.UI.WebControls.Button btnSubmit;
        protected System.Web.UI.WebControls.TextBox TextBoxFirstName;
        protected System.Web.UI.WebControls.TextBox TextBoxZip;
        protected System.Web.UI.WebControls.TextBox TextBoxZipExtended;
        protected System.Web.UI.WebControls.TextBox TextBoxLastName;
        protected System.Web.UI.WebControls.TextBox TextBoxStreetAddress;
        protected System.Web.UI.WebControls.TextBox TextBoxApartmentAddress;
        protected System.Web.UI.WebControls.TextBox TextBoxCity;
        protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorFirstName;
        protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorLastName;
        protected System.Web.UI.WebControls.TextBox TextBoxAreaCode;
        protected System.Web.UI.WebControls.TextBox TextBoxPhonePrefix;
        protected System.Web.UI.WebControls.TextBox TextBoxPhoneEnd;
        protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorStreeAddress;
        protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorCity;
        protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorZipCode;
        protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorState;
        protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorUserID;
        protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorPassword;
        protected System.Web.UI.WebControls.Label LabelPasswordMismatch;
        protected System.Web.UI.WebControls.Label LabelUserNameAlreadyExists;
        protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidator4;
        protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidator5;
        protected System.Web.UI.WebControls.Button btnReset;
		protected System.Web.UI.WebControls.Label LabelUserIDTooShort;
		protected System.Web.UI.WebControls.Label LabelPasswordTooShort;
		protected System.Web.UI.WebControls.CustomValidator CustomValidatorPhone;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorAreaCode;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorPhonePrefix;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorPhoneEnd;
        protected System.Web.UI.WebControls.TextBox TextBoxState;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnSubmit.Click += new System.EventHandler(this.btnSubmit_Click);
			this.btnReset.Click += new System.EventHandler(this.btnReset_Click);
			this.CustomValidatorPhone.ServerValidate += new System.Web.UI.WebControls.ServerValidateEventHandler(this.CustomValidatorPhone_ServerValidate);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnReset_Click(object sender, System.EventArgs e)
		{
            this.txtUserID.Text = string.Empty;
            this.txtPassword.Text = string.Empty;
            this.txtConfirmPassword.Text = string.Empty;
            this.TextBoxApartmentAddress.Text = string.Empty;
            this.TextBoxAreaCode.Text = string.Empty;
            this.TextBoxCity.Text = string.Empty;
            this.TextBoxFirstName.Text = string.Empty;
            this.TextBoxLastName.Text = string.Empty;
            this.TextBoxPhoneEnd.Text = string.Empty;
            this.TextBoxPhonePrefix.Text = string.Empty;
            this.TextBoxState.Text = string.Empty;
            this.TextBoxStreetAddress.Text = string.Empty;
            this.TextBoxZip.Text = string.Empty;
            this.TextBoxZipExtended.Text = string.Empty;

			this.LabelPasswordMismatch.Visible = false;
			this.LabelPasswordTooShort.Visible = false;
			this.LabelUserNameAlreadyExists.Visible = false;
			this.LabelUserIDTooShort.Visible = false;
		}

		private void btnSubmit_Click(object sender, System.EventArgs e)
		{
			if(this.txtUserID.Text.Length >= 4) 
			{
				LabelUserIDTooShort.Visible = false;
			}
			else
			{
				LabelUserIDTooShort.Visible = true;
			}

			if(this.txtPassword.Text.Length >= 4) 
			{
				LabelPasswordTooShort.Visible = false;
			}
			else
			{
				LabelPasswordTooShort.Visible = true;
			}

			if (this.txtPassword.Text == this.txtConfirmPassword.Text)
			{
				this.LabelPasswordMismatch.Visible = false;
			}
			else
			{
				this.LabelPasswordMismatch.Visible = true;
			}

			if((this.txtUserID.Text.Length >= 4) && (this.txtPassword.Text.Length >= 4) &&
				(this.txtPassword.Text == this.txtConfirmPassword.Text) && Page.IsValid) 
			{
				string phoneNumber = this.TextBoxAreaCode.Text + this.TextBoxPhonePrefix.Text + this.TextBoxPhoneEnd.Text;
				string aptAddress = this.TextBoxApartmentAddress.Text.Trim();
				string extZipCode = this.TextBoxZipExtended.Text;

				try
				{
					Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spCreateAccount",
						new SqlParameter("@loginName", this.txtUserID.Text.Trim()),
						new SqlParameter("@password", this.txtPassword.Text),
						new SqlParameter("@firstname", this.TextBoxFirstName.Text.Trim()),
						new SqlParameter("@lastname", this.TextBoxLastName.Text.Trim()),
						new SqlParameter("@phoneNumber", phoneNumber != string.Empty ? phoneNumber : null),
						new SqlParameter("@streetAddress", this.TextBoxStreetAddress.Text.Trim()),
						new SqlParameter("@aptAddress", aptAddress != string.Empty ? aptAddress : null),
						new SqlParameter("@city", this.TextBoxCity.Text.Trim()),
						new SqlParameter("@state", this.TextBoxState.Text),
						new SqlParameter("@zipCode", this.TextBoxZip.Text),
						new SqlParameter("@extZipCode", extZipCode != string.Empty ? extZipCode : null));
				}
				catch (SqlException sqlE)
				{
					if (sqlE.Message == "User name already exists") this.LabelUserNameAlreadyExists.Visible = true;
					else
					{
						Response.Write("ERROR: " + sqlE.Message);
					}
				}

				Session.Add("t_user", this.txtUserID.Text.Trim());
				Response.Redirect("Index.aspx");
			}            

		}

		private void CustomValidatorPhone_ServerValidate(object source, System.Web.UI.WebControls.ServerValidateEventArgs args)
		{
			args.IsValid = (this.RegularExpressionValidatorAreaCode.IsValid
				&& this.RegularExpressionValidatorPhonePrefix.IsValid
				&& this.RegularExpressionValidatorPhoneEnd.IsValid);
		}

        //private bool LoginOkay
	}
}
