using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace DatabaseProj
{
	/// <summary>
	/// Summary description for CustomerInvoices.
	/// </summary>
	public class CustomerInvoices : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGridInvoices;
		protected System.Web.UI.WebControls.Label LabelInstructions;
		protected System.Web.UI.WebControls.Label LabelNoInvoices;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			string customerID = (string) Session["customerID"];
			if(customerID == null) 
			{
				Session.Clear();
				Response.Redirect("index.aspx");
			}


			DataTable invoices = Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spGetCustomerInvoices",
				new SqlParameter("@customerID", customerID)).Tables[0];

			if(invoices.Rows.Count > 0) 
			{
				DataGridInvoices.DataSource = invoices;
				DataGridInvoices.DataBind();
				LabelInstructions.Visible = true;
				DataGridInvoices.Visible = true;
				LabelNoInvoices.Visible = false;
			}
			else 
			{
				LabelInstructions.Visible = false;
				DataGridInvoices.Visible = false;
				LabelNoInvoices.Visible = true;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
