using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace DatabaseProj
{
	/// <summary>
	/// Summary description for Payment.
	/// </summary>
	public class Payment : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DropDownList DropDownListPaymentType;
		protected System.Web.UI.WebControls.TextBox TextBoxCCNumber;
		protected System.Web.UI.WebControls.TextBox TextBoxExpMonth;
		protected System.Web.UI.WebControls.TextBox TextBoxExpYear;
		protected System.Web.UI.WebControls.DropDownList DropDownListCCType;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorCCNumber;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorCCCode;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorCCMonth;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorCCYear;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorCCNumber;
		protected System.Web.UI.WebControls.Button ButtonContinue;
		protected System.Web.UI.WebControls.DropDownList DropDownListCC;
		protected System.Web.UI.WebControls.RangeValidator RangeValidatorExpMonth;
		protected System.Web.UI.WebControls.RangeValidator RangeValidatorExpYear;
		protected System.Web.UI.WebControls.TextBox TextBoxCCCode;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(! Page.IsPostBack) 
			{
				DataTable creditCards = Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spGetCustomerCreditCards",
					new SqlParameter("@customerID", (string) Session["customerID"])).Tables[0];

				Session.Add("customerCreditCards", creditCards);

				int i = 0;
				foreach (DataRow row in creditCards.Rows) 
				{
					string display = row["CCn"].ToString() + ", " + row["CCeM"].ToString() + "/" + row["CCeY"].ToString();
					string val = i.ToString();
					i++;
					ListItem item = new ListItem(display, val);
					DropDownListCC.Items.Add(item);
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.DropDownListPaymentType.SelectedIndexChanged += new System.EventHandler(this.DropDownListPaymentType_SelectedIndexChanged);
			this.DropDownListCC.SelectedIndexChanged += new System.EventHandler(this.DropDownListCC_SelectedIndexChanged);
			this.ButtonContinue.Click += new System.EventHandler(this.ButtonContinue_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ButtonBack_Click(object sender, System.EventArgs e)
		{
			Session.Remove("customerCreditCards");
			Response.Redirect("ChooseShipping.aspx");
		}

		private void ButtonContinue_Click(object sender, System.EventArgs e)
		{
			if(Page.IsValid) 
			{
				string customerID = (string) Session["customerID"];
				DataTable dtInvoice = (DataTable) Session["Invoice"];
				DataRow invoice = dtInvoice.Rows[0];

				invoice.BeginEdit();
				invoice["paymentType"] = this.DropDownListPaymentType.SelectedValue;
				
				if(this.DropDownListPaymentType.SelectedValue.Equals("CreditCard")) 
				{
					string sqlStr = "SELECT * FROM plincoln_billing.dbo.CreditCard WHERE 1=2";
					SqlDataAdapter daCC = new SqlDataAdapter(sqlStr, Common.ConnectionString);
					SqlCommandBuilder cbCC = new SqlCommandBuilder(daCC);
					DataTable dtCC = new DataTable("CreditCard");
					daCC.Fill(dtCC);
					
					DataRow CC = dtCC.NewRow();

					CC.BeginEdit();
					
					CC["number"] = this.TextBoxCCNumber.Text;
					invoice["CCnumber"] = CC["number"];
					
					CC["expMonth"] = int.Parse(this.TextBoxExpMonth.Text);
					invoice["CCexpMonth"] = CC["expMonth"];
					
					CC["expYear"] = int.Parse(this.TextBoxExpYear.Text);
					invoice["CCexpYear"] = CC["expYear"];

					CC["type"] = this.DropDownListCCType.SelectedValue;
					if(this.TextBoxCCCode.Text != "")
						CC["securityCode"] = this.TextBoxCCCode.Text;
					CC.EndEdit();

					dtCC.Rows.Add(CC);

					Session.Add("CC", dtCC);
					Session.Add("CCAdapter", daCC);
				}
				else
				{
					invoice["CCnumber"] = DBNull.Value;
					invoice["CCexpMonth"] = DBNull.Value;
					invoice["CCexpYear"] = DBNull.Value;

					Session.Remove("CC");
					Session.Remove("CCAdapter");
				}
				invoice.EndEdit();

				Session.Remove("customerCreditCards");
				Response.Redirect("Confirmation.aspx");
			}
		}

		private void DropDownListPaymentType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(this.DropDownListPaymentType.SelectedValue == "CreditCard")
			{
				TextBoxCCNumber.Enabled = true;
				TextBoxExpMonth.Enabled = true;
				TextBoxExpYear.Enabled = true;
				DropDownListCCType.Enabled = true;
				RegularExpressionValidatorCCNumber.Enabled = true;
				RangeValidatorExpMonth.Enabled = true;
				RangeValidatorExpYear.Enabled = true;
				RegularExpressionValidatorCCCode.Enabled = true;
				RequiredFieldValidatorCCMonth.Enabled = true;
				RequiredFieldValidatorCCYear.Enabled = true;
				RequiredFieldValidatorCCNumber.Enabled = true;
				TextBoxCCCode.Enabled = true;
				DropDownListCC.Enabled = true;
			}
			else
			{
				TextBoxCCNumber.Enabled = false;
				TextBoxExpMonth.Enabled = false;
				TextBoxExpYear.Enabled = false;
				DropDownListCCType.Enabled = false;
				RegularExpressionValidatorCCNumber.Enabled = false;
				RangeValidatorExpMonth.Enabled = false;
				RangeValidatorExpYear.Enabled = false;
				RegularExpressionValidatorCCCode.Enabled = false;
				RequiredFieldValidatorCCMonth.Enabled = false;
				RequiredFieldValidatorCCYear.Enabled = false;
				RequiredFieldValidatorCCNumber.Enabled = false;
				TextBoxCCCode.Enabled = false;
				DropDownListCC.Enabled = false;
			}
		}

		private void DropDownListCC_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DataTable creditCards = (DataTable) Session["customerCreditCards"];
			string selectedValue = DropDownListCC.SelectedValue;
			if(selectedValue == "AddNew") 
			{
				TextBoxCCNumber.Text = "";
				TextBoxExpMonth.Text = "";
				TextBoxExpYear.Text = "";
				TextBoxCCCode.Text = "";

				TextBoxCCNumber.Enabled = true;
				TextBoxExpMonth.Enabled = true;
				TextBoxExpYear.Enabled = true;
				TextBoxCCCode.Enabled = true;
				DropDownListCCType.Enabled = true;
				
				
			}
			else
			{
				int index = int.Parse(selectedValue);
				DataRow row = creditCards.Rows[index];
				TextBoxCCNumber.Text = row["CCn"].ToString();
				TextBoxExpMonth.Text = row["CCeM"].ToString();
				TextBoxExpYear.Text = row["CCeY"].ToString();
				TextBoxCCCode.Text = row["CCsC"].ToString();
				DropDownListCCType.SelectedIndex = DropDownListCCType.Items.IndexOf(DropDownListCCType.Items.FindByValue(row["CCt"].ToString()));

				TextBoxCCNumber.Enabled = false;
				TextBoxExpMonth.Enabled = false;
				TextBoxExpYear.Enabled = false;
				TextBoxCCCode.Enabled = false;
				DropDownListCCType.Enabled = false;
			}

		}
	}
}
