using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace DatabaseProj
{
	/// <summary>
	/// Summary description for UpdateCustomer.
	/// </summary>
	public class UpdateCustomer : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox TextBoxPhoneEnd;
		protected System.Web.UI.WebControls.TextBox TextBoxPhonePrefix;
		protected System.Web.UI.WebControls.TextBox TextBoxAreaCode;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorZipCode;
		protected System.Web.UI.WebControls.TextBox TextBoxZipExtended;
		protected System.Web.UI.WebControls.TextBox TextBoxZip;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorState;
		protected System.Web.UI.WebControls.TextBox TextBoxState;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorCity;
		protected System.Web.UI.WebControls.TextBox TextBoxCity;
		protected System.Web.UI.WebControls.TextBox TextBoxApartmentAddress;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorStreeAddress;
		protected System.Web.UI.WebControls.TextBox TextBoxStreetAddress;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorLastName;
		protected System.Web.UI.WebControls.TextBox TextBoxLastName;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidatorFirstName;
		protected System.Web.UI.WebControls.TextBox TextBoxFirstName;
		protected System.Web.UI.WebControls.TextBox txtConfirmPassword;
		protected System.Web.UI.WebControls.TextBox txtPassword;
		protected System.Web.UI.WebControls.Button ButtonUpdatePassword;
		protected System.Web.UI.WebControls.Button ButtonCancelPassword;
		protected System.Web.UI.WebControls.Label LabelIncorrectOldPassword;
		protected System.Web.UI.WebControls.Button ButtonCancelInfo;
		protected System.Web.UI.WebControls.Label LabelPasswordUpdated;
		protected System.Web.UI.WebControls.Label LabelInfoUpdated;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorZipCodeFormat;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorZipCodeExtFormat;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorAreaCode;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorPhonePrefix;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidatorPhoneEnd;
		protected System.Web.UI.WebControls.CustomValidator CustomValidatorPhone;
		protected System.Web.UI.WebControls.TextBox TextBoxOldPassword;
		protected System.Web.UI.WebControls.Label LabelPasswordTooShort;
		protected System.Web.UI.WebControls.Label LabelPasswordMismatch;
		protected System.Web.UI.WebControls.Button ButtonUpdateInfo;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(Session["customerID"] == null)
				Response.Redirect("index.aspx");

			if(TextBoxFirstName.Text.Equals("<<<<>>>><<<<>>>><<<<>>>>"))
				loadCustomerOldData();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ButtonUpdatePassword.Click += new System.EventHandler(this.ButtonUpdatePassword_Click);
			this.ButtonCancelPassword.Click += new System.EventHandler(this.ButtonCancelPassword_Click);
			this.CustomValidatorPhone.ServerValidate += new System.Web.UI.WebControls.ServerValidateEventHandler(this.CustomValidatorPhone_ServerValidate);
			this.ButtonUpdateInfo.Click += new System.EventHandler(this.ButtonUpdateInfo_Click);
			this.ButtonCancelInfo.Click += new System.EventHandler(this.ButtonCancelInfo_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ButtonUpdatePassword_Click(object sender, System.EventArgs e)
		{
			bool oldOk = oldPasswordOk();
			if(oldOk) 
			{
				LabelIncorrectOldPassword.Visible = false;
			} 
			else 
			{
				LabelIncorrectOldPassword.Visible = true;
			}
			
			if(this.txtPassword.Text == this.txtConfirmPassword.Text) 
			{
				this.LabelPasswordMismatch.Visible = false;
			} 
			else 
			{
				this.LabelPasswordMismatch.Visible = true;
			}

			if(this.txtPassword.Text.Length >= 4) 
			{
				this.LabelPasswordTooShort.Visible = false;
			}
			else 
			{
				this.LabelPasswordTooShort.Visible = true;
			}

			if(oldOk && (this.txtPassword.Text == this.txtConfirmPassword.Text) && (this.txtPassword.Text.Length >= 4)) 
			{
				LabelIncorrectOldPassword.Visible = false;
				LabelPasswordMismatch.Visible = false;
				LabelPasswordTooShort.Visible = false;

				try 
				{
					Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spUpdatePassword",
						new SqlParameter("@customerID", (string) Session["customerID"]),
						new SqlParameter("@newPassword", this.txtPassword.Text));
				}
				catch(SqlException) 
				{
					this.LabelPasswordUpdated.Text = "Password Update Failed!";
					this.LabelPasswordUpdated.Visible = true;
					return;
				}

				loadCustomerOldData();
				this.LabelPasswordUpdated.Text = "Password Update Success!";
				this.LabelPasswordUpdated.Visible = true;
				
			}
		}

		private bool oldPasswordOk() 
		{
			int count = (int) Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spComparePassword",
				new SqlParameter("@customerID", (string) Session["customerID"]),
				new SqlParameter("@password", TextBoxOldPassword.Text)).Tables[0].Rows[0]["ok"];

			return count > 0;
		}

		private void ButtonCancelPassword_Click(object sender, System.EventArgs e)
		{
			LabelIncorrectOldPassword.Text = "";
			LabelPasswordMismatch.Text = "";
			LabelPasswordTooShort.Text = "";

			LabelIncorrectOldPassword.Visible = false;
			LabelPasswordMismatch.Visible = false;
			LabelPasswordTooShort.Visible = false;

			LabelPasswordUpdated.Visible = false;
		}

		private void ButtonUpdateInfo_Click(object sender, System.EventArgs e)
		{
			if(Page.IsValid) 
			{
				string phoneNumber = this.TextBoxAreaCode.Text + this.TextBoxPhonePrefix.Text + this.TextBoxPhoneEnd.Text;
				string aptAddress = this.TextBoxApartmentAddress.Text.Trim();
				string extZipCode = this.TextBoxZipExtended.Text;

				string customerID = (string) Session["customerID"];

				try
				{
					Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spUpdateAccountInfo",
						new SqlParameter("@customerID", customerID),
						new SqlParameter("@firstname", this.TextBoxFirstName.Text.Trim()),
						new SqlParameter("@lastname", this.TextBoxLastName.Text.Trim()),
						new SqlParameter("@phoneNumber", ((phoneNumber != string.Empty) 
							? phoneNumber
							: null)),
						new SqlParameter("@streetAddress", this.TextBoxStreetAddress.Text.Trim()),
						new SqlParameter("@aptAddress", ((aptAddress != string.Empty)
							? aptAddress
							: null)),
						new SqlParameter("@city", this.TextBoxCity.Text.Trim()),
						new SqlParameter("@state", this.TextBoxState.Text),
						new SqlParameter("@zipCode", this.TextBoxZip.Text),
						new SqlParameter("@extZipCode", ((extZipCode != string.Empty)
							? extZipCode
							: null)));
				} 
				catch (SqlException ex) 
				{
					Response.Write(ex.Message);
					LabelInfoUpdated.Text = "Information Update Failed!";
					LabelInfoUpdated.Visible = true;
					return;
				}

				loadCustomerOldData();
				LabelInfoUpdated.Text = "Name/Address Updated!";
				LabelInfoUpdated.Visible = true;
				
			}
			else
			{
				// comment                     
			}
		}

		private void ButtonCancelInfo_Click(object sender, System.EventArgs e)
		{
			loadCustomerOldData();
		}

		private void loadCustomerOldData() 
		{
			string customerID = (string) Session["customerID"];
			
			DataSet customerSet = Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spGetCustomer",
				new SqlParameter("@custID", customerID));

			DataRow customerInfo = customerSet.Tables[0].Rows[0];

			TextBoxFirstName.Text = (string) customerInfo["firstName"];
			TextBoxLastName.Text = (string) customerInfo["lastName"];
			TextBoxStreetAddress.Text = (string) customerInfo["streetAddress"];

			if(customerInfo["aptAddress"].GetType().ToString().Equals("System.DBNull"))
				TextBoxApartmentAddress.Text = "";
			else
				TextBoxApartmentAddress.Text = (string) customerInfo["aptAddress"];

			TextBoxCity.Text = (string) customerInfo["city"];
			TextBoxState.Text = (string) customerInfo["state"];
			TextBoxZip.Text = (string) customerInfo["zipCode"];

			if(customerInfo["extZipCode"].GetType().ToString().Equals("System.DBNull"))
				TextBoxZipExtended.Text = "";
			else
				TextBoxZipExtended.Text = (string) customerInfo["extZipCode"];

			if(! customerInfo["phone"].GetType().ToString().Equals("System.DBNull")) 
			{
				string phone = (string) customerInfo["phone"];
				TextBoxAreaCode.Text = phone.Substring(1,3);
				TextBoxPhonePrefix.Text = phone.Substring(6,3);
				TextBoxPhoneEnd.Text = phone.Substring(10,4);
			}

			LabelInfoUpdated.Visible = false;
		}

		private void CustomValidatorPhone_ServerValidate(object source, System.Web.UI.WebControls.ServerValidateEventArgs args)
		{
			args.IsValid = (this.RegularExpressionValidatorAreaCode.IsValid
				&& this.RegularExpressionValidatorPhonePrefix.IsValid
				&& this.RegularExpressionValidatorPhoneEnd.IsValid);
		}

	}
}
