using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace DatabaseProj
{
	/// <summary>
	/// Summary description for Warehouses.
	/// </summary>
	public class Warehouses : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label LabelStreet;
		protected System.Web.UI.WebControls.Label LabelCityStateZip;
		protected System.Web.UI.WebControls.Label LabelNumShipped;
		protected System.Web.UI.WebControls.DataGrid DataGridProducts;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(Request["id"] != null)
			{				
				string warehouse = (string)Request["id"];
				DataSet warehouseTables = Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spGetWarehouse", 
																							new SqlParameter("@warehouseID", warehouse));
				DataTable address = warehouseTables.Tables[0];
				DataTable vendor = warehouseTables.Tables[1];
				DataTable products = warehouseTables.Tables[2];
				DataTable shipped = warehouseTables.Tables[3];
	
				DataGridProducts.DataSource = products;
				DataGridProducts.DataBind();
				DataGridProducts.Visible = true;

				if(address.Rows[0] != null)
				{
					LabelStreet.Text = (string)address.Rows[0]["StreetAddress"];
					LabelCityStateZip.Text = (string)address.Rows[0]["City"] + ", " + (string)address.Rows[0]["State"] + " " + (string)address.Rows[0]["Zip"];				
				}
				LabelNumShipped.Text = ((int)shipped.Rows[0]["TotalShipped"]).ToString();

			}			
		}	

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
