using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;	// This is the library with the SQL types we're using below



namespace DatabaseProj
{
    /// <summary>
    /// Summary description for index.
    /// </summary>
    public class index : System.Web.UI.Page
    {
        protected System.Web.UI.WebControls.TextBox TextBoxUserName;
        protected System.Web.UI.WebControls.Button ButtonSignIn;
        protected System.Web.UI.WebControls.Button ButtonReset;
        protected System.Web.UI.WebControls.Label LabelNotFound;
        protected System.Web.UI.WebControls.Label LabelCongrats;
        protected System.Web.UI.WebControls.TextBox TextBoxPassword;
	
        private void Page_Load(object sender, System.EventArgs e)
        {
            if (Page.IsPostBack) return;

            // Put user code to initialize the page here
            //If there is someone who just created an account, place their name in the user field
            if(Session["t_user"] != null)
            {
                this.TextBoxUserName.Text = (String) Session["t_user"];
                this.LabelCongrats.Visible = true;
                Session.Remove("t_user");
            }
        }

        private void SignIn(string username, string inputPassword)
        {
            DataSet ds = Common.RunStoredProcedure(Common.ConnectionString, "plincoln_billing.dbo.spCheckPassword", 
                new SqlParameter("@username", username),
                new SqlParameter("@inputPassword", inputPassword));

            // check to see if any rows were returned
            if (ds.Tables[0].Rows.Count != 0)
            {
                DataRow returnData = ds.Tables[0].Rows[0];
                string customerID = returnData["customerID"].ToString();
                bool   isManager  = (bool)returnData["isManager"];
                string redirectUrl = null;

                // if it's a manager, redirect to the management page
                if (isManager) 
                {
                    Session.Add("isManager", true);
                    redirectUrl = "Management.aspx";
                }
                else
                {
                    Session.Add("customerID", customerID);
                    redirectUrl = "Inventory.aspx";
                }

                // initialize the shopping cart in the session
                Common.InitializeShoppingCart(this.Session);

                // move to the next page
                Response.Redirect(redirectUrl);
            }
            else
            {
                this.LabelNotFound.Visible = true;
            }
        }


        #region Web Form Designer generated code
        override protected void OnInit(EventArgs e)
        {
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit(e);
        }
		
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {    
            this.ButtonSignIn.Click += new System.EventHandler(this.ButtonSignIn_Click);
            this.ButtonReset.Click += new System.EventHandler(this.ButtonReset_Click);
            this.Load += new System.EventHandler(this.Page_Load);

        }
        #endregion

        private void ButtonReset_Click(object sender, System.EventArgs e)
        {
            TextBoxUserName.Text = "";
            TextBoxPassword.Text = "";
            this.LabelNotFound.Visible = false;
        }

        private void ButtonSignIn_Click(object sender, System.EventArgs e)
        {
            this.SignIn(this.TextBoxUserName.Text.Trim(), this.TextBoxPassword.Text.Trim());
        }
    }
}