using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace DatabaseProj
{
	/// <summary>
	/// Summary description for OrderCompletionStatus.
	/// </summary>
	public class OrderCompletionStatus : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label LabelStatus;
		protected System.Web.UI.WebControls.Button Button;
		protected System.Web.UI.WebControls.Label LabelMessage;
	
		private const string SUCCESS = "success";
		private const string FAILURE = "failure";

		private void Page_Load(object sender, System.EventArgs e)
		{
			string status = (string) Request["status"];
			string invoiceID = (string) Request["invoiceID"];
			if(status == "S")
			{
				LabelStatus.Text = SUCCESS;
				LabelMessage.Text = "Your order was a success! &nbsp;Your invoice number is '" + invoiceID + "'. &nbsp;"
					+ "Click <a href=\"Invoice.aspx?invoiceID=" + invoiceID +"\">here</a> to view your invoice.";
				Button.Text = "View Invoice";
			}
			else
			{
				LabelStatus.Text = FAILURE;
				LabelMessage.Text = "Your order failed! &nbsp;We're sorry. &nbsp;Please try again.";
				Button.Text = "Retry";
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Button.Click += new System.EventHandler(this.Button_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Button_Click(object sender, System.EventArgs e)
		{
			if(LabelStatus.Text == SUCCESS) 
			{
				string invoiceID = (string) Request["invoiceID"];
				Response.Redirect("Invoice.aspx?invoiceID=" + invoiceID);
			}
			else
			{
				Session.Clear();
				Response.Redirect("index.aspx");
			}
		}
	}
}
