using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace DatabaseProj
{
	/// <summary>
	/// Summary description for ProcessingShipping.
	/// </summary>
	public class ProcessingShipping : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGridTest2;
		protected System.Web.UI.WebControls.DataGrid DataGridTest;
			
		private void Page_Load(object sender, System.EventArgs e)
		{
			DataTable dtCDs = (DataTable)Session["CDPurchases"];
			DataTable dtBooks = (DataTable)Session["BookPurchases"];
			string destination = (string)Session["Destination"];

			fillBookWarehouses(dtBooks, destination);
			fillCDWarehouses(dtCDs, destination);

			Response.Redirect("ChooseShipping.aspx");
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void fillCDWarehouses(DataTable CDs, string destination)
		{
			DataTable processed = CDs.Copy();
			processed.Clear();
			for(int i=0; i < CDs.Rows.Count; i++)
			{
				DataSet warehouses = Common.RunStoredProcedure(Common.ConnectionString, "cgillum_inventory.dbo.spGetWarehousesCDStock", 
					new SqlParameter("@CDID", CDs.Rows[i]["CDID"]));
				int amount = (int)CDs.Rows[i]["quantity"];
				
				if((int)warehouses.Tables[0].Rows[0]["quantity"] >= amount) 
				{					
					DataRow updated = CDs.Rows[i];
					updated["warehouse"] = extractWarehouse(amount, warehouses.Tables[0], destination);
					processed.ImportRow(updated);
				}
				else
				{
					int j = 0;
					while(amount > 0)
					{						
						if(j < warehouses.Tables[0].Rows.Count)
						{
							DataRow updated = CDs.Rows[i];							
							updated["warehouse"] = warehouses.Tables[0].Rows[j]["warehouseID"];
							if((amount - (int)warehouses.Tables[0].Rows[j]["quantity"]) >= 0)
							{
								updated["quantity"] = warehouses.Tables[0].Rows[j]["quantity"]; 
								amount -= (int)warehouses.Tables[0].Rows[j]["quantity"];	
							}
							else
							{
								updated["quantity"] = amount;
								amount = 0;
							}												
							j++;
							processed.ImportRow(updated);
						}
						else 
							break;
					}
				}
			}		
			//Test Display
			DataGridTest.Visible = false; //TURN OFF TO DEBUG
			DataGridTest.DataSource = processed;
			DataGridTest.DataBind();

			//Rebind Session Object
			Session["CDPurchases"] = processed;
			return;

		}

		private void fillBookWarehouses(DataTable books, string destination)
		{
			DataTable processed = books.Copy();
			processed.Clear();
			for(int i=0; i < books.Rows.Count; i++)
			{
				DataSet warehouses = Common.RunStoredProcedure(Common.ConnectionString, "cgillum_inventory.dbo.spGetWarehousesBookStock", 
					new SqlParameter("@ISBN", books.Rows[i]["ISBN"]));
				int amount = (int)books.Rows[i]["quantity"];
				
				if((int)warehouses.Tables[0].Rows[0]["quantity"] >= amount) 
				{
					DataRow updated = books.Rows[i];
					updated["warehouse"] = extractWarehouse(amount, warehouses.Tables[0], destination);
					processed.ImportRow(updated);
				}
				else
				{
					int j = 0;
					while(amount > 0)
					{
						if(j < warehouses.Tables[0].Rows.Count)
						{
							DataRow updated = books.Rows[i];
							updated["warehouse"] = warehouses.Tables[0].Rows[j]["warehouseID"];
							updated["quantity"] = warehouses.Tables[0].Rows[j]["quantity"];
							amount -= (int)warehouses.Tables[0].Rows[j]["quantity"];
							j++;
							processed.ImportRow(updated);
						}else
							break;
					}
				}
			}
			//Test Display
			DataGridTest2.Visible = false; //TURN OFF TO DEBUG
			DataGridTest2.DataSource = processed;
			DataGridTest2.DataBind();
			
			//Rebind Session Object
			Session["BookPurchases"] = processed;

			return;
		}

		private string extractWarehouse(int amount, DataTable warehouses, string destination)
		{
			for(int i=0; i<warehouses.Rows.Count; i++)
			{
				if(warehouses.Rows[i]["city"].ToString() == destination && (int)warehouses.Rows[i]["quantity"] >= amount)
					return warehouses.Rows[i]["warehouseID"].ToString();
			}
			return warehouses.Rows[0]["warehouseID"].ToString();
		}
	}
}
