using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace DatabaseProj
{
	/// <summary>
	/// Summary description for ShippingMethodInformation.
	/// </summary>
	public class ShippingMethodInformation : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGridShipping;
		protected System.Web.UI.WebControls.Button ButtonSubmit;
		protected System.Web.UI.WebControls.TextBox TextBoxCity;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			//If not manager, get out!
			if(Session["isManager"] == null || !(bool)Session["isManager"])
			{	
				Session.Clear();
				Response.Redirect("index.aspx");
			}	
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.TextBoxCity.TextChanged += new System.EventHandler(this.TextBoxCity_TextChanged);
			this.ButtonSubmit.Click += new System.EventHandler(this.ButtonSubmit_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void TextBoxCity_TextChanged(object sender, System.EventArgs e)
		{
			
		}

		private void ButtonSubmit_Click(object sender, System.EventArgs e)
		{
			DataSet salesTable = Common.RunStoredProcedure(Common.ConnectionString, "drashid_shipping.dbo.spShipToCity", 
				new SqlParameter("@city", TextBoxCity.Text));
			//Edit Restrictions
			DataTable dt = salesTable.Tables[0];
			dt.Columns.Add("Restrict");
			for(int i =0; i < dt.Rows.Count; i++)
			{
                if(dt.Rows[i]["Restrictions"] == null)
                    continue;
				dt.Rows[i].BeginEdit();
				if(dt.Rows[i]["Restrictions"].ToString() == "max items")
					dt.Rows[i]["Restrict"] = dt.Rows[i]["Restrictions"].ToString() + " is " + ((int)dt.Rows[0]["RestrictionValue"]).ToString();
				else if( dt.Rows[i]["Restrictions"].ToString() == "max weight")
					dt.Rows[i]["Restrict"] = dt.Rows[i]["Restrictions"].ToString() + " of " + ((int)dt.Rows[0]["RestrictionValue"]).ToString() + " lbs.";
				else
					dt.Rows[i]["Restrict"] = dt.Rows[i]["Restrictions"].ToString();
				dt.Rows[i].EndEdit();
			}
			DataGridShipping.DataSource = salesTable.Tables[0].DefaultView;
			DataGridShipping.DataBind();
			DataGridShipping.Visible = true;
		}
	}
}
