<companyInfo>
<companyName>444f</companyName>
<products>
{for $x in document("books.xml")/books/b
let 	$key := $x/a[1]/k[1],
	$p := $key/@price, $d := $key/@discountPrice,
	$q := $key/p/@quantity
return <book><isbn>{fn:string($x/@isbn)}</isbn>

	<title>{fn:string($x/@title)}</title>
	<year>{fn:string($x/@year)}</year>
	<category>{fn:string($x/@category)}</category>
	{for $a in $x/a
	let $l := fn:substring-before(fn:string($a/@author),","),
		$f := fn:substring-after(fn:string($a/@author),", ")
	return <author><fn>{fn:string($f)}</fn>
		<ln>{fn:string($l)}</ln></author>}
	<publisher>{fn:string($x/@publisher)}</publisher>
	{ for $k in $x/a[1]/k
	return <keyword>{fn:string($k/@keyword)}</keyword>}
	<price>{fn:string($p)}</price>
	<discountPrice>{fn:string($d)}</discountPrice>
	<quantity>{fn:string($q)}</quantity>
</book>}

{for $x in document("cds.xml")/cds/c
return <music><id>{fn:string($x/@cdid)}</id>

	<albumName>{fn:string($x/@albumName)}</albumName>
	<genre>{fn:string($x/@genre)}</genre>
	<artist>{fn:string($x/a/@artist)}</artist>
	<recordingCompany>{fn:string($x/@recordingCompany)}</recordingCompany>
	<price>{fn:string($x/a/@price)}</price>
	<discount>{fn:string($x/a/@discountPrice)}</discount>
	<quantity>{fn:string($x/a/p/@quantity)}</quantity>
</music>}

</products>

  <shipping>
  { for $shipping in document("shipping_raw.xml")/result,
    $vendor in $shipping/vendor
    return
      <vendor>
        { $vendor/name, $vendor/url, $vendor/toll-free,
          for $method in $vendor/method
          return
            <method id="{($method/id)}">
            {
              $method/option,
              let $price := $method/price/text() where $method/pricing_unit = 'flat  ' return <price><flat>{ $price }</flat></price>,
              let $price := $method/price/text() where $method/pricing_unit = 'items ' return <price><perUnit>{ $price }</perUnit></price>,
              let $price := $method/price/text() where $method/pricing_unit = 'weight' return <price><perPound>{ $price }</perPound></price>,

              for $restrictions in $method/restrictions
              return
                <restrictions>
                {
                  $restrictions/maximumWeight,
                  $restrictions/maximumitems,
                  for $cities in $restrictions/cities
                  return <cities>{ $cities/city/text() }</cities>
                }
                </restrictions>
            }
            </method>
        }
      </vendor>
  }
  </shipping>
</companyInfo>
