using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace phase2
{
	/// <summary>
	/// Summary description for browse.
	/// </summary>
	public class browse : System.Web.UI.Page
	{
		private string errorOpen = "<b><font color='red'><big><big><big>";
		private string errorClose = "</big></big></big></font></b><br>";
		private SqlConnection sqlConn;	// Declare a connection object
		private SqlCommand sqlCom;		  // Declare a command object
		private SqlDataReader sqlRdr;	  // Declare a reader to read the query result
		private string strSqlString = "server=IISQLSRV; uid=kristamd; pwd=TeamKMR; database=kristamd_inventory";
		protected System.Web.UI.WebControls.Button allProducts;
		protected System.Web.UI.WebControls.TextBox authArtText;
		protected System.Web.UI.WebControls.Label noItems;
		protected System.Web.UI.WebControls.Label errorLabel;
		protected System.Web.UI.WebControls.TextBox titleText;
		protected System.Web.UI.WebControls.Button titleButton;
		protected System.Web.UI.WebControls.Button authorButton;
		protected System.Web.UI.WebControls.Button artistButton;
		protected System.Web.UI.WebControls.TextBox keywordText;
		protected System.Web.UI.WebControls.Button keywordButton;
		protected System.Web.UI.WebControls.DataGrid cdGrid;
		protected System.Web.UI.WebControls.DataGrid bookGrid;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.allProducts.Click += new System.EventHandler(this.allProducts_Click);
			this.titleButton.Click += new System.EventHandler(this.title_Click);
			this.authorButton.Click += new System.EventHandler(this.author_Click);
			this.artistButton.Click += new System.EventHandler(this.artist_Click);
			this.keywordButton.Click += new System.EventHandler(this.keyword_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void author_Click(object sender, System.EventArgs e) 
		{
			makeInvisible();

			string name = authArtText.Text;
			if (name.Length == 0) { 
				this.noItems.Text += errorOpen + "Please enter an Author's name."+errorClose;
				return;
			}

			try 
			{
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	// open the connection

				string strSql = "select authors.isbn+','+partnerCompany as ID, "+
					"authorName as Author, title as Title, discount as Price " +
					"from books, allproducts, authors " +
					"where authorName like '%"+name+"%' and authors.isbn = books.isbn and books.isbn = idNum";
											
				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				// Get the answer from the reader and write it to the label.
				if (sqlRdr.HasRows) 
				{

					bookGrid.DataSource = sqlRdr;
					bookGrid.DataBind();
					bookGrid.Visible = true;
				}
				else
				{
					this.noItems.Text += errorOpen + "There are no items by "+name+"."+errorClose;
				}

				// Close the sql connection at the end
				sqlConn.Close();
			}
			catch(Exception e1) 
			{
				errorLabel.Text = errorOpen + e1.Message.ToString() + errorClose;
			}
		}

		private void artist_Click(object sender, System.EventArgs e) 
		{
			makeInvisible();

			string name = authArtText.Text;
			if (name.Length == 0) { 
				this.noItems.Text = errorOpen + "Please enter an artist name." + errorClose;			
				return;
			}
			try 
			{
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	// open the connection

				string strSql = "select artist as Artist, artists.cdid+','+partnerCompany as ID, albumName as Album, quantity, discount as Price " +
					"from cds, allproducts, artists " +
					"where artist like '%"+name+"%' and artists.cdid = cds.cdid and cds.cdid = idNum";
											
				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				// Get the answer from the reader and write it to the label.
				if (sqlRdr.HasRows) 
				{
					cdGrid.DataSource = sqlRdr;
					cdGrid.DataBind();
					cdGrid.Visible = true;
				}
				else
				{
					this.noItems.Text += errorOpen + "There are no items by "+name+"." + errorClose;
				}

				// Close the sql connection at the end
				sqlConn.Close();
			}
			catch(Exception e1) 
			{
				errorLabel.Text = errorOpen + e1.Message.ToString() + errorClose;
			}
		}
		
		private void allProducts_Click(object sender, System.EventArgs e) 
		{	
			makeInvisible();
			try 
			{
				getbooks("0");
				getcds("0");
			}
			catch(Exception e1) 
			{
				errorLabel.Text = errorOpen + e1.Message.ToString() + errorClose;
			}
		}
		
		private void getbooks(string q) 
		{
			// Start a new connection to the database specified in strSqlString
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection
	

			// Execute query -- Here you could make 'strSql' any query you want
			string strSql = "SELECT idNum+','+partnerCompany as ID, title as Title, max(authorName) as Author, discount as Price " +
				"FROM allProducts, books, authors " +
				"WHERE allProducts.idNum = books.isbn and books.isbn=authors.isbn and type='book' " +
				"and allProducts.quantity >= " + q +
				" GROUP BY idNum, partnerCompany, type, title, discount";
							
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			// Get the answer from the reader and write it to the label.
			if (sqlRdr.HasRows) 
			{
				bookGrid.DataSource = sqlRdr;
				bookGrid.DataBind();
				bookGrid.Visible = true;
			}
			else
			{
				this.noItems.Text += errorOpen + "There are no Books" + errorClose;
			}
			
			// Close the sql connection at the end
			sqlConn.Close();

		}

		private void getcds(string q) 
		{
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection

			string strSql = "SELECT idNum+','+partnerCompany as ID, allProducts.type, albumName as Album, max(artist) as Artist, discount as Price " +
				"FROM allProducts, cds, artists " +
				"WHERE allProducts.idNum = cds.cdID and cds.cdid=artists.cdid and allProducts.type='cd' " +
				"and allProducts.quantity >= " + q +
				" GROUP BY idNum, partnerCompany, allProducts.type, albumName, discount";
											
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			// Get the answer from the reader and write it to the label.
			if (sqlRdr.HasRows) 
			{
				cdGrid.DataSource = sqlRdr;
				cdGrid.DataBind();
				cdGrid.Visible = true;
			}
			else
			{
				this.noItems.Text += errorOpen + "There are no CDs" + errorClose;
			}

			// Close the sql connection at the end
			sqlConn.Close();
		}

		private void title_Click(object sender, System.EventArgs e) 
		{
			makeInvisible();

			string title = this.titleText.Text;
			if (title.Length == 0) 
			{ 
				this.noItems.Text = errorOpen + "Please enter a title." + errorClose;
				return;
			}

			try 
			{
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	// open the connection

				string strSql = "select idNum+','+partnerCompany as ID, "+
					"title as Title, max(authorName) as Author, discount as Price " +
					"from books, allproducts, authors " +
					"where title like '%"+title+"%' and idNum = books.isbn and authors.isbn = books.isbn " + 
					"group by idNum, partnerCompany, title, discount";
											
				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				// Get the answer from the reader and write it to the label.
				if (sqlRdr.HasRows) 
				{

					bookGrid.DataSource = sqlRdr;
					bookGrid.DataBind();
					bookGrid.Visible = true;
				}
				else
				{
					this.noItems.Text += errorOpen + "There are no books with title: "+title+"."+errorClose;
				}

				// Close the sql connection at the end
				sqlConn.Close();
			}
			catch(Exception e1) 
			{
				errorLabel.Text = errorOpen + e1.Message.ToString() + errorClose;
			}
		}

		private void keyword_Click(object sender, System.EventArgs e) 
		{
			makeInvisible();

			string key = this.keywordText.Text;
			if (key.Length == 0) 
			{ 
				this.noItems.Text += errorOpen + "Please enter a word to search for."+errorClose;
				return;
			}

			try 
			{
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	// open the connection

				string strSql = "select keywords.isbn+','+partnerCompany as ID, max(authorName) as Author, title as Title, discount as Price " +
					"from books, authors, keywords, allproducts " +
					"where keyword like '%"+key+"%' and authors.isbn = books.isbn "+
					"and books.isbn = keywords.isbn and keywords.isbn = allproducts.idNum " + 
					"group by keywords.isbn, title, partnerCompany, discount";
											
				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				// Get the answer from the reader and write it to the label.
				if (sqlRdr.HasRows) 
				{

					bookGrid.DataSource = sqlRdr;
					bookGrid.DataBind();
					bookGrid.Visible = true;
				}
				else
				{
					this.noItems.Text += errorOpen + "There are no books with keyword: "+key+"."+errorClose;
				}

				// Close the sql connection at the end
				sqlConn.Close();
			}
			catch(Exception e1) 
			{
				errorLabel.Text = errorOpen + e1.Message.ToString() + errorClose;
			}
		}

		private void makeInvisible()
		{
			errorLabel.Text = "";;
			this.noItems.Text = "";
			bookGrid.Visible = false;											
			cdGrid.Visible = false;
		}


	}
}
