using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Configuration;
using System.IO;

namespace phase2
{
	/// <summary>
	/// Check out items and run transaction
	/// </summary>
	public class checkout : System.Web.UI.Page
	{
		private string noteString = "Please enter ";
		private string errorOpen = "<p class='error'>";
		private string errorClose = "</p>";
		private double tax = .085;
		private string custID = "";

		// Store retrieved database tables here for later access.
		private DataSet data;

		private SqlConnection sqlConn;	// Declare a connection object
		private SqlCommand sqlCom;		  // Declare a command object
		private SqlDataReader sqlRdr;	  // Declare a reader to read the query result
		private string strSqlString;
		
		private string[][] unableToShip;

		protected System.Web.UI.WebControls.Panel shippingAddrPanel;
		protected System.Web.UI.WebControls.Panel shippingOptsPanel;
		protected System.Web.UI.WebControls.Panel methodOfPaymentPanel;
		protected System.Web.UI.WebControls.Panel confirmPanel;
		protected System.Web.UI.WebControls.RadioButton myAddrRadio;
		protected System.Web.UI.WebControls.RadioButton otherAddrRadio;
		protected System.Web.UI.WebControls.Button changeShippingAddr;
		protected System.Web.UI.WebControls.Button shippingAddrButton;
		protected System.Web.UI.WebControls.DataGrid shippingAddrGrid;
		protected System.Web.UI.WebControls.Panel blankAddrPanel;
		protected System.Web.UI.WebControls.TextBox address1;
		protected System.Web.UI.WebControls.TextBox address2;
		protected System.Web.UI.WebControls.TextBox city;
		protected System.Web.UI.WebControls.TextBox state;
		protected System.Web.UI.WebControls.TextBox zip;
		protected System.Web.UI.WebControls.TextBox phone;
	    protected System.Web.UI.WebControls.TextBox fax;
		protected System.Web.UI.WebControls.Label addrNoteLabel;
		protected System.Web.UI.WebControls.Label errorLabel;
		protected System.Web.UI.HtmlControls.HtmlTableCell itemCostBox;
		protected System.Web.UI.HtmlControls.HtmlTableCell taxBox;
		protected System.Web.UI.HtmlControls.HtmlTableCell shippingCostBox;
		protected System.Web.UI.HtmlControls.HtmlTableCell totalCostBox;
		protected System.Web.UI.WebControls.RadioButton creditRadio;
		protected System.Web.UI.WebControls.Button changeCreditCardButton;
		protected System.Web.UI.WebControls.DataGrid creditGrid;
		protected System.Web.UI.WebControls.RadioButton pigeonRadio;
		protected System.Web.UI.WebControls.TextBox cardNumText;
		protected System.Web.UI.WebControls.TextBox cardCompanyText;
		protected System.Web.UI.WebControls.TextBox exprMonthText;
		protected System.Web.UI.WebControls.TextBox yearBox;
		protected System.Web.UI.WebControls.TextBox name;
		protected System.Web.UI.WebControls.Panel otherPersonNamePanel;
		protected System.Web.UI.WebControls.Panel creditPanel;
		protected System.Web.UI.WebControls.Button methodOfPaymentSubmit;
		protected System.Web.UI.HtmlControls.HtmlTable costSummaryTable;
		protected System.Web.UI.WebControls.DataGrid confirmItemsGrid;
		protected System.Web.UI.WebControls.Label confirmAddress;
		protected System.Web.UI.WebControls.DataGrid confirmCardGrid;
		protected System.Web.UI.WebControls.Label confirmShippingLabel;
		protected System.Web.UI.WebControls.Label confirmPaymentLabel;
		protected System.Web.UI.WebControls.DataGrid confirmCreditGrid;
		protected System.Web.UI.WebControls.DataGrid ShippingOptsGrid;
		protected System.Web.UI.WebControls.DataGrid confirmAddressGrid;
		protected System.Web.UI.WebControls.DataGrid PackageItemsGrid;
		protected System.Web.UI.WebControls.Label CompanyItemsLabel;
		protected System.Web.UI.WebControls.Label ShippingOptsLabel;
		protected System.Web.UI.WebControls.Button confirmFinalSubmit;

		private void Page_Load(object sender, System.EventArgs e)
		{
			custID = getCustID();
			if (custID == "") 
			{
				this.errorLabel.Text += errorOpen + "You must be logged in to have a cart." + errorClose;
				hideAllPanels();
				return;
			}

			int cartSize = getCartSize();
			if (cartSize <= 0) 
			{ 
				this.errorLabel.Text += errorOpen + "Your Cart is empty!" + errorClose;
				hideAllPanels();
				return;
			}

			data = new DataSet("Data");
			unableToShip = new string[cartSize][];
			this.errorLabel.Text = "";

			if (!this.IsPostBack) 
			{
				setUpShippingAddr();
				Session["shippingChoices"] = null;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.myAddrRadio.CheckedChanged += new System.EventHandler(this.myAddrRadio_CheckedChanged);
			this.changeShippingAddr.Click += new System.EventHandler(this.changeShippingAddr_Click);
			this.otherAddrRadio.CheckedChanged += new System.EventHandler(this.otherAddrRadio_CheckedChanged);
			this.shippingAddrButton.Click += new System.EventHandler(this.shippingAddrButton_Click);
			this.ShippingOptsGrid.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.ShippingOptionSelected);
			this.creditRadio.CheckedChanged += new System.EventHandler(this.creditRadio_CheckedChanged);
			this.changeCreditCardButton.Click += new System.EventHandler(this.changeCreditCardButton_Click);
			this.pigeonRadio.CheckedChanged += new System.EventHandler(this.pigeonRadio_CheckedChanged);
			this.methodOfPaymentSubmit.Click += new System.EventHandler(this.methodOfPaymentSubmit_Click);
			this.confirmFinalSubmit.Click += new System.EventHandler(this.confirmFinalSubmit_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		#region Generally useful methods
		private string getCustID() 
		{
			object id = Session["customerid"];
			if (id == null) { return ""; }
			return id.ToString();
		}

		//returns the number of items in the customer's cart
		//does NOT consider quantity of one item
		private int getCartSize() 
		{
			dbquery_inventory db = new dbquery_inventory();
			return db.getShoppingCartSize(custID);
		}

		private void hideAllPanels()
		{
			shippingAddrPanel.Visible = false;

			shippingOptsPanel.Visible = false;
			methodOfPaymentPanel.Visible = false;
			confirmPanel.Visible = false;

			shippingAddrGrid.Visible = false;
			blankAddrPanel.Visible = false;
		}

		private void showError(string error)
		{
			errorLabel.Text += errorOpen + error + errorClose;
		}
		private void showMessage(string message)
		{
			errorLabel.Text += "<p class='message'>" + message + "</p>\n";
		}
		#endregion

		#region Shipping Address Panel = Step 1
		private void setUpShippingAddr() 
		{
			hideAllPanels();
			shippingAddrPanel.Visible = true;
			showMyAddress();
		}

		private DataTable readMyAddress()
		{
			DataSet data = new DataSet();

			try 
			{
				sqlConn = new phase2.dbquery_billing().createConnection();
				sqlConn.Open();	// open the connection

				string strSql =
					"SELECT name, a.id, address1, address2, city, state, zip, phone " +
					"FROM   address as a, customer as c " +
					"WHERE a.id = c.addressid and c.id = @custID";
								
				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);
				sqlCom.Parameters.Add("@custID", SqlDbType.Int).Value = this.custID;
				// Execute the command
				new SqlDataAdapter(sqlCom).Fill(data, "shippingAddress");

				return data.Tables["shippingAddress"];
			} 
			catch (Exception e1) 
			{
				showError("ERROR:" + e1.Message.ToString());
				return null;
			}
			finally 
			{
				sqlConn.Close();
			}
		}

		private void address2Fields(DataTable addressTable)
		{
			if (addressTable != null && addressTable.Rows.Count > 0) 
			{
				DataRow address = addressTable.Rows[0];
				this.name.Text = address["name"].ToString();
				this.address1.Text = address["address1"].ToString();
				this.address2.Text = address["address2"].ToString();
				this.city.Text = address["city"].ToString();
				this.state.Text = address["state"].ToString();
				this.zip.Text = address["zip"].ToString();
				this.phone.Text = address["phone"].ToString();
			}
		}
		private void showMyAddress()
		{
			if (custID == "" || myAddrRadio.Checked == false)
				return;

			/* if we have a shipping address,
			 * use shippingAddrGrid to display it.
			 * else, show blankAddrPanel
			 */
			DataTable address = readMyAddress();
			address2Fields(address);

			// Hide the address input panel
			blankAddrPanel.Visible = false;

			if (address != null) 
			{
				shippingAddrGrid.DataSource = new DataView(address);
				shippingAddrGrid.DataBind();
				shippingAddrGrid.Visible = true;
			}				
			else 
			{ 
				shippingAddrGrid.Visible = false;
				this.addrNoteLabel.Text = noteString + "your shipping Address:";
				this.blankAddrPanel.Visible = true;
			}
		}

		private void myAddrRadio_CheckedChanged(object sender, System.EventArgs e)
		{
			if (custID == "" || myAddrRadio.Checked == false)
				return;

			showMyAddress();
		}

		private void otherAddrRadio_CheckedChanged(object sender, System.EventArgs e)
		{
			if (otherAddrRadio.Checked == false)
				return;

			this.addrNoteLabel.Text = noteString + "address of the person receiving this gift:";
			this.blankAddrPanel.Visible = true;
			this.otherPersonNamePanel.Visible = true;
			this.shippingAddrGrid.Visible = false;

			// Clear all address fields
			this.name.Text = this.address1.Text = this.address2.Text = this.city.Text = this.state.Text = this.zip.Text = "";
		}

		private void changeShippingAddr_Click(object sender, System.EventArgs e)
		{
			this.addrNoteLabel.Text = noteString + "your new Address:";
			this.blankAddrPanel.Visible = true;
			this.otherAddrRadio.Checked = false;
			this.myAddrRadio.Checked = true;
			this.otherPersonNamePanel.Visible = false;
			this.shippingAddrGrid.Visible = false;
			
			DataTable addressTable = this.readMyAddress();

			address2Fields(addressTable);
		}

		private void shippingAddrButton_Click(object sender, System.EventArgs e)
		{
			if (blankAddrPanel.Visible) 
			{
				// Address has been provided. Either it's a new address, or and update to the user's address.
				if (address1.Text == "" || city.Text == "" ||
					state.Text == "" || zip.Text == "") 
				{
					showError("Please fill in all starred fields.");
					return;
				}
				if (this.myAddrRadio.Checked) 
				{
					int id = (int) Session["customerid"];

					// Customer has requested that their address be changed
					if (!(new phase2.dbquery_billing()).updateAddress(id, address1.Text, address2.Text, city.Text, state.Text, zip.Text)) 
					{
						showError("Failed to update address information.");
						return;
					}
					else
					{
						showMessage("Address information changed.");
					}
				} 
				else 
				{
					// Gift shipping for someone else
					// Ensure that name was given, but don't do anything in the database yet.
					if (name.Text == "") 
					{
						showError("Please fill in the name of the recipient of this purchase.");
						return;
					}
				}
			} // datagrid must be holding their addr in database and they want to ship there
			//set any instanse variables needed for the final invoice.

			//if all goes well, do:
			//findWarehouses(); //will set some instance variable and update Marie's database?
			//inventory will have warehouse quantities updated at confirm

			//gear up for step 2!
			setupShippingOpts();
		
		}

		#endregion

		#region Shipping Options Panel = Step 2

		//Marie, I believe this is your domain.  Enjoy....

		private void setupShippingOpts()
		{
			hideAllPanels();
			shippingOptsPanel.Visible = true;

			// if we have not yet made the list of shipping companies, do that.
			if(Session["shippingChoices"] == null) 
			{
				
				DataTable shoppingCart = new dbquery_inventory().getShoppingCart((int)(Session["customerid"]));

				int companyOverCount = shoppingCart.Rows.Count;
				string[,] allCompanies = new string[companyOverCount,2];
				foreach (DataRow r in shoppingCart.Rows)
				{
					string companyName = (string) r["partnerCompany"];
					bool recorded = false;
					int i = 0;
					while(i < companyOverCount && allCompanies[i,0] != null) 
					{
						if(allCompanies[i,0] == companyName) 
						{
							recorded = true;
						}
						i++;
					}
					if(recorded == false) 
					{
						allCompanies[i,0] = companyName;
					}
				}
				Session["shippingChoices"] = allCompanies;
			}
			// then work on filling out the company table
			if(getNextShippingOption() == false) 
			{
				setUpMethodOfPayment();
			}
		}

		// put the next shipping option into the "shippingChoices" table
		// return true if we did that and false if there were no more company entries to fill out
		private bool getNextShippingOption()
		{
			string[,] allCompanies = (string[,]) Session["shippingChoices"];
			string currentCompany = "";
			for(int i = 0; i < allCompanies.Length/2; i++) 
			{
				if(allCompanies[i,0] != null && allCompanies[i,1] == null) 
				{
					currentCompany = allCompanies[i,0];
					break;
				}
			}
			if(currentCompany == "") 
			{
				return false;
			}
			this.CompanyItemsLabel.Text = "We will be shipping these items from " + currentCompany + ", our affiliate company.";
			if(currentCompany == "444f") 
			{
				this.CompanyItemsLabel.Text = "We will be shipping these items from our own company.";
			}
			this.ShippingOptsLabel.Text = "Please choose a shipping option for these items.";
			string city = this.city.Text;
			string custid = this.getCustID();

			strSqlString = ConfigurationSettings.AppSettings["InventoryDatabase"];
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection

			// show the user all the items coming from here the current company
			string strSql =
				"SELECT carts.quantity, products.type, id, title, price, discount, weight\n" +
				"FROM   ShoppingCarts AS carts,\n" +
				"       (SELECT 'book' AS type, isbn AS id, title\n" +
				"        FROM Books UNION SELECT 'cd', cdid, albumName FROM CDs) AS products,\n" +
				"       AllProducts\n" +
				"WHERE  carts.itemID = products.id AND carts.itemType = products.type\n" +
				"       AND carts.itemID = AllProducts.idNum AND carts.itemType = AllProducts.type\n" +
				"       AND carts.partnerCompany = AllProducts.partnerCompany\n" +
				"       AND custId = '" + custid + "'\n" +
				"		AND carts.partnerCompany = '" + currentCompany + "'\n";

			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			PackageItemsGrid.DataSource = sqlRdr;
			PackageItemsGrid.DataBind();
			PackageItemsGrid.Visible = true;
			sqlRdr.Close();


			// now we want to get the total weight of the package
			strSql =
				"SELECT SUM(weight) as w\n" +
				"FROM   ShoppingCarts AS carts,\n" +
				"       (SELECT 'book' AS type, isbn AS id, title\n" +
				"        FROM Books UNION SELECT 'cd', cdid, albumName FROM CDs) AS products,\n" +
				"       AllProducts\n" +
				"WHERE  carts.itemID = products.id AND carts.itemType = products.type\n" +
				"       AND carts.itemID = AllProducts.idNum AND carts.itemType = AllProducts.type\n" +
				"       AND carts.partnerCompany = AllProducts.partnerCompany\n" +
				"       AND custId = '" + custid + "'\n" +
				"		AND carts.partnerCompany = '" + currentCompany + "'\n";

			// The command needs to know the query and the connection
			SqlCommand command = new SqlCommand(strSql, sqlConn);

			DataSet ds = new DataSet();
			new SqlDataAdapter(command).Fill(ds, "weight");
			
			// and then we want to get the total number of items in the package
			strSql =
				"SELECT SUM(carts.quantity) as q\n" +
				"FROM   ShoppingCarts AS carts,\n" +
				"       (SELECT 'book' AS type, isbn AS id, title\n" +
				"        FROM Books UNION SELECT 'cd', cdid, albumName FROM CDs) AS products,\n" +
				"       AllProducts\n" +
				"WHERE  carts.itemID = products.id AND carts.itemType = products.type\n" +
				"       AND carts.itemID = AllProducts.idNum AND carts.itemType = AllProducts.type\n" +
				"       AND carts.partnerCompany = AllProducts.partnerCompany\n" +
				"       AND custId = '" + custid + "'\n" +
				"		AND carts.partnerCompany = '" + currentCompany + "'\n";

			// The command needs to know the query and the connection
			command = new SqlCommand(strSql, sqlConn);

			new SqlDataAdapter(command).Fill(ds, "quantity");
			
						
			sqlConn.Close();

			DataRow r = ds.Tables["quantity"].Rows[0];
			string numItems = (r["q"]).ToString();
			r = ds.Tables["weight"].Rows[0];
			string weight = (r["w"]).ToString();
//			string companyName = (string) r["partnerCompany"];

			strSqlString = ConfigurationSettings.AppSettings["ShippingDatabase"];
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection

			// get all shipping methods for the originating company and destination city,
			// and get the package cost.
//			strSql = "SELECT ID, Vendor_Name, Shipping_Option, Days_to_deliver,  " +
//				"FROM Shipping_Methods, Shipping_Cities " +
//				"WHERE Shipping_Methods.company = Shipping_Cities.company AND Shipping_Vendor=Vendor_Name AND Delivery_City = '" + city + "' AND Shipping_Methods.company = '" + currentCompany + "' ";
			
			strSql =	"SELECT Valid_Vendors.ID, Valid_Vendors.Vendor_Name, Shipping_Option, Package_Cost, Days_to_Deliver " +
						"FROM (((SELECT company, ID, Vendor_Name, Price_per_Unit AS Package_Cost " +
							"FROM Shipping_Methods " +
							"WHERE Pricing_Unit = 'flat') UNION " +
							"(SELECT company, ID, Vendor_Name, Price_per_Unit*" + weight + " AS Package_Cost " +
							"FROM Shipping_Methods " +
							"WHERE Pricing_Unit = 'weight')) UNION " +
							"(SELECT company, ID, Vendor_Name, Price_per_Unit*" + numItems + " AS Package_Cost " +
							"FROM Shipping_Methods " +
							"WHERE Pricing_Unit = 'items')) AS Valid_Vendors, " +
							"Shipping_Cities, Shipping_Methods " +
						"WHERE	Delivery_City = '" + city + "' AND " +
							"Shipping_Cities.company = '" + currentCompany + "' AND " +
							"Valid_Vendors.company = '" + currentCompany + "' AND " +
							"Shipping_Methods.company = '" + currentCompany + "' AND " +
							"Shipping_Cities.Shipping_Vendor = Valid_Vendors.Vendor_Name AND " +
							"Shipping_Cities.Shipping_Vendor = Shipping_Methods.Vendor_Name AND " +
							"Shipping_Methods.ID = Valid_Vendors.ID " +
						"ORDER BY Package_Cost";


			
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows) 
			{
				ShippingOptsGrid.DataSource = sqlRdr;
				ShippingOptsGrid.DataBind();
				ShippingOptsGrid.Visible = true;
			}
			else 
			{
				this.showError("Unfortunately, our partner company, " + currentCompany + ", does not ship items to the city of " + city + ". Please remove these items from your cart, or move to another city to continue. For debugging, all partner companies <em>can</em> ship to the city 'nowhere'.");
				ShippingOptsGrid.Visible = false;
			}
			sqlConn.Close();

			return true;

		}

		// store the user's selection and give them the next choice
		// if there are no more choices to make, send them on to payment
		private void ShippingOptionSelected(object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e) 
		{
			string option_num = ((System.Web.UI.WebControls.Button)e.CommandSource).Text;
			string[,] allCompanies = (string[,]) Session["shippingChoices"];
			for(int i = 0; i < allCompanies.Length/2; i++) 
			{
				if(allCompanies[i,0] != null && allCompanies[i,1] == null) 
				{
					allCompanies[i,1] = option_num;
					break;
				}
			}
			Session["shippingChoices"] = allCompanies;
			if(getNextShippingOption() == false) 
			{
				setUpMethodOfPayment();
			}

		}

		private void skip2button_Click(object sender, System.EventArgs e)
		{
			setUpMethodOfPayment();
		}

		#region Lots of Stuff that didn't work for phase 2 (currently commented out)
		/*
		private void setupShippingOpts()
		{
			hideAllPanels();
			shippingOptsPanel.Visible = true;

			string city = this.city.Text;
			try 
			{
				string[][] correctWarehouse = this.getInTownWarehouse(city);
				if(correctWarehouse.Length == 0) 
				{
					correctWarehouse = this.getSingleOutOfTownWarehouse(city);
					//we found exactly one -- either in city or not
					if(correctWarehouse.Length == 0) 
					{
						correctWarehouse = this.getSeveralOutOfTownWarehouses(city);
					}
				}
				//save what is coming from where!  or it will get cleared!
				fillInventoryDataGrid(correctWarehouse);
				getShippingOpts(correctWarehouse[0][0], city);
			}
			catch (System.Data.SqlClient.SqlException e) 
			{
				this.errorLabel.Text = e.Message;
				return;
			}
		}

		//fill a datagrid so we remember what and how much is coming from where
		private void fillInventoryDataGrid(string[][] wareIdTypeQuant)
		{
			DataTable crap = new DataTable();
			crap.Columns.Add("warehouse");
			crap.Columns.Add("idNum");
			crap.Columns.Add("type");
			crap.Columns.Add("quantity");

			for (int i=0; i < wareIdTypeQuant.Length; i++) 
			{
				if (wareIdTypeQuant[i] == null) { break; }
				crap.Rows.Add(wareIdTypeQuant[i]);
			}
			this.AdminInventoryGrid.DataSource = new DataView(crap);
			this.AdminInventoryGrid.DataBind();
			//this.AdminInventoryGrid.Visible = true;

		}

		/-
		private void giveShippingOpts(string[][] wareIdTypeQuant, int whichWare)
		{
			if (wareIdTypeQuant.Length >= whichWare ||
				wareIdTypeQuant[whichWare] == null) { return; }
			DataTable options = getShippingOpts(wareIdTypeQuant[whichWare][0], city);
			
			ShippingOptsGrid.DataSource = new DataView(options);
			ShippingOptsGrid.DataBind();
			ShippingOptsGrid.Visible = true;
		}	-/

		// Try to find a warehouse in the destination city that has the entire shopping cart.
		private string[][] getInTownWarehouse(string city) 
		{
			try 
			{
				// Now get all warehouses in the destination city
				sqlConn = new SqlConnection( ConfigurationSettings.AppSettings["InventoryDatabase"]);
				sqlConn.Open();	// open the connection
				
				string query = "SELECT DISTINCT name FROM Warehouses WHERE city = '" + city + "' ";
				DataSet ds = new DataSet("Warehouses");
				new SqlDataAdapter(query, sqlConn).Fill(ds, "city_warehouses");
				sqlConn.Close();

				sqlConn = new SqlConnection(ConfigurationSettings.AppSettings["ShippingDatabase"]);
				sqlConn.Open();

				// Now figure out which of those warehouses can ship to the desired city
				int rowCount = ds.Tables["city_warehouses"].Rows.Count;
				IEnumerator enumerator = ds.Tables["city_warehouses"].Rows.GetEnumerator();
				enumerator.MoveNext();
				for(int i = 0; i < rowCount; i++) 
				{
					string currentWarehouse = ((DataRow)(enumerator.Current)).ItemArray.GetValue(0).ToString();
					enumerator.MoveNext();
					query = "SELECT DISTINCT Warehouse " + 
						"FROM Warehouse_Shippers, Shipping_Cities " + 
						"WHERE Delivery_City = '" + city + "' AND Shipping_Vendor = Vendor_Name AND Warehouse = '" + currentWarehouse + "' ";
					new SqlDataAdapter(query, sqlConn).Fill(ds, "shippable_warehouses");
				}
			

				// And finally figure out if any of the warehouses can ship the entire invoice
				// first make a shopping cart dataset
				query = "SELECT itemID, itemType " +
					"FROM ShoppingCarts " +
					"WHERE custID = '" + this.custID + "'";
				new SqlDataAdapter(query, sqlConn).Fill(ds, "shopping_cart");

				rowCount = ds.Tables["shippable_warehouses"].Rows.Count;
				enumerator = ds.Tables["shippable_warehouses"].Rows.GetEnumerator();
				enumerator.MoveNext();
				// then make a data set out of all the items in the cart entirely fulfilled by a given warehouse
				for(int i = 0; i < rowCount; i++) 
				{
					string currentWarehouse = ((DataRow)(enumerator.Current)).ItemArray.GetValue(0).ToString();
					enumerator.MoveNext();
					query = "SELECT itemID, itemType " +
						"FROM ShoppingCarts, ProductLocals " +
						"WHERE itemID = idNum AND itemType = type AND ShoppingCarts.quantity <= ProductLocals.quantity AND warehouse = '" + currentWarehouse + "' AND custId = '" + this.custID + "' ";
					new SqlDataAdapter(query, sqlConn).Fill(ds, "warehouse_cart");
					// then if a warehouse entirely fulfills all of the shopping cart, use it.
					if(ds.Tables["shopping_cart"].Rows.Count == ds.Tables["warehouse_cart"].Rows.Count) 
					{
						sqlConn.Close();
						return fillRetWith(currentWarehouse);
					}
					ds.Tables["warehouse_cart"].Clear();

				}
			}
			catch (System.Data.SqlClient.SqlException e) 
			{
				this.errorLabel.Text = e.Message;
				return new string[0][];
			}
			finally 
			{
				sqlConn.Close();
			}
			return new string[0][];

		}

		private string[][] getSingleOutOfTownWarehouse(string city) 
		{
			try 
			{
				// Figure out which warehouses can ship to the desired city
				sqlConn = new SqlConnection(ConfigurationSettings.AppSettings["ShippingDatabase"]);
				sqlConn.Open();
				string query = "SELECT DISTINCT Warehouse " + 
					"FROM Warehouse_Shippers, Shipping_Cities " + 
					"WHERE Delivery_City = '" + city + "' AND Shipping_Vendor = Vendor_Name ";
				DataSet ds = new DataSet("Warehouses");
				new SqlDataAdapter(query, sqlConn).Fill(ds, "shippable_warehouses");
				sqlConn.Close();

				sqlConn = new SqlConnection(ConfigurationSettings.AppSettings["InventoryDatabase"]);
				sqlConn.Open();

				// And then figure out if any of the warehouses can ship the entire invoice
				// first make a shopping cart dataset
				query = "SELECT itemID, itemType " +
					"FROM ShoppingCarts " +
					"WHERE custID = '" + this.custID + "'";
				new SqlDataAdapter(query, sqlConn).Fill(ds, "shopping_cart");

				int rowCount = ds.Tables["shippable_warehouses"].Rows.Count;
				IEnumerator enumerator = ds.Tables["shippable_warehouses"].Rows.GetEnumerator();
				enumerator.MoveNext();
				// then make a data set out of all the items in the cart entirely fulfilled by a given warehouse
				for(int i = 0; i < rowCount; i++) 
				{
					string currentWarehouse = ((DataRow)(enumerator.Current)).ItemArray.GetValue(0).ToString();
					enumerator.MoveNext();
					query = "SELECT itemID, itemType " +
						"FROM ShoppingCarts, ProductLocals " +
						"WHERE itemID = idNum AND itemType = type AND ShoppingCarts.quantity <= ProductLocals.quantity AND warehouse = '" + currentWarehouse + "' AND custId = '" + this.custID + "' ";
					new SqlDataAdapter(query, sqlConn).Fill(ds, "warehouse_cart");
					if(ds.Tables["shopping_cart"].Rows.Count == ds.Tables["warehouse_cart"].Rows.Count) 
					{
						sqlConn.Close();
						return fillRetWith(currentWarehouse);
					}
					ds.Tables["warehouse_cart"].Clear();

				}
			} 
			catch (Exception e) 
			{
				this.errorLabel.Text = e.Message;
				return new string[0][];
			} 
			finally 
			{
				sqlConn.Close();
			}
			return new string[0][];

		}

		private string[][] fillRetWith(string ware) 
		{
			int numItemIds = getCartSize();
			string[][] ret = new string[numItemIds][];
			try 
			{
				sqlConn = new SqlConnection(ConfigurationSettings.AppSettings["InventoryDatabase"]);
				DataSet ds = new DataSet("shoppingCarts");
				sqlConn.Open();

				// first make a shopping cart dataset
				string query = "SELECT itemID, itemType, quantity " +
					"FROM ShoppingCarts " +
					"WHERE custID = '" + this.custID + "'";

				new SqlDataAdapter(query, sqlConn).Fill(ds, "items");
				sqlConn.Close();
				IEnumerator itemEnum = ds.Tables["items"].Rows.GetEnumerator();
				// then make a data set out of all the items in the cart entirely fulfilled by a given warehouse
				string idNum = "";
				string type = "";
				string quantity = "";
				for(int i = 0; itemEnum.MoveNext(); i++) 
				{
					idNum = ((DataRow)(itemEnum.Current)).ItemArray.GetValue(0).ToString();
					type = ((DataRow)(itemEnum.Current)).ItemArray.GetValue(1).ToString();
					quantity = ((DataRow)(itemEnum.Current)).ItemArray.GetValue(2).ToString();

					ret[i] = new string[] {ware, idNum, type, quantity};
				}
			} 
			catch (Exception e) 
			{
				this.errorLabel.Text = e.Message;
			} 
			finally 
			{
				sqlConn.Close();
			}
			return ret;
		}

		// string[] needs to hold {"warehouse", "itemID", "type", "quantity"}
		private string[][] getSeveralOutOfTownWarehouses(string city) 
		{
			string[][] ret;
			try 
			{
				sqlConn = new SqlConnection(ConfigurationSettings.AppSettings["ShippingDatabase"]);
				sqlConn.Open();
				//get the warehouse that have a vendor that can shipt to "city"
				string query = "select distinct(warehouse) from warehouse_shippers " +
					"where Vendor_Name in (select Shipping_Vendor from Shipping_Cities " +
					"where Delivery_City = '"+city+"')";
				DataSet ds = new DataSet("Warehouses");
				new SqlDataAdapter(query, sqlConn).Fill(ds, "shippable_warehouses");
				sqlConn.Close();

				sqlConn = new SqlConnection(ConfigurationSettings.AppSettings["InventoryDatabase"]);
				sqlConn.Open();

				// first make a shopping cart dataset
				query = "SELECT itemID, itemType, quantity " +
					"FROM ShoppingCarts " +
					"WHERE custID = '" + this.custID + "'";
				new SqlDataAdapter(query, sqlConn).Fill(ds, "shopping_cart");
				sqlConn.Close();

				int rowCount = ds.Tables["shopping_cart"].Rows.Count;
				int wareRowCount = ds.Tables["shippable_warehouses"].Rows.Count;

				//give us enough space to get each product from all warehouses
				ret = new string[rowCount*wareRowCount][];
				int retIndex = 0;

				IEnumerator cartEnum = ds.Tables["shopping_cart"].Rows.GetEnumerator();
				//cartEnum.MoveNext();
				// then make a data set out of all the items in the cart entirely fulfilled by a given warehouse
				for(int i = 0; cartEnum.MoveNext(); i++) 
				{
					string idNum = ((DataRow)(cartEnum.Current)).ItemArray.GetValue(0).ToString();
					string type = ((DataRow)(cartEnum.Current)).ItemArray.GetValue(1).ToString();
					int quant = Int32.Parse(((DataRow)(cartEnum.Current)).ItemArray.GetValue(2).ToString());
					IEnumerator shipEnum = ds.Tables["shippable_warehouses"].Rows.GetEnumerator();
					for(int j=0; shipEnum.MoveNext(); j++) 
					{
						if (quant > 0) 
						{
							string ware = ((DataRow)(shipEnum.Current)).ItemArray.GetValue(0).ToString();
							//method should return quant found that is needed, never more, sometimes less
							int quantFound = useAsManyFromThisWarehouse(quant,idNum,type,ware);
							if (quantFound > 0) 
							{
								ret[retIndex] = new string[4]{ware, idNum, type, quantFound.ToString()};
								retIndex++;
								quant -= quantFound;
							}//else move on to next warehouse
						} 
						else { break; } //we have enough, go on to next item
					} //end of warehouse loop
					if (quant > 0) //we don't have enough from where they can be shipped.
					{
						unableToShip[unableToShipIndex] = new string[3] {idNum, type, quant.ToString()};
						unableToShipIndex++;
					}
				}//end of item loop
			}
			catch (Exception e) 
			{
				this.errorLabel.Text = e.Message;
				return new string[0][];
			} 
			finally 
			{
				sqlConn.Close();
			}
			return ret;
		}

		//returns the max number the warehouse can offer that the customer wants to buy
		private int useAsManyFromThisWarehouse(int quant,string idNum,string type,string ware) 
		{
			

			// And then figure out if any of the warehouses can ship the entire invoice
			// first make a shopping cart dataset
			string query = "select quantity from productLocals "+
				"where idNum='"+idNum+"' and type='"+type+"' and warehouse='"+ware+"'";
			try 
			{
				sqlConn = new SqlConnection(ConfigurationSettings.AppSettings["InventoryDatabase"]);
				sqlConn.Open();
				SqlCommand command = new SqlCommand(query, sqlConn);
				object result = command.ExecuteScalar();
				if (result == null) 
				{
					return 0;
				}
				else  
				{
					int ret = (int) result;
					if (ret >= quant) { return quant; }
					return ret;
				}
			} 
			catch (Exception e) { return 0; }
			finally { sqlConn.Close();}

		}

		private void getShippingOpts(string correctWarehouse, string city) 
		{		
			string totalItems = getTotalItems(correctWarehouse);
			string totalWeight = getTotalWeight(correctWarehouse);
			//this.warehouseLabel.Text = "TotalItems:" + totalItems + "<br>TotalWeight:" + totalWeight;

			// Now figure a price for each method
			sqlConn = new SqlConnection( ConfigurationSettings.AppSettings["ShippingDatabase"]);
			sqlConn.Open();	// open the connection

			// Take city, warehouse, weight, total number of pieces, and dump all possible ways of getting it there.
			// returning vendor, option, cost, days
			string query = "SELECT Vendor_Name + '~' + Shipping_Option + '~' + cast(Days_to_Deliver as varchar) as 'Option', Package_Cost, Days_to_Deliver " +
				"FROM " +
				"(((SELECT Vendor_Name, Shipping_Option, Price_per_Unit AS Package_Cost, Pricing_Unit, Price_per_Unit, Days_to_Deliver " +
				"FROM Shipping_Methods " +
				"WHERE Pricing_Unit = 'flat') UNION " +
				"(SELECT Vendor_Name, Shipping_Option, Price_per_Unit*" + totalWeight + " AS Package_Cost, Pricing_Unit, Price_per_Unit, Days_to_Deliver " +
				"FROM Shipping_Methods " +
				"WHERE Pricing_Unit = 'weight')) UNION " +
				"(SELECT Vendor_Name, Shipping_Option, Price_per_Unit*" + totalItems + " AS Package_Cost, Pricing_Unit, Price_per_Unit, Days_to_Deliver " +
				"FROM Shipping_Methods " +
				"WHERE Pricing_Unit = 'items')) AS a " +
				"WHERE Vendor_Name IN " +
				"(SELECT Shipping_Cities.Shipping_Vendor " +
				"FROM Shipping_Cities, Warehouse_Shippers " +
				"WHERE Shipping_Cities.Shipping_Vendor = Warehouse_Shippers.Vendor_Name " +
				"AND Delivery_City = '" + city + "' AND Warehouse = '" + correctWarehouse + "') ";


	
			DataSet ds = new DataSet("Shippers");
			new SqlDataAdapter(query, sqlConn).Fill(ds, "shipping_opts");
			sqlConn.Close();
			this.warehouseLabel.Text = correctWarehouse;
			DataTable table = ds.Tables["shipping_opts"];
			try 
			{
				this.AdminPackagesGrid.DataSource = new DataView(table);
				this.AdminPackagesGrid.DataBind();
				this.AdminPackagesGrid.Visible = true;
			} 
			catch (Exception e4) {}

		}

		//gets ALL the items in the cart taking quantity into account
		private string getTotalItems(string currWare) 
		{
			int quant = 0;
			IEnumerator warehouseEnum = this.AdminInventoryGrid.Items.GetEnumerator();

			for(int i=0; warehouseEnum.MoveNext();i++)//warehouseEnum.MoveNext(); i++) 
			{
				IEnumerator TEST = ((DataGridItem)(warehouseEnum.Current)).Cells.GetEnumerator();
				for(int k=0; TEST.MoveNext();k++)//warehouseEnum.MoveNext(); i++) 
				{
					if (currWare == ((TableCell)TEST.Current).Text) 
					{
						TEST.MoveNext();
						int q = Int32.Parse(((TableCell)TEST.Current).Text);
						quant += q;
						break;
					}
				}
			}
			return quant.ToString();

		}

		//gets total weight of the items in the cart taking quantity into account
		private string getTotalWeight(string ware) 
		{
			int totalWeight = 0;
			try 
			{
				// First figure out the number of items
				sqlConn = new SqlConnection( ConfigurationSettings.AppSettings["InventoryDatabase"]);
				sqlConn.Open();
				string query = "select idNum, type, weight " +
					"from shoppingCarts, allProducts " +
					"where itemID=idNum and itemType=type and custID='" + this.custID + "' ";

				DataSet ds = new DataSet("weights");
				new SqlDataAdapter(query, sqlConn).Fill(ds, "item_weights");
				sqlConn.Close();
				DataTable table = ds.Tables["item_weights"];

				IEnumerator warehouseEnum = this.AdminInventoryGrid.Items.GetEnumerator();

				while(warehouseEnum.MoveNext())//warehouseEnum.MoveNext(); i++) 
				{
					IEnumerator TEST = ((DataGridItem)(warehouseEnum.Current)).Cells.GetEnumerator();
					string id = "";
					string type = "";
					for(int k=0; TEST.MoveNext();k++)//warehouseEnum.MoveNext(); i++) 
					{
						if (k%4 == 0) { id = ((TableCell)TEST.Current).Text; continue; }
						if (k%4 == 1) { type = ((TableCell)TEST.Current).Text; continue; }
						if (ware == ((TableCell)TEST.Current).Text)  
						{
							k++;
							TEST.MoveNext();
							int quantity = Int32.Parse(((TableCell)TEST.Current).Text);

							IEnumerator weightEnum = table.Rows.GetEnumerator();
							for (int i=0; weightEnum.MoveNext(); i++) 
							{
								if (id == ((DataRow)(weightEnum.Current)).ItemArray.GetValue(0).ToString() &&
									type == ((DataRow)(weightEnum.Current)).ItemArray.GetValue(1).ToString())
								{
									int weight = Int32.Parse(((DataRow)(weightEnum.Current)).ItemArray.GetValue(2).ToString());
									totalWeight += quantity*weight;
									break;
								}
							}
						}
					}
				}
			}
			catch (System.Data.SqlClient.SqlException e) 
			{
				this.errorLabel.Text = e.Message;
				return "";
			}
			finally 
			{
				sqlConn.Close();
			}
			return totalWeight.ToString();
		}

		private void skip2button_Click(object sender, System.EventArgs e)
		{
			setUpMethodOfPayment();
		}

		private void ShippingOptsGrid_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			try 
			{
				string shipping_method = ((System.Web.UI.WebControls.LinkButton)e.CommandSource).Text;
				string[] shipper = shipping_method.Split(new char[1] {'~'});
				DataTable crap = new DataTable();
				crap.Columns.Add("Weight");
				crap.Columns.Add("Num_Items");
				crap.Columns.Add("Shipping_Vendor");
				crap.Columns.Add("Shipping_Options");
				crap.Columns.Add("Delivery_Notes");
				crap.Columns.Add("Warehouse");
				crap.Columns.Add("Delivery_Date");

				crap.Rows.Add(formatPackagesGridString(shipper));

				this.AdminPackagesGrid.DataSource = new DataView(crap);
				this.AdminPackagesGrid.DataBind();
				this.AdminPackagesGrid.Visible = true;

				string warehouse = getNextWarehouse();
				if (warehouse != null) { this.getShippingOpts(warehouse, city.Text); }
			} 
			catch (Exception e1) {}
		}

		private string[] formatPackagesGridString(string[] shipper)
		{
			string warehouse = this.warehouseLabel.Text;
			string[] ret = new string[7] {getTotalWeight(warehouse), getTotalItems(warehouse),
											 shipper[0], shipper[1], "", warehouse, shipper[2]};
			return ret;
		}

		private string getNextWarehouse() 
		{
			string currWare = this.warehouseLabel.Text;
			IEnumerator warehouseEnum = this.AdminPackagesGrid.Columns.GetEnumerator();
			warehouseEnum.MoveNext();
			while (currWare != ((DataRow)(warehouseEnum.Current)).ItemArray.GetValue(5).ToString())
			{
				continue;
			}
			if (warehouseEnum.MoveNext()) 
			{ //if we have another warehouse in the list
				return ((DataRow)(warehouseEnum.Current)).ItemArray.GetValue(5).ToString();
			}
			return null;
		}
		*/
		#endregion


		#endregion

		#region Method of Payment Panel = Step 3

		private void setUpMethodOfPayment()
		{
			makeInvisibleForMethodOfPayment();
			showPrices();
			showCreditCardInfo();
		}


		// Makes the other panels invisible and everything in the opts panel
		private void makeInvisibleForMethodOfPayment() 
		{
			hideAllPanels();
			methodOfPaymentPanel.Visible = true;
		}

		private void showPrices()
		{
			string itemTotal = "";
			string itemTax = "";
			string shipping = "";
			try 
			{
				// Start a new connection to the database specified in strSqlString
				strSqlString = ConfigurationSettings.AppSettings["InventoryDatabase"];
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	// open the connection

				// Execute query -- Here you could make 'strSql' any query you want
				string strSql = "select cast (sum(shoppingcarts.quantity*price*(100-discount)/100) as money) as Total " +
					"from allProducts, shoppingcarts " +
					"where custid = '" + this.custID + "' and idNum = itemID and type = itemtype";
							
				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				// Get the answer from the reader and write it to the label.
				if (sqlRdr.Read()) 
				{
					System.Data.SqlTypes.SqlMoney sqlTotal = sqlRdr.GetSqlMoney(0);
					itemTotal = sqlTotal.ToString();
					this.itemCostBox.InnerText = itemTotal;
				}

				// TODO: use real shipping cost
				double itemTaxAsDouble = (Double.Parse(itemTotal)*tax);
				itemTax = itemTaxAsDouble.ToString();
				taxBox.InnerText = itemTax;
				shipping = "5";
				shippingCostBox.InnerText = shipping;
				double total = itemTaxAsDouble + Double.Parse(itemTotal) + Double.Parse(shipping);
				totalCostBox.InnerText = total.ToString();

			} 
			catch (Exception e1) 
			{
				errorLabel.Text = errorOpen + "ERROR:" + e1.Message.ToString() + errorClose;
			}
			// Close the sql connection at the end
			sqlConn.Close();
		}

		private DataTable readMyCreditCard()
		{
			if (data.Tables.Contains("creditcard"))
				return data.Tables["creditcard"];
			try 
			{
				sqlConn = new phase2.dbquery_billing().createConnection();
				sqlConn.Open();	// open the connection

				string strSql =
					"SELECT cardnumber, company, customerid, addressid, expiremonth, expireyear " +
					"FROM   creditcard " +
					"WHERE  customerid = @id";
								
				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);
				sqlCom.Parameters.Add("@id", SqlDbType.Int).Value = this.custID;
				// Execute the command
				new SqlDataAdapter(sqlCom).Fill(data, "creditcard");

				return data.Tables["creditcard"];
			} 
			catch (Exception e1) 
			{
				showError("ERROR:" + e1.Message.ToString());
				return null;
			}
			finally 
			{
				sqlConn.Close();
			}
		}

		private void showCreditCardInfo()
		{
			DataTable creditcardTable = readMyCreditCard();

			if (creditcardTable != null && creditcardTable.Rows.Count > 0) 
			{
				this.creditGrid.DataSource = new DataView(creditcardTable);
				this.creditGrid.DataBind();
				this.creditGrid.Visible = true;

				DataRow creditcard = creditcardTable.Rows[0];

				this.cardNumText.Text = creditcard["cardnumber"].ToString();
				this.cardCompanyText.Text = creditcard["company"].ToString();
				this.exprMonthText.Text = creditcard["expiremonth"].ToString();
				this.yearBox.Text = creditcard["expireyear"].ToString();

				this.creditPanel.Visible = false;
			} 
			else 
			{
				this.creditPanel.Visible = true;
			}
		}	

		private bool storeCreditCardInfo()
		{
			int id = (int) Session["customerid"];
			int month, year;

			if (cardNumText.Text.Length != 16) 
			{
				showError("That doesn't look like a real credit card number to me.");
			}

			TypeConverter converter = TypeDescriptor.GetConverter(typeof(int));
			try 
			{
				month = (int) converter.ConvertFromString(exprMonthText.Text);
				year = (int) converter.ConvertFromString(yearBox.Text);
			} 
			catch (Exception) 
			{
				showError("Month and year must be numbers.");
				return false;
			}

			if (month < 1 || month > 12) 
			{
				showError("Month must be between 1 and 12.");
				return false;
			}

			if (year < 2005)
			{
				showError("Your credit card is expired. No dice.");
				return false;
			}

			if (!(new phase2.dbquery_billing(errorLabel)).updateCreditCard(id, cardNumText.Text, cardCompanyText.Text, month, year)) 
			{
				showError("Could not update credit card info.");
				return false;
			} 


			showMessage("Updated credit card info");
			return true;
		}

		private void creditRadio_CheckedChanged(object sender, System.EventArgs e)
		{
			if (!creditRadio.Checked)
				return;

			showCreditCardInfo();
		}

		private void pigeonRadio_CheckedChanged(object sender, System.EventArgs e)
		{
			if (!pigeonRadio.Checked)
				return;

			creditPanel.Visible = false;
			creditGrid.Visible = false;
		}

		private void changeCreditCardButton_Click(object sender, System.EventArgs e)
		{		
			creditPanel.Visible = true;
			pigeonRadio.Checked = false;
			creditRadio.Checked = true;
			creditGrid.Visible = false;
		}

		private void methodOfPaymentSubmit_Click(object sender, System.EventArgs e)
		{
			if (this.creditPanel.Visible) 
			{
				if (!storeCreditCardInfo())
					return;
			}

			setUpFinalConfirmation();
		}

		#endregion

		#region Final Confirmation = Step 4

		private void setUpFinalConfirmation()
		{
			hideAllPanels();
			confirmPanel.Visible = true;
			showConfirmationData();
		}

		private void showConfirmationData()
		{
			int customerid = (int) Session["customerid"];
			this.confirmItemsGrid.DataSource = new DataView(new dbquery_inventory().getShoppingCart(customerid));
			this.confirmItemsGrid.DataBind();

			this.confirmAddress.Text =
				name.Text + "<br>" +
				address1.Text + "<br>" + 
				(address2.Text == "" ? "" : (address2.Text + "<br>")) +
				city.Text + ", " + state.Text + "  " + zip.Text;

			if (this.creditRadio.Checked) 
			{
				this.confirmPaymentLabel.Text = "Credit Card";

				DataTable creditTable = this.readMyCreditCard();
				this.confirmCreditGrid.DataSource = new DataView(creditTable);
				this.confirmCreditGrid.DataBind();
			}
			else 
			{
				this.confirmPaymentLabel.Text = "Carrier Pigeon";
			}
		}

		private void confirmFinalSubmit_Click(object sender, System.EventArgs e)
		{
			int invoiceid = storeInvoice();
			storeItems(invoiceid);
			makeXML(invoiceid);

			new phase2.dbquery_inventory().emptyShoppingCart((int) Session["customerid"]);

			showMessage("Thank you for shopping with us. Your confirmation number is: " + invoiceid.ToString());

			hideAllPanels();
		}

		// Now we make an XML file for each implicated company that is not us.
		private void makeXML(int invoiceid) 
		{
			string[,] allCompanies = (string[,]) Session["shippingChoices"];
			DataTable shoppingCart = new dbquery_inventory().getShoppingCart((int)(Session["customerid"]));
			int xmlCount = 0;
			string address = this.address1.Text + " " + this.address2.Text;
			string city = this.city.Text;
			string state = this.state.Text;
			string zip = this.zip.Text;
			string phone = this.phone.Text;
			string fax = this.fax.Text;
			for(int i = 0; i < allCompanies.Length/2; i++) 
			{
				string currentCompany = allCompanies[i,0];
				if( currentCompany == null || currentCompany == "444f") 
				{
					continue;
				}
				string shippingMethod = allCompanies[i,1];
				string file = Server.MapPath(".\\orders\\") + "invoice" + invoiceid.ToString() + "-order" + (xmlCount++).ToString() + ".xml";
				StreamWriter output = new StreamWriter(file);
				output.Write("<order>\n");
				output.Write("\t<issuingCompany>444f</issuingCompany>\n");
				output.Write("\t<partnerCompany>"+currentCompany+"</partnerCompany>\n");
				string cartCompany = "";
				string type = "";
				string identifier = "";
				string name = "";
				string quantity = "";
				foreach(DataRow r in shoppingCart.Rows)
				{
					cartCompany = (string) r["partnerCompany"];
					if(cartCompany == currentCompany) 
					{
						type = (string) r["type"];
						identifier = (string) r["id"];
						name = (string) r["title"];
						quantity = r["quantity"].ToString();
						output.Write("\t<product>\n");
						output.Write("\t\t<type>" + type + "</type>\n");
						output.Write("\t\t<identifier>" + identifier + "</identifier>\n");
						output.Write("\t\t<name>" + name + "</name>\n");
						output.Write("\t\t<quantity>" + quantity + "</quantity>\n");
						output.Write("\t</product>\n");
					}
				}
				output.Write("\n\t<shippingMethod>"+shippingMethod+"</shippingMethod>\n");
				output.Write("\t<destination>\n");
				output.Write("\t\t<address>"+address+"</address>\n");
				output.Write("\t\t<city>"+city+"</city>\n");
				output.Write("\t\t<state>"+state+"</state>\n");
				output.Write("\t\t<zip>"+zip+"</zip>\n");
				output.Write("\t\t<contact>\n" +
				             "\t\t\t<tel>"+phone+"</tel>\n" +
					         "\t\t\t<fax>"+fax+"</fax>\n" +
					         "\t\t</contact>\n");
				output.Write("\t</destination>\n");
				output.Write("</order>\n");
				output.Flush();
				output.Close();
				Session["shippingChoices"] = null;
			}
				
//			DataTable shoppingCart = new dbquery_inventory().getShoppingCart((int)(Session["customerid"]));

//			int companyOverCount = shoppingCart.Rows.Count;
//			string[,] allCompanies = new string[companyOverCount,2];
//			foreach (DataRow r in shoppingCart.Rows)
//			{
//				string companyName = (string) r["partnerCompany"];
//				bool recorded = false;
//				int i = 0;
//				while(i < companyOverCount && allCompanies[i,0] != null) 
//				{
//					if(allCompanies[i,0] == companyName) 
//					{
//						recorded = true;
//					}
//					i++;
//				}

		}

		private int storeInvoice()
		{
			int buyerid = (int) Session["customerid"];
			int recipientid = buyerid;
			string shippingmethod = "trebuchet";
			string paymentmethod = "pigeon";
			string creditcard = null;
			float paymentamount = 0;

			// Payment amount
			TypeConverter converter = TypeDescriptor.GetConverter(typeof(float));
			paymentamount = (float) converter.ConvertFromString(this.itemCostBox.InnerText);

			// Payment method
			if (this.creditRadio.Checked) 
			{
				paymentmethod = "creditcard";
				DataTable creditTable = this.readMyCreditCard();
				creditcard = creditTable.Rows[0]["cardnumber"].ToString();
			}

			phase2.dbquery_billing billingdb = new phase2.dbquery_billing(this.errorLabel);
			
			// Recipient
			if (this.otherAddrRadio.Checked) 
			{
				recipientid = billingdb.addRecipient(name.Text, address1.Text, address2.Text, city.Text, state.Text, zip.Text);
			}

			// Build invoice
			int invoiceid = billingdb.addInvoice(buyerid, recipientid, shippingmethod, paymentmethod, creditcard, paymentamount);

			billingdb.addPriceAdjust(invoiceid, -1, "tax", "Sales Tax", (float) (paymentamount * tax));
			billingdb.addPriceAdjust(invoiceid, -1, "shipping", "Shipping", 5);

			return invoiceid;
		}

		private void storeItems(int invoiceid)
		{
			int customerid = (int) Session["customerid"];
			DataTable cart = new dbquery_inventory().getShoppingCart(customerid);

			phase2.dbquery_billing billingdb = new phase2.dbquery_billing(errorLabel);

			foreach (DataRow cartitem in cart.Rows) 
			{
				int itemid = billingdb.addItem(invoiceid, cartitem["id"], cartitem["type"], cartitem["title"], cartitem["quantity"], cartitem["price"], "warehouse");
			}
		}

		#endregion


	}
}
