using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace phase2
{
	/// <summary>
	/// Summary description for inventory.
	/// </summary>
	public class inventory : System.Web.UI.Page
	{

		dbquery_inventory inventorydb = new dbquery_inventory();
		protected System.Web.UI.WebControls.DataGrid inventoryGrid;
		dbquery_billing billingdb = new dbquery_billing();
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			showInventorySales();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void showInventorySales()
		{
			DataTable dt = inventorydb.getInventoryTable();
			dt.Columns.Add("sales", typeof(float));
			
			SqlConnection connection = billingdb.createConnection();

			connection.Open();
			foreach (DataRow row in dt.Rows) 
			{
				object productid = row["id"];
				object producttype = row["type"];

				string query =
					"SELECT sum(unitprice * quantity) + ISNULL(sum(adjustment), 0)\n" +
					"FROM item LEFT OUTER JOIN priceadjustment\n" +
					"          ON item.id = priceadjustment.itemid\n" +
					"WHERE productid = @productid AND producttype = @producttype\n" +
					"GROUP BY productid, producttype";

				SqlCommand command = new SqlCommand(query, connection);

				command.Parameters.Add("@productid", SqlDbType.VarChar, 13).Value = productid;
				command.Parameters.Add("@producttype", SqlDbType.VarChar, 4).Value = producttype;

				object result = command.ExecuteScalar();

				row["sales"] = result == null ? 0 : result;
			}
			connection.Close();

			inventoryGrid.DataSource = new DataView(dt);
			inventoryGrid.DataBind();
		}
	}
}
