using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace phase2
{
	/// <summary>
	/// Summary description for itemInfo.
	/// </summary>
	public class itemInfo : System.Web.UI.Page
	{
		private string itemID = "";
		private string type = "";
		private string company = "";

		private string errorOpen = "<b><font color='red'><big><big><big>";
		private string errorClose = "</big></big></big></font></b><br>";
		private SqlConnection sqlConn;	// Declare a connection object
		private SqlCommand sqlCom;		  // Declare a command object
		private SqlDataReader sqlRdr;	  // Declare a reader to read the query result
		private string strSqlString = "server=IISQLSRV; uid=kristamd; pwd=TeamKMR; database=kristamd_inventory";
		protected System.Web.UI.WebControls.DataGrid itemGrid;
		protected System.Web.UI.WebControls.TextBox quantText;
		protected System.Web.UI.WebControls.Button addButton;
		protected System.Web.UI.WebControls.DataGrid artAuthGrid;
		protected System.Web.UI.WebControls.DataGrid cdSugGrid;
		protected System.Web.UI.WebControls.DataGrid bookSugGrid;
		protected System.Web.UI.WebControls.Label errorLabel;
		protected System.Web.UI.WebControls.Label noItems;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
			String[] idCompany = (this.Context.Request.QueryString.GetValues("id")[0]).Split(new char[] {','});
			this.itemID = idCompany[0];
			this.type = this.Context.Request.QueryString.GetValues("type")[0];
			this.company = idCompany[1];
			displayItem();
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.addButton.Click += new System.EventHandler(this.addButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void displayItem() 
		{
			makeInvisible();
			try 
			{
				if (type.Equals("cd"))
				{
					getCDInfo();
				} 
				else 
				{ //book
					getBookInfo();
				}
			} 
			catch(Exception e1) 
			{
				errorLabel.Text = errorOpen + e1.Message.ToString() + errorClose;
			}
		}


		private void getCDInfo() 
		{		
			//10% mark up is in the table already!!!
			string id = itemID;
			string[] strSql = new string[3];
			strSql[0] = "select idNum as ID, albumName as Album, price as RegularPrice, discount as PriceWithDiscount, " + 
				"availQuantity Quantity " +
				"from allProducts, cds " +
				" where idNum = '" + id + "' and allProducts.type='CD' and cdid = '" + id + "' and partnerCompany='"+ company +"'";
			strSql[1] = "select artist as Artists from artists where cdid = '" + id + "'";
			strSql[2] = "select cdid as ID, albumName as SuggestedAlbum from CDs, suggestions " +
				"where suggestions.idNum = '" + id + "' and suggestionID = cdid";

			for (int i=0; i< strSql.Length; i++) 
			{
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	// open the connection

				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql[i], sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				if (i==0 && sqlRdr.HasRows) 
				{
					itemGrid.DataSource = sqlRdr;
					itemGrid.DataBind();
					itemGrid.Visible = true;
				}
				else if(i==1 && sqlRdr.HasRows) 
				{	
					artAuthGrid.DataSource = sqlRdr;
					artAuthGrid.DataBind();
					artAuthGrid.Visible = true;
				}
				else if(i==2 && sqlRdr.HasRows) 
				{
					cdSugGrid.DataSource = sqlRdr;
					cdSugGrid.DataBind();
					cdSugGrid.Visible = true;
				}
				else if ( i==0 && !sqlRdr.HasRows ) 
				{
					this.noItems.Text = errorOpen + "Item unknown" + errorClose;
				}
			
				// Close the sql connection at the end
				sqlConn.Close();
			}


		}

		private void getBookInfo()
		{
			string id = itemID;
			string[] strSql = new string[2];
			strSql[0] = "select idNum as ID, title as Title, price as RegularPrice, cast(price*(100-discount)/100 as money) as PriceWithDiscount, " + 
				"cast(discount as varchar) + '%' as Discount, availQuantity Quantity " +
				"from allProducts, books " +
				" where idNum = '" + id + "' and allProducts.type='Book' and isbn = '" + id + "' and partnerCompany='"+ company +"'";
			strSql[1] = "select authorName as Authors from authors where isbn = '" + id + "'";
			/*strSql[2] = "select isbn as ID, title as SuggestedTitle from books, suggestions " +
				"where suggestions.idNum = '" + id + "' and suggestionID = isbn";
			*/
			for (int i=0; i< strSql.Length; i++) 
			{
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	// open the connection

				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql[i], sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();
				if (i==0 && sqlRdr.HasRows) 
				{
					itemGrid.DataSource = sqlRdr;
					itemGrid.DataBind();
					itemGrid.Visible = true;
				}
				else if(i==1 && sqlRdr.HasRows) 
				{	
					artAuthGrid.DataSource = sqlRdr;
					artAuthGrid.DataBind();
					artAuthGrid.Visible = true;
				}
				else if(i==2 && sqlRdr.HasRows) 
				{
					bookSugGrid.DataSource = sqlRdr;
					bookSugGrid.DataBind();
					bookSugGrid.Visible = true;
				} 
				else if ( i==0 && !sqlRdr.HasRows ) 
				{
					this.noItems.Text = errorOpen + "Item unknown" + errorClose;
				}
			
				// Close the sql connection at the end
				sqlConn.Close();
			}
		}

		private void makeInvisible()
		{
			errorLabel.Text = "";;
			this.noItems.Text = "";
			itemGrid.Visible = false;
			artAuthGrid.Visible = false;
			cdSugGrid.Visible = false;
			bookSugGrid.Visible = false;
		}

		private void addButton_Click(object sender, System.EventArgs e)
		{

			if (Session["customerid"] == null)
			{
				this.noItems.Text = "You must login before adding items to your cart.";
				return;
			}

			string url = "viewCart.aspx?";
			url += "type=" + this.type;
			url += "&addproduct=" + itemID;
			url += "&quantity=" + this.quantText.Text;
			url += "&company=" + this.company;
			this.Server.Transfer(url);
		
		}

	}
}
