using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace phase2
{
	/// <summary>
	/// Register for website
	/// </summary>
	public class register : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox password;
		protected System.Web.UI.WebControls.TextBox name;
		protected System.Web.UI.WebControls.TextBox phone;
		protected System.Web.UI.WebControls.TextBox email;
		protected System.Web.UI.WebControls.TextBox address1;
		protected System.Web.UI.WebControls.TextBox address2;
		protected System.Web.UI.WebControls.TextBox city;
		protected System.Web.UI.WebControls.TextBox state;
		protected System.Web.UI.WebControls.TextBox zip;
		protected System.Web.UI.WebControls.Button submit;
		protected System.Web.UI.WebControls.TextBox login;
		protected System.Web.UI.WebControls.Panel registrationPanel;
		protected System.Web.UI.WebControls.Label resultLabel;

		dbquery_billing billingDatabase = new dbquery_billing();
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.submit.Click += new System.EventHandler(this.submit_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void showResult(bool success)
		{
			if (success) 
			{
				this.resultLabel.Text = "Congratulations, " + login.Text + ", you have successfully registered.";
				this.registrationPanel.Visible = false;
			}
			else
			{
				this.resultLabel.Text = "<p class='error'>Error: either the login name you have requested is taken, you did not fill in a required field, or the database is on fire. No, I don't know which. You just have to sit there and wonder why you cannot get ye flask.</p>";
				this.registrationPanel.Visible = true;
			}

			this.resultLabel.Visible = true;
		}

		/// <summary>
		/// Text box to database value. Converts empty text boxes into NULL's.
		/// </summary>
		/// <param name="textbox">Text box</param>
		/// <returns>Database value</returns>
		public object tb2v(System.Web.UI.WebControls.TextBox textbox)
		{
			return textbox.Text == "" ? DBNull.Value : (object) textbox.Text;
		}

		private void submit_Click(object sender, System.EventArgs e)
		{
			string insertAddress =
				"INSERT INTO address (id, address1, address2, city, state, zip)\n" +
				"SELECT MAX(address.id) + 1, @address1, @address2, @city, @state, @zip\n" +
				"FROM   address\n";

			string insertCustomer =
				"INSERT INTO customer (id, name, addressid, phone, email)\n" +
				"SELECT MAX(customer.id) + 1, @name, MAX(address.id), @phone, @email\n" +
				"FROM   address, customer\n";

			string insertLogin =
				"INSERT INTO login (customerid, login, password)\n" +
				"SELECT MAX(customer.id), @login, @password\n" +
				"FROM   customer\n";

			string query = insertAddress + "\n" + insertCustomer + "\n" + insertLogin + "\n";

			SqlCommand command = new SqlCommand(query);

			command.Parameters.Add("@address1", SqlDbType.VarChar, 255).Value = tb2v(address1);
			command.Parameters.Add("@address2", SqlDbType.VarChar, 255).Value = tb2v(address2);
			command.Parameters.Add("@city", SqlDbType.VarChar, 255).Value = tb2v(city);
			command.Parameters.Add("@state", SqlDbType.VarChar, 2).Value = tb2v(state);
			command.Parameters.Add("@zip", SqlDbType.VarChar, 10).Value = tb2v(zip);

			command.Parameters.Add("@name", SqlDbType.VarChar, 255).Value = tb2v(name);
			command.Parameters.Add("@phone", SqlDbType.VarChar, 30).Value = tb2v(phone);
			command.Parameters.Add("@email", SqlDbType.VarChar, 255).Value = tb2v(email);

			command.Parameters.Add("@login", SqlDbType.VarChar, 255).Value = tb2v(login);
			command.Parameters.Add("@password", SqlDbType.VarChar, 255).Value = tb2v(password);

			bool success = billingDatabase.executeCommand(command);
			showResult(success);

			/* Furthermore, log the new user in. */
			if (success) 
			{
				int customerId = billingDatabase.getCustomerId(login.Text, password.Text);
				if (customerId >= 0)
					Session["customerid"] = customerId;
			}
		}
	}
}
