using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;	// Defines sql types
using System.Configuration;

namespace phase2
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class status : System.Web.UI.Page
	{
		private SqlConnection sqlConn;
		private string shippingConnectString = ConfigurationSettings.AppSettings["ShippingDatabase"];
		private string billingConnectString = ConfigurationSettings.AppSettings["BillingDatabase"];
		private SqlCommand sqlCom;
		private SqlDataReader sqlRdr;
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.TextBox TextBox1;
		protected System.Web.UI.WebControls.DataGrid DataGrid2;
		protected System.Web.UI.WebControls.Button Button2;
		protected System.Web.UI.WebControls.Label message;
		protected System.Web.UI.WebControls.Panel statusPanel;
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.WebControls.DataGrid itemGrid;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (Session["customerid"] == null) 
			{
				message.Text = "You need to log in, foo.";
				statusPanel.Visible = false;
				return;
			}

			String userID = Session["customerid"].ToString();

			sqlConn = new SqlConnection( billingConnectString);
			sqlConn.Open();

			// Pull invoice numbers pertaining to user from billing table, put 5 of them on screen
			string strSql = "SET ROWCOUNT 5 " + 
				"SELECT id " +
				"FROM Invoice " +
				"WHERE buyerid = '" + userID + "' " +
				"ORDER BY orderdate " +
				"SET ROWCOUNT 0";

			sqlCom = new SqlCommand(strSql, sqlConn);

			sqlRdr = sqlCom.ExecuteReader();


			if (sqlRdr.HasRows) 
			{
				DataGrid2.DataSource = sqlRdr;
				DataGrid2.DataBind();
				DataGrid2.Visible = true;
			}

			sqlConn.Close();

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.TextBox1.TextChanged += new System.EventHandler(this.TextBox1_TextChanged);
			this.DataGrid2.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid2_ItemCommand);
			this.Button2.Click += new System.EventHandler(this.Button2_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private bool validate_user_invoice(String invoiceNum) 
		{
			sqlConn = new SqlConnection( billingConnectString);
			sqlConn.Open();

			string strSql = "SELECT id " + 
				"FROM invoice " +
				"WHERE id = @invoiceNum AND buyerid = @customerid";

			sqlCom = new SqlCommand(strSql, sqlConn);
			sqlCom.Parameters.Add("@invoiceNum", SqlDbType.VarChar).Value = invoiceNum;
			sqlCom.Parameters.Add("@customerid", SqlDbType.VarChar).Value = Session["customerid"];

			sqlRdr = sqlCom.ExecuteReader();

			bool valid = sqlRdr.HasRows;
            sqlConn.Close();
            
			return valid;
		}

		private void TextBox1_TextChanged(object sender, System.EventArgs e)
		{
			String invoice_num = this.TextBox1.Text;
			if(validate_user_invoice(invoice_num)) 
			{

				sqlConn = new SqlConnection( shippingConnectString);
				sqlConn.Open();

				string strSql = "SELECT Tracking_Number, Invoice_Number, Weight, " + 
					"Shipping_Vendor, Shipping_Option, Warehouse, " +
					"Delivery_City, Delivery_State, Delivery_Zip, " +
					"CONVERT(CHAR(10), Delivery_Date, 110) AS 'Delivery_Date', " +
					"Order_Status " +
					"FROM Packages " +
					"WHERE Invoice_Number = @invoice_num";

				// LIMIT only to invoices for this customer. foo. RJP, MET

				sqlCom = new SqlCommand(strSql, sqlConn);
				sqlCom.Parameters.Add("@invoice_num", SqlDbType.Int).Value = invoice_num;

				sqlRdr = sqlCom.ExecuteReader();

				DataGrid1.DataSource = sqlRdr;
				DataGrid1.DataBind();
				DataGrid1.Visible = true;



				sqlConn.Close();
			} 
			else 
			{
				DataGrid1.Visible = false;
			}

			new dbquery_billing().query2grid("SELECT * FROM item WHERE invoiceid = '" + invoice_num + "'", itemGrid);
		}

		private void Button1_Click(object sender, System.EventArgs e)
		{
			TextBox1_TextChanged(sender, e);
		}

		private void Button2_Click(object sender, System.EventArgs e)
		{
			if (Session["customerid"] == null) 
			{
				message.Text = "You need to log in, foo.";
				statusPanel.Visible = false;
				return;
			}

			sqlConn = new SqlConnection( billingConnectString);
			sqlConn.Open();
			String userID = Session["customerid"].ToString();
			// TODO: find a way of making it better. Duplicate code in page_load(). MET

			// get from billing the pertinant invoice numbers for this user and display all of them
			string strSql = "SELECT id " +
				"FROM Invoice " +
				"WHERE buyerid = '" + userID + "'";

			sqlCom = new SqlCommand(strSql, sqlConn);

			sqlRdr = sqlCom.ExecuteReader();


			if (sqlRdr.HasRows) 
			{
				DataGrid2.DataSource = sqlRdr;
				DataGrid2.DataBind();
				DataGrid2.Visible = true;
			}

			sqlConn.Close();		
		}

		private void DataGrid2_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			string invoice_num = ((System.Web.UI.WebControls.LinkButton)e.CommandSource).Text;
			//string test2 = e.Item.Cells[1].Text;

			sqlConn = new SqlConnection( shippingConnectString);
			sqlConn.Open();

			string strSql = "SELECT Tracking_Number, Invoice_Number, Weight, Shipping_Vendor, Shipping_Option, Warehouse, Delivery_City, Delivery_State, Delivery_Zip, CONVERT(CHAR(10), Delivery_Date, 110) AS 'Delivery_Date', Order_Status " +
				"FROM Packages " +
				"WHERE Invoice_Number = '" + invoice_num + "'";

			sqlCom = new SqlCommand(strSql, sqlConn);

			sqlRdr = sqlCom.ExecuteReader();

			DataGrid1.DataSource = sqlRdr;
			DataGrid1.DataBind();
			DataGrid1.Visible = true;

			sqlConn.Close();

			new dbquery_billing().query2grid("SELECT * FROM item WHERE invoiceid = '" + invoice_num + "'", itemGrid);
		}
	}
}
