using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace kmd
{
	/// <summary>
	/// Summary description for warehouseInfo.
	/// </summary>
	public class warehouseInfo : System.Web.UI.Page
	{
		private string name = "";
		private string errorOpen = "<b><font color='red'><big><big><big>";
		private string errorClose = "</big></big></big></font></b><br>";
		private SqlConnection sqlConn;	// Declare a connection object
		private SqlCommand sqlCom;		  // Declare a command object
		private SqlDataReader sqlRdr;	  // Declare a reader to read the query result
		private string inventLogin = "server=IISQLSRV; uid=kristamd; pwd=TeamKMR; database=kristamd_inventory";
		//private string billLogin = "server=IISQLSRV; uid=bitman; pwd=TeamKMR; database=bitman_billing";
		private string shipLogin = "server=IISQLSRV; uid=marie; pwd=TeamKMR; database=marie_shipping";
		protected System.Web.UI.WebControls.Label errorLabel;
		protected System.Web.UI.WebControls.DataGrid addrGrid;
		protected System.Web.UI.WebControls.Label totalLabel;
		protected System.Web.UI.WebControls.DataGrid vendorGrid;
		protected System.Web.UI.WebControls.DataGrid bookGrid;
		protected System.Web.UI.WebControls.DataGrid cdGrid;
		protected System.Web.UI.WebControls.Label stockLabel;
		protected System.Web.UI.WebControls.Label nameLabel;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
			try 
			{
				name = this.Context.Request.QueryString.GetValues("name")[0];
				showDetails();
			} 
			catch (Exception e1) 
			{
				errorLabel.Text = errorOpen + e1.Message + errorClose;
			}

		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void showDetails() 
		{
			displayName();
			getTotalSold();
			getAddress();
			getVendors();
			getInStockItems();
		}

		private void displayName() 
		{
			this.nameLabel.Text = errorOpen + "<h1>" + name + "</h1>" + errorClose;
		}


		/* Accesses the inventory db
		 * dumps basic query to addrGrid
		 */
		private void getAddress() 
		{
			string strSql = "select street, city, state, zip from warehouses where name = '" + name + "'";

			try 
			{
				sqlConn = new SqlConnection( inventLogin );
				sqlConn.Open();	// open the connection

				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				if (sqlRdr.HasRows) 
				{
					addrGrid.DataSource = sqlRdr;
					addrGrid.DataBind();
					addrGrid.Visible = true;
				}
			} 
			catch (Exception e) 
			{
				errorLabel.Text = errorOpen + e.Message + errorClose;
			}
			
		}


		/* Accesses the Shipping db
		 * dumps basic query to vendorGrid
		 */
		private void getVendors()
		{
			string strSql = "select Vendor_name from Warehouse_Shippers where warehouse = '" + name + "'";

			try 
			{
				sqlConn = new SqlConnection( shipLogin );
				sqlConn.Open();	// open the connection

				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				if (sqlRdr.HasRows) 
				{
					vendorGrid.DataSource = sqlRdr;
					vendorGrid.DataBind();
					vendorGrid.Visible = true;
				}
			} 
			catch (Exception e) 
			{
				errorLabel.Text = errorOpen + e.Message + errorClose;
			}
	
		}


		/* Accesses the inventory db
		 * dumps contents to bookGrid, cdGrid
		 */
		private void getInStockItems() 
		{
			bool books = getInStockItems("book");
			bool cds = getInStockItems("cd");
			if (!books && !cds) 
			{
				stockLabel.Text = errorOpen + "Warehouse is <i>completely</i> out of items!" + errorClose;
			}

		}
		
		private bool getInStockItems(string type) 
		{
			string idType = (type == "book") ? "isbn" : "cdid";
			string itemName = (type == "book") ? "title as Title" : "albumName as Album";
			string table = (type == "book") ? "books" : "cds";
			string strSql = "select idNum as '"+idType+"', "+itemName+", quantity as Quantity " +
				"from ProductLocals p, " + table +
				" where idNum = "+idType+" and p.type='"+type+"' and warehouse = '"+name+"' and quantity > 0";

			try 
			{
				sqlConn = new SqlConnection( inventLogin );
				sqlConn.Open();	// open the connection

				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				if (sqlRdr.HasRows) 
				{
					if (type == "book") 
					{
						bookGrid.DataSource = sqlRdr;
						bookGrid.DataBind();
						bookGrid.Visible = true;
					} 
					else 
					{
						cdGrid.DataSource = sqlRdr;
						cdGrid.DataBind();
						cdGrid.Visible = true;
					}
					return true;
				} 
				else { return false; }
			} 
			catch (Exception e) 
			{
				errorLabel.Text = errorOpen + e.Message + errorClose;
				return false;
			}
		}


		/* Accesses the billing db
		 * dumps query with count(id) having warehouse=name to totalLabel
		 */
		private void getTotalSold()
		{
			string strSql = "select sum(Num_Items) as 'sum' from Packages "+
				"where Order_Status = 'shipped' or Order_Status = 'completed' "+
				"group by warehouse having warehouse = '"+name+"'";

			try 
			{
				sqlConn = new SqlConnection( shipLogin );
				sqlConn.Open();	// open the connection

				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				if (sqlRdr.Read()) 
				{
					string totalSold = sqlRdr.GetSqlInt32(0).ToString();
					this.totalLabel.Text = errorOpen + "</big><h3>Total items shipped from "+name+": " + totalSold+"</h3><big>" + errorClose;
				} 
				else 
				{
					this.totalLabel.Text = errorOpen + "</big><h3>No items have been shipped from "+name+".</h3><big>" + errorClose;
				}
			} 
			catch (Exception e) 
			{
				errorLabel.Text = errorOpen + e.Message + errorClose;
			}

		}



	}
}
