using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace phase1
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid invoiceGrid;
		protected System.Web.UI.HtmlControls.HtmlInputText fieldProductCount;
		protected System.Web.UI.HtmlControls.HtmlInputText fieldWarehouseCount;
		protected System.Web.UI.HtmlControls.HtmlInputText fieldCustomerName;
		protected System.Web.UI.HtmlControls.HtmlInputCheckBox checkOverdueInvoices;
		protected System.Web.UI.HtmlControls.HtmlTextArea areaQueryString;
		protected System.Web.UI.HtmlControls.HtmlInputButton submitInvoice;
		protected System.Web.UI.HtmlControls.HtmlInputCheckBox checkShowQuery;
		protected System.Web.UI.HtmlControls.HtmlInputText fieldInvoiceNumber;
		protected System.Web.UI.HtmlControls.HtmlInputButton submitInvoiceNumber;
		protected System.Web.UI.WebControls.DataGrid itemGrid;
		protected System.Web.UI.HtmlControls.HtmlInputText fieldCity;
		protected System.Web.UI.HtmlControls.HtmlInputButton submitCity;
		protected System.Web.UI.WebControls.DataGrid itemMiniGrid;
		protected System.Web.UI.WebControls.DataList invoicePage;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			this.areaQueryString.Visible = false;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.submitInvoiceNumber.ServerClick += new System.EventHandler(this.submitInvoiceNumber_ServerClick);
			this.submitInvoice.ServerClick += new System.EventHandler(this.submit_ServerClick);
			this.submitCity.ServerClick += new System.EventHandler(this.submitCity_ServerClick);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private bool isNumber(string number)
		{
			if (number == "")
				return false;

			try 
			{
				System.Convert.ToInt32(number);
				return true;
			}
			catch (System.OverflowException)
			{
				return false;
			}
			catch (System.FormatException)
			{
				return false;
			}
		}

		private void showQueryString(string query)
		{
			if (this.checkShowQuery.Checked) 
			{
				this.areaQueryString.Value = query;
				this.areaQueryString.Visible = true;
			}
			else 
			{
				this.areaQueryString.Visible = false;
			}
		}

		private void query2grid(string query, System.Web.UI.WebControls.BaseDataList grid)
		{
			try 
			{
				// SQL connecty dealy
				const string sqlConnectString = "server=IISQLSRV; uid=bitman; pwd=TeamKMR; database=bitman_billing";

				SqlConnection connection = new SqlConnection(sqlConnectString);
				connection.Open();
				SqlDataReader reader = (new SqlCommand(query, connection)).ExecuteReader();

				if (reader.HasRows)
				{
					grid.DataSource = reader;
					grid.DataBind();
					grid.Visible = true;
				} 
				else 
				{
					grid.Visible = false;
				}

				connection.Close();
			}
			catch (System.Data.SqlClient.SqlException) 
			{
				grid.Visible = false;
			}
		}

		private void hideAll()
		{
			this.invoicePage.Visible = false;
			this.invoiceGrid.Visible = false;
			this.itemGrid.Visible = false;
			this.itemMiniGrid.Visible = false;
		}

		private void submit_ServerClick(object sender, System.EventArgs e)
		{
			hideAll();

			bool overdueInvoices = this.checkOverdueInvoices.Checked;
			string productCount = this.fieldProductCount.Value;
			string warehouseCount = this.fieldWarehouseCount.Value;
			string customer = this.fieldCustomerName.Value;

			string query =
				"SELECT   invoice.id, buyer.name AS buyername, recipient.name AS recipientname, orderdate, shippingmethod, paymentmethod, paymentamount \n" +
				"FROM     invoice, customer AS buyer, customer AS recipient" + (overdueInvoices ? ", item " : " ") + "\n" +
				"WHERE    buyerid = buyer.id AND recipientid = recipient.id \n";

			if (isNumber(productCount))
			{
				query +=
					"         AND invoice.id = ANY (SELECT invoice.id FROM invoice, item \n" +
					"                          WHERE invoiceid = invoice.id \n" +
					"                          GROUP BY invoice.id HAVING COUNT(item.id) >= " + productCount + ") \n";
			}

			if (isNumber(warehouseCount)) 
			{
				query +=
					"         AND invoice.id = ANY (SELECT invoice.id FROM invoice, item \n" +
					"                          WHERE invoiceid = invoice.id \n" +
					"                          GROUP BY invoice.id HAVING COUNT(distinct warehouse) > " + warehouseCount + ") \n";
			}

			if (customer != "")
			{
				// TODO: strip single quotes and illegal chars from customer string
				query +=
					"         AND (buyer.name = '" + customer + "' OR recipient.name = '" + customer + "') \n";
			}

			if (overdueInvoices) 
			{
				query +=
					"         AND invoiceid = invoice.id AND deliverydate < GETDATE() \n" +
					"GROUP BY invoice.id, buyer.name, recipient.name, orderdate, shippingmethod, paymentmethod, paymentamount \n";
			}

			query2grid(query, this.invoiceGrid);
			showQueryString(query);
		}

		private void submitInvoiceNumber_ServerClick(object sender, System.EventArgs e)
		{
			hideAll();
			string id = this.fieldInvoiceNumber.Value;
			string invoiceQuery = "";
			string itemQuery = "";

			if (isNumber(id))
			{
				invoiceQuery =
					"SELECT   invoice.id AS id, orderdate, shippingmethod, paymentamount, paymentmethod,\n\n" +

					"         creditcardnumber, company, expiremonth, expireyear,\n" +
					"         cardholder.name AS cc_name, cardholder.phone AS cc_phone, cardholder.email AS cc_email,\n" +
					"         ISNULL(cc_address.address1, cardholderaddress.address1) AS cc_address1,\n" +
					"         ISNULL(cc_address.address2, cardholderaddress.address2) AS cc_address2,\n" +
					"         ISNULL(cc_address.city,     cardholderaddress.city)     AS cc_city,\n" +
					"         ISNULL(cc_address.state,    cardholderaddress.state)    AS cc_state,\n" +
					"         ISNULL(cc_address.zip,      cardholderaddress.zip)      AS cc_zip,\n\n" +

					"         buyerid, buyer.name AS buyername, buyer.phone AS buyerphone, buyer.email AS buyeremail,\n" +
					"         buyeraddress.address1 AS buyer_address1, buyeraddress.address2 AS buyer_address2,\n" +
					"         buyeraddress.city AS buyer_city, buyeraddress.state AS buyer_state, buyeraddress.zip AS buyer_zip,\n\n" +

					"         recipientid, recipient.name AS recipientname, recipient.phone AS recipientphone, recipient.email AS recipientemail,\n" +
					"         recipientaddress.address1 AS recipient_address1, recipientaddress.address2 AS recipient_address2,\n" +
					"         recipientaddress.city AS recipient_city, recipientaddress.state AS recipient_state, recipientaddress.zip AS recipient_zip\n\n" +

					"FROM     invoice LEFT JOIN creditcard\n" +
					"                 ON creditcardnumber = cardnumber\n" +
					"                 LEFT JOIN address AS cc_address\n" +
					"                 ON creditcard.addressid = cc_address.id\n" +
					"                 LEFT JOIN customer AS cardholder\n" +
					"                 ON cardholder.id = creditcard.customerid\n" +
					"                 LEFT JOIN address AS cardholderaddress\n" +
					"                 ON cardholder.addressid = cardholderaddress.id,\n" +
					"         customer AS buyer      LEFT JOIN address AS buyeraddress\n" +
					"                                ON buyer.addressid = buyeraddress.id,\n" +
					"         customer AS recipient  LEFT JOIN address AS recipientaddress\n" +
					"                                ON recipient.addressid = recipientaddress.id\n\n" +

					"WHERE    buyer.id = buyerid AND recipient.id = recipientid\n" +
					"         AND invoice.id = " + id + "\n";

				itemQuery =
					"SELECT   id, productid, name, quantity, unitprice, deliverydate, warehouse, ISNULL(SUM(adjustment), 0) as totaladjustment, (unitprice + ISNULL(SUM(adjustment), 0)) * quantity AS totalprice\n" +
					"FROM     item LEFT JOIN priceadjustment ON id = itemid\n" +
					"WHERE    item.invoiceid = " + id + "\n" +
					"GROUP BY id, productid, name, quantity, unitprice, deliverydate, warehouse\n";

				query2grid(invoiceQuery, this.invoicePage);
				query2grid(itemQuery, this.itemGrid);
			}

			showQueryString(invoiceQuery + "\n\n" + itemQuery);
		}

		private void submitCity_ServerClick(object sender, System.EventArgs e)
		{
			hideAll();

			string city = this.fieldCity.Value;
			string query = 
				"SELECT   productid, name, SUM(quantity) AS copies\n" +
				"FROM     item, invoice LEFT JOIN address ON invoice.recipientid = address.id\n" +
				"WHERE    item.invoiceid = invoice.id AND city = '" + city + "'\n" +
				"GROUP BY productid, name\n" +
				"UNION\n" +
				"SELECT   productid, name, 0 AS copies\n" +
				"FROM     item, invoice LEFT JOIN address ON invoice.recipientid = address.id\n" +
				"WHERE    item.invoiceid = invoice.id AND city != '" + city + "'\n" +
				"GROUP BY productid, name\n" +
				"ORDER BY copies DESC\n";

			query2grid(query, this.itemMiniGrid);
			showQueryString(query);
		}
	}
}
