using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace _404_Not_Found
{
	/// <summary>
	/// Summary description for Invoices.
	/// </summary>
	public class Invoices : System.Web.UI.Page
	{
		private string shipping = "server=IISQLSRV; uid=xinpl; pwd=rainday; database=xindig_shipping";
		private string billing = "server=IISQLSRV; uid=xinpl; pwd=rainday; database=xindig_billing";
		private SqlConnection sqlConn;
		private SqlCommand sqlCom;
		private SqlDataReader sqlRdr;
		private string id;

		protected System.Web.UI.WebControls.ImageButton shoppingCart_btn;
		protected System.Web.UI.WebControls.Label loginName_lbl;
		protected System.Web.UI.WebControls.LinkButton logout_btn;
		protected System.Web.UI.WebControls.Label Site_slogan_lbl;
		protected System.Web.UI.WebControls.LinkButton home_link;
		protected System.Web.UI.WebControls.Label Invoice_lbl;
		protected System.Web.UI.WebControls.DataGrid Invoice_grid;
		protected System.Web.UI.WebControls.Panel Invoice_pnl;
		protected System.Web.UI.WebControls.Panel Book_pnl;
		protected System.Web.UI.WebControls.DataGrid Book_grid;
		protected System.Web.UI.WebControls.Label Book_lbl;
		protected System.Web.UI.WebControls.DataGrid Music_grid;
		protected System.Web.UI.WebControls.Label Music_lbl;
		protected System.Web.UI.WebControls.Panel Music_pnl;
		protected System.Web.UI.WebControls.DataGrid importMusic_grid;
		protected System.Web.UI.WebControls.DataGrid importBook_;
		protected System.Web.UI.WebControls.DataGrid importBook_grid;
		protected System.Web.UI.WebControls.Label Site_title_lbl;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			loginName_lbl.Text = "Logged in as " +
				Convert.ToString(Session["CustomerName"]);
			loginName_lbl.ForeColor = Color.Black;
			
			updateStatus();

			if ( Request.QueryString["id"] != null )
			{
				id = Request.QueryString["id"];

				string strsql = "SELECT distinct pi.invoiceid as oNum, status, " +
								"dateShipped as ds, deliveryDate as dd " +
						"from	xindig_shipping.dbo.Package_status as ps, " +
							"xindig_shipping.dbo.Package_Invoice as pi, " +
							"(select invoiceid  " +
							"from xindig_billing.dbo.Invoice3 " +
							"where invoiceid = " + id +
                    		" group by invoiceid) as i " +
						"where	pi.invoiceid = i.invoiceid and " +
							"ps.trackingNo = pi.trackingNo";

				sqlConn = new SqlConnection(shipping);
				sqlConn.Open();
				sqlCom = new SqlCommand(strsql, sqlConn);
				sqlRdr = sqlCom.ExecuteReader();

				if (sqlRdr.HasRows)
				{
					Invoice_grid.DataSource = sqlRdr;
					Invoice_grid.DataBind();
					Invoice_pnl.Visible = true;
				}
				else
				{
					Invoice_pnl.Visible = false;
				}
				sqlConn.Close();

				getBooks();	//Shows the list of the books in the order
				getMusic();	//Shows the list of the music in the order
			}
			else
			{
				//oh snap
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.home_link.Click += new System.EventHandler(this.home_link_Click);
			this.logout_btn.Click += new System.EventHandler(this.logout_btn_Click);
			this.shoppingCart_btn.Click += new System.Web.UI.ImageClickEventHandler(this.shoppingCart_btn_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
		
		private void updateStatus()
		{
			string sqlquery = "update	package_status " +
				"set	status = 'In transit' " +
					"where	'" + Convert.ToString(DateTime.Today) + 
					"' > dateShipped and " +
					"status = 'Not Shipped'";

			sqlConn = new SqlConnection(shipping);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);
			sqlRdr = sqlCom.ExecuteReader();
			sqlConn.Close();

			sqlquery = "update	package_status " +
				"set	status = 'Arrived' " +
					"where	'" + Convert.ToString(DateTime.Today) + "' > deliveryDate and " +
					"status != 'Arrived'";

			sqlConn = new SqlConnection(shipping);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);
			sqlRdr = sqlCom.ExecuteReader();
			sqlConn.Close();
		}

		private void getBooks()
		{
			string strsql = "select Title, Author, i.amount as Quantity " +
					"from Invoice3 as i, susik82_inv.dbo.Books3 as b " +
					"where invoiceID = " + id + " and " +
					"itemid = b.ISBN and i.type = 'b'";

			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(strsql, sqlConn);
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows)
			{
				Book_grid.DataSource = sqlRdr;
				Book_grid.DataBind();
				Book_pnl.Visible = true;
			}
			else
			{
				Book_pnl.Visible = false;
			}
			sqlConn.Close();

			strsql = "select Title, Author, i.amount as Quantity " +
				"from importInvoice3 as i, susik82_inv.dbo.ImportBooks3 as b " +
				"where invoiceID = " + id + " and " +
				"i.type = 'b' and itemid = b.ISBN and i.CID = b.CID";

			sqlConn.Open();
			sqlCom = new SqlCommand(strsql, sqlConn);
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows)
			{
				importBook_grid.DataSource = sqlRdr;
				importBook_grid.DataBind();
				Book_pnl.Visible = true;
			}
			sqlConn.Close();
		}

		private void getMusic()
		{
			string strsql = "select AlbumName, Artist, i.amount as Quantity " +
					"from Invoice3 as i, susik82_inv.dbo.Music3 as m " +
					"where invoiceID = " + id + " and " +
					"itemid = m.ID and i.type = 'm'";

			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(strsql, sqlConn);
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows)
			{
				Music_grid.DataSource = sqlRdr;
				Music_grid.DataBind();
				Music_pnl.Visible = true;
			}
			else
			{
				Music_pnl.Visible = false;
			}
			sqlConn.Close();

			strsql = "select AlbumName, Artist, i.amount as Quantity " +
				"from importInvoice3 as i, susik82_inv.dbo.importMusic3 as m " +
				"where invoiceID = " + id + " and " +
				"itemid = m.ID and i.type = 'm' and i.CID = m.CID";

			sqlConn.Open();
			sqlCom = new SqlCommand(strsql, sqlConn);
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows)
			{
				importMusic_grid.DataSource = sqlRdr;
				importMusic_grid.DataBind();
				Music_pnl.Visible = true;
			}
			sqlConn.Close();
		}
		private void logout_btn_Click(object sender, System.EventArgs e)
		{
			Session["CustomerID"] = null;
			Session["CustomerName"] = null;
			loginName_lbl.Text = "Not Logged In";
			loginName_lbl.Visible = true;
			loginName_lbl.ForeColor = Color.Red;
			logout_btn.Visible = false;
			return;
		}

		private void shoppingCart_btn_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			Server.Transfer("ShoppingCart.aspx");
		}

		private void home_link_Click(object sender, System.EventArgs e)
		{
			Server.Transfer("Index.aspx");
		}
	}
}
