using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.IO;

namespace _404_Not_Found
{
	/// <summary>
	/// Summary description for PartnerSuccess.
	/// </summary>
	public class PartnerSuccess : System.Web.UI.Page
	{

		public class Item
		{
			public string qty;
			public string type;
			public string itemID;

			public Item(string x, string y, string z)
			{
				qty = x;
				type = y;
				itemID = z;
			}
		}

		private SqlConnection sqlConn;
		private SqlCommand sqlCom;
		private SqlDataReader sqlRdr;
		private string billing = "server=IISQLSRV; uid=xinpl; pwd=rainday; database=xindig_billing";
		private string CID;
		protected System.Web.UI.WebControls.Label success_lbl;
		private string MID;
		protected System.Web.UI.WebControls.LinkButton home_link;
		private ArrayList items;

		private void Page_Load(object sender, System.EventArgs e)
		{
			Session["LastPage"] = "PartnerSuccess.aspx";

			if (Request.QueryString["id"] != null)
			{
				char[] delim = {'!'};
				string[] tokens = (Request.QueryString["id"]).Split(delim);

				CID = tokens[0];
				MID = tokens[1];
				sqlConn = new SqlConnection(billing);
				updateStats();
				generateOrder();
				removeFromShoppingCart();
				
				if (checkPartners())
				{
					Server.Transfer("PartnerShipping.aspx");
				}
				else
				{
					// we are done
					success_lbl.Visible = true;
				}
			}
		}

		private void updateStats()
		{
			string query = "update xindig_shipping.dbo.importshippingstats " +
				"set used = used + 1 " +
				"where CID = " + CID + " and MID = " + MID;
			
			sqlConn.Open();
			sqlCom = new SqlCommand(query, sqlConn);
			sqlRdr = sqlCom.ExecuteReader();
			sqlConn.Close();
		}

		private void generateOrder()
		{
			string cName, file = Server.MapPath("..\\orders\\") + "Inv" + Session["InvID"] + "CID" + CID + ".xml";
			string query = "select	CompanyName " +
				"from	susik82_Inv.dbo.importBooks3 " +
				"where	CID = " + CID + " " +
				"group by	CompanyName";

			sqlConn.Open();
			sqlCom = new SqlCommand(query, sqlConn);
			sqlRdr = sqlCom.ExecuteReader();			

			if (sqlRdr.HasRows)
			{
				sqlRdr.Read();
				cName = sqlRdr.GetString(0);
			}
			else
			{
				// oh crap
				cName = "";
			}
			sqlConn.Close();
	
			query = "select	cast(Amount as varchar(10)), Type, ItemID " +
				"from	ImportInvoice3 " +
				"where	CID = " + CID + " and InvoiceID = " + Session["InvID"];

			sqlConn.Open();
			sqlCom = new SqlCommand(query, sqlConn);
			sqlRdr = sqlCom.ExecuteReader();

			items = new ArrayList();

			if (sqlRdr.HasRows)
			{
				while (sqlRdr.Read())
				{
					items.Add(new Item(sqlRdr.GetString(0), sqlRdr.GetString(1), sqlRdr.GetString(2)));
				}
			}
			sqlConn.Close();

			StreamWriter output = new StreamWriter(file);
			output.Write("<order>\n");
			output.Write("<issuingCompany>404 Not Found</issuingCompany>\n");
			output.Write("<partnerCompany>" + cName + "</partnerCompany>\n");

			for (int i = 0; i < items.Count; i++)
			{
				Item curr = (Item) items[i];

				output.Write("<product>\n");

				if (curr.type.Equals("b"))
				{
					string itemName;
					query = "select	Title " +
						"from	susik82_Inv.dbo.importBooks3 " +
						"where	ISBN = '" + curr.itemID + "' and " +
						"CID = " + CID;
					sqlConn.Open();
					sqlCom = new SqlCommand(query, sqlConn);
					sqlRdr = sqlCom.ExecuteReader();
					if (sqlRdr.HasRows)
					{
						sqlRdr.Read();
						itemName = sqlRdr.GetString(0);
					}
					else
					{
						itemName = "";
					}
					sqlConn.Close();

					output.Write("<type>book</type>\n");
					output.Write("<identifier>" + curr.itemID + "</identifier>\n");
					output.Write("<name>" + itemName + "</name>\n");
					output.Write("<quantity>" + curr.qty + "</quantity>\n");

					updateBooks(curr.itemID, curr.qty);
				}
				else
				{
					string itemName;
					query = "select	AlbumName " +
						"from	susik82_Inv.dbo.importMusic3 " +
						"where	ID = '" + curr.itemID + "' and " +
						"CID = " + CID;
					sqlConn.Open();
					sqlCom = new SqlCommand(query, sqlConn);
					sqlRdr = sqlCom.ExecuteReader();
					if (sqlRdr.HasRows)
					{
						sqlRdr.Read();
						itemName = sqlRdr.GetString(0);
					}
					else
					{
						itemName = "";
					}
					sqlConn.Close();

					output.Write("<type>music</type>\n");
					output.Write("<identifier>" + curr.itemID + "</identifier>\n");
					output.Write("<name>" + itemName + "</name>\n");
					output.Write("<quantity>" + curr.qty + "</quantity>\n");

					updateMusic(curr.itemID, curr.qty);
				}
				output.Write("</product>\n");
			}

			query = "select street, city, state, cast(zip as varchar(10)), phone " +
				"from address as a, customer as c " +
				"where a.customerid = c.customerid and " +
				"a.customerid = " + Session["CustomerID"] + " and " +
				"a.AID = " + Session["AddrID"];

			sqlConn.Open();
			sqlCom = new SqlCommand(query, sqlConn);
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows)
			{
				sqlRdr.Read();

				output.Write("<shippingMethod>" + MID + "</shippingMethod>\n");
				output.Write("<destination>\n");
				output.Write("<address>" + sqlRdr.GetString(0) + "</address>\n");
				output.Write("<city>" + sqlRdr.GetString(1) + "</city>\n");
				output.Write("<state>" + sqlRdr.GetString(2) + "</state>\n");
				output.Write("<zip>" + sqlRdr.GetString(3) + "</zip>\n");

				output.Write("<contact>\n");
				output.Write("<tel>" + sqlRdr.GetString(4) + "</tel>\n");
				output.Write("<fax>" + sqlRdr.GetString(4) + "</fax>\n");
				output.Write("</contact>\n");
				output.Write("</destination>\n");
			}
			sqlConn.Close();
			output.Write("</order>\n");
			output.Close();
		}

		private void updateBooks(string itemID, string qty)
		{
			string query = "update susik82_Inv.dbo.importBooks3 " +
				"set quantity = quantity - " + qty + " " +
				"where cid = " + CID + " and ISBN = '" + itemID + "'";

			sqlConn.Open();
			sqlCom = new SqlCommand(query, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
			sqlConn.Close();
		}

		private void updateMusic(string itemID, string qty)
		{
			string query = "update susik82_Inv.dbo.importMusic3 " +
				"set quantity = quantity - " + qty + " " +
				"where cid = " + CID + " and ID = '" + itemID + "'";

			sqlConn.Open();
			sqlCom = new SqlCommand(query, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
			sqlConn.Close();
		}

		private void removeFromShoppingCart()
		{
			string query = "delete from importShoppingCart3 " +
				"where CID = " + Session["CustomerID"] + " and " +
				"CompanyID = " + CID;

			sqlConn.Open();
			sqlCom = new SqlCommand(query, sqlConn);
			sqlRdr = sqlCom.ExecuteReader();
			sqlConn.Close();
		}

		private bool checkPartners()
		{
			string query = "select * from importShoppingCart3";

			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(query, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows)
			{
				// means there's something we are buying from partner company
				return true;
			}
			return false;
		}
		
		private void home_link_Click(object sender, System.EventArgs e)
		{
			Server.Transfer("Index.aspx");
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.home_link.Click += new System.EventHandler(this.home_link_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
