using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace _404_Not_Found
{
	/// <summary>
	/// Summary description for Success.
	/// </summary>
	public class Success : System.Web.UI.Page
	{
		public class Item
		{
			public	string id;
			public	int amount;

			public Item(string x, int y) 
			{
				id = x;
				amount = y;
			}
		}

		protected System.Web.UI.WebControls.Label loginName_lbl;
		protected System.Web.UI.WebControls.Label Site_slogan_lbl;
		protected System.Web.UI.WebControls.LinkButton logout_btn;
		protected System.Web.UI.WebControls.Label Site_title_lbl;
		protected System.Web.UI.WebControls.LinkButton home_link;
		protected System.Web.UI.WebControls.Label trans_lbl;
		private string billing = "server=IISQLSRV; uid=xinpl; pwd=rainday; database=xindig_billing";
		private ArrayList music;
		private ArrayList books;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (Session["LastPage"].ToString() == "Success.aspx")
			{
				return;
			}

			loginName_lbl.Text = "Logged in as " +
				Convert.ToString(Session["CustomerName"]);

			Session["LastPage"] = "Success.aspx";

			music = new ArrayList();
			books = new ArrayList();

			if (Request.QueryString["id"] != null )
			{
				Session["MID"] = Request.QueryString["id"];
				updateStats(Request.QueryString["id"]);
				updateShoppingCart();

				if(sameCityShip())
				{
					// case when everything can be found in the same city
					sameCityPackage();
				}
				else
				{
					getItems();
					makeShipping();
				}
			}

			filterShoppingCart();
			checkPartners();
		}

		private void updateStats(string mid)
		{
			SqlConnection sqlConn;
			SqlCommand sqlCom;
			SqlDataReader sqlRdr;
			
			string query = "update xindig_shipping.dbo.shippingStats " +
				"set used = used + 1 " +
				"where MID = " + mid;

			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(query, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
		}

		private void filterShoppingCart()
		{
			// filters out stuff in the importshoppingcart that is not in invoices
			SqlConnection sqlConn;
			SqlCommand sqlCom;
			SqlDataReader sqlRdr;
			
			string query = "delete	from	ImportShoppingCart3 " +
				"where	CID = " + Session["CustomerID"] + " and " +
				"ItemID not in (select ItemID " +
				"from ImportInvoice3 " +
				"where InvoiceID = " + Session["InvID"] + ")";

			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(query, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
		}


		private void checkPartners()
		{
			SqlConnection sqlConn;
			SqlCommand sqlCom;
			SqlDataReader sqlRdr;
			string query = "select * from importinvoice3";

			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(query, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows)
			{
				// means there's something we are buying from partner company
				Server.Transfer("PartnerShipping.aspx");
			}
			// else there's is nothing from partner companies so we are done
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.home_link.Click += new System.EventHandler(this.home_link_Click);
			this.logout_btn.Click += new System.EventHandler(this.logout_btn_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
		private void makeShipping()
		{
			SqlConnection sqlConn;
			SqlCommand sqlCom;
			SqlDataReader sqlRdr;
			string sqlquery;
			Item current;

			for (int i = 0; i < music.Count; i++)
			{
				current = (Item) music[i];

				sqlquery = "select	a.quantity - " + current.amount + ", a.warehouse " +
					"from	susik82_inv.dbo.availability3 as a " +
					"where	a.musicid = " + current.id;

				sqlConn = new SqlConnection(billing);
				sqlConn.Open();
				sqlCom = new SqlCommand(sqlquery, sqlConn);	
				sqlRdr = sqlCom.ExecuteReader();

				ArrayList delta = new ArrayList();
				ArrayList warehouse = new ArrayList();

				if (sqlRdr.HasRows)
				{
					while(sqlRdr.Read())
					{	
						delta.Add(sqlRdr.GetInt32(0));
						warehouse.Add(sqlRdr.GetInt32(1));
					}
				}

				sqlConn.Close();

				// we need to find the warehouse that can do this item
				int wnum = 0; // warehouse number

				for (int j = 0; j < delta.Count; j++)
				{
					if ((int) delta[j] >= 0)
					{
						wnum = (int) warehouse[j];
					}
				}
				
				if (wnum != 0)
					createShipping(wnum, current.id, current.amount, 'm');
				else
				{
					// we need to check multiple warehouses to get all the quantity needed
					int currqty = current.amount;
					int qty;

					for (int k = 0; k < delta.Count; k++)
					{
						qty = (int) delta[k] + current.amount;
						// qty is how much of the item is at warehouse k

						if ((currqty - qty) >= 0 && (qty != 0))
						{
							// if currqty, which is what we want is greater than qty...
							createShipping((int) warehouse[k], current.id, qty, 'm');
							currqty -= qty;
						}
						else
						{
							// done with this item
							createShipping((int) warehouse[k], current.id, currqty, 'm');
							break;
						}
					}
				}
			}// end for

			for (int i = 0; i < books.Count; i++)
			{	// we need to find the warehouse that can do this item
				int wnum = 0; // warehouse number

				current = (Item) books[i];

				sqlquery = "select	a.quantity - " + current.amount + ", a.warehouse " +
					"from	susik82_inv.dbo.availability3 as a " +
					"where	a.ISBN = " + current.id;

				sqlConn = new SqlConnection(billing);
				sqlConn.Open();
				sqlCom = new SqlCommand(sqlquery, sqlConn);	
				sqlRdr = sqlCom.ExecuteReader();

				ArrayList delta = new ArrayList();
				ArrayList warehouse = new ArrayList();

				if (sqlRdr.HasRows)
				{
					while(sqlRdr.Read())
					{
						delta.Add(sqlRdr.GetInt32(0));
						warehouse.Add(sqlRdr.GetInt32(1));
					}
				}

				sqlConn.Close();

				for (int j = 0; j < delta.Count; j++)
				{
					if ((int) delta[j] >= 0)
					{
						wnum = (int) warehouse[j];
					}
				}

				if (wnum != 0)
					createShipping(wnum, current.id, current.amount, 'b');
				else
				{
					// we need to check multiple warehouses to get all the quantity needed
					int currqty = current.amount;
					int qty;

					for (int k = 0; k < delta.Count; k++)
					{
						qty = (int) delta[k] + current.amount;
						// qty is how much of the item is at warehouse k

						if ((currqty - qty) >= 0 && (qty != 0))
						{
							// if currqty, which is what we want is greater than qty...
							createShipping((int) warehouse[k], current.id, qty, 'b');
							currqty -= qty;
						}
						else
						{
							// done with this item
							createShipping((int) warehouse[k], current.id, currqty, 'b');
							break;
						}
					}
				}
			}// end for
        }
		
		/* 
		 * create all the shipping information given warehouse, itemid, and 
		 * amount taken from this warehouse, and then m for type music b for book
		 * this is only for music items
		 */
		private void createShipping(int warehouse, string id, int amount, char type)
		{
			SqlConnection sqlConn;
			SqlCommand sqlCom;
			SqlDataReader sqlRdr;
			string sqlquery;

			string t;
			if (type == 'm')
			{
				t = "musicid";
			}
			else
			{
				t = "ISBN";
			}

			sqlquery = "update	susik82_inv.dbo.availability3 " +
				"set	quantity = a.quantity - " + amount + " " +
				"from	susik82_inv.dbo.availability3 as a, invoice3 " +
				"where	invoice3.buyer = " + Session["CustomerID"] + " and " +
				"a.warehouse = " + warehouse + " and " +
				"(invoice3.type = '" + type + "' and '" + id + "' = a." + t + ")";

			executeSql(sqlquery);

			int trackingNo;

			sqlquery = "select	count(distinct trackingNo) + 1 " +
				"from	xindig_shipping.dbo.packages";

			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows)
			{
				sqlRdr.Read();
				trackingNo = sqlRdr.GetInt32(0);
				sqlConn.Close();
			}
			else
			{
				// oh snap shouldn't really happen
				sqlConn.Close();
				return;
			}

			sqlquery = "insert	xindig_shipping.dbo.package_invoice " +
				"values (" + trackingNo + ", " + Session["InvID"] + ")";
			executeSql(sqlquery);

			int deliveryTime;
			int pkgWeight;

			sqlquery = "select	deliveryTime, weight " +
				"from	xindig_shipping.dbo.shipping_price as sp, " +
				"xindig_shipping.dbo.shipping_time as st " +
				"where	sp.mid = " + Session["MID"] + " and " +
				"sp.name = st.name and " +
				"sp.opt = st.opt";

			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows)
			{
				sqlRdr.Read();
				deliveryTime = sqlRdr.GetInt32(0);
				pkgWeight = sqlRdr.GetInt32(1);
				sqlConn.Close();
			}
			else
			{
				sqlConn.Close();
				return;
			}
			
			DateTime temp = (DateTime) Session["Date"];

			DateTime shipDate = temp.AddDays(deliveryTime);

			sqlquery = "insert	xindig_shipping.dbo.package_status " +
				"values	(" + trackingNo + ", 'Not Shipped'" + ", " + 
				"'" + Convert.ToString(Session["Date"]) + "', " +
				"'" + shipDate.ToString() + "', '" + Session["Shipping_Instructions"] + "')";
			executeSql(sqlquery);

			int units = amount;
			string name, opt;

			sqlquery = "select	name, opt " +
				"from	xindig_shipping.dbo.shipping_price as sp " +
				"where	sp.mid = " + Session["MID"];
			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows)
			{
				sqlRdr.Read();
				name = sqlRdr.GetString(0);
				opt = sqlRdr.GetString(1);
			}
			else
			{
				name = "";
				opt = "";
			}
			sqlConn.Close();

			sqlquery = "insert	xindig_shipping.dbo.packages " +
				"values	(" + trackingNo + ", '" + name + "', " +
				units + ", " + pkgWeight + ", '" + opt + "', " + 
				Session["AddrID"] + ")";
			executeSql(sqlquery);
		}

		private void getItems()
		{
			SqlConnection sqlConn;
			SqlCommand sqlCom;
			SqlDataReader sqlRdr;
			string sqlquery;
			string itemid;
			int amount;

			sqlquery = "select	itemid, amount " +
				"from	invoice3 " +
				"where	type = 'm' and " +
					"invoiceid = " + Session["InvID"] + " and " +
					"buyer = " + Session["CustomerID"];
			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
			if (sqlRdr.HasRows)
			{
				while (sqlRdr.Read())
				{
					itemid = sqlRdr.GetString(0);
					amount = sqlRdr.GetInt32(1);
					music.Add(new Item(itemid, amount));
				}
			}
			sqlConn.Close();

			sqlquery = "select	itemid, amount " +
				"from	invoice3 " +
				"where	type = 'b' and " +
				"invoiceid = " + Session["InvID"] + " and " +
				"buyer = " + Session["CustomerID"];
			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
			if (sqlRdr.HasRows)
			{
				while (sqlRdr.Read())
				{
					itemid = sqlRdr.GetString(0);
					amount = sqlRdr.GetInt32(1);
					books.Add(new Item(itemid, amount));
				}
			}
			sqlConn.Close();
		}

		private void logout_btn_Click(object sender, System.EventArgs e)
		{
			Session["CustomerID"] = null;
			Session["CustomerName"] = null;
			Server.Transfer("Index.aspx");
		}

		private void home_link_Click(object sender, System.EventArgs e)
		{
			Server.Transfer("Index.aspx");
		}

		private void sameCityPackage()
		{
			SqlConnection sqlConn;
			SqlCommand sqlCom;
			SqlDataReader sqlRdr;
			int warehouse;

			string sqlquery = "select	wnumber " +
				"from	susik82_inv.dbo.warehouses as w, address " +
				"where	customerid = " + Session["CustomerID"] + " and " +
					"aid = " + Session["AddrID"] + " and " +
					"address.city = w.city";
			
			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows)
			{
				sqlRdr.Read();
				warehouse = sqlRdr.GetInt32(0);
				sqlConn.Close();
			}
			else
			{
				sqlConn.Close();
				return;
			}

			sqlquery = "update	susik82_inv.dbo.availability3 " +
				"set	quantity = a.quantity - invoice3.amount " +
					"from	susik82_inv.dbo.availability3 as a, invoice3 " +
					"where	invoice3.buyer = " + Session["CustomerID"] + " and " +
						"invoice3.invoiceid = " + Session["InvID"] + " and " +
						"a.warehouse = " + warehouse + " and " +
						"(invoice3.type = 'b' and " +
						"invoice3.itemid = a.ISBN)";
			executeSql(sqlquery);

			sqlquery = "update	susik82_inv.dbo.availability3 " +
				"set	quantity = a.quantity - invoice3.amount " +
					"from	susik82_inv.dbo.availability3 as a, invoice3 " +
					"where	invoice3.buyer = " + Session["CustomerID"] + " and " +
						"invoice3.invoiceid = " + Session["InvID"] + " and " +
						"a.warehouse = " + warehouse + " and " +
						"(invoice3.type = 'm' and " +
						"invoice3.itemid = a.musicid)";
			executeSql(sqlquery);

			int trackingNo;

			sqlquery = "select	count(distinct trackingNo) + 1 " +
				"from	xindig_shipping.dbo.packages";

			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows)
			{
				sqlRdr.Read();
				trackingNo = sqlRdr.GetInt32(0);
				sqlConn.Close();
			} 
			else
			{
				sqlConn.Close();
				return;
			}

			sqlquery = "insert	xindig_shipping.dbo.package_invoice " +
				"values (" + trackingNo + ", " + Session["InvID"] + ")";
			executeSql(sqlquery);

			int deliveryTime;
			int pkgWeight;

			sqlquery = "select	deliveryTime, weight " +
				"from	xindig_shipping.dbo.shipping_price as sp, " +
					"xindig_shipping.dbo.shipping_time as st " +
				"where	sp.mid = " + Session["MID"] + " and " +
					"sp.name = st.name and " +
					"sp.opt = st.opt";

			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows)
			{
				sqlRdr.Read();
				deliveryTime = sqlRdr.GetInt32(0);
				pkgWeight = sqlRdr.GetInt32(1);
				sqlConn.Close();
			}
			else
			{
				sqlConn.Close();
				return;
			}

			DateTime x = (DateTime) Session["Date"];
			DateTime temp = x.AddDays((double) deliveryTime);
			
			sqlquery = "insert	xindig_shipping.dbo.package_status " +
				"values	(" + trackingNo + ", 'Not Shipped'" + ", " + 
				"'" + Convert.ToString(Session["Date"]) + "', " +
				"'" + temp.ToString() + "', '" + Session["Shipping_Instructions"] + "')";
			executeSql(sqlquery);

			int units;
			string name, opt;

			sqlquery = "select		count(itemid) as units " +
				"from		invoice3 " +
				"where		invoiceid = " + Session["InvID"] +
				"group by	invoiceid";

			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
			if (sqlRdr.HasRows)
			{
				sqlRdr.Read();
				units = sqlRdr.GetInt32(0);
			}
			else
			{
				units = 1;
			}
			sqlConn.Close();

			sqlquery = "select	name, opt " +
				"from	xindig_shipping.dbo.shipping_price as sp " +
				"where	sp.mid = " + Session["MID"];
			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
			
			if (sqlRdr.HasRows)
			{
				sqlRdr.Read();
				name = sqlRdr.GetString(0);
				opt = sqlRdr.GetString(1);
			}
			else
			{
				name = "";
				opt = "";
			}
			sqlConn.Close();

			sqlquery = "insert	xindig_shipping.dbo.packages " +
				"values	(" + trackingNo + ", '" + name + "', " +
				units + ", " + pkgWeight + ", '" + opt + "', " + 
				Session["AddrID"] + ")";
			executeSql(sqlquery);
		}

		private void executeSql(string sqlquery)
		{
			SqlConnection sqlConn;
			SqlCommand sqlCom;
			SqlDataReader sqlRdr;
			
			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
			sqlConn.Close();
		}

		private bool sameCityShip()
		{
			SqlConnection sqlConn;
			SqlCommand sqlCom;
			SqlDataReader sqlRdr;

			string sqlquery = "select * " +
				"from	invoice3 " +
				"where	invoice3.type = 'b' and " +
					"invoice3.itemid not in " +
					"(select	ISBN " +
					"from	susik82_Inv.dbo.Availability3 as a, " +
						"susik82_Inv.dbo.warehouses as w, " +
						"(select	city, amount, itemid " +
						"from	invoice3, address " +
						"where	invoice3.invoiceid = " + Session["InvID"] + " and " +
							"invoice3.buyer = " + Session["CustomerID"] + " and " +
							"address.customerid = " + Session["CustomerID"] + " and " +
							"address.AID = " + Session["AddrID"] + " and " +
							"invoice3.type = 'b') as books " +
					"where	a.warehouse = w.wnumber and " +
						"books.itemid = a.ISBN and " +
						"w.city = books.city and " +
						"a.quantity >= books.amount)";


			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();

			if(sqlRdr.HasRows) 
			{
				return false;
			}
			sqlConn.Close();

			sqlquery = "select * " +
				"from	invoice3 " +
				"where	invoice3.type = 'm' and " +
					"invoice3.itemid not in " +
					"(select	musicid " +
					"from	susik82_Inv.dbo.Availability3 as a, " +
						"susik82_Inv.dbo.warehouses as w, " +
						"(select	city, amount, itemid " +
						"from	invoice3, address " +
						"where	invoice3.invoiceid = " + Session["InvID"] + " and " +
							"invoice3.buyer = " + Session["CustomerID"] + " and " +
							"address.customerid = " + Session["CustomerID"] + " and " +
							"address.AID = " + Session["AddrID"] + " and " +
							"invoice3.type = 'm') as music " +
					"where	a.warehouse = w.wnumber and " +
						"music.itemid = a.musicid and " +
						"w.city = music.city and " +
						"a.quantity >= music.amount)";

			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();

			if(sqlRdr.HasRows)
			{
				return false;
			}
			sqlConn.Close();

			return true;
		}

		private void updateShoppingCart()
		{
			SqlConnection sqlConn;
			SqlCommand sqlCom;
			SqlDataReader sqlRdr;

			string sqlquery = "delete from shoppingcart3 " +
				"where CID = " + Session["CustomerID"];
			
			sqlConn = new SqlConnection(billing);
			sqlConn.Open();
			sqlCom = new SqlCommand(sqlquery, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();

			sqlConn.Close();
		}
	}
}
