using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;	// This is the library with the SQL types we're using below

namespace phase2
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		//class variables
		#region

		protected System.Web.UI.WebControls.Button MusicSearch;
		protected System.Web.UI.WebControls.TextBox ArtistBox;
		protected System.Web.UI.WebControls.TextBox BookTitleBox;
		protected System.Web.UI.WebControls.TextBox PasswordBox;
		protected System.Web.UI.WebControls.TextBox KeywordBox;
		protected System.Web.UI.WebControls.TextBox CDTitleBox;
		protected System.Web.UI.WebControls.DataGrid CDpicks;
		private SqlConnection sqlConn;	// Declare a connection object
		private SqlCommand sqlCom;		  // Declare a command object
		private SqlConnection sqlConn2;
		private SqlDataReader sqlRdr;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.Label Label3;
		protected System.Web.UI.WebControls.Label LoggedInGreeting;
		protected System.Web.UI.WebControls.TextBox UserNameBox;
		protected System.Web.UI.WebControls.Label Label4;
		protected System.Web.UI.WebControls.Label Label5;
		protected System.Web.UI.WebControls.Label Label6;
		protected System.Web.UI.WebControls.DataGrid BookResults;
		protected System.Web.UI.WebControls.DataGrid CDResults;
		protected System.Web.UI.WebControls.Label Label8;
		protected System.Web.UI.WebControls.DataGrid Bookpicks;
		protected System.Web.UI.WebControls.Button ViewAllButton;
		protected System.Web.UI.WebControls.Button LoginButton;
		protected System.Web.UI.WebControls.TextBox AuthorBox;
		protected System.Web.UI.WebControls.Button BookSearch;
		protected System.Web.UI.WebControls.HyperLink CreateAccount;
		protected System.Web.UI.WebControls.HyperLink ModifyAccount;
		protected System.Web.UI.WebControls.HyperLink ShoppingCartLink;
		private string strSqlString = "server=IISQLSRV.cs.washington.edu; uid=jblat; pwd=pass; database=jblat_inventory";
		#endregion
		/* Browsing: A customer can browse books and music CDs in store. 
		 * The browsing methods are either (1) find by title, (2) find by author or musician,
		 * (3) by keyword for books, and (4) view all products. Some important information that MUST be displayed
		 * (either in the browsing page or by implementing another "view detailed information" page) include product ID,
		 * product name, author, price, have discount or not and total quantity in stock (sum over all warehouses).
		 * Your work in Phase 1 should have prepared you well for this.*/

		private void Page_Load(object sender, System.EventArgs e)
		{
				if (Session["AccountPageType"] == null)
			{
				Session.Add("AccountPageType", "creation");
			}

			Label8.Visible = false;
			if (!this.Page.IsPostBack)
			{
				if (Session["AccountPageType"] == null)
				{
					Session.Add("AccountPageType", "creation");
				}
				else 
				{
					Session.Remove("AccountPageType"); //not sure how to just change it, so we remove and add
					Session.Add("AccountPageType", "creation");

				}
				if (Session["CustomerID"] != null)
				{
					this.LoggedIn();
				}
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	// open the connection

				// Execute query -- Here you could make 'strSql' any query you want
				string strSql = "select title, author, isbn, discountprice from books where staffpick = 1";
						
				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				// Get the answer from the reader and write it to the label.
				if (sqlRdr.HasRows) 
				{
					Bookpicks.DataSource = sqlRdr;
					Bookpicks.DataBind();
					Bookpicks.Visible = true;
				}
				else 
				{
					Bookpicks.Visible = false;
				}

				//close and reopen the connection. don't know how to get multiple queries out of one connection.

				sqlConn.Close();

				//get cd staff picks
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	// open the connection


				// Execute query -- Here you could make 'strSql' any query you want
				strSql = "select albumname, artists, genre, cdid, discountprice from music where staffpick = 1";
						
				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				// Get the answer from the reader and write it to the label.
				if (sqlRdr.HasRows) 
				{
					CDpicks.DataSource = sqlRdr;
					CDpicks.DataBind();
					CDpicks.Visible = true;
				}
				else 
				{
					CDpicks.Visible = false;
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.LoginButton.Click += new System.EventHandler(this.LoginButton_Click);
			this.ViewAllButton.Click += new System.EventHandler(this.ViewAllButton_Click);
			this.BookSearch.Click += new System.EventHandler(this.BookSearch_Click);
			this.Bookpicks.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.Bookpicks_ItemCommand);
			this.CDpicks.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.CDpicks_ItemCommand);
			this.CDpicks.SelectedIndexChanged += new System.EventHandler(this.CDpicks_SelectedIndexChanged);
			this.MusicSearch.Click += new System.EventHandler(this.MusicSearch_Click);
			this.BookResults.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.BookResults_ItemCommand);
			this.CDResults.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.CDResults_ItemCommand);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
		/* Some important information that MUST be displayed (either in the browsing page or by implementing another
		 *  "view detailed information" page) include product ID, product name, author, price, have discount or not 
		 * and total quantity in stock (sum over all warehouses).*/
		private void BookSearch_Click(object sender, System.EventArgs e)
		{
			this.ClearAll();
			int searchType = this.CheckWhichBookBox();
			//person entered an author. We are not checking for correct input type
			// Start a new connection to the database specified in strSqlString
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection
			string strSql = "";

			switch(searchType) 
			{
				case 1: //it's an author search
					// Execute query 
					strSql = "SELECT isbn, title, author, sellingprice, discountprice, totalStocked, company = '444h'" +
						" FROM books, (SELECT book, SUM(numinstock) AS totalStocked" +
						" FROM books, bookstock" +
						" WHERE book = isbn AND author LIKE '%" + AuthorBox.Text + "%'" +
						" GROUP BY book) AS authorstuff" +
						" WHERE isbn = book" +
						" UNION" +
						" SELECT distinct isbn, title, author, round(sellingprice*1.1,2), round(discountprice*1.1,2), quantity as totalStocked, company" +
						" FROM djwatson.partnerbooks" +
						" WHERE author LIKE '%" + AuthorBox.Text + "%'" +
						" ";
						
					// The command needs to know the query and the connection
					sqlCom = new SqlCommand(strSql, sqlConn);	
					// Execute the command
					sqlRdr = sqlCom.ExecuteReader();

					// Get the answer from the reader and write it to the label.
					if (sqlRdr.HasRows) 
					{
						BookResults.DataSource = sqlRdr;
						BookResults.DataBind();
						BookResults.Visible = true;
						Label3.Visible = true;
					}
					else 
					{
						Label1.Text = "No info found for that author. Are you sure you spelled it right?";
						Label1.Visible = true;
					}
					sqlConn.Close();
					break;

				case 2:
					//it's a title search
					// Execute query 
					strSql = "SELECT isbn, title, author, sellingprice, discountprice, totalStocked, company = '444h'" +
						" FROM books, (SELECT book, SUM(numinstock) AS totalStocked" +
						" FROM books, bookstock" +
						" WHERE book = isbn AND title LIKE '%" + BookTitleBox.Text + "%'" +
						" GROUP BY book) AS titlestuff" +
						" WHERE isbn = book" + 
						" UNION SELECT isbn, title, author, round(sellingprice*1.1,2), round(discountprice*1.1,2), quantity as totalStocked, company" +
						" FROM djwatson.partnerbooks" +
						" WHERE title LIKE '%" + BookTitleBox.Text + "%'";
						
					// The command needs to know the query and the connection
					sqlCom = new SqlCommand(strSql, sqlConn);	
					// Execute the command
					sqlRdr = sqlCom.ExecuteReader();

					// Get the answer from the reader and write it to the label.
					if (sqlRdr.HasRows) 
					{
						BookResults.DataSource = sqlRdr;
						BookResults.DataBind();
						BookResults.Visible = true;
						Label3.Visible = true;
					}
					else 
					{
						Label1.Text = "No info found for that title. Are you sure you spelled it right?";
						Label1.Visible = true;
					}
					sqlConn.Close();
					break;


				case 3:
					//it's a keyword search
					// Execute query 
					strSql = "SELECT isbn, title, author, sellingprice, discountprice, keywords, totalStocked, company = '444h'" +
						" FROM books, (SELECT book, SUM(numinstock) AS totalStocked" +
						" FROM books, bookstock" +
						" WHERE book = isbn AND keywords LIKE '%" + KeywordBox.Text + "%'" +
						" GROUP BY book) AS keywordstuff" +
						" WHERE isbn = book" + 
						" UNION SELECT isbn, title, author, round(sellingprice*1.1,2), round(discountprice*1.1,2), keywords, quantity as totalStocked, company" +
						" FROM djwatson.partnerbooks" +
						" WHERE keywords LIKE '%" + KeywordBox.Text + "%'";
						
					// The command needs to know the query and the connection
					sqlCom = new SqlCommand(strSql, sqlConn);	
					// Execute the command
					sqlRdr = sqlCom.ExecuteReader();

					// Get the answer from the reader and write it to the label.
					if (sqlRdr.HasRows) 
					{
						BookResults.DataSource = sqlRdr;
						BookResults.DataBind();
						BookResults.Visible = true;
						Label3.Visible = true;
					}
					else 
					{
						Label1.Text = "No book found with that keyword. Are you sure you spelled it right?";
						Label1.Visible = true;
					}
					sqlConn.Close();
					break;

				case 0: //it's an invalid search
					break;
			}
			
		}




		private void ViewAllButton_Click(object sender, System.EventArgs e)
		{
			this.ClearAll();
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection
			// Execute query -- Here you could make 'strSql' any query you want
			string strSql = "";

			//get info for all the cds in the database
			strSql = "SELECT cdid, albumname, artists, sellingprice, discountprice, totalStocked, company = '444h'" +
				" FROM music, (SELECT cd, SUM(numinstock) AS totalStocked" +
				" FROM music, musicstock" +
				" WHERE cd = cdid " +
				" GROUP BY cd) AS artiststuff" +
				" WHERE cdid = cd" + 
				" UNION SELECT cdid, albumname, artists, round(sellingprice*1.1,2), round(discountprice*1.1,2), quantity as totalStocked, company" +
				" FROM bovinium.partnermusic";
						
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			// Get the answer from the reader and write it to the label.
			if (sqlRdr.HasRows) 
			{
				CDResults.DataSource = sqlRdr;
				CDResults.DataBind();
				CDResults.Visible = true;
				Label3.Visible = true;
				Label1.Text = "Books";
				Label1.Visible = true;
			}
			else 
			{
				Label2.Text = "No CDs found in the database. Our inventory must have been wiped out!";
				Label2.Visible = true;
			}

			//close and reopen the connection. don't know how to get multiple queries out of one connection.
			sqlConn.Close();
			sqlConn.Open();

			//get info for all the books in the database
			strSql = "SELECT isbn, title, author, sellingprice, discountprice, totalStocked, company='444h'" +
				" FROM books, (SELECT book, SUM(numinstock) AS totalStocked" +
				" FROM books, bookstock" +
				" WHERE book = isbn " +
				" GROUP BY book) AS titlestuff" +
				" WHERE isbn = book" + 
				" UNION SELECT isbn, title, author, round(sellingprice*1.1,2), round(discountprice*1.1,2), quantity as totalStocked, company" +
				" FROM djwatson.partnerbooks";
						
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			// Get the answer from the reader and write it to the label.
			if (sqlRdr.HasRows) 
			{
				BookResults.DataSource = sqlRdr;
				BookResults.DataBind();
				BookResults.Visible = true;
				Label3.Visible = true;
				Label2.Text = "Albums";
				Label2.Visible = true;
			}
			else 
			{
				Label1.Text = "No books found in the database. Our inventory must have been wiped out!";
				Label1.Visible = true;
			}
			sqlConn.Close();
		
		}

		private void MusicSearch_Click(object sender, System.EventArgs e)
		{
			this.ClearAll();
			int searchType = this.CheckWhichCDBox();
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection
			string strSql = "";
			switch(searchType)
			{
				case 1: //it's an artist search


					// Execute query -- Here you could make 'strSql' any query you want
					strSql = "SELECT cdid, albumname, artists, sellingprice, discountprice, totalStocked,company='444h'" +
						" FROM music, (SELECT cd, SUM(numinstock) AS totalStocked" +
						" FROM music, musicstock" +
						" WHERE cd = cdid AND artists LIKE '%" + ArtistBox.Text + "%'" +
						" GROUP BY cd) AS artiststuff" +
						" WHERE cdid = cd"+
						" UNION SELECT cdid, albumname, artists, round(sellingprice*1.1,2), round(discountprice*1.1,2), quantity as totalStocked,company" +
						" FROM bovinium.partnermusic" +
						" WHERE artists LIKE '%" + ArtistBox.Text + "%'";
						
					// The command needs to know the query and the connection
					sqlCom = new SqlCommand(strSql, sqlConn);	
					// Execute the command
					sqlRdr = sqlCom.ExecuteReader();

					// Get the answer from the reader and write it to the label.
					if (sqlRdr.HasRows) 
					{
						CDResults.DataSource = sqlRdr;
						CDResults.DataBind();
						CDResults.Visible = true;
						Label3.Visible = true;
					}
					else 
					{
						Label1.Text = "No info found for that artist. Are you sure you spelled it right?";
						Label1.Visible = true;
					}

					//close the connection. 

					sqlConn.Close();
					break;
				case 2: //it's a title search
					
					// Execute query -- Here you could make 'strSql' any query you want
					strSql = "SELECT cdid, albumname, artists, sellingprice, discountprice, totalStocked,company = '444h'" +
						" FROM music, (SELECT cd, SUM(numinstock) AS totalStocked" +
						" FROM music, musicstock" +
						" WHERE cd = cdid AND albumname LIKE '%" + CDTitleBox.Text + "%'" +
						" GROUP BY cd) AS albumstuff" +
						" WHERE cdid = cd" +
						" UNION SELECT cdid, albumname, artists, round(sellingprice*1.1,2), round(discountprice*1.1,2), quantity as totalStocked, company" +
						" FROM bovinium.partnermusic" +
						" WHERE  albumname LIKE '%" + CDTitleBox.Text + "%'";
						
					// The command needs to know the query and the connection
					sqlCom = new SqlCommand(strSql, sqlConn);	
					// Execute the command
					sqlRdr = sqlCom.ExecuteReader();

					// Get the answer from the reader and write it to the label.
					if (sqlRdr.HasRows) 
					{
						CDResults.DataSource = sqlRdr;
						CDResults.DataBind();
						CDResults.Visible = true;
						Label3.Visible = true;
					}
					else 
					{
						Label1.Text = "No info found for that artist. Are you sure you spelled it right?";
						Label1.Visible = true;
					}

					//close and reopen the connection. don't know how to get multiple queries out of one connection.

					sqlConn.Close();
					break;
				case 0: //it's an invalid search
					break;
			}
		}

		private int CheckWhichBookBox() 
		{/*method to check whether a user entered something into the text box labeled books or 
		   * the text box labeled music, or both or neither. We assume the user did what they wanted
		   * and did not write in the book box when they meant the music box, and vice versa */

			/* return a 0 if the user entered the values wrong, a 1 if it's a book and a 2 if it's a cd. */
			
			//user has not entered anything into any of the book boxes
			if ((AuthorBox.Text.Length == 0) && (BookTitleBox.Text.Length == 0) && (KeywordBox.Text.Length == 0)) 
			{
				Label1.Text = "You must enter a criteria to search for in one of the book search boxes";
				Label1.Visible = true;
				return 0;
			}

				//user has entered something in multiple boxes
			else if (((AuthorBox.Text.Length != 0) && (BookTitleBox.Text.Length != 0)) || ((AuthorBox.Text.Length != 0)
				&& (KeywordBox.Text.Length != 0)) || ((BookTitleBox.Text.Length != 0) && (KeywordBox.Text.Length != 0)))
			{
				Label1.Text = "You may only choose to look up one search criteria at a time.";
				Label1.Visible = true;
				return 0;
			}

				//user has entered an an author and nothing else
			else if (AuthorBox.Text.Length != 0) 
			{
				//it's an author search
				return 1;
			}

				//user has entered a book title and nothing else
			else if (BookTitleBox.Text.Length != 0)
			{ //it's a title
				return 2;
			}

			else if (KeywordBox.Text.Length != 0) 
			{
				//it's a keyword search
				return 3;
			}
			else 
			{ //there should be no other cases, but we make a default other case 
				return 0;
			}
		}

		private int CheckWhichCDBox()
		{
				
			//user has not entered an search criteria
			if ((ArtistBox.Text.Length == 0) && (CDTitleBox.Text.Length == 0)) 
			{
				Label1.Text = "You must enter a search criteria in one of the music search boxes!";
				Label1.Visible = true;
				return 0;
			}

				//user has entered both an ISBN/author and a CDID/artist
			else if ((ArtistBox.Text.Length != 0) && (CDTitleBox.Text.Length != 0)) 
			{
				Label1.Text = "You may only choose to look up one search criteria at a time.";
				Label1.Visible = true;
				return 0;
			}

				//user has entered an artist
			else if (ArtistBox.Text.Length != 0)
			{
				//it's a artist search
				return 1;
			}

				//user has entered a title
			else if (CDTitleBox.Text.Length != 0)
			{ //it's a title search
				return 2;
			}

			else 
			{ //there should be no other cases, but we make a default other case 
				return 0;
			}


		}
		private void ClearAll() 
		{ /* a method to make datagrids and some labels invisible, to keep the page uncluttered */
			CDResults.Visible = false;
			BookResults.Visible = false;
			Label1.Visible = false;
			Label2.Visible = false;
			Label3.Visible = false;
			Label8.Visible = false;
		}

		private void LoginButton_Click(object sender, System.EventArgs e)
		{
			this.ClearAll();
			
			if (Session["CustomerID"] == null) //we are trying to login
			{
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	// open the connection
				string strSql = "select * from MattMckenzieBilling.dbo.Customers" +
					" WHERE CustomerID = '" + UserNameBox.Text + "'" +
					" and pass = '" + PasswordBox.Text + "'";
						
				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				// Get the answer from the reader and write it to the label.
				if (sqlRdr.HasRows) 
				{
					Session.Add("CustomerID", UserNameBox.Text);
					this.LoggedIn();
				}
				else 
				{
					LoggedInGreeting.Text = "Invalid username/password combination";
					LoggedInGreeting.Visible = true;
				}

				//close and reopen the connection. don't know how to get multiple queries out of one connection.

				sqlConn.Close();
			}
			else //we are logging out
			{
				Session.Clear(); //clear the session
				Label4.Visible = true;
				PasswordBox.Visible = true;
				UserNameBox.Visible = true;
				LoginButton.Text = "Login";
				Label5.Visible = true;
				Label6.Text = "password";
				UserNameBox.Text = ""; //clear the username and password
				PasswordBox.Text = "";
				LoggedInGreeting.Visible = false;
				ModifyAccount.Visible = false;
				CreateAccount.Visible = true;
				ShoppingCartLink.Visible = false;
				if (Session["AccountPageType"] == null)
				{
					Session.Add("AccountPageType", "creation");
				}
				else 
				{
					Session.Remove("AccountPageType"); //not sure how to just change it, so we remove and add
					Session.Add("AccountPageType", "creation");

				}
			}
		}
	
	

		private void LoggedIn() 
		{
			LoggedInGreeting.Text = "Welcome " + Session["CustomerID"];
			LoggedInGreeting.Visible = true;
			Label4.Visible = false;
			PasswordBox.Visible = false; //we don't want them to be able to login again 
			UserNameBox.Visible = false; //until they've logged out
			LoginButton.Text = "Logout";
			Label5.Visible = false;
			Label6.Text = "Not you?";
			ModifyAccount.Visible = true;
			CreateAccount.Visible = false;
			ShoppingCartLink.Visible = true;
			if (Session["AccountPageType"] == null)
			{
				Session.Add("AccountPageType", "modification");
			}
			else 
			{
				Session.Remove("AccountPageType"); //not sure how to just change it, so we remove and add
				Session.Add("AccountPageType", "modification");

			}
		}


		private void CDResults_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			if (Session["CustomerID"] != null) //cannot add things to cart if you're not logged in
			{
				if (e.CommandName == "CDAddToCart") 
				{
					string cdid = e.Item.Cells[1].Text;
					string type = "cd";
					string title = e.Item.Cells[2].Text;
					string company = e.Item.Cells[7].Text;
					bool worked = this.AddItemToCart(cdid, type, title, company);
					if (worked) 
					{
						Label8.Text = "CD added to cart";
						Label8.Visible = true;
					}
					else 
					{
						Label8.Text = "Transaction Failed";
						Label8.Visible = true;
					}
					
				}
			}
			else 
			{
				Label8.Text = "You must log in to add items to your cart.";
				Label8.Visible = true;
			}

		}

		private void BookResults_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			if (Session["CustomerID"] != null) //cannot add things to cart if you're not logged in
			{
			
				if (e.CommandName == "BAddToCart") 
				{
					string isbn = e.Item.Cells[1].Text;
					string type = "book";
					string title = e.Item.Cells[2].Text;
					string company = e.Item.Cells[7].Text;
					bool worked = this.AddItemToCart(isbn, type, title, company);
					if (worked) 
					{
						Label8.Text = "Book added to cart";
						Label8.Visible = true;
					}
					else 
					{
						Label8.Text = "Transaction Failed";
						Label8.Visible = true;
					}
				}
			}
			else 
			{
				Label8.Text = "You must log in to add items to your cart.";
				Label8.Visible = true;
			}
		
		}

		private void Bookpicks_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			if (Session["CustomerID"] != null) //cannot add things to cart if you're not logged in
			{
				if (e.CommandName == "BpickAddToCart") 
				{
					string isbn = e.Item.Cells[3].Text;
					string type = "book";
					string title = e.Item.Cells[1].Text;
					bool worked = this.AddItemToCart(isbn, type, title,"444h");
					if (worked) 
					{
						Label8.Text = "Book added to cart";
						Label8.Visible = true;
					}
					else 
					{
						Label8.Text = "Transaction Failed";
						Label8.Visible = true;
					}
				}
			}
			else 
			{
				Label8.Text = "You must log in to add items to your cart.";
				Label8.Visible = true;
			}

		}

		private void CDpicks_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			if (Session["CustomerID"] != null) //cannot add things to cart if you're not logged in
			{
				if (e.CommandName == "CDpAddToCart") 
				{
					string cdid = e.Item.Cells[4].Text;
					string type = "cd";
					string title = e.Item.Cells[1].Text;
					bool worked = this.AddItemToCart(cdid, type, title,"444h");
					if (worked) 
					{
						Label8.Text = "CD Added to Cart";
						Label8.Visible = true;
					}
					else 
					{
						Label8.Text = "Transaction Failed";
						Label8.Visible = true;
					}
				}
			}
			else 
			{
				Label8.Text = "You must log in to add items to your cart.";
				Label8.Visible = true;
			}
		}


		private bool AddItemToCart(string itemID, string itemType, string title, string company)
		{
			string strSql = "";
			//System.Int16.Parse(itemID);
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection
			// Execute query -- Here you could make 'strSql' any query you want
			string name = Session["CustomerID"] as String; //probably don't need to do this. Did for debugging

			string strSQL = "SELECT Qty FROM djwatson_shipping.dbo.Cart WHERE CustomerID = '" +
				name + "' and ProductID = '" + itemID + "' and type = '" + itemType + "' and company = '" + company + "'";
			sqlCom = new SqlCommand(strSQL, sqlConn);
			sqlRdr = sqlCom.ExecuteReader();
			if (sqlRdr.HasRows)
			{
				/*
				DataGrid1.DataSource = sqlRdr;
				DataGrid1.DataBind();
				DataGrid1.Visible = true;
				testlabel2.DataBind();
*/
				int ord = sqlRdr.GetOrdinal("Qty");
				//testlabel2.Text = ord.ToString();
				sqlRdr.Read();
				int quantity = sqlRdr.GetSqlInt32(ord).Value + 1; //add the item to the quantity
				sqlConn.Close();
				SqlConnection sqlConn3 = new SqlConnection(strSqlString);
			
				strSql = "UPDATE djwatson_shipping.dbo.Cart SET Qty = '" + quantity + "' WHERE" +
					" CustomerID = '" + name + "' and ProductID = '" + itemID + "' and type = '" + itemType + "'and company = '" + company + "'";
				sqlConn3.Open();
				sqlCom = new SqlCommand(strSql, sqlConn3);	
				
				int worked = sqlCom.ExecuteNonQuery();
				sqlConn3.Close(); 
				if (worked > 0 ) 
				{
					return true;
				}
				else 
				{
					return false;
				}
				
			}
			
			else
			{	sqlConn2 = new SqlConnection(strSqlString);
				sqlConn2.Open();
				strSql = "INSERT INTO djwatson_shipping.dbo.Cart(CustomerID, ProductID, type, Qty, name,company)" +
					" VALUES('" + name + "', '" + itemID + "', '" + itemType + "', " + "'1', '" + title + "', '" + company + "')";
						
				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn2);	
				// Execute the command
				int worked = sqlCom.ExecuteNonQuery();
				sqlConn2.Close();
				if (worked > 0) 
				{
					return true;
				}
				else
				{
					return false;
				}
				
			}
		}

		private void CreateModifyAccount_Click(object sender, System.EventArgs e)
		{
			if (Session["CustomerID"] != null) //we are logged out, going to create an account
			{
				Session.Add("AccountPageType", "creation"); 
				
			}
			else //we are logged in, trying to update our account
			{
				Session.Add("AccountPageType", "modification");
			}
		
		}

		private void CDpicks_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}
	
	}

}

