using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace phase2_management
{
	/// <summary>
	/// Summary description for salesamounts.
	/// </summary>
	public class salesamounts : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label LabelMusic;
		protected System.Web.UI.WebControls.Label LabelBooks;
		protected System.Web.UI.WebControls.DataGrid DataGridBooks;
		protected System.Web.UI.WebControls.DataGrid DataGridMusic;
		protected System.Web.UI.WebControls.Label LabelSalesStats;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			getBookData();
			getMusicData();
		}

		private void getBookData()
		{
			string query =	"select ISBN, " +
							"       title, " +
							"       author " +
							"from Books";

			DataSet dataSet = SQL.Query( query, "jblat_inventory" );

			this.DataGridBooks.DataSource = dataSet;
			DataTable dataTable = dataSet.Tables[0];
            
			getItemData( dataTable, "book" );

			this.DataGridBooks.DataBind();
		}
		
		private void getMusicData()
		{
			string query =	"select CDID, " +
							"       albumname, " +
							"       artists " +
							"from Music";

			DataSet dataSet = SQL.Query( query, "jblat_inventory" );

			this.DataGridMusic.DataSource = dataSet;
			DataTable dataTable = dataSet.Tables[0];

			getItemData( dataTable, "cd" );

			this.DataGridMusic.DataBind();
		}

		private void getItemData( DataTable dataTable, string prefix )
		{
			DataColumn dataColumnCount = new DataColumn( "count", typeof(int) );
			DataColumn dataColumnIncome = new DataColumn( "income", typeof(decimal) );

			string column = prefix.Equals( "book" ) ? "ISBN" : "CDID";

			dataTable.Columns.Add( dataColumnCount );
			dataTable.Columns.Add( dataColumnIncome );

			SqlConnection connection = new SqlConnection( SQL.ConnectString + SQL.DefaultDatabase );
			connection.Open();

			foreach( DataRow row in dataTable.Rows )
			{
				string query =	"select sum(Qty) as 'Total sold', sum(ammount) as 'Total sales' " +
								"from (select Qty, Qty * UnitPricePaid as ammount " +
								"      from Items " +
								"      where ProductID = '" + prefix + " " + ((long)row[column]).ToString() + "') as totals ";

				SqlCommand command = new SqlCommand( query, connection );
				SqlDataReader dataReader = command.ExecuteReader();

				if( dataReader.HasRows )
				{
					dataReader.Read();

					int ordinalCount = dataReader.GetOrdinal( "Total sold" );
					int ordinalIncome = dataReader.GetOrdinal( "Total sales" );

					if( dataReader.IsDBNull( ordinalCount ) )
						row["count"] = 0;
					else
						row["count"] = dataReader.GetInt32( ordinalCount );

					if( dataReader.IsDBNull( ordinalIncome ) )
						row["income"] = 0;
					else
						row["income"] = dataReader.GetDecimal( ordinalIncome );
				}

				dataReader.Close();
			}

			connection.Close();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
