using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace phase2_management
{
	/// <summary>
	/// Summary description for warehouseinfo.
	/// </summary>
	public class warehouseinfo : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGridWarehouseInfo;
		protected System.Web.UI.WebControls.Label LabelWarehouseInfo;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			getWarehouseData();
		}

		private void getWarehouseData()
		{
			string query =	"select *, cast(warehousid as varchar) as 'warehouseid'" +
							"from Warehouses";

			DataSet dataSet = new DataSet();

			DataTable dataTable = SQL.QueryTable( query, "jblat_inventory" );
			dataTable.TableName = "Warehouses";
			dataSet.Tables.Add( dataTable  );

			query =	"select * " +
					"from vendors";

			dataTable = SQL.QueryTable( query, "djwatson_shipping" );
			dataTable.TableName = "Vendors";
			dataSet.Tables.Add( dataTable );

			DataRelation dataRelation = new DataRelation( "WarehouseVendors", dataSet.Tables["Warehouses"].Columns["warehouseid"], dataSet.Tables["Vendors"].Columns["warehouse"], true );
			dataSet.Relations.Add( dataRelation );

			query =	"select *, cast(warehouse as varchar) as 'warehouseid' " +
					"from Bookstock ";

			dataTable = SQL.QueryTable( query, "jblat_inventory" );
			dataTable.TableName = "BookStock";
			dataSet.Tables.Add( dataTable );

			dataRelation = new DataRelation( "WarehouseBooks", dataSet.Tables["Warehouses"].Columns["warehouseid"], dataSet.Tables["BookStock"].Columns["warehouseid"], true );
			dataSet.Relations.Add( dataRelation );

			query =	"select *, cast(warehouse as varchar) as 'warehouseid' " +
					"from Musicstock ";

			dataTable = SQL.QueryTable( query, "jblat_inventory" );
			dataTable.TableName = "MusicStock";
			dataSet.Tables.Add( dataTable );

			dataRelation = new DataRelation( "WarehouseMusic", dataSet.Tables["Warehouses"].Columns["warehouseid"], dataSet.Tables["MusicStock"].Columns["warehouseid"], true );
			dataSet.Relations.Add( dataRelation);

			this.DataGridWarehouseInfo.DataSource = dataSet;
			this.DataGridWarehouseInfo.DataMember = "Warehouses";

			getNumProductsShipped( dataSet.Tables["Warehouses"] );

			this.DataGridWarehouseInfo.DataBind();
		}

		private void getNumProductsShipped( DataTable dataTable )
		{
			DataColumn dataColumnTimesUsed = new DataColumn( "numproducts", typeof(int) );

			dataTable.Columns.Add( dataColumnTimesUsed );

			SqlConnection connection = new SqlConnection( SQL.ConnectString + "djwatson_shipping" );
			connection.Open();

			foreach( DataRow row in dataTable.Rows )
			{
				string warehouseid = row["warehouseid"].ToString();

				string query =	"select sum(numitems) as 'numproducts' " +
								"from packages " +
								"where warehouse = '" + warehouseid + "'";

				SqlCommand command = new SqlCommand( query, connection );
				SqlDataReader dataReader = command.ExecuteReader();

				if( dataReader.HasRows )
				{
					dataReader.Read();

					int ordinalNumProducts = dataReader.GetOrdinal( "numproducts" );

					if( dataReader.IsDBNull( ordinalNumProducts ) )
						row["numproducts"] = 0;
					else
						row["numproducts"] = dataReader.GetInt32( ordinalNumProducts );
				}

				dataReader.Close();
			}

			connection.Close();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
