using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;	// This is the library with the SQL types we're using below

namespace aldenk
{
	/// <summary>
	/// Summary description for Inventory.
	/// </summary>
	public class Inventory : System.Web.UI.Page
	{
		protected const int AUTHOR_ARTIST_TITLE = 0;
		protected const int KEYWORD = 1;
		protected const int STOCKED_MIN = 2;
		protected const int STOCKED_AT_X_WAREHOUSES = 3;
		protected const int FIND_AT_WAREHOUSE = 4;

//		private SqlConnection sqlConn;
//		private SqlCommand sqlCom;
		protected System.Web.UI.WebControls.Button btn_Search;
		protected System.Web.UI.WebControls.TextBox txt_QueryParam1;
		protected System.Data.SqlClient.SqlConnection sqlConn;
		protected System.Data.SqlClient.SqlCommand sqlCmd;
		protected System.Web.UI.WebControls.DataGrid dg_ResultsTable;
		private SqlDataReader sqlRdr;
		protected System.Web.UI.WebControls.Label lbl_Error;
		protected System.Web.UI.WebControls.DropDownList cb_SearchChoice;
		protected System.Web.UI.WebControls.DataList dl_Results_Music;
		protected System.Web.UI.WebControls.DataList dl_Results_Books;
		protected System.Web.UI.WebControls.DataList dl_Results;
		protected System.Web.UI.WebControls.Label lbl_NoResults;
		protected System.Web.UI.WebControls.DataList dl_Warehouses;
		protected System.Web.UI.WebControls.LinkButton lbtn_Browse_All;
		protected System.Web.UI.WebControls.LinkButton lbtn_Browse_Books;
		protected System.Web.UI.WebControls.LinkButton lbtn_Browse_Music;
		protected System.Web.UI.WebControls.LinkButton lbtn_Browse_NoStock;
		protected System.Web.UI.WebControls.Panel pnl_Admin;
		protected System.Web.UI.WebControls.DataGrid dg_Admin;
		protected System.Web.UI.WebControls.Label lbl_AdminGrid;
		protected System.Web.UI.WebControls.Label lbl_AdminError;
		protected System.Web.UI.WebControls.LinkButton lbtn_Logout;

		protected bool isAdmin;
		protected string browseSubset;
		protected System.Web.UI.WebControls.LinkButton lbtn_Login;
		protected System.Web.UI.WebControls.LinkButton lbtn_ViewCart;
		protected System.Web.UI.WebControls.LinkButton shipMethods;
		protected System.Web.UI.WebControls.LinkButton tracking;
		protected System.Web.UI.WebControls.LinkButton updateInfo;
		protected string queryConnectStr = "server=iisqlsrv.cs.washington.edu; uid=aldenk; pwd=drmonroe2337; database=aldenk_inventory";
		protected System.Web.UI.WebControls.LinkButton lbtn_Checkout;
		protected string defaultCompany = "444j";
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!User.Identity.IsAuthenticated) 
			{
				lbtn_Logout.Visible=false;
				lbtn_Login.Visible=true;
				lbtn_ViewCart.Visible=false;
				lbtn_Checkout.Visible=false;
				tracking.Visible=false;
				updateInfo.Visible=false;
			} 
			else
			{
				lbtn_Logout.Visible=true;
				lbtn_Login.Visible=false;
				lbtn_ViewCart.Visible=true;
				lbtn_Checkout.Visible=true;
				tracking.Visible=true;
				updateInfo.Visible=true;
			}
			isAdmin = Convert.ToBoolean(this.Session["Admin"]);
			if (isAdmin)
			{
				lbtn_Browse_NoStock.Visible = true;
				pnl_Admin.Visible = true;
				shipMethods.Visible = true;
			}
			else
			{
				lbtn_Browse_NoStock.Visible = false;
				pnl_Admin.Visible = false;
				shipMethods.Visible = false;
			}

			System.Collections.Specialized.NameValueCollection nv = Request.QueryString;
			string param;
			param = nv.Get("b");
			browseSubset = param;
			if (browseSubset == "No_Stock")
			{
				BrowseNoStock();
				pnl_Admin.Visible = false;
			}
			else if (browseSubset == "All")
			{
				BrowseAll();
			}
			else if (browseSubset == "Books")
			{
				BrowseBooks();
			}
			else if (browseSubset == "Music")
			{
				BrowseMusic();
			}
			else
			{
				if (this.IsPostBack)
				{
					DoSearch();
				}
				else
				{
					pnl_Admin.Visible = false;
				}
				SetFocus(txt_QueryParam1);
			}
		}

		private void SetFocus(Control ctrl)
		{
			// Define the JavaScript function for the specified control.
			string focusScript = "<script type='text/javascript'>" +
				"if (document && document.getElementById){ var elem = document.getElementById('" + ctrl.ClientID +	"');" +
				"elem.focus();" +
				//"if (elem.setSelectionRange) {elem.setSelectionRange(elem.value.length,elem.value.length);}" +
				//"else if (elem.createTextRange) {var range = elem.createTextRange(); range.moveStart('character', elem.value.length); range.moveEnd('character', 0);}" +
				//"else {" + 
				"elem.select();}</script>";

			// Add the JavaScript code to the page.
			Page.RegisterStartupScript("FocusScript", focusScript);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.sqlConn = new System.Data.SqlClient.SqlConnection();
			this.sqlCmd = new System.Data.SqlClient.SqlCommand();
			this.lbtn_Browse_All.Click += new System.EventHandler(this.lbtn_Browse_All_Click);
			this.lbtn_Browse_Books.Click += new System.EventHandler(this.lbtn_Browse_Books_Click);
			this.lbtn_Browse_Music.Click += new System.EventHandler(this.lbtn_Browse_Music_Click);
			this.lbtn_Browse_NoStock.Click += new System.EventHandler(this.lbtn_Browse_NoStock_Click);
			this.btn_Search.Click += new System.EventHandler(this.btn_Search_Click);
			this.lbtn_Logout.Click += new System.EventHandler(this.lbtn_Logout_Click);
			this.shipMethods.Click += new System.EventHandler(this.shipMethods_Click);
			this.tracking.Click += new System.EventHandler(this.tracking_Click);
			this.lbtn_Login.Click += new System.EventHandler(this.lbtn_Login_Click);
			this.updateInfo.Click += new System.EventHandler(this.updateInfo_Click);
			this.lbtn_ViewCart.Click += new System.EventHandler(this.lbtn_ViewCart_Click);
			// 
			// sqlCmd
			// 
			this.sqlCmd.Connection = this.sqlConn;
			this.lbtn_Checkout.Click += new System.EventHandler(this.lbtn_Checkout_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btn_Search_Click(object sender, System.EventArgs e)
		{
			DoSearch();
		}

		private void DoSearch()
		{
			pnl_Admin.Visible = false;		// don't show relevant admin data here

			// make space default to OR, translate underscores to spaces, and make quotes proper
			string param = txt_QueryParam1.Text.Trim().Replace(" ","%").Replace("_"," ").Replace("\'","\'\'");
			bool paramIsInt = false;
			try {Convert.ToInt32(param); paramIsInt = true;}
			catch (System.FormatException e1){paramIsInt = false;}

			string sqlSelect = "*";
			string sqlFrom = "BookMusic";
			string sqlWhere = "1=1";
			#region < queryBuilder >
				switch (cb_SearchChoice.SelectedIndex)
				{
					case AUTHOR_ARTIST_TITLE:	// value = "Author/Artist/Title search"
						sqlSelect = "*";
						sqlFrom = "BookMusic";
						sqlWhere = "ISBN_ASIN = \'" + param + "\' OR company LIKE \'%" + param + "%\' OR artists LIKE \'%" + param + "%\' OR title LIKE \'%" + param + "%\'";
						break;
					case KEYWORD:	// value = "Keywords"
						sqlSelect = "DISTINCT BookMusic.*";
						sqlFrom = "BookMusic, Keywords";
						sqlWhere = "BookMusic.ISBN_ASIN = Keywords.ISBN_ASIN AND BookMusic.company = Keywords.company AND (Keywords.ISBN_ASIN = \'" + param + "\' OR Keywords.company LIKE \'%" + param + "%\' OR word LIKE \'%" + param + "%\')";
						break;
					case STOCKED_MIN:	// value = "Admin: Stocked min"
						sqlSelect = "BookMusic.*";
						sqlFrom = "BookMusic, Availability";
						if (paramIsInt)
							sqlWhere = "BookMusic.ISBN_ASIN = Availability.ISBN_ASIN " +
								"GROUP BY BookMusic.ISBN_ASIN, BookMusic.company, BookMusic.title, BookMusic.artists, BookMusic.year, BookMusic.publisher, BookMusic.weight " +
								"HAVING sum(quantity) > " + param;
						else
							sqlWhere = "1=0";	// return no results
						break;
					case STOCKED_AT_X_WAREHOUSES:	// value = "Admin: Stocked at x warehouses"
						sqlSelect = "BookMusic.*";
						sqlFrom = "BookMusic";
						if (paramIsInt)
							sqlWhere = param + " < (SELECT Count(*) FROM Availability " +
								"WHERE Availability.ISBN_ASIN = BookMusic.ISBN_ASIN AND Availability.company = BookMusic.company AND Availability.quantity > 0 " + 
								"GROUP BY BookMusic.ISBN_ASIN, BookMusic.company)";
						else
							sqlWhere = "1=0";	// return no results
						break;
					case FIND_AT_WAREHOUSE:	// value = "Admin: Find warehouse with product"
						sqlSelect = "Warehouses.ID, streetNum, city, state, zip, quantity";
						sqlFrom = "Availability, Warehouses";
						sqlWhere = "Availability.ISBN_ASIN = \'" + param + "\' AND Availability.company = \'" + this.defaultCompany + "\' AND quantity > 0 AND Availability.ID = Warehouses.ID " +
							"";//"ORDER BY state, city";
						break;
				}
			#endregion
			if (cb_SearchChoice.SelectedIndex == FIND_AT_WAREHOUSE)
			{
				DoQuery(sqlSelect, sqlFrom, sqlWhere, dl_Warehouses);
			}
			else
			{
				DoQuery(sqlSelect, sqlFrom, sqlWhere, dl_Results);
			}
		}

		public void DoQuery(string sqlSelect, string sqlFrom, string sqlWhere)
		{
			DoQuery(sqlSelect, sqlFrom, sqlWhere, dl_Results);
		}
		public void DoQuery(string sqlSelect, string sqlFrom, string sqlWhere, System.Web.UI.WebControls.DataList list)
		{
			string sqlStr;
			dl_Results.Visible = false;
			dl_Warehouses.Visible = false;


			#region < populate >
				try
				{
					// Start a new connection to the database specified in strSqlString
					//sqlConn = new SqlConnection( queryConnectStr );
					sqlConn.ConnectionString = queryConnectStr;
					sqlConn.Open();	// open the connection
					sqlStr = "SELECT " + sqlSelect + " FROM " + sqlFrom + " WHERE " + sqlWhere;
					sqlCmd = new SqlCommand(sqlStr, sqlConn);
					sqlRdr = sqlCmd.ExecuteReader();

					if (sqlRdr.HasRows) 
					{
						lbl_NoResults.Visible = false;
						dl_Warehouses.Visible = false;
						list.DataSource = sqlRdr;
						list.DataBind();
						list.Visible = true;
					}
					else
					{
						lbl_NoResults.Text = "The search has returned no results.";
						lbl_NoResults.Visible = true;
					}
				} 
				catch (Exception e1)
				{
					lbl_Error.Text = "Problem connecting to database.  Please try again later.";
				//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
				}
				finally
				{
					// ensure close connection
					sqlConn.Close();
				}
				if (isAdmin)
				{
					string param;
					string sqlTitle = "";
					bool fill = true;
					//subCondition = "WHERE prodId IN ";
					if (browseSubset == "All")
					{
						lbl_AdminGrid.Text = "Books and Music";
						sqlFrom = "BookMusic";
						sqlSelect = sqlFrom + ".title";
						sqlTitle = sqlFrom + ".ISBN_ASIN";
						//subCondition += "(SELECT ISBN_ASIN FROM BookMusic)";
					}
					else if (browseSubset == "Books")
					{
						lbl_AdminGrid.Text = "Books";
						sqlFrom = "Books";
						sqlSelect = sqlFrom + ".title";
						sqlTitle = sqlFrom + ".ISBN";
						//subCondition += "(SELECT ISBN FROM Books)";
					}
					else if (browseSubset == "Music")
					{
						lbl_AdminGrid.Text = "Music";
						sqlFrom = "Music";
						sqlSelect = sqlFrom + ".name";
						sqlTitle = sqlFrom + ".ASIN";
						//subCondition += "(SELECT ASIN FROM Music)";
					}
					else
					{
						lbl_AdminGrid.Text = "";
						fill = false;
					}
					pnl_Admin.Visible = fill;
					if (fill)
					{
						try
						{
							// Start a new connection to the database specified in strSqlString
							//sqlConn = new SqlConnection( queryConnectStr );
							sqlConn.ConnectionString = queryConnectStr;
							sqlConn.Open();	// open the connection
							sqlStr = "SELECT " + sqlSelect + " AS Title, prodId AS Product, company AS Company, Sum(quantity) AS \'Num Sold\', Sum(quantity * singleprice) AS \'Revenue (US$)\' FROM " + sqlFrom + ", vaeniel_billing.dbo.PurchasedItems AS bought WHERE bought.prodID = " + sqlTitle + " GROUP BY prodID, company, " + sqlSelect;
							sqlCmd = new SqlCommand(sqlStr, sqlConn);
							sqlRdr = sqlCmd.ExecuteReader();

							if (sqlRdr.HasRows) 
							{
								dg_Admin.DataSource = sqlRdr;
								dg_Admin.DataBind();
								dg_Admin.Visible = true;
								lbl_AdminError.Text = "";
							}
							else
							{
								dg_Admin.Visible = false;
								lbl_AdminError.Text = "";
							}
						} 
						catch (Exception e1)
						{
							lbl_AdminError.Text = "Problem connecting to admin database.  Please try again later.";
							//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
						}
						finally
						{
							// ensure close connection
							sqlConn.Close();
						}
					}
					else
						dg_Admin.Visible = false;
				}	// </ if(isAdmin) >
			#endregion </ populate >
		}

		private void lbtn_Browse_All_Click(object sender, System.EventArgs e)
		{	BrowseAll();	}

		private void lbtn_Browse_Books_Click(object sender, System.EventArgs e)
		{	BrowseBooks();	}

		private void lbtn_Browse_Music_Click(object sender, System.EventArgs e)
		{	BrowseMusic();	}

		private void lbtn_Browse_NoStock_Click(object sender, System.EventArgs e)
		{	BrowseNoStock();	}

		public void BrowseAll()
		{
			browseSubset = "All";
			DoQuery("*", "BookMusic", "1=1", dl_Results);
		}
		public void BrowseBooks()
		{
			browseSubset = "Books";
			DoQuery("ISBN AS ISBN_ASIN, title, authors AS artists, year, publisher, company", "Books", "1=1", dl_Results);
		}
		public void BrowseMusic()
		{
			browseSubset = "Music";
			DoQuery("ASIN AS ISBN_ASIN, name AS title, artists, year, label AS publisher, company", "Music", "1=1", dl_Results);
		}
		public void BrowseNoStock()
		{
			browseSubset = "No_Stock";
			DoQuery("BookMusic.*", "BookMusic",
				"NOT (EXISTS(SELECT * FROM Availability WHERE BookMusic.ISBN_ASIN = Availability.ISBN_ASIN AND BookMusic.company = Availability.company " +
				"AND Availability.quantity > 0))", dl_Results);
		}

		private void lbtn_Logout_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("Logout.aspx");
		}

		private void lbtn_Login_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("Login.aspx");
		}

		private void lbtn_ViewCart_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("ViewCart.aspx");
		}

		private void shipMethods_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("Shipping_methods.aspx");
		}

		private void tracking_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("Tracking.aspx");
		}

		private void updateInfo_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("UpdateInfo.aspx");
		}

		private void lbtn_Checkout_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("Checkout.aspx");
		}
	}
}
