namespace aldenk
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Data.SqlClient;

	/// <summary>
	///		Summary description for VerboseBook.
	/// </summary>
	public class VerboseBook : System.Web.UI.UserControl
	{
		protected System.Data.SqlClient.SqlCommand sqlCmd;
		protected System.Data.SqlClient.SqlConnection sqlConn;
		protected System.Data.SqlClient.SqlDataReader sqlRdr;
		protected System.Web.UI.WebControls.Label lbl_Year;
		protected System.Web.UI.WebControls.Panel pnl_All;
		protected System.Web.UI.WebControls.Label lbl_Error;
		protected System.Web.UI.WebControls.Label lbl_Title;
		protected System.Web.UI.WebControls.Label lbl_Authors;
		protected System.Web.UI.WebControls.Label lbl_Categories;
		protected System.Web.UI.WebControls.Label lbl_Keywords;
		protected System.Web.UI.WebControls.Label lbl_Price;
		protected System.Web.UI.WebControls.DataGrid dg_Availability;

		protected string queryConnectStr = "server=iisqlsrv.cs.washington.edu; uid=aldenk; pwd=drmonroe2337; database=aldenk_inventory";

		//		private SqlConnection sqlConn;
		//		private SqlCommand sqlCom;

		protected string isbn;

		public string ISBN
		{
			get
			{	return this.isbn;	}
			set
			{	this.isbn = value;	}
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			System.Collections.Specialized.NameValueCollection nv = Request.QueryString;
			
			this.isbn = nv.Get("ISBN");

			string strSql;
			// Put user code to initialize the page here
			#region < populate >
				#region < get what="book basics" >
					try 
					{
						// Start a new connection to the database specified in strSqlString
						//sqlConn = new SqlConnection( queryConnectStr );
						sqlConn.ConnectionString = queryConnectStr;
						sqlConn.Open();	// open the connection

						strSql = "SELECT authors, title, year FROM Books WHERE ISBN=\'" + this.isbn + "\'";
						
						// The command needs to know the query and the connection
						sqlCmd = new SqlCommand(strSql, sqlConn);	
						// Execute the command
						sqlRdr = sqlCmd.ExecuteReader();

						// Get the answer from the reader and write it to the label.
						if (sqlRdr.Read())
						{
							lbl_Authors.Text = sqlRdr["authors"].ToString();
							lbl_Title.Text = sqlRdr["title"].ToString();
							lbl_Year.Text = "Published in: " + sqlRdr["year"].ToString();
						}
						else
						{
							pnl_All.Visible = false;
							lbl_Error.Text = "Unable find book.  Please check the id or try again later.";
						}
					}
					catch (Exception e1)
					{
						pnl_All.Visible = false;
						lbl_Error.Text = "Unable find book.  Please check the id or try again later.";
					}
					finally
					{
						// ensure close connection
						sqlConn.Close();
					}
				#endregion
				#region < get what="genre" >
					try 
					{
						// Start a new connection to the database specified in strSqlString
						//sqlConn = new SqlConnection( queryConnectStr );
						sqlConn.ConnectionString = queryConnectStr;
						sqlConn.Open();	// open the connection

						strSql = "SELECT DISTINCT type FROM Categories WHERE ISBN=\'" + this.isbn + "\'";
						
						// The command needs to know the query and the connection
						sqlCmd = new SqlCommand(strSql, sqlConn);	
						// Execute the command
						sqlRdr = sqlCmd.ExecuteReader();


						// Get the answer from the reader and write it to the label.
						lbl_Categories.Text = "";
						while (sqlRdr.Read())
						{
							if (lbl_Categories.Text != "") 
								lbl_Categories.Text += ", ";
							else
								lbl_Categories.Text = "Genres: ";
							lbl_Categories.Text = lbl_Categories.Text + sqlRdr["type"];
						}
					}
					catch (Exception e1)
					{
						lbl_Error.Text = "Unable find book.  Please check the id or try again later.";
						//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
					}
					finally
					{
						// ensure close connection
						sqlConn.Close();
					}
				#endregion
				#region < get what="price" >
					try 
					{
						// Start a new connection to the database specified in strSqlString
						//sqlConn = new SqlConnection( queryConnectStr );
						sqlConn.ConnectionString = queryConnectStr;
						sqlConn.Open();	// open the connection

						strSql = "SELECT * FROM Prices WHERE ISBN_ASIN=\'" + this.isbn + "\'";
						
						// The command needs to know the query and the connection
						sqlCmd = new SqlCommand(strSql, sqlConn);	
						// Execute the command
						sqlRdr = sqlCmd.ExecuteReader();


						// Get the answer from the reader and write it to the label.
						if (sqlRdr.Read())
						{
							double price, saleprice;
							price = Convert.ToDouble(sqlRdr["base"]);
							saleprice = Convert.ToDouble(sqlRdr["now"]);
							if (price == saleprice)
							{
								lbl_Price.Text = "Price: " + price.ToString();
							}
							else
							{
								lbl_Price.Text = "Price: <strike>" + price.ToString() + "</strike> On Sale!  " + saleprice.ToString();
							}
						}
					}
					catch (Exception e1)
					{
						lbl_Price.Text = "Pricing information is currently unavailable.  We are sorry for the inconvenience.  Please try again later.";
						//lbl_Error.Text = "Unable find book's price.  Please check the id or try again later.";
						//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
					}
					//finally
					{
						// ensure close connection
						sqlConn.Close();
					}
				#endregion
				#region < get what="keywords" >
					try 
					{
						// Start a new connection to the database specified in strSqlString
						//sqlConn = new SqlConnection( queryConnectStr );
						sqlConn.ConnectionString = queryConnectStr;
						sqlConn.Open();	// open the connection

						strSql = "SELECT DISTINCT * FROM Keywords WHERE ISBN_ASIN=\'" + this.isbn + "\'";
						
						// The command needs to know the query and the connection
						sqlCmd = new SqlCommand(strSql, sqlConn);	
						// Execute the command
						sqlRdr = sqlCmd.ExecuteReader();


						// Get the answer from the reader and write it to the label.
						while (sqlRdr.Read())
						{
							if (lbl_Keywords.Text != "") 
								lbl_Keywords.Text += ", ";
							else
								lbl_Keywords.Text = "Keywords: ";
							lbl_Keywords.Text = lbl_Keywords.Text + sqlRdr["word"];
						}
					}
					catch (Exception e1)
					{
						lbl_Error.Text = "Unable find book's keywords.  Please check the id or try again later.";
						//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
					}
					finally
					{
						// ensure close connection
						sqlConn.Close();
					}
				#endregion
				#region < get what="availability" >
					try 
					{
						// Start a new connection to the database specified in strSqlString
						//sqlConn = new SqlConnection( queryConnectStr );
						sqlConn.ConnectionString = queryConnectStr;
						sqlConn.Open();	// open the connection


						// Execute query -- Here you could make 'strSql' any query you want

						strSql = "SELECT Warehouses.ID, quantity, streetNum, city, state, zip, phone, manager FROM Warehouses, Availability " +
								"WHERE ISBN_ASIN=\'" + this.isbn + "\' AND Availability.ID = Warehouses.ID " + 
								"ORDER BY state, city";
						
						// The command needs to know the query and the connection
						sqlCmd = new SqlCommand(strSql, sqlConn);
						// Execute the command
						sqlRdr = sqlCmd.ExecuteReader();

						// Get the answer from the reader and write it to the label.
						if (sqlRdr.HasRows) 
						{
							dg_Availability.DataSource = sqlRdr;
							dg_Availability.DataBind();
						}
					}
					catch (Exception e1)
					{
						//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
					}
					finally
					{
						// ensure close connection
						sqlConn.Close();
					}
				#endregion
			#endregion </ populate >
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.sqlConn = new System.Data.SqlClient.SqlConnection();
			this.sqlCmd = new System.Data.SqlClient.SqlCommand();
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
