namespace aldenk
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Data.SqlClient;	// This is the library with the SQL types we're using below

	/// <summary>
	///		Summary description for VerboseWarehouse.
	/// </summary>
	public class VerboseWarehouse : System.Web.UI.UserControl
	{
		protected System.Data.SqlClient.SqlCommand sqlCmd;
		protected System.Web.UI.WebControls.Label lbl_Error;
		protected System.Web.UI.WebControls.DataGrid dg_Tracks;
		protected System.Web.UI.WebControls.Label lbl_Add1;
		protected System.Web.UI.WebControls.Label lbl_Fax;
		protected System.Web.UI.WebControls.Label lbl_Phone;
		protected System.Web.UI.WebControls.Label lbl_Manager;
		protected System.Web.UI.WebControls.Label lbl_Id;
		protected System.Web.UI.WebControls.Label lbl_Add2;
		protected System.Web.UI.WebControls.Label lbl_Add3;
		protected System.Data.SqlClient.SqlConnection sqlConn;
		protected System.Data.SqlClient.SqlDataReader sqlRdr;

		protected bool isAdmin;
		protected string queryConnectStr = "server=iisqlsrv.cs.washington.edu; uid=aldenk; pwd=drmonroe2337; database=aldenk_inventory";
		protected System.Web.UI.WebControls.DataGrid dg_Vendors;
		protected System.Web.UI.WebControls.Label lbl_Vendors;
		protected System.Web.UI.WebControls.Panel pnl_Admin;
		protected System.Web.UI.WebControls.Label lbl_Stock;
		protected System.Web.UI.WebControls.DataGrid dg_Stock;
		protected System.Web.UI.WebControls.Label lbl_ShippedCount;
		protected string houseId;

		private void Page_Load(object sender, System.EventArgs e)
		{
			isAdmin = Convert.ToBoolean(this.Session["Admin"]);

			System.Collections.Specialized.NameValueCollection nv = Request.QueryString;
			
			this.houseId = nv.Get("ID");

			if (!isAdmin)
			{
				lbl_Error.Text = "You must be an administrator to view this page.";
				pnl_Admin.Visible = false;
			}
			else
			{
				pnl_Admin.Visible = true;
				Populate();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.sqlCmd = new System.Data.SqlClient.SqlCommand();
			this.sqlConn = new System.Data.SqlClient.SqlConnection();
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Populate()
		{
			string strSql = "";
			string parse;
			#region < get what="contact" >
				try
				{
					// Start a new connection to the database specified in strSqlString
					//sqlConn = new SqlConnection( queryConnectStr );
					sqlConn.ConnectionString = queryConnectStr;
					sqlConn.Open();	// open the connection

					strSql = "SELECT ID, streetNum, city, state, zip, manager, phone, fax FROM warehouses WHERE ID=\'" + this.houseId + "\'";
					
					// The command needs to know the query and the connection
					sqlCmd = new SqlCommand(strSql, sqlConn);	
					// Execute the command
					sqlRdr = sqlCmd.ExecuteReader();

					// Get the answer from the reader and write it to the label.
					if (sqlRdr.Read())
					{
						lbl_Id.Text = "<small>ID: " + sqlRdr["ID"].ToString() + "</small>";
						lbl_Manager.Text = "Manager: " + sqlRdr["manager"].ToString();
						parse = sqlRdr["phone"].ToString();
						if (parse != null && parse.Trim() != "")
							lbl_Phone.Text = "Phone: (" + parse.Substring(0, 3) + ") " + parse.Substring(4, 3) + "-" + parse.Substring(7);
						parse = sqlRdr["fax"].ToString();
						if (parse != null && parse.Trim() != "")
							lbl_Fax.Text = "Fax: (" + parse.Substring(0, 3) + ") " + parse.Substring(4, 3) + "-" + parse.Substring(7);
						lbl_Add1.Text = sqlRdr["streetNum"].ToString();
						lbl_Add2.Text = sqlRdr["city"].ToString() + " " + sqlRdr["state"].ToString().ToUpper() + ", " + sqlRdr["zip"];

					}
					else
					{
						pnl_Admin.Visible = false;
						lbl_Error.Text = "Unable find warehouse.  Please check the id or try again later.";
					}
				}
				catch (Exception e1)
				{
					pnl_Admin.Visible = false;
					lbl_Error.Text = "Unable find warehouse.  Please check the id or try again later.";
				}
				finally
				{
					// ensure close connection
					sqlConn.Close();
				}
			#endregion
			#region < get what="vendors" >
				try 
				{
					// Start a new connection to the database specified in strSqlString
					//sqlConn = new SqlConnection( queryConnectStr );
					sqlConn.ConnectionString = queryConnectStr;
					sqlConn.Open();	// open the connection


					// Execute query -- Here you could make 'strSql' any query you want

					strSql = "SELECT DISTINCT name, url, phone# AS phone FROM bksshipping.dbo.vendors WHERE CAST(warehouse AS CHAR(5))=\'" + this.houseId + "\'";
					
					// The command needs to know the query and the connection
					sqlCmd = new SqlCommand(strSql, sqlConn);	
					// Execute the command
					sqlRdr = sqlCmd.ExecuteReader();

					// Get the answer from the reader and write it to the label.
					if (sqlRdr.HasRows) 
					{
						lbl_Vendors.Text = "Vendors:";
						dg_Vendors.DataSource = sqlRdr;
						dg_Vendors.DataBind();
						dg_Vendors.Visible = true;
					}
					else
					{
						lbl_Vendors.Text = "No vendors";
						dg_Vendors.Visible = false;
					}
				}
				catch (Exception e1)
				{
					lbl_Vendors.Text = "Vendors currently unavailable.";
					dg_Vendors.Visible = false;
					//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
				}
				finally
				{
					// ensure close connection
					sqlConn.Close();
				}
			#endregion
			#region < get what="stock" >
				try 
				{
					// Start a new connection to the database specified in strSqlString
					//sqlConn = new SqlConnection( queryConnectStr );
					sqlConn.ConnectionString = queryConnectStr;
					sqlConn.Open();	// open the connection


					// Execute query -- Here you could make 'strSql' any query you want

					strSql = "SELECT BookMusic.title, BookMusic.company, BookMusic.ISBN_ASIN, Availability.quantity FROM BookMusic, Availability WHERE Availability.quantity > 0 " +
						"AND BookMusic.ISBN_ASIN = Availability.ISBN_ASIN AND BookMusic.company = Availability.company AND Availability.ID=\'" + this.houseId + "\'";
					
					// The command needs to know the query and the connection
					sqlCmd = new SqlCommand(strSql, sqlConn);	
					// Execute the command
					sqlRdr = sqlCmd.ExecuteReader();

					// Get the answer from the reader and write it to the label.
					
					if (sqlRdr.HasRows) 
					{
						lbl_Stock.Text = "Stock:";
						dg_Stock.DataSource = sqlRdr;
						dg_Stock.DataBind();
						dg_Stock.Visible = true;
					}
					else
					{
						lbl_Stock.Text = "No Items in stock.";
						dg_Stock.Visible = false;
					}
				}
				catch (Exception e1)
				{
					lbl_Stock.Text = "Stock currently unavailable.";
					dg_Stock.Visible = false;
					//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
				}
				finally
				{
					// ensure close connection
					sqlConn.Close();
				}
			#endregion
			#region < get what="shipped" >
				try 
				{
					// Start a new connection to the database specified in strSqlString
					//sqlConn = new SqlConnection( queryConnectStr );
					sqlConn.ConnectionString = queryConnectStr;
					sqlConn.Open();	// open the connection


					// Execute query -- Here you could make 'strSql' any query you want

					strSql = "SELECT SUM(#ofitems) AS count FROM bksshipping.dbo.packages AS pack WHERE pack.warehouse=\'" + this.houseId + "\'";
					
					// The command needs to know the query and the connection
					sqlCmd = new SqlCommand(strSql, sqlConn);	
					// Execute the command
					sqlRdr = sqlCmd.ExecuteReader();
					if (sqlRdr.Read())
					{
						lbl_ShippedCount.Text = "Number of items shipped: " + sqlRdr["count"].ToString();
					}
					else
					{
					}
				}
				catch (Exception e1)
				{
					lbl_ShippedCount.Text = "";
					//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
				}
				finally
				{
					// ensure close connection
					sqlConn.Close();
				}
			#endregion
		}
	}
}
