namespace aldenk
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Data.SqlClient;	// This is the library with the SQL types we're using below

	/// <summary>
	///		Summary description for ProductVerbose.
	/// </summary>
	public class ProductVerbose : System.Web.UI.UserControl
	{
		protected System.Data.SqlClient.SqlConnection sqlConn;
		protected System.Data.SqlClient.SqlCommand sqlCmd;
		protected System.Data.SqlClient.SqlDataReader sqlRdr;
		protected System.Web.UI.WebControls.Label lbl_Error;
		protected System.Web.UI.WebControls.Panel pnl_NotAdmin;
		protected System.Web.UI.WebControls.Label lbl_Keywords;
		protected System.Web.UI.WebControls.Label lbl_Genres;
		protected System.Web.UI.WebControls.Label lbl_Year;
		protected System.Web.UI.WebControls.Label lbl_Artist;
		protected System.Web.UI.WebControls.Label lbl_Album;
		protected System.Web.UI.WebControls.Label lbl_Weight;
		protected System.Web.UI.WebControls.Label lbl_Price;
		protected System.Web.UI.WebControls.DataGrid dg_Tracks;
		protected System.Web.UI.WebControls.Label lbl_Availability;
		protected System.Web.UI.WebControls.DataGrid dg_Availability;
		protected System.Web.UI.WebControls.Label lbl_PId;
		protected System.Web.UI.WebControls.Panel pnl_Admin;
		protected System.Web.UI.WebControls.Label lbl_NumSold;
		protected System.Web.UI.WebControls.Label lbl_PriceSold;
		
		protected bool isAdmin;
		protected string queryConnectStr = "server=iisqlsrv.cs.washington.edu; uid=aldenk; pwd=drmonroe2337; database=aldenk_inventory";
		protected string salesConnectStr = "server=iisqlsrv.cs.washington.edu; uid=aldenk; pwd=drmonroe2337; database=vaeniel_billing";

		//		private SqlConnection sqlConn;
		//		private SqlCommand sqlCom;

		protected string productId;
		public string ProductID
		{
			get
			{	return this.productId;	}
			set
			{	this.productId = value;	}
		}
		protected bool isBook;
		protected System.Web.UI.WebControls.LinkButton lbl_AddToCart;
	
		public string IsBook
		{
			get
			{	return this.isBook.ToString();	}
			set
			{	this.isBook = Convert.ToBoolean(value);	}
		}
		protected bool isMusic;
		public string IsMusic
		{
			get
			{	return this.isMusic.ToString();	}
			set
			{	this.isMusic = Convert.ToBoolean(value);	}
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			isAdmin = Convert.ToBoolean(this.Session["Admin"]);

			System.Collections.Specialized.NameValueCollection nv = Request.QueryString;
			this.isBook = this.isMusic = false;
			
			this.productId = nv.Get("ISBN_ASIN");

			string strSql = "";
			string what = "item";
//			if (this.isBook)
//				what = "book";
//			else if (this.isMusic)
//				what = "album";
//			else
//				what = "item";
			#region < populate >
				#region < get what="type" >
					try 
					{
						// Start a new connection to the database specified in strSqlString
						//sqlConn = new SqlConnection( queryConnectStr );
						sqlConn.ConnectionString = queryConnectStr;
						sqlConn.Open();	// open the connection

						strSql = "SELECT * FROM Books WHERE ISBN=\'" + this.productId + "\'";
						
						// The command needs to know the query and the connection
						sqlCmd = new SqlCommand(strSql, sqlConn);	
						// Execute the command
						sqlRdr = sqlCmd.ExecuteReader();

						// Get the answer from the reader and write it to the label.
						if (sqlRdr.Read()) 
						{
							this.isBook = true;
							what = "book";
						}
						sqlConn.Close();

						sqlConn.Open();	// open the connection

						strSql = "SELECT * FROM Music WHERE ASIN=\'" + this.productId + "\'";
						
						// The command needs to know the query and the connection
						sqlCmd = new SqlCommand(strSql, sqlConn);	
						// Execute the command
						sqlRdr = sqlCmd.ExecuteReader();

						// Get the answer from the reader and write it to the label.
						if (sqlRdr.Read()) 
						{
							this.isMusic = true;
							what = "album";
						}
					}
					catch (Exception e1)
					{
						pnl_NotAdmin.Visible = false;
						lbl_Error.Text = "Unable to find item.  Please check the id or try again later.";
					}
					finally
					{
						// ensure close connection
						sqlConn.Close();
					}
				#endregion
				#region < get what="art basics" >
					try
					{
						// Start a new connection to the database specified in strSqlString
						//sqlConn = new SqlConnection( queryConnectStr );
						sqlConn.ConnectionString = queryConnectStr;
						sqlConn.Open();	// open the connection

						if (this.isBook)
							strSql = "SELECT authors as artists, title, year, weight FROM Books WHERE ISBN=\'" + this.productId + "\'";
						else if (this.isMusic)
							strSql = "SELECT artists, name as title, year, weight FROM Music WHERE ASIN=\'" + this.productId + "\'";
						
						// The command needs to know the query and the connection
						sqlCmd = new SqlCommand(strSql, sqlConn);	
						// Execute the command
						sqlRdr = sqlCmd.ExecuteReader();

						// Get the answer from the reader and write it to the label.
						if (sqlRdr.Read())
						{
							lbl_Artist.Text = sqlRdr["artists"].ToString();
							lbl_Album.Text = sqlRdr["title"].ToString();
							if (this.isBook)
								lbl_Year.Text = "Publication year: " + sqlRdr["year"].ToString();
							else if (this.isMusic)
								lbl_Year.Text = "Release year: " + sqlRdr["year"].ToString();
							lbl_Weight.Text = "Shipping weight: " + sqlRdr["weight"].ToString() + " kg";
							if (this.isBook)
								lbl_PId.Text = "ISBN: " + this.productId;
							else
								lbl_PId.Text = "Product ID: " + this.productId;
						}
						else
						{
							pnl_NotAdmin.Visible = false;
							lbl_Error.Text = "Unable find " + what + ".  Please check the id or try again later.";
						}
					}
					catch (Exception e1)
					{
						pnl_NotAdmin.Visible = false;
						lbl_Error.Text = "Unable find " + what + ".  Please check the id or try again later.";
					}
					finally
					{
						// ensure close connection
						sqlConn.Close();
					}
				#endregion
				#region < get what="genre" >
					try 
					{
						// Start a new connection to the database specified in strSqlString
						//sqlConn = new SqlConnection( queryConnectStr );
						sqlConn.ConnectionString = queryConnectStr;
						sqlConn.Open();	// open the connection

						if (this.isBook)
							strSql = "SELECT type FROM Categories WHERE ISBN=\'" + this.productId + "\'";
						else if (this.isMusic)
							strSql = "SELECT type FROM Genres WHERE ASIN=\'" + this.productId + "\'";
						
						// The command needs to know the query and the connection
						sqlCmd = new SqlCommand(strSql, sqlConn);	
						// Execute the command
						sqlRdr = sqlCmd.ExecuteReader();


						// Get the answer from the reader and write it to the label.
						lbl_Genres.Text = "";
						while (sqlRdr.Read()) 
						{
							if (lbl_Genres.Text != "") 
								lbl_Genres.Text += ", ";
							else
							{
								if (this.isBook)
									lbl_Genres.Text = "Categories: ";
								else if (this.isMusic)
									lbl_Genres.Text = "Genres: ";
							}
							lbl_Genres.Text = lbl_Genres.Text + sqlRdr["type"];
						}
					}
					catch (Exception e1)
					{
						lbl_Error.Text = "Unable find " + what + ".  Please check the id or try again later.";
						//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
					}
					finally
					{
						// ensure close connection
						sqlConn.Close();
					}
				#endregion
				#region < get what="price" >
					try 
					{
						// Start a new connection to the database specified in strSqlString
						//sqlConn = new SqlConnection( queryConnectStr );
						sqlConn.ConnectionString = queryConnectStr;
						sqlConn.Open();	// open the connection

						strSql = "SELECT * FROM Prices WHERE ISBN_ASIN=\'" + this.productId + "\'";
						
						// The command needs to know the query and the connection
						sqlCmd = new SqlCommand(strSql, sqlConn);	
						// Execute the command
						sqlRdr = sqlCmd.ExecuteReader();


						// Get the answer from the reader and write it to the label.
						if (sqlRdr.Read())
						{
							double price, saleprice;
							price = Convert.ToDouble(sqlRdr["base"]);
							saleprice = Convert.ToDouble(sqlRdr["now"]);
							if (price == saleprice)
							{
								lbl_Price.Text = "Price: " + price.ToString();
							}
							else
							{
								lbl_Price.Text = "Price: <strike>" + price.ToString() + "</strike> On Sale!  " + saleprice.ToString();
							}
						}
					}
					catch (Exception e1)
					{
						lbl_Price.Text = "Pricing information is currently unavailable.  We are sorry for the inconvenience.  Please try again later.";
						//lbl_Error.Text = "Unable find book's price.  Please check the id or try again later.";
						//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
					}
					finally
					{
						// ensure close connection
						sqlConn.Close();
					}
				#endregion
				#region < get what="keywords" >
					try 
					{
						// Start a new connection to the database specified in strSqlString
						//sqlConn = new SqlConnection( queryConnectStr );
						sqlConn.ConnectionString = queryConnectStr;
						sqlConn.Open();	// open the connection

						strSql = "SELECT DISTINCT * FROM Keywords WHERE ISBN_ASIN=\'" + this.productId + "\'";
						
						// The command needs to know the query and the connection
						sqlCmd = new SqlCommand(strSql, sqlConn);	
						// Execute the command
						sqlRdr = sqlCmd.ExecuteReader();


						// Get the answer from the reader and write it to the label.
						while (sqlRdr.Read())
						{
							if (lbl_Keywords.Text != "") 
								lbl_Keywords.Text += ", ";
							else
								lbl_Keywords.Text = "Keywords: ";
							lbl_Keywords.Text = lbl_Keywords.Text + sqlRdr["word"];
						}
					}
					catch (Exception e1)
					{
						lbl_Error.Text = "Unable find album's keywords.  Please check the id or try again later.";
						//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
					}
					finally
					{
						// ensure close connection
						sqlConn.Close();
					}
				#endregion
				if (this.isMusic)
				{
				#region < get what="tracks" >
					try 
					{
						// Start a new connection to the database specified in strSqlString
						//sqlConn = new SqlConnection( queryConnectStr );
						sqlConn.ConnectionString = queryConnectStr;
						sqlConn.Open();	// open the connection


						// Execute query -- Here you could make 'strSql' any query you want

						strSql = "SELECT number, title, duration FROM Tracks WHERE ASIN=\'" + this.productId + "\'";
						
						// The command needs to know the query and the connection
						sqlCmd = new SqlCommand(strSql, sqlConn);	
						// Execute the command
						sqlRdr = sqlCmd.ExecuteReader();

						// Get the answer from the reader and write it to the label.
						if (sqlRdr.HasRows) 
						{
							dg_Tracks.DataSource = sqlRdr;
							dg_Tracks.DataBind();
						}
					}
					catch (Exception e1)
					{
						//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
					}
					finally
					{
						// ensure close connection
						sqlConn.Close();
					}
				#endregion
				}
				#region < get what="availability" >
					try 
					{
						// Start a new connection to the database specified in strSqlString
						//sqlConn = new SqlConnection( queryConnectStr );
						sqlConn.ConnectionString = queryConnectStr;
						sqlConn.Open();	// open the connection


						// Execute query -- Here you could make 'strSql' any query you want
						if (dg_Availability.Visible)
							strSql = "SELECT Warehouses.ID, quantity, streetNum, city, state, zip, phone, manager FROM Warehouses, Availability " +
								"WHERE ISBN_ASIN=\'" + this.productId + "\' AND Availability.ID = Warehouses.ID " + 
								"ORDER BY state, city";
						else
							strSql = "SELECT sum(quantity) as total, 0 as zero FROM Availability " + 
								"WHERE ISBN_ASIN=\'" + this.productId + "\'";

						// The command needs to know the query and the connection
						sqlCmd = new SqlCommand(strSql, sqlConn);
						// Execute the command
						sqlRdr = sqlCmd.ExecuteReader();

						// Get the answer from the reader and write it to the label.
						if (sqlRdr.HasRows)
						{
							if (dg_Availability.Visible)
							{
								lbl_Availability.Text = "Availiability";
								dg_Availability.DataSource = sqlRdr;
								dg_Availability.DataBind();
							}
							else
							{
								if (sqlRdr.Read())
								{
									int num = Convert.ToInt32(sqlRdr["total"]);
									if (num <= 0)
										lbl_Availability.Text = "Availability: Out of stock";
									else
										lbl_Availability.Text = "Availiability: " + num.ToString();
								}
							}
						}
					}
					catch (Exception e1)
					{
						lbl_Availability.Text = "Item Unavailable.";
						//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
					}
					finally
					{
						// ensure close connection
						sqlConn.Close();
					}
				#endregion
				if (this.isAdmin)
				{
					pnl_Admin.Visible = true;
					#region < get what="sales" >
					try 
					{
						// Start a new connection to the database specified in strSqlString
						//sqlConn = new SqlConnection( queryConnectStr );
						sqlConn.ConnectionString = salesConnectStr;
						sqlConn.Open();	// open the connection


						// Execute query -- Here you could make 'strSql' any query you want

						strSql = "SELECT Sum(quantity) AS count, Sum(quantity * singleprice) AS total FROM PurchasedItems WHERE prodID=\'" + "39489\' GROUP BY prodID";//this.productId + "\' GROUP BY prodID";
								
						// The command needs to know the query and the connection
						sqlCmd = new SqlCommand(strSql, sqlConn);	
						// Execute the command
						sqlRdr = sqlCmd.ExecuteReader();

						// Get the answer from the reader and write it to the label.
						if (sqlRdr.Read())
						{
							lbl_NumSold.Text =		"Number sold: " + sqlRdr["count"].ToString();
							lbl_PriceSold.Text =	"Revenue:    $" + (Math.Round(Convert.ToDecimal(sqlRdr["total"]), 2)).ToString();
						}
						else
						{
							lbl_NumSold.Text =		"Number sold: 0";
							lbl_PriceSold.Text =	"Revenue:    $0";
						}
					}
					
					catch (Exception e1)
					{
						pnl_Admin.Visible = false;
						//	lbl_Error.Text = "<b><font color='red'>" + e1.Message.ToString() + "</font></b>";
					}
					finally
					{
						// ensure close connection
						sqlConn.Close();
					}
					#endregion
				}
				else
				{
					pnl_Admin.Visible = false;
				}
			#endregion </ populate >
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.sqlConn = new System.Data.SqlClient.SqlConnection();
			this.sqlCmd = new System.Data.SqlClient.SqlCommand();
			this.lbl_AddToCart.Click += new System.EventHandler(this.lbl_AddToCart_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void lbl_AddToCart_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("ViewCart.aspx?add=" + this.productId);
		}
	}
}
