using System;
using System.Collections;
using System.Text.RegularExpressions;
using System.IO;
using System.ComponentModel;
using System.Data; 
using System.Drawing;
using System.Configuration;
using System.Data.SqlClient;
using System.Text; 
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Security.Cryptography;


namespace prinsess_inventory.Classes
{
	/// <summary>
	/// Summary description for ContactInformation.
	/// </summary>
	public class ContactInformation
	{
		string billFirstName, billLastName, billStreet, billCity, billState, billZip, billPhone, 
			shipFirstName, shipLastName, shipStreet, shipCity, shipState, shipZip, shipPhone;
		public ContactInformation(string billFirstName, string billLastName, 
			string billStreet, string billCity, string billState, string billZip, 
			string billPhone, string shipFirstName, string shipLastName, string shipStreet, 
			string shipCity, string shipState, string shipZip, string shipPhone)
		{
			this.billFirstName = billFirstName;
			this.billLastName = billLastName;
			this.billStreet = billStreet;
			this.billCity = billCity;
			this.billState = billState;
			this.billZip = billZip;
			this.billPhone = billPhone;
			this.shipFirstName = shipFirstName;
			this.shipLastName = shipLastName;
			this.shipStreet = shipStreet;
			this.shipCity = shipCity;
			this.shipState = shipState;
			this.shipZip = shipZip;
			this.shipPhone = shipPhone;
		}

		public static DataTable getAllPaymentMethods(int customerID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringPhil");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getAllPaymentMethods", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@customerID", SqlDbType.Int);
			objCommand.Parameters["@customerID"].Value = customerID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewpayments");
			DataTable objDataTable = objDataSet.Tables["viewpayments"];


			return objDataTable;
		}

		public static DataTable getAllShippingAddresses(int customerID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringPhil");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getAllShippingAddresses", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@customerID", SqlDbType.Int);
			objCommand.Parameters["@customerID"].Value = customerID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewaddresses");
			DataTable objDataTable = objDataSet.Tables["viewaddresses"];


			return objDataTable;
		}

		public static int addShippingAddress(int customerID, string street, string city, string state, string zip)
		{
			
			
			string connectionstring = ConfigurationSettings.AppSettings.Get("connstringPhil");

			SqlConnection objconn = new SqlConnection(connectionstring);
			SqlCommand objCommand = new SqlCommand("sp_addAddress",objconn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objconn.Open();
			// parameters to insert
			
				objCommand.Parameters.Add("@customerID", SqlDbType.Int);
				objCommand.Parameters["@customerID"].Value = customerID;
			
				objCommand.Parameters.Add("@street", SqlDbType.VarChar,30);
				objCommand.Parameters["@street"].Value = street;
			
				objCommand.Parameters.Add("@city", SqlDbType.VarChar,30);
				objCommand.Parameters["@city"].Value = city;
			
				objCommand.Parameters.Add("@state", SqlDbType.VarChar,2);
				objCommand.Parameters["@state"].Value = state;
			
				objCommand.Parameters.Add("@zip", SqlDbType.VarChar,10);
				objCommand.Parameters["@zip"].Value = zip;
			


			// returns the reference id to insert into the applicant table
			int id = Convert.ToInt32(objCommand.ExecuteScalar());
			objconn.Close();
			return id;
		
		}
		
		public static int addBillingMethod(int customerID, string cardtype, int expmonth, int expyear, string cardholder, 
			string cardnumber, string street, string city, string state, string zip)
		 {
			
			
			 string connectionstring = ConfigurationSettings.AppSettings.Get("connstringPhil");

			 SqlConnection objconn = new SqlConnection(connectionstring);
			 SqlCommand objCommand = new SqlCommand("sp_addAddress",objconn);
			 objCommand.CommandType = CommandType.StoredProcedure;
			 objconn.Open();
			 // parameters to insert
			
			 objCommand.Parameters.Add("@customerID", SqlDbType.Int);
			 objCommand.Parameters["@customerID"].Value = customerID;
			
			 objCommand.Parameters.Add("@street", SqlDbType.VarChar,30);
			 objCommand.Parameters["@street"].Value = street;
			
			 objCommand.Parameters.Add("@city", SqlDbType.VarChar,30);
			 objCommand.Parameters["@city"].Value = city;
			
			 objCommand.Parameters.Add("@state", SqlDbType.VarChar,2);
			 objCommand.Parameters["@state"].Value = state;
			
			 objCommand.Parameters.Add("@zip", SqlDbType.VarChar,10);
			 objCommand.Parameters["@zip"].Value = zip;
			


			 // returns the reference id to insert into the applicant table
			 int addressID = Convert.ToInt32(objCommand.ExecuteScalar());
			 objconn.Close();
			
			objCommand = new SqlCommand("sp_addBillingPayment", objconn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objconn.Open();

			objCommand.Parameters.Add("@customerID", SqlDbType.Int);
			objCommand.Parameters["@customerID"].Value = customerID;
			
			objCommand.Parameters.Add("@cardtype", SqlDbType.VarChar,30);
			objCommand.Parameters["@cardtype"].Value = cardtype;

			objCommand.Parameters.Add("@expmonth", SqlDbType.Int);
			objCommand.Parameters["@expmonth"].Value = expmonth;

			objCommand.Parameters.Add("@expyear", SqlDbType.Int);
			objCommand.Parameters["@expyear"].Value = expyear;
			
			objCommand.Parameters.Add("@cardholder", SqlDbType.VarChar,50);
			objCommand.Parameters["@cardholder"].Value = cardholder;

			objCommand.Parameters.Add("@addressID", SqlDbType.Int);
			objCommand.Parameters["@addressID"].Value = addressID;

			objCommand.Parameters.Add("@cardnumber", SqlDbType.VarChar,16);
			objCommand.Parameters["@cardnumber"].Value = cardnumber;
			


			// returns the reference id to insert into the applicant table
			int id = Convert.ToInt32(objCommand.ExecuteScalar());
			objconn.Close();
			 return id;
		
		 }

		public static DataTable getAllCities()
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringPhil");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getAllCities", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewCities");
			DataTable objDataTable = objDataSet.Tables["viewCities"];
			

			return objDataTable;
		}
	}
}
