using System;
using System.Collections;
using System.Text.RegularExpressions;
using System.IO;
using System.ComponentModel;
using System.Data; 
using System.Drawing;
using System.Configuration;
using System.Data.SqlClient;
using System.Text; 
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Security.Cryptography;

namespace prinsess_inventory.Classes
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class Product
	{
		int productID;
		string ISBN;
		string title;
		string company;
		double origPrice;
		string productType;
		double weight;
		string picture;
		int conditionID;

		public Product(int productID, string ISBN, string title, string company, double origPrice, string productType, double weight, string picture, int conditionID)
		{
			this.productID = productID;
			this.ISBN = ISBN;
			this.title = title;
			this.origPrice = origPrice;
			this.productType = productType;
			this.weight = weight;
			this.picture = picture;
			this.conditionID = conditionID;

		}
		public static DataSet viewAllProducts(string productType, int index, int size)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getAllProducts", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@productType", SqlDbType.VarChar, 50);
			objCommand.Parameters["@productType"].Value = productType;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,index, size, "viewproducts");
			

			return objDataSet;
		}

		public static DataSet viewAllProducts(string productType)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getAllProducts", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@productType", SqlDbType.VarChar, 50);
			objCommand.Parameters["@productType"].Value = productType;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproducts");
			

			return objDataSet;
		}

		public static DataTable getProductInfo(int productID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getProductInfo", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@productID", SqlDbType.Int);
			objCommand.Parameters["@productID"].Value = productID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];


			return objDataTable;
		}

		public static DataTable getWarehousesPerProduct(int productID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_warehousesPerProduct", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@productID", SqlDbType.Int);
			objCommand.Parameters["@productID"].Value = productID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewwarhouses");
			DataTable objDataTable = objDataSet.Tables["viewwarhouses"];
			

			return objDataTable;
		}

		public static DataSet viewOutOfStock()
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_viewOutOfStock", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;

			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewOutOfStock");
			

			return objDataSet;
		}

		public static DataTable countAtLeast(int amt)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_countAtLeast", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@count", SqlDbType.Int);
			objCommand.Parameters["@count"].Value = amt;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable inNWarehouses(int amt)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_howManyWarehouses", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@numWarehouses", SqlDbType.Int);
			objCommand.Parameters["@numWarehouses"].Value = amt;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable howManyPerAuthor(int author)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_howManyPerAuthor", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@author", SqlDbType.Int);
			objCommand.Parameters["@author"].Value = author;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable searchByTitle(string title)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_searchByTitle", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@title", SqlDbType.VarChar, 100);
			objCommand.Parameters["@title"].Value = title;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable searchByAuthor(string author)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_searchByAuthor", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@author", SqlDbType.VarChar, 100);
			objCommand.Parameters["@author"].Value = author;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable searchByKeyword(string keyword)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_searchByKeyword", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@keyword", SqlDbType.VarChar, 300);
			objCommand.Parameters["@keyword"].Value = keyword;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable searchByISBN(string ISBN)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_searchByISBN", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@ISBN", SqlDbType.VarChar, 10);
			objCommand.Parameters["@ISBN"].Value = ISBN;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable searchByCategory(int categoryID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_searchByCategory", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@categoryID", SqlDbType.Int);
			objCommand.Parameters["@categoryID"].Value = categoryID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable getPkgsFromInvoice(int invoice)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getPkgs", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@invoice", SqlDbType.Int);
			objCommand.Parameters["@invoice"].Value = invoice;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewPkgs");
			DataTable objDataTable = objDataSet.Tables["viewPkgs"];
			

			return objDataTable;
		}

		public static DataTable getItems(int pkg)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getItems", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@pkg", SqlDbType.Int);
			objCommand.Parameters["@pkg"].Value = pkg;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewItems");
			DataTable objDataTable = objDataSet.Tables["viewItems"];
			

			return objDataTable;
		}

		public static DataTable getCountPerProduct(string productType)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringPhil");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getCountPerProduct", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@productType", SqlDbType.VarChar, 30);
			objCommand.Parameters["@productType"].Value = productType;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewItems");
			DataTable objDataTable = objDataSet.Tables["viewItems"];
			

			return objDataTable;
		}
		public static DataTable getItemsbyUser(int custID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getItemsbyUser", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@userID", SqlDbType.Int);
			objCommand.Parameters["@userID"].Value = custID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewItemsbyUser");
			DataTable objDataTable = objDataSet.Tables["viewItemsbyUser"];

			
			//objDataSet.Tables["viewItemsbyUser"].Rows.Add

			return objDataTable;
		}

		public static DataTable cheapestMthdperOpt(int pkg) 
		{
			//first, get Package Info
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getPkgInfo", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@pkg", SqlDbType.Int);
			objCommand.Parameters["@pkg"].Value = pkg;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"pkgstuff");
			DataTable pkgInfo = objDataSet.Tables["pkgstuff"];
			//extract data from package
			string city = pkgInfo.Rows[0]["dcity"].ToString();
			float weight = (float) Convert.ToDouble(pkgInfo.Rows[0]["weight"].ToString()); //float?
			int wh = Convert.ToInt32(pkgInfo.Rows[0]["warehouseID"].ToString());
			int items = Convert.ToInt32(pkgInfo.Rows[0]["numItems"].ToString());


			// Send necessary pkg info into cheapestmthd procedure
			SqlCommand objCommand2 = new SqlCommand("sp_cheapestMthdperOpt", objConn);
			objCommand2.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand2.Parameters.Add("@city", SqlDbType.Text);
			objCommand2.Parameters["@city"].Value = city;

			objCommand2.Parameters.Add("@weight", SqlDbType.Float);
			objCommand2.Parameters["@weight"].Value = weight;

			objCommand2.Parameters.Add("@wh", SqlDbType.Int);
			objCommand2.Parameters["@wh"].Value = wh;

			objCommand2.Parameters.Add("@items", SqlDbType.Int);
			objCommand2.Parameters["@items"].Value = items;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter2 = new SqlDataAdapter();
			objDataAdapter2.SelectCommand = objCommand2; //gonna use the command object
			DataSet objDataSet2 = new DataSet();//create the virutal database
			
			objDataAdapter2.Fill(objDataSet2,"cheapestopts");
			DataTable objDataTable = objDataSet2.Tables["cheapestopts"];
			

			return objDataTable;
		}
		//new stuff
		public static DataTable cheapestMthdperOptOthers(int pkg) 
		{
			//first, get Package Info
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getPkgInfo", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@pkg", SqlDbType.Int);
			objCommand.Parameters["@pkg"].Value = pkg;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"pkgstuff");
			DataTable pkgInfo = objDataSet.Tables["pkgstuff"];
			//extract data from package
			string city = pkgInfo.Rows[0]["dcity"].ToString();
			float weight = (float) Convert.ToDouble(pkgInfo.Rows[0]["weight"].ToString()); //float?
			int items = Convert.ToInt32(pkgInfo.Rows[0]["numItems"].ToString());
			string cname = pkgInfo.Rows[0]["cname"].ToString();

			
			//@city varchar(100), @weight float, @items int, @cname varchar(50) 

			// Send necessary pkg info into cheapestmthd procedure
			SqlCommand objCommand2 = new SqlCommand("sp_cheapestMthdperOptOthers", objConn);
			objCommand2.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand2.Parameters.Add("@city", SqlDbType.Text);
			objCommand2.Parameters["@city"].Value = city;

			objCommand2.Parameters.Add("@weight", SqlDbType.Float);
			objCommand2.Parameters["@weight"].Value = weight;

			objCommand2.Parameters.Add("@items", SqlDbType.Int);
			objCommand2.Parameters["@items"].Value = items;

			objCommand2.Parameters.Add("@cname", SqlDbType.Text);
			objCommand2.Parameters["@cname"].Value = cname;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter2 = new SqlDataAdapter();
			objDataAdapter2.SelectCommand = objCommand2; //gonna use the command object
			DataSet objDataSet2 = new DataSet();//create the virutal database
			
			objDataAdapter2.Fill(objDataSet2,"cheapestopts");
			DataTable objDataTable = objDataSet2.Tables["cheapestopts"];
			

			return objDataTable;
		}
		//end new stuff

		/* Returns datatable with zero or 1 row, depicting name of the company
		 */
		public static DataTable isFromOtherCo(int pkgID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_isFromOtherCo", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@pkgID", SqlDbType.Int);
			objCommand.Parameters["@pkgID"].Value = pkgID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"cnameCol");
			DataTable objDataTable = objDataSet.Tables["cnameCol"];

			return objDataTable;

		}

		/*Returns a table of warehouses in the following order:
		 * Warehouses that can supply all items in the same city&state (via getGoodWHs)
		 * Warehouses that can supply all items	(via " ")
		 * Warehouses in the same city (via getOthers method)
		 * The rest of the warehouses  (via " ")
		 */ 

		public static DataTable getWHsInOrder(int custID, string city, string state)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getGoodWHs", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@ID", SqlDbType.Int);
			objCommand.Parameters["@ID"].Value = custID;

			objCommand.Parameters.Add("@city", SqlDbType.Text);
			objCommand.Parameters["@city"].Value = city;//"Portland"; //change to get city from shipping addy
			
			objCommand.Parameters.Add("@state", SqlDbType.Text);
			objCommand.Parameters["@state"].Value = state;//"OR"; //change to get state from shipping addy

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"goodWHs");
			DataTable objDataTable = objDataSet.Tables["goodWHs"];

			//get rest of warehouses, and append to current table
			DataTable objDataTable2 = getOthers(custID); 
			for (int i = 0; i < objDataTable2.Rows.Count; i++)
			{
				objDataTable.DataSet.Tables["goodWHs"].ImportRow(objDataTable2.DataSet.Tables["restWHs"].Rows[i]);
			}
			return objDataTable;
		}

		/*Helper method: returns a list of all warehouses that can't supply everything, in order of
		 *destination city first
		 */
		public static DataTable getOthers(int custID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getRestWHs", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@ID", SqlDbType.Int);
			objCommand.Parameters["@ID"].Value = custID;

			objCommand.Parameters.Add("@city", SqlDbType.Text);
			objCommand.Parameters["@city"].Value = "Portland"; //change to get city from shipping addy
			
			objCommand.Parameters.Add("@state", SqlDbType.Text);
			objCommand.Parameters["@state"].Value = "OR"; //change to get state from shipping addy

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"restWHs");
			DataTable objDataTable = objDataSet.Tables["restWHs"];

			return objDataTable;
		}
		
		/* Helper for Package mthd */
		private static void doQuery(string query, string dbconn) 
		{
			SqlCommand sqlCom;
			SqlDataReader sqlRdr;
			SqlConnection sqlConn = new SqlConnection( ConfigurationSettings.AppSettings.Get(dbconn));
			sqlConn.Open();	// open the connection
			sqlCom = new SqlCommand(query, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
			sqlRdr.Close();
			sqlConn.Close();
		}

		/*Packaging method
		 * Packages all items in customer's shopping cart
		 * Returns a table with package info as well as associated option
		 */		



		public static string package(Page p, int custID, string city, string state, string address, string name, string contact) 
		{
			string packageQuery = "SELECT * FROM Package, Methods WHERE (0 = 1";

			SqlCommand sqlCom;
			SqlDataReader sqlRdr;

			SqlConnection sqlConn = new SqlConnection( ConfigurationSettings.AppSettings.Get("connstringPhil"));
			sqlConn.Open();	// open the connection


			// make invoice
			string strSql = 
				"INSERT INTO Invoices VALUES ( " + // invoiceID
				custID + ", " + // buy_customerID
				"null" + ", " + // ship_customerID (old)
				"null" + ", " + // addressID (old)
				"null" + ", " + // shippingmethod (old)
				"GETDATE()" + ", " + // transdate
				"0" + ", " + // shippingcost
				"0" + ", " + // taxes
				"0" + ", " + // discount
				"0" + ", " + // total
				"GETDATE()" + // shipdate
				")";

				
			doQuery(strSql, "connstringPhil");

			int invoiceID = 0;
			strSql = "SELECT IDENT_CURRENT('Invoices') AS nextIndex";
			sqlCom = new SqlCommand(strSql, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
			if (sqlRdr.Read()) 
			{
				invoiceID = Convert.ToInt32(sqlRdr.GetValue(0));
				p.Session["invoiceID"] = invoiceID;
			}
			sqlRdr.Close();

			if (invoiceID == 0) 
			{
				return "";
			}			

			// insert the products into the invoice
			strSql = 
				"SELECT s.productID, s.quantity, p.cname " + 
				" FROM iisqlsrv.prinsess_inventory.dbo.ShoppingCart AS s, iisqlsrv.prinsess_inventory.dbo.Products AS p "  +
				" WHERE s.productID = p.productID AND customerID = " + custID + "";

			sqlCom = new SqlCommand(strSql, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();			

			while (sqlRdr.Read()) 
			{
				// for each product, insert it into invoice_product
				int productID = Convert.ToInt32(sqlRdr.GetValue(0));
				int quantity = Convert.ToInt32(sqlRdr.GetValue(1));
				string companyName = Convert.ToString(sqlRdr.GetValue(2));

				double saleprice = 0;
				
				// find discounted price
				string strSql2 = 
					"SELECT origPrice - discountDiff " + 
					" FROM iisqlsrv.prinsess_inventory.dbo.Discount AS d, iisqlsrv.prinsess_inventory.dbo.Products AS p "  +
					" WHERE d.productID = p.productID AND d.productID = " + productID + "";

				SqlConnection sqlConn2 = new SqlConnection( ConfigurationSettings.AppSettings.Get("connstringPhil"));
				sqlConn2.Open();	// open the connection

				SqlCommand sqlCom2 = new SqlCommand(strSql2, sqlConn2);	
				SqlDataReader sqlRdr2 = sqlCom2.ExecuteReader();	
				
				if (sqlRdr2.Read()) 
				{
					saleprice = Convert.ToDouble(sqlRdr2.GetValue(0));
				}

				doQuery (
					"INSERT INTO invoice_product VALUES (" + invoiceID + ", " + 
					productID + ", " + 
					quantity + ", " + 
					saleprice + "," + 
					"0" + ")", 
					"connstringPhil"
				);
		
					doQuery (
					"UPDATE invoices " +
					" SET total = total + " + 
					(saleprice * quantity) + " * (1+" + " (SELECT TOP 1 rate FROM iisqlsrv.prinsess_inventory.phillee.taxes)/100) " +
					" WHERE invoiceID = " + invoiceID,
					"connstringPhil"
				);

				doQuery (
					"UPDATE invoices " +
					" SET taxes = taxes + " + 
					(saleprice * quantity) + " * (" + " (SELECT TOP 1 rate FROM iisqlsrv.prinsess_inventory.phillee.taxes)/100) " +
					" WHERE invoiceID = " + invoiceID,
					"connstringPhil"
					);

				if (companyName != "") 
				{
					
				}
			}
			sqlRdr.Close();

			// now, remove all items from another company

			strSql = 
				"SELECT DISTINCT cname " +
				" FROM iisqlsrv.prinsess_inventory.dbo.ShoppingCart AS s, iisqlsrv.prinsess_inventory.dbo.Products AS p " +
				" WHERE s.productID = p.productID AND p.cname IS NOT NULL ";
			
			sqlCom = new SqlCommand(strSql, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();

			while (sqlRdr.Read()) 
			{
				string companyName = Convert.ToString(sqlRdr.GetValue(0));
				int packageID = -1;				
				string strSql2 = 
					"INSERT INTO Package VALUES (" + 
					"'adsf'" + "," + 
					"0" + "," + // numItems
					"0" + "," + // weight
					"1" + "," + // methodID - will be overwritten
					"1" + "," + // vendorID - will be overwritten
					"0" + "," + 
					"'" + name + "'," + // name  
					"'" + address + "'," + // address
					"'" + city + "'," + // city
					"'" + state + "'," + // state
					"'" + contact + "'," + // contact
					"GETDATE()" + "," + // time - will be overwritten with + guaranteetime for mthd
					"NULL" + "," + // pickuptime
					"'Pending'" + "," + // status
					"0" + "," + //fragile- will be overwritten if nec later
					"'none'" + // notes - will be overwritten if nec later
					"," + "'" + companyName + "'" + // cname
					")";
				
				SqlConnection sqlConn2 = new SqlConnection( ConfigurationSettings.AppSettings.Get("connstringMaxine"));
				sqlConn2.Open();	// open the connection
				SqlCommand sqlCom2 = new SqlCommand(strSql2, sqlConn2);	
				SqlDataReader sqlRdr2 = sqlCom2.ExecuteReader();							
				sqlRdr2.Close();

				// get packageID
				strSql2 = "SELECT IDENT_CURRENT('Package') AS nextIndex";

				sqlCom2 = new SqlCommand(strSql2, sqlConn2);	
				sqlRdr2 = sqlCom2.ExecuteReader();							
				if (sqlRdr2.Read()) 
				{
					packageID = Convert.ToInt32(sqlRdr2.GetValue(0));
				} 
				else 
				{
					// something went wrong
				}
				sqlRdr2.Close();

				// iterate through products, insert them into pkgproduct
				strSql2 = 
					"SELECT s.quantity, s.productID, s.shoppingCartID, p.weight " + 
					" FROM iisqlsrv.prinsess_inventory.dbo.ShoppingCart AS s, iisqlsrv.prinsess_inventory.dbo.Products AS p "  +
					" WHERE s.productID = p.productID AND p.cname = '" + companyName + "'";
				sqlCom2 = new SqlCommand(strSql2, sqlConn2);	
				sqlRdr2 = sqlCom2.ExecuteReader(); 
				while (sqlRdr2.Read()) 
				{
					int quantity = Convert.ToInt32(sqlRdr2.GetValue(0));
					int productID = Convert.ToInt32(sqlRdr2.GetValue(1));
					int shoppingCartID = Convert.ToInt32(sqlRdr2.GetValue(2));
					double weight = Convert.ToDouble(sqlRdr2.GetValue(3));

					doQuery(
						"UPDATE iisqlsrv.mtoh412_shipping.dbo.Package SET weight = weight + " + (weight * quantity) + "",
						"connstringPhil");

					doQuery(
						"INSERT INTO iisqlsrv.mtoh412_shipping.dbo.PkgProduct VALUES (" + 
						packageID + ", " + 
						productID + ", " + 
						quantity + ")"
						, "connstringPhil");

					doQuery(
						"UPDATE iisqlsrv.mtoh412_shipping.dbo.Package SET numItems = numItems + " + quantity + " WHERE packageID = " + 
						packageID + ""
						, "connstringPhil");

					doQuery(
						"DELETE FROM iisqlsrv.prinsess_inventory.dbo.shoppingCart WHERE shoppingCartID = " + shoppingCartID + ""
						, "connstringPhil");

					doQuery(
						"UPDATE iisqlsrv.prinsess_inventory.dbo.Availability SET conditionID = conditionID - " + quantity + " WHERE productID = " + productID + ""
						, "connstringPhil");


				}

				doQuery(
					"INSERT INTO iisqlsrv.mtoh412_shipping.dbo.InvoicePackage VALUES(" + invoiceID + "," + packageID + ")"
					, "connstringPhil");

				packageQuery += " OR packageID = " + packageID;
			}
			sqlRdr.Close();


			DataTable WHsInOrder = getWHsInOrder(custID, city, state);

			// iterate through warehouses
			for (int i = 0; i < WHsInOrder.Rows.Count; i++) 
			{
				int warehouseID = Convert.ToInt32(WHsInOrder.Rows[i]["warehouseID"].ToString());

				int packageID = 0;
				
				string strSql2 = 
					"SELECT productID, quantity " + 
					" FROM iisqlsrv.prinsess_inventory.dbo.ShoppingCart "  +
					" WHERE customerID = " + custID + "";
				SqlConnection sqlConn2 = new SqlConnection( ConfigurationSettings.AppSettings.Get("connstringPhil"));
				sqlConn2.Open();	// open the connection

				SqlCommand sqlCom2 = new SqlCommand(strSql2, sqlConn2);	
				SqlDataReader sqlRdr2 = sqlCom2.ExecuteReader();							
				
				// iterate through the shopping cart
				while (sqlRdr2.Read()) 
				{
					int productID = Convert.ToInt32(sqlRdr2.GetValue(0));
					int quantity = Convert.ToInt32(sqlRdr2.GetValue(1));
					
					// lookup availability for the package in the warehouse
					string strSql3 = "SELECT conditionID " +
						" FROM iisqlsrv.prinsess_inventory.dbo.Availability " +
						" WHERE productID = " + productID + " AND" +
						" warehouseID = " + warehouseID + "";

					SqlConnection sqlConn3 = new SqlConnection( ConfigurationSettings.AppSettings.Get("connstringPhil"));
					sqlConn3.Open();	// open the connection
					SqlCommand sqlCom3 = new SqlCommand(strSql3, sqlConn3);	
					SqlDataReader sqlRdr3 = sqlCom3.ExecuteReader();

					if (sqlRdr3.Read()) 
					{
						// this warehouse contains the product

						// make package if it doesn't exist
						SqlConnection sqlConn4 = new SqlConnection( ConfigurationSettings.AppSettings.Get("connstringMaxine"));
						sqlConn4.Open();	// open the connection
						SqlCommand sqlCom4;
						SqlDataReader sqlRdr4;

						if (packageID == 0) 
						{
							string strSql4 = "INSERT INTO Package VALUES (" + 
								"'adsf'" + "," + 
								"0" + "," + // numItems
								"0" + "," + // weight
								"1" + "," + // methodID - will be overwritten
								"1" + "," + // vendorID - will be overwritten
								warehouseID + "," + 
								"'" + name + "'," + // name  
								"'" + address + "'," + // address
								"'" + city + "'," + // city
								"'" + state + "'," + // state
								"'" + contact + "'," + // contact
								"GETDATE()" + "," + // time - will be overwritten with + guaranteetime for mthd
								"NULL" + "," + // pickuptime
								"'Pending'" + "," + // status
								"0" + "," + //fragile- will be overwritten if nec later
								"'none'" + // notes - will be overwritten if nec later
								"," + "NULL" + // temp for cname, PHIL WILL FIX later, CHANGE THIS
								")";
							sqlCom4 = new SqlCommand(strSql4, sqlConn4);	
							sqlRdr4 = sqlCom4.ExecuteReader();
							sqlRdr4.Close();

							strSql4 = "SELECT IDENT_CURRENT('Package') AS nextIndex";

							sqlCom4 = new SqlCommand(strSql4, sqlConn4);	
							sqlRdr4 = sqlCom4.ExecuteReader();
							if (sqlRdr4.Read()) 
							{
								packageID = Convert.ToInt32(sqlRdr4.GetValue(0));
							} 
							else 
							{
								// something went wrong
							}
							sqlRdr4.Close();
							packageQuery += " OR packageID = " + packageID;
						}
						
						// we have stuff
						// two cases here, either we have more than quantity needed
						// or we have less than quantity needed
						int haveQuantity = Convert.ToInt32(sqlRdr3.GetValue(0));
						int usedQuantity = 0;
						if (haveQuantity > quantity) 
						{
							// we have more in this warehouse than we need

							// update availability to new value
							doQuery(
								"UPDATE iisqlsrv.prinsess_inventory.dbo.Availability " +
								" SET conditionID = " + (haveQuantity - quantity) +
								" WHERE warehouseID = " + warehouseID + " AND " +
								" productID = " + productID + ""
								, "connstringPhil");
							
							// we have the amount needed for this product
							doQuery(
								"DELETE FROM iisqlsrv.prinsess_inventory.dbo.ShoppingCart " +
								" WHERE productID = " + productID + ""
								, "connstringPhil");
							usedQuantity = quantity;						
						} 
						else 
						{
							// we're using all of it up from this warehouse
							
							// delete it or set quantity to 0?
							doQuery(
								"DELETE FROM iisqlsrv.prinsess_inventory.dbo.Availability " + 
								" WHERE warehouseID = " + warehouseID + " AND " +
								" productID = " + productID + ""
								, "connstringPhil");

							// update to new quantity
							doQuery(
								"UPDATE iisqlsrv.prinsess_inventory.dbo.ShoppingCart " +
								" SET quantity = " + (quantity-haveQuantity ) +
								" WHERE productID = " + productID + ""
								, "connstringPhil");
							usedQuantity = haveQuantity;
						}
						
						// insert into package
						if (usedQuantity > 0) 
						{
							doQuery(
								"INSERT INTO iisqlsrv.mtoh412_shipping.dbo.PkgProduct VALUES (" + 
								packageID + ", " + 
								productID + ", " + 
								usedQuantity + ")"
								, "connstringPhil");
							
							// update weight
							string strSql4 = "SELECT weight FROM iisqlsrv.prinsess_inventory.dbo.Products WHERE productID = " + productID + "";
							sqlCom4 = new SqlCommand(strSql4, sqlConn4);	
							sqlRdr4 = sqlCom4.ExecuteReader();
							double weight = 0;
							if (sqlRdr4.Read()) 
							{
								weight = Convert.ToDouble(sqlRdr4.GetValue(0));
							} 
							else 
							{
								// something went wrong
							}
							sqlRdr4.Close();
	
							doQuery(
								"UPDATE iisqlsrv.mtoh412_shipping.dbo.Package SET weight = weight + " + 
								(quantity * weight) + 
								" WHERE packageID = " + packageID + ""
								, "connstringPhil");

							// update numItems
							doQuery(
								"UPDATE iisqlsrv.mtoh412_shipping.dbo.Package SET numItems = numItems + " + usedQuantity + " WHERE packageID = " + 
								packageID + ""
								, "connstringPhil");

						}
						sqlConn4.Close();
					}
					// done with this product
					sqlRdr3.Close();
					sqlConn3.Close();
				}
				// done with this warehouse
				sqlRdr2.Close();
				sqlConn2.Close();

				// add the package into the invoice
				if (packageID != 0) 
				{
					doQuery(
						"INSERT INTO iisqlsrv.mtoh412_shipping.dbo.InvoicePackage VALUES(" + invoiceID + ", " + packageID + ")"
						, "connstringPhil");
				}

			}
			sqlRdr.Close();
			sqlConn.Close();
			packageQuery += ") AND  Package.methodID = Methods.methodID";
			return packageQuery;
		}


		/*Helper method - retrieves Address info given an ID*/
		public static DataTable getAddressInfo(int addyID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getAddressInfo", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@addyID", SqlDbType.Int);
			objCommand.Parameters["@addyID"].Value = addyID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"addyInfo");
			DataTable objDataTable = objDataSet.Tables["addyInfo"];
			return objDataTable;
		}

	

		/*foo function to return a list of pkgs*/
		public static DataTable fooPackage(int custID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("fooPackage", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();
			objConn.Close();
				
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
				
			objDataAdapter.Fill(objDataSet,"pkgs");
			DataTable objDataTable = objDataSet.Tables["pkgs"];
			return objDataTable;
		}

		public static int howManyInStock(int productID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_howManyInStock", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();
			objCommand.Parameters.Add("@productID", SqlDbType.Int);
			objCommand.Parameters["@productID"].Value = productID;
			objConn.Close();
				
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
				
			objDataAdapter.Fill(objDataSet,"pkgs");
			DataTable objDataTable = objDataSet.Tables["pkgs"];
			int quantity = Convert.ToInt32(objDataTable.Rows[0]["quantity"]);
			return quantity;
		}

		public static void setMethodForPkg(int pkgID, int mthdID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_setMethodForPkg", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@pkgID", SqlDbType.Int);
			objCommand.Parameters["@pkgID"].Value = pkgID;

			objCommand.Parameters.Add("@mthdID", SqlDbType.Int);
			objCommand.Parameters["@mthdID"].Value = mthdID;
							
			objCommand.ExecuteNonQuery();
			objConn.Close();
		}
		public static void setNotes(int pkgID, string notes)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_setNotes", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;

			objConn.Open();

			objCommand.Parameters.Add("@pkgID", SqlDbType.Int);
			objCommand.Parameters["@pkgID"].Value = pkgID;

			objCommand.Parameters.Add("@notes", SqlDbType.VarChar);
			objCommand.Parameters["@notes"].Value = notes;
							
			objCommand.ExecuteNonQuery();
			objConn.Close();
		}

		public static string getNotes(int pkgID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getNotes", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;

			objConn.Open();

			objCommand.Parameters.Add("@pkgID", SqlDbType.Int);
			objCommand.Parameters["@pkgID"].Value = pkgID;

							
			objCommand.ExecuteNonQuery();
			objConn.Close();

			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
				
			objDataAdapter.Fill(objDataSet,"notes");
			DataTable objDataTable = objDataSet.Tables["notes"];
			
			string notes = (objDataTable.Rows[0]["Notes"]).ToString();

			return notes;
		}

		//helper mthd: runs a query and rets a datatable
		
		public static DataTable runQuery(string strSql)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			// Start a new connection to the database specified in strSqlString
			SqlConnection sqlConn = new SqlConnection( connectionString );
			sqlConn.Open();	// open the connection

						
			// The command needs to know the query and the connection
			SqlCommand sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			//SqlDataReader sqlRdr = sqlCom.ExecuteReader();

			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = sqlCom; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
				
			objDataAdapter.Fill(objDataSet,"pkgs");
			DataTable objDataTable = objDataSet.Tables["pkgs"];

			return objDataTable;
		
		
		}

	}
	

}
