using System;
using System.Collections;
using System.Text.RegularExpressions;
using System.IO;
using System.ComponentModel;
using System.Data; 
using System.Drawing;
using System.Configuration;
using System.Data.SqlClient;
using System.Text; 
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Security.Cryptography;

namespace prinsess_inventory.Classes
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class Product
	{
		int productID;
		string ISBN;
		string title;
		string company;
		double origPrice;
		string productType;
		double weight;
		string picture;
		int conditionID;

		public Product(int productID, string ISBN, string title, string company, double origPrice, string productType, double weight, string picture, int conditionID)
		{
			this.productID = productID;
			this.ISBN = ISBN;
			this.title = title;
			this.origPrice = origPrice;
			this.productType = productType;
			this.weight = weight;
			this.picture = picture;
			this.conditionID = conditionID;

		}
		public static DataSet viewAllProducts(string productType)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getAllProducts", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@productType", SqlDbType.VarChar, 50);
			objCommand.Parameters["@productType"].Value = productType;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproducts");
			

			return objDataSet;
		}

		public static DataTable getProductInfo(int productID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getProductInfo", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@productID", SqlDbType.Int);
			objCommand.Parameters["@productID"].Value = productID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];


			return objDataTable;
		}

		public static DataTable getWarehousesPerProduct(int productID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_warehousesPerProduct", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@productID", SqlDbType.Int);
			objCommand.Parameters["@productID"].Value = productID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewwarhouses");
			DataTable objDataTable = objDataSet.Tables["viewwarhouses"];
			

			return objDataTable;
		}

		public static DataSet viewOutOfStock()
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_viewOutOfStock", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;

			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewOutOfStock");
			

			return objDataSet;
		}

		public static DataTable countAtLeast(int amt)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_countAtLeast", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@count", SqlDbType.Int);
			objCommand.Parameters["@count"].Value = amt;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable inNWarehouses(int amt)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_howManyWarehouses", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@numWarehouses", SqlDbType.Int);
			objCommand.Parameters["@numWarehouses"].Value = amt;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable howManyPerAuthor(int author)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_howManyPerAuthor", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@author", SqlDbType.Int);
			objCommand.Parameters["@author"].Value = author;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable searchByTitle(string title)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_searchByTitle", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@title", SqlDbType.VarChar, 100);
			objCommand.Parameters["@title"].Value = title;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable searchByAuthor(string author)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_searchByAuthor", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@author", SqlDbType.VarChar, 100);
			objCommand.Parameters["@author"].Value = author;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable searchByKeyword(string keyword)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_searchByKeyword", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@keyword", SqlDbType.VarChar, 300);
			objCommand.Parameters["@keyword"].Value = keyword;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable searchByISBN(string ISBN)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_searchByISBN", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@ISBN", SqlDbType.VarChar, 10);
			objCommand.Parameters["@ISBN"].Value = ISBN;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable searchByCategory(int categoryID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_searchByCategory", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@categoryID", SqlDbType.Int);
			objCommand.Parameters["@categoryID"].Value = categoryID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewproduct");
			DataTable objDataTable = objDataSet.Tables["viewproduct"];
			

			return objDataTable;
		}

		public static DataTable getPkgsFromInvoice(int invoice)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getPkgs", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@invoice", SqlDbType.Int);
			objCommand.Parameters["@invoice"].Value = invoice;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewPkgs");
			DataTable objDataTable = objDataSet.Tables["viewPkgs"];
			

			return objDataTable;
		}

		public static DataTable getItems(int pkg)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getItems", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@pkg", SqlDbType.Int);
			objCommand.Parameters["@pkg"].Value = pkg;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewItems");
			DataTable objDataTable = objDataSet.Tables["viewItems"];
			

			return objDataTable;
		}


		public static DataTable getItemsbyUser(int custID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getItemsbyUser", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@userID", SqlDbType.Int);
			objCommand.Parameters["@userID"].Value = custID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewItemsbyUser");
			DataTable objDataTable = objDataSet.Tables["viewItemsbyUser"];

			
			//objDataSet.Tables["viewItemsbyUser"].Rows.Add

			return objDataTable;
		}

		public static DataTable cheapestMthdperOpt(int pkg) 
		{
			//first, get Package Info
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getPkgInfo", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@pkg", SqlDbType.Int);
			objCommand.Parameters["@pkg"].Value = pkg;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"pkgstuff");
			DataTable pkgInfo = objDataSet.Tables["pkgstuff"];
			//extract data from package
			string city = pkgInfo.Rows[0]["dcity"].ToString();
			float weight = (float) Convert.ToDouble(pkgInfo.Rows[0]["weight"].ToString()); //float?
			int wh = Convert.ToInt32(pkgInfo.Rows[0]["warehouseID"].ToString());
			int items = Convert.ToInt32(pkgInfo.Rows[0]["numItems"].ToString());


			// Send necessary pkg info into cheapestmthd procedure
			SqlCommand objCommand2 = new SqlCommand("sp_cheapestMthdperOpt", objConn);
			objCommand2.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand2.Parameters.Add("@city", SqlDbType.Text);
			objCommand2.Parameters["@city"].Value = city;

			objCommand2.Parameters.Add("@weight", SqlDbType.Float);
			objCommand2.Parameters["@weight"].Value = weight;

			objCommand2.Parameters.Add("@wh", SqlDbType.Int);
			objCommand2.Parameters["@wh"].Value = wh;

			objCommand2.Parameters.Add("@items", SqlDbType.Int);
			objCommand2.Parameters["@items"].Value = items;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter2 = new SqlDataAdapter();
			objDataAdapter2.SelectCommand = objCommand2; //gonna use the command object
			DataSet objDataSet2 = new DataSet();//create the virutal database
			
			objDataAdapter2.Fill(objDataSet,"cheapestopts");
			DataTable objDataTable = objDataSet2.Tables["cheapestopts"];
			

			return objDataTable;
		}


		/*Returns a table of warehouses in the following order:
		 * Warehouses that can supply all items in the same city&state (via getGoodWHs)
		 * Warehouses that can supply all items	(via " ")
		 * Warehouses in the same city (via getOthers method)
		 * The rest of the warehouses  (via " ")
		 */ 

		public static DataTable getWHsInOrder(int custID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getGoodWHs", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@ID", SqlDbType.Int);
			objCommand.Parameters["@ID"].Value = custID;

			objCommand.Parameters.Add("@city", SqlDbType.Text);
			objCommand.Parameters["@city"].Value = "Portland"; //change to get city from shipping addy
			
			objCommand.Parameters.Add("@state", SqlDbType.Text);
			objCommand.Parameters["@state"].Value = "OR"; //change to get state from shipping addy

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"goodWHs");
			DataTable objDataTable = objDataSet.Tables["goodWHs"];

			//get rest of warehouses, and append to current table
			DataTable objDataTable2 = getOthers(custID); 
			for (int i = 0; i < objDataTable2.Rows.Count; i++)
			{
				objDataTable.DataSet.Tables["goodWHs"].ImportRow(objDataTable2.DataSet.Tables["restWHs"].Rows[i]);
			}
			return objDataTable;
		}

		/*Helper method: returns a list of all warehouses that can't supply everything, in order of
		 *destination city first
		 */
		public static DataTable getOthers(int custID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getRestWHs", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@ID", SqlDbType.Int);
			objCommand.Parameters["@ID"].Value = custID;

			objCommand.Parameters.Add("@city", SqlDbType.Text);
			objCommand.Parameters["@city"].Value = "Portland"; //change to get city from shipping addy
			
			objCommand.Parameters.Add("@state", SqlDbType.Text);
			objCommand.Parameters["@state"].Value = "OR"; //change to get state from shipping addy

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"restWHs");
			DataTable objDataTable = objDataSet.Tables["restWHs"];

			return objDataTable;
		}
		
		/*Packaging method
		 * Packages all items in customer's shopping cart
		 * Returns a table with package info as well as associated option
		 *
		private void package(int customerID) 
		{

			SqlConnection sqlConn;
			SqlCommand sqlCom;
			SqlDataReader sqlRdr;

			sqlConn = new SqlConnection( ConfigurationSettings.AppSettings.Get("connstringPhil"));
			sqlConn.Open();	// open the connection


			// make invoice
			string strSql = 
				"INSERT INTO Invoices VALUES ('', " + // invoiceID
				Session["customerID"] + ", " + // buy_customerID
				"0" + ", " + // ship_customerID (old)
				"0" + ", " + // addressID (old)
				"0" + ", " + // shippingmethod (old)
				"GETDATE()" + ", " + // transdate
				"0" + ", " + // shippingcost
				"0" + ", " + // taxes
				"0" + ", " + // discount
				"0" + ", " + // total
				"0" + ", " + // shipdate
				"";
				
			sqlCom = new SqlCommand(strSql, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
			sqlRdr.Close();

			int invoiceID = 0;
			strSql = "SELECT IDENT_CURRENT('Invoices') AS nextIndex";
			sqlCom = new SqlCommand(strSql, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
			if (sqlRdr.Read()) 
			{
				invoiceID = Convert.ToInt32(sqlRdr.GetValue(0));
			}
			sqlRdr.Close();

			if (invoiceID == 0) 
			{
				return;
			}			
			//new
			// start actual packaging sequence
			string shippingID = Convert.ToInt32(Request.QueryString["shippingAddressID"]);
			DataTable addyInfo = getAddressInfo(shippingID);

			//get destination city and state
			string city = addyInfo.Rows[0]["city"];
			string state = addyInfo.Rows[0]["state"];

			DataTable WHsInOrder = getWHsInOrder(customerID);

			// iterate through warehouses
			for (int i = 0; i < WHsInOrder.Rows.Count(); i++) 
			{
				int warehouseID = Convert.ToInt32(WHsInOrder.Rows[i]["warehouseID"].ToString()); 
				// end new
				int packageID = 0;
				
				string strSql2 = 
					"SELECT productID, quantity " + 
					" FROM ShoppingCart "  +
					" WHERE customerID = " + customerID + "";

				SqlCommand sqlCom2 = new SqlCommand(strSql2, sqlConn);	
				SqlDataReader sqlRdr2 = sqlCom2.ExecuteReader();							
				
				// iterate through the shopping cart
				while (sqlRdr2.Read()) 
				{
					int productID = Convert.ToInt32(sqlRdr2.GetValue(0));
					int quantity = Convert.ToInt32(sqlRdr2.GetValue(1));
					
					// lookup availability for the package in the warehouse
					string strSql3 = "SELECT conditionID " +
						" FROM Availability " +
						" WHERE productID = " + productID + " AND" +
						" warehouseID = " + warehouseID + "";

					SqlCommand sqlCom3 = new SqlCommand(strSql3, sqlConn);	
					SqlDataReader sqlRdr3 = sqlCom3.ExecuteReader();

					if (sqlRdr3.HasRows) 
					{
						// make package if it doesn't exist
						SqlCommand sqlCom4;
						SqlDataReader sqlRdr4;

						if (packageID == 0) 
						{
							string strSql4 = "INSERT INTO Package VALUES ('', " + 
								"trackingNum" + "," + 
								"0" + "," + // numItems
								"0" + "," + // weight
								"0" + "," + // methodID
								"0" + "," + // vendorID
								warehouseID + "," + 
								"dname" + "," + // name
								"daddress" + "," + // address
								"dcity" + "," + // city
								"dstate" + "," + // state
								"dcontact" + "," + // contact
								"dtime" + "," + // time
								"pickuptime" + "," + // pickuptime
								"status" + "," + // status
								"fragile" + "," + //fragile
								"notes" + "," + // notes
								")";
							sqlCom4 = new SqlCommand(strSql4, sqlConn);	
							sqlRdr4 = sqlCom4.ExecuteReader();
							sqlRdr4.Close();

							strSql4 = "SELECT IDENT_CURRENT('Package') AS nextIndex";

							sqlCom4 = new SqlCommand(strSql4, sqlConn);	
							sqlRdr4 = sqlCom4.ExecuteReader();
							if (sqlRdr4.Read()) 
							{
								packageID = Convert.ToInt32(sqlRdr4.GetValue(0));
							} 
							else 
							{
								// something went wrong
							}
							sqlRdr4.Close();
						}
						
						// we have stuff
						// two cases here, either we have more than quantity needed
						// or we have less than quantity needed
						int haveQuantity = Convert.ToInt32(sqlRdr3.GetValue(0));
						int usedQuantity = 0;
						if (haveQuantity > quantity) 
						{
							// we have more in this warehouse than we need

							// update availability to new value
							string strSql4 = "UPDATE Availability " +
								" SET conditionID = " + (haveQuantity - quantity) +
								" WHERE warehouseID = " + warehouseID + " AND " +
								" productID = " + productID + "";

							sqlCom4 = new SqlCommand(strSql4, sqlConn);	
							sqlRdr4 = sqlCom4.ExecuteReader();
							sqlRdr4.Close();
							
							// we have the amount needed for this product
							strSql4 = "DELETE FROM ShoppingCart " +
								" WHERE productID = " + productID + "";
							usedQuantity = quantity;

							sqlCom4 = new SqlCommand(strSql4, sqlConn);	
							sqlRdr4 = sqlCom4.ExecuteReader();
							sqlRdr4.Close();							
						} 
						else 
						{
							// we're using all of it up from this warehouse
							
							// delete it or set quantity to 0?
							string strSql4 = "DELETE FROM Availability " + 
								" WHERE warehouseID = " + warehouseID + " AND " +
								" productID = " + productID + "";
							
							sqlCom4 = new SqlCommand(strSql4, sqlConn);	
							sqlRdr4 = sqlCom4.ExecuteReader();
							sqlRdr4.Close();

							// update to new quantity
							strSql4 = "UPDATE ShoppingCart " +
								" SET quantity = " + (haveQuantity - quantity) +
								" WHERE productID = " + productID + "";
							
							sqlCom4 = new SqlCommand(strSql4, sqlConn);	
							sqlRdr4 = sqlCom4.ExecuteReader();
							sqlRdr4.Close();

							usedQuantity = haveQuantity;
						}
						
						// insert into package
						if (usedQuantity > 0) 
						{
							string strSql4 = "INSERT INTO PkgProduct VALUES ('', " + packageID + ", " + productID + ", " + usedQuantity + ")";
							sqlCom4 = new SqlCommand(strSql4, sqlConn);	
							sqlRdr4 = sqlCom4.ExecuteReader();
							sqlRdr4.Close();	
							
							// update weight
							strSql4 = "SELECT weight FROM Products WHERE productID = " + productID + "";
							sqlCom4 = new SqlCommand(strSql4, sqlConn);	
							sqlRdr4 = sqlCom4.ExecuteReader();
							double weight = 0;
							if (sqlRdr4.Read()) 
							{
								weight = Convert.ToDouble(sqlRdr4.GetValue(0));
							} 
							else 
							{
								// something went wrong
							}
							sqlRdr4.Close();
	
							strSql4 = "UPDATE Packages SET weight = weight + " + (quantity * weight) + " WHERE packageID = " + packageID + "";
							sqlCom4 = new SqlCommand(strSql4, sqlConn);	
							sqlRdr4 = sqlCom4.ExecuteReader();
							sqlRdr4.Close();	

							// update numItems
							strSql4 = "UPDATE Packages SET numItems = numItems + 1 WHERE packageID = " + packageID + "";
							sqlCom4 = new SqlCommand(strSql4, sqlConn);	
							sqlRdr4 = sqlCom4.ExecuteReader();
							sqlRdr4.Close();
						}
					}
					// done with this product
					sqlRdr3.Close();
				}
				// done with this warehouse
				sqlRdr2.Close();

				// add the package into the invoice
				if (packageID != 0) 
				{
					strSql2 = "INSERT INTO InvoicePackage VALUES('', " + invoiceID + ", " + packageID + ")";

					sqlCom2 = new SqlCommand(strSql2, sqlConn);
					sqlRdr2 = sqlCom2.ExecuteReader();	
					sqlRdr2.Close();
				}

			}
			sqlRdr.Close();
		} */

		/*Helper method - retrieves Address info given an ID*/
		public static DataTable getAddressInfo(int addyID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getAddressInfo", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@addyID", SqlDbType.Int);
			objCommand.Parameters["@addyID"].Value = addyID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"addyInfo");
			DataTable objDataTable = objDataSet.Tables["addyInfo"];
			return objDataTable;
		}

	

		/*foo function to return a list of pkgs*/
		public static DataTable fooPackage(int custID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringMaxine");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("fooPackage", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();
			objConn.Close();
				
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
				
			objDataAdapter.Fill(objDataSet,"pkgs");
			DataTable objDataTable = objDataSet.Tables["pkgs"];
			return objDataTable;
		}
	}

}
