using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using prinsess_inventory.Classes;
using System.Configuration;
using System.Data.SqlClient;
using System.IO;

namespace prinsess_inventory
{
	/// <summary>
	/// Summary description for template.
	/// </summary>
	public class invoice : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtSearch;
		protected System.Web.UI.WebControls.DropDownList ddlSearchBy;
		protected System.Web.UI.WebControls.DropDownList ddlProductType;
		protected System.Web.UI.WebControls.DropDownList ddlCategories;
		protected System.Web.UI.WebControls.ImageButton ibSearchCategories;
		protected System.Web.UI.WebControls.Label lblSearchByError;
		protected System.Web.UI.WebControls.Label lblSearchByCategory;
		protected System.Web.UI.WebControls.DataGrid dgItems;
		protected System.Web.UI.WebControls.DataGrid dgInvoice;
		protected System.Web.UI.WebControls.Label lblThankYou;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.Panel Panel1;
		protected System.Web.UI.WebControls.ImageButton ibSearch;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			Customers.fillPanel(Panel1, Session["customerID"]);
			Customers.loginCheck(this, Session["customerID"]);

			if(!(Page.IsPostBack)){
				string type;
				if(ddlProductType.SelectedIndex == 0)
				{
					type = "CD";
				}
				else
				{
					type = "Book";
				}
				DataSet objDS = Categories.getAllCategories(type);
				DataTable objDTCategories = new DataTable();
				objDTCategories = objDS.Tables[0];
				ddlCategories.DataSource = objDTCategories;
				
				ddlCategories.DataValueField = "categoryID";
				ddlCategories.DataTextField = "categoryName";	
				ddlCategories.DataBind();
			}

			
			// Create the Manager 
			RollOverImageManager m = new RollOverImageManager(); 

			// Intialize the Image Controls 
			m.InitializeImage(ibSearch, "images/searchdown.jpg"); 
			m.InitializeImage(ibSearchCategories, "images/searchdown.jpg"); 

			// Load the Images (generate the JavaScript) 
			m.LoadImages(this); 
			DataSet objDSa = new DataSet();//create the virutal database
			if (Request.QueryString["trans"] != null) 
			{
				lblThankYou.Text = "Thank you for your purchase, " + Customers.customerAttribute(Convert.ToInt32(Session["customerID"]), "firstname") + "! Here's a brief summary.<br><br>";
			}
			if (Request.QueryString["invoiceID"] != null && Customers.invoiceCustomer(this, Convert.ToInt32(Request.QueryString["invoiceID"]), Session["customerID"]))
			{
				int invoiceID = Convert.ToInt32(Request.QueryString["invoiceID"]);
				Label1.Visible = true;
				Label2.Visible = true;

				// look up invoices
				string connectionString = ConfigurationSettings.AppSettings.Get("connstringPhil");
				SqlConnection objConn = new SqlConnection(connectionString);

				SqlCommand objCommand = new SqlCommand(
					"SELECT * " + 
					" FROM invoice_product, " +
					" iisqlsrv.prinsess_inventory.dbo.Products AS p " +
					" WHERE invoice_product.invoiceID = " + invoiceID +
					" AND p.productID = invoice_product.productID"
					, objConn);
				objConn.Open();
			
				//pipe that transfers all the information from database to the dataset
				SqlDataAdapter objDataAdapter = new SqlDataAdapter();
				objDataAdapter.SelectCommand = objCommand; //gonna use the command object
				
			
				objConn.Close();

				objDataAdapter.Fill(objDSa,"viewinvoices");

				DataTable objDT = new DataTable();
				objDT = objDSa.Tables[0];
				if (objDT.Rows.Count > 0) 
				{
					dgItems.DataSource = objDT;
					dgItems.DataBind();
				} 
				else 
				{
				}
			
				// look up invoices
				string connectionString2 = ConfigurationSettings.AppSettings.Get("connstringPhil");
				SqlConnection objConn2 = new SqlConnection(connectionString);

				SqlCommand objCommand2 = new SqlCommand(
					"SELECT * " + 
					" FROM invoices " +
					" WHERE invoiceID = " + invoiceID
					, objConn);
				objConn2.Open();
			
				//pipe that transfers all the information from database to the dataset
				SqlDataAdapter objDataAdapter2 = new SqlDataAdapter();
				objDataAdapter2.SelectCommand = objCommand2; //gonna use the command object
				DataSet objDSa2 = new DataSet();//create the virutal database
			
				objConn2.Close();

				objDataAdapter2.Fill(objDSa2,"viewinvoices2");

				DataTable objDT2 = new DataTable();
				objDT2 = objDSa2.Tables[0];
				if (objDT2.Rows.Count > 0) 
				{
					dgInvoice.DataSource = objDT2;
					dgInvoice.DataBind();
				} 
				else 
				{
				}
			} 
			else 
			{
				Label1.Visible = false;
				Label2.Visible = false;
			}

			//THIS IS WHERE WE START MAKING THE ORDER.XML FILES
			if(Request.QueryString["trans"] != null)
			{
				DataTable externalPackages = Invoices.getExternalPackages(Convert.ToInt32(Request.QueryString["invoiceID"]));
				for(int j = 0; j < externalPackages.Rows.Count; j++)
				{
					DataRow thisRow = externalPackages.Rows[j];

					//create the filename, in the folders file, concatenated with the word "order" and with the companyName and the packageID
					string file = Server.MapPath(".\\orders\\") + "order" + thisRow["cname"].ToString() + externalPackages.Rows[j]["packageID"] + ".xml";
				
					string xmlContent = "<order><issuingCompany>444k</issuingCompany><partnerCompany>" + 
						thisRow["cname"] + 
						"</partnerCompany><shippingMethod>" + 
						thisRow["cMethodID"].ToString() + //what is this supposed to be?
						"</shippingMethod><destination><address>" +
						thisRow["daddress"].ToString() +
						"</address><city>" + 
						thisRow["dcity"].ToString() +
						"</city><state>" + 
						thisRow["dstate"].ToString() + 
						"</state><zip>" +
						"" + //what are we going to do about zip code?
						"</zip><contact><tel>" +
						thisRow["contact"].ToString() +
						"</tel><fax>" +
						"" + //what do we do about this extra field?
						"</fax></contact></destination>";
					int pkgID = Convert.ToInt32(thisRow["packageID"]);
					//Response.Write("aslhadslhf " +pkgID);
					DataTable products = Product.getItems(pkgID);
					for(int k = 0; k < products.Rows.Count; k++)
					{
						DataRow productRow = products.Rows[k];
						string type;
						if(productRow["Type"].ToString().Equals("CD"))
						{
							type = "Music";
						}
						else
						{
							type = "Book";
						}
						xmlContent = xmlContent + 
							"<product><type>" +
							type + 
							"</type><identifier>" +
							productRow["ISBN"].ToString() +
							"</identifier><name>" +
							productRow["Title"].ToString() + 
							"</name><quantity>" +
							productRow["Qty"].ToString() +
							"</quantity></product>";

					}
					xmlContent = xmlContent + "</order>";
					try
					{
						TextWriter output = new StreamWriter(file);
						output.WriteLine(xmlContent);
						output.Close();
					}
					catch(Exception ex)
					{
						Response.Write(ex.ToString());
					}
				}
			}

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ibSearch.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearch_Click);
			this.ibSearchCategories.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearchCategories_Click);
			this.dgItems.SelectedIndexChanged += new System.EventHandler(this.dgItems_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ibSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if(txtSearch.Text==""){
				lblSearchByError.Visible = true;
				return;
			}
			Response.Redirect("searchByField.aspx?searchBy=" + txtSearch.Text + "&ddlSearchBy=" + ddlSearchBy.SelectedItem.Value);
		}

		private void ibSearchCategories_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			string value = ddlCategories.SelectedValue;
			Response.Redirect("searchByCategory.aspx?&ddlSearchBy=" + value);
		}

		private void ddlProductType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string type;
			if(ddlProductType.SelectedIndex == 0)
			{
				type = "CD";
			}
			else
			{
				type = "Book";
			}
			DataSet objDS = Categories.getAllCategories(type);
			DataTable objDTCategories = new DataTable();
			objDTCategories = objDS.Tables[0];
			ddlCategories.DataSource = objDTCategories;
				
			ddlCategories.DataValueField = "categoryID";
			ddlCategories.DataTextField = "categoryName";	
			ddlCategories.DataBind();
		}

		private void dgItems_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

	}
}
