using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using prinsess_inventory.Classes;


namespace prinsess_inventory
{
	/// <summary>
	/// Summary description for purchaseAddressInfo.
	/// </summary>
	public class purchaseAddressInfo : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtSearch;
		protected System.Web.UI.WebControls.DropDownList ddlSearchBy;
		protected System.Web.UI.WebControls.ImageButton ibSearch;
		protected System.Web.UI.WebControls.DropDownList ddlProductType;
		protected System.Web.UI.WebControls.DropDownList ddlCategories;
		protected System.Web.UI.WebControls.ImageButton ibSearchCategories;
		protected System.Web.UI.WebControls.Label lblFirstName;
		protected System.Web.UI.WebControls.TextBox txtFirstName;
		protected System.Web.UI.WebControls.Label lblLastName;
		protected System.Web.UI.WebControls.TextBox txtLastName;
		protected System.Web.UI.WebControls.Label lblStreet;
		protected System.Web.UI.WebControls.TextBox txtStreet;
		protected System.Web.UI.WebControls.Label lblCity;
		protected System.Web.UI.WebControls.TextBox txtCity;
		protected System.Web.UI.WebControls.Label lblState;
		protected System.Web.UI.WebControls.TextBox txtState;
		protected System.Web.UI.WebControls.Label lblZip;
		protected System.Web.UI.WebControls.TextBox txtZip;
		protected System.Web.UI.WebControls.Label lblPhone;
		protected System.Web.UI.WebControls.TextBox txtPhone;
		protected System.Web.UI.WebControls.Label lblShipFirstName;
		protected System.Web.UI.WebControls.TextBox txtShipFirstName;
		protected System.Web.UI.WebControls.Label lblShipLastName;
		protected System.Web.UI.WebControls.TextBox txtShipLastName;
		protected System.Web.UI.WebControls.Label lblShipStreet;
		protected System.Web.UI.WebControls.TextBox txtShipStreet;
		protected System.Web.UI.WebControls.Label lblShipCity;
		protected System.Web.UI.WebControls.TextBox txtShipCity;
		protected System.Web.UI.WebControls.Label lblShipState;
		protected System.Web.UI.WebControls.TextBox txtShipState;
		protected System.Web.UI.WebControls.Label lblShipZip;
		protected System.Web.UI.WebControls.TextBox txtShipZip;
		protected System.Web.UI.WebControls.Label lblShipPhone;
		protected System.Web.UI.WebControls.TextBox txtShipPhone;
		protected System.Web.UI.WebControls.ImageButton next;
		protected System.Web.UI.WebControls.CheckBox cbSame;
		protected System.Web.UI.WebControls.Label lblSearchByError;
		protected System.Web.UI.WebControls.Panel Panel1;
		protected System.Web.UI.WebControls.Label lblSearchByCategory;
		
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			Customers.fillPanel(Panel1, Session["customerID"]);
			Customers.loginCheck(this, Session["customerID"]);

			if(!(Page.IsPostBack)){
				string type;
				if(ddlProductType.SelectedIndex == 0)
				{
					type = "CD";
				}
				else
				{
					type = "Book";
				}
				DataSet objDSa = Categories.getAllCategories(type);
				DataTable objDTCategories = new DataTable();
				objDTCategories = objDSa.Tables[0];
				ddlCategories.DataSource = objDTCategories;
				
				ddlCategories.DataValueField = "categoryID";
				ddlCategories.DataTextField = "categoryName";	
				ddlCategories.DataBind();
			}
			// Create the Manager 
			RollOverImageManager m = new RollOverImageManager(); 

			// Intialize the Image Controls 
			m.InitializeImage(ibSearch, "images/searchdown.jpg"); 
			m.InitializeImage(ibSearchCategories, "images/searchdown.jpg"); 

			// Load the Images (generate the JavaScript) 
			m.LoadImages(this); 
			
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ibSearch.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearch_Click);
			this.ddlProductType.SelectedIndexChanged += new System.EventHandler(this.ddlProductType_SelectedIndexChanged);
			this.ibSearchCategories.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearchCategories_Click);
			this.cbSame.CheckedChanged += new System.EventHandler(this.cbSame_CheckedChanged);
			this.next.Click += new System.Web.UI.ImageClickEventHandler(this.next_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void cbSame_CheckedChanged(object sender, System.EventArgs e)
		{
			if(cbSame.Checked)
			{
				txtShipFirstName.Text = txtFirstName.Text;
				txtShipFirstName.ReadOnly = true;
				txtShipLastName.Text = txtLastName.Text;
				txtShipLastName.ReadOnly = true;
				txtShipStreet.Text = txtStreet.Text;
				txtShipStreet.ReadOnly= true;
				txtShipCity.Text = txtCity.Text;
				txtShipCity.ReadOnly=true;
				txtShipState.Text = txtState.Text;
				txtShipState.ReadOnly = true;
				txtShipZip.Text = txtZip.Text;
				txtShipZip.ReadOnly = true;
				txtShipPhone.Text = txtPhone.Text;
				txtShipPhone.ReadOnly = true;
			}
			else
			{
				txtShipFirstName.Text = "";
				txtShipFirstName.ReadOnly = false;
				txtShipLastName.Text = "";
				txtShipLastName.ReadOnly = false;
				txtShipStreet.Text = "";
				txtShipStreet.ReadOnly= false;
				txtShipCity.Text = "";
				txtShipCity.ReadOnly=false;
				txtShipState.Text = "";
				txtShipState.ReadOnly = false;
				txtShipZip.Text = "";
				txtShipZip.ReadOnly = false;
				txtShipPhone.Text = "";
				txtShipPhone.ReadOnly = false;
			}
		}

		private void next_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			ContactInformation ci = new ContactInformation(txtFirstName.Text, 
				txtLastName.Text,	txtStreet.Text,txtCity.Text, txtState.Text, txtZip.Text,
				txtPhone.Text, txtShipFirstName.Text, txtShipLastName.Text, 
				txtShipStreet.Text, txtShipCity.Text, txtShipState.Text, txtShipZip.Text, 
				txtShipPhone.Text);
			Session["contactInfo"] = ci;
		}

		private void ibSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if(txtSearch.Text=="")
			{
				lblSearchByError.Visible = true;
				return;
			}
			Response.Redirect("searchByField.aspx?searchBy=" + txtSearch.Text + "&ddlSearchBy=" + ddlSearchBy.SelectedItem.Value);
		}

		private void ibSearchCategories_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			string value = ddlCategories.SelectedValue;
			Response.Redirect("searchByCategory.aspx?&ddlSearchBy=" + value);
		}

		private void ddlProductType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string type;
			if(ddlProductType.SelectedIndex == 0)
			{
				type = "CD";
			}
			else
			{
				type = "Book";
			}
			DataSet objDS = Categories.getAllCategories(type);
			DataTable objDTCategories = new DataTable();
			objDTCategories = objDS.Tables[0];
			ddlCategories.DataSource = objDTCategories;
				
			ddlCategories.DataValueField = "categoryID";
			ddlCategories.DataTextField = "categoryName";	
			ddlCategories.DataBind();
		}
	}
}
