using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using prinsess_inventory.Classes;

namespace prinsess_inventory
{
	/// <summary>
	/// Summary description for template.
	/// </summary>
	public class searchByField : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtSearch;
		protected System.Web.UI.WebControls.DropDownList ddlSearchBy;
		protected System.Web.UI.WebControls.DropDownList ddlProductType;
		protected System.Web.UI.WebControls.DropDownList ddlCategories;
		protected System.Web.UI.WebControls.ImageButton ibSearchCategories;
		protected System.Web.UI.WebControls.Label lblSearchByError;
		protected System.Web.UI.WebControls.Label lblSearchByCategory;
		protected System.Web.UI.WebControls.DataList dlProducts;
		protected System.Web.UI.WebControls.Panel Panel1;
		protected System.Web.UI.WebControls.ImageButton ibSearch;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			Customers.fillPanel(Panel1, Session["customerID"]);

			if(!(Page.IsPostBack))
			{
				string searchByText = "%" + Request.QueryString["searchBy"].Trim() + "%";
				string ddlSearchBy = Request.QueryString["ddlSearchBy"];
				DataTable results;
				if(ddlSearchBy.Equals("Author"))
				{
					results = Product.searchByAuthor(searchByText);
				}
				else if(ddlSearchBy.Equals("ISBN"))
				{
					results = Product.searchByISBN(searchByText);
				}
				else if(ddlSearchBy.Equals("Name"))
				{
					results = Product.searchByTitle(searchByText);
				}
				else
				{
					results = Product.searchByKeyword(searchByText);
				}
				dlProducts.DataSource = results;
				dlProducts.DataBind();
				for(int i = 0; i < results.Rows.Count; i++)
				{
					if(results.Rows[i]["productType"].Equals("CD"))
					{
						
							((System.Web.UI.WebControls.Image)dlProducts.Items[i].FindControl("productImage")).Width=75;
							((System.Web.UI.WebControls.Image)dlProducts.Items[i].FindControl("productImage")).Height=75;
						
					}
					else
					{
							((System.Web.UI.WebControls.Image)dlProducts.Items[i].FindControl("productImage")).Width=75;
							((System.Web.UI.WebControls.Image)dlProducts.Items[i].FindControl("productImage")).Height=100;
						
					}
				}
				
				string type;
				if(ddlProductType.SelectedIndex == 0)
				{
					type = "CD";
				}
				else
				{
					type = "Book";
				}
				DataSet objDSa = Categories.getAllCategories(type);
				DataTable objDTCategories = new DataTable();
				objDTCategories = objDSa.Tables[0];
				ddlCategories.DataSource = objDTCategories;
				
				ddlCategories.DataValueField = "categoryID";
				ddlCategories.DataTextField = "categoryName";	
				ddlCategories.DataBind();	
			}

			
			// Create the Manager 
			RollOverImageManager m = new RollOverImageManager(); 

			// Intialize the Image Controls 
			m.InitializeImage(ibSearch, "images/searchdown.jpg"); 
			m.InitializeImage(ibSearchCategories, "images/searchdown.jpg"); 

			// Load the Images (generate the JavaScript) 
			m.LoadImages(this); 




		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ibSearch.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearch_Click);
			this.ddlProductType.SelectedIndexChanged += new System.EventHandler(this.ddlProductType_SelectedIndexChanged);
			this.ibSearchCategories.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearchCategories_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ibSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if(txtSearch.Text=="")
			{
				lblSearchByError.Visible = true;
				return;
			}
			Response.Redirect("searchByField.aspx?searchBy=" + txtSearch.Text + "&ddlSearchBy=" + ddlSearchBy.SelectedItem.Value);
		}

		private void ibSearchCategories_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			string value = ddlCategories.SelectedValue;
			Response.Redirect("searchByCategory.aspx?&ddlSearchBy=" + value);
		}

		private void ddlProductType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string type;
			if(ddlProductType.SelectedIndex == 0)
			{
				type = "CD";
			}
			else
			{
				type = "Book";
			}
			DataSet objDS = Categories.getAllCategories(type);
			DataTable objDTCategories = new DataTable();
			objDTCategories = objDS.Tables[0];
			ddlCategories.DataSource = objDTCategories;
				
			ddlCategories.DataValueField = "categoryID";
			ddlCategories.DataTextField = "categoryName";	
			ddlCategories.DataBind();
		}
	}
}
