using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using prinsess_inventory.Classes;

namespace prinsess_inventory
{
	/// <summary>
	/// Summary description for viewShoppingCart.
	/// </summary>
	public class viewShoppingCart : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtSearch;
		protected System.Web.UI.WebControls.DropDownList ddlSearchBy;
		protected System.Web.UI.WebControls.DropDownList ddlProductType;
		protected System.Web.UI.WebControls.DropDownList ddlCategories;
		protected System.Web.UI.WebControls.ImageButton ibSearchCategories;
		protected System.Web.UI.WebControls.ImageButton ibSearch;
		protected System.Web.UI.WebControls.DataGrid dgProducts;
		protected System.Web.UI.WebControls.Label lblError;
		protected System.Web.UI.WebControls.Label lblSearchByError;
		protected System.Web.UI.WebControls.Label lblSearchByCategory;
		protected System.Web.UI.WebControls.Label lblWrongFormat;
		protected System.Web.UI.WebControls.DropDownList ddlChangeBillingInfo;
		protected System.Web.UI.WebControls.DropDownList ddlChangeShippingInfo;
		protected System.Web.UI.WebControls.ImageButton ibChangeShippingInfo;
		protected System.Web.UI.WebControls.ImageButton ibPurchaseButton;
		protected System.Web.UI.WebControls.TextBox recipName;
		protected System.Web.UI.WebControls.TextBox contactNum;
		protected System.Web.UI.WebControls.Panel Panel1;
		protected System.Web.UI.WebControls.ImageButton ibChangeBillingInfo;
		
//		protected System.Web.UI.WebControls.Label lblShippingName;
//		protected System.Web.UI.WebControls.Label lblShippingAddress;
//		protected System.Web.UI.WebControls.Label lblShippingCityStateZip;
//		protected System.Web.UI.WebControls.Label lblCardType;
//		protected System.Web.UI.WebControls.Label lblCardNumber;
//		protected System.Web.UI.WebControls.Label lblExpirationDate;
//		protected System.Web.UI.WebControls.Label lblCardholder;
//		protected System.Web.UI.WebControls.Label lblBillingAddress;
//		protected System.Web.UI.WebControls.Label lblBillingCityStateZip;


		private void Page_Load(object sender, System.EventArgs e)
		{
			Customers.fillPanel(Panel1, Session["customerID"]);
			Customers.loginCheck(this, Session["customerID"]);

			// Create the Manager 
			RollOverImageManager m = new RollOverImageManager(); 

			// Intialize the Image Controls 
			m.InitializeImage(ibSearch, "images/searchdown.jpg"); 
			m.InitializeImage(ibSearchCategories, "images/searchdown.jpg"); 

			// Load the Images (generate the JavaScript) 
			m.LoadImages(this); 
			if(!(Page.IsPostBack))
			{
				contactNum.Text = Customers.customerAttribute(Convert.ToInt32(Session["customerID"]), "phone");
				recipName.Text = Customers.customerAttribute(Convert.ToInt32(Session["customerID"]), "firstname") + " " + Customers.customerAttribute(Convert.ToInt32(Session["customerID"]), "lastname");

				////NEED TO DO
				DataTable products = ShoppingCart.viewCart(Convert.ToInt32(Session["customerID"])).Tables["products"];
				products.Columns.Add(new DataColumn("finalPrice", typeof(decimal)));
				for(int i = 0;i < products.Rows.Count;i++)
				{
					products.Rows[i]["origPrice"] = Convert.ToDecimal(products.Rows[i]["origPrice"]) + ((Convert.ToDecimal(products.Rows[i]["origPrice"]))*((Convert.ToDecimal(products.Rows[i]["fee"]))/100));
					products.Rows[i]["discount"] = Convert.ToDecimal(products.Rows[i]["discount"]);
					products.Rows[i]["finalPrice"] = Convert.ToDecimal(products.Rows[i]["origPrice"]) - Convert.ToDecimal(products.Rows[i]["discount"]);
				}
				dgProducts.DataSource = products;
				dgProducts.DataBind();
				string type;
				if(ddlProductType.SelectedIndex == 0)
				{
					type = "CD";
				}
				else
				{
					type = "Book";
				}
				DataSet objDSa = Categories.getAllCategories(type);
				DataTable objDTCategories = new DataTable();
				objDTCategories = objDSa.Tables[0];
				ddlCategories.DataSource = objDTCategories;
				
				ddlCategories.DataValueField = "categoryID";
				ddlCategories.DataTextField = "categoryName";	
				ddlCategories.DataBind();	

				DataTable objDTShippingAddresses = ContactInformation.getAllShippingAddresses(Convert.ToInt32(Session["customerID"]));
				ddlChangeShippingInfo.DataSource = objDTShippingAddresses;
				objDTShippingAddresses.Columns.Add("addressText");
				DataRow thisRow;
				for(int i = 0; i < objDTShippingAddresses.Rows.Count; i++)
				{
					thisRow = objDTShippingAddresses.Rows[i];
					string address = thisRow["address"].ToString();
					string city = thisRow["city"].ToString();
					string state = thisRow["state"].ToString();
					string zip = thisRow["zip"].ToString();
					string addressText = address + ", " + city + ", " + state + ", " + zip;
					thisRow["addressText"] =   addressText;
				}
				ddlChangeShippingInfo.DataValueField = "addressID";
				ddlChangeShippingInfo.DataTextField = "addressText";
				ddlChangeShippingInfo.DataBind();
				string shippingAddress = Request.QueryString["shippingAddressID"];
				if(shippingAddress != null)
				{
					ddlChangeShippingInfo.SelectedValue = shippingAddress;
				}
						

				DataTable objDTBillingInfo = ContactInformation.getAllPaymentMethods(Convert.ToInt32(Session["customerID"]));
				ddlChangeBillingInfo.DataSource = objDTBillingInfo;
				objDTBillingInfo.Columns.Add("billingText");
				DataRow thisBillingRow;
				for(int i = 0; i < objDTBillingInfo.Rows.Count; i++)
				{
					thisBillingRow = objDTBillingInfo.Rows[i];
					string cardnumber = thisBillingRow["cardnumber"].ToString();
					string cardholder = thisBillingRow["cardholder"].ToString();
					string billingInfo = "xxxx-xxxx-xxxx-" + cardnumber.Substring(12) + ", " + cardholder;
					thisBillingRow["billingText"] =   billingInfo;
				}
				ddlChangeBillingInfo.DataValueField = "creditcardID";
				ddlChangeBillingInfo.DataTextField = "billingText";
				ddlChangeBillingInfo.DataBind();
				string billingmethod = Request.QueryString["billingMethodID"];
				if(billingmethod != null)
				{
					ddlChangeBillingInfo.SelectedValue = billingmethod;
				}
				
				
			}

		
			
		}
		public void dgProducts_Delete(Object sender, DataGridCommandEventArgs e){
			int productID =(int)dgProducts.DataKeys[(int)e.Item.ItemIndex]; 
			ShoppingCart.deleteCartItem(productID, Convert.ToInt32(Session["customerID"]));
			dgProducts.EditItemIndex = -1;
			DataTable products = ShoppingCart.viewCart(Convert.ToInt32(Session["customerID"])).Tables["products"];
			products.Columns.Add(new DataColumn("finalPrice", typeof(decimal)));
			for(int i = 0;i < products.Rows.Count;i++)
			{
				products.Rows[i]["origPrice"] = Convert.ToDecimal(products.Rows[i]["origPrice"]);
				products.Rows[i]["discount"] = Convert.ToDecimal(products.Rows[i]["discount"]);
				products.Rows[i]["finalPrice"] = Convert.ToDecimal(products.Rows[i]["origPrice"]) - Convert.ToDecimal(products.Rows[i]["discount"]);
			}
			dgProducts.DataSource = products;
			dgProducts.DataBind();
		}
		public void dgProducts_Edit(Object sender, DataGridCommandEventArgs e)
		{
			dgProducts.EditItemIndex = (int)e.Item.ItemIndex;
			DataTable products = ShoppingCart.viewCart(Convert.ToInt32(Session["customerID"])).Tables["products"];
			products.Columns.Add(new DataColumn("finalPrice", typeof(decimal)));
			for(int i = 0;i < products.Rows.Count;i++)
			{
				products.Rows[i]["origPrice"] = Convert.ToDecimal(products.Rows[i]["origPrice"]);
				products.Rows[i]["discount"] = Convert.ToDecimal(products.Rows[i]["discount"]);
				products.Rows[i]["finalPrice"] = Convert.ToDecimal(products.Rows[i]["origPrice"]) - Convert.ToDecimal(products.Rows[i]["discount"]);
			}
			dgProducts.DataSource = products;
			dgProducts.DataBind();
		}
		public void dgProducts_Cancel(Object sender, DataGridCommandEventArgs e)
		{
			dgProducts.EditItemIndex = -1;
			DataTable products = ShoppingCart.viewCart(Convert.ToInt32(Session["customerID"])).Tables["products"];
			products.Columns.Add(new DataColumn("finalPrice", typeof(decimal)));
			for(int i = 0;i < products.Rows.Count;i++)
			{
				products.Rows[i]["origPrice"] = Convert.ToDecimal(products.Rows[i]["origPrice"]);
				products.Rows[i]["discount"] = Convert.ToDecimal(products.Rows[i]["discount"]);
				products.Rows[i]["finalPrice"] = Convert.ToDecimal(products.Rows[i]["origPrice"]) - Convert.ToDecimal(products.Rows[i]["discount"]);
			}
			dgProducts.DataSource = products;
			dgProducts.DataBind();
		}
		public void dgProducts_Update(Object sender, DataGridCommandEventArgs e)
		{
//			Response.Write(((System.Web.UI.WebControls.TextBox)e.Item.Cells[1].Controls[0]).ToString());
			//int productID = Convert.ToInt32(((System.Web.UI.WebControls.TextBox)e.Item.Cells[1].Controls[0]).Text);
			int productID = Convert.ToInt32(e.Item.Cells[2].Text);
			int customerID = Convert.ToInt32(Session["customerID"]);
			//Response.Write(productID);
			int qty = 0;
			try
			{
				qty = Convert.ToInt32(((System.Web.UI.WebControls.TextBox)e.Item.Cells[3].Controls[0]).Text);
			}
			catch(System.FormatException)
			{
				lblWrongFormat.Visible = true;
				return;
			}
			if(qty == 0)
			{
				ShoppingCart.deleteCartItem(productID, Convert.ToInt32(Session["customerID"]));
			}
			else
			{
				ShoppingCart.updateQuantityImm(qty, productID, Convert.ToInt32(Session["customerID"]));
			}

			//check to see if availabiltiy is that much in the first place:
			int amtInStock = ShoppingCart.checkAvailability(productID, customerID);
			if(amtInStock < qty)
			{
				lblError.Visible = true;
				return;
			}
			dgProducts.EditItemIndex = -1;
			DataTable products = ShoppingCart.viewCart(Convert.ToInt32(Session["customerID"])).Tables["products"];
			products.Columns.Add(new DataColumn("finalPrice", typeof(decimal)));
			for(int i = 0;i < products.Rows.Count;i++)
			{
				products.Rows[i]["origPrice"] = Convert.ToDecimal(products.Rows[i]["origPrice"]);
				products.Rows[i]["discount"] = Convert.ToDecimal(products.Rows[i]["discount"]);
				products.Rows[i]["finalPrice"] = (Convert.ToDecimal(products.Rows[i]["origPrice"]) - Convert.ToDecimal(products.Rows[i]["discount"]))*(Convert.ToInt32(products.Rows[i]["quantity"]));
			}
			dgProducts.DataSource = products;
			dgProducts.DataBind();

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ibSearch.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearch_Click);
			this.ddlProductType.SelectedIndexChanged += new System.EventHandler(this.ddlProductType_SelectedIndexChanged);
			this.ibSearchCategories.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearchCategories_Click);
			this.ibChangeShippingInfo.Click += new System.Web.UI.ImageClickEventHandler(this.ibChangeShippingInfo_Click);
			this.ibChangeBillingInfo.Click += new System.Web.UI.ImageClickEventHandler(this.ibChangeBillingInfo_Click);
			this.ibPurchaseButton.Click += new System.Web.UI.ImageClickEventHandler(this.ibPurchaseButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ibSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if(txtSearch.Text=="")
			{
				lblSearchByError.Visible = true;
				return;
			}
			Response.Redirect("searchByField.aspx?searchBy=" + txtSearch.Text + "&ddlSearchBy=" + ddlSearchBy.SelectedItem.Value);
		}

		private void ibSearchCategories_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			string value = ddlCategories.SelectedValue;
			Response.Redirect("searchByCategory.aspx?&ddlSearchBy=" + value);
		}

		private void ddlProductType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string type;
			if(ddlProductType.SelectedIndex == 0)
			{
				type = "CD";
			}
			else
			{
				type = "Book";
			}
			DataSet objDS = Categories.getAllCategories(type);
			DataTable objDTCategories = new DataTable();
			objDTCategories = objDS.Tables[0];
			ddlCategories.DataSource = objDTCategories;
				
			ddlCategories.DataValueField = "categoryID";
			ddlCategories.DataTextField = "categoryName";	
			ddlCategories.DataBind();
		}

		private void ibChangeBillingInfo_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			Response.Redirect("addBillingMethod.aspx?billingMethodID=" + ddlChangeBillingInfo.SelectedValue.ToString() + "&shippingAddressID=" + ddlChangeShippingInfo.SelectedValue + "&name=" + recipName.Text + "&contact=" + contactNum.Text);
		}

		private void ibChangeShippingInfo_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			Response.Redirect("addShippingAddress.aspx?billingMethodID=" + ddlChangeBillingInfo.SelectedValue.ToString() + "&shippingAddressID=" + ddlChangeShippingInfo.SelectedValue);
		}

		private void ibPurchaseButton_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			Response.Redirect("viewOptions.aspx?billingMethodID=" + ddlChangeBillingInfo.SelectedValue.ToString() + "&shippingAddressID=" + ddlChangeShippingInfo.SelectedValue + "&contact=" + contactNum.Text + "&name=" + recipName.Text);
		}

		
		
	}
}
