using System;
using System.Collections;
using System.Text.RegularExpressions;
using System.IO;
using System.ComponentModel;
using System.Data; 
using System.Drawing;
using System.Configuration;
using System.Data.SqlClient;
using System.Text; 
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Security.Cryptography;

namespace prinsess_inventory.Classes
{

	/// <summary>
	/// Summary description for Customers.
	/// </summary>
	public class Customers
	{

		public Customers()
		{
		}

		public static bool isManager(Object c) 
		{
			if (c == null || Convert.ToInt32(c) == -1) 
			{
				return false;
			} 
			if (Convert.ToInt32(c) == 1) 
			{ 
				return true;
			}
			return false;
		}

		public static bool invoiceCustomer(Page p, int invoiceID, Object c) 
		{
			if (c == null || Convert.ToInt32(c) == -1) 
			{
				p.Response.Redirect("login.aspx?w=true&redir=" + p.Request.RawUrl);
				return false;
			} 
			else 
			{
				SqlConnection sqlConn;	// Declare a connection object
				SqlCommand sqlCom;		  // Declare a command object
				SqlDataReader sqlRdr;	  // Declare a reader to read the query result

				// we'll trust attribute is an actual attribute...
				sqlConn = new SqlConnection( ConfigurationSettings.AppSettings.Get("connstringPhil"));
				sqlConn.Open();	// open the connection

				// make the new customer
				// fields are firstname, lastname, username, password, email, phone
				string strSql = 
					" SELECT buy_customerID " + 
					" FROM invoices " +
					" WHERE buy_customerID = " + Convert.ToInt32(c); 

				sqlCom = new SqlCommand(strSql, sqlConn);	
				sqlRdr = sqlCom.ExecuteReader();

				if (sqlRdr.Read()) 
				{
					return (Convert.ToInt32(sqlRdr.GetValue(0)) == Convert.ToInt32(c));
				} 
				else 
				{
					return false;
				}
                			
			}
		}

		public static void authorize(Page p, Object c) 
		{
			if (!isManager(c)) 
			{
				p.Response.Redirect("error.aspx");
			}
		}

		public static void loginCheck(Page p, Object c) 
		{
			if (c == null || Convert.ToInt32(c) == -1) 
			{
				p.Response.Redirect("login.aspx?w=true&redir=" + p.Request.RawUrl);
			}
		}

		public static void fillPanel(Panel p, Object c) 
		{
			if (c == null || Convert.ToInt32(c) == -1) 
			{
				// greeting
				Label g = new Label();
				g.Text = "Please sign in to see member options";
				g.Font.Size = FontUnit.XXSmall;
				g.Font.Bold = true; 
				p.Controls.Add(g);

				p.Controls.Add(new LiteralControl("<br>"));

				// login
				HyperLink li = new HyperLink();
				li.NavigateUrl = "login.aspx";
				li.Text = "Sign In";
				p.Controls.Add(li);
			
				p.Controls.Add(new LiteralControl("<br>"));

				// register
				HyperLink reg = new HyperLink();
				reg.NavigateUrl = "register.aspx";
				reg.Text = "Register With Us!";
				p.Controls.Add(reg);
			} 
			else 
			{
				int customerID = Convert.ToInt32(c);
				
				// greeting
				Label l = new Label();
				l.Text = "Hello, " + customerAttribute(customerID, "firstname");	
				l.Font.Size = FontUnit.XXSmall;
				l.Font.Bold = true; 
				p.Controls.Add(l);
				
				p.Controls.Add(new LiteralControl("<br>"));
				
				// personal page
				HyperLink cp = new HyperLink();
				cp.NavigateUrl = "customer.aspx";
				cp.Text = "View Your Personal Page";
				p.Controls.Add(cp);
				
				p.Controls.Add(new LiteralControl("<br>"));
				
				// shopping cart
				HyperLink sc = new HyperLink();
				sc.NavigateUrl = "viewShoppingCart.aspx";
				sc.Text = "View Shopping Cart";
				p.Controls.Add(sc);
				
				p.Controls.Add(new LiteralControl("<br>"));

				// edit attributes
				HyperLink at = new HyperLink();
				at.NavigateUrl = "customer_edit.aspx";
				at.Text = "Edit Account Settings";
				p.Controls.Add(at);

				p.Controls.Add(new LiteralControl("<br>"));

				if (isManager(c)) 
				{

					p.Controls.Add(new LiteralControl("<br>"));
					// manager greeting
					Label l1 = new Label();
					l1.Text = "Management tools";	
					l1.Font.Size = FontUnit.XXSmall;
					l1.Font.Bold = true; 
					p.Controls.Add(l1);
				
					p.Controls.Add(new LiteralControl("<br>"));
				
					// sale amount
					HyperLink m1 = new HyperLink();
					m1.NavigateUrl = "getTotalSalesPerProduct.aspx";
					m1.Text = "Sale Amount";
					p.Controls.Add(m1);
				
					p.Controls.Add(new LiteralControl("<br>"));
				
					// shipping methods
					HyperLink m2 = new HyperLink();
					m2.NavigateUrl = "givenACity.aspx";
					m2.Text = "Shipping Methods";
					p.Controls.Add(m2);
				
					p.Controls.Add(new LiteralControl("<br>"));

					// warehouse info
					HyperLink m3 = new HyperLink();
					m3.NavigateUrl = "viewWarehouses.aspx";
					m3.Text = "Warehouse Information";
					p.Controls.Add(m3);

					p.Controls.Add(new LiteralControl("<br>"));

				}

				// logout
				HyperLink lo = new HyperLink();
				lo.NavigateUrl = "login.aspx?logout=true";
				lo.Text = "Log Out";
				p.Controls.Add(lo);

			}
		}

		public static String customerAttribute(int customerID, string attribute) 
		{
			SqlConnection sqlConn;	// Declare a connection object
			SqlCommand sqlCom;		  // Declare a command object
			SqlDataReader sqlRdr;	  // Declare a reader to read the query result

			// we'll trust attribute is an actual attribute...
			sqlConn = new SqlConnection( ConfigurationSettings.AppSettings.Get("connstringPhil"));
			sqlConn.Open();	// open the connection

			// make the new customer
			// fields are firstname, lastname, username, password, email, phone
			string strSql = 
				"SELECT " + attribute + " FROM customers " +
				" WHERE customerID = " + customerID; 

			sqlCom = new SqlCommand(strSql, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.Read()) 
			{
				return Convert.ToString(sqlRdr.GetValue(0));
			} 
			else 
			{
				sqlConn.Close();
				return null;
			}
		}

		public static String customerAddress(int customerID, string attribute) 
		{
			return "hi";
		}

		public static bool userExists(string username)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringPhil");
			SqlConnection objConn = new SqlConnection(connectionString);
			SqlCommand objCommand = new SqlCommand("userExists", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objCommand.Parameters.Add("@username", SqlDbType.VarChar, 50);
			objCommand.Parameters["@username"].Value = username;

			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			objDataAdapter.Fill(objDataSet,"customers");
			if(objDataSet.Tables["customers"].Rows.Count >= 1)
			{
				return true;
			}
			else
			{
				return false;
			}
		}

		public static int isAuthenticated(string username, string password)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringPhil");
			SqlConnection objConn = new SqlConnection(connectionString);
			SqlCommand objCommand = new SqlCommand("sp_getUsers", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objCommand.Parameters.Add("@username", SqlDbType.VarChar, 50);
			objCommand.Parameters["@username"].Value = username;
			objCommand.Parameters.Add("@password", SqlDbType.VarChar, 50);
			objCommand.Parameters["@password"].Value = password;

			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"customers");
			objConn.Close();
			if(objDataSet.Tables["customers"].Rows.Count == 1)
			{
				return Convert.ToInt32(objDataSet.Tables["customers"].Rows[0]["customerID"]);
			}
			else
			{
				return -1;
			}
		}
	}
}