using System;
using System.Collections;
using System.Text.RegularExpressions;
using System.IO;
using System.ComponentModel;
using System.Data; 
using System.Drawing;
using System.Configuration;
using System.Data.SqlClient;
using System.Text; 
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Security.Cryptography;

namespace prinsess_inventory.Classes
{
	/// <summary>
	/// Summary description for ShoppingCart.
	/// </summary>
	public class ShoppingCart
	{
		public ShoppingCart()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public static bool productInCart(int productID, int customerID){
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_inCart", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;

			objCommand.Parameters.Add("@productID", SqlDbType.Int);
			objCommand.Parameters["@productID"].Value = productID;
			
			objCommand.Parameters.Add("@customerID", SqlDbType.Int);
			objCommand.Parameters["@customerID"].Value = customerID;

			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"products");
			if(objDataSet.Tables["products"].Rows.Count > 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}

		public static void updateQuantity(int amt, int productID, int customerID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_updateCartQuantity", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@productID", SqlDbType.Int);
			objCommand.Parameters["@productID"].Value = productID;
			
			objCommand.Parameters.Add("@customerID", SqlDbType.Int);
			objCommand.Parameters["@customerID"].Value = customerID;

			objCommand.Parameters.Add("@amt", SqlDbType.Int);
			objCommand.Parameters["@amt"].Value = amt;

			objCommand.ExecuteNonQuery();
			objConn.Close();
		}

		public static void updateQuantityImm(int amt, int productID, int customerID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_updateCartQuantityImm", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@productID", SqlDbType.Int);
			objCommand.Parameters["@productID"].Value = productID;
			
			objCommand.Parameters.Add("@customerID", SqlDbType.Int);
			objCommand.Parameters["@customerID"].Value = customerID;

			objCommand.Parameters.Add("@amt", SqlDbType.Int);
			objCommand.Parameters["@amt"].Value = amt;

			objCommand.ExecuteNonQuery();
			objConn.Close();
		}

		public static void addIntoCart(int productID, int customerID, int amt)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_addProductInCart", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@productID", SqlDbType.Int);
			objCommand.Parameters["@productID"].Value = productID;
			
			objCommand.Parameters.Add("@customerID", SqlDbType.Int);
			objCommand.Parameters["@customerID"].Value = customerID;

			objCommand.Parameters.Add("@amt", SqlDbType.Int);
			objCommand.Parameters["@amt"].Value = amt;

			objCommand.ExecuteNonQuery();
			objConn.Close();
		}

		public static DataSet viewCart(int customerID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_viewShoppingCart", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			
			objCommand.Parameters.Add("@customerID", SqlDbType.Int);
			objCommand.Parameters["@customerID"].Value = customerID;

			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"products");
			return objDataSet;
		}

		public static void deleteCartItem(int productID, int customerID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_deleteCartItem", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@productID", SqlDbType.Int);
			objCommand.Parameters["@productID"].Value = productID;
			
			objCommand.Parameters.Add("@customerID", SqlDbType.Int);
			objCommand.Parameters["@customerID"].Value = customerID;

			objCommand.ExecuteNonQuery();
			objConn.Close();
		}

		public static int checkAvailability(int productID, int customerID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_checkAvailability", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@productID", SqlDbType.Int);
			objCommand.Parameters["@productID"].Value = productID;
			objCommand.Parameters.Add("@customerID", SqlDbType.Int);
			objCommand.Parameters["@customerID"].Value = customerID;

			objCommand.ExecuteNonQuery();
			objConn.Close();

			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"products");
			int amtInStock;
			if(objDataSet.Tables[0].Rows[0]["amt"].Equals(System.DBNull.Value))
			{
				amtInStock = 0;
			}
			else
			{
				amtInStock = Convert.ToInt32(objDataSet.Tables[0].Rows[0]["amt"]);
			}
			return amtInStock;
		}
	}
}
