using System;
using System.Collections;
using System.Text.RegularExpressions;
using System.IO;
using System.ComponentModel;
using System.Data; 
using System.Drawing;
using System.Configuration;
using System.Data.SqlClient;
using System.Text; 
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Security.Cryptography;

namespace prinsess_inventory.Classes
{
	/// <summary>
	/// Summary description for Warehouse.
	/// </summary>
	public class Warehouse
	{
		public Warehouse()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public static DataTable viewProductsPerWarehouse(int warehouseID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringPhil");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_viewProductsPerWarehouse", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@warehouseID", SqlDbType.Int);
			objCommand.Parameters["@warehouseID"].Value = warehouseID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewItems");
			DataTable objDataTable = objDataSet.Tables["viewItems"];
			

			return objDataTable;
		}

		public static DataTable viewVendorsPerWarehouse(int warehouseID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstringPhil");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_viewVendorsPerWarehouse", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@warehouseID", SqlDbType.Int);
			objCommand.Parameters["@warehouseID"].Value = warehouseID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewVendors");
			DataTable objDataTable = objDataSet.Tables["viewVendors"];
			

			return objDataTable;
		}

		public static DataTable viewAvailableProductsPerWarehouse(int warehouseID)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_viewAvailableProducts", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@warehouseID", SqlDbType.Int);
			objCommand.Parameters["@warehouseID"].Value = warehouseID;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewVendors");
			DataTable objDataTable = objDataSet.Tables["viewVendors"];
			

			return objDataTable;
		}

		public static DataTable getWarehouses()
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_getWarehouses", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewWarehouses");
			DataTable objDataTable = objDataSet.Tables["viewWarehouses"];
			

			return objDataTable;
		}
		public static DataTable givenACity(string city)
		{
			string connectionString = ConfigurationSettings.AppSettings.Get("connstring");
			SqlConnection objConn = new SqlConnection(connectionString);

			SqlCommand objCommand = new SqlCommand("sp_methodsPerCity", objConn);
			objCommand.CommandType = CommandType.StoredProcedure;
			objConn.Open();

			objCommand.Parameters.Add("@city", SqlDbType.VarChar, 50);
			objCommand.Parameters["@city"].Value = city;

			objConn.Close();
			
			//pipe that transfers all the information from database to the dataset
			SqlDataAdapter objDataAdapter = new SqlDataAdapter();
			objDataAdapter.SelectCommand = objCommand; //gonna use the command object
			DataSet objDataSet = new DataSet();//create the virutal database
			
			objDataAdapter.Fill(objDataSet,"viewMethods");
			DataTable objDataTable = objDataSet.Tables["viewMethods"];
			

			return objDataTable;
		}


	}
}
