using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using prinsess_inventory.Classes;
using System.Data.SqlClient;
using System.Configuration;

namespace prinsess_inventory
{
	/// <summary>
	/// Summary description for login.
	/// </summary>
	public class login : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtSearch;
		protected System.Web.UI.WebControls.DropDownList ddlSearchBy;
		protected System.Web.UI.WebControls.DropDownList ddlProductType;
		protected System.Web.UI.WebControls.DropDownList ddlCategories;
		protected System.Web.UI.WebControls.ImageButton ibSearchCategories;
		protected System.Web.UI.WebControls.TextBox txtUsername;
		protected System.Web.UI.WebControls.TextBox txtPassword;
		protected System.Web.UI.WebControls.ImageButton ibSubmit;
		protected System.Web.UI.WebControls.Label lblError;
		protected System.Web.UI.WebControls.ImageButton ibSearch;
		
		protected System.Web.UI.WebControls.Label lblSearchByError;
		protected System.Web.UI.WebControls.Panel pCustomer;
		protected System.Web.UI.WebControls.Label lblLogin;
		protected System.Web.UI.WebControls.Label lblSearchByCategory;
		
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			lblLogin.Visible = false;

			if ((Request.QueryString["logout"] != null) && (Session["customerID"] != null) && (Convert.ToInt32(Session["customerID"]) != -1)) 
			{
				lblLogin.Visible = true;
				lblLogin.Text = "You have successfully logged out<br><br>";
				Session["customerID"] = -1;
			}

			Customers.fillPanel(pCustomer, Session["customerID"]);

			if(!(Page.IsPostBack))
			{

				string type;
				if(ddlProductType.SelectedIndex == 0)
				{
					type = "CD";
				}
				else
				{
					type = "Book";
				}
				DataSet objDS = Categories.getAllCategories(type);
				DataTable objDTCategories = new DataTable();
				objDTCategories = objDS.Tables[0];
				ddlCategories.DataSource = objDTCategories;
				
				ddlCategories.DataValueField = "categoryID";
				ddlCategories.DataTextField = "categoryName";	
				ddlCategories.DataBind();
			}

			
			// Create the Manager 
			RollOverImageManager m = new RollOverImageManager(); 

			// Intialize the Image Controls 
			m.InitializeImage(ibSearch, "images/searchdown.jpg"); 
			m.InitializeImage(ibSearchCategories, "images/searchdown.jpg"); 

			// Load the Images (generate the JavaScript) 
			m.LoadImages(this); 

			if (Request.QueryString["w"] != null) 
			{
				lblLogin.Visible = true;
				lblLogin.Text = "You must log in to view this page<br><br>";
			}


		}
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ibSearch.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearch_Click);
			this.ddlProductType.SelectedIndexChanged += new System.EventHandler(this.ddlProductType_SelectedIndexChanged);
			this.ibSearchCategories.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearchCategories_Click);
			this.ibSubmit.Click += new System.Web.UI.ImageClickEventHandler(this.ibSubmit_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
		private void doQuery(string query, string dbconn) 
		{
			SqlCommand sqlCom;
			SqlDataReader sqlRdr;
			SqlConnection sqlConn = new SqlConnection( ConfigurationSettings.AppSettings.Get(dbconn));
			sqlConn.Open();	// open the connection
			sqlCom = new SqlCommand(query, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
			sqlRdr.Close();
			sqlConn.Close();
		}

		private void ibSubmit_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			int authenticated = Customers.isAuthenticated(txtUsername.Text, txtPassword.Text);
			if(authenticated != -1)
			{
				Session["customerID"] = authenticated;
				if (Request.QueryString["redir"] != null) 
				{
					Response.Redirect(Convert.ToString(Request.QueryString["redir"]));
				} 
				else 
				{
					Response.Redirect("customer.aspx");
				}
			}
			else
			{
				lblError.Visible = true;
				Session["customerID"] = -1;
			}
		}

		private void ibSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if(txtSearch.Text=="")
			{
				lblSearchByError.Visible = true;
				return;
			}
			Response.Redirect("searchByField.aspx?searchBy=" + txtSearch.Text + "&ddlSearchBy=" + ddlSearchBy.SelectedItem.Value);
		}

		private void ibSearchCategories_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			string value = ddlCategories.SelectedValue;
			Response.Redirect("searchByCategory.aspx?&ddlSearchBy=" + value);
		}

		private void ddlProductType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string type;
			if(ddlProductType.SelectedIndex == 0)
			{
				type = "CD";
			}
			else
			{
				type = "Book";
			}
			DataSet objDS = Categories.getAllCategories(type);
			DataTable objDTCategories = new DataTable();
			objDTCategories = objDS.Tables[0];
			ddlCategories.DataSource = objDTCategories;
				
			ddlCategories.DataValueField = "categoryID";
			ddlCategories.DataTextField = "categoryName";	
			ddlCategories.DataBind();
		}
	}
}
