using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using prinsess_inventory.Classes;
using Microsoft.VisualBasic;

namespace prinsess_inventory
{
	/// <summary>
	/// Summary description for productDetails.
	/// </summary>
	public class productDetails : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtSearch;
		protected System.Web.UI.WebControls.DropDownList ddlSearchBy;
		protected System.Web.UI.WebControls.ImageButton ibSearch;
		protected System.Web.UI.WebControls.DropDownList ddlProductType;
		protected System.Web.UI.WebControls.DropDownList ddlCategories;
		protected System.Web.UI.WebControls.ImageButton ibSearchCategories;
		protected System.Web.UI.WebControls.ImageButton ibUpdate;
		protected System.Web.UI.WebControls.Label lblError;
		protected System.Web.UI.WebControls.Label lblSearchByError;
		protected System.Web.UI.WebControls.Label lblSearchByCategory;
		protected System.Web.UI.WebControls.Label lblWrongFormat;
		protected System.Web.UI.WebControls.Panel Panel1;

		protected System.Web.UI.WebControls.DataList dlProduct;
		private void Page_Load(object sender, System.EventArgs e)
		{
			Customers.fillPanel(Panel1, Session["customerID"]);

			// Create the Manager 
			RollOverImageManager m = new RollOverImageManager(); 

			// Intialize the Image Controls 
			m.InitializeImage(ibSearch, "images/searchdown.jpg"); 
			m.InitializeImage(ibSearchCategories, "images/searchdown.jpg"); 

			// Load the Images (generate the JavaScript) 
			m.LoadImages(this); 
			if(!(Page.IsPostBack))
			{
				DataTable objDT;
				int productID = Convert.ToInt32(Request.QueryString["ProductID"]);
				objDT = Product.getProductInfo(productID);
				dlProduct.DataSource = objDT;
				dlProduct.DataBind();
				for(int i = 0; i< dlProduct.Items.Count; i++)
				{
					if(objDT.Rows[i]["origPrice"].ToString().Equals("Not Currently Available"))
					{
						((System.Web.UI.WebControls.Label)dlProduct.Items[i].FindControl("lblQuantity")).Visible = false;
						((System.Web.UI.WebControls.TextBox)dlProduct.Items[i].FindControl("txtQuantity")).Visible = false;
						((System.Web.UI.WebControls.ImageButton)dlProduct.Items[i].FindControl("ibUpdate")).Visible = false;
						
					}
				}
				if(objDT.Rows[0]["productType"].Equals("CD"))
				{
					((System.Web.UI.WebControls.Image)dlProduct.Items[0].FindControl("productImage")).Width=125;
					((System.Web.UI.WebControls.Image)dlProduct.Items[0].FindControl("productImage")).Height=125;
				}
				else
				{
					((System.Web.UI.WebControls.Image)dlProduct.Items[0].FindControl("productImage")).Width=125;
					((System.Web.UI.WebControls.Image)dlProduct.Items[0].FindControl("productImage")).Height=167;
				}
				string type;
				if(ddlProductType.SelectedIndex == 0)
				{
					type = "CD";
				}
				else
				{
					type = "Book";
				}
				DataSet objDSa = Categories.getAllCategories(type);
				DataTable objDTCategories = new DataTable();
				objDTCategories = objDSa.Tables[0];
				ddlCategories.DataSource = objDTCategories;
				
				ddlCategories.DataValueField = "categoryID";
				ddlCategories.DataTextField = "categoryName";	
				ddlCategories.DataBind();

				//need to set the controltovalidate for the comparevalidator
				//cvQuantity.ControlToValidate = "((System.Web.UI.WebControls.TextBox)dlProduct.Items[0].FindControl("txtQuantity"))";
			}
		}


		public void dlProduct_Update(Object sender, DataListCommandEventArgs e) 
		{
			if(Session["customerID"] == null)
			{
				Response.Redirect("login.aspx");
			}
			string bleh = ((TextBox)dlProduct.Items[0].FindControl("txtQuantity")).Text;
			int productID = Convert.ToInt32(Request.QueryString["ProductID"]);
			int amt;
			try
			{
				amt = Convert.ToInt32(((TextBox)dlProduct.Items[0].FindControl("txtQuantity")).Text);	
			}
			catch(System.FormatException)
			{
				lblWrongFormat.Visible = true;
				return;
			}
			lblWrongFormat.Visible = false;
			int customerID = Convert.ToInt32(Session["customerID"]);
			
			if(amt == 0)
			{
				return;
			}
			//check to see if availabiltiy is that much in the first place:
			int amtInStock = ShoppingCart.checkAvailability(productID, customerID);
			if(amtInStock < amt)
			{
				lblError.Visible = true;
				return;
			}
			//check to see if there is an instance of that type of product in the shopping cart already
			if(ShoppingCart.productInCart(productID, customerID))
			{
				//need to update the quantity of that product in the shopping cart
				ShoppingCart.updateQuantity(amt, productID, customerID);

			}
			else
			{
				//need to insert a new record into the cart
				ShoppingCart.addIntoCart(productID, customerID, amt);
			}
			((TextBox)dlProduct.Items[0].FindControl("txtQuantity")).Text = "";
			lblError.Visible = false;
				
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ibSearch.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearch_Click);
			this.ddlProductType.SelectedIndexChanged += new System.EventHandler(this.ddlProductType_SelectedIndexChanged);
			this.ibSearchCategories.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearchCategories_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ibSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if(txtSearch.Text=="")
			{
				lblSearchByError.Visible = true;
				return;
			}
			Response.Redirect("searchByField.aspx?searchBy=" + txtSearch.Text + "&ddlSearchBy=" + ddlSearchBy.SelectedItem.Value);
		}

		private void ibSearchCategories_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			string value = ddlCategories.SelectedValue;
			Response.Redirect("searchByCategory.aspx?&ddlSearchBy=" + value);
		}

		private void ddlProductType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string type;
			if(ddlProductType.SelectedIndex == 0)
			{
				type = "CD";
			}
			else
			{
				type = "Book";
			}
			DataSet objDS = Categories.getAllCategories(type);
			DataTable objDTCategories = new DataTable();
			objDTCategories = objDS.Tables[0];
			ddlCategories.DataSource = objDTCategories;
				
			ddlCategories.DataValueField = "categoryID";
			ddlCategories.DataTextField = "categoryName";	
			ddlCategories.DataBind();
		}



	}
}
