using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using prinsess_inventory.Classes;

namespace prinsess_inventory
{
	/// <summary>
	/// Summary description for viewOptions.
	/// </summary>
	public class viewOptions : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtSearch;
		protected System.Web.UI.WebControls.DropDownList ddlSearchBy;
		protected System.Web.UI.WebControls.DropDownList ddlProductType;
		protected System.Web.UI.WebControls.DropDownList ddlCategories;
		protected System.Web.UI.WebControls.ImageButton ibSearchCategories;
		protected System.Web.UI.WebControls.Label lblSearchByError;
		protected System.Web.UI.WebControls.Label lblSearchByCategory;
		protected System.Web.UI.WebControls.DataGrid dgPkgs;
		protected System.Web.UI.WebControls.DataGrid dgItems;
		protected System.Web.UI.WebControls.Label ChooseOptlbl;
		protected System.Web.UI.WebControls.Label ChooseOpt2lbl;
		protected System.Web.UI.WebControls.ImageButton ibSearch;
		protected System.Web.UI.WebControls.DataGrid dgItems2;
		protected System.Web.UI.WebControls.Button updNotesBtn;
		protected System.Web.UI.WebControls.TextBox NotesBox;
		protected System.Web.UI.WebControls.Label itemslbl;
		protected System.Web.UI.WebControls.Label items2lbl;
		protected System.Web.UI.WebControls.Label Noteslbl;
		protected System.Web.UI.WebControls.Label Packageslbl;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.ImageButton ibNextButton;
		protected System.Web.UI.WebControls.Label warninglbl;
		protected System.Web.UI.WebControls.Panel Panel1;

		static int currPkg;
		
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			Customers.fillPanel(Panel1, Session["customerID"]);
			Customers.loginCheck(this, Session["customerID"]);

			if(!(Page.IsPostBack))
			{
				Session["shipPrices"] = new Hashtable(1000);	
				string type;
				if(ddlProductType.SelectedIndex == 0)
				{
					type = "CD";
				}
				else
				{
					type = "Book";
				}
				DataSet objDS = Categories.getAllCategories(type);
				DataTable objDTCategories = new DataTable();
				objDTCategories = objDS.Tables[0];
				ddlCategories.DataSource = objDTCategories;
				
				ddlCategories.DataValueField = "categoryID";
				ddlCategories.DataTextField = "categoryName";	
				ddlCategories.DataBind();

				int custID = Convert.ToInt32(Session["customerID"].ToString());
				int shippingID = Convert.ToInt32(Request.QueryString["shippingAddressID"]);
				DataTable addyInfo = Product.getAddressInfo(shippingID);
				string contact = Request.QueryString["contact"];
				string name = Request.QueryString["name"];
				//get necessary info
				string city = addyInfo.Rows[0]["city"].ToString();
				string state = addyInfo.Rows[0]["state"].ToString();
				string address = addyInfo.Rows[0]["address"].ToString();

				string PkgsQuery = Product.package(this, custID, city, state, address, name, contact);   /*data returned from package mthd*/

				Session["PkgsQuery"] = PkgsQuery;
			} //end if not postback

			// Create the Manager 
			RollOverImageManager m = new RollOverImageManager(); 

			// Intialize the Image Controls 
			m.InitializeImage(ibSearch, "images/searchdown.jpg"); 
			m.InitializeImage(ibSearchCategories, "images/searchdown.jpg"); 

			// Load the Images (generate the JavaScript) 
			m.LoadImages(this); 

			//run pkging query over ea/ warehouse
          
			loadPkgs();


		} //end page load

		public void loadPkgs()
		{			

			dgPkgs.DataSource = Product.runQuery(Session["PkgsQuery"].ToString());
			dgPkgs.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.dgItems.SelectedIndexChanged += new System.EventHandler(this.dgItems_SelectedIndexChanged);
			this.updNotesBtn.Click += new System.EventHandler(this.updNotesBtn_Click);
			this.ibNextButton.Click += new System.Web.UI.ImageClickEventHandler(this.ibNextButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ibSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if(txtSearch.Text=="")
			{
				lblSearchByError.Visible = true;
				return;
			}
			Response.Redirect("searchByField.aspx?searchBy=" + txtSearch.Text + "&ddlSearchBy=" + ddlSearchBy.SelectedItem.Value);
		}

		private void ibSearchCategories_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			string value = ddlCategories.SelectedValue;
			Response.Redirect("searchByCategory.aspx?&ddlSearchBy=" + value);
		}

		private void ddlProductType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string type;
			if(ddlProductType.SelectedIndex == 0)
			{
				type = "CD";
			}
			else
			{
				type = "Book";
			}
			DataSet objDS = Categories.getAllCategories(type);
			DataTable objDTCategories = new DataTable();
			objDTCategories = objDS.Tables[0];
			ddlCategories.DataSource = objDTCategories;
				
			ddlCategories.DataValueField = "categoryID";
			ddlCategories.DataTextField = "categoryName";	
			ddlCategories.DataBind();
		}

		//Some command was hit, determine here:
		public void PkgCommand (Object sender, DataGridCommandEventArgs e) 
		{     
			

			// e.Item is the row of the table where the command fired
			// For bound columns the value is stored in the Text property of TableCell
			TableCell pkgCell = e.Item.Cells[2]; //get pkgID from datagrid1
			string pkg = pkgCell.Text;
			int pkgNum = Convert.ToInt16(pkg);
			currPkg = pkgNum; //to keep track of later
			DataTable objDT;

			if (((LinkButton)e.CommandSource).CommandName == "seeOptions") //user wants to view options
			{
				objDT =  Product.cheapestMthdperOpt(pkgNum); 
				dgItems.DataSource = objDT;
				dgItems.DataBind();
				dgItems.Visible = true;
				
				ChooseOptlbl.Visible = true;
				ChooseOpt2lbl.Text = pkg;
				ChooseOpt2lbl.Visible = true;	
			} 
			else if (((LinkButton)e.CommandSource).CommandName == "viewItems") //User wants to view items
			{
				objDT =  Product.getItems(pkgNum);
				dgItems2.DataSource = objDT;
				dgItems2.DataBind();
				dgItems2.Visible = true;
				itemslbl.Visible = true;
				items2lbl.Text = pkg;
				items2lbl.Visible = true;
			} 
			else //User wants to edit notes
			{
				string notes = Product.getNotes(currPkg);
				NotesBox.Text = notes;
				updNotesBtn.Visible = true;
				NotesBox.Visible = true;
				Noteslbl.Visible = true;
			}
		}

		//Sets selected method for current package
		public void choseOptionCmd(Object sender, DataGridCommandEventArgs e) 
		{     
			// e.Item is the row of the table where the command fired
			// For bound columns the value is stored in the Text property of TableCell
				
			//TableCell	 mthdCell = e.Item.Cells[4];//get mthdID from displayed datagrid2
					
			if (((Hashtable)Session["shipPrices"]).ContainsKey(dgItems.DataKeys[e.Item.DataSetIndex])) 
			{
				((Hashtable)Session["shipPrices"]).Remove(dgItems.DataKeys[e.Item.DataSetIndex]);
			}

			((Hashtable)Session["shipPrices"]).Add(dgItems.DataKeys[e.Item.DataSetIndex], Convert.ToDouble((e.Item.Cells[4]).Text));
			
            
			int mthdID = Convert.ToInt32(dgItems.DataKeys[e.Item.DataSetIndex]);
			//string methodID = mthdCell.Text;
			//int mthdID = Convert.ToInt16(methodID);
			Product.setMethodForPkg(currPkg, mthdID);
			loadPkgs(); //reload Pkgs screen w/ updated data

		}

		//Update notes
		private void updNotesBtn_Click(object sender, System.EventArgs e)
		{
			string notes = NotesBox.Text;
			Product.setNotes(currPkg, notes);
		}

		//TO DO - give invoice# to Phil, but check before that all methods have been assigned (!=1)
		//
		//have setmethod also set dtime
		//add option to mark as fragile
		//
		//CHANGED TODAY: added Product methods, replace viewOptions, main/viewHist temp changed
		// opt: add a note to all pkgs
		private void ibNextButton_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			DataTable temp = Product.runQuery(Session["PkgsQuery"].ToString());
			
			bool allSelected = true;

			for(int i = 0; i < temp.Rows.Count; i++)
			{
				if (Convert.ToInt32(temp.Rows[i]["methodID"]) == 1)
				{
					allSelected = false;
				}
			}

			if(allSelected) // methods haave been selected
			{
				warninglbl.Visible = false;
				int invoiceID = Convert.ToInt32(Session["invoiceID"]);
				double shippingCost = 0;
				IEnumerator enumr = ((Hashtable)Session["shipPrices"]).Values.GetEnumerator();
				while (enumr.MoveNext()) 
				{
					shippingCost += Convert.ToDouble(enumr.Current);
				}
				Session["shipPrices"] = null;
				Product.doQuery("UPDATE invoices SET shippingcost = " + shippingCost + " WHERE invoiceID = " + invoiceID, "connstringPhil");
				Product.doQuery("UPDATE invoices SET total = total + " + shippingCost + " WHERE invoiceID = " + invoiceID, "connstringPhil");
				Response.Redirect("invoice.aspx?invoiceID=" + invoiceID + "&trans=true");
			} 
			else 
			{
				warninglbl.Visible = true;
			}
		}

		private void dgItems_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}
	}
}
