using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using prinsess_inventory.Classes;

namespace prinsess_inventory
{
	/// <summary>
	/// Summary description for viewProducts.
	/// </summary>
	public class viewProducts : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataList dlProducts;
		protected System.Web.UI.WebControls.TextBox txtSearch;
		protected System.Web.UI.WebControls.DropDownList ddlSearchBy;
		protected System.Web.UI.WebControls.ImageButton ibSearch;
		protected System.Web.UI.WebControls.DropDownList ddlProductType;
		protected System.Web.UI.WebControls.DropDownList ddlCategories;
		protected System.Web.UI.WebControls.ImageButton ibSearchCategories;
		protected System.Web.UI.WebControls.DropDownList ddlChoose;
		protected System.Web.UI.WebControls.Image productImage;
		protected System.Web.UI.WebControls.Label lblSearchByError;
		protected System.Web.UI.WebControls.Panel Panel1;
		protected System.Web.UI.WebControls.Label lblSearchByCategory;
		
		
		
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			Customers.fillPanel(Panel1, Session["customerID"]);

			// Create the Manager 
			RollOverImageManager m = new RollOverImageManager(); 

			// Intialize the Image Controls 
			m.InitializeImage(ibSearch, "images/searchdown.jpg"); 
			m.InitializeImage(ibSearchCategories, "images/searchdown.jpg"); 

			// Load the Images (generate the JavaScript) 
			m.LoadImages(this); 
			if(!(Page.IsPostBack))
			{
				DataSet objDS = Product.viewAllProducts("Book");
				DataTable objDT = new DataTable();
				objDT = objDS.Tables[0];
				dlProducts.DataSource = objDT;
				dlProducts.DataBind();
				for(int i = 0; i< dlProducts.Items.Count; i++)
				{
					((System.Web.UI.WebControls.Image)dlProducts.Items[i].FindControl("productImage")).Width=75;
					((System.Web.UI.WebControls.Image)dlProducts.Items[i].FindControl("productImage")).Height=100;
				}

				for(int i = 0; i< dlProducts.Items.Count; i++)
				{
					if(Convert.ToInt32(objDT.Rows[i]["origPrice"]) == 0)
					{
						((System.Web.UI.WebControls.Label)dlProducts.Items[i].FindControl("origPrice")).Text = "Not Currently Available";
					}
					int x =Convert.ToInt32(objDT.Rows[i]["discount"]);
					if(Convert.ToInt32(objDT.Rows[i]["discount"]) == 0)
					{
						((System.Web.UI.WebControls.Label)dlProducts.Items[i].FindControl("origPrice")).Font.Strikeout = false;
						((System.Web.UI.WebControls.Label)dlProducts.Items[i].FindControl("discountedPrice")).Text = "No Discount";
					}
				}
			
				string type;
				if(ddlProductType.SelectedIndex == 0)
				{
					type = "CD";
				}
				else
				{
					type = "Book";
				}
				DataSet objDSa = Categories.getAllCategories(type);
				DataTable objDTCategories = new DataTable();
				objDTCategories = objDSa.Tables[0];
				ddlCategories.DataSource = objDTCategories;
				
				ddlCategories.DataValueField = "categoryID";
				ddlCategories.DataTextField = "categoryName";	
				ddlCategories.DataBind();	
			}

			

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ibSearch.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearch_Click);
			this.ddlProductType.SelectedIndexChanged += new System.EventHandler(this.ddlProductType_SelectedIndexChanged);
			this.ibSearchCategories.Click += new System.Web.UI.ImageClickEventHandler(this.ibSearchCategories_Click);
			this.ddlChoose.SelectedIndexChanged += new System.EventHandler(this.ddlChoose_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ddlChoose_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DataSet objDS = Product.viewAllProducts(ddlChoose.SelectedItem.Value);
			DataTable objDT = new DataTable();
			objDT = objDS.Tables[0];
			dlProducts.DataSource = objDT;
			dlProducts.DataBind();
			if(ddlChoose.SelectedItem.Value == "CD")
			{
				for(int i = 0; i< dlProducts.Items.Count; i++)
				{
					((System.Web.UI.WebControls.Image)dlProducts.Items[i].FindControl("productImage")).Width=75;
					((System.Web.UI.WebControls.Image)dlProducts.Items[i].FindControl("productImage")).Height=75;
				}
			}
			else{
				for(int i = 0; i< dlProducts.Items.Count; i++)
				{
					((System.Web.UI.WebControls.Image)dlProducts.Items[i].FindControl("productImage")).Width=75;
					((System.Web.UI.WebControls.Image)dlProducts.Items[i].FindControl("productImage")).Height=100;
				}
			}

			for(int i = 0; i< dlProducts.Items.Count; i++)
			{
				if(Convert.ToInt32(objDT.Rows[i]["origPrice"]) == 0)
				{
					((System.Web.UI.WebControls.Label)dlProducts.Items[i].FindControl("origPrice")).Text = "Not Currently Available";
				}
				int x =Convert.ToInt32(objDT.Rows[i]["discount"]);
				if(Convert.ToInt32(objDT.Rows[i]["discount"]) == 0)
				{
					((System.Web.UI.WebControls.Label)dlProducts.Items[i].FindControl("origPrice")).Font.Strikeout = false;
					((System.Web.UI.WebControls.Label)dlProducts.Items[i].FindControl("discountedPrice")).Text = "No Discount";
				}
			}
		}

		private void ibSearch_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if(txtSearch.Text=="")
			{
				lblSearchByError.Visible = true;
				return;
			}
			Response.Redirect("searchByField.aspx?searchBy=" + txtSearch.Text + "&ddlSearchBy=" + ddlSearchBy.SelectedItem.Value);
		}

		private void ibSearchCategories_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			string value = ddlCategories.SelectedValue;
			Response.Redirect("searchByCategory.aspx?&ddlSearchBy=" + value);
		}

		private void ddlProductType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string type;
			if(ddlProductType.SelectedIndex == 0)
			{
				type = "CD";
			}
			else
			{
				type = "Book";
			}
			DataSet objDS = Categories.getAllCategories(type);
			DataTable objDTCategories = new DataTable();
			objDTCategories = objDS.Tables[0];
			ddlCategories.DataSource = objDTCategories;
				
			ddlCategories.DataValueField = "categoryID";
			ddlCategories.DataTextField = "categoryName";	
			ddlCategories.DataBind();
		}
	}
}
