using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using prinsess_inventory.Classes;

namespace prinsess_inventory
{
	/// <summary>
	/// Summary description for viewHistory.
	/// </summary>
	public class viewStatus : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtSearch;
		protected System.Web.UI.WebControls.DropDownList ddlSearchBy;
		protected System.Web.UI.WebControls.DropDownList ddlProductType;
		protected System.Web.UI.WebControls.DropDownList ddlCategories;
		protected System.Web.UI.WebControls.ImageButton ibSearchCategories;
		protected System.Web.UI.WebControls.TextBox tbInvoiceNum;
		protected System.Web.UI.WebControls.Button btnInvoiceNum;
		protected System.Web.UI.WebControls.DataGrid dgPkgs;
		protected System.Web.UI.WebControls.DataGrid dgItems;
		protected System.Web.UI.WebControls.Panel Panel1;
		protected System.Web.UI.WebControls.ImageButton ibSearch;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			Customers.fillPanel(Panel1, Session["customerID"]);
			Customers.loginCheck(this, Session["customerID"]);

			if(!(Page.IsPostBack))
			{
				if (Request.QueryString["invoiceID"] != null) 
				{
					int InvoiceNum = Convert.ToInt32(Request.QueryString["invoiceID"]);
					DataTable objDT;
					objDT =  Product.getPkgsFromInvoice(InvoiceNum);
					dgPkgs.DataSource = objDT;
					dgPkgs.DataBind();
				}
			}
			string type;
			if(ddlProductType.SelectedIndex == 0)
			{
				type = "CD";
			}
			else
			{
				type = "Book";
			}
			DataSet objDS = Categories.getAllCategories(type);
			DataTable objDTCategories = new DataTable();
			objDTCategories = objDS.Tables[0];
			ddlCategories.DataSource = objDTCategories;
				
			ddlCategories.DataValueField = "categoryID";
			ddlCategories.DataTextField = "categoryName";	
			ddlCategories.DataBind();

			
			// Create the Manager 
			RollOverImageManager m = new RollOverImageManager(); 

			// Intialize the Image Controls 
			m.InitializeImage(ibSearch, "images/searchdown.jpg"); 
			m.InitializeImage(ibSearchCategories, "images/searchdown.jpg"); 

			// Load the Images (generate the JavaScript) 
			m.LoadImages(this); 


			

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnInvoiceNum.Click += new System.EventHandler(this.btnInvoiceNum_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnInvoiceNum_Click(object sender, System.EventArgs e)
		{
			int InvoiceNum = Convert.ToInt32(tbInvoiceNum.Text);
			DataTable objDT;
			objDT =  Product.getPkgsFromInvoice(InvoiceNum);
			dgPkgs.DataSource = objDT;
			dgPkgs.DataBind();

		}
		public void viewItemsCommand(Object sender, DataGridCommandEventArgs e) 
		{
     
			// e.Item is the row of the table where the command fired
			// For bound columns the value is stored in the Text property of TableCell
			TableCell pkgCell = e.Item.Cells[1];
			string pkg = pkgCell.Text;
			int pkgNum = Convert.ToInt16(pkg);
			DataTable objDT;
			objDT =  Product.getItems(pkgNum);
			dgItems.DataSource = objDT;
			dgItems.DataBind();
			dgItems.Visible = true;
			

		}

	}
}
