using System;
using System.Data.SqlClient;	// This is the library with the SQL types we're using below
using System.Data;
using System.Data.SqlTypes;

namespace phase2
{
	/// <summary>
	/// Summary description for DBHandler.
	/// </summary>
	public class DBHandler
	{		
		private static string inventorySqlString = "server=IISQLSRV; uid=jfuchs; pwd=12345; database=jfuchs_inventory";
		private static string billingSqlString = "server=IISQLSRV; uid=jfuchs; pwd=12345; database=lingmann_billing";
		private static string shippingSqlString = "server=IISQLSRV; uid=jfuchs; pwd=12345; database=keward2_shipping";

		public DBHandler()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		private static DataSet executeQueryOnInventory(string query) 
		{
			SqlConnection connection = new SqlConnection(inventorySqlString);
			SqlDataAdapter adapter = new SqlDataAdapter();
			adapter.SelectCommand = new SqlCommand(query, connection);
			DataSet dataset = new DataSet("result");
			adapter.Fill(dataset);
			connection.Close();
			
			return dataset;
		}

		private static DataSet executeQueryOnBilling(string query) 
		{
			SqlConnection connection = new SqlConnection(billingSqlString);
			SqlDataAdapter adapter = new SqlDataAdapter();
			adapter.SelectCommand = new SqlCommand(query, connection);
			DataSet dataset = new DataSet("result");
			adapter.Fill(dataset);
			connection.Close();
			
			return dataset;
		}

		private static DataSet executeQueryOnShipping(string query) 
		{
			SqlConnection connection = new SqlConnection(shippingSqlString);
			SqlDataAdapter adapter = new SqlDataAdapter();
			adapter.SelectCommand = new SqlCommand(query, connection);
			DataSet dataset = new DataSet("result");
			adapter.Fill(dataset);
			connection.Close();
			
			return dataset;
		}

        private static DataSet executeCustomQuery(string query)
		{
			SqlConnection connection = new SqlConnection(shippingSqlString);
			SqlDataAdapter adapter = new SqlDataAdapter();
			adapter.SelectCommand = new SqlCommand(query, connection);
			DataSet dataset = new DataSet("result");
			adapter.Fill(dataset);
			connection.Close();
			
			return dataset;
		}


		public static DataSet getAllProductsFromInventory() 
		{
			string query = @"
				(select UID, Name, BasePrice, Total_Discount, (BasePrice - Total_Discount) as FinalPrice
				from products,
				(	
					select productid, sum(discount_amount) as total_discount
					from discounts
					where Discount_start < getdate() and Discount_end > getdate()
					group by productid
				) total_discounts
				where products.UID = total_discounts.productid)
				UNION
				(select UID, Name, BasePrice, 0 as Total_Discount, BasePrice as FinalPrice
				FROM products
				where not products.UID in 
				(	
					select productid
					from discounts
					where Discount_start < getdate() and Discount_end > getdate()
					group by productid
				))";
			return executeQueryOnInventory(query);
		}

		public static DataSet getProductsWhereTitleLike(string title)
		{
			string query = @"SELECT *
				FROM 
				((select UID, Name, BasePrice, Total_Discount, (BasePrice - Total_Discount) as FinalPrice
				from products,
				(	
					select productid, sum(discount_amount) as total_discount
					from discounts
					where Discount_start < getdate() and Discount_end > getdate()
					group by productid
				) total_discounts
				where products.UID = total_discounts.productid)
				UNION
				(select UID, Name, BasePrice, 0 as Total_Discount, BasePrice as FinalPrice
				FROM products
				where not products.UID in 
				(	
					select productid
					from discounts
					where Discount_start < getdate() and Discount_end > getdate()
					group by productid
				))) prods
				WHERE Name LIKE '%" + title + "%'";
			return executeQueryOnInventory(query);
		}

		public static DataSet getProductsWithAALike(string a) 
		{
			string query = @"
				(SELECT UID, Name, BasePrice, Total_Discount, FinalPrice 
				FROM ((select UID, Name, BasePrice, Total_Discount, (BasePrice - Total_Discount) as FinalPrice
				from products,
				(	
					select productid, sum(discount_amount) as total_discount
					from discounts
					where Discount_start < getdate() and Discount_end > getdate()
					group by productid
				) total_discounts
				where products.UID = total_discounts.productid)
				UNION
				(select UID, Name, BasePrice, 0 as Total_Discount, BasePrice as FinalPrice
				FROM products
				where not products.UID in 
				(	
					select productid
					from discounts
					where Discount_start < getdate() and Discount_end > getdate()
					group by productid
				))) prods, Book_Authors 
				WHERE ISBN=UID
				AND Author LIKE '%" + a + @"%')

				UNION

				(SELECT UID, Name, BasePrice, Total_Discount, FinalPrice 
				FROM ((select UID, Name, BasePrice, Total_Discount, (BasePrice - Total_Discount) as FinalPrice
				from products,
				(	
					select productid, sum(discount_amount) as total_discount
					from discounts
					where Discount_start < getdate() and Discount_end > getdate()
					group by productid
				) total_discounts
				where products.UID = total_discounts.productid)
				UNION
				(select UID, Name, BasePrice, 0 as Total_Discount, BasePrice as FinalPrice
				FROM products
				where not products.UID in 
				(	
					select productid
					from discounts
					where Discount_start < getdate() and Discount_end > getdate()
					group by productid
				))) prods, CD_Artists 
				WHERE CD_UID=UID
				AND Artist LIKE '%" + a + "%')";
			return executeQueryOnInventory(query);
		}

		public static DataSet getBooksWithAuthorLike(string author) 
		{
			string query = @"SELECT * 
				FROM ((select UID, Name, BasePrice, Total_Discount, (BasePrice - Total_Discount) as FinalPrice
				from products,
				(	
					select productid, sum(discount_amount) as total_discount
					from discounts
					where Discount_start < getdate() and Discount_end > getdate()
					group by productid
				) total_discounts
				where products.UID = total_discounts.productid)
				UNION
				(select UID, Name, BasePrice, 0 as Total_Discount, BasePrice as FinalPrice
				FROM products
				where not products.UID in 
				(	
					select productid
					from discounts
					where Discount_start < getdate() and Discount_end > getdate()
					group by productid
				))) prods, Book_Authors 
				WHERE ISBN=UID
				AND Author LIKE '%" + author + "%'";
			return executeQueryOnInventory(query);
		}

		public static DataSet getCDsWithArtistLike(string artist) 
		{
			string query = @"SELECT * 
				FROM ((select UID, Name, BasePrice, Total_Discount, (BasePrice - Total_Discount) as FinalPrice
				from products,
				(	
					select productid, sum(discount_amount) as total_discount
					from discounts
					where Discount_start < getdate() and Discount_end > getdate()
					group by productid
				) total_discounts
				where products.UID = total_discounts.productid)
				UNION
				(select UID, Name, BasePrice, 0 as Total_Discount, BasePrice as FinalPrice
				FROM products
				where not products.UID in 
				(	
					select productid
					from discounts
					where Discount_start < getdate() and Discount_end > getdate()
					group by productid
				))) prods, CD_Artists 
				WHERE CD_UID=UID
				AND Artist LIKE '%" + artist + "%'";
			return executeQueryOnInventory(query);
		}

		public static DataSet getBooksWithKeywordLike(string keyword) 
		{
			string query = @"SELECT * 
				FROM ((select UID, Name, BasePrice, Total_Discount, (BasePrice - Total_Discount) as FinalPrice
				from products,
				(	
					select productid, sum(discount_amount) as total_discount
					from discounts
					where Discount_start < getdate() and Discount_end > getdate()
					group by productid
				) total_discounts
				where products.UID = total_discounts.productid)
				UNION
				(select UID, Name, BasePrice, 0 as Total_Discount, BasePrice as FinalPrice
				FROM products
				where not products.UID in 
				(	
					select productid
					from discounts
					where Discount_start < getdate() and Discount_end > getdate()
					group by productid
				))) prods, Book_Keywords "
				+ "WHERE ISBN=UID AND Keyword LIKE '%" + keyword + "%'";
			return executeQueryOnInventory(query);
		}
		
		public static DataSet getCustomersWhereEmailAndPassLike(string email, string pass) 
		{
			string query = "SELECT customerID, firstName, lastName "
				+ "FROM Customer "
				+ "WHERE email='" + email + "' and password='" + pass +"'";
			return executeQueryOnBilling(query);
		}

		public static DataSet getCustomerData(int customerID)
		{
			string query = String.Format( @"
				SELECT *
				FROM Customer
				WHERE customerID = '{0}'", customerID.ToString());
			return executeQueryOnBilling(query);
		}

		// Add the given item to a shopping cart.  If the item is already in the shopping cart,
		// we just increment the quantity appropriately.  Returns true unless there is an error with 
		// the query.
		// ASSERT (quantity >= 0)
		public static bool addToShoppingCart(int customerID, string itemID, int quantity, string partnerID, SqlMoney unitPrice)
		{
			// Make sure the quantity is always >= 0
			if (quantity < 0) quantity = 0;
			int currentQuantity = getShoppingCartQuantity(customerID, itemID, partnerID);

			int newQuantity = quantity + currentQuantity;
			return (updateShoppingCart(customerID, itemID, newQuantity, partnerID, unitPrice));
		}

		// Update the shopping cart with the given (absolute) quantity -- if quantity = 0, then the item
		// is removed from the shopping cart completely.  Returns false if something goes wrong with the
		// SQL command.  This is where the actual work and SQL query is run.
		// ASSERT (quantity >= 0)
		public static bool updateShoppingCart(int customerID, string itemID, int quantity, string partnerID, SqlMoney unitPrice)
		{
			// Make sure we never have negative quantities
			if (quantity < 0) quantity = 0;

			int currentQuantity = getShoppingCartQuantity(customerID, itemID, partnerID);
			
			string query = "";

			// If the quantity is 0, just DELETE any reference to the item
			if (quantity == 0) 
			{
				query = String.Format( @"
					DELETE
					FROM ShoppingCart 
					WHERE customerID = '{0}' AND itemID = '{1}' AND partnerID = '{2}'",
					customerID.ToString(), itemID, partnerID);
			} 

			// If the quantity = 1, INSERT the new item
			else if (currentQuantity == 0 && quantity >= 1)
			{
				query = String.Format( @"
					INSERT INTO ShoppingCart(customerID, itemID, quantity, partnerID, unitPrice)
					VALUES('{0}', '{1}', '{2}', '{3}', {4})",
					customerID.ToString(), itemID, quantity.ToString(), partnerID, unitPrice.ToString());
			}

			// Otherwise currentQuantity >= 1 && quantity >= 1
			// Just update the existing entry
			else
			{
				query = String.Format( @"
					UPDATE ShoppingCart
					SET quantity = '{0}', unitPrice = {4}
					WHERE customerID = '{1}' AND itemID = '{2}' AND partnerID = '{3}'",
					quantity.ToString(), customerID.ToString(), itemID, partnerID, unitPrice.ToString());
			}
			try
			{
				executeQueryOnBilling(query);
			}
			catch (Exception ex) 
			{
				return false;
			}
			return true;
		}

		public static bool updateShoppingCart(int customerID, string itemID, int quantity, string partnerID, string unitPrice)
		{
			// Make sure we never have negative quantities
			if (quantity < 0) quantity = 0;

			int currentQuantity = getShoppingCartQuantity(customerID, itemID, partnerID);
			
			string query = "";

			// If the quantity is 0, just DELETE any reference to the item
			if (quantity == 0) 
			{
				query = String.Format( @"
					DELETE
					FROM ShoppingCart 
					WHERE customerID = '{0}' AND itemID = '{1}' AND partnerID = '{2}'",
					customerID.ToString(), itemID, partnerID);
			} 

				// If the quantity = 1, INSERT the new item
			else if (currentQuantity == 0 && quantity >= 1)
			{
				query = String.Format( @"
					INSERT INTO ShoppingCart(customerID, itemID, quantity, partnerID, unitPrice)
					VALUES('{0}', '{1}', '{2}', '{3}', {4})",
					customerID.ToString(), itemID, quantity.ToString(), partnerID, unitPrice);
			}

				// Otherwise currentQuantity >= 1 && quantity >= 1
				// Just update the existing entry
			else
			{
				query = String.Format( @"
					UPDATE ShoppingCart
					SET quantity = '{0}', unitPrice = {4}
					WHERE customerID = '{1}' AND itemID = '{2}' AND partnerID = '{3}'",
					quantity.ToString(), customerID.ToString(), itemID, partnerID, unitPrice);
			}
			try
			{
				executeQueryOnBilling(query);
			}
			catch (Exception ex) 
			{
				return false;
			}
			return true;
		}

		// Returns the quantity of the given item in the customer's shopping cart
		// NOTE: From an application perspective, itemID, partnerID, and customerID form a KEY
		public static int getShoppingCartQuantity(int customerID, string itemID, string partnerID)
		{
			string query = String.Format( @"
				SELECT quantity FROM ShoppingCart 
				WHERE customerID = '{0}' AND itemID = '{1}'",
				customerID.ToString(), itemID);
			int result = 0;
			try 
			{
				DataSet ds = executeQueryOnBilling(query);
				DataRow row = ds.Tables[0].Rows[0];
				result = (int)row["quantity"];
			}
			catch (Exception ex) 
			{
				// Do nothing
			}
			return result;
		}

		// Returns the next available customerID in the database
		public static int getUniqueCustomerID()
		{
			string query = "SELECT Max(customerID) AS max FROM Customer";
			DataSet ds = executeQueryOnBilling(query);
			DataRow row = ds.Tables[0].Rows[0];
			int result = (int)row["max"] + 1;
			return result;
		}

		// Returns a new invoice ID
		public static int getUniqueInvoiceID()
		{
			string query = "SELECT Max(invoiceID) AS max FROM Invoice";
			DataSet ds = executeQueryOnBilling(query);
			DataRow row = ds.Tables[0].Rows[0];
			int result = (int)row["max"] + 1;
			return result;
		}

		// Returns the shopping cart DataSet for the current user
		public static DataSet getShoppingCart(int customerID)
		{
			string query = String.Format( @"
				SELECT UID as itemID, Name, BasePrice, Total_Discount, FinalPrice as unitPrice, quantity, (FinalPrice * quantity) as extendedPrice
					FROM (
					
						(select UID, Name, BasePrice, Total_Discount, (BasePrice - Total_Discount) as FinalPrice
						from products,
							(select productid, sum(discount_amount) as total_discount
							from discounts
							where Discount_start < getdate() and Discount_end > getdate()
							group by productid
							) total_discounts
						where products.UID = total_discounts.productid)

						UNION
						
						(select UID, Name, BasePrice, 0 as Total_Discount, BasePrice as FinalPrice
						FROM products
						where not products.UID in 
							(select productid
							from discounts
							where Discount_start < getdate() and Discount_end > getdate()
							group by productid
							)
						)) prods, lingmann_billing.dbo.shoppingcart
				where itemID = UID
				and customerID = '{0}'",
				customerID.ToString());

			return executeQueryOnInventory(query);
		}

		public static int addShippingCustomer(string firstName, string lastName, string company, string address,
			string city, string state, string zip5, string zip4, string notes) 
		{
			SqlConnection connection = new SqlConnection(billingSqlString);
			connection.Open();
			string query = "SELECT Max(customerID) FROM Customer";
			SqlCommand sqlCom = new SqlCommand(query, connection);
			SqlDataReader sqlRdr = sqlCom.ExecuteReader();
			int result = -1;

			if (sqlRdr.Read()) 
			{
				int newID = (int)sqlRdr.GetValue(0) + 1;
				sqlRdr.Close();

				// Register the user
				query = String.Format( @"
						INSERT INTO Customer(customerID, firstName, lastName, address, city, state, 
							zip5, zip4, company, notes) 
						VALUES('{0}', '{1}', '{2}', '{3}', '{4}', '{5}', '{6}', '{7}', '{8}', '{9}')", 		
					newID, firstName, lastName, address, city, state, zip5,
					zip4, company, notes);
				sqlCom = new SqlCommand(query, connection);
				if (sqlCom.ExecuteNonQuery() == 1) 
				{
					result = newID;
				}
			
			}
			connection.Close();
			return result;
		}


		public static DataSet getUserPackages(string cid)
		{
			string query = 
				"SELECT invoice, companyName, status " +
				"FROM Package " +
					"inner join ShippingStatus on Package.statusID = ShippingStatus.statusID " +
					"inner join ShippingCompany on Package.shippingCompany = ShippingCompany.companyID " +
				"WHERE customerID='" + cid + "'";
			return executeQueryOnBilling(query);
		}

		public static DataSet getUserInvoices(string cid)
		{
			string query = 
				"SELECT description, orderDate, lingmann_billing.dbo.Item.shipDate, lingmann_billing.dbo.Invoice.invoiceID, shipper, trackingNumber, status " +
				"FROM lingmann_billing.dbo.Invoice " +
				"inner join lingmann_billing.dbo.Item on lingmann_billing.dbo.Item.invoiceId=lingmann_billing.dbo.Invoice.invoiceID " +
				"inner join keward2_shipping.dbo.Package on lingmann_billing.dbo.Item.trackingNumber=cast(keward2_shipping.dbo.Package.tracking as varchar) " +
				"inner join keward2_shipping.dbo.ShippingStatus on keward2_shipping.dbo.Package.statusID = keward2_shipping.dbo.ShippingStatus.statusID " +
				"Where buyer='" + cid + "' " +
				"group by status, orderDate, lingmann_billing.dbo.Item.shipDate, description, shipper, lingmann_billing.dbo.Invoice.invoiceID, trackingNumber " +
				"order by status desc, orderDate, description";
			return executeQueryOnBilling(query);
		}

		public static DataSet getUserInvoices(string cid, string invoiceNum)
		{
			string query = 
				"SELECT description, orderDate, lingmann_billing.dbo.Item.shipDate, lingmann_billing.dbo.Invoice.invoiceID, shipper, trackingNumber, status " +
				"FROM lingmann_billing.dbo.Invoice " +
				"inner join lingmann_billing.dbo.Item on lingmann_billing.dbo.Item.invoiceId=lingmann_billing.dbo.Invoice.invoiceID " +
				"inner join keward2_shipping.dbo.Package on lingmann_billing.dbo.Item.trackingNumber=cast(keward2_shipping.dbo.Package.tracking as varchar) " +
				"inner join keward2_shipping.dbo.ShippingStatus on keward2_shipping.dbo.Package.statusID = keward2_shipping.dbo.ShippingStatus.statusID " +
				"Where buyer='" + cid + "' and lingmann_billing.dbo.Invoice.invoiceID='" + invoiceNum + "' " +
				"group by status, orderDate, lingmann_billing.dbo.Item.shipDate, description, shipper, lingmann_billing.dbo.Invoice.invoiceID, trackingNumber " +
				"order by status desc, orderDate, description";
			return executeQueryOnBilling(query);
		}

		public static DataSet getItemSales()
		{
			string query = @"(select UID, name, quantitysold, totalsales
				from jfuchs_inventory.dbo.products, (select itemID, sum(quantity) as QuantitySold, sum(unitPrice * quantity) as TotalSales
				from item
				group by itemID) sales
				where uid = itemID)
				UNION
				(select UID, name, 0 as quantitysold, 0 as totalsales
				from jfuchs_inventory.dbo.products
				where UID not in (select itemID from item))";
			return executeQueryOnBilling(query);
		}

		public static DataSet getShippingMethodsToCity(string city) 
		{
			string query = @"SELECT 'THIS IS WRONG' AS RESULT";
			return executeQueryOnBilling(query);
		}

		public static DataSet getWarehouseInformation()
		{
			string query = @"select warehouses.id, streetaddress, city, state, zipcode, sum(itemCount) as ItemsShippedFromHere
				from warehouses, keward2_shipping.dbo.package
				where keward2_shipping.dbo.package.warehouseID = warehouses.id
				group by warehouses.id, streetaddress, city, state, zipcode";
			return executeQueryOnInventory(query);
		}

		public static DataSet getWarehouseInfo(string WID)
		{
			string query = @"select *
				from warehouses
				where ID = '" + WID + "'";
			return executeQueryOnInventory(query);
		}

		public static DataSet getWarehouseStockForWarehouseID(string WID)
		{
			string query = @"select productID
				from stocks
				where warehouseID = '" + WID + "'";
			return executeQueryOnInventory(query);
		}

		public static DataSet getWarehouseShippingVendorsForWarehouseID(string WID)
		{
			string query = @"
				select companyID from WarehouseList
				where warehouseID = '" + WID + "'";
			return executeQueryOnShipping(query);
		}

		public static DataSet getCities()
		{
			string query = @"
				select distinct cityID, cityName
				from cities";
			return executeQueryOnShipping(query);
		}

		public static DataSet getShippingMethodsForCity(string city) 
		{
			string query = @"
				select y.methodName, y.companyName, y.priceType, y.rate, y.maxWeight, y.maxCount, count(x.shippingOption) as 'times_used'
				from Package as x, 
					(select distinct shippingCompany, shippingOption, methodName, companyName, priceType, rate, maxWeight, maxCount
						from Package
							inner join ShippingMethod on Package.shippingOption = ShippingMethod.methodID
							inner join ShippingCompany on Package.shippingCompany = ShippingCompany.companyID
							inner join Cities on ShippingCompany.companyID = Cities.companyID
						where cityName = '" + city + @"') as y
				where x.shippingCompany = y.shippingCompany and x.shippingOption = y.shippingOption
				group by y.companyName, y.methodName, y.priceType, y.rate, y.maxWeight, y.maxCount";
			return executeQueryOnShipping(query);
		}

		public static int addInvoice(int customerID, int recipientID, string notes, string shipmethod, string paymentmethod) 
		{
			int newID = getUniqueInvoiceID();
			try 
			{
				string query = String.Format(@"
					insert into invoice (invoiceID, orderDate, buyer, recipient, shipmethod, paymentmethod, tax, orderstatus, notes)
					select {0}, getdate(), '{1}', '{2}', '{3}', '{4}', 0.08, '', ''",
					newID.ToString(), customerID.ToString(), recipientID.ToString(), shipmethod, paymentmethod);
				executeQueryOnBilling(query);
			}
			catch (Exception ex)
			{
			}
			return newID;

		}

		public static void clearShoppingCart(int customerID)
		{
			try
			{
				string query = String.Format(@"
					DELETE
					FROM shoppingCart
					WHERE customerID = {0}", customerID.ToString());
				executeQueryOnBilling(query);
			}
			catch (Exception ex)
			{
			}
		}

		public static void addItems(int invoiceID, int customerID, SqlMoney shippingHandling, string warehouse, string shipper, string trackNum)
		{
			try
			{
				string query = String.Format(@"

					insert into item (invoiceID, itemID, quantity, unitPrice, shippingHandling, warehouse, shipper, trackingNumber, shipDate)
					select {0}, itemID, quantity, unitPrice, {1}, '{2}', '{3}', '{4}', getdate()
					from (select *
						from shoppingCart
						where customerID = '{5}') innerTable",
					invoiceID.ToString(), shippingHandling.ToString(), warehouse, shipper, trackNum, customerID);

				executeQueryOnBilling(query);
			}
			catch (Exception ex)
			{
			}
		}
	}
}
