using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data;

namespace phase2
{
	/// <summary>
	/// Summary description for login.
	/// </summary>
	public class loginControl : UserControl
	{
		protected System.Web.UI.WebControls.Label loginTitle;
		protected System.Web.UI.WebControls.Label userNameLabel;
		protected System.Web.UI.WebControls.Label passwordLabel;
		protected System.Web.UI.HtmlControls.HtmlTable LoginTable;
		protected System.Web.UI.WebControls.TextBox loginName;
		protected System.Web.UI.WebControls.TextBox loginPassword;
		protected System.Web.UI.WebControls.Button loginButton;
		protected System.Web.UI.WebControls.Button logoutButton;
		protected System.Web.UI.WebControls.Button cartButton;
		protected System.Web.UI.WebControls.Button RegisterButton;
		protected System.Web.UI.WebControls.Button AccountButton;
		protected System.Web.UI.WebControls.Button HistoryButton;

		public loginControl()
		{
		
		}

		protected override void OnInit(System.EventArgs e)
		{
			//if not logged in
			if(Session["customerID"] == null)
			{
				loginTitle.Text = "LOGIN";
				loginName.Visible = true;
				loginPassword.Visible = true;
				userNameLabel.Visible = true;
				loginButton.Visible = true;
				passwordLabel.Visible = true;
				logoutButton.Visible = false;
				cartButton.Visible = false;
				RegisterButton.Visible = true;
				AccountButton.Visible = false;
				HistoryButton.Visible = false;

			} 
			else
			{
				String fName = Session["firstName"].ToString();
				loginTitle.Text = "WELCOME " + fName.ToUpper();
				loginName.Visible = false;
				loginPassword.Visible = false;
				userNameLabel.Visible = false;
				passwordLabel.Visible = false;
				loginButton.Visible = false;
				logoutButton.Visible = true;
				cartButton.Visible = true;
				RegisterButton.Visible = false;
				AccountButton.Visible = true;
				HistoryButton.Visible = true;
			}
		}

		public loginControl(String bgcolor, String width)
		{
			//loggedin = false;
			this.LoginTable.BgColor = bgcolor;
			this.LoginTable.Width = width;
		}


		public String BackColor
		{
			get { return LoginTable.BgColor; }
			set { LoginTable.BgColor = value; }
		}
	
		public string UserName
		{
			get { return loginName.Text; }
			set { loginName.Text = value; }
		}
	
		public string Password 
		{
			get { return loginPassword.Text; }
			set {loginPassword.Text = value; }
		}
	
		public String Width
		{
			get { return LoginTable.Width; }
			set { LoginTable.Width = value; }
		}
	
		public void OnLoginButtonClicked(object sender, System.EventArgs e)
		{
			String name = loginName.Text.ToString();
			String password = loginPassword.Text.ToString();

			try 
			{
				DataSet ds = DBHandler.getCustomersWhereEmailAndPassLike(name, password);
				DataTable myTable = ds.Tables[0];
				DataRow myRow = myTable.Rows[0];
				DataColumn myCol = myTable.Columns["customerID"];
				int cID = (int)myRow[myCol];
				myCol = myTable.Columns["firstName"];
				string fName = myRow[myCol].ToString();
				myCol = myTable.Columns["lastName"];
				string lName = myRow[myCol].ToString();
				Session["customerID"] = cID;
				Session["firstName"] = fName;
				Session["lastName"] = lName;

				loginTitle.Text = "WELCOME " + fName.ToUpper();
				loginName.Visible = false;
				loginPassword.Visible = false;
				userNameLabel.Visible = false;
				passwordLabel.Visible = false;
				loginButton.Visible = false;
				logoutButton.Visible = true;
				cartButton.Visible = true;
				RegisterButton.Visible = false;
				AccountButton.Visible = true;
				HistoryButton.Visible = true;
			} 
			catch (Exception ex) 
			{
				// Do nothing
			}
		}

		public void OnLogoutButtonClicked(object sender, System.EventArgs e)
		{
			if(Session["customerID"] != null)
			{
				Session["customerID"] = null;
				Session["firstName"] = null;
				Session["lastName"] = null;
				loginTitle.Text = "LOGIN";
				loginName.Visible = true;
				loginPassword.Visible = true;
				userNameLabel.Visible = true;
				loginButton.Visible = true;
				passwordLabel.Visible = true;
				logoutButton.Visible = false;
				cartButton.Visible = false;
				RegisterButton.Visible = true;
				AccountButton.Visible = false;
				HistoryButton.Visible = false;
			} 
		}

		public void OnCartButtonClicked(object sender, System.EventArgs e)
		{
			Response.Redirect("shoppingCart.aspx");
		}

		public void OnRegisterButtonClicked(object sender, System.EventArgs e)
		{
			Response.Redirect("registration.aspx");
		}

		public void OnAccountButtonClicked(object sender, System.EventArgs e)
		{
			Response.Redirect("registration.aspx");
		}

		public void OnHistoryButtonClicked(object sender, System.EventArgs e)
		{
			Response.Redirect("shoppingHistory.aspx");
		}
	}
}
