using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlTypes;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;	// This is the library with the SQL types we're using below

namespace phase2
{
	/// <summary>
	/// Summary description for product.
	/// </summary>
	public class product : System.Web.UI.Page
	{

		private SqlConnection sqlConn;	// Declare a connection object
		private SqlCommand sqlCom;		  // Declare a command object
		private SqlDataReader sqlRdr;	  // Declare a reader to read the query result
		private string strSqlString = "server=IISQLSRV; uid=jfuchs; pwd=12345; database=jfuchs_inventory";

		private SqlMoney subtotal;
		private SqlMoney total;
		private string item_group;
		private string prodtype;
		protected System.Web.UI.WebControls.Button AddToCartButton;
		protected System.Web.UI.WebControls.Label GenreLabel;
		protected System.Web.UI.WebControls.Label PublisherLabel;
		protected System.Web.UI.WebControls.Label AuthorLabel;
		protected System.Web.UI.WebControls.Label FinalPriceLabel;
		protected System.Web.UI.WebControls.Label DiscountLabel;
		protected System.Web.UI.WebControls.Label PriceLabel;
		protected System.Web.UI.WebControls.Label ProductTypeLabel;
		protected System.Web.UI.WebControls.Label ProductNameLabel;
		protected System.Web.UI.WebControls.Label GroupLabel;
		private string pid;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			pid = Request.QueryString["id"];
			if (pid == null) 
			{
				ShowError("Please specify a product ID");
				
			}
			else 
			{
				// Start a new connection to the database specified in strSqlString
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	// open the connection


				// Execute query -- Here you could make 'strSql' any query you want
				string strSql = @"select UID, Name, weight, BasePrice, groupName from products
where groupName is NULL
and UID = '" + pid + @"'

union all

select UID, Name, weight, BasePrice*$1.10 as BasePrice, groupName from products
where groupName is not NULL
and UID = '" + pid + @"'";
							
				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				// Get the answer from the reader and write it to the label.
				if (sqlRdr.Read()) 
				{
					ProductNameLabel.Text = "GROUP: " + sqlRdr.GetString(1);
					if (sqlRdr.IsDBNull(4))
					{
						GroupLabel.Visible = false;
						item_group = "444l";
					}
					else
					{
						GroupLabel.Text = sqlRdr.GetString(4);
						item_group = sqlRdr.GetString(4);
					}

					//PriceLabel.Text = "$" + sqlRdr.GetString(3);
					PriceLabel.Text = "$" + sqlRdr.GetSqlMoney(3).ToString();

					subtotal = sqlRdr.GetSqlMoney(3);

					sqlRdr.Close();

					strSql = "select discount_amount from discounts"
						+ " where ProductID='" + pid
						+ "' and Discount_start < getdate() and Discount_end > getdate()";
					sqlCom = new SqlCommand(strSql, sqlConn);	
					// Execute the command
					sqlRdr = sqlCom.ExecuteReader();
					if (sqlRdr.Read())
					{
						//PriceLabel.ApplyStyle("text-decoration: strikethrough");
						DiscountLabel.Text = " - $" + sqlRdr.GetSqlMoney(0).ToString();
						subtotal = SqlMoney.Subtract(subtotal, sqlRdr.GetSqlMoney(0));
						while (sqlRdr.Read())
						{
							DiscountLabel.Text = DiscountLabel.Text + " - $"
								+ sqlRdr.GetSqlMoney(0).ToString();
							subtotal = SqlMoney.Subtract(subtotal, sqlRdr.GetSqlMoney(0));
						}
						FinalPriceLabel.Text = " = <b>$" + subtotal.ToString() + "</b>";
						
					}
					else 
					{
						DiscountLabel.Visible = false;
						FinalPriceLabel.Visible = false;
						PriceLabel.Text = "<b>" + PriceLabel.Text + "</b>";
					}
					sqlRdr.Close();


					strSql = "select publisher, genre, author from books, book_authors where books.isbn = '" + 
						pid + "' and books.isbn = book_authors.isbn";
					sqlCom = new SqlCommand(strSql, sqlConn);	
					// Execute the command
					sqlRdr = sqlCom.ExecuteReader();

					if (sqlRdr.Read()) 
					{
						ProductTypeLabel.Text = "(Book)";
						PublisherLabel.Text = "publisher: "
							+ sqlRdr.GetString(0);
						GenreLabel.Text = "category: "
							+ sqlRdr.GetString(1);
						AuthorLabel.Text = "author(s): "
							+ sqlRdr.GetString(2);
						while (sqlRdr.Read()) 
						{
							AuthorLabel.Text = AuthorLabel.Text + ", " + sqlRdr.GetString(2);
						}
						prodtype = "book";
					}
					else
					{
						sqlRdr.Close();
						strSql = "select record_company, genre, artist from CDs, CD_artists where CDs.cd_uid = '" + 
							pid + "' and CDs.cd_uid = CD_artists.cd_uid";
						sqlCom = new SqlCommand(strSql, sqlConn);	

						sqlRdr = sqlCom.ExecuteReader();
						if (sqlRdr.Read()) 
						{
							ProductTypeLabel.Text = "(CD)";
							PublisherLabel.Text = "Record Label: "
								+ sqlRdr.GetString(0);
							GenreLabel.Text = "Genre: "
								+ sqlRdr.GetString(1);
							AuthorLabel.Text = "Artist(s): "
								+ sqlRdr.GetString(2);
							while (sqlRdr.Read()) 
							{
								AuthorLabel.Text = AuthorLabel.Text + ", " + sqlRdr.GetString(2);
							}
							prodtype = "music";
						}
						else
						{
							ShowError("Product appears to be neither book nor CD");
						}
					}
				}
				else
				{
					ShowError("Product Not found in database");
				}
				sqlConn.Close();
			}
		}

		private void ShowError(string msg) 
		{
			ProductNameLabel.Text = msg;
			ProductTypeLabel.Visible = false;
			AuthorLabel.Visible = false;
			PublisherLabel.Visible = false;
			GenreLabel.Visible = false;
			PriceLabel.Visible = false;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.AddToCartButton.Click += new System.EventHandler(this.AddToCartButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void AddToCartButton_Click(object sender, System.EventArgs e)
		{
			// Check to see if the customer is logged in
			if (Session["customerID"] == null) 
			{
				Response.Redirect("registration.aspx");
			}
			else
			{
				//DBHandler.addToShoppingCart(Convert.ToInt32(Session["customerID"]), pid, 1, item_group, subtotal, prodtype);
				DBHandler.addToShoppingCart(Convert.ToInt32(Session["customerID"]), pid, 1, item_group, subtotal);
				Response.Redirect("shoppingCart.aspx");
			}
		}
	}
}
