using System;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;

namespace myprj
{
	/// <summary>
	/// Summary description for MyDB.
	/// </summary>
	public class MyDB
	{
		// MODIFY: KCHIA - 2/13/2005 3:43 PM - Added two variables to access shipping/billing databases
		private static string strSqlStringI = "server=IISQLSRV; uid=dklayn; pwd=FINAL3; database=dklayn_inventory";
		private static string strSqlStringS = "server=IISQLSRV; uid=kchia; pwd=changed!; database=kchia_shipping";
		private static string strSqlStringB = "server=IISQLSRV; uid=kchia; pwd=changed!; database=kchia_billing";

		// DEFAULT: Access Inventory database
		private static string strSqlString = strSqlStringI;

		// MODIFY: KCHIA - 2/13/2005 3:43 PM - Added method to select which database to access
		// Note: May break store code where access to inventory database is assumed

		public static bool setDB(string db) 
		{
			if(db.Equals("inventory"))
			{
				strSqlString = strSqlStringI;
				return true;
			}			   
			else if(db.Equals("billing")) 
			{
				strSqlString = strSqlStringB;
				return true;
			}
			else if(db.Equals("shipping")) 
			{
				strSqlString = strSqlStringS;
				return true;
			}
			return false;
		}

		public static DataView getView(string strSql) 
		{
			SqlConnection sqlConn;
			SqlDataAdapter sqlAdt;
			DataSet sqlData;
			DataView sqlView;

			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();

			sqlAdt = new SqlDataAdapter(strSql, sqlConn);	
			sqlData = new DataSet();
			sqlAdt.Fill(sqlData);

			sqlView = sqlData.Tables[0].DefaultView;
			sqlConn.Close();

			return sqlView;			
		}
		
		public static bool bindSQL(BaseDataList webList, string strSql)
		{
			DataView sqlView;

			sqlView = getView(strSql);
			webList.DataSource = sqlView;
			webList.DataBind();

			return sqlView.Count > 0;
		}

		public static bool bindSQL2(ListControl webList, string strSql)
		{
			DataView sqlView;

			sqlView = getView(strSql);
			webList.DataSource = sqlView;
			webList.DataTextField = "text";
			webList.DataValueField = "text";
			webList.DataBind();

			return sqlView.Count > 0;
		}

		public static string queryValue(string table, string val, string cond) 
		{
			SqlConnection sqlConn;
			SqlCommand sqlCmd;
			string ret;

			sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();
			
			sqlCmd = new SqlCommand("SELECT "+val+" FROM "+table+" WHERE "+cond, sqlConn);
			ret = sqlCmd.ExecuteScalar().ToString();
			
			sqlConn.Close();
			
			return ret;
		}

		public static string queryValue(string strSQL) 
		{
			SqlConnection sqlConn;
			SqlCommand sqlCmd;
			string ret;

			sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();
			
			sqlCmd = new SqlCommand(strSQL, sqlConn);
			ret = (string)(sqlCmd.ExecuteScalar()).ToString();
			
			sqlConn.Close();

			return ret;
		}

		public static void insert(string table, string values) 
		{
			SqlConnection sqlConn;
			SqlCommand sqlCmd;
			
			sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();
			
			sqlCmd = new SqlCommand("INSERT "+table+" VALUES ("+values+")", sqlConn);
			sqlCmd.ExecuteNonQuery();	
			//Console.WriteLine("INSERT "+table+" VALUES ("+values+")");
			sqlConn.Close();
		}

		public static void insert(string table, Hashtable htvals) 
		{
			SqlConnection sqlConn;
			SqlCommand sqlCmd;
			string[] vals = new string[htvals.Count];
			string[] cols = new string[htvals.Count];
			string values, columns;

			IDictionaryEnumerator en = htvals.GetEnumerator();
			int i = 0;
			while(en.MoveNext()) 
			{								
				if(en.Value.GetType() == Type.GetType("System.String")) 
					vals[i] = "'"+en.Value+"'";
				else 
					vals[i] = en.Value.ToString();
				cols[i] = (string)en.Key;
				i++;
			}			
			values = String.Join(",", vals,0,i);
			columns = String.Join(",", cols,0,i);

			sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();
			

			sqlCmd = new SqlCommand("INSERT "+table+" ("+columns+") VALUES ("+values+")", sqlConn);
			sqlCmd.ExecuteNonQuery();	
			sqlConn.Close();
		}

		public static bool update(string table, string key, string values) 
		{
			SqlConnection sqlConn;
			SqlCommand sqlCmd;
			string cmd;
			int rowsAffected;

			sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();
						
			cmd = "IF(EXISTS (SELECT * FROM "+table+" WHERE "+key+"))"+
				  "  UPDATE "+table+" SET "+values+" WHERE "+key+" ";				  

			sqlCmd = new SqlCommand(cmd, sqlConn);
			rowsAffected = sqlCmd.ExecuteNonQuery();	
			sqlConn.Close();

			return rowsAffected > 1;
		}

		public static bool delete(string table, string cond) 
		{
			SqlConnection sqlConn;
			SqlCommand sqlCmd;
			int rows;

			sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();
			
			sqlCmd = new SqlCommand("DELETE FROM "+table+" WHERE "+cond, sqlConn);
			rows = sqlCmd.ExecuteNonQuery();
			
			sqlConn.Close();
			
			return rows > 0;
		}

		public static void fillMyAddr(string user, TextBox name, TextBox addr, TextBox city,
			DropDownList state, TextBox zip, Button btn)
		{
			if(user == null) return;
			string cond = "login='"+user+"'";
			
			if(btn.Text == "Use my address")
			{
				name.Text = MyDB.queryValue("customers", "cname", cond);
				addr.Text = MyDB.queryValue("customers", "street", cond);
				city.Text = MyDB.queryValue("customers", "city", cond);
				state.SelectedValue = MyDB.queryValue("customers", "state", cond);
				zip.Text = MyDB.queryValue("customers", "zip", cond);
				btn.Text = "Clear";
			}
			else 
			{
				name.Text = "";
				addr.Text = "";
				city.Text = "";
				state.SelectedIndex = 0;
				zip.Text = "";
				btn.Text = "Use my address";
			}
		}

		public static SqlDataReader getReader(string strSQL) 
		{
			SqlConnection sqlConn;
			SqlCommand sqlCmd;
			SqlDataReader ret;

			sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();
			
			sqlCmd = new SqlCommand(strSQL, sqlConn);
			ret = sqlCmd.ExecuteReader();
			return ret;
		}
	}
}
