using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace myprj
{
	/// <summary>
	/// Summary description for browse.
	/// </summary>
	public class browse : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataList DisplayList;
		protected System.Web.UI.WebControls.Button BuyBtn;

		private void Page_Load(object sender, System.EventArgs e)
		{
			BuyBtn.Visible = false;

			if(IsPostBack) return;

			if(Request.Params["ID"] != null) 
			{
				displayDetails(Request.Params["ID"]);
				return;
			}
			if(Session["pendingBuy"] != null) 
			{
				string id = (string)Session["pendingBuy"];

				Session.Remove("pendingBuy");
				doBuy(id);
				return;
			}

			if(Session["browse"] == null) return;

			if((string)Session["browse"] == "all") 
			{
				DisplayList.ItemTemplate = Page.LoadTemplate("ProductsTpl.ascx");
				DisplayList.Visible = true;
				MyDB.bindSQL(DisplayList,
					"SELECT type='book',ISBN AS ID, "+
					"       Title AS 'Title',Authors,Price "+
					"FROM   books "+
					"UNION " +
					"SELECT type='cd',SKU,Album,Artists,Price "+ 
					"FROM   cds ");
			}
			else if((string)Session["browse"] == "search") 
			{
				string inp = (string)Session["search_input"];

				DisplayList.ItemTemplate = Page.LoadTemplate("ProductsTpl.ascx");
				DisplayList.Visible = true;

				switch((string)Session["search_type"]) 
				{
					case "Title":
						MyDB.bindSQL(DisplayList,
							"SELECT type='book',ISBN AS ID, "+
							"       Title AS 'Title',Authors,Price "+
							"FROM   books "+
							"WHERE  title LIKE '%"+inp+"%' "+
							"UNION " +
							"SELECT type='cd',SKU,Album,Artists,Price "+ 
							"FROM   cds "+
							"WHERE  album LIKE '%"+inp+"%' ");
						break;
					case "Author/Artist":
						MyDB.bindSQL(DisplayList,
							"SELECT type='book',ISBN AS ID, "+
							"       Title AS 'Title',Authors,Price "+
							"FROM   books "+
							"WHERE  authors LIKE '%"+inp+"%' "+
							"UNION " +
							"SELECT type='cd',SKU,Album,Artists,Price "+ 
							"FROM   cds "+
							"WHERE  artists LIKE '%"+inp+"%' ");
						break;
					case "Keyword":
						MyDB.bindSQL(DisplayList,
							"SELECT type='book',ISBN AS ID, "+
							"       Title AS 'Title',Authors,Price "+
							"FROM   books "+
							"WHERE  keywords LIKE '%"+inp+"%' ");
						break;
				}
			}
			Session.Remove("browse");
		}

		private void displayDetails(string id)
		{
			string sub;
						
			BuyBtn.Visible = true;

			sub = "SELECT productid,sum(stock) as 'stock' "+
				"FROM availability "+
				"GROUP BY productid";

			DisplayList.ItemTemplate = Page.LoadTemplate("BookTpl.ascx");

			bool bound = MyDB.bindSQL(DisplayList,
							"SELECT * "+
							"FROM   books,("+sub+") as s "+
							"WHERE  isbn=productid AND isbn="+id);
			
			if(bound) return;
	
			DisplayList.ItemTemplate = Page.LoadTemplate("CDTpl.ascx");
			MyDB.bindSQL(DisplayList,
				"SELECT * "+ 
				"FROM   cds,("+sub+") as s "+
				"WHERE  sku=productid AND sku="+id);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.BuyBtn.Click += new System.EventHandler(this.BuyBtn_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void BuyBtn_Click(object sender, System.EventArgs e)
		{
			doBuy(Request.Params["ID"]);
		}

		private void doBuy(string id) {		
			string user = (string)Session["user"];
			
			if(user == null) 
			{	
				Session["pendingBuy"] = id;
				Session["rlogin"] = "browse.aspx";
				Response.Redirect("login.aspx", false);
				return;
			}

			string title = MyDB.queryValue("books", "title", "isbn="+id);
			if(title == null)
				title = MyDB.queryValue("cds", "album", "sku="+id);

			if(!MyDB.update("cart", "customer='"+user+"'AND productid="+id, "quantity=quantity+1"))
				MyDB.insert("cart", "'"+user+"',"+id+",'"+title+"',1");

			Response.Redirect("cart.aspx", false);
		}
	}
}
