using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace myprj
{
	/// <summary>
	/// Summary description for cart.
	/// </summary>
	public class cart : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox Quantity;
		protected System.Web.UI.WebControls.Label TotalLbl;
		protected System.Web.UI.WebControls.Button CheckoutBtn;
		protected System.Web.UI.WebControls.DataGrid CartGrid;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(IsPostBack) return;
			if(Session["user"] == null) 
			{
				Session["rlogin"] = "cart.aspx";
				Response.Redirect("login.aspx", false);
				return;
			}
			
			BindCart();
		}

		private void BindCart() 
		{
			string sVal;

			MyDB.bindSQL(CartGrid, "SELECT customer,productid,quantity,books.title,Price, "+
				"       subtotal=quantity*price "+
				"FROM cart,books "+
				"WHERE customer='"+Session["user"]+"' AND"+
				"      productid=isbn "+
				"UNION "+
				"SELECT customer,productid,quantity,album,Price, "+
				"       subtotal=quantity*price "+
				"FROM cart,cds "+
				"WHERE customer='"+Session["user"]+"' AND"+
				"      productid=sku ");


			sVal = MyDB.queryValue("SELECT sum(subtotal) "+
				                   "FROM (SELECT subtotal=price*quantity "+
				                   "      FROM   cart, books "+
				                   "      WHERE  customer='"+Session["user"]+"' AND "+
				                   "             productid=isbn "+
				                   "      UNION "+
				                   "      SELECT subtotal=price*quantity "+
				                   "      FROM   cart, cds "+
				                   "      WHERE  customer='"+Session["user"]+"' AND "+
				                   "             productid=sku) as sq");

			TotalLbl.Text = "$"+sVal;
		}
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.CartGrid.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.CartGrid_ItemCommand);
			this.CheckoutBtn.Click += new System.EventHandler(this.CheckoutBtn_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void CartGrid_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			if(e.CommandName == "quantity") 
			{				
				string user = (string)Session["user"];
				string id = (string)e.CommandArgument;
				TextBox QuantityTxt = (TextBox)((Button)e.CommandSource).Parent.FindControl("Quantity");
				int quant = int.Parse(QuantityTxt.Text);

				if(quant < 1) 
					MyDB.delete("cart", "customer='"+user+"' AND productid="+id);
				else
					MyDB.update("cart", "customer='"+user+"' AND productid="+id, "quantity="+quant);
				BindCart();
			}
		}

		private void CheckoutBtn_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("checkout.aspx", false);
		}
	}
}
