using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace myprj
{
	/// <summary>
	/// Summary description for manage.
	/// </summary>
	public class manage : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button city;
		protected System.Web.UI.WebControls.Button Sales;
		protected System.Web.UI.WebControls.Button Warehouses;
		protected System.Web.UI.WebControls.DataList DisplayList2;
		protected System.Web.UI.WebControls.Label Header1;
		protected System.Web.UI.WebControls.Label Header2;
		protected System.Web.UI.WebControls.TextBox cityname;
		protected System.Web.UI.WebControls.DataList DisplayList;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			if(Request.Params["warehouseID"] != null) 
			{
				Header1.Text = "Vendors:";
				Header2.Text = "Items in Stock:";
				Header1.Visible = true;
				Header2.Visible = true;
				displayDetails(Request.Params["warehouseID"]);
				return;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Sales.Click += new System.EventHandler(this.Sales_Click);
			this.Warehouses.Click += new System.EventHandler(this.Warehouses_Click);
			this.city.Click += new System.EventHandler(this.City_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Sales_Click(object sender, System.EventArgs e)
		{
			MyDB.setDB("inventory");
			DisplayList.ItemTemplate = Page.LoadTemplate("SalesTpl.ascx");
			DisplayList.Visible = true;
			MyDB.bindSQL(DisplayList,
				"SELECT type='book',books.ISBN AS ID, "+
				"       Title AS 'Title',Authors,Price,numSold,sales "+
				"FROM   books, booksales "+
				"WHERE books.ISBN = booksales.ISBN "+
				"UNION " +
				"SELECT type='cd',cds.SKU,Album,Artists,Price,numSold,sales "+ 
				"FROM   cds,cdsales "+
				"WHERE cds.SKU = cdsales.SKU");
		}

		private void Warehouses_Click(object sender, System.EventArgs e)
		{
			MyDB.setDB("inventory");
			DisplayList.ItemTemplate = Page.LoadTemplate("WarehouseTpl.ascx");
			DisplayList.Visible = true;
			MyDB.bindSQL(DisplayList,
				"SELECT warehouseID AS warehouseID, street, city, state, zipcode AS zip "+
				"FROM warehouses");
		}

		private void displayDetails(string warehouseID) 
		{
			// Display vendors associated with warehouse
			MyDB.setDB("shipping");
			DisplayList.ItemTemplate = Page.LoadTemplate("VendorsTpl.ascx");
			MyDB.bindSQL(DisplayList,
				"SELECT vendorname "+
				"FROM warehouses "+
				"WHERE warehouseID = "+warehouseID);

			// Display all products in warehouse
			MyDB.setDB("inventory");
			DisplayList2.ItemTemplate = Page.LoadTemplate("Products2Tpl.ascx");
			MyDB.bindSQL(DisplayList2,
				"SELECT type='book',ISBN AS ID, "+
				"       Title AS 'Title',Authors,Price,Stock AS numStock "+
				"FROM   books, availability "+
				"WHERE isbn=productID "+
				"AND warehouseID="+warehouseID+
				" UNION " +
				"SELECT type='cd',SKU,Album,Artists,Price,Stock AS numStock "+ 
				"FROM   cds, availability "+
				"WHERE SKU=productID "+
				"AND warehouseID="+warehouseID);
		}

		private void City_Click(object sender, System.EventArgs e)
		{
			// Display shipping methods, used, pricing unit, price per unit, maxitems, maxweight, weekenddlvry
			string citynm = cityname.Text;
			if(city.Equals("")) return;
			MyDB.setDB("shipping");
			DisplayList.ItemTemplate = Page.LoadTemplate("ShippingTpl.ascx");
			MyDB.bindSQL(DisplayList,
				"SELECT methods.vendorname AS vendorname, methods.shipoption AS shipoption, ratingunit, rateperunit, maxitems, maxweight, used "+
				"FROM methods, dstcities "+
				"WHERE city='"+citynm+"' "+
				"AND methods.vendorname = dstcities.vendorname "+
				"AND methods.shipoption = dstcities.shipoption");
		}
	}
}
