using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Globalization;

namespace myprj
{
	/// <summary>
	/// Summary description for payment.
	/// </summary>
	public class payment : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button MyAddrBillBtn;
		protected System.Web.UI.WebControls.TextBox BillNameTxt;
		protected System.Web.UI.WebControls.TextBox BillAddrTxt;
		protected System.Web.UI.WebControls.TextBox BillCityTxt;
		protected System.Web.UI.WebControls.DropDownList BillStateList;
		protected System.Web.UI.WebControls.DataGrid CartGrid;
		protected System.Web.UI.WebControls.Label SubLbl;
		protected System.Web.UI.WebControls.Label ShipLbl;
		protected System.Web.UI.WebControls.Label TotalLbl;
		protected System.Web.UI.WebControls.DropDownList PaymentList;
		protected System.Web.UI.WebControls.TextBox CreditTxt;
		protected System.Web.UI.WebControls.Button OrderBtn;
		protected System.Web.UI.WebControls.TextBox CCNumTxt;
		protected System.Web.UI.WebControls.DropDownList CCTypeList;
		protected System.Web.UI.WebControls.TextBox CCYearTxt;
		protected System.Web.UI.WebControls.DropDownList CCMonthList;
		protected System.Web.UI.WebControls.TextBox BillZipTxt;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(Session["user"] == null ||
			   Session["checkout-payment"] == null)
			{
				Response.Redirect("cart.aspx", false);
				return;
			}
			if(IsPostBack) return;
			BindCart();
		}

		private void BindCart() 
		{
			string sVal;

			MyDB.bindSQL(CartGrid, "SELECT customer,productid,quantity,books.title,Price, "+
				"       subtotal=quantity*price "+
				"FROM cart,books "+
				"WHERE customer='"+Session["user"]+"' AND"+
				"      productid=isbn "+
				"UNION "+
				"SELECT customer,productid,quantity,album,Price, "+
				"       subtotal=quantity*price "+
				"FROM cart,cds "+
				"WHERE customer='"+Session["user"]+"' AND"+
				"      productid=sku ");


			sVal = MyDB.queryValue("SELECT sum(subtotal) "+
				"FROM (SELECT subtotal=price*quantity "+
				"      FROM   cart, books "+
				"      WHERE  customer='"+Session["user"]+"' AND "+
				"             productid=isbn "+
				"      UNION "+
				"      SELECT subtotal=price*quantity "+
				"      FROM   cart, cds "+
				"      WHERE  customer='"+Session["user"]+"' AND "+
				"             productid=sku) as sq");

			double costSub = double.Parse(sVal);
			double costShip = 0;
			Package[] pkgs;

			pkgs = Package.allPackages(Page);
			foreach(Package pkg in pkgs)
				costShip += pkg.shippingPrice;
			
			double costTotal = costSub + costShip;

			SubLbl.Text = String.Format("{0:c}", costSub);
			ShipLbl.Text = String.Format("{0:c}", costShip);
			TotalLbl.Text = String.Format("{0:c}", costTotal);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.MyAddrBillBtn.Click += new System.EventHandler(this.MyAddrBillBtn_Click);
			this.OrderBtn.Click += new System.EventHandler(this.OrderBtn_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void MyAddrBillBtn_Click(object sender, System.EventArgs e)
		{
			if(Session["user"] == null) return;
			MyDB.fillMyAddr((string)Session["user"],BillNameTxt, BillAddrTxt, BillCityTxt, BillStateList,
				BillZipTxt, MyAddrBillBtn);	
		}

		private void OrderBtn_Click(object sender, System.EventArgs e)
		{
			Hashtable ht = new Hashtable();
			int invoiceID;
			string[] name;
			string fname, lname;

			name = ((string)Session["shipping-name"]).Split(' ');
			fname = String.Join(" ", name, 0, name.Length-1);
			lname = name[name.Length-1];

			MyDB.setDB("billing");

			try 
			{
				invoiceID = int.Parse(MyDB.queryValue("SELECT max(invoiceID)+1 FROM invoice"));
			}
			catch 
			{
				invoiceID = 1;
			}

			ht["invoiceID"] = String.Format("{0:d15}", invoiceID);
			ht["buyername"] = Session["user"];
			ht["rcptfname"] = fname;
			ht["rcptlname"] = lname;
			ht["subtotal"] = double.Parse(SubLbl.Text, NumberStyles.Currency);
			ht["orderdate"] = DateTime.Now.ToString();
			ht["dststreet"] = Session["shipping-addr"];
			ht["dstcity"] = Session["shipping-city"];
			ht["dststate"] = Session["shipping-state"];
			ht["dstzip"] = Session["shipping-zip"];
			ht["paymethod"] = PaymentList.SelectedValue;
			if(PaymentList.SelectedValue == "Credit") 
			{
				ht["ccowner"] = Session["user"];
				ht["cctype"] = CCTypeList.SelectedValue;
				ht["ccno"] = CCNumTxt.Text;
				ht["ccexpdate"] = CCMonthList.SelectedValue+CCYearTxt.Text;
			}
				
			MyDB.insert("invoice", ht);
			
			MyDB.setDB("shipping");

			Package[] pkgs = Package.allPackages(Page);
			foreach(Package pkg in pkgs) 
			{
				int trackID;
				try 
				{
					trackID = int.Parse(MyDB.queryValue("SELECT max(trackingID)+1 FROM packages"));
				} 
				catch 
				{
					trackID = 1;
				}
			
				ht.Clear();
				ht["invoiceID"] = String.Format("{0:d15}", invoiceID);
				ht["trackingID"] = String.Format("{0:d15}", trackID);
				ht["weight"] = pkg.weight;
				ht["status"] = "In transit";
				ht["numItems"] = pkg.numItems;
				ht["srcwarehouse"] = pkg.wareID.ToString();
				ht["shiptime"] = DateTime.Now.ToString();
				ht["estdlvrytime"] = pkg.ETA;
				ht["shipoption"] = pkg.shippingMethod;
				ht["vendor"] = pkg.shippingVendor;
				ht["requiresign"] = 0;
				MyDB.insert("packages", ht);
			}

			MyDB.setDB("inventory");
			MyDB.delete("cart", "customer='"+Session["user"]+"'");
			Response.Redirect("orders.aspx", false);
		}
	}
}
