using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Globalization;

namespace myprj
{
	/// <summary>
	/// Summary description for shipping.
	/// </summary>
	public class shipping : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label PkgHTML;
		protected System.Web.UI.WebControls.DataGrid ShipGrid;
		protected System.Web.UI.WebControls.Button NextBtn;
	
		private void Page_Load(object sender, System.EventArgs e)
		{			
			if(Session["checkout-shipping"] == null) 
			{
				Response.Redirect("checkout.aspx", false);
				return;
			}
			if(IsPostBack) return;
			generatePackages();

			string cache_id = (string)Session["user"] + "-pkgs";
			Package[] pdata;

			pdata = (Package[])Cache[cache_id];
			if(pdata == null) return;
			
			bindPkg();
		}

		private void generatePackages() 
		{
			string s = "";
			string cmd = "SELECT c.productid,warehouseid,quantity,stock "+
				"FROM   cart as c, availability as a "+
				"WHERE  customer='"+Session["user"]+"' AND "+
				"       c.productid=a.productid";
		  
			SqlDataReader reader = MyDB.getReader(cmd);
			Hashtable htWare = new Hashtable();
			Hashtable htNeed = new Hashtable();
			Hashtable htPkgs = new Hashtable();
							
			while(reader.Read()) 
			{
				int prodID, wareID, quantity, stock;

				prodID = reader.GetInt32(0);
				wareID = reader.GetInt32(1);
				quantity = reader.GetInt32(2);
				stock = reader.GetInt32(3);

				if(htNeed[prodID] == null)
					htNeed[prodID] = quantity;

				if(htWare[wareID] != null)
					htWare[wareID] = (int)htWare[wareID] + Math.Min(quantity, stock);
				else
					htWare[wareID] = Math.Min(quantity, stock);
			}
			reader.Close();

			while(htNeed.Count > 0) 
			{
				int maxVal = 0;
				int maxID = -1;				

				if(htWare.Count == 0) 
				{
//					MyHTML.Text = "Unable to ship!<BR>";
					return;
				}

				IDictionaryEnumerator enWare = htWare.GetEnumerator();
				while(enWare.MoveNext()) 
				{
					if((int)enWare.Value > maxVal) 
					{
						maxVal = (int)enWare.Value;
						maxID = (int)enWare.Key;
					}
				}			
				if(maxID != -1)
					htWare.Remove(maxID);

				htPkgs[maxID] = new Hashtable();

				cmd = "SELECT c.productid,stock "+
					"FROM   cart as c, availability as a "+
					"WHERE  customer='"+Session["user"]+"' AND "+
					"       c.productid=a.productid AND "+
					"       a.warehouseid="+maxID;
		  		
				reader = MyDB.getReader(cmd);

				while(reader.Read()) 
				{
					int prodID, stock;

					prodID = reader.GetInt32(0);
					stock = reader.GetInt32(1);

					if(htNeed[prodID] != null) 
					{
						int need = (int)htNeed[prodID];
						int shipped;

						shipped = Math.Min(need, stock);
						
						if(need == shipped)
							htNeed.Remove(prodID);
						else
							htNeed[prodID] = need - shipped;

						((Hashtable)htPkgs[maxID])[prodID] = shipped;
					}
				}
				reader.Close();
			}			

			IDictionaryEnumerator enPkgs = htPkgs.GetEnumerator();
			int pkgNum = 0;
			Package[] pdata = new Package[htPkgs.Count];

			while(enPkgs.MoveNext()) 
			{
				int wareID = (int)enPkgs.Key;
				string wareAddr, wareCity, wareState, wareZip, warePhone;
				string cond = "warehouseid="+wareID;
				double pkgWeight = 0;
				int pkgItems = 0;				

				wareAddr  = MyDB.queryValue("warehouses", "street", cond);
				wareCity  = MyDB.queryValue("warehouses", "city", cond);
				wareState = MyDB.queryValue("warehouses", "state", cond);
				wareZip   = MyDB.queryValue("warehouses", "zipcode", cond).ToString();
				warePhone = MyDB.queryValue("warehouses", "voice", cond).ToString();

				IDictionaryEnumerator enPkg = ((Hashtable)enPkgs.Value).GetEnumerator();

				string fr, to, pd;

				s += "<table border=1 width=\"100%\">";
				s += "<tr><td colspan=2>Package #"+(pkgNum+1)+"</td></tr>";
				
				fr  = "<table><tr><td><b>From:</b></td></tr>";
				fr += "<tr><td>Warehouse "+wareID+"</td></tr>";
				fr += "<tr><td>"+wareAddr+"</td></tr>";
				fr += "<tr><td>"+wareCity+", "+wareState+" "+wareZip+"</td></tr>";
				fr += "</table>";

				to  = "<table><tr><td><b>To:</b></td></tr>";
				to += "<tr><td>"+Session["shipping-name"]+"</td></tr>";
				to += "<tr><td>"+Session["shipping-addr"]+"</td></tr>";
				to += "<tr><td>"+Session["shipping-city"]+
                      ", "+Session["shipping-state"]+
                      " "+Session["shipping-zip"]+"</td></tr>";
				to += "</table>";

				pd = "<table border=1><tr><td>ProductID</td><td>Title</td><td align=\"center\">Quantity</td></tr>";
				while(enPkg.MoveNext())
				{
					string title = MyDB.queryValue("cart", "title", 
												   "customer='"+Session["user"]+"' AND "+
						                           "productid="+enPkg.Key);

					double prodW;
					try 
					{
						prodW = double.Parse(MyDB.queryValue("books", "weight", "isbn="+enPkg.Key));
					}
					catch 
					{
						prodW = double.Parse(MyDB.queryValue("cds", "weight", "sku="+enPkg.Key));
					}

					pkgItems += int.Parse(enPkg.Value.ToString());
					pkgWeight += int.Parse(enPkg.Value.ToString()) * prodW;

					pd += "<tr><td>"+enPkg.Key+"</td><td>"+title+
                          "</td><td align=\"center\">"+ enPkg.Value + "</td></tr>";
				}
				pd += "</table>";

				s += "<tr><td>"+fr+"</td><td>"+to+"</td></tr>";
				s += "<tr><td colspan=2>"+pd+"</td></tr>";
				s += "</table>";
	
				pdata[pkgNum] = new Package();
				pdata[pkgNum].HTML = s;
				pdata[pkgNum].wareID = wareID;
				pdata[pkgNum].weight = pkgWeight;
				pdata[pkgNum].numItems = pkgItems;

				s = "";
				pkgNum++;
			}			

			string cache_id = (string)Session["user"] + "-pkgs";

			Cache[cache_id] = pdata;
			Session["maxPkg"] = htPkgs.Count - 1;
			Session["curPkg"] = 0;			
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.NextBtn.Click += new System.EventHandler(this.NextBtn_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void bindPkg() 
		{
			string cache_id = (string)Session["user"] + "-pkgs";
			Package[] pdata;
			DataView costView;

			pdata = (Package[])Cache[cache_id];
			if(pdata == null) return;
							
			PkgHTML.Text = pdata[(int)Session["curPkg"]].HTML;
			int wareID = pdata[(int)Session["curPkg"]].wareID;

			costView = MyShipping.costView(wareID, 5, 4);
			if(costView != null) 
			{
				ShipGrid.DataSource = costView;
				ShipGrid.DataBind();
			}
		}

		

		private void NextBtn_Click(object sender, System.EventArgs e)
		{
			if(Session["checkout-shipping"] == null) return;

			if((int)Session["curPkg"] < (int)Session["maxPkg"]) 
			{
				Session["curPkg"] = (int)Session["curPkg"] + 1;
				bindPkg();
				return;
			}
			Session["checkout-payment"] = 1;

			Response.Redirect("payment.aspx", false);
		}

		public void HandleRadio(object sender,EventArgs e) 
		{			
			if(Session["checkout-shipping"] == null) return;

			RadioButton rb = (RadioButton) sender;
			string sRbText = rb.ClientID;
 
			foreach (DataGridItem i in ShipGrid.Items) 
			{
				rb = (RadioButton) i.FindControl("ShipRb");
				rb.Checked = false;
				if (sRbText==rb.ClientID) 
				{
					rb.Checked = true;

					Package pkg = Package.currentPackage(Page);
					if(pkg == null) return;

					pkg.shippingMethod = i.Cells[0].Text;
					pkg.shippingVendor = i.Cells[1].Text;
					pkg.ETA = DateTime.Now.AddDays(double.Parse(i.Cells[2].Text)).ToString();
					pkg.shippingPrice = Double.Parse(i.Cells[3].Text,NumberStyles.Currency);
				}									
			}
		}
	}
}
