using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace Femron
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class ShoppingCartForm : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label lblCart;
		protected System.Web.UI.WebControls.DataGrid grdMyCart;
	
		private SqlConnection sqlConn;	// Declare a connection object
		private SqlCommand sqlComCart;
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.WebControls.LinkButton LinkButton1;	// Declare a command object for the shopping cart


		private string strSqlString = "server=IISQLSRV; uid=msl3; pwd=kmaart; database=lidstrom_billing";
		protected System.Web.UI.WebControls.LinkButton lnkBtnCheckout;
		private string accountID;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.Label Label3;
		protected System.Web.UI.WebControls.Label Label1;
		private string error;
	

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			accountID = this.Request["accountID"];
			error = this.Request["error"];

			if(this.error != null)
			{
				Label1.Text = error;
				Label1.Visible = true;
			}

//			if(accountID == null)	//redirect to Login.aspx
//			{
//				Response.Redirect("Login.aspx?back=ShoppingCart.aspx");
//			}
			//else	//execute query to populate the grid
			{				
				if(!IsPostBack)
					this.DisplayCart();
			}
		}

		//displays the contents of the cart based on the accountID that the user has 
		//logged-in under
		private void DisplayCart()
		{
			grdMyCart.DataSource = this.cartData();
			grdMyCart.DataBind();
				
			grdMyCart.Visible = true;
		}

		//gets the contents of the cart based on the accountID that the user has 
		//logged-in under
		private DataSet cartData()
		{
			//int cart = 1;
			DataSet customerData = null;
			sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();

			//initialize a new command object for the stored procedure that displays the cart
			sqlComCart = new SqlCommand("sp_infoizeCart", sqlConn);
				
			SqlParameter _AccountID= new SqlParameter("@accountID",accountID);
			sqlComCart.Parameters.Add(_AccountID);

			try
			{
				//run the stored procedure		
				customerData = Login.runStoredProcedure(strSqlString, sqlComCart);
			}
			catch(Exception e)
			{
				lblCart.Text = e.Message+e.StackTrace;
			}

			//cartData.Tables[0].Columns["quantity"].Site = grdMyCart.Columns[1];

			// Close the sql connection at the end
			sqlConn.Close();

			return customerData;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.grdMyCart.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.grdMyCart_CancelCommand);
			this.grdMyCart.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.grdMyCart_EditCommand);
			this.grdMyCart.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.grdMyCart_UpdateCommand);
			this.lnkBtnCheckout.Click += new System.EventHandler(this.lnkBtnCheckout_Click);
			this.LinkButton1.Click += new System.EventHandler(this.LinkButton1_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion	
		
		//NEEDS A LOT OF FIXING
		//updates the quantity of the selected item
		private void grdMyCart_UpdateCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();

			//int quantity = Int32.Parse(e.Item.Cells[1].Text.ToString());
			TextBox qtyText = (TextBox)e.Item.Cells[1].Controls[0];
			//Control temp = e.Item.Cells[4];

			// Retrieve the updated values.
			string itemID = e.Item.Cells[4].Text;
			string itemType = e.Item.Cells[3].Text;
			string company = e.Item.Cells[6].Text;
			string qty = qtyText.Text;

			int newQuantity = Convert.ToInt32(qty);

			//execute SQL query to update quantity of the selected item
			//reload the data in the datagrid

			//sqlComCart = new SqlCommand("sp_infoizeCart", sqlConn);

			if(newQuantity <= 0)
			{
				sqlComCart = new SqlCommand("sp_removeFromShoppingCart", sqlConn);
			}
			else
			{
				sqlComCart = new SqlCommand("sp_updateShoppingCart", sqlConn);				
				sqlComCart.Parameters.Add(new SqlParameter("@quantity",newQuantity));
			}


			
			sqlComCart.Parameters.Add(new SqlParameter("@accountID",accountID));
			sqlComCart.Parameters.Add(new SqlParameter("@itemID",itemID));
			sqlComCart.Parameters.Add(new SqlParameter("@itemType",itemType));
			sqlComCart.Parameters.Add(new SqlParameter("@CompanyName",company));

			sqlComCart.CommandType = CommandType.StoredProcedure;

			sqlComCart.ExecuteNonQuery();
			
			//reset the EditItemIndex
			grdMyCart.EditItemIndex = -1;
			this.DisplayCart();
			
			sqlConn.Close();
		}

		//sets the edit index of the item selected
		private void grdMyCart_EditCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			grdMyCart.EditItemIndex = e.Item.ItemIndex;	//update the edit index
			this.DisplayCart();							//display the grid
		}

		//reset the edit index
		private void grdMyCart_CancelCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			grdMyCart.EditItemIndex = -1;	//reset the edit item index
			this.DisplayCart();				//display the grid
		}

		private void LinkButton1_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("Index.aspx?accountID=" + accountID);
		}

		private void lnkBtnCheckout_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("ShippingAddress.aspx?accountID=" + accountID);
		}
	}
}
