using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace Femron
{
	/// <summary>
	/// Summary description for Shipping.
	/// </summary>
	public class ShippingInfo : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label lblTitle;
		protected System.Web.UI.WebControls.Button btnSubmit;

		private string strSqlString = "server=IISQLSRV; uid=asifd; pwd=8asif4; database=sultan_inventory";
		protected System.Web.UI.WebControls.Label lblCreditCard;
		protected System.Web.UI.WebControls.DropDownList lstCards;
		protected System.Web.UI.WebControls.Label lblCardNumber;
		protected System.Web.UI.WebControls.TextBox txtCardNumber;
		protected System.Web.UI.WebControls.Label lblExpiration;
		protected System.Web.UI.WebControls.TextBox txtExpiration;
		protected System.Web.UI.WebControls.TextBox txtTotal;
		protected System.Web.UI.WebControls.Label lblTotal;
		protected System.Web.UI.WebControls.Label lblBilling;
		
		private SqlConnection sqlConn;	// Declare a connection object
		private SqlCommand sqlCom;	// Declare a command object
		private SqlCommand sqlComShip;
		//private DataSet data;			

		private string accountID;	//string that passes along the accountID
		private string city;
		private string state;
		private string address;
		protected System.Web.UI.WebControls.Label lblPackages;
		protected System.Web.UI.WebControls.DataGrid datagrdPurchases;
		protected System.Web.UI.WebControls.DataGrid datagrdPackages;
		protected System.Web.UI.WebControls.DataGrid datagrdShippingOptions;
		protected System.Web.UI.WebControls.Label lblPurchases;
		protected System.Web.UI.WebControls.Label lblShippingMethod;
		private DataSet shippingInfo;

	
		private void Page_Load(object sender, System.EventArgs e)
		{
			this.accountID = this.Request["accountID"];
			this.city = this.Request["city"];
			this.state = this.Request["state"];
			this.address = this.Request["address"];
				
			if(!this.IsPostBack)
			{
				this.shippingInfo = this.getShippingInfo();	
				this.DisplayPurchases();
				this.displayPackages();
				this.shippingOptionsDisplay();
			}
		}

		//display the items being purchased and their corresponding packages
		private void displayPackages()
		{
			datagrdPackages.DataSource = this.shippingInfo;

			datagrdPackages.DataBind();
			datagrdPackages.Visible = true;
		}

		//BLAH
		private DataSet getShippingInfo()
		{
			DataSet result = new DataSet();

			this.sqlConn = new SqlConnection(strSqlString);
			this.sqlConn.Open();


			// LOOK FOR A WAREHOUSE THAT CAN SUPPLY ALL ITEMS IN A CART AND IS IN THE SAME CITY AS BUYER

			this.sqlComShip = new SqlCommand("sultan_inventory.dbo.sp_findStockedWarehouseInCity",sqlConn);
			this.sqlComShip.Parameters.Add("@accountID",this.accountID);
			this.sqlComShip.Parameters.Add("@city",this.city);
			this.sqlComShip.CommandType = CommandType.StoredProcedure;

			(new SqlDataAdapter(this.sqlComShip)).Fill(result);
			
			//if found return that result
			if(result.Tables[0].Rows.Count > 0)
			{
				result.Tables[0].Columns["WarehouseID"].ColumnName = "PackageID";
				return result;
			}

			// LOOK FOR A WAREHOUSE THAT CAN SUPPLY ALL ITEMS IN A CART
			
			result = new DataSet();
			this.sqlComShip = new SqlCommand("sultan_inventory.dbo.sp_findStockedWarehouse",sqlConn);
			this.sqlComShip.Parameters.Add("@accountID",this.accountID);
			this.sqlComShip.CommandType = CommandType.StoredProcedure;

			(new SqlDataAdapter(this.sqlComShip)).Fill(result);

			//if found return that result
			if(result.Tables[0].Rows.Count > 0)
			{
				result.Tables[0].Columns["WarehouseID"].ColumnName = "PackageID";
				return result;
			}

			sqlConn.Close();


			// FIND A LIST OF WAREHOUSES THAT CAN SUPPLY A CART
            result = new DataSet();
			ArrayList warehouseList = (new Femron.ShoppingCart(accountID, sqlConn)).getWarehouseList();

			//if none are found then the cart can't be purchased -- panic attack!
			if(warehouseList == null)
				return result;

			result.Tables.Add();

			result.Tables[0].Columns.Add();
			result.Tables[0].Columns.Add();
			result.Tables[0].Columns.Add();
			result.Tables[0].Columns.Add();
			result.Tables[0].Columns[0].ColumnName = "PackageID";
			result.Tables[0].Columns[1].ColumnName = "quantity";
			result.Tables[0].Columns[2].ColumnName = "ItemID";
			result.Tables[0].Columns[3].ColumnName = "ItemName";

			for(int i = 0; i < warehouseList.Count; i++)
			{
				result.Tables[0].Rows.Add((string [])(warehouseList[i]));
			}

			return result;
		}

		//displays the contents of the cart based on the accountID that the user has 
		//logged-in under
		private void DisplayPurchases()
		{
			datagrdPurchases.DataSource = this.cartData();
			datagrdPurchases.DataBind();
				
			datagrdPurchases.Visible = true;
		}

		//gets the contents of the cart based on the accountID that the user has 
		//logged-in under
		private DataSet cartData()
		{
			//int cart = 1;
			DataSet customerData = null;
			sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();

			//initialize a new command object for the stored procedure that displays the cart
			sqlCom = new SqlCommand("petert_shipping.dbo.sp_getCartOrderInfo", sqlConn);
				
			SqlParameter _AccountID = new SqlParameter("@accountID","2");
			sqlCom.Parameters.Add(_AccountID);

			try
			{
				//run the stored procedure		
				customerData = Login.runStoredProcedure(strSqlString, sqlCom);
			}
			catch(Exception e)
			{
				//lblCart.Text = e.Message+e.StackTrace;
				lblTitle.Text = e.Message;
			}

			//cartData.Tables[0].Columns["quantity"].Site = grdMyCart.Columns[1];

			// Close the sql connection at the end
			sqlConn.Close();


			return customerData;
		}

		//---------------------------------------------
		// work on this
		//---------------------------------------------
		private void shippingOptionsDisplay()
		{			
			ArrayList result = new ArrayList();
			DataSet packageShippingInfo = new DataSet();
		
			if(this.shippingInfo.Tables[0].Rows.Count > 1)
			{
				sqlCom = new SqlCommand("petert_shipping.dbo.sp_getShippingOptions", sqlConn);

				SqlParameter _CITY = new SqlParameter("@city", this.city);
				sqlCom.Parameters.Add(_CITY);

				SqlParameter _WAREHOUSE = new SqlParameter("@warehouse", this.shippingInfo.Tables[0].Rows[0]["packageID"]);
				sqlCom.Parameters.Add(_WAREHOUSE);

				SqlParameter _TIME = new SqlParameter("@deliveryTime", 1);
				sqlCom.Parameters.Add(_TIME);

				SqlParameter _WEIGHT = new SqlParameter("@weight", 1);
				sqlCom.Parameters.Add(_WEIGHT);

				SqlParameter _NUMITEMS = new SqlParameter("@numItems", this.shippingInfo.Tables[0].Rows[0]["quantity"]);
				sqlCom.Parameters.Add(_NUMITEMS);

				this.sqlComShip.CommandType = CommandType.StoredProcedure;

				(new SqlDataAdapter(this.sqlComShip)).Fill(packageShippingInfo);

				
			}
			else 
			{
				for(int i = 0; i < this.shippingInfo.Tables[0].Rows.Count; i++)
				{
					string warehouseID = shippingInfo.Tables[0].Rows[i]["PackageID"].ToString();
					string packageID   = warehouseID;
					string deliveryTime = "1";	//i.Cells[2].Text;
					string weight = "1";
					string numItems = shippingInfo.Tables[0].Rows[i]["quantity"].ToString();
					
					bool alreadyExists = false;
					for(int j = 0; j < result.Count; ++i)
						if(((string[])result[j])[0] == packageID)
							alreadyExists = true;
					if(alreadyExists)
						continue;

					DataSet shippingOptions = null;
					sqlConn = new SqlConnection(strSqlString);

					sqlConn.Open();
				
					//GETS THE SHIPPING METHOD & VENDOR, COST, guaranteedDeliveryTime
					sqlCom = new SqlCommand("petert_shipping.dbo.sp_getShippingOptions", sqlConn);

					SqlParameter _CITY = new SqlParameter("@city", this.city);
					sqlCom.Parameters.Add(_CITY);

					SqlParameter _WAREHOUSE = new SqlParameter("@warehouse", warehouseID);
					sqlCom.Parameters.Add(_WAREHOUSE);

					SqlParameter _TIME = new SqlParameter("@deliveryTime", deliveryTime);
					sqlCom.Parameters.Add(_TIME);

					SqlParameter _WEIGHT = new SqlParameter("@weight", weight);
					sqlCom.Parameters.Add(_WEIGHT);

					SqlParameter _NUMITEMS = new SqlParameter("@numItems", numItems);
					sqlCom.Parameters.Add(_NUMITEMS);

					//shippingOptions.Tables.Add();
					DataSet temp = Login.runStoredProcedure(strSqlString, sqlCom);
					string[] bestMethod = new string[] {packageID, 
														   (string)temp.Tables[0].Rows[0][0], 
														   (string)temp.Tables[0].Rows[0][1], 
														   (string)temp.Tables[0].Rows[0][2]};
					result.Add(bestMethod);
				}
				packageShippingInfo.Tables.Add();
				
				packageShippingInfo.Tables[0].Columns.Add();
				packageShippingInfo.Tables[0].Columns.Add();
				packageShippingInfo.Tables[0].Columns.Add();
				packageShippingInfo.Tables[0].Columns[0].ColumnName = "ShippingMethod";
				packageShippingInfo.Tables[0].Columns[1].ColumnName = "Cost";
				packageShippingInfo.Tables[0].Columns[2].ColumnName = "GuaranteedDeliveryTime";

				for(int i = 0; i < result.Count; i++)
				{
					packageShippingInfo.Tables[0].Rows.Add((string [])(result[i]));
				}
			}


			datagrdShippingOptions.DataSource = packageShippingInfo;

			datagrdShippingOptions.DataBind();
			datagrdShippingOptions.Visible = true;			
		}
		//---------------------------------------------
		// Stop working on this here
		//---------------------------------------------


		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnSubmit.Click += new System.EventHandler(this.btnSubmit_Click);
			this.datagrdShippingOptions.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datagrdShippingOptions_CancelCommand);
			this.datagrdShippingOptions.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datagrdShippingOptions_EditCommand);
			this.datagrdShippingOptions.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datagrdShippingOptions_UpdateCommand);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion


		private void btnSubmit_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("Success.aspx?accountID=" + this.accountID + "?totalAmount=" + this.txtTotal.Text);
		}

		private void datagrdShippingOptions_EditCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			datagrdShippingOptions.EditItemIndex = e.Item.ItemIndex;	//update the edit index
			this.shippingOptionsDisplay();								//display the grid
		}

		private void datagrdShippingOptions_UpdateCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			this.shippingOptionsDisplay();
			datagrdShippingOptions.EditItemIndex = -1;
		}

		private void datagrdShippingOptions_CancelCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			datagrdShippingOptions.EditItemIndex = -1;
			this.shippingOptionsDisplay();
		}
	}
}
