using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace Femron
{
	/// <summary>
	/// Summary description for Shipping.
	/// </summary>
	public class ShippingInfo : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label lblTitle;
		protected System.Web.UI.WebControls.Button btnSubmit;

		private string strSqlString = "server=IISQLSRV; uid=asifd; pwd=8asif4; database=sultan_inventory";
		protected System.Web.UI.WebControls.Label lblCreditCard;
		protected System.Web.UI.WebControls.DropDownList lstCards;
		protected System.Web.UI.WebControls.Label lblCardNumber;
		protected System.Web.UI.WebControls.TextBox txtCardNumber;
		protected System.Web.UI.WebControls.Label lblExpiration;
		protected System.Web.UI.WebControls.TextBox txtExpiration;
		protected System.Web.UI.WebControls.TextBox txtTotal;
		protected System.Web.UI.WebControls.Label lblTotal;
		protected System.Web.UI.WebControls.Label lblBilling;
		
		private SqlConnection sqlConn;	// Declare a connection object
		private SqlCommand sqlCom;	// Declare a command object
		private SqlCommand sqlComShip;
		//private DataSet data;			

		private string accountID;	//string that passes along the accountID
		private string city;
		private string state;
		private string address;
		private string zipCode;
		protected System.Web.UI.WebControls.Label lblPackages;
		protected System.Web.UI.WebControls.DataGrid datagrdPurchases;
		protected System.Web.UI.WebControls.DataGrid datagrdPackages;
		protected System.Web.UI.WebControls.DataGrid datagrdShippingOptions;
		protected System.Web.UI.WebControls.Label lblPurchases;
		protected System.Web.UI.WebControls.Label lblShippingMethod;
		private DataSet shippingInfo;

	
		private void Page_Load(object sender, System.EventArgs e)
		{
			this.accountID = this.Request["accountID"];
			this.city = this.Request["city"];
			this.state = this.Request["state"];
			this.address = this.Request["address"];
			this.zipCode = this.Request["zipCode"];
				
			if(!this.IsPostBack)
			{
				this.shippingInfo = this.getShippingInfo();	
				this.DisplayPurchases();
				this.displayPackages();
				shippingOptionsDisplay();
			}
		}

		//display the items being purchased and their corresponding packages
		private void displayPackages()
		{
			datagrdPackages.DataSource = this.shippingInfo;

			datagrdPackages.DataBind();
			datagrdPackages.Visible = true;
		}

		//BLAH
		private DataSet getShippingInfo()
		{
			DataSet result = new DataSet();

			this.sqlConn = new SqlConnection(strSqlString);
			this.sqlConn.Open();


			// LOOK FOR A WAREHOUSE THAT CAN SUPPLY ALL ITEMS IN A CART AND IS IN THE SAME CITY AS BUYER

			this.sqlComShip = new SqlCommand("sultan_inventory.dbo.sp_findStockedWarehouseInCity",sqlConn);
			this.sqlComShip.Parameters.Add("@accountID",this.accountID);
			this.sqlComShip.Parameters.Add("@city",this.city);
			this.sqlComShip.CommandType = CommandType.StoredProcedure;

			(new SqlDataAdapter(this.sqlComShip)).Fill(result);
			
			//if found return that result
			if(result.Tables[0].Rows.Count > 0)
			{
				result.Tables[0].Columns["WarehouseID"].ColumnName = "PackageID";
				return result;
			}

			// LOOK FOR A WAREHOUSE THAT CAN SUPPLY ALL ITEMS IN A CART
			
			result = new DataSet();
			this.sqlComShip = new SqlCommand("sultan_inventory.dbo.sp_findStockedWarehouse",sqlConn);
			this.sqlComShip.Parameters.Add("@accountID",this.accountID);
			this.sqlComShip.CommandType = CommandType.StoredProcedure;

			(new SqlDataAdapter(this.sqlComShip)).Fill(result);

			//if found return that result
			if(result.Tables[0].Rows.Count > 0)
			{
				result.Tables[0].Columns["WarehouseID"].ColumnName = "PackageID";
				return result;
			}

			sqlConn.Close();


			// FIND A LIST OF WAREHOUSES THAT CAN SUPPLY A CART
            result = new DataSet();
			ArrayList warehouseList = (new Femron.ShoppingCart(accountID, sqlConn)).getWarehouseList();

			//if none are found then the cart can't be purchased -- panic attack!
			if(warehouseList == null)
			{
				btnSubmit.Visible = false;
				return result;
			}

			result.Tables.Add();

			result.Tables[0].Columns.Add();
			result.Tables[0].Columns.Add();
			result.Tables[0].Columns.Add();
			result.Tables[0].Columns.Add();
			result.Tables[0].Columns.Add();
			result.Tables[0].Columns[0].ColumnName = "PackageID";
			result.Tables[0].Columns[1].ColumnName = "quantity";
			result.Tables[0].Columns[2].ColumnName = "ItemID";
			result.Tables[0].Columns[3].ColumnName = "ItemName";
			result.Tables[0].Columns[4].ColumnName = "PackageWeight";

			for(int i = 0; i < warehouseList.Count; i++)
			{
				result.Tables[0].Rows.Add((string [])(warehouseList[i]));
			}

			return result;
		}

		//displays the contents of the cart based on the accountID that the user has 
		//logged-in under
		private void DisplayPurchases()
		{
			datagrdPurchases.DataSource = this.cartData();
			datagrdPurchases.DataBind();
				
			datagrdPurchases.Visible = true;
		}

		//gets the contents of the cart based on the accountID that the user has 
		//logged-in under
		private DataSet cartData()
		{
			//int cart = 1;
			DataSet customerData = null;
			sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();

			//initialize a new command object for the stored procedure that displays the cart
			sqlCom = new SqlCommand("petert_shipping.dbo.sp_getCartOrderInfo", sqlConn);
				
			SqlParameter _AccountID = new SqlParameter("@accountID","2");
			sqlCom.Parameters.Add(_AccountID);

			try
			{
				//run the stored procedure		
				customerData = Login.runStoredProcedure(strSqlString, sqlCom);
			}
			catch(Exception e)
			{
				//lblCart.Text = e.Message+e.StackTrace;
				lblTitle.Text = e.Message;
			}

			//cartData.Tables[0].Columns["quantity"].Site = grdMyCart.Columns[1];

			// Close the sql connection at the end
			sqlConn.Close();


			return customerData;
		}


		//---------------------------------------------
		// work on this
		//---------------------------------------------
		private void shippingOptionsDisplay()
		{			
			DataSet result = new DataSet();
			//ArrayList shippingOptionsDataSets;
		
			if(shippingInfo.Tables[0].Rows.Count > 1)
			{}
			else 
			{
				//shippingOptionsDataSets = new ArrayList(shippingInfo.Tables[0].Rows.Count);

				for(int i = 0; i < shippingInfo.Tables[0].Rows.Count; i++)
				{
					string warehouseID = shippingInfo.Tables[0].Rows[i]["PackageID"].ToString();
					string packageID   = warehouseID;
					string deliveryTime = shippingInfo.Tables[0].Rows[i]["PackageWeight"].ToString();
					string weight = shippingInfo.Tables[0].Rows[i]["weight"].ToString();
					string numItems = shippingInfo.Tables[0].Rows[i]["quantity"].ToString();

					try
					{
						result.Tables.Add(packageID);
					} 
					catch(DuplicateNameException) 
					{
						continue;
					}
				
					DataSet shippingOptions = null;
					sqlConn = new SqlConnection(strSqlString);

					sqlConn.Open();
				
					//GETS THE SHIPPING METHOD & VENDOR, COST, guaranteedDeliveryTime
					sqlCom = new SqlCommand("petert_shipping.dbo.sp_getShippingOptions", sqlConn);

					SqlParameter _CITY = new SqlParameter("@city", this.city);
					sqlCom.Parameters.Add(_CITY);

					SqlParameter _WAREHOUSE = new SqlParameter("@warehouse", warehouseID);
					sqlCom.Parameters.Add(_WAREHOUSE);

					SqlParameter _TIME = new SqlParameter("@deliveryTime", deliveryTime);
					sqlCom.Parameters.Add(_TIME);

					SqlParameter _WEIGHT = new SqlParameter("@weight", weight);
					sqlCom.Parameters.Add(_WEIGHT);

					SqlParameter _NUMITEMS = new SqlParameter("@numItems", numItems);
					sqlCom.Parameters.Add(_NUMITEMS);
					
					
					(new SqlDataAdapter(sqlCom)).Fill(shippingOptions);
					
					//shippingOptions = Login.runStoredProcedure(strSqlString, sqlCom);
					
					//shippingOptions.Tables[packageID];

					//shippingOptionsDataSets[i] = shippingOptions;
					sqlConn.Close();
				}

				
			}
			//datagrdShippingOptions.DataSource = shippingInfo;
			datagrdShippingOptions.DataBind();
			datagrdShippingOptions.Visible = true;
		}
		//---------------------------------------------
		// Stop working on this here
		//---------------------------------------------


		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnSubmit.Click += new System.EventHandler(this.btnSubmit_Click);
			this.datagrdShippingOptions.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datagrdShippingOptions_CancelCommand);
			this.datagrdShippingOptions.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datagrdShippingOptions_EditCommand);
			this.datagrdShippingOptions.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datagrdShippingOptions_UpdateCommand);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion


		private void btnSubmit_Click(object sender, System.EventArgs e)
		{
			DataSet invoiceSet = new DataSet();
			DataSet packageSet = new DataSet();
			int invoiceID;
			int packageID;
			this.sqlConn = new SqlConnection(strSqlString);
			this.sqlConn.Open();
			
			//=======================================
			// create the new invoice
			//=======================================
			this.sqlCom = new SqlCommand("lidstrom_billing.dbo.sp_newInvoiceWithReturn", sqlConn);
			SqlParameter _BUYER = new SqlParameter("@buyer", this.accountID);
			sqlCom.Parameters.Add(_BUYER);
			
			SqlParameter _PAYMENTMETHOD = new SqlParameter("@paymentMethod", "MO");
			sqlCom.Parameters.Add(_PAYMENTMETHOD);
			
			SqlParameter _CREDCARDNUM = new SqlParameter("@credCardNum", "123456789");
			sqlCom.Parameters.Add(_CREDCARDNUM);
			
			SqlParameter _PAYMENTRECEIVED = new SqlParameter("@paymentReceived", "f");
			sqlCom.Parameters.Add(_PAYMENTRECEIVED);
			
			SqlParameter _SHIPMETHOD = new SqlParameter("@shipMethod", "FedEX Air");
			sqlCom.Parameters.Add(_SHIPMETHOD);
			
			SqlParameter _SHIPSTADDRESS = new SqlParameter("@shipStAddress", this.address);
			sqlCom.Parameters.Add(_SHIPSTADDRESS);
			
			SqlParameter _SHIPZIPCODE = new SqlParameter("@shipZipCode", this.zipCode);
			sqlCom.Parameters.Add(_SHIPZIPCODE);
			
			SqlParameter _SHIPCITY = new SqlParameter("@shipCity", this.city);
			sqlCom.Parameters.Add(_SHIPCITY);
			
			SqlParameter _SHIPSTATE = new SqlParameter("@shipState", "WA");
			sqlCom.Parameters.Add(_SHIPSTATE);
			
			SqlParameter _SHIPPOBOX = new SqlParameter("@shipPOBox", "");
			sqlCom.Parameters.Add(_SHIPPOBOX);
			
			sqlCom.CommandType = CommandType.StoredProcedure;
			(new SqlDataAdapter(sqlCom)).Fill(invoiceSet);
			invoiceID = Convert.ToInt32(invoiceSet.Tables[0].Rows[0].ItemArray[0].ToString());
			
			//=============================================
			//creat the new packages
			//insert a for loop over all packages
			//==============================================

			sqlCom.Parameters.Clear();
			this.sqlCom = new SqlCommand("petert_shipping.dbo.sp_newPackageWithReturn", sqlConn);
			
			SqlParameter _INVOICEID = new SqlParameter("@invoiceID", invoiceID.ToString());
			sqlCom.Parameters.Add(_INVOICEID);
			
			SqlParameter _WEIGHT = new SqlParameter("@weight", "1");
			sqlCom.Parameters.Add(_WEIGHT);
			
			SqlParameter _NUMUNITS = new SqlParameter("@numUnits", "1");
			sqlCom.Parameters.Add(_NUMUNITS);
			
			SqlParameter _SPECIALINSTRUCTIONS = new SqlParameter("@specialInstructions", "");
			sqlCom.Parameters.Add(_SPECIALINSTRUCTIONS);
			
			SqlParameter _WAREHOUSEID = new SqlParameter("@warehouseID", "123");
			sqlCom.Parameters.Add(_WAREHOUSEID);
			
			SqlParameter _VENDORNAME = new SqlParameter("@vendorName", "FedEX");
			sqlCom.Parameters.Add(_VENDORNAME);
			
			SqlParameter _METHODNAME = new SqlParameter("@methodName", "Air");
			sqlCom.Parameters.Add(_METHODNAME);
			
			SqlParameter _DESTINATIONFIRSTNAME = new SqlParameter("@destinationFirstName", "Matt");
			sqlCom.Parameters.Add(_DESTINATIONFIRSTNAME);
			
			SqlParameter _DESTINATIONLASTNAME = new SqlParameter("@destinationLastName", "Lidstrom");
			sqlCom.Parameters.Add(_DESTINATIONLASTNAME);
			
			SqlParameter _DESTINATIONSTREETADDRESS = new SqlParameter("@destinationStreetAddress", this.address);
			sqlCom.Parameters.Add(_DESTINATIONSTREETADDRESS);
			
			SqlParameter _DESTINATIONCITY = new SqlParameter("@destinationCity", this.city);
			sqlCom.Parameters.Add(_DESTINATIONCITY);
			
			SqlParameter _DESTINATIONSTATE = new SqlParameter("@destinationState", "WA");
			sqlCom.Parameters.Add(_DESTINATIONSTATE);
			
			SqlParameter _DESTINATIONZIP = new SqlParameter("@destinationZip", this.zipCode);
			sqlCom.Parameters.Add(_DESTINATIONZIP);
			
			SqlParameter _CONTACTPHONE1 = new SqlParameter("@contactPhone1", "14256661234");
			sqlCom.Parameters.Add(_CONTACTPHONE1);
			
			SqlParameter _CONTACTPHONE2 = new SqlParameter("@contactPhone2", "14256661234");
			sqlCom.Parameters.Add(_CONTACTPHONE2);
			
			SqlParameter _EMAIL = new SqlParameter("@contactEmail", "msl3@u.washington.edu");
			sqlCom.Parameters.Add(_EMAIL);
			
			sqlCom.CommandType = CommandType.StoredProcedure;
			(new SqlDataAdapter(sqlCom)).Fill(packageSet);
			packageID = Convert.ToInt32(packageSet.Tables[0].Rows[0].ItemArray[0].ToString());

			//==========================================
			//Store the Purchases
			//==========================================

			sqlCom.Parameters.Clear();
			this.sqlCom = new SqlCommand("lidstrom_billing.dbo.sp_storePurchase", sqlConn);
			
			_INVOICEID = new SqlParameter("@invoiceID", invoiceID.ToString());
			sqlCom.Parameters.Add(_INVOICEID);
			
			SqlParameter _ITEMID = new SqlParameter("@itemID", "565656");
			sqlCom.Parameters.Add(_ITEMID);
			
			SqlParameter _ITEMNAME = new SqlParameter("@itemName", "The Book of");
			sqlCom.Parameters.Add(_ITEMNAME);
			
			SqlParameter _UNITPRICE = new SqlParameter("@unitPrice", "1");
			sqlCom.Parameters.Add(_UNITPRICE);
			
			SqlParameter _PRODUCTDISCOUNT = new SqlParameter("@productDiscount", "3");
			sqlCom.Parameters.Add(_PRODUCTDISCOUNT);
			
			SqlParameter _QUANTITY = new SqlParameter("@quantity", "1");
			sqlCom.Parameters.Add(_QUANTITY);
			
			SqlParameter _ITEMTYPE = new SqlParameter("@itemType", "B");
			sqlCom.Parameters.Add(_ITEMTYPE);
			
			sqlCom.CommandType = CommandType.StoredProcedure;
			sqlCom.ExecuteNonQuery();
			
			//==========================================
			//Store the ShippingInfo
			//==========================================

			sqlCom.Parameters.Clear();
			this.sqlCom = new SqlCommand("lidstrom_billing.dbo.sp_storeShippingInfo", sqlConn);
			
			_INVOICEID = new SqlParameter("@invoiceID", invoiceID.ToString());
			sqlCom.Parameters.Add(_INVOICEID);
			
			_ITEMID = new SqlParameter("@itemID", "565656");
			sqlCom.Parameters.Add(_ITEMID);
			
			_WAREHOUSEID = new SqlParameter("@warehouseID", "123");
			sqlCom.Parameters.Add(_WAREHOUSEID);
			
			_QUANTITY = new SqlParameter("@quantity", "1");
			sqlCom.Parameters.Add(_QUANTITY);
			
			SqlParameter _COST = new SqlParameter("@cost", "1.00");
			sqlCom.Parameters.Add(_COST);
			
			_ITEMTYPE = new SqlParameter("@itemType", "B");
			sqlCom.Parameters.Add(_ITEMTYPE);

			sqlCom.CommandType = CommandType.StoredProcedure;
			sqlCom.ExecuteNonQuery();

			//===========================================
			
			sqlConn.Close();

			Response.Redirect("Success.aspx?accountID=" + this.accountID + "&totalAmount=" + this.txtTotal.Text + "&invoiceID=" + invoiceID.ToString());
		}

		private void datagrdShippingOptions_EditCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			datagrdShippingOptions.EditItemIndex = e.Item.ItemIndex;	//update the edit index
			this.shippingOptionsDisplay();								//display the grid
		}

		private void datagrdShippingOptions_UpdateCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			this.shippingOptionsDisplay();
			datagrdShippingOptions.EditItemIndex = -1;
		}

		private void datagrdShippingOptions_CancelCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			datagrdShippingOptions.EditItemIndex = -1;
			this.shippingOptionsDisplay();
		}
	}
}
