using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.IO;

namespace Femron
{
	/// <summary>
	/// Summary description for Shipping.
	/// </summary>
	public class ShippingInfo : System.Web.UI.Page
	{
		#region Instance Varianbles
		protected System.Web.UI.WebControls.Label lblTitle;
		protected System.Web.UI.WebControls.Button btnSubmit;

		private string strSqlString = "server=IISQLSRV; uid=asifd; pwd=8asif4; database=sultan_inventory";
		protected System.Web.UI.WebControls.Label lblCreditCard;
		protected System.Web.UI.WebControls.DropDownList lstCards;
		protected System.Web.UI.WebControls.Label lblCardNumber;
		protected System.Web.UI.WebControls.TextBox txtCardNumber;
		protected System.Web.UI.WebControls.Label lblExpiration;
		protected System.Web.UI.WebControls.TextBox txtExpiration;
		protected System.Web.UI.WebControls.TextBox txtTotal;
		protected System.Web.UI.WebControls.Label lblTotal;
		protected System.Web.UI.WebControls.Label lblBilling;
		
		private SqlConnection sqlConn;	// Declare a connection object
		private SqlCommand sqlCom;	// Declare a command object
		private SqlCommand sqlComShip;
		private SqlCommand sqlCommAccount;	//acount info
		private SqlCommand sqlComMethod;

		private string accountID;	//string that passes along the accountID
		private string city;
		private string state;
		private string address;
		private string zipCode;
		protected System.Web.UI.WebControls.Label lblPackages;
		protected System.Web.UI.WebControls.DataGrid datagrdPurchases;
		protected System.Web.UI.WebControls.DataGrid datagrdPackages;
		protected System.Web.UI.WebControls.DataGrid datagrdShippingOptions;
		protected System.Web.UI.WebControls.Label lblPurchases;
		protected System.Web.UI.WebControls.Label lblShippingMethod;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.DataGrid datagrdOtherCompany;
		protected DataSet packageShippingInfo;
		private static DataSet shippingInfo;
		private static DataSet foreignShipments;

		//account info
		private string fnameStr, lnameStr, miStr, acctNameStr, oldPassStr, stAddressStr, POboxStr, cityStr, stateStr, zipStr, emailStr,
			homePhoneStr, cellPhoneStr;

		//payment info
		private string cardType, cardNumber, expirationDate;

		//data structures to generate order form info
		ArrayList companies = new ArrayList();
		protected System.Web.UI.WebControls.Label companyMethodErrorLabel;
		
		Random orderNumberGen = new Random();

		#endregion
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			//get destination shipping info from the previous screen
			this.accountID = this.Request["accountID"];
			this.city = this.Request["city"];
			this.state = this.Request["state"];
			this.address = this.Request["address"];
			this.zipCode = this.Request["zipCode"];
			
			sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();

			sqlCom = new SqlCommand("petert_shipping.dbo.sp_getOrderCost",sqlConn);
			sqlCom.Parameters.Add("@acct", accountID);
			
			sqlCom.CommandType = CommandType.StoredProcedure;
			DataSet packageSet = new DataSet();
			(new SqlDataAdapter(sqlCom)).Fill(packageSet);
			txtTotal.Text = "$" + Math.Round(double.Parse(packageSet.Tables[0].Rows[0][0].ToString()), 2).ToString();
			
			sqlConn.Close();
			if(!this.IsPostBack)
			{
				this.packageShippingInfo = new DataSet();
				ShippingInfo.shippingInfo = this.getShippingInfo();	
				this.DisplayPurchases();
				this.displayPackages();
				this.otherCompanyShipping();
				//this.shippingOptionsDisplay();
			}

			//get the account information for this person
			this.sqlConn = new SqlConnection(strSqlString);
			this.sqlConn.Open();

			this.sqlCommAccount = new SqlCommand("lidstrom_billing.dbo.sp_getAccountInfo",sqlConn);
			this.sqlCommAccount.Parameters.Add(new SqlParameter("@accountID", accountID));

			this.sqlCommAccount.CommandType = CommandType.StoredProcedure;
			DataSet data = new DataSet();
			(new SqlDataAdapter(this.sqlCommAccount)).Fill(data);

			DataRow customerData = data.Tables[0].Rows[0];
			
			//extract the account info from the database not the previous shipping screen
			this.fnameStr	  = (customerData[0] == null)  ? "" : (string)customerData[0];
			this.lnameStr	  = (customerData[1] == null)  ? "" : (string)customerData[1];
			this.miStr		  = (customerData[2] == null)  ? "" : (string)customerData[2];
			this.acctNameStr  = (customerData[3] == null)  ? "" : (string)customerData[3];
			this.oldPassStr   = (customerData[4] == null)  ? "" : (string)customerData[4];
			this.stAddressStr = (customerData[5] == null)  ? "" : (string)customerData[5];
			this.POboxStr	  = (customerData[6] == null)  ? "" : (string)customerData[6];
			this.cityStr	  = (customerData[7] == null)  ? "" : (string)customerData[7];
			this.stateStr     = (customerData[8] == null)  ? "" : (string)customerData[8];
			this.zipStr       = (customerData[9] == null)  ? "" : (string)customerData[9];
			this.emailStr     = (customerData[10] == null) ? "" : (string)customerData[10];
			this.homePhoneStr = (customerData[11] == null) ? "" : (string)customerData[11];
			this.cellPhoneStr = (customerData[12] == null) ? "" : (string)customerData[12];
			
			
			//this.shippingOptionsDisplay();
			
		}

		
		private void btnSubmit_Click(object sender, System.EventArgs e)
		{
			//make sure that all shipping methods have been specified for the other companies
			bool methodsSet = true;
			for(int i = 0; i < this.datagrdOtherCompany.Items.Count; i++)
			{
				if(this.datagrdOtherCompany.Items[i].Cells[4].Text.ToString() == "N/A" || this.datagrdOtherCompany.Items[i].Cells[4].Text.ToString() == "")
					methodsSet = false;
			}
			if(methodsSet)
			{

				//=====================================
				// generate XML order forms
				//=====================================
				for(int i = 0; i < datagrdPurchases.Items.Count; i++)
				{
					string company = datagrdPurchases.Items[i].Cells[8].Text;
					bool exists = false;
					for(int j = 0; j < companies.Count; j++)
					{
						if(companies[j].ToString() == company)
						{
							exists = true;
						}
					}
					if(!exists)
						companies.Add(company);
				}

				for(int i = 0; i < companies.Count; i++)
				{
					this.generateOrderFile(companies[i].ToString());
				}

				//================================================
				// data structures for database updating
				//================================================

				DataSet invoiceSet = new DataSet();
				DataSet packageSet = new DataSet();
				int invoiceID;
				int packageID;
				this.sqlConn = new SqlConnection(strSqlString);
				this.sqlConn.Open();
			
				//=======================================
				// create the new invoice
				//=======================================
			
				this.cardType = this.lstCards.SelectedValue;
				this.cardNumber = this.txtCardNumber.Text;
				this.expirationDate = this.txtExpiration.Text;
			
			
				this.sqlCom = new SqlCommand("lidstrom_billing.dbo.sp_newInvoiceWithReturn", sqlConn);
				SqlParameter _BUYER = new SqlParameter("@buyer", this.accountID);
				sqlCom.Parameters.Add(_BUYER);
			
				SqlParameter _PAYMENTMETHOD = new SqlParameter("@paymentMethod", "credit");
				sqlCom.Parameters.Add(_PAYMENTMETHOD);
			
				SqlParameter _CREDCARDNUM = new SqlParameter("@credCardNum", this.cardNumber);
				sqlCom.Parameters.Add(_CREDCARDNUM);
			
				SqlParameter _PAYMENTRECEIVED = new SqlParameter("@paymentReceived", "f");
				sqlCom.Parameters.Add(_PAYMENTRECEIVED);
			
				SqlParameter _SHIPMETHOD = new SqlParameter("@shipMethod", "FedEX Air");
				sqlCom.Parameters.Add(_SHIPMETHOD);
			
				SqlParameter _SHIPSTADDRESS = new SqlParameter("@shipStAddress", this.address);
				sqlCom.Parameters.Add(_SHIPSTADDRESS);
			
				SqlParameter _SHIPZIPCODE = new SqlParameter("@shipZipCode", this.zipCode);
				sqlCom.Parameters.Add(_SHIPZIPCODE);
			
				SqlParameter _SHIPCITY = new SqlParameter("@shipCity", this.city);
				sqlCom.Parameters.Add(_SHIPCITY);
			
				SqlParameter _SHIPSTATE = new SqlParameter("@shipState", this.stateStr);
				sqlCom.Parameters.Add(_SHIPSTATE);
			
				SqlParameter _SHIPPOBOX = new SqlParameter("@shipPOBox", "");
				sqlCom.Parameters.Add(_SHIPPOBOX);
			
				sqlCom.CommandType = CommandType.StoredProcedure;
				(new SqlDataAdapter(sqlCom)).Fill(invoiceSet);
			
				invoiceID = Convert.ToInt32(invoiceSet.Tables[0].Rows[0].ItemArray[0].ToString());
			
				//ArrayList itemIDs;

				for(int i = 0; i < datagrdPackages.Items.Count; ++i)
				{
					//foreach(DataGridItem item in datagrdPackages.Items)
					//{
				
					string itemWeight = datagrdPackages.Items[i].Cells[4].Text;
					string numUnits = datagrdPackages.Items[i].Cells[1].Text;
					string warehouseID =  datagrdPackages.Items[i].Cells[0].Text;
					string itemID =  datagrdPackages.Items[i].Cells[2].Text;
					string itemName = datagrdPackages.Items[i].Cells[3].Text;
					string cost = "", unitPrice = "", productDiscount = "";

					//int quantity = 0;

					//get the total cost, unitPrice, and productDiscount for an item
					foreach(DataGridItem item in datagrdPurchases.Items)
					{
						if(itemID == item.Cells[0].Text)
						{
							double c = Double.Parse(item.Cells[6].Text.Substring(1));
							cost = c.ToString();
							unitPrice = item.Cells[4].Text.Substring(1);
							productDiscount = item.Cells[3].Text.Substring(1);

							//get the total quantity for an item
							/*foreach(DataGridItem item2 in datagrdPackages)
							{
								if(itemID == item2.Cells[2].Text)
									quantity += Int32.Parse(item2.Cells[1].Text);
							}*/
						}
					}

				

					//				int totalQuantityPerItem = 0;
					//				int numPackages = 0;
					//
					//				itemIDs.Add(itemID);
					//
					//				foreach(string item in itemIDs)
					//				{
					//					if(item == itemID)
					//					{
					//						++numPackages;
					//					}
					//				}

					//string unitPrice =  datagrdPurchases.Items[i].Cells[4].Text.Substring(1);
					//string productDiscount =  datagrdPurchases.Items[i].Cells[3].Text.Substring(1);
					//string cost = datagrdPurchases.Items[i].Cells[6].Text.Substring(1);
				
					//=============================================
					//creat the new packages
					//insert a for loop over all packages
					//==============================================
			
					sqlCom.Parameters.Clear();
				
					this.sqlCom = new SqlCommand("petert_shipping.dbo.sp_newPackageWithReturn", sqlConn);							
				
					SqlParameter _INVOICEID = new SqlParameter("@invoiceID", invoiceID.ToString());
					sqlCom.Parameters.Add(_INVOICEID);

					SqlParameter _WEIGHT = new SqlParameter("@weight", itemWeight);
					sqlCom.Parameters.Add(_WEIGHT);
				
					SqlParameter _NUMUNITS = new SqlParameter("@numUnits", numUnits);
					sqlCom.Parameters.Add(_NUMUNITS);
				
					SqlParameter _SPECIALINSTRUCTIONS = new SqlParameter("@specialInstructions", "");
					sqlCom.Parameters.Add(_SPECIALINSTRUCTIONS);
				
					SqlParameter _WAREHOUSEID = new SqlParameter("@warehouseID", warehouseID);
					sqlCom.Parameters.Add(_WAREHOUSEID);
				
					SqlParameter _VENDORNAME = new SqlParameter("@vendorName", "FedEX");
					sqlCom.Parameters.Add(_VENDORNAME);
				
					SqlParameter _METHODNAME = new SqlParameter("@methodName", "Air");
					sqlCom.Parameters.Add(_METHODNAME);
				
					SqlParameter _DESTINATIONFIRSTNAME = new SqlParameter("@destinationFirstName", this.fnameStr);
					sqlCom.Parameters.Add(_DESTINATIONFIRSTNAME);
				
					SqlParameter _DESTINATIONLASTNAME = new SqlParameter("@destinationLastName", this.lnameStr);
					sqlCom.Parameters.Add(_DESTINATIONLASTNAME);
				
					SqlParameter _DESTINATIONSTREETADDRESS = new SqlParameter("@destinationStreetAddress", this.address);
					sqlCom.Parameters.Add(_DESTINATIONSTREETADDRESS);
				
					SqlParameter _DESTINATIONCITY = new SqlParameter("@destinationCity", this.city);
					sqlCom.Parameters.Add(_DESTINATIONCITY);
				
					SqlParameter _DESTINATIONSTATE = new SqlParameter("@destinationState", this.stateStr);
					sqlCom.Parameters.Add(_DESTINATIONSTATE);
				
					SqlParameter _DESTINATIONZIP = new SqlParameter("@destinationZip", this.zipCode);
					sqlCom.Parameters.Add(_DESTINATIONZIP);
				
					SqlParameter _CONTACTPHONE1 = new SqlParameter("@contactPhone1", this.homePhoneStr);
					sqlCom.Parameters.Add(_CONTACTPHONE1);
				
					SqlParameter _CONTACTPHONE2 = new SqlParameter("@contactPhone2", this.cellPhoneStr);
					sqlCom.Parameters.Add(_CONTACTPHONE2);
				
					SqlParameter _EMAIL = new SqlParameter("@contactEmail", this.emailStr);
					sqlCom.Parameters.Add(_EMAIL);
				
					sqlCom.CommandType = CommandType.StoredProcedure;
					(new SqlDataAdapter(sqlCom)).Fill(packageSet);
					packageID = Convert.ToInt32(packageSet.Tables[0].Rows[0].ItemArray[0].ToString());

					//==========================================
					//Store the ShippingInfo
					//==========================================

					sqlCom.Parameters.Clear();
					this.sqlCom = new SqlCommand("lidstrom_billing.dbo.sp_storeShippingInfo", sqlConn);
			
					_INVOICEID = new SqlParameter("@invoiceID", invoiceID.ToString());
					sqlCom.Parameters.Add(_INVOICEID);
			
					SqlParameter _ITEMID = new SqlParameter("@itemID", itemID);
					sqlCom.Parameters.Add(_ITEMID);
			
					_WAREHOUSEID = new SqlParameter("@warehouseID", warehouseID);
					sqlCom.Parameters.Add(_WAREHOUSEID);
			
					SqlParameter _QUANTITY = new SqlParameter("@quantity", numUnits);
					sqlCom.Parameters.Add(_QUANTITY);
			
					/*********************/
					SqlParameter _COST = new SqlParameter("@cost", cost);
					sqlCom.Parameters.Add(_COST);
			
					SqlParameter _ITEMTYPE = new SqlParameter("@itemType", "B");
					sqlCom.Parameters.Add(_ITEMTYPE);

					sqlCom.CommandType = CommandType.StoredProcedure;
					sqlCom.ExecuteNonQuery();

					//}


					//foreach(DataGridItem item in datagrdPurchases.Items)
					//{
					//==========================================
					//Store the Purchases
					//==========================================

					//if(i <= datagrdPurchases.Items.Count)
				{
					sqlCom.Parameters.Clear();


					this.sqlCom = new SqlCommand("lidstrom_billing.dbo.sp_storePurchase", sqlConn);
			
					_INVOICEID = new SqlParameter("@invoiceID", invoiceID.ToString());
					sqlCom.Parameters.Add(_INVOICEID);
			
					_ITEMID = new SqlParameter("@itemID", itemID);
					sqlCom.Parameters.Add(_ITEMID);
			
					SqlParameter _ITEMNAME = new SqlParameter("@itemName", itemName);		//can't get the title easily so just store the itemID
					sqlCom.Parameters.Add(_ITEMNAME);
			
					SqlParameter _UNITPRICE = new SqlParameter("@unitPrice", unitPrice);
					sqlCom.Parameters.Add(_UNITPRICE);
			
					SqlParameter _PRODUCTDISCOUNT = new SqlParameter("@productDiscount", productDiscount);
					sqlCom.Parameters.Add(_PRODUCTDISCOUNT);
			
					_QUANTITY = new SqlParameter("@quantity", numUnits);
					sqlCom.Parameters.Add(_QUANTITY);
			
					_ITEMTYPE = new SqlParameter("@itemType", "B");
					sqlCom.Parameters.Add(_ITEMTYPE);
			
					sqlCom.CommandType = CommandType.StoredProcedure;
					sqlCom.ExecuteNonQuery();
				}
				}

				sqlConn.Close();

				Response.Redirect("Thanks.aspx?accountID=" + this.accountID + "&totalAmount=" + this.txtTotal.Text + "&invoiceID=" + invoiceID.ToString());
			}
			else
			{
				companyMethodErrorLabel.Visible = true;
			}
		}

		
		//display the items being purchased and their corresponding packages
		private void displayPackages()
		{
			datagrdPackages.DataSource = ShippingInfo.shippingInfo;

			datagrdPackages.DataBind();
			datagrdPackages.Visible = true;
		}

		
		//BLAH
		private DataSet getShippingInfo()
		{
			DataSet result = new DataSet();

			this.sqlConn = new SqlConnection(strSqlString);
			this.sqlConn.Open();


			// LOOK FOR A WAREHOUSE THAT CAN SUPPLY ALL ITEMS IN A CART AND IS IN THE SAME CITY AS BUYER

			this.sqlComShip = new SqlCommand("sultan_inventory.dbo.sp_findStockedWarehouseInCity",sqlConn);
			this.sqlComShip.Parameters.Add("@accountID",this.accountID);
			this.sqlComShip.Parameters.Add("@city",this.city);
			this.sqlComShip.CommandType = CommandType.StoredProcedure;

			(new SqlDataAdapter(this.sqlComShip)).Fill(result);
			
			//if found return that result
			if(result.Tables[0].Rows.Count > 0)
			{
				result.Tables[0].Columns["WarehouseID"].ColumnName = "PackageID";
				return result;
			}

			// LOOK FOR A WAREHOUSE THAT CAN SUPPLY ALL ITEMS IN A CART
			
			result = new DataSet();
			this.sqlComShip = new SqlCommand("sultan_inventory.dbo.sp_findStockedWarehouse",sqlConn);
			this.sqlComShip.Parameters.Add("@accountID",this.accountID);
			this.sqlComShip.CommandType = CommandType.StoredProcedure;

			(new SqlDataAdapter(this.sqlComShip)).Fill(result);

			//if found return that result
			if(result.Tables[0].Rows.Count > 0)
			{
				result.Tables[0].Columns["WarehouseID"].ColumnName = "PackageID";
				return result;
			}

			sqlConn.Close();


			// FIND A LIST OF WAREHOUSES THAT CAN SUPPLY A CART
            result = new DataSet();
			ArrayList warehouseList = (new Femron.ShoppingCart(accountID, sqlConn)).getWarehouseList();

			//if none are found then the cart can't be purchased -- panic attack!
			if(warehouseList == null)
			{
				Response.Redirect("ShoppingCart.aspx?accountID="+ this.accountID + "&error=You Bought Way Too Much of Our Stock");

			}

			result.Tables.Add();

			result.Tables[0].Columns.Add();
			result.Tables[0].Columns.Add();
			result.Tables[0].Columns.Add();
			result.Tables[0].Columns.Add();
			result.Tables[0].Columns.Add();
			result.Tables[0].Columns[0].ColumnName = "PackageID";
			result.Tables[0].Columns[1].ColumnName = "quantity";
			result.Tables[0].Columns[2].ColumnName = "ItemID";
			result.Tables[0].Columns[3].ColumnName = "ItemName";
			result.Tables[0].Columns[4].ColumnName = "PackageWeight";

			for(int i = 0; i < warehouseList.Count; i++)
			{
				result.Tables[0].Rows.Add((string [])(warehouseList[i]));
			}

			return result;
		}

		
		//displays the contents of the cart based on the accountID that the user has 
		//logged-in under
		private void DisplayPurchases()
		{
			datagrdPurchases.DataSource = this.cartData();
			datagrdPurchases.DataBind();
				
			datagrdPurchases.Visible = true;
		}

		
		//gets the contents of the cart based on the accountID that the user has 
		//logged-in under
		private DataSet cartData()
		{
			//int cart = 1;
			DataSet customerData = null;
			sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();

			//initialize a new command object for the stored procedure that displays the cart
			sqlCom = new SqlCommand("petert_shipping.dbo.sp_getCartOrderInfo", sqlConn);
				
			SqlParameter _AccountID = new SqlParameter("@accountID",this.accountID);
			sqlCom.Parameters.Add(_AccountID);

			try
			{
				//run the stored procedure		
				customerData = Login.runStoredProcedure(strSqlString, sqlCom);
			}
			catch(Exception e)
			{
				//lblCart.Text = e.Message+e.StackTrace;
				lblTitle.Text = e.Message;
			}

			//cartData.Tables[0].Columns["quantity"].Site = grdMyCart.Columns[1];

			// Close the sql connection at the end
			sqlConn.Close();


			return customerData;
		}

		
		private void shippingOptionsDisplay()
		{			
			ArrayList result = new ArrayList();
			if(packageShippingInfo == null)
				packageShippingInfo = new DataSet();
		
			//if there is information in the shipping info table
			if(ShippingInfo.shippingInfo.Tables[0].Rows.Count == 1)
			{
				//get the lowest cost shipping method to the destination
				sqlCom = new SqlCommand("petert_shipping.dbo.sp_getShippingOptions", sqlConn);

				SqlParameter _CITY = new SqlParameter("@city", this.city);
				sqlCom.Parameters.Add(_CITY);

				SqlParameter _WAREHOUSE = new SqlParameter("@warehouse", ShippingInfo.shippingInfo.Tables[0].Rows[0]["PackageID"]);
				sqlCom.Parameters.Add(_WAREHOUSE);

				SqlParameter _TIME = new SqlParameter("@deliveryTime", 5);
				sqlCom.Parameters.Add(_TIME);

				SqlParameter _WEIGHT = new SqlParameter("@weight", 1);
				sqlCom.Parameters.Add(_WEIGHT);

				SqlParameter _NUMITEMS = new SqlParameter("@numItems", ShippingInfo.shippingInfo.Tables[0].Rows[0]["quantity"]);
				sqlCom.Parameters.Add(_NUMITEMS);

				this.sqlCom.CommandType = CommandType.StoredProcedure;

				(new SqlDataAdapter(this.sqlCom)).Fill(packageShippingInfo);				
			}
			else 
			{
				for(int i = 0; i < ShippingInfo.shippingInfo.Tables[0].Rows.Count; i++)
				{
					string warehouseID = shippingInfo.Tables[0].Rows[i]["PackageID"].ToString();
					string packageID   = warehouseID;
					string deliveryTime = "1";	

					string weight = "1";
					string numItems = shippingInfo.Tables[0].Rows[i]["quantity"].ToString();
					
					bool alreadyExists = false;
					for(int j = 0; j < result.Count; ++j)
						if(((string[])result[j])[0] == packageID)
							alreadyExists = true;
					if(alreadyExists)
						continue;

					sqlConn = new SqlConnection(strSqlString);

					sqlConn.Open();
				
					//GETS THE SHIPPING METHOD & VENDOR, COST for the guaranteedDeliveryTime selected
					sqlCom = new SqlCommand("petert_shipping.dbo.sp_getShippingOptions", sqlConn);

					SqlParameter _CITY = new SqlParameter("@city", this.city);
					sqlCom.Parameters.Add(_CITY);

					SqlParameter _WAREHOUSE = new SqlParameter("@warehouse", warehouseID);
					sqlCom.Parameters.Add(_WAREHOUSE);

					SqlParameter _TIME = new SqlParameter("@deliveryTime", deliveryTime);
					sqlCom.Parameters.Add(_TIME);

					SqlParameter _WEIGHT = new SqlParameter("@weight", weight);
					sqlCom.Parameters.Add(_WEIGHT);

					SqlParameter _NUMITEMS = new SqlParameter("@numItems", numItems);
					sqlCom.Parameters.Add(_NUMITEMS);
					
					//shippingOptions.Tables.Add();
					DataSet temp = Login.runStoredProcedure(strSqlString, sqlCom);

					string[] bestMethod = new string[] {packageID, temp.Tables[0].Rows[0][0].ToString(), temp.Tables[0].Rows[0][1].ToString()};
					result.Add(bestMethod);
				}
				packageShippingInfo.Tables.Add();
				
				packageShippingInfo.Tables[0].Columns.Add();
				packageShippingInfo.Tables[0].Columns.Add();
				packageShippingInfo.Tables[0].Columns.Add();
				packageShippingInfo.Tables[0].Columns[1].ColumnName = "ShippingMethod";
				packageShippingInfo.Tables[0].Columns[2].ColumnName = "Cost";
				packageShippingInfo.Tables[0].Columns[0].ColumnName = "PackageID";

				for(int i = 0; i < result.Count; i++)
				{
					packageShippingInfo.Tables[0].Rows.Add((string [])(result[i]));
				}
			}


			datagrdShippingOptions.DataSource = packageShippingInfo;

			datagrdShippingOptions.DataBind();
			datagrdShippingOptions.Visible = true;			
		}


		//Display shipping information for products purchased from another company
		private void otherCompanyShipping()
		{
			foreignShipments = new DataSet();
			this.sqlConn = new SqlConnection(strSqlString);
			this.sqlConn.Open();

			//get all of the foreign products and their associated sums of the shipment
			this.sqlComShip = new SqlCommand("lidstrom_billing.dbo.sp_infoizeCartForOtherCompanies",sqlConn);
			this.sqlComShip.Parameters.Add("@accountID",this.accountID);
			this.sqlComShip.CommandType = CommandType.StoredProcedure;

			(new SqlDataAdapter(this.sqlComShip)).Fill(foreignShipments);

			datagrdOtherCompany.DataSource = ShippingInfo.foreignShipments;
			datagrdOtherCompany.DataBind();
		}

		private void otherCompanyShipping(ArrayList vendors, ArrayList methods, ArrayList costs, ArrayList times)
		{
			foreignShipments = new DataSet();
			this.sqlConn = new SqlConnection(strSqlString);
			this.sqlConn.Open();

			//get all of the foreign products and their associated sums of the shipment
			this.sqlComShip = new SqlCommand("lidstrom_billing.dbo.sp_infoizeCartForOtherCompanies",sqlConn);
			this.sqlComShip.Parameters.Add("@accountID",this.accountID);
			this.sqlComShip.CommandType = CommandType.StoredProcedure;

			(new SqlDataAdapter(this.sqlComShip)).Fill(foreignShipments);

			datagrdOtherCompany.DataSource = ShippingInfo.foreignShipments;
			datagrdOtherCompany.DataBind();

			//restore the updated values
			for(int i = 0; i < this.datagrdOtherCompany.Items.Count; i++)
			{
				this.datagrdOtherCompany.Items[i].Cells[4].Text = (string)vendors[i];
				this.datagrdOtherCompany.Items[i].Cells[5].Text = (string)methods[i];
				this.datagrdOtherCompany.Items[i].Cells[6].Text = (string)costs[i];
				if((string)times[i] != "Ignore me")
					this.datagrdOtherCompany.Items[i].Cells[7].Text = (string)times[i];
			}
		}



		//write to the order directory and xml file describing the order
		private void generateOrderFile(string foreignCompany)//need to pass along list of products (book or music, id, name, quantity)
		{
			int orderNum = orderNumberGen.Next(1000000);
			string option = "";
			
			//File to write order to
			string file = Server.MapPath(".\\orders\\") + "order" + foreignCompany + orderNum.ToString() + ".xml";//change order file to name of company plus invoice or random number
			StreamWriter output = new StreamWriter(file);
			
			//Select appropriate shipping method for the company
			if( foreignCompany == "Femron")
			{
				//get the lowest cost shipping method to the destination
				packageShippingInfo = new DataSet();
				sqlCom = new SqlCommand("petert_shipping.dbo.sp_getShippingOptions", sqlConn);

				SqlParameter _CITY = new SqlParameter("@city", this.city);
				sqlCom.Parameters.Add(_CITY);

				SqlParameter _WAREHOUSE = new SqlParameter("@warehouse", "123");
				sqlCom.Parameters.Add(_WAREHOUSE);

				SqlParameter _TIME = new SqlParameter("@deliveryTime", "0");
				sqlCom.Parameters.Add(_TIME);

				SqlParameter _WEIGHT = new SqlParameter("@weight", "0");
				sqlCom.Parameters.Add(_WEIGHT);

				SqlParameter _NUMITEMS = new SqlParameter("@numItems", "0");
				sqlCom.Parameters.Add(_NUMITEMS);

				this.sqlCom.CommandType = CommandType.StoredProcedure;

				(new SqlDataAdapter(this.sqlCom)).Fill(packageShippingInfo);

				if(packageShippingInfo.Tables[0].Rows.Count != 0)
					option = packageShippingInfo.Tables[0].Rows[0][1].ToString();
			}
			else
			{
				for(int i = 0; i < this.datagrdOtherCompany.Items.Count; i++)
				{
					if(this.datagrdOtherCompany.Items[i].Cells[1].Text == foreignCompany)
						option = this.datagrdOtherCompany.Items[i].Cells[5].Text.ToString();
				}
			}
			
			//Write the appropriate data to the order file
			output.Write("<order><issuingCompany>Femron</issuingCompany>");
			output.Write("<partnerCompany>" + foreignCompany + "</partnerCompany>");
			
			//Loop over all purchases and add the item information to the purchase order
			for(int i = 0; i < datagrdPurchases.Items.Count; i++)
			{
				string itemCompany = datagrdPurchases.Items[i].Cells[8].Text;
				if(itemCompany == foreignCompany)
				{
					output.Write("<product>");
					if(datagrdPurchases.Items[i].Cells[10].Text == "B")
						output.Write("<type>book</type>");
					else
						output.Write("<type>music</type>");
					output.Write("<identifier>" + datagrdPurchases.Items[i].Cells[0].Text + "</identifier>");
					output.Write("<name>" + datagrdPurchases.Items[i].Cells[7].Text + "</name>");
					output.Write("<quantity>" + datagrdPurchases.Items[i].Cells[9].Text + "</quantity>");
					output.Write("</product>");
				}
			}
			output.Write("<shippingMethod>" + option + "</shippingMethod>");
			output.Write("<destination>");
			output.Write("<address>" + address + "</address>");
			output.Write("<city>" + city + "</city>");
			output.Write("<state>" + state + "</state>");
			output.Write("<zip>" + zipCode + "</zip>");
			output.Write("<contact><tel>" + homePhoneStr + "</tel>");
			output.Write("<fax>" + cellPhoneStr + "</fax>");
			output.Write("</contact></destination></order>");

			//Close the order file
			output.Close();
		}


		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnSubmit.Click += new System.EventHandler(this.btnSubmit_Click);
			this.datagrdOtherCompany.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datagrdOtherCompany_CancelCommand);
			this.datagrdOtherCompany.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datagrdOtherCompany_EditCommand);
			this.datagrdOtherCompany.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datagrdOtherCompany_UpdateCommand);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		//display the edit buttons and text box option
		private void datagrdOtherCompany_EditCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			datagrdOtherCompany.EditItemIndex = e.Item.ItemIndex;	//update the edit index
			
			ArrayList vendors = new ArrayList();
			ArrayList methods = new ArrayList();
			ArrayList costs = new ArrayList();
			ArrayList times = new ArrayList();
			
			//pass along ArrayLists with the appropriate shipping method info
			for(int i = 0; i < datagrdOtherCompany.Items.Count; i++)
			{
				vendors.Add(this.datagrdOtherCompany.Items[i].Cells[4].Text.ToString());
				methods.Add(this.datagrdOtherCompany.Items[i].Cells[5].Text.ToString());
				costs.Add(this.datagrdOtherCompany.Items[i].Cells[6].Text.ToString());
				if(i == e.Item.ItemIndex)
					times.Add("Ignore me");
				else
					times.Add(this.datagrdOtherCompany.Items[i].Cells[7].Text.ToString());
			}
			
			this.otherCompanyShipping(vendors, methods, costs, times);							//display the grid
		}

		
		//find the cheapest valid of shipment for the given company
		private void datagrdOtherCompany_UpdateCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			DataSet methodResults = new DataSet();
			string vendor, method, cost;
			
			sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();

			TextBox txtTime = (TextBox)e.Item.Cells[7].Controls[0];

			// Retrieve the updated values.
			string time = txtTime.Text;

			int newTime = Convert.ToInt32(time);

			//execute SQL query to update the delivery time of the selected item
			//reload the data in the datagrid

			sqlComMethod = new SqlCommand("petert_shipping.dbo.sp_getShippingOptionsCompany", sqlConn);
			
			sqlComMethod.Parameters.Add(new SqlParameter("@city", this.city));
			sqlComMethod.Parameters.Add(new SqlParameter("@deliveryTime", time));
			sqlComMethod.Parameters.Add(new SqlParameter("@weight", e.Item.Cells[3].Text));
			sqlComMethod.Parameters.Add(new SqlParameter("@numItems", e.Item.Cells[2].Text));
			sqlComMethod.Parameters.Add(new SqlParameter("@CompanyName", e.Item.Cells[1].Text));

			sqlComMethod.CommandType = CommandType.StoredProcedure;

			(new SqlDataAdapter(this.sqlComMethod)).Fill(methodResults);
			
			if ( methodResults.Tables.Count != 0 && methodResults.Tables[0].Rows.Count != 0)
			{
				//update the datagrid with new package items
				this.datagrdOtherCompany.Items[e.Item.ItemIndex].Cells[4].Text = methodResults.Tables[0].Rows[0][0].ToString();
				this.datagrdOtherCompany.Items[e.Item.ItemIndex].Cells[5].Text = methodResults.Tables[0].Rows[0][1].ToString();
				this.datagrdOtherCompany.Items[e.Item.ItemIndex].Cells[6].Text = methodResults.Tables[0].Rows[0][2].ToString();
				this.datagrdOtherCompany.Items[e.Item.ItemIndex].Cells[7].Text = time;
			}
			else
			{
				//otherwise print that there is no specified best shipping method
				this.datagrdOtherCompany.Items[e.Item.ItemIndex].Cells[4].Text = "N/A";
				this.datagrdOtherCompany.Items[e.Item.ItemIndex].Cells[5].Text = "N/A";
				this.datagrdOtherCompany.Items[e.Item.ItemIndex].Cells[6].Text = "N/A";
			}
			
			ArrayList vendors = new ArrayList();
			ArrayList methods = new ArrayList();
			ArrayList costs = new ArrayList();
			ArrayList times = new ArrayList();
			
			//pass along ArrayLists with the appropriate shipping method info
			for(int i = 0; i < datagrdOtherCompany.Items.Count; i++)
			{
				vendors.Add(this.datagrdOtherCompany.Items[i].Cells[4].Text.ToString());
				methods.Add(this.datagrdOtherCompany.Items[i].Cells[5].Text.ToString());
				costs.Add(this.datagrdOtherCompany.Items[i].Cells[6].Text.ToString());
				times.Add(this.datagrdOtherCompany.Items[i].Cells[7].Text.ToString());
			}
			
			//reset the EditItemIndex
			datagrdOtherCompany.EditItemIndex = -1;
			this.otherCompanyShipping(vendors, methods, costs, times);	//display the grid
			sqlConn.Close();
		}

		
		//revert back to an empty grid
		private void datagrdOtherCompany_CancelCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			datagrdOtherCompany.EditItemIndex = -1;	//reset the edit item index
			this.otherCompanyShipping();	//display the grid
		}

	}
}
