using System;
using System.Data;

namespace SqlRequest
{
    //simple wrapper that takes care of applying relations to the datasets returned
    //from multiple queries, C#'s way of doing table joins
    public class Relation
    {
        #region Private Data

        private string ParentID;
        private string ChildID;
        private string ParentColumnName;
        private string ChildColumnName;
        private string RelationName;

        #endregion

        #region constructor

        public Relation(string name, string PID, string ParentCN, string CID, string ChildCN)
        {
            this.RelationName = name;
            this.ParentID = PID;
            this.ChildID = CID;
            this.ParentColumnName = ParentCN;
            this.ChildColumnName = ChildCN;
        }

        #endregion

        #region Public Methods

        public void ApplyRelation(DataSet d)
        {                                 
            d.Relations.Add(this.RelationName, d.Tables[this.ParentID].Columns[this.ParentColumnName], d.Tables[this.ChildID].Columns[this.ChildColumnName]);
        }

        #endregion
    }
}
