using System;
using System.Data;
using System.Data.SqlClient;

namespace SqlRequest
{
    public class SQLRequest
    {
        #region Private Data

        private SQLServer Server;
        private string Request;
        private string result_name;

        #endregion

        #region Constructor

        public SQLRequest(SQLServer s, string request)
        {	
            this.Server = s;
            this.Request = request;
        }

        public SQLRequest(SQLServer s, string request, string rn)
        {	
            this.Server = s;
            this.Request = request;

            this.result_name = rn;
        }

        #endregion

        #region Public Methods

        public DataSet Invoke()
        {
            DataSet toRet = new DataSet();

            SqlDataAdapter adaptor = new SqlDataAdapter();
            adaptor.SelectCommand = new SqlCommand(this.Request, this.Server.Connection);
            
            adaptor.Fill(toRet);                          

            if(this.result_name != null)
                toRet.Tables[0].TableName = this.result_name;

            return toRet;
        }

        #endregion

        #region Public Attributes
        
        public string ResultName
        {
            get
            {
                return this.result_name;
            }
        }

        #endregion
    }	
}
