using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using foofaraw.transactions;


namespace foofaraw
{
	/// <summary>
	/// Summary description for user_cart.
	/// </summary>
	public class user_cart : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataList BookCart;
		protected System.Web.UI.WebControls.DropDownList quantity;
		protected System.Web.UI.WebControls.TextBox TextBox1;
		protected System.Web.UI.WebControls.DataGrid Cart_Grid;
		protected System.Web.UI.WebControls.Label Total;
		protected System.Web.UI.WebControls.Button ContinueShopping;
		protected System.Web.UI.WebControls.Button checkout;
		protected System.Web.UI.WebControls.Label lPageStatus;
		protected System.Web.UI.HtmlControls.HtmlForm Form1;
		protected System.Web.UI.WebControls.DataList MusicCart;

		private string back;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			Cart_Grid.Visible = false;
			CartAdder adder = new CartAdder();
			if(!IsPostBack)
			{
				adder.AddToCart(Request.QueryString["type"],
					Request.QueryString["id"],
					(ShoppingCart) Session["MyShoppingCart"]);
				bind();
			}

			back = Request.QueryString["back"];
			if(back==null) 
				back = "productsearch.aspx";

		}

		private void bind()
		{
			// Put user code to initialize the page here
			ShoppingCart cart = (ShoppingCart) Session["MyShoppingCart"];
			if (cart != null) 
			{
				Cart_Grid.DataSource = cart.BookOrders;
				Cart_Grid.DataBind();
				BookCart.DataSource = cart.BookOrders;
				BookCart.DataBind();
				MusicCart.DataSource = cart.MusicOrders;
				MusicCart.DataBind();
				Total.Text = String.Format ("Total Cost: {0:c}",
					cart.TotalCost);
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Cart_Grid.SelectedIndexChanged += new System.EventHandler(this.Cart_Grid_SelectedIndexChanged);
			this.BookCart.CancelCommand += new System.Web.UI.WebControls.DataListCommandEventHandler(this.BookCart_CancelCommand);
			this.BookCart.EditCommand += new System.Web.UI.WebControls.DataListCommandEventHandler(this.BookCart_EditCommand);
			this.BookCart.UpdateCommand += new System.Web.UI.WebControls.DataListCommandEventHandler(this.BookCart_UpdateCommand);
			this.BookCart.DeleteCommand += new System.Web.UI.WebControls.DataListCommandEventHandler(this.BookCart_DeleteCommand);
			this.BookCart.SelectedIndexChanged += new System.EventHandler(this.BookCart_SelectedIndexChanged);
			this.checkout.Click += new System.EventHandler(this.checkout_Click);
			this.ContinueShopping.Click += new System.EventHandler(this.ContinueShopping_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Cart_Grid_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			if(e.CommandName == "removeFromCart")
			{
				ShoppingCart cart = (ShoppingCart) Session["MyShoppingCart"];
				if (cart != null) 
				{
					cart.RemoveBookOrder (e.Item.Cells[0].Text);
					Cart_Grid.DataBind();
					Total.Text = String.Format ("Total Cost: {0:c}",
						cart.TotalCost);
				}
			}
		}

		private void Cart_Grid_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

		private void BookCart_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

		private void BookCart_EditCommand(object source, System.Web.UI.WebControls.DataListCommandEventArgs e)
		{
			BookCart.EditItemIndex = e.Item.ItemIndex;
			bind();
		}

		private void BookCart_CancelCommand(object source, System.Web.UI.WebControls.DataListCommandEventArgs e)
		{
			BookCart.EditItemIndex = -1;
			bind();
		}

		private void BookCart_UpdateCommand(object source, System.Web.UI.WebControls.DataListCommandEventArgs e)
		{
			ShoppingCart cart = (ShoppingCart) Session["MyShoppingCart"];
			if (cart != null) 
			{
				int newQuantity = Convert.ToInt32(((TextBox)e.Item.FindControl("t_Quantity")).Text);
				string ItemID = ((Label)e.Item.FindControl("l_ItemID")).Text;
				if (newQuantity > 0)
				{
					cart.SetBookOrderQuantity(ItemID, newQuantity);
				} 
				else 
				{
					cart.RemoveBookOrder(ItemID);
				}
					
			}
			BookCart.EditItemIndex = -1;
			bind();
		}

		private void ContinueShopping_Click(object sender, System.EventArgs e)
		{
			Response.Redirect(back);		
		}

		private void BookCart_DeleteCommand(object source, System.Web.UI.WebControls.DataListCommandEventArgs e)
		{
			ShoppingCart cart = (ShoppingCart) Session["MyShoppingCart"];
			if (cart != null) 
			{
				string ItemID = ((Label)e.Item.FindControl("l_ItemID_Remove")).Text;
				cart.RemoveBookOrder(ItemID);
			}
			BookCart.EditItemIndex = -1;
			bind();
		}

		private void checkout_Click(object sender, System.EventArgs e)
		{
			Login LoginController = (Login) Session["Login"];
			if(LoginController != null) 
			{
				if(LoginController.LoggedIn()) 
				{
					ShoppingCart cart = (ShoppingCart)Session["MyShoppingCart"];
					if(!cart.isEmpty())
					{
						Session["transaction"] = new Transaction(cart);
						Response.Redirect("transactionCustInfo.aspx");
					}
			
					lPageStatus.Text = "You must Add Items to your shopping cart before you can checkout!";
					lPageStatus.Visible = true;
				}
				else 
				{
					Response.Redirect("login.aspx?next=ShoppingCart.aspx");
				}
			}
		}


	}
}
