using System;
using System.Data.SqlClient;

namespace SqlRequest
{
    //a class representing a SQL server and a connection to said SQL server
    public class SQLServer
    {
        #region Private Data
		
        private string ServerName;
        private string UserID;
        private string Password;
        private string Database;
        private SqlConnection DBConnection;
        
        #endregion

        #region Constructor
		
        public SQLServer(string sName, string uID, string pWord, string db)
        {
            this.ServerName = sName;
            this.UserID = uID;
            this.Password = pWord;
            this.Database = db;

            this.DBConnection = null;
        }
  
        #endregion

        #region Public Methods

        public void TerminateConnection()
        {
            this.DBConnection.Close();
        }
        
        #endregion

        #region Public Attributes

        public SqlConnection Connection 
        {
            get 
            {
                if(this.DBConnection == null)
                {
                    this.DBConnection = new SqlConnection("server=" + this.ServerName+"; uid=" + this.UserID +"; pwd=" + this.Password + "; database=" + this.Database);
                    this.DBConnection.Open();
                }
                
                return this.DBConnection;
            }
        }

        #endregion
    }
}
