using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using foofaraw.management;

namespace foofaraw
{
	/// <summary>
	/// Summary description for manage_inventory.
	/// </summary>
	public class manage_inventory : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox SearchQuery;
		protected System.Web.UI.WebControls.DropDownList SearchType;
		protected System.Web.UI.WebControls.Button Search;
		protected System.Web.UI.WebControls.Label QueryReturn;
		protected System.Web.UI.HtmlControls.HtmlForm Form1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!Page.IsPostBack)		
			{
				ManagementSearch search = new ManagementSearch();
				string isbn = Request.QueryString["isbn"];
				string cdid = Request.QueryString["cdid"];
				string count = Request.QueryString["count"];
				if(isbn != null) 
				{
					SearchQuery.Text = isbn;
					SearchType.SelectedIndex = 0;
					publish(search.SearchForBookByISBN(Convert.ToInt64(isbn)),null,
						count,"isbn",isbn);
				}
				else if(cdid != null) 
				{
					SearchQuery.Text = cdid;
					SearchType.SelectedIndex = 1;
					publish(null,search.SearchForMusicByCDID(Convert.ToInt64(cdid)),
						count,"cdid",cdid);
				}
				else
				{					
					publish(search.SearchForAllBooks(),
						search.SearchForAllMusic(),count,"all","all");
				}
			} 
		}

		private void publish(DataSet book_data, DataSet music_data, string count, string type, string search) 
		{
			int icount;
			if(count==null)
				icount = 1;
			else
				icount = int.Parse(count);
			string book, music;
			book = music = string.Empty;	
			ManagementQueryResult results = new ManagementQueryResult(book_data,music_data,icount);
			if(book_data!=null)
				book = results.CreateBookResults(icount,type,search);
			if(music_data!=null)
				music = results.CreateMusicResults(icount,type,search);
			QueryReturn.Text = book + music;
		}

		private void Search_Click(object sender, System.EventArgs e) 
		{
			string type = SearchType.SelectedItem.Value;
			string query = SearchQuery.Text;

			if(query.Length == 0)
				return;

			switch (type)
			{
				case "isbn":
					Response.Redirect("manage_inventory.aspx?isbn=" + query);
					break;
				case "cdid":
					Response.Redirect("manage_inventory.aspx?cdid=" + query);
					break;
				default:
					break;
			}

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Search.Click += new System.EventHandler(this.Search_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
