using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using foofaraw.management;

namespace foofaraw
{
	/// <summary>
	/// Summary description for manage_warehouses.
	/// </summary>
	public class manage_warehouses : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label warehouselist;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!Page.IsPostBack)		
			{
				CreateWarehouseList();
			}
		}

		private void CreateWarehouseList() 
		{
			ManagementSearch search = new ManagementSearch();
			DataTable result = search.GetCurrentWarehouseInfo().Tables[0];
			string html = string.Empty;
			foreach(DataRow row in result.Rows) 
			{
				int books, music;
				int current = Convert.ToInt32(row["id"]);
				Object book_total = search.GetTotalBooksAtWarehouse(current).Tables[0].Rows[0]["total"];
				Object music_total = search.GetTotalMusicAtWarehouse(current).Tables[0].Rows[0]["total"];
				if(book_total is DBNull)
					books = 0;
				else
					books = Convert.ToInt32(book_total);
				if(music_total is DBNull)
					music = 0;
				else
					music = Convert.ToInt32(music_total);
				html += "<div class=\"itembox\"><div class=\"itementry\">";
				html += row["city"].ToString() + " Warehouse: " + (books+music) +
					" items in stock.</div>";
				html += "<a href=\"warehouse_detail.aspx?id=" + row["id"] + "\">View Details</a></div>\n";
			}

			warehouselist.Text = html;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
