using System;
using System.Data;
using SqlRequest;
using System.Text.RegularExpressions;

namespace foofaraw.management
{
	/// <summary>
	/// Summary description for Search.
	/// </summary>
	public class ManagementSearch
	{
		private SQLServer server = StaticServer.CaseyH;
		private string standard_book_select;
		private string standard_book_group;
		private string standard_music_select;
		private string standard_music_group;
			
		public ManagementSearch()
		{
			standard_book_select = "select distinct books.isbn,title,price,sum(availible) as availible ";
            standard_book_group = "group by books.isbn,title,price";
			standard_music_select = "select distinct music.cdid,title,price,sum(availible) as availible ";
			standard_music_group = "group by music.cdid,title,price";
		}


		public DataSet SearchForBookByISBN(Int64 isbn) 
		{			
			string sqlStr = standard_book_select +
				"from books,book_inv " +
				"where bookid=isbn " +
				"and isbn=" + isbn.ToString() + " " +
				standard_book_group;
			return ProcessQuery(sqlStr);
		}

		public DataSet SearchForBookAuthors(Int64 isbn) 
		{
			string sqlStr = "select distinct authors.name " +
				"from books,authors " +
				"where authors.bookid=isbn " +
				"and isbn = " + isbn.ToString() ;			
			return ProcessQuery(sqlStr);
		}

		public DataSet GetNumberOfBooksSold(Int64 isbn) 
		{
			string sqlStr = "select sum(quantity) as sold " +
				"from renacer_billing.dbo.items " +
				"where ItemType=0 " + 
				"and UniqueProductID = " + isbn.ToString();			
			return ProcessQuery(sqlStr);
		}

		public DataSet SearchForAllBooks() 
		{
			string sqlStr = standard_book_select +
				"from books,book_inv " +
				"where bookid=isbn " +
				standard_book_group;
			return ProcessQuery(sqlStr);
		}

		public DataSet SearchForMusicByCDID(Int64 cdid) 
		{
			string sqlStr = standard_music_select +
				"from music,music_inv " +
				"where musicid=cdid " +
				"and cdid=" + cdid.ToString() + " " + 
				standard_music_group;
			return ProcessQuery(sqlStr);
		}
		
		public DataSet SearchForMusicArtists(Int64 cdid) 
		{
			string sqlStr = "select distinct artists.name " +
				"from music,artists " +
				"where artists.musicid=cdid " +
				"and cdid = " + cdid.ToString();
			return ProcessQuery(sqlStr);
		}

		public DataSet GetNumberOfMusicSold(Int64 cdid) 
		{
			string sqlStr = "select sum(quantity) as sold " +
				"from renacer_billing.dbo.items " +
				"where ItemType=1 " + 
				"and UniqueProductID = " + cdid.ToString();			
			return ProcessQuery(sqlStr);
		}

		public DataSet SearchForAllMusic() 
		{
			string sqlStr = standard_music_select +
				"from music,music_inv " +
				"where musicid=cdid " +
				standard_music_group;
			return ProcessQuery(sqlStr);
		}

		public DataSet GetCurrentWarehouseInfo() 
		{
			string sqlStr = "select id,city,address,zipcode,telephone,fax,manager " +
				"from wharehouses";
			return ProcessQuery(sqlStr);
		}

		public DataSet GetCurrentWarehouseInfo(int id) 
		{
			string sqlStr = "select id,city,address,zipcode,telephone,fax,manager " +
				"from wharehouses " +
				"where id=" + id.ToString();
			return ProcessQuery(sqlStr);
		}

		public DataSet GetBookInventoryAtWarehouse(int warehouse) 
		{
			string sqlStr = "select bookid,title,availible from wharehouses,book_inv,books " +
				"where book_inv.location = id and isbn=bookid and id=" + warehouse.ToString();
			return ProcessQuery(sqlStr);
		}

		public DataSet GetMusicInventoryAtWarehouse(int warehouse) 
		{
			string sqlStr = "select musicid,title,availible from wharehouses,music_inv,music " +
				"where music_inv.location = id and cdid=musicid and id=" + warehouse.ToString();
			return ProcessQuery(sqlStr);
		}

		public DataSet GetTotalBooksAtWarehouse(int warehouse) 
		{
			string sqlStr = "select sum(availible) as total from book_inv,wharehouses " +
				"where location=id and id=" + warehouse.ToString();
			return ProcessQuery(sqlStr);
		}

		public DataSet GetTotalMusicAtWarehouse(int warehouse) 
		{
			string sqlStr = "select sum(availible) as total from music_inv,wharehouses " +
				"where location=id and id=" + warehouse.ToString();
			return ProcessQuery(sqlStr);
		}

		public DataSet GetVendorsForWarehouse(int warehouse) 
		{
			string sqlStr = "SELECT vendor_name " +
				"FROM tprouty_shipping.dbo.Shipping_Vendors sv, tprouty_shipping.dbo.Shipping_Vendors_Warehouse svw " +
				"WHERE sv.vendor_id = svw.vendor_id AND svw.warehouse_id = " + warehouse.ToString();
			return ProcessQuery(sqlStr);
		}

		public DataSet GetNumPackagesShippedFromWarehouse(int warehouse) 
		{
			string sqlStr = "SELECT sum(num_items) as total " +
				"FROM tprouty_shipping.dbo.Packages p " +
				"WHERE p.source_warehouse =" + warehouse.ToString();
			return ProcessQuery(sqlStr);
		}

		private DataSet ProcessQuery(string query) 
		{
			SQLRequest request = new SQLRequest(this.server, query);          
			return request.Invoke();
		}
	}
}
