using System;
using System.Collections;

namespace foofaraw.management
{
	/// <summary>
	/// Summary description for SearchResult.
	/// </summary>
	public class ManagementSearchResultTemplate
	{
		private ArrayList left;
		private ArrayList right;

		public ManagementSearchResultTemplate()
		{
			left = new ArrayList();
            right = new ArrayList();
		}

		#region Insertion Methods
		public void InsertItemLeft(string itemname, string itemvalue) 
		{
			ArrayList items = new ArrayList();
			items.Add(itemvalue);
			InsertItemLeft(itemname,items);
		}

		public void InsertItemLeft(string itemname, ArrayList itemvalues) 
		{
			Object[] entry = new Object[2];
			entry[0] = itemname;
			entry[1] = itemvalues;
			left.Add(entry);
		}

		public void InsertItemRight(string itemname, string itemvalue) 
		{
			ArrayList items = new ArrayList();
			items.Add(itemvalue);
			InsertItemRight(itemname,items);
		}

		public void InsertItemRight(string itemname, ArrayList itemvalues) 
		{
			Object[] entry = new Object[2];
			entry[0] = itemname;
			entry[1] = itemvalues;
			right.Add(entry);
		}
		#endregion

		#region String Creation
		public string create()
		{
			string html = "<div class=\"searchresult\">\n";
			html += "<div class=\"left\">\n";
			html += PrintSide(left);
			html += "\n</div>\n";
			html += "<div class=\"right\">\n";
			html += PrintSide(right);
			html += "\n</div>\n";
			html += "</div>\n";
			return html;
		}

		private string PrintSide(ArrayList side) 
		{
			string html = "<table>\n";
			for(int i=0; i<side.Count; i++) 
			{
				Object[] row = (Object[])side[i];
				html += "<tr>\n<td class=\"label\">";
				html += (string)row[0] + ":</td><td>";
				if(row[1] is ArrayList) 
				{
					foreach(string item in (ArrayList)row[1]) 
						html += item + "<br />";
				}
				else
					html += row[1];
				html += "</td></tr>\n";
			}
			return html += "</table>\n";
		}

		#endregion
	}
}
