using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using foofaraw.inventory;

namespace foofaraw
{
	/// <summary>
	/// Summary description for productsearch.
	/// </summary>
	public class productsearch : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox SearchQuery;
		protected System.Web.UI.WebControls.Button Search;
		protected System.Web.UI.WebControls.DropDownList SearchType;
		protected System.Web.UI.WebControls.Label QueryReturn;
		protected System.Web.UI.HtmlControls.HtmlForm Form1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!Page.IsPostBack)		
			{
				InventorySearch search = new InventorySearch();
				string title = Request.QueryString["title"];
				string artist = Request.QueryString["artist"];
				string keyword = Request.QueryString["keyword"];
				string all = Request.QueryString["all"];
				string count = Request.QueryString["count"];
				if(title != null) 
				{
					SearchQuery.Text = title;
					SearchType.SelectedIndex = 0;
					publish(search.SearchForBookByTitle(title),
						search.SearchForMusicByTitle(title),
						count,"title",title);
				}
				else if(artist != null) 
				{
					SearchQuery.Text = artist;
					SearchType.SelectedIndex = 1;
					publish(search.SearchForBookByAuthor(artist),
						search.SearchForMusicByArtist(artist),
						count,"artist",artist);
				}
				else if(keyword != null) 
				{
					SearchQuery.Text = keyword;
					SearchType.SelectedIndex = 2;
					publish(search.SearchForBookByKeyword(keyword),
						null,count,"keyword",keyword);
				}
				else if(all != null) 
				{					
					publish(search.SearchForAllBooks(),
						search.SearchForAllMusic(),count,"all",all);
				}
			} 
		}

		private void publish(DataSet book_data, DataSet music_data, string count, string type, string search) 
		{
			int icount;
			if(count==null)
				icount = 1;
			else
				icount = int.Parse(count);
			string book, music;
			book = music = string.Empty;		
			QueryResult results = new QueryResult(book_data,music_data);
			if(book_data!=null)
				book = results.CreateBookResults(icount,type,search);
			if(music_data!=null)
				music = results.CreateMusicResults(icount,type,search);
			QueryReturn.Text = book + music;
		}

		private void Search_Click(object sender, System.EventArgs e) 
		{
			string type = SearchType.SelectedItem.Value;
			string query = SearchQuery.Text;

			if(query.Length == 0)
				return;

			switch (type)
			{
				case "title":
					Response.Redirect("productsearch.aspx?title=" + query);
					break;
				case "artist":
					Response.Redirect("productsearch.aspx?artist=" + query);
					break;
				case "keyword":
					Response.Redirect("productsearch.aspx?keyword=" + query);
					break;
				default:
					break;
			}

		}


		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Search.Click += new System.EventHandler(this.Search_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
