using System;

using System.Data;
using SqlRequest;

namespace foofaraw.transactions
{
	/// <summary>
	/// Summary description for Queries.
	/// </summary>
	public class TransactionQueries
	{
		public TransactionQueries()
		{
		}

		public DataSet getShippingOptionsList()
		{
			string sql= "SELECT distinct method_name " +
				"FROM Shipping_Methods " +
				"WHERE method_available = 1";
			return ProcessQuery(sql,StaticServer.TimP);
		}

		/// <summary>
		/// use this one for other companies.
		/// </summary>
		/// <param name="companyName"></param>
		/// <returns></returns>
		public DataSet getShippingOptionsList(string companyName)
		{
			string sql= "SELECT distinct method_name " +
				"FROM Shipping_Methods " +
				"WHERE method_available = 1 AND company_name = '"+companyName+"'";
			return ProcessQuery(sql,StaticServer.TimP);
		}

		public DataSet getOtherCompCheapestOption(string methodName, string city, string warehouse, double pkg_weight2, int num_items2, string companyName)
		{
			string sql = "SELECT DISTINCT ao.vendor_name, ao.method_name, ao.ship_price, ao.method_id, ao.delivery_time " +
						 "FROM ( (SELECT sv.vendor_name, sm.method_name, ni.price ship_price, sm.vendor_id, sm.method_id, sm.delivery_time "+
							"FROM Shipping_Methods sm, Num_Items_Pricing_Options ni, Shipping_Vendors sv " +
							"WHERE sm.vendor_id = sv.vendor_id AND sm.method_id = ni.method_id AND ni.num_items_min <= "+num_items2+" AND ni.num_items_max > "+num_items2+" AND sm.company_name = '"+companyName+"') " +
							"UNION " +
							"(SELECT sv.vendor_name, sm.method_name, w.price ship_price, sm.vendor_id, sm.method_id, sm.delivery_time " +
							"FROM Shipping_Methods sm, Weight_Pricing_Options w, Shipping_Vendors sv " +
							"WHERE sm.method_id = w.method_id  AND sm.vendor_id = sv.vendor_id AND w.weight_bracket_min <= "+pkg_weight2+" AND w.weight_bracket_max >= "+pkg_weight2+" AND sm.company_name = '"+companyName+"') " +
							"UNION " +
							"(SELECT sv.vendor_name, sm.method_name, f.price ship_price, sm.vendor_id, sm.method_id, sm.delivery_time " +
							"FROM Shipping_Methods sm, Fixed_Pricing_Options f, Shipping_Vendors sv "+
							"WHERE sm.method_id = f.method_id  AND sm.vendor_id = sv.vendor_id AND sm.company_name = '"+companyName+"') ) ao " +
						"WHERE ao.method_name = '"+methodName+"' "+
						"AND ao.ship_price = (SELECT DISTINCT min(a1.ship_price) "+
									"FROM ( (SELECT sv.vendor_name, sm.method_name, ni.price ship_price, sm.vendor_id, sm.method_id "+
										"FROM Shipping_Methods sm, Num_Items_Pricing_Options ni, Shipping_Vendors sv "+
										"WHERE sm.vendor_id = sv.vendor_id AND sm.method_id = ni.method_id AND ni.num_items_min <= "+num_items2+" AND ni.num_items_max > "+num_items2+" AND sm.company_name = '"+companyName+"') "+
									"UNION  "+
										"(SELECT sv.vendor_name, sm.method_name, w.price ship_price, sm.vendor_id, sm.method_id "+
										"FROM Shipping_Methods sm, Weight_Pricing_Options w, Shipping_Vendors sv "+
										"WHERE sm.method_id = w.method_id  AND sm.vendor_id = sv.vendor_id AND w.weight_bracket_min <= "+pkg_weight2+" AND w.weight_bracket_max >= "+pkg_weight2+" AND sm.company_name = '"+companyName+"') "+
									"UNION " +
										"(SELECT sv.vendor_name, sm.method_name, f.price ship_price, sm.vendor_id, sm.method_id " +
										"FROM Shipping_Methods sm, Fixed_Pricing_Options f, Shipping_Vendors sv " +
										"WHERE sm.method_id = f.method_id  AND sm.vendor_id = sv.vendor_id AND sm.company_name = '"+companyName+"') ) a1 "+
										"WHERE a1.method_name = '"+methodName+"')";
	

						
			return ProcessQuery(sql,StaticServer.TimP);
		}


		public DataSet getCheapestOption(string methodName, string city, string warehouse, double pkg_weight2, int num_items2)
		{
			string sql = "SELECT DISTINCT ao.vendor_name, ao.method_name, ao.ship_price, ao.method_id, ao.delivery_time " +
				"FROM ( " +
				"(SELECT sv.vendor_name, sm.method_name, ni.price ship_price, sm.vendor_id, sm.method_id, sm.delivery_time " +
				"FROM Shipping_Methods sm, Num_Items_Pricing_Options ni, Shipping_Vendors sv " +
				"WHERE sm.vendor_id = sv.vendor_id AND sm.method_id = ni.method_id " +
				"AND ni.num_items_min <= "+num_items2+" AND ni.num_items_max > "+num_items2+") " +
				"UNION " +
				"(SELECT sv.vendor_name, sm.method_name, w.price ship_price, sm.vendor_id, sm.method_id, sm.delivery_time " +
				"FROM Shipping_Methods sm, Weight_Pricing_Options w, Shipping_Vendors sv " +
				"WHERE sm.method_id = w.method_id  AND sm.vendor_id = sv.vendor_id " +
				"AND w.weight_bracket_min <= "+pkg_weight2+" AND w.weight_bracket_max >= "+pkg_weight2+") " +
				"UNION " +
				"(SELECT sv.vendor_name, sm.method_name, f.price ship_price, sm.vendor_id, sm.method_id, sm.delivery_time " +
				"FROM Shipping_Methods sm, Fixed_Pricing_Options f, Shipping_Vendors sv " +
				"WHERE sm.method_id = f.method_id  AND sm.vendor_id = sv.vendor_id) " +
				") ao, Shipping_Vendors_Warehouse svw " +
				"WHERE ao.vendor_id = svw.vendor_id AND svw.warehouse_id = "+warehouse+" AND ao.method_name = '"+methodName+"' " +
				"AND ao.method_id NOT IN (SELECT method_id  " +
				"FROM Cities c, Restricted_Cities rc " +
				"WHERE c.city_id = rc.city_id AND c.city_name = '"+city+" ') " +
				"AND ao.ship_price = (SELECT DISTINCT min(a1.ship_price) " +
				"FROM ( " +
				"(SELECT sv.vendor_name, sm.method_name, ni.price ship_price, sm.vendor_id, sm.method_id " +
				"FROM Shipping_Methods sm, Num_Items_Pricing_Options ni, Shipping_Vendors sv " +
				"WHERE sm.vendor_id = sv.vendor_id AND sm.method_id = ni.method_id " +
				"AND ni.num_items_min <= "+num_items2+" AND ni.num_items_max > "+num_items2+") " +
				"UNION  " +
				"(SELECT sv.vendor_name, sm.method_name, w.price ship_price, sm.vendor_id, sm.method_id " +
				"FROM Shipping_Methods sm, Weight_Pricing_Options w, Shipping_Vendors sv " +
				"WHERE sm.method_id = w.method_id  AND sm.vendor_id = sv.vendor_id " +
				"AND w.weight_bracket_min <= "+pkg_weight2+" AND w.weight_bracket_max >= "+pkg_weight2+") " +
				"UNION " +
				"(SELECT sv.vendor_name, sm.method_name, f.price ship_price, sm.vendor_id, sm.method_id " +
				"FROM Shipping_Methods sm, Fixed_Pricing_Options f, Shipping_Vendors sv " +
				"WHERE sm.method_id = f.method_id  AND sm.vendor_id = sv.vendor_id) " +
				") a1, Shipping_Vendors_Warehouse svw " +
				"WHERE a1.vendor_id = svw.vendor_id AND svw.warehouse_id = "+warehouse+" AND a1.method_name = '"+methodName+"' " +
				"AND a1.method_id NOT IN (SELECT method_id  " +
				"FROM Cities c, Restricted_Cities rc " +
				"WHERE c.city_id = rc.city_id AND c.city_name = '"+city+" '))";

			//Original Working
			/*string sql = "SELECT DISTINCT ao.vendor_name, ao.method_name, ao.ship_price, ao.method_id, ao.delivery_time " +
								"FROM ( " +
									"(SELECT sv.vendor_name, sm.method_name, ni.price ship_price, sm.vendor_id, sm.method_id, sm.delivery_time " +
									"FROM Shipping_Methods sm, Num_Items_Pricing_Options ni, Shipping_Vendors sv " +
									"WHERE sm.vendor_id = sv.vendor_id AND sm.method_id = ni.method_id " +
									"AND ni.num_items_min <= "+num_items2+" AND ni.num_items_max > "+num_items2+") " +
									"UNION " +
									"(SELECT sv.vendor_name, sm.method_name, w.price ship_price, sm.vendor_id, sm.method_id, sm.delivery_time " +
									"FROM Shipping_Methods sm, Weight_Pricing_Options w, Shipping_Vendors sv " +
									"WHERE sm.method_id = w.method_id  AND sm.vendor_id = sv.vendor_id " +
									"AND w.weight_bracket_min <= "+pkg_weight2+" AND w.weight_bracket_max >= "+pkg_weight2+") " +
									"UNION " +
									"(SELECT sv.vendor_name, sm.method_name, f.price ship_price, sm.vendor_id, sm.method_id, sm.delivery_time " +
									"FROM Shipping_Methods sm, Fixed_Pricing_Options f, Shipping_Vendors sv " +
									"WHERE sm.method_id = f.method_id  AND sm.vendor_id = sv.vendor_id) " +
								") ao, Shipping_Vendors_Warehouse svw " +
								"WHERE ao.vendor_id = svw.vendor_id AND svw.warehouse_id = "+warehouse+" AND ao.method_name = '"+methodName+"' " +
								"AND ao.method_id NOT IN (SELECT method_id  " +
											"FROM Cities c, Restricted_Cities rc " +
											"WHERE c.city_id = rc.city_id AND c.city_name = '"+city+" ') " +
								"AND ao.ship_price = (SELECT DISTINCT min(a1.ship_price) " +
											"FROM ( " +
												"(SELECT sv.vendor_name, sm.method_name, ni.price ship_price, sm.vendor_id, sm.method_id " +
												"FROM Shipping_Methods sm, Num_Items_Pricing_Options ni, Shipping_Vendors sv " +
												"WHERE sm.vendor_id = sv.vendor_id AND sm.method_id = ni.method_id " +
												"AND ni.num_items_min <= "+num_items2+" AND ni.num_items_max > "+num_items2+") " +
												"UNION  " +
												"(SELECT sv.vendor_name, sm.method_name, w.price ship_price, sm.vendor_id, sm.method_id " +
												"FROM Shipping_Methods sm, Weight_Pricing_Options w, Shipping_Vendors sv " +
												"WHERE sm.method_id = w.method_id  AND sm.vendor_id = sv.vendor_id " +
												"AND w.weight_bracket_min <= "+pkg_weight2+" AND w.weight_bracket_max >= "+pkg_weight2+") " +
												"UNION " +
												"(SELECT sv.vendor_name, sm.method_name, f.price ship_price, sm.vendor_id, sm.method_id " +
												"FROM Shipping_Methods sm, Fixed_Pricing_Options f, Shipping_Vendors sv " +
												"WHERE sm.method_id = f.method_id  AND sm.vendor_id = sv.vendor_id) " +
											") a1, Shipping_Vendors_Warehouse svw " +
											"WHERE a1.vendor_id = svw.vendor_id AND svw.warehouse_id = "+warehouse+" AND a1.method_name = '"+methodName+"' " +
											"AND a1.method_id NOT IN (SELECT method_id  " +
														"FROM Cities c, Restricted_Cities rc " +
														"WHERE c.city_id = rc.city_id AND c.city_name = '"+city+" '))";*/
			
			return ProcessQuery(sql,StaticServer.TimP);
		}

		public DataSet GetOrderHistory(string login) 
		{
			string sql = "select login,login.invoicenumber,itemname,sum(quantity) as quantity,priceperunit,estimateddeliverydate " +
				"from login, items " +
				"where login.invoicenumber=items.invoicenumber " +
				"and login='" + login + "' " +
				"group by login,login.invoicenumber,itemname,priceperunit,estimateddeliverydate";
			return ProcessQuery(sql,StaticServer.RyanM);
		}

		public DataSet GetCardNames() 
		{
			string sql = "select * from mapcard";
			return ProcessQuery(sql,StaticServer.RyanM);
		}

		private DataSet ProcessQuery(string query, SQLServer server) 
		{
			SQLRequest request = new SQLRequest(server, query);          
			return request.Invoke();
		}
	}
}
