using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;	// This is the library with the SQL types we're using below

namespace foofaraw
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		private SqlConnection sqlConn;	// Declare a connection object
		private SqlCommand sqlCom;		  // Declare a command object
		private SqlDataReader sqlRdr;
		protected System.Web.UI.WebControls.Label filterDisplay;	  // Declare a reader to read the query result
		private string strSqlString = "server=IISQLSRV; uid=invert90; pwd=tacobell; database=tprouty_shipping";
		private int onRouteVendorID;
		private int deliveredVendorID;
		protected System.Web.UI.WebControls.Button minWeight_btn;
		protected System.Web.UI.WebControls.Button todayArrival_btn;
		protected System.Web.UI.WebControls.Button displayAllPackages_btn;
		private bool todayArrival;
		protected System.Web.UI.WebControls.Label randomOut;
		protected System.Web.UI.WebControls.Button onRoute_btn;
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.Label alternateResults;
		protected System.Web.UI.WebControls.DataGrid num_pkg;
		protected System.Web.UI.WebControls.DataGrid num_pkgs_grid;
		private double minWeight;
		private double pkg_weight1;
		private double pkg_weight2;
		protected System.Web.UI.WebControls.Button shippingOptions;
		protected System.Web.UI.HtmlControls.HtmlInputText pkg_weight_fld;
		protected System.Web.UI.HtmlControls.HtmlInputText numItems_fld;
		protected System.Web.UI.HtmlControls.HtmlInputText minWeightVal_fld;
		protected System.Web.UI.WebControls.DataGrid shipOptions;
		protected System.Web.UI.WebControls.Label shippingDisplay;
		protected System.Web.UI.WebControls.Button cheapShipping_btn;
		protected System.Web.UI.HtmlControls.HtmlInputText pkg_weight2_fld;
		protected System.Web.UI.HtmlControls.HtmlInputText num_items2_fld;
		protected System.Web.UI.HtmlControls.HtmlInputText destCity_fld;
		protected System.Web.UI.HtmlControls.HtmlInputText warehouse_fld;
		protected System.Web.UI.WebControls.DataGrid cheapestShipping;
		private int num_items1;
		private int num_items2;
		private int warehouse;
		private string city;
		
		private void Page_Load(object sender, System.EventArgs e)
		{
			//reQuery();
		}

		private void reQuery()
		{
			// Put user code to initialize the page here
			// Put user code to initialize the page here
			// Start a new connection to the database specified in strSqlString
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection


			// Execute query -- Here you could make 'strSql' any query you want
			
			string filterClause = "";
			string filterDisplayVal = "";
			string alternateResultsVal = "";
			string shippingDisplayVal = "";
			int pkgID = 0;
			pkgID = Convert.ToInt16(Request.QueryString["pkg_tracking_id"]);
			
			

			if(onRouteVendorID > 0 )
			{
								
				string strSql = "SELECT d_all.vendor_name, pkgs_on_route, pkgs_delivered " +
									"FROM  " +
										"(SELECT sv1.vendor_name,  pkgs_delivered " +
										"FROM Shipping_Vendors sv1 LEFT OUTER JOIN  " +
										"(SELECT sv.vendor_id, sv.vendor_name, count(pkg_tracking_id) pkgs_delivered " +
										"FROM Packages p, Shipping_Methods sm, Shipping_Vendors sv " +
										"WHERE sm.method_id = p.shipping_method_id AND sv.vendor_id = sm.vendor_id AND  " +
										"p.expected_delivery_date < '1/26/2005 12:00:00 AM' " +
										"GROUP BY sv.vendor_id, sv.vendor_name) d  " +
										"ON d.vendor_id = sv1.vendor_id) d_all " +
									"FULL OUTER JOIN  " +
										"(SELECT sv1.vendor_name,  pkgs_on_route " +
										"FROM Shipping_Vendors sv1 LEFT OUTER JOIN  " +
										"(SELECT sv.vendor_id, sv.vendor_name, count(pkg_tracking_id) pkgs_on_route " +
										"FROM Packages p, Shipping_Methods sm, Shipping_Vendors sv " +
										"WHERE sm.method_id = p.shipping_method_id AND sv.vendor_id = sm.vendor_id AND  " +
										"p.expected_delivery_date >= '1/26/2005 12:00:00 AM' AND p.date_shipped < '1/26/2005 12:00:00 AM' " +
										"GROUP BY sv.vendor_id, sv.vendor_name) d  " +
										"ON d.vendor_id = sv1.vendor_id) or_all " +
									"ON " +
										"d_all.vendor_name = or_all.vendor_name ";

				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();
				num_pkgs_grid.DataSource = sqlRdr;
				num_pkgs_grid.DataBind();
				
				DataGrid1.Visible = false;
				shipOptions.Visible = false;
				cheapestShipping.Visible = false;
				num_pkgs_grid.Visible = true;
			} 
			else if(num_items1 > 0 & pkg_weight1 > 0)
			{
				shippingDisplayVal = shippingDisplayVal + "<b>Weight: </b>"+ pkg_weight1;
				shippingDisplayVal = shippingDisplayVal + "<br /><b>Number of Items: </b>"+ num_items1;
			
				string strSql = "(SELECT sv.vendor_name, sm.method_name, ni.price ship_price " +
					"FROM Shipping_Methods sm, Num_Items_Pricing_Options ni, Shipping_Vendors sv " +
					"WHERE sm.vendor_id = sv.vendor_id AND sm.method_id = ni.method_id " +
					"AND ni.num_items_min <= " + num_items1 + " AND ni.num_items_max > " + num_items1 + ") " +
					"UNION " +
					"(SELECT sv.vendor_name, sm.method_name, w.price ship_price " +
					"FROM Shipping_Methods sm, Weight_Pricing_Options w, Shipping_Vendors sv " +
					"WHERE sm.method_id = w.method_id  AND sm.vendor_id = sv.vendor_id " +
					"AND w.weight_bracket_min <= " + pkg_weight1 + " AND w.weight_bracket_max >= " + pkg_weight1 + ") " +
					"UNION " +
					"(SELECT sv.vendor_name, sm.method_name, f.price ship_price " +
					"FROM Shipping_Methods sm, Fixed_Pricing_Options f, Shipping_Vendors sv " +
					"WHERE sm.method_id = f.method_id  AND sm.vendor_id = sv.vendor_id) ";

				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();
				shipOptions.DataSource = sqlRdr;
				shipOptions.DataBind();


				DataGrid1.Visible = false;	 
				num_pkgs_grid.Visible = false;
				cheapestShipping.Visible = false;
				shipOptions.Visible = true;

			}
			else if(pkg_weight2 > 0	&& num_items2 > 0 && warehouse > 0 && city.Length != 0)
			{
				shippingDisplayVal = shippingDisplayVal + "<b>Weight: </b>"+ pkg_weight2;
				shippingDisplayVal = shippingDisplayVal + "<br /><b>Number of Items: </b>"+ num_items2;
				shippingDisplayVal = shippingDisplayVal + "<br /><b>Warehouse: </b>"+ warehouse;
				shippingDisplayVal = shippingDisplayVal + "<br /><b>City: </b>"+ city;
			
				string strSql = "SELECT DISTINCT ao.vendor_name, ao.method_name, ao.ship_price " +
								"FROM ( " +
									"(SELECT sv.vendor_name, sm.method_name, ni.price ship_price, sm.vendor_id, sm.method_id " +
									"FROM Shipping_Methods sm, Num_Items_Pricing_Options ni, Shipping_Vendors sv " +
									"WHERE sm.vendor_id = sv.vendor_id AND sm.method_id = ni.method_id " +
									"AND ni.num_items_min <= "+num_items2+" AND ni.num_items_max > "+num_items2+") " +
									"UNION " +
									"(SELECT sv.vendor_name, sm.method_name, w.price ship_price, sm.vendor_id, sm.method_id " +
									"FROM Shipping_Methods sm, Weight_Pricing_Options w, Shipping_Vendors sv " +
									"WHERE sm.method_id = w.method_id  AND sm.vendor_id = sv.vendor_id " +
									"AND w.weight_bracket_min <= "+pkg_weight2+" AND w.weight_bracket_max >= "+pkg_weight2+") " +
									"UNION " +
									"(SELECT sv.vendor_name, sm.method_name, f.price ship_price, sm.vendor_id, sm.method_id " +
									"FROM Shipping_Methods sm, Fixed_Pricing_Options f, Shipping_Vendors sv " +
									"WHERE sm.method_id = f.method_id  AND sm.vendor_id = sv.vendor_id) " +
								") ao, Shipping_Vendors_Warehouse svw " +
								"WHERE ao.vendor_id = svw.vendor_id AND svw.warehouse_id = "+warehouse+" " +
								"AND ao.method_id NOT IN (SELECT method_id  " +
											"FROM Cities c, Restricted_Cities rc " +
											"WHERE c.city_id = rc.city_id AND c.city_name = '"+city+" ') " +
								"AND ao.ship_price = (SELECT DISTINCT min(ao.ship_price) " +
											"FROM ( " +
												"(SELECT sv.vendor_name, sm.method_name, ni.price ship_price, sm.vendor_id, sm.method_id " +
												"FROM Shipping_Methods sm, Num_Items_Pricing_Options ni, Shipping_Vendors sv " +
												"WHERE sm.vendor_id = sv.vendor_id AND sm.method_id = ni.method_id " +
												"AND ni.num_items_min <= "+num_items2+" AND ni.num_items_max > "+num_items2+") " +
												"UNION  " +
												"(SELECT sv.vendor_name, sm.method_name, w.price ship_price, sm.vendor_id, sm.method_id " +
												"FROM Shipping_Methods sm, Weight_Pricing_Options w, Shipping_Vendors sv " +
												"WHERE sm.method_id = w.method_id  AND sm.vendor_id = sv.vendor_id " +
												"AND w.weight_bracket_min <= "+pkg_weight2+" AND w.weight_bracket_max >= "+pkg_weight2+") " +
												"UNION " +
												"(SELECT sv.vendor_name, sm.method_name, f.price ship_price, sm.vendor_id, sm.method_id " +
												"FROM Shipping_Methods sm, Fixed_Pricing_Options f, Shipping_Vendors sv " +
												"WHERE sm.method_id = f.method_id  AND sm.vendor_id = sv.vendor_id) " +
											") ao, Shipping_Vendors_Warehouse svw " +
											"WHERE ao.vendor_id = svw.vendor_id AND svw.warehouse_id = "+warehouse+" " +
											"AND ao.method_id NOT IN (SELECT method_id  " +
														"FROM Cities c, Restricted_Cities rc " +
														"WHERE c.city_id = rc.city_id AND c.city_name = '"+city+" '))";

				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();
				cheapestShipping.DataSource = sqlRdr;
				cheapestShipping.DataBind();


				DataGrid1.Visible = false;	 
				num_pkgs_grid.Visible = false;
				shipOptions.Visible = false;
				cheapestShipping.Visible = true;
			}
			else
			{


				if(todayArrival)
				{
					filterDisplayVal = "<b>Filtered Results:</b> Arriving Today";
					filterClause = " AND expected_delivery_date = '" + DateTime.Today.ToString() + "'";
				}

				if(pkgID > 0)
				{
					filterDisplayVal = filterDisplayVal  + "<b>Filtered Results:</b> tracking id = " + pkgID;
					filterClause = filterClause + " AND pkg_tracking_id = " + pkgID;
				} 

				if(minWeight >= 0)
				{	
					filterDisplayVal = filterDisplayVal + "<b>Filtered Results:</b> min weight >= " + minWeight;
					filterClause = filterClause + " AND weight >= " + minWeight;
				}

				string strSql = "SELECT pkg_tracking_id, weight, num_items, expected_delivery_date, method_name, shipping_state, shipping_zip " +
					"FROM Packages p, Shipping_Methods m " +
					"WHERE p.shipping_method_id = m.method_id" +
					filterClause;

				//filterDisplayVal = filterDisplayVal + strSql;
							
				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				// Get the answer from the reader and write it to the label.
				if (sqlRdr.HasRows) 
				{
					DataGrid1.DataSource = sqlRdr;
					DataGrid1.DataBind();
					DataGrid1.Visible = true;
					num_pkgs_grid.Visible = false;
					shipOptions.Visible = false;
					cheapestShipping.Visible = false;
				} 
				else 
				{
					DataGrid1.Visible = false;
					alternateResultsVal = "No Results";
				}
			}
			

			// Close the sql connection at the end
			sqlConn.Close();
			alternateResults.Text = alternateResultsVal;
			filterDisplay.Text = filterDisplayVal;
			shippingDisplay.Text = shippingDisplayVal;
		}
			
	

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.cheapShipping_btn.Click += new System.EventHandler(this.cheapShipping_btn_Click);
			this.shippingOptions.Click += new System.EventHandler(this.shippingOptions_Click);
			this.shipOptions.SelectedIndexChanged += new System.EventHandler(this.shipOptions_SelectedIndexChanged);
			this.displayAllPackages_btn.Click += new System.EventHandler(this.displayAllPackages_btn_Click);
			this.todayArrival_btn.Click += new System.EventHandler(this.todayArrival_btn_Click);
			this.minWeight_btn.Click += new System.EventHandler(this.minWeight_btn_Click);
			this.onRoute_btn.Click += new System.EventHandler(this.onRoute_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion



		
		private void DataGrid1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

		private void todayArrival_btn_Click(object sender, System.EventArgs e)
		{
			deliveredVendorID = 0;
			onRouteVendorID = 0;
			minWeight = -1;
			todayArrival = true;
			num_items1 = -1;
			pkg_weight1 = -1;
			pkg_weight2 = -1;
			num_items2 = -1;
			warehouse = -1;
			city = "";
			reQuery();
		}

		private void minWeight_btn_Click(object sender, System.EventArgs e)
		{
			if(minWeightVal_fld.Value.Length == 0)
			{
				filterDisplay.Text = "The field above the button must have a valid positive integer to use this query.";
				DataGrid1.Visible = false;
				num_pkgs_grid.Visible = false;
				alternateResults.Visible = false;
			} 
			else
			{
				deliveredVendorID = 0;
				onRouteVendorID = 0;
				minWeight = Convert.ToDouble(minWeightVal_fld.Value);
				todayArrival = false;
				num_items1 = -1;
				pkg_weight1 = -1;
				pkg_weight2 = -1;
				num_items2 = -1;
				warehouse = -1;
				city = "";
				reQuery();
			}
		}

		private void displayAllPackages_btn_Click(object sender, System.EventArgs e)
		{	
			deliveredVendorID = 0;
			onRouteVendorID = 0;
			minWeight = -1;
			todayArrival = false;
			num_items1 = -1;
			pkg_weight1 = -1;
			pkg_weight2 = -1;
			num_items2 = -1;
			warehouse = -1;
			city = "";
			reQuery();
			//randomOut.Text = DateTime.Today.ToString();
		}

		private void minWeightVal_ServerChange(object sender, System.EventArgs e)
		{
		
		}


		private void onRoute_Click(object sender, System.EventArgs e)
		{
			onRouteVendorID = 1;
			deliveredVendorID = 0;
			minWeight = -1;
			todayArrival = false;
			num_items1 = -1;
			pkg_weight1 = -1;
			pkg_weight2 = -1;
			num_items2 = -1;
			warehouse = -1;
			city = "";
			reQuery();
		}

		private void shippingOptions_Click(object sender, System.EventArgs e)
		{
			if(pkg_weight_fld.Value.Length == 0 || numItems_fld.Value.Length == 0)
			{
				shippingDisplay.Text = "Both fields required to calculate the cheapest Shipping Option";
				shipOptions.Visible = false;
				cheapestShipping.Visible = false;
			} 
			else 
			{
				num_items1 = Convert.ToInt16(numItems_fld.Value);
				pkg_weight1 = Convert.ToDouble(pkg_weight_fld.Value);
				deliveredVendorID = 0;
				onRouteVendorID = 0;
				minWeight = -1;
				todayArrival = false;
				pkg_weight2 = -1;
				num_items2 = -1;
				warehouse = -1;
				city = "";
				reQuery();
			}
		}

		private void cheapShipping_btn_Click(object sender, System.EventArgs e)
		{
			
			if(pkg_weight2_fld.Value.Length == 0 || num_items2_fld.Value.Length == 0 || warehouse_fld.Value.Length == 0 || destCity_fld.Value.Length == 0)
			{
				shippingDisplay.Text = "All 4 fields required to calculate the cheapest Shipping Option";
				cheapestShipping.Visible = false;
				shipOptions.Visible = false;
			} 
			else 
			{
				pkg_weight2 = Convert.ToDouble(pkg_weight2_fld.Value);
				num_items2 = Convert.ToInt16(num_items2_fld.Value);
				warehouse = Convert.ToInt32(warehouse_fld.Value);
				city = destCity_fld.Value;
				num_items1 = -1;
				pkg_weight1 = -1;
				deliveredVendorID = 0;
				onRouteVendorID = 0;
				minWeight = -1;
				todayArrival = false;
				reQuery();
			}
		}

		private void shipOptions_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}
	}
}
