Select 1 as Tag,
	null 		as Parent,
	name 		as [vendor!1!name!element],
	url 		as [vendor!1!url!element],
	tollfree 	as [vendor!1!toll-free!element],
	null		as [method!2!id],
	null 		as [method!2!option!element],
	null		as [price!3!flat!element],
	null		as [price!3!perUnit!element],
	null		as [price!3!perPound!element],
	null		as [restrictions!4!maximumWeight!element],
	null		as [restrictions!4!maximumitems!element],
	null		as [cities!5!]
From Vendors V
Union All
Select 2 as Tag,
	1 as Parent,
	V.name,
	V.url,
	V.tollfree,
	M.methodID,
	M.shipOption,
	null,
	null,
	null,
	null,
	null,
	null
From Vendors V, Methods M
Where V.name = M.vendor
Union All
Select 3 as Tag,
	2 as Parent,
	V.name,
	V.url,
	V.tollfree,
	M.methodID,
	M.shipOption,
	Case When P.priceUnit = 'fixed' Then P.price Else null End,
	Case When P.priceUnit = 'Item' Then P.price Else null End,
	Case When P.priceUnit = 'Pound' Then P.price Else null End,
	null,
	null,
	null
From Vendors V, Methods M, Methods P
Where V.name = M.vendor
	and M.methodID = P.methodID
Union All
Select 4 as Tag,
	2 as Parent,
	V.name,
	V.url,
	V.tollfree,
	M.methodID,
	M.shipOption,
	null,
	null, 
	null,
	P.maxWeight,
	P.maxUnit,
	null
From Methods M, Vendors V, Methods P
Where V.name = M.vendor
	and M.methodID = P.methodID
Union ALL
Select 5 as Tag,
	4 as Parent,
	V.name,
	V.url,
	V.tollfree,
	M.methodID,
	M.shipOption,
	null,
	null, 
	null,
	null,
	null,
	R.city
From Methods M, Vendors V, Methods P, RestrictedCities R
Where V.name = M.vendor
	and M.methodID = P.methodID
	and M.methodID = R.shippingMethod
Order by [vendor!1!name!element],[method!2!id], tag
For XML Explicit