using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;  // SQL library

namespace cse444project
{
	/// <summary>
	/// Summary description for AddToCart.
	/// </summary>
	public class AddToCart : Template
	{
		protected System.Web.UI.WebControls.TextBox ItemIDTextBox;
		protected System.Web.UI.WebControls.TextBox StockTextBox;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Label Label3;
		protected System.Web.UI.WebControls.Label Label4;
		protected System.Web.UI.WebControls.TextBox QuantityTextBox;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.TextBox TitleTextBox;
		protected System.Web.UI.WebControls.TextBox PriceTextBox;
		protected System.Web.UI.WebControls.TextBox DiscountTextBox;
		protected System.Web.UI.WebControls.Label Label5;
		protected System.Web.UI.WebControls.Label Discount;
		protected System.Web.UI.WebControls.Button AddToCartBtn;
		private string strSqlString = "server=IISQLSRV; uid=triroot; pwd=changeME";
		protected System.Web.UI.WebControls.TextBox CurrQtyTextBox;
		protected System.Web.UI.WebControls.Label Label6;
		protected System.Web.UI.WebControls.Label Label7;
		protected System.Web.UI.WebControls.Label WarningLabel;
		private int currQty;
		protected System.Web.UI.WebControls.Label Label8;
		protected System.Web.UI.WebControls.TextBox CompanyTextBox;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			Title = "Add To Cart";
			
			ItemIDTextBox.Text = Session.Contents["itemID"].ToString();
			StockTextBox.Text = Session.Contents["numStock"].ToString();
			TitleTextBox.Text = Session.Contents["title"].ToString();
			PriceTextBox.Text = Session.Contents["price"].ToString();
			DiscountTextBox.Text = Session.Contents["discount"].ToString();
			CompanyTextBox.Text = Session.Contents["company"].ToString();

			GetCurrentQty();

			CurrQtyTextBox.Text = currQty.ToString();
		}

		private void GetCurrentQty()
		{
			SqlConnection sqlConn = new SqlConnection(strSqlString);
			sqlConn.Open();
			
			string username;
			try
			{
				username = Session.Contents["username"].ToString();
			}
			catch(Exception)
			{
				Server.Transfer("Login.aspx");
				username = "";
			}
			username = username;
			
			string qtyText = QuantityTextBox.Text;
			string strSql = " SELECT qty " +
				" FROM phil60_shipping.dbo.ShoppingCartItems AS cart " +
				" WHERE cart.username = '" + username + "' AND cart.itemID = '" + ItemIDTextBox.Text + "' AND cart.company = '" + CompanyTextBox.Text + "'";

			SqlCommand sqlCom = new SqlCommand(strSql, sqlConn);
			SqlDataReader sqlRdr = sqlCom.ExecuteReader();

			sqlRdr.Read();
			if (sqlRdr.HasRows)
				this.currQty =  Int32.Parse(sqlRdr.GetValue(0).ToString());
			else
				this.currQty = 0;

			sqlRdr.Close();
			sqlConn.Close();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.AddToCartBtn.Click += new System.EventHandler(this.AddToCartBtn_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private bool CheckQty()
		{
			int newQty = Int32.Parse(QuantityTextBox.Text);
			int currStock = Int32.Parse(StockTextBox.Text);

			if ((newQty + currQty) > currStock && newQty <= 0)
			{
				return false;
			}

			return true;
		}

		private void AddToCartBtn_Click(object sender, System.EventArgs e)
		{
			int newQty = Int32.Parse(QuantityTextBox.Text);
			int currStock = Int32.Parse(StockTextBox.Text);

			if (newQty < currStock)
			{
				SqlConnection sqlConn = new SqlConnection(strSqlString);
				sqlConn.Open();
				string username;
				try
				{
					username = Session.Contents["username"].ToString();
				}
				catch(Exception)
				{
					Server.Transfer("Login.aspx");
					username = "";
				}
				username = username;
			
				string qtyText = QuantityTextBox.Text;
				string strSql = " SELECT * " +
					" FROM phil60_shipping.dbo.ShoppingCartItems AS cart " +
					" WHERE cart.username = '" + username + "' AND cart.itemID = '" + ItemIDTextBox.Text + "' AND cart.company = '" + CompanyTextBox.Text + "'";

				SqlCommand sqlCom = new SqlCommand(strSql, sqlConn);
				SqlDataReader sqlRdr = sqlCom.ExecuteReader();

				if (sqlRdr.HasRows) // already exists in shopping cart so we should update	
				{
					if (CheckQty())
					{
						sqlConn.Close();
						sqlConn.Open();
						strSql = "UPDATE phil60_shipping.dbo.ShoppingCartItems" +
							" SET phil60_shipping.dbo.ShoppingCartItems.qty = phil60_shipping.dbo.ShoppingCartItems.qty + " + qtyText +
							" WHERE phil60_shipping.dbo.ShoppingCartItems.username = '" + username + "' AND phil60_shipping.dbo.ShoppingCartItems.itemID = '" + ItemIDTextBox.Text + "' AND phil60_shipping.dbo.ShoppingCartItems.company = '" + CompanyTextBox.Text + "' ";  //update
						sqlCom = new SqlCommand(strSql, sqlConn);
						sqlCom.ExecuteNonQuery();
					}
				} 
				else  // item does not exist in shopping cart already so we need to insert
				{
					sqlConn.Close();
					sqlConn.Open();
					strSql = " INSERT INTO phil60_shipping.dbo.ShoppingCartItems " +  // insert
							" VALUES ('" + username + "','" + ItemIDTextBox.Text + "'," + qtyText + ",'" + CompanyTextBox.Text + "')";
					sqlCom = new SqlCommand(strSql, sqlConn);
					sqlCom.ExecuteNonQuery();
				}

				sqlRdr.Close();
				sqlConn.Close();
			}

			Server.Transfer("Browse.aspx");
		}
	}
}
