using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;				// This is the library with the SQL types we're using below

namespace cse444project
{
	/// <summary>
	/// Summary description for BrowseForm.
	/// </summary>
	public class Browse : Template
	{
		private SqlConnection sqlConn;		// Declare a connection object
		private SqlCommand sqlCom;			// Declare a command object
		private SqlDataReader sqlRdr;		// Declare a reader to read the query result
		private string strSqlString = "server=IISQLSRV; uid=craigatk; pwd=12345; database=craigatk_inventory";
		protected System.Web.UI.WebControls.Button DisplayAllBtn;
		protected System.Web.UI.WebControls.Label Label7;
		protected System.Web.UI.WebControls.Button ArtistAuthorBtn;
		protected System.Web.UI.HtmlControls.HtmlForm Form1;
		protected System.Web.UI.WebControls.DataGrid BookDataGrid;
		protected System.Web.UI.WebControls.DataGrid CDDataGrid;
		protected System.Web.UI.WebControls.DropDownList ArtistAuthorTypeList;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.TextBox TitleTextBox;
		protected System.Web.UI.WebControls.Button TitleBtn;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.TextBox BookKeywordTextBox;
		protected System.Web.UI.WebControls.Button BookKeywordBtn;
		protected System.Web.UI.WebControls.TextBox ArtistAuthorTextBox;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ArtistAuthorBtn.Click += new System.EventHandler(this.ArtistAuthorBtn_Click);
			this.BookKeywordBtn.Click += new System.EventHandler(this.BookKeywordBtn_Click);
			this.TitleBtn.Click += new System.EventHandler(this.TitleBtn_Click);
			this.CDDataGrid.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.addToCart);
			this.DisplayAllBtn.Click += new System.EventHandler(this.DisplayAllBtn_Click);
			this.BookDataGrid.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.addToCart);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void DisplayAllBtn_Click(object sender, System.EventArgs e)
		{
			executeDualSQLQuery(generateDisplayAllQuery("Books"), generateDisplayAllQuery("CDs"));
		}

		private string generateQuery(string tableName, string fromClause, string whereClause, string groupbyClause)
		{
			tableName = tableName.ToLower();
			string idColumn = (tableName == "books") ? "ISBN" : "ID";
			string nameTable = (tableName == "books") ? "Authors" : "Artists";
			string prodTableID = tableName + "." + idColumn;
			string nameTableID = nameTable + "." + idColumn;
			string name = (tableName == "books") ? nameTable + ".fname, " + nameTable + ".lname" : nameTable + ".artist";
			string company = tableName + ".company";
			string companyCheck = company + " = " + nameTable + ".company ";

			string strSql;
			

			strSql = "SELECT " + prodTableID + ", title, " + name + ", price, discount, sum(stock.numStock) AS NumInStock, " + company +
				" FROM " + nameTable + ", stock, products, " + tableName + " LEFT OUTER JOIN discounts ON (" + prodTableID + " = discounts.itemID AND " + company + " = discounts.company) " + fromClause + 
				" WHERE " + prodTableID + " = " + nameTableID + " AND products.itemID = " + prodTableID + " AND stock.itemID = " + prodTableID + " AND " + companyCheck + whereClause +
				" GROUP BY " + name + "," + prodTableID + ", title, price, discount, " + company + groupbyClause +
				" ORDER BY title ";

			System.Diagnostics.Debug.WriteLine(strSql);

			return strSql;
		}

		private string generateDisplayAllQuery(string tableName)
		{
			return generateQuery(tableName,"","","");
		}

		private void executeDualSQLQuery(string bookQuery, string cdQuery)
		{
			string strSql;

			// Hide the two data grids
			BookDataGrid.Visible = false;
			CDDataGrid.Visible = false;

			// Start a new connection to the database specified in strSqlString
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection

			// Book
			// Execute query
			strSql = bookQuery;
						
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			// Get the answer from the reader and write it to the label.
			if (sqlRdr.HasRows) 
			{
				BookDataGrid.DataSource = sqlRdr;
				BookDataGrid.DataBind();

				Hashtable itemHash = new Hashtable();
				foreach (DataGridItem i in BookDataGrid.Items)
				{
					string itemVal = i.Cells[1] + i.Cells[2].Text;
					if (!itemHash.ContainsValue(itemVal))
					{
						itemHash.Add(itemVal.GetHashCode(),itemVal);
					}
					else
					{
						i.Visible = false;
					}
				}

				BookDataGrid.Visible = true;
			}

			sqlRdr.Close();
			
			// CD
			// Execute query 
			strSql = cdQuery;
						
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			// Get the answer from the reader and write it to the label.
			if (sqlRdr.HasRows) 
			{
				CDDataGrid.DataSource = sqlRdr;
				CDDataGrid.DataBind();

				int offset = BookDataGrid.Items.Count * 25 + 100;
				CDDataGrid.Style["TOP"] = offset.ToString() + "px";

				Hashtable itemHash = new Hashtable();
				foreach (DataGridItem i in CDDataGrid.Items)
				{
					string itemVal = i.Cells[1] + i.Cells[2].Text;
					if (!itemHash.ContainsValue(itemVal))
					{
						itemHash.Add(itemVal.GetHashCode(),itemVal);
					}
					else
					{
						i.Visible = false;
					}
				}

				CDDataGrid.Visible = true;
			}

			// Close the sql connection at the end
			sqlRdr.Close();
			sqlConn.Close();
		}

		private void executeSingleSQLQuery(string itemType, string query)
		{
			string strSql;

			// Hide the two data grids
			BookDataGrid.Visible = false;
			CDDataGrid.Visible = false;

			// Start a new connection to the database specified in strSqlString
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection

			// Execute query
			strSql = query;

			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			// Get the answer from the reader and write it to the label.
			if (sqlRdr.HasRows) 
			{
				if (itemType == "Books")
				{
					BookDataGrid.DataSource = sqlRdr;
					BookDataGrid.DataBind();

					Hashtable itemHash = new Hashtable();
					foreach (DataGridItem i in BookDataGrid.Items)
					{
						string itemVal = i.Cells[1] + i.Cells[2].Text;
						if (!itemHash.ContainsValue(itemVal))
						{
							itemHash.Add(itemVal.GetHashCode(),itemVal);
						}
						else
						{
							i.Visible = false;
						}
					}

					BookDataGrid.Visible = true;
				}
				else if (itemType == "CDs")
				{
					CDDataGrid.DataSource = sqlRdr;
					CDDataGrid.DataBind();

					Hashtable itemHash = new Hashtable();
					foreach (DataGridItem i in CDDataGrid.Items)
					{
						string itemVal = i.Cells[1] + i.Cells[2].Text;
						if (!itemHash.ContainsValue(itemVal))
						{
							itemHash.Add(itemVal.GetHashCode(),itemVal);
						}
						else
						{
							i.Visible = false;
						}
					}

					CDDataGrid.Visible = true;
				}
			}

			// Close the sql connection at the end
			sqlRdr.Close();
			sqlConn.Close();
		}

		private void ArtistAuthorBtn_Click(object sender, System.EventArgs e)
		{
			string tableName = ArtistAuthorTypeList.SelectedValue;
			string searchStr = ArtistAuthorTextBox.Text;

			executeSingleSQLQuery(tableName, generateNameSearchQuery(tableName, searchStr));
			//executeDualSQLQuery(generateNameSearchQuery("Books", searchStr),generateNameSearchQuery("CDs", searchStr));
		}

		private string generateNameSearchQuery(string tableName, string searchStr)
		{
			//string strSql;
			string idColumn = (tableName.ToLower() == "books") ? "ISBN" : "ID";
			string nameTable = (tableName.ToLower() == "books") ? "Authors" : "Artists";
			string prodTableID = tableName + "." + idColumn;
			string nameTableID = nameTable + "." + idColumn;
			string name = (tableName == "books") ? nameTable + ".fname, " + nameTable + ".lname" : nameTable + ".artist";
			ArrayList nameList = new ArrayList();
			bool dualName = false;

			ArrayList delims = new ArrayList(new char[]{',', ' ', ';'});

			for (int i = 0; i < delims.Count; i++)
			{
				if (searchStr.IndexOf((char)delims[i]) != -1)
				{
					nameList = new ArrayList(searchStr.Split((char)delims[i]));
					dualName = true;
					break;
				}
			}

			if (!dualName)
				nameList = new ArrayList(new string[]{searchStr});

			string whereClause = " AND (";

			if (tableName.ToLower() == "books")
			{
				for (int i = 0; i < nameList.Count; i++)
					whereClause += nameTable + ".lname LIKE '%" + nameList[i].ToString() + "%' OR " + nameTable + ".fname LIKE '%" + nameList[i].ToString() + "%' OR ";

				whereClause += " 0=1)";
			}
			else
			{
				for (int i = 0; i < nameList.Count; i++)
					whereClause += nameTable + ".artist LIKE '%" + nameList[i].ToString() + "%' OR ";

				whereClause += " 0=1)";
			}
						
			return generateQuery(tableName, "", whereClause, "");
		}

		private void TitleBtn_Click(object sender, System.EventArgs e)
		{
			executeDualSQLQuery(generateTitleSearchQuery("Books", TitleTextBox.Text),generateTitleSearchQuery("CDs", TitleTextBox.Text));
		}

		private string generateTitleSearchQuery(string tableName, string searchStr)
		{
			string whereClause = " AND title LIKE '%" + searchStr + "%' ";

			return generateQuery(tableName, "", whereClause, "");
		}

		private void BookKeywordBtn_Click(object sender, System.EventArgs e)
		{
			executeSingleSQLQuery("Books", generateBookKeywordQuery(BookKeywordTextBox.Text));
		}

		private string generateBookKeywordQuery(string searchStr)
		{
			string whereClause = " AND BookKeywords.ISBN = books.ISBN AND BookKeywords.company = books.company AND BookKeywords.keyword LIKE '%" + searchStr + "%' ";
			return generateQuery("Books", ", BookKeywords", whereClause, ", BookKeywords.keyword");
		}

		private void addToCart(Object sender, DataGridCommandEventArgs e)
		{
			string itemID = e.Item.Cells[1].Text;
			string title = e.Item.Cells[2].Text;
			int offset = (sender == BookDataGrid) ? 1 : 0;
			string price = e.Item.Cells[4+offset].Text;
			string discount = (e.Item.Cells[5+offset].Text == "&nbsp;") ? "" : e.Item.Cells[5+offset].Text;
			string numStock = e.Item.Cells[6+offset].Text;
			string company = e.Item.Cells[7+offset].Text;

			Session.Add("itemID",itemID);
			Session.Add("title",title);
			Session.Add("price",price);
			Session.Add("discount",discount);
			Session.Add("numStock",numStock);
			Session.Add("company",company);

			Server.Transfer("AddToCart.aspx");
		}
	}
}
