using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using System.IO;

namespace cse444project
{
	/// <summary>
	/// Summary description for Checkout.
	/// </summary>
	public class Checkout : Template
	{
		protected System.Web.UI.WebControls.TextBox CreditTypeBox;
		protected System.Web.UI.WebControls.DropDownList PaymentList;
		protected System.Web.UI.WebControls.Button PayButton;
		protected System.Web.UI.WebControls.Label LabelA2;
		protected System.Web.UI.WebControls.TextBox CreditNumberBox;
		protected System.Web.UI.WebControls.Label LabelA3;
		protected System.Web.UI.WebControls.Label PriceLabel;
		protected System.Web.UI.WebControls.Label LabelA5;
		protected System.Web.UI.WebControls.Label LabelA6;
		protected System.Web.UI.WebControls.Label LabelA7;
		protected System.Web.UI.WebControls.Label LabelA8;
		protected System.Web.UI.WebControls.Label LabelA9;
		protected System.Web.UI.WebControls.Label DiscountLabel;
		protected System.Web.UI.WebControls.Label TaxLabel;
		protected System.Web.UI.WebControls.Label ShippingLabel;
		protected System.Web.UI.WebControls.Label TotalLabel;
		protected System.Web.UI.WebControls.Label LabelA4;
		private Hashtable packages;

		private void Page_Load(object sender, System.EventArgs e)
		{
			Hashtable[] checkoutInfo = (Hashtable[]) Session["InvoiceInfo"];
			Hashtable cost = (Hashtable) checkoutInfo[1];
			decimal price = 0;
			decimal discount = 0;
			decimal shipping = 0;
			IDictionaryEnumerator enumer = cost.GetEnumerator();
			while(enumer.MoveNext())
			{
				decimal[] currCompanyCost = (decimal[]) cost[(string)enumer.Key];
				price += currCompanyCost[0];
				discount += currCompanyCost[1];
				shipping += currCompanyCost[2];
			}
			PriceLabel.Text = price.ToString();
			DiscountLabel.Text = discount.ToString();
			decimal priceAfterDisc = price - discount;
			decimal tax = ((decimal)priceAfterDisc*(decimal)0.09);
			TaxLabel.Text = tax.ToString();
			ShippingLabel.Text = shipping.ToString();
			decimal total = priceAfterDisc + tax + shipping;
			TotalLabel.Text = total.ToString();

			packages = (Hashtable)Session["packages"];
			if(packages == null)
				packages = new Hashtable();

			try
			{
				GetCreditInfo();
			}
			catch (Exception)
			{
				// do nothing
			}

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.PayButton.Click += new System.EventHandler(this.PayButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void PayButton_Click(object sender, System.EventArgs e)
		{
			/* create orders */
			// for loop thru session variables
			//ArrayList[] checkoutInfo = (ArrayList[]) Session["InvoiceInfo"];
			//ArrayList orders = (ArrayList) checkoutInfo[0];
			Hashtable[] checkoutInfo = (Hashtable[]) Session["InvoiceInfo"];
			Hashtable orders = (Hashtable) checkoutInfo[0];
			//for(int i=0;i<orders.Count;i++)
			IDictionaryEnumerator enumer = orders.GetEnumerator();
			while(enumer.MoveNext())
			{
				object[] order = (object[]) (orders[(string)enumer.Key]);
				if("fsycpf" != (string) order[0])// if partner order
				{
					//  call write order with the applicable info
					WriteOrder((string)order[0],(string[])order[1],(string[])order[2],
						(string[])order[3],(int[])order[4],(string)order[5],
						(string)order[6],(string)order[7],(string)order[8],
						(string)order[9],(string)order[10],(string)order[11]);
				} 
				else // our order
				{
					AddInvoice(order, (Hashtable)checkoutInfo[1]);
				}
			}

			ShoppingCart.DeleteCart(Session["username"].ToString());
			Server.Transfer("ThankYou.aspx");
			
		}
		public void WriteOrder(string company, string[] itemType, string[] itemID, 
			string[] itemName, int[] qty, string shippingMethod, string streetAddr, 
			string city, string state, string zip, string phoneNum, string faxNum)
		{
			/* create order xml */
			string order = "<order><issuingCompany>fsycpf</issuingCompany><partnerCompany>" + company + "</partnerCompany>";
			// Append the products
			for(int i = 0; i<itemID.Length;i++)
			{
				order += "<product><type>" + itemType[i] + "</type>" +
					"<identifier>" + itemID[i] + "</identifier>" +
					"<name>" + itemName[i] + "</name>" +
					"<quantity>" + qty[i] + "</quantity>" + 
					"</product>";
			}
			// Append shipping method
			order += "<shippingMethod>" + shippingMethod + "</shippingMethod>";
			// Append customer's address
			if( faxNum == null ) faxNum = "";
			order += "<destination>" + 
				"<address>" + streetAddr + "</address>" +
				"<city>" + city + "</city>" +
				"<state>" + state + "</state>" +
				"<zip>" + zip + "</zip>" +
				"<contact>" +
				"<tel>" + phoneNum + "</tel>" +
				"<fax>" + faxNum + "</fax>" +
				"</contact>" +
				"</destination>" +
				"</order>";

			Random r = new Random(order.GetHashCode());

			int id = r.Next(0,10000);

			/* output the xml to file */
			string file = Server.MapPath(".\\orders\\") + company + "-" + id.ToString() + ".xml";
			StreamWriter output = new StreamWriter(file);
			output.Write(order);
			output.Flush();
		}

		private void GetCreditInfo()
		{
			string username = Session["username"].ToString();

			string sqlStr = " SELECT creditcardtype, creditcardnumber " +
				" FROM phil60_shipping.dbo.invoices " +
				" WHERE buyerid = '" + username + "' ";

			string sqlString = "server=IISQLSRV; uid=triroot; pwd=changeME";
			SqlConnection sqlConn = new SqlConnection(sqlString);
			sqlConn.Open();

			SqlCommand sqlCom = new SqlCommand(sqlStr, sqlConn);
			SqlDataReader sqlRdr = sqlCom.ExecuteReader();

			sqlRdr.Read();
			if (sqlRdr.HasRows)
			{
				CreditTypeBox.Text = sqlRdr.GetValue(0).ToString();
				CreditNumberBox.Text = sqlRdr.GetValue(1).ToString();
			}

			sqlRdr.Close();
			sqlConn.Close();
		}

		private void AddInvoice(object[] order, Hashtable cost)
		{
			decimal price = 0;
			decimal discount = 0;
			decimal shipping = 0;
			/*
			for(int i=0;i<cost.Count;i++)
			{
				object[] currCompanyCost = (object[]) cost[i];
				price += (decimal) currCompanyCost[0];
				discount += (decimal) currCompanyCost[1];
				shipping += (decimal) currCompanyCost[2];
			}
			*/
			IDictionaryEnumerator enumer = cost.GetEnumerator();
			while(enumer.MoveNext())
			{
				decimal[] currCompanyCost = (decimal[]) cost[(string)enumer.Key];
				price += currCompanyCost[0];
				discount += currCompanyCost[1];
				shipping += currCompanyCost[2];
			}
			string invoiceID = GetNextInvoiceID().ToString();
			string purchaseDate = DateTime.Now.ToString("d");
			string addressID = Session["addressID"].ToString(); //(string) order[6];  
			string username = Session["username"].ToString();
			string methodofshipping = (string) order[5];  //ShipOptionList.SelectedItem.Text;
			string priceOfItems = price.ToString();
			string discounts = discount.ToString();
			decimal priceAfterDisc = price - discount;
			string tax = ((decimal)priceAfterDisc*(decimal)0.09).ToString();
			string shippingCost = shipping.ToString();
			string totalPrice = (priceAfterDisc + shipping).ToString();
			string creditCardType = CreditTypeBox.Text;
			string paymentType = PaymentList.SelectedItem.Text;
			string creditCardNum = CreditNumberBox.Text;
			
			SqlMoney.Parse(totalPrice);
			SqlMoney.Parse(priceOfItems);
			SqlMoney.Parse(discounts);
			SqlMoney.Parse(tax);
			SqlMoney.Parse(shippingCost);

			System.Diagnostics.Debug.WriteLine(" VALUES (" + invoiceID + "," + SqlDateTime.Parse(purchaseDate) + "," + addressID + ",'" + username + "','" + methodofshipping + "'," + SqlMoney.Parse(totalPrice) + ",'" + 
				creditCardType + "','" + paymentType + "','" + creditCardNum + "'," + SqlMoney.Parse(priceOfItems) + "," + SqlMoney.Parse(discounts) + "," + SqlMoney.Parse(tax) + "," + SqlMoney.Parse(shippingCost) + ") ");

			string sqlStr = " INSERT INTO phil60_shipping.dbo.invoices " +
				" VALUES (" + invoiceID + ",'" + purchaseDate + "'," + addressID + ",'" + username + "','" + methodofshipping + "'," + SqlMoney.Parse(totalPrice) + ",'" + 
				creditCardType + "','" + paymentType + "','" + creditCardNum + "'," + SqlMoney.Parse(priceOfItems) + "," + SqlMoney.Parse(discounts) + "," + SqlMoney.Parse(tax) + "," + SqlMoney.Parse(shippingCost) + ") ";
			
			QueryHelper.ExecuteNonQuery(sqlStr);

			AddItemsToDB(invoiceID, purchaseDate);
			RemoveAllFromStock();
		}

		private void RemoveAllFromStock()
		{
			IDictionaryEnumerator enu = packages.GetEnumerator();

			while (enu.MoveNext())
			{
				ArrayList curPackageList = (ArrayList)enu.Value;
				foreach (Object[] package in curPackageList)
				{
					RemoveFromStock(enu.Key.ToString(), package[0].ToString(), package[1].ToString());
				}
			}
		}
		private void RemoveFromStock(string warehouseID, string itemID, string quantity)
		{
			string sqlQuery;
			sqlQuery = "UPDATE craigatk_inventory.dbo.stock " +
				" SET craigatk_inventory.dbo.stock.NumStock = craigatk_inventory.dbo.stock.NumStock - " + quantity +
				" WHERE craigatk_inventory.dbo.stock.warehouseID = " + warehouseID + " AND craigatk_inventory.dbo.stock.itemID = '" + itemID + "' ";

			QueryHelper.ExecuteQuery(sqlQuery);
		}

		/*private void AddItemsToDB(string invoiceID, string shipDate)
		{
			IDictionaryEnumerator enu = packages.GetEnumerator();

			while (enu.MoveNext())
			{
				ArrayList curPackageList = (ArrayList)enu.Value;
				foreach (Object[] package in curPackageList)
				{
					//RemoveFromStock(enu.Key.ToString(), package[0].ToString(), package[1].ToString());

					string itemID = package[0].ToString();
					string name = "";
					string price = "";

					string sqlStr = "SELECT  Distinct Case WHEN Products.ItemType = 'Book' THEN " +
						"Books.Title ELSE CDs.Title END as Title, Case WHEN Products.ItemType = 'Book' THEN " +
						"Books.Price ELSE CDs.Price END as Price " +
						"FROM craigatk_inventory.dbo.Products as Products, craigatk_inventory.dbo.CDs as CDs, " +
						"craigatk_inventory.dbo.Books as Books " +
						"WHERE (Products.ItemID = CDs.ID OR " +
						"Books.ISBN = Products.ItemID) AND " +
						"Products.ItemID = '" + itemID + "' ";

					string sqlString = "server=IISQLSRV; uid=triroot; pwd=changeME";
					SqlConnection sqlConn = new SqlConnection(sqlString);
					sqlConn.Open();

					SqlCommand sqlCom = new SqlCommand(sqlStr, sqlConn);
					SqlDataReader sqlRdr = sqlCom.ExecuteReader();

					sqlRdr.Read();
					if (sqlRdr.HasRows)
					{
						name = sqlRdr.GetValue(0).ToString();
						name = name.Replace("'","''");
						price = sqlRdr.GetValue(1).ToString();
					}

					sqlRdr.Close();
					sqlConn.Close();

					string strSql = " INSERT INTO phil60_shipping.dbo.items " +
						" VALUES ('" + itemID + "'," + invoiceID + ",'" + name + "'," + SqlMoney.Parse(price) + "," + package[1].ToString() + "," + 
						enu.Key.ToString() + ",'" + shipDate + "'," + GetNextTrackingNum() + ") ";

					System.Diagnostics.Debug.WriteLine(" VALUES ('" + itemID + "'," + invoiceID + ",'" + name + "'," + SqlMoney.Parse(price) + "," + package[1].ToString() + "," + 
						enu.Key.ToString() + ",'" + shipDate + "') ");
						
					QueryHelper.ExecuteNonQuery(strSql);
				}
			}
		}*/
		private void AddItemsToDB(string invoiceID, string shipDate)
		{
			IDictionaryEnumerator enu = packages.GetEnumerator();

			while (enu.MoveNext())
			{
				ArrayList curPackageList = (ArrayList)enu.Value;
				foreach (Object[] package in curPackageList)
				{
					string itemID = package[0].ToString();
					string quantity = package[1].ToString();
					string warehouseID = enu.Key.ToString();
					string name = "";
					string price = "";
					string weight = "";
					//string instructions = InstructionBox.Text;
					string addressID = Session["addressID"].ToString();
					string shipMethodID = Session[warehouseID].ToString();

					string sqlStr = "SELECT  Distinct Case WHEN Products.ItemType = 'Book' THEN " +
						"Books.Title ELSE CDs.Title END as Title, Case WHEN Products.ItemType = 'Book' THEN " +
						"Books.Price ELSE CDs.Price END as Price, Case WHEN Products.ItemType = 'Book' THEN " +
						"Books.Weight ELSE CDs.Weight END as Weight " +
						"FROM craigatk_inventory.dbo.Products as Products, craigatk_inventory.dbo.CDs as CDs, " +
						"craigatk_inventory.dbo.Books as Books " +
						"WHERE (Products.ItemID = CDs.ID OR " +
						"Books.ISBN = Products.ItemID) AND " +
						"Products.ItemID = '" + itemID + "' ";

					string sqlString = "server=IISQLSRV; uid=triroot; pwd=changeME";
					SqlConnection sqlConn = new SqlConnection(sqlString);
					sqlConn.Open();

					SqlCommand sqlCom = new SqlCommand(sqlStr, sqlConn);
					SqlDataReader sqlRdr = sqlCom.ExecuteReader();

					sqlRdr.Read();
					if (sqlRdr.HasRows)
					{
						name = sqlRdr.GetValue(0).ToString();
						name = name.Replace("'","''");
						price = sqlRdr.GetValue(1).ToString();
						weight = sqlRdr.GetValue(2).ToString();
					}

					sqlRdr.Close();
					sqlConn.Close();

					int trackingNum = GetNextTrackingNum();

					string strSql = " INSERT INTO phil60_shipping.dbo.items " +
						" VALUES ('" + itemID + "'," + invoiceID + ",'" + name + "'," + SqlMoney.Parse(price) + "," + quantity + "," + 
						warehouseID + ",'" + shipDate + "'," + trackingNum + ") ";

					QueryHelper.ExecuteNonQuery(strSql);

					string strSql2 = " INSERT INTO triroot_shipping.dbo.packages " +
						" VALUES (" + trackingNum + "," + invoiceID + "," + weight + "," + quantity + "," + shipMethodID + ",'" +
						/*instructions*/"" + "'," + warehouseID + "," + addressID + ",'" + shipDate + "','" +DateTime.Now.AddDays(GetMaxTime(shipMethodID)).ToString("d") + 
						"','Sent to warehouse')";

					System.Diagnostics.Debug.WriteLine(strSql2);

					QueryHelper.ExecuteNonQuery(strSql2);			
				}
			}
		}

		// Returns the max time for the given shipping method
		private int GetMaxTime(string shipMethodID)
		{
			int maxTime;
			string sqlStr = " SELECT maxTime " +
				" FROM triroot_shipping.dbo.methods " +
				" WHERE methodID = " + shipMethodID;

			string sqlString = "server=IISQLSRV; uid=triroot; pwd=changeME";
			SqlConnection sqlConn = new SqlConnection(sqlString);
			sqlConn.Open();

			SqlCommand sqlCom = new SqlCommand(sqlStr, sqlConn);
			SqlDataReader sqlRdr = sqlCom.ExecuteReader();

			sqlRdr.Read();

			if (sqlRdr.HasRows)
				maxTime = Int32.Parse(sqlRdr.GetValue(0).ToString());
			else
				maxTime = 0;

			sqlRdr.Close();
			sqlConn.Close();

			return maxTime;
		}

		private int GetNextInvoiceID()
		{
			int id;
			string sqlStr = " SELECT invoiceID " +
				" FROM phil60_shipping.dbo.invoices " +
				" ORDER BY invoiceID DESC ";

			string sqlString = "server=IISQLSRV; uid=triroot; pwd=changeME";
			SqlConnection sqlConn = new SqlConnection(sqlString);
			sqlConn.Open();

			SqlCommand sqlCom = new SqlCommand(sqlStr, sqlConn);
			SqlDataReader sqlRdr = sqlCom.ExecuteReader();

			sqlRdr.Read();
			if (sqlRdr.HasRows)
			{
				id = Int32.Parse(sqlRdr.GetValue(0).ToString()) + 1;
			}
			else
			{
				id = 1;
			}

			sqlRdr.Close();
			sqlConn.Close();

			return id;
		}

		// Returns a tracking number 1 greater than the highest current one
		private int GetNextTrackingNum()
		{
			int id;
			string sqlStr = " SELECT packageNum " +
				" FROM phil60_shipping.dbo.items " +
				" ORDER BY packageNum DESC ";

			string sqlString = "server=IISQLSRV; uid=triroot; pwd=changeME";
			SqlConnection sqlConn = new SqlConnection(sqlString);
			sqlConn.Open();

			SqlCommand sqlCom = new SqlCommand(sqlStr, sqlConn);
			SqlDataReader sqlRdr = sqlCom.ExecuteReader();

			sqlRdr.Read();
			if (sqlRdr.HasRows)
			{
				id = Int32.Parse(sqlRdr.GetValue(0).ToString()) + 1;
			}
			else
			{
				id = 1;
			}

			sqlRdr.Close();
			sqlConn.Close();

			return id;
		}
	}
}
