using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlTypes;
using System.Data.SqlClient;

namespace cse444project
{
	/// <summary>
	/// Summary description for PartnerOrder.
	/// </summary>
	public class PartnerOrder : Template
	{
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Label PartnerNameLabel;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.Button OptionButton;
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.Label Label3;
		protected System.Web.UI.WebControls.Label Label4;
		protected System.Web.UI.WebControls.Label Label5;
		protected System.Web.UI.WebControls.Label Label6;
		protected System.Web.UI.WebControls.Label Label7;
		protected System.Web.UI.WebControls.Label Label8;
		protected System.Web.UI.WebControls.Label PriceLabel;
		protected System.Web.UI.WebControls.Label DiscountLabel;
		protected System.Web.UI.WebControls.Label ShippingLabel;
		protected System.Web.UI.WebControls.Label TaxLabel;
		protected System.Web.UI.WebControls.Label TotalLabel;
		protected System.Web.UI.WebControls.DropDownList ShipOptionList;
	
		protected System.Web.UI.WebControls.Button ContinueButton;
		protected System.Web.UI.WebControls.Button AddrBtn;
		protected System.Web.UI.WebControls.TextBox InstructionBox;
		protected System.Web.UI.WebControls.Label Label9;
		protected System.Web.UI.WebControls.TextBox AddrBox;
		protected System.Web.UI.WebControls.TextBox CityBox;
		protected System.Web.UI.WebControls.TextBox StateBox;
		protected System.Web.UI.WebControls.TextBox ZipBox;
		protected System.Web.UI.WebControls.TextBox NameBox;
		protected System.Web.UI.WebControls.TextBox PhoneBox;
		protected System.Web.UI.WebControls.Label Label10;
		protected System.Web.UI.WebControls.Label Label11;
		protected System.Web.UI.WebControls.Label Label12;
		protected System.Web.UI.WebControls.Label Label13;
		protected System.Web.UI.WebControls.Label Label14;
		protected System.Web.UI.WebControls.Label Label15;
		protected System.Web.UI.WebControls.Button ShowButton;
		protected System.Web.UI.WebControls.Button ChangeAddrButton;

		private string partnerName;
		private ArrayList ItemArray;
		private decimal[] prices = new decimal[3];
		private object[] package;
		private string[] address = new string[7];
		protected System.Web.UI.WebControls.Label DropLabel;
		protected System.Web.UI.WebControls.Button DropButton;
		private string username;

		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				username = Session.Contents["username"].ToString();
			}
			catch(Exception)
			{
				Server.Transfer("Login.aspx");
			}
			// Put user code to initialize the page here
			ArrayList companies = (ArrayList)Session["ShipCompanies"];
			if(companies.Count > 0)
			{
				//IDictionaryEnumerator enumer = companies.GetEnumerator();
				//enumer.MoveNext();
				//partnerName = (string)enumer.Value;
				partnerName = (string)companies[0];
				System.Diagnostics.Debug.WriteLine(partnerName);
			}
			else
			{
				Server.Transfer("Checkout.aspx");
			}
			PartnerNameLabel.Text = partnerName;
			//setAddr();
			GetPackage();

			DropLabel.Visible = false;
			DropButton.Visible = false;

			ShipOptionList.Visible = false;
			OptionButton .Visible = false;
			Label2.Visible = false;

			Label4.Visible = false;
			Label5.Visible = false;
			Label6.Visible = false;
			Label7.Visible = false;
			Label8.Visible = false;
			PriceLabel.Visible = false;
			DiscountLabel.Visible = false;
			ShippingLabel.Visible = false;
			TaxLabel.Visible = false;
			TotalLabel.Visible = false;
			ContinueButton.Visible = false;
			ContinueButton.Enabled = false;
		}

		private void GetPackage()
		{
			string userName = (string)Session["username"];

			string sqlstr = "SELECT C.itemID, P.itemType, " +
				"Case When P.itemType = 'Book' Then B.title Else CD.title END As 'Title', "+
				"C.qty, "+
				"Case When P.itemType = 'Book' Then B.price  Else CD.price END As 'Price per Unit', "+
				"Case When P.itemType = 'Book' Then B.weight Else CD.weight END As 'Weight per Unit', "+
				"Case When D.discount is Null Then 0 Else D.discount End As 'Discount' "+
				"FROM phil60_shipping.dbo.ShoppingCartItems C "+
				"INNER JOIN phil60_shipping.dbo.Customers U "+
					"ON C.userName = U.username "+
				"LEFT JOIN craigatk_inventory.dbo.Products P "+
					"ON C.itemId = P.itemID AND C.company = P.company "+
				"LEFT JOIN craigatk_inventory.dbo.Books B "+
					"ON B.ISBN = P.itemID AND B.company = P.company "+
				"LEFT JOIN craigatk_inventory.dbo.CDs CD "+
					"ON CD.Id = P.itemID AND CD.company = P.company "+
				"LEFT JOIN craigatk_inventory.dbo.Discounts D "+
					"ON D.itemID = P.itemID AND D.company = P.company "+
				"WHERE C.username = '"+userName+"' " +
			//"AND CD.company = '"/*+partnerName*/+"fsycpf' "+ 
			//"AND B.company = '"/*+partnerName*/+"fsycpf' "+ 
			"AND P.company = '"+partnerName+"' ";

			DataSet ds = QueryHelper.ExecuteQuery(sqlstr);
			DataGrid1.DataSource = ds;
			DataGrid1.DataBind();
			DataGrid1.Visible = true;

			DataTable data = ds.Tables[0]; //the query Row Collection
			object[] package = new object[4];
			package[0] = (int)0;
			package[1] = (decimal)0;
			package[2] = (decimal)0;
			package[3] = (decimal)0;

			ArrayList Items = new ArrayList();
			object[] item = new object[4];
			IEnumerator enumer = data.Rows.GetEnumerator();
			while(enumer.MoveNext())
			{
				string itemId = (string)((DataRow)enumer.Current)[0];
				string type = (string)((DataRow)enumer.Current)[1];
				string title = (string)((DataRow)enumer.Current)[2];
				int need = (int)((DataRow)enumer.Current)[3];
				decimal priceUnit = (decimal)((DataRow)enumer.Current)[4];
				decimal weightUnit = (decimal)((DataRow)enumer.Current)[5];
				decimal discount = (decimal)(((DataRow)enumer.Current)[6]);

				item[0] = type;
				item[1] = itemId;
				item[2] = title;
				item[3] = need;
				Items.Add(item);

				package[0] = (int)package[0]+ need;
				package[1] = (decimal)package[1]+ priceUnit*(decimal)need;
				package[2] = (decimal)package[2]+ weightUnit*(decimal)need;
				package[3] = (decimal)package[3]+ discount*(decimal)need;
			}
			this.package = package;
			ItemArray = Items;
		}

		private void OfferShippingOptions()
		{
			ArrayList options = null;
			ShipOptionList.Items.Clear();

			string sqlstr = "Select distinct M.shipOption "+
				"From triroot_shipping.dbo.Methods M, triroot_shipping.dbo.RestrictedCities R, "+
				"triroot_shipping.dbo.Vendors V "+
				"Where M.methodID = R.shippingMethod "+
				"And M.company = '"+partnerName+"' "+ 
				"And V.name = M.vendor " +
				//"And W.warehouseID = " + (int)x.Key + " "+
				"And R.city = '"+CityBox.Text+"' "+
				//"And R.state = '"+StateBox.Text+"' "+
				"And (M.priceUnit = 'fixed' "+
				"OR (M.priceUnit = 'pounds' AND "+(decimal)package[2]+" <= M.maxWeight) "+
				"OR (M.priceUnit = 'item' AND "+(int)package[0]+" <= M.maxUnit)) ";
				
			DataSet ds = QueryHelper.ExecuteQuery(sqlstr);
			DataTable data = ds.Tables[0]; //the query Row Collection

			options = new ArrayList();
			IEnumerator enumer = data.Rows.GetEnumerator();
			while(enumer.MoveNext())
			{
				string option = (string)((DataRow)enumer.Current)[0];
				options.Add(option);
			}
			
			IEnumerator ienum = options.GetEnumerator();
			while(ienum.MoveNext())
			{
				string option = (string)ienum.Current;
				if(!ShipOptionList.Items.Contains(new ListItem(option)))
					ShipOptionList.Items.Add(option);
			}
		}


		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.AddrBtn.Click += new System.EventHandler(this.AddrBtn_Click);
			this.OptionButton.Click += new System.EventHandler(this.OptionButton_Click);
			this.ContinueButton.Click += new System.EventHandler(this.ContinueButton_Click);
			this.ChangeAddrButton.Click += new System.EventHandler(this.ChangeAddrButton_Click);
			this.ShowButton.Click += new System.EventHandler(this.ShowButton_Click);
			this.DropButton.Click += new System.EventHandler(this.DropButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void OptionButton_Click(object sender, System.EventArgs e)
		{
			System.Diagnostics.Debug.WriteLine(ShipOptionList.SelectedItem.Text);
			Label4.Visible = true;
			Label5.Visible = true;
			Label6.Visible = true;
			Label7.Visible = true;
			Label8.Visible = true;
			PriceLabel.Visible = true;
			DiscountLabel.Visible = true;
			ShippingLabel.Visible = true;
			TaxLabel.Visible = true;
			TotalLabel.Visible = true;
			ContinueButton.Visible = true;
			ContinueButton.Enabled = true;

			ShipOptionList.Visible = true;
			OptionButton.Visible = true;
			Label2.Visible = true;

			string option = ShipOptionList.SelectedItem.Text;
			decimal weight = (decimal)package[2];
			int items = (int)package[0];

			string strSql = "SELECT '"+option+"' As 'Option', M.vendor, M.priceUnit, M.Maxtime As 'Days of Delivery', M.Price As 'PerUnit', "+
				"Case When M.priceUnit = 'fixed' Then M.price Else  "+
				"Case When M.priceUnit = 'Item' Then M.price*"+items+" Else M.price*"+weight+" End End As 'TotalPrice', M.methodID "+
				"From triroot_shipping.dbo.Methods M, triroot_shipping.dbo.RestrictedCities R,  "+
				"triroot_shipping.dbo.Vendors V  "+
				"Where M.methodID = R.shippingMethod  "+
				"And M.shipOption = '"+option+"' "+
				"And V.name = M.vendor  "+
				"And M.company = '"+partnerName+"' " + //ADDITION FOR PHASE III
				"And R.city = '"+CityBox.Text+"'  "+
				//"And R.state = '"+StateBox.Text+"'  "+
				"And (M.priceUnit = 'fixed'  "+
				"OR (M.priceUnit = 'pounds' AND "+items+" <= M.maxWeight)  "+
				"OR (M.priceUnit = 'item' AND "+weight+" <= M.maxUnit))  "+
				"Order By TotalPrice ";
			DataTable dt = QueryHelper.ExecuteQuery(strSql).Tables[0];
			DataRow dr = dt.Rows[0];
			
			PriceLabel.Text = package[1].ToString();
			DiscountLabel.Text = package[3].ToString();
			ShippingLabel.Text = dr[5].ToString();
			decimal tax = (((decimal)package[1]-(decimal)package[3])*(decimal).09);
			if (tax < 0)
				tax = (decimal)0;
			TaxLabel.Text = tax.ToString();
			TotalLabel.Text = ((decimal)package[1]-(decimal)package[3]+tax).ToString();

			prices[0] = (decimal)package[1];
			prices[1] = (decimal)package[3];
			prices[2] = (decimal)dr[5];
			System.Diagnostics.Debug.WriteLine("0: "+prices[0]+" 1: "+prices[1]+" 2: "+prices[2]);
			Hashtable[] info = (Hashtable[])Session["InvoiceInfo"];
			if(info[1].Contains(partnerName))
				info[1].Remove(partnerName);
			info[1].Add(partnerName, prices);
		}

		private void ShipOptionList_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		}

		private void ContinueButton_Click(object sender, System.EventArgs e)
		{
			string company = partnerName;
			int size = ItemArray.Count;
			string[] itemType = new string[size];
			string[] itemID = new string[size];
			string[] itemName = new string[size];
			int[] qty = new int[size];
			IEnumerator enumer = ItemArray.GetEnumerator();
			int i = 0;
			while(enumer.MoveNext())
			{
				itemType[i] = (string)((object[])enumer.Current)[0];
				itemID[i] = (string)((object[])enumer.Current)[1];
				itemName[i] = (string)((object[])enumer.Current)[2];
				qty[i] = (int)((object[])enumer.Current)[3];
				i++;
			}

			address[0] = ShipOptionList.SelectedItem.Text;
			address[1] = AddrBox.Text;
			address[2] = CityBox.Text;
			address[3] = StateBox.Text;
			address[4] = ZipBox.Text;
			address[5] = PhoneBox.Text;
			address[6] = "";

			string shippingMethod = address[0];
			string streetAddr = address[1];
			string city = address[2];
			string state = address[3];
			string zip = address[4];
			string phoneNum = address[5];
			string faxNum = address[6];
			
			object[] order = new object[12];
			order[0] = company;
			order[1] = itemType;
			order[2] = itemID;
			order[3] = itemName;
			order[4] = qty;
			order[5] = shippingMethod;
			order[6] = streetAddr;
			order[7] = city;
			order[8] = state;
			order[9] = zip;
			order[10] = phoneNum;
			order[11] = faxNum;
			
			Hashtable[] info = (Hashtable[])Session["InvoiceInfo"];
			if(info[0].Contains(partnerName))
				info[0].Remove(partnerName);
			info[0].Add(partnerName, order);

			((ArrayList)Session["ShipCompanies"]).Remove(partnerName);
			Server.Transfer("PartnerOrder.aspx");
		}

		private void AddrBtn_Click(object sender, System.EventArgs e)
		{
			setAddr();
		}

		private void setAddr()
		{
			//System.Diagnostics.Debug.WriteLine("lkajsdfiiaosfdj");
			string username = Session["username"].ToString();

			string sqlStr = " SELECT homephone, firstname, lastname, streetaddress, city, state, zip, addressID " +
				" FROM phil60_shipping.dbo.addresses, phil60_shipping.dbo.customers  " +
				" WHERE phil60_shipping.dbo.addresses.username = '" + username + "' AND phil60_shipping.dbo.customers.username = '" + username + "' ";

			string sqlString = "server=IISQLSRV; uid=triroot; pwd=changeME";
			SqlConnection sqlConn = new SqlConnection(sqlString);
			sqlConn.Open();

			SqlCommand sqlCom = new SqlCommand(sqlStr, sqlConn);
			SqlDataReader sqlRdr = sqlCom.ExecuteReader();

			sqlRdr.Read();
			if (sqlRdr.HasRows)
			{
				PhoneBox.Text = sqlRdr.GetValue(0).ToString();
				NameBox.Text = sqlRdr.GetValue(1).ToString() + " " + sqlRdr.GetValue(2);
				AddrBox.Text = sqlRdr.GetValue(3).ToString();
				CityBox.Text = sqlRdr.GetValue(4).ToString();
				StateBox.Text = sqlRdr.GetValue(5).ToString();
				ZipBox.Text = sqlRdr.GetValue(6).ToString();

				Session.Add("addressID", sqlRdr.GetValue(7).ToString());
			}

			sqlRdr.Close();
			sqlConn.Close();
		}

		private void ChangeAddrButton_Click(object sender, System.EventArgs e)
		{
			Label4.Visible = false;
			Label5.Visible = false;
			Label6.Visible = false;
			Label7.Visible = false;
			Label8.Visible = false;
			PriceLabel.Visible = false;
			DiscountLabel.Visible = false;
			ShippingLabel.Visible = false;
			TaxLabel.Visible = false;
			TotalLabel.Visible = false;
			ContinueButton.Visible = false;
			ContinueButton.Enabled = false;

			ShowButton.Visible = true;
			ShipOptionList.Visible = false;
			OptionButton.Visible = false;
			Label2.Visible = false;

			address[0] = ShipOptionList.SelectedItem.Text;
			address[1] = AddrBox.Text;
			address[2] = CityBox.Text;
			address[3] = StateBox.Text;
			address[4] = ZipBox.Text;
			address[5] = PhoneBox.Text;
			address[6] = "";

			OfferShippingOptions();
		}

		private void ShowButton_Click(object sender, System.EventArgs e)
		{
			OfferShippingOptions();
			if(ShipOptionList.Items.Count == 0)
			{
				DropLabel.Visible = true;
				DropButton.Visible = true;
			}
			else
			{
				ShowButton.Visible = false;
				ShipOptionList.Visible = true;
				OptionButton.Visible = true;
				Label2.Visible = true;
			}
		}

		private void DropButton_Click(object sender, System.EventArgs e)
		{
			Hashtable[] info = (Hashtable[])Session["InvoiceInfo"];
			if(info[0].Contains(partnerName))
				info[0].Remove(partnerName);
			if(info[1].Contains(partnerName))
				info[1].Remove(partnerName);
			((ArrayList)Session["ShipCompanies"]).Remove(partnerName);
			Server.Transfer("PartnerOrder.aspx");
		}
		
	}
}
