using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlTypes;
using System.Data.SqlClient;

namespace cse444project
{
	/// <summary>
	/// Summary description for Transaction.
	/// </summary>
	public class Transaction : Template
	{
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.Label Label3;
		protected System.Web.UI.WebControls.Label Label4;
		protected System.Web.UI.WebControls.Label Label5;
		protected System.Web.UI.WebControls.Label Label6;
		protected System.Web.UI.WebControls.Label Label7;
		protected System.Web.UI.WebControls.TextBox CreditNumberBox;
		protected System.Web.UI.WebControls.Label TotalLabel;
		protected System.Web.UI.WebControls.Label ShippingLabel;
		protected System.Web.UI.WebControls.Label TaxLabel;
		protected System.Web.UI.WebControls.Label DiscountLabel;
		protected System.Web.UI.WebControls.TextBox PhoneBox;
		protected System.Web.UI.WebControls.TextBox NameBox;
		protected System.Web.UI.WebControls.TextBox ZipBox;
		protected System.Web.UI.WebControls.TextBox StateBox;
		protected System.Web.UI.WebControls.TextBox CityBox;
		protected System.Web.UI.WebControls.TextBox AddrBox;
		protected System.Web.UI.WebControls.TextBox InstructionBox;
		protected System.Web.UI.WebControls.DataGrid DataGrid;
		protected System.Web.UI.WebControls.Button ContinueButton;
		protected System.Web.UI.WebControls.DropDownList ShipOptionList;
		protected System.Web.UI.WebControls.Label PriceLabel;
		protected System.Web.UI.WebControls.Button PayButton;
		protected System.Web.UI.WebControls.DropDownList PaymentList;
		protected System.Web.UI.WebControls.Label LabelA4;
		protected System.Web.UI.WebControls.Label LabelA3;
		protected System.Web.UI.WebControls.Label LabelA2;
		protected System.Web.UI.WebControls.Label LabelA9;
		protected System.Web.UI.WebControls.Label LabelA8;
		protected System.Web.UI.WebControls.Label LabelA7;
		protected System.Web.UI.WebControls.Label LabelA6;
		protected System.Web.UI.WebControls.Label LabelA1;
		protected System.Web.UI.WebControls.Label LabelA5;
		protected System.Web.UI.WebControls.TextBox CreditTypeBox;
		protected System.Web.UI.WebControls.Button OptionButton;
		protected System.Web.UI.WebControls.Button AddrBtn;

		private Hashtable packages;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			string username = "";
			// IF the user Isn't logged in, throw him to the login page
			try
			{
				username = Session.Contents["username"].ToString();
			}
			catch(Exception)
			{
				Server.Transfer("Login.aspx");
			}

			if (!CheckCart())
				Server.Transfer("Browse.aspx");
			
			string sqlstr ="Select distinct company " +
							"From phil60_shipping.dbo.ShoppingCartItems " +
							"Where username = '"+username+"' ";

			ArrayList companies = new ArrayList();
			DataSet ds = QueryHelper.ExecuteQuery(sqlstr);
			DataTable data = ds.Tables[0];
			IEnumerator enumer = data.Rows.GetEnumerator();
			while(enumer.MoveNext())
			{
				string company = (string)((DataRow)enumer.Current)[0];
				companies.Add(company);
			}
			
            Session.Add("ShipCompanies", companies);

			if(!companies.Contains("fsycpf"))
			{
				Hashtable[] info = new Hashtable[2];
				info[0] = new Hashtable();
				info[1] = new Hashtable();
				Session.Add("InvoiceInfo", info);
				Session.Remove("packages");
				Server.Transfer("PartnerOrder.aspx");
			}

			packages = (Hashtable)Session["packages"];
			if(packages == null)
				packages = new Hashtable();
			// Put user code to initialize the page here
		}

		// Checks to see if the user has any items in his or her cart
		private bool CheckCart()
		{
			string username = Session["username"].ToString();
			bool val;

			string sqlStr = " SELECT * " +
				" FROM phil60_shipping.dbo.shoppingcartitems " +
				" WHERE username = '" + username + "'";

			string sqlString = "server=IISQLSRV; uid=triroot; pwd=changeME";
			SqlConnection sqlConn = new SqlConnection(sqlString);
			sqlConn.Open();

			SqlCommand sqlCom = new SqlCommand(sqlStr, sqlConn);
			SqlDataReader sqlRdr = sqlCom.ExecuteReader();

			sqlRdr.Read();
			if (sqlRdr.HasRows)
			{
				val = true;
			}
			else
			{
				val = false;
			}

			sqlRdr.Close();
			sqlConn.Close();

			return val;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ContinueButton.Click += new System.EventHandler(this.ContinueButton_Click);
			this.ShipOptionList.SelectedIndexChanged += new System.EventHandler(this.ShipOptionList_SelectedIndexChanged);
			this.PayButton.Click += new System.EventHandler(this.PayButton_Click);
			this.OptionButton.Click += new System.EventHandler(this.OptionButton_Click);
			this.AddrBtn.Click += new System.EventHandler(this.AddrBtn_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void OfferShippingOptions()
		{
			ArrayList options = null;
			ShipOptionList.Items.Clear();
			IDictionaryEnumerator x = packages.GetEnumerator();
			while(x.MoveNext())
			{
				ArrayList package = (ArrayList)x.Value;
				object[] packInfo = packageItemsPriceWeightDiscount(package);
				string sqlstr = "Select distinct M.shipOption "+
					"From triroot_shipping.dbo.Methods M, triroot_shipping.dbo.RestrictedCities R, "+
						"triroot_shipping.dbo.VendorWarehouses W, triroot_shipping.dbo.Vendors V "+
					"Where M.methodID = R.shippingMethod "+
							"And M.company = '"/*+partnerName*/+"fsycpf' "+ //ADDITION FOR PHASE III
							"And V.name = W.vendor " +
							"And V.name = M.vendor " +
							"And W.warehouseID = " + (int)x.Key + " "+
							"And R.city = '"+CityBox.Text+"' "+
							"And R.state = '"+StateBox.Text+"' "+
							"And (M.priceUnit = 'fixed' "+
								"OR M.priceUnit = 'pounds' AND "+(decimal)packInfo[2]+" <= M.maxWeight "+
								"OR M.priceUnit = 'item' AND "+(int)packInfo[0]+" <= M.maxUnit) ";
				
				DataSet ds = QueryHelper.ExecuteQuery(sqlstr);
				DataTable data = ds.Tables[0]; //the query Row Collection

				ArrayList TempList = new ArrayList();
				IEnumerator enumer = data.Rows.GetEnumerator();
				while(enumer.MoveNext())
				{
					string option = (string)((DataRow)enumer.Current)[0];
					TempList.Add(option);
				}
				if(options == null)
					options = TempList;
				else
				{
					for (int i = options.Count - 1; i >= 0; i--)
					{
						string oS = (string)options[i];
						if (!TempList.Contains(oS))
							options.Remove(oS);
					}
				}
			}
			IEnumerator ienum = options.GetEnumerator();
			while(ienum.MoveNext())
			{
				string option = (string)ienum.Current;
				if(!ShipOptionList.Items.Contains(new ListItem(option)))
					ShipOptionList.Items.Add(option);
			}
		}

		//returns int[total items in package, total price, total weight, total discount]
		private object[] packageItemsPriceWeightDiscount(ArrayList package)
		{
			object[] packInfo = new object[4];
			packInfo[0] = (int)0;
			packInfo[1] = (decimal)0;
			packInfo[2] = (decimal)0;
			packInfo[3] = (decimal)0;
			for(int i = 0; i < package.Count; i++)
			{
				packInfo[0] = (int)packInfo[0] + (int)((object[])package[i])[1];
				packInfo[1] = (decimal)packInfo[1] + (decimal)((object[])package[i])[2]*(int)((object[])package[i])[1];
				packInfo[2] = (decimal)packInfo[2] + (decimal)((object[])package[i])[3]*(int)((object[])package[i])[1];
				packInfo[3] = (decimal)packInfo[3] + (decimal)((object[])package[i])[4]*(int)((object[])package[i])[1];
			}
			return packInfo;
		}

		private void ContinueButton_Click(object sender, System.EventArgs e)
		{
			packages = new Hashtable();

			ShipOptionList.Visible = true;
			LabelA1.Visible = true;
			OptionButton.Visible = true;

			string mailZip = ZipBox.Text;
			string userName = (string)Session["username"];
			
			string sqlStr = "SELECT C.itemID, W.ID, S.NumStock, C.qty, "+
					"CASE WHEN S.NumStock >= C.qty THEN 1 ELSE 0 END 'QuantityIsInStock', "+
					"CASE WHEN W.Zip = '"+mailZip+"' THEN 1 ELSE 0 END 'WarehouseIsInSameCity', "+
					"(SELECT count(*) 'ItemsInStock' "+
						"FROM phil60_shipping.dbo.ShoppingCartItems Ca "+
							"INNER JOIN phil60_shipping.dbo.Customers Ua  "+
								"ON Ca.userName = Ua.username "+
							"LEFT JOIN craigatk_inventory.dbo.Stock Sa  "+
								"ON Ca.itemID = Sa.ItemID  "+
									"AND Sa.NumStock >= Ca.qty "+
							"LEFT JOIN craigatk_inventory.dbo.Warehouses Wa "+
								"ON Sa.WarehouseID = Wa.ID "+
						"WHERE Ca.username = '"+userName+"' "+
							"AND Wa.ID = S.WarehouseID) AS 'WarehouseItemsInStock', "+
					"Case When P.itemType = 'Book' Then B.price  Else CD.price END As 'Price', "+
					"Case When P.itemType = 'Book' Then B.weight Else CD.weight END As 'Weight', "+
					"Case When D.discount is Null Then 0 Else D.discount End "+
				"FROM phil60_shipping.dbo.ShoppingCartItems C "+
					"INNER JOIN phil60_shipping.dbo.Customers U "+
						"ON C.userName = U.username "+
					"LEFT JOIN craigatk_inventory.dbo.Stock S "+
						"ON C.itemID = S.ItemID "+
					"LEFT JOIN craigatk_inventory.dbo.Warehouses W "+
						"ON S.WarehouseID = W.ID "+
					"LEFT JOIN craigatk_inventory.dbo.Products P "+
						"ON C.itemId = P.itemID "+
					"LEFT JOIN craigatk_inventory.dbo.Books B "+
						"ON B.ISBN = P.itemID "+
					"LEFT JOIN craigatk_inventory.dbo.CDs CD "+
						"ON CD.Id = P.itemID "+
					"LEFT JOIN craigatk_inventory.dbo.Discounts D "+
						"ON D.itemID = P.itemID "+
				"WHERE C.username = '"+userName+"' "+
						//"And CD.company = '"/*+partnerName*/+"fsycpf' "+ //ADDITION FOR PHASE III
						//"And B.company = '"/*+partnerName*/+"fsycpf' "+  //ADDITION FOR PHASE III
						"And C.company = 'fsycpf' "+  //ADDITION FOR PHASE III
				"ORDER BY C.itemID, WarehouseItemsInStock DESC, QuantityIsInStock DESC, WarehouseIsInSameCity DESC";

			//store the data from the query
			DataSet ds = QueryHelper.ExecuteQuery(sqlStr);
			//store shopingcart data
			DataTable data = ds.Tables[0]; //the query Row Collection
			ArrayList package;

			IEnumerator enumer = data.Rows.GetEnumerator();
			bool enoughPackaged = true;
			string item = null;
			int needQty = -1;
			while(enumer.MoveNext())
			{
				string itemId = (string)((DataRow)enumer.Current)[0];
				int warehouse = (int)((DataRow)enumer.Current)[1];
				int stock = (int)((DataRow)enumer.Current)[2];
				int need = (int)((DataRow)enumer.Current)[3];
				decimal priceUnit = (decimal)((DataRow)enumer.Current)[7];
				decimal weightUnit = (decimal)((DataRow)enumer.Current)[8];
				decimal discount = (decimal)(((DataRow)enumer.Current)[9]);
	
				if(itemId != item)
				{
					if(enoughPackaged)
					{
						item = itemId;
						enoughPackaged = false;
						needQty = need;
					}
					else
					{
						Exception ex = new Exception("Error: Not enough Items in stock.");
						throw ex;
					}
				}
				
				if(!enoughPackaged)
				{
					if(packages.ContainsKey(warehouse))
						package = (ArrayList)packages[warehouse];
					else
						package = new ArrayList();
					object[] purchase = new object[5];
					purchase[0] = itemId;
					purchase[2] = priceUnit;
					purchase[3] = weightUnit;
					purchase[4] = discount;
					if(stock >= needQty)
					{
						purchase[1] = needQty;
						package.Add(purchase);
						if(!packages.ContainsKey(warehouse))
							packages.Add(warehouse, package);
						enoughPackaged = true;
					}
					else
					{
						if(stock > 0)
						{
							purchase[1] = stock;
							package.Add(purchase);
							needQty = needQty - stock;
							if(!packages.ContainsKey(warehouse))
								packages.Add(warehouse, package);
						}
					}
				}
			}

			OfferShippingOptions();
			Session.Add("packages", packages);
		}

		private DataRow cheapestShipping(int package, string option, int items, decimal weight, int warehouse)
		{
			string strSql = "Select "+package+" as 'Package', '"+option+"' As 'Option', M.vendor, M.priceUnit, M.Maxtime As 'Days of Delivery', M.Price As 'PerUnit', "+
								"Case When M.priceUnit = 'fixed' Then M.price Else  "+
									"Case When M.priceUnit = 'Item' Then M.price*"+items+" Else M.price*"+weight+" End End As 'TotalPrice', M.methodID "+
							"From triroot_shipping.dbo.Methods M, triroot_shipping.dbo.RestrictedCities R,  "+
								"triroot_shipping.dbo.VendorWarehouses W, triroot_shipping.dbo.Vendors V  "+
							"Where M.methodID = R.shippingMethod  "+
								"And M.shipOption = '"+option+"' "+
								"And V.name = W.vendor  "+
								"And V.name = M.vendor  "+
								"And M.company = '"/*+partnerName*/+"fsycpf' " + //ADDITION FOR PHASE III
								"And W.warehouseID =  "+warehouse+"  "+
								"And R.city = '"+CityBox.Text+"'  "+
								"And R.state = '"+StateBox.Text+"'  "+
								"And (M.priceUnit = 'fixed'  "+
								"OR M.priceUnit = 'pounds' AND "+items+" <= M.maxWeight  "+
								"OR M.priceUnit = 'item' AND "+weight+" <= M.maxUnit)  "+
							"Order By TotalPrice ";
			DataTable dt = QueryHelper.ExecuteQuery(strSql).Tables[0];
			DataRow dr = dt.Rows[0];
			return dr;
		}

		private void ShipOptionList_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

		private void OptionButton_Click(object sender, System.EventArgs e)
		{
			PayButton.Visible = true;
			LabelA2.Visible = true;
			LabelA3.Visible = true;
			LabelA4.Visible = true;
			LabelA5.Visible = true;
			LabelA6.Visible = true;
			LabelA7.Visible = true;
			LabelA8.Visible = true;
			LabelA9.Visible = true;
			CreditTypeBox.Visible = true;
			CreditNumberBox.Visible = true;
			PriceLabel.Visible = true;
			DiscountLabel.Visible = true;
			TaxLabel.Visible = true;
			ShippingLabel.Visible = true;
			TotalLabel.Visible = true;
			DataGrid.Visible = true;
			PaymentList.Visible = true;

			string option = ShipOptionList.SelectedItem.Text;
			object[] allPackageInfo = new object[4];
			allPackageInfo[0] = (int) 0;
			allPackageInfo[1] = (decimal) 0;
			allPackageInfo[2] = (decimal) 0;
			allPackageInfo[3] = (decimal) 0;
			DataTable dt = new DataTable("Option");
			dt.Columns.Clear();
			dt.Columns.Add("Package");
			dt.Columns.Add("Option");
			dt.Columns.Add("Vendor");
			dt.Columns.Add("PriceUnit");
			dt.Columns.Add("Days of Delivery");
			dt.Columns.Add("PerUnit");
			dt.Columns.Add("TotalPrice");

			int package = 1;
			decimal shippingCost = 0;
			IDictionaryEnumerator IDE = packages.GetEnumerator();
			while(IDE.MoveNext())
			{
				object[] packInfo = packageItemsPriceWeightDiscount((ArrayList)IDE.Value);
				allPackageInfo[0] = (int)allPackageInfo[0] + (int)packInfo[0];
				allPackageInfo[1] = (decimal)allPackageInfo[1] + (decimal)packInfo[1];
				allPackageInfo[2] = (decimal)allPackageInfo[2] + (decimal)packInfo[2];
				allPackageInfo[3] = (decimal)allPackageInfo[3] + (decimal)packInfo[3];
				DataRow dr = cheapestShipping(package, option, (int)packInfo[0], (decimal)packInfo[2], (int)IDE.Key);
				shippingCost = shippingCost + (decimal)dr[6];
				dt.ImportRow(dr);
				package++;
				Session.Add(IDE.Key.ToString(), dr[7]);
			}

			DataGrid.DataSource = dt;
			DataGrid.DataBind();

			PriceLabel.Text = allPackageInfo[1].ToString();
			DiscountLabel.Text = allPackageInfo[3].ToString();
			TaxLabel.Text = ((decimal)allPackageInfo[1]*(decimal)0.09).ToString();
			ShippingLabel.Text = shippingCost.ToString();
			TotalLabel.Text = ((decimal)allPackageInfo[1]+(decimal)allPackageInfo[3]+((decimal)allPackageInfo[1]*(decimal)0.09)+(decimal)shippingCost).ToString();
			Session.Add("packages", packages);

			GetCreditInfo();
		}

		private void AddrBtn_Click(object sender, System.EventArgs e)
		{
			System.Diagnostics.Debug.WriteLine("lkajsdfiiaosfdj");
			string username = Session["username"].ToString();

			string sqlStr = " SELECT homephone, firstname, lastname, streetaddress, city, state, zip, addressID " +
				" FROM phil60_shipping.dbo.addresses, phil60_shipping.dbo.customers  " +
				" WHERE phil60_shipping.dbo.addresses.username = '" + username + "' AND phil60_shipping.dbo.customers.username = '" + username + "' ";

			string sqlString = "server=IISQLSRV; uid=triroot; pwd=changeME";
			SqlConnection sqlConn = new SqlConnection(sqlString);
			sqlConn.Open();

			SqlCommand sqlCom = new SqlCommand(sqlStr, sqlConn);
			SqlDataReader sqlRdr = sqlCom.ExecuteReader();

			sqlRdr.Read();
			if (sqlRdr.HasRows)
			{
				PhoneBox.Text = sqlRdr.GetValue(0).ToString();
				NameBox.Text = sqlRdr.GetValue(1).ToString() + " " + sqlRdr.GetValue(2);
				AddrBox.Text = sqlRdr.GetValue(3).ToString();
				CityBox.Text = sqlRdr.GetValue(4).ToString();
				StateBox.Text = sqlRdr.GetValue(5).ToString();
				ZipBox.Text = sqlRdr.GetValue(6).ToString();

				Session.Add("addressID", sqlRdr.GetValue(7).ToString());
			}

			sqlRdr.Close();
			sqlConn.Close();
		}

		private void PayButton_Click(object sender, System.EventArgs e)
		{
			string company = "fsycpf";
			/*int size = ItemArray.Count;
			string[] itemType = new string[size];
			string[] itemID = new string[size];
			string[] itemName = new string[size];
			int[] qty = new int[size];
			IEnumerator enumer = ItemArray.GetEnumerator();
			int i = 0;
			while(enumer.MoveNext())
			{
				itemType[i] = (string)((object[])enumer.Current)[0];
				itemID[i] = (string)((object[])enumer.Current)[1];
				itemName[i] = (string)((object[])enumer.Current)[2];
				qty[i] = (int)((object[])enumer.Current)[3];
				i++;
			}
			string shippingMethod = address[0];
			string streetAddr = address[1];
			string city = address[2];
			string state = address[3];
			string zip = address[4];
			string phoneNum = address[5];
			string faxNum = address[6];
			*/
			object[] order = new object[12];
			order[0] = company;
			//order[1] = itemType;
			//order[2] = itemID;
			//order[3] = itemName;
			//order[4] = qty;
			order[5] = ShipOptionList.SelectedItem.Text;
			//order[6] = streetAddr;
			//order[7] = city;
			//order[8] = state;
			//order[9] = zip;
			//order[10] = phoneNum;
			//order[11] = faxNum;

			decimal[] prices = new decimal[3];
			prices[0] = Decimal.Parse(PriceLabel.Text);
			prices[1] = Decimal.Parse(DiscountLabel.Text);
			prices[2] = Decimal.Parse(ShippingLabel.Text);
			
			Hashtable[] info = new Hashtable[2];
			info[0] = new Hashtable();
			info[1] = new Hashtable();
			info[0].Add(company, order);
			info[1].Add(company, prices);
			Session.Add("InvoiceInfo", info);
			

			((ArrayList)Session["ShipCompanies"]).Remove("fsycpf");
			Server.Transfer("PartnerOrder.aspx");

			//RemoveAllFromStock();
			//AddInvoice();
			//ShoppingCart.DeleteCart(Session["username"].ToString());
		}

		private void RemoveAllFromStock()
		{
			IDictionaryEnumerator enu = packages.GetEnumerator();

			while (enu.MoveNext())
			{
				ArrayList curPackageList = (ArrayList)enu.Value;
				foreach (Object[] package in curPackageList)
				{
					RemoveFromStock(enu.Key.ToString(), package[0].ToString(), package[1].ToString());
				}
			}
		}

		private void RemoveFromStock(string warehouseID, string itemID, string quantity)
		{
			string sqlQuery;
			sqlQuery = "UPDATE craigatk_inventory.dbo.stock " +
				" SET craigatk_inventory.dbo.stock.NumStock = craigatk_inventory.dbo.stock.NumStock - " + quantity +
				" WHERE craigatk_inventory.dbo.stock.warehouseID = " + warehouseID + " AND craigatk_inventory.dbo.stock.itemID = '" + itemID + "' ";

			QueryHelper.ExecuteQuery(sqlQuery);
		}

		private void GetCreditInfo()
		{
			string username = Session["username"].ToString();

			string sqlStr = " SELECT creditcardtype, creditcardnumber " +
				" FROM phil60_shipping.dbo.invoices " +
				" WHERE buyerid = '" + username + "' ";

			string sqlString = "server=IISQLSRV; uid=triroot; pwd=changeME";
			SqlConnection sqlConn = new SqlConnection(sqlString);
			sqlConn.Open();

			SqlCommand sqlCom = new SqlCommand(sqlStr, sqlConn);
			SqlDataReader sqlRdr = sqlCom.ExecuteReader();

			sqlRdr.Read();
			if (sqlRdr.HasRows)
			{
				CreditTypeBox.Text = sqlRdr.GetValue(0).ToString();
				CreditNumberBox.Text = sqlRdr.GetValue(1).ToString();
			}

			sqlRdr.Close();
			sqlConn.Close();
		}

		private void AddInvoice()
		{
			string invoiceID = GetNextInvoiceID().ToString();
			string purchaseDate = DateTime.Now.ToString("d");
			string addressID = Session["addressID"].ToString();
			string username = Session["username"].ToString();
			string methodofshipping = ShipOptionList.SelectedItem.Text;
			string totalPrice = TotalLabel.Text;
			string creditCardType = CreditTypeBox.Text;
			string paymentType = PaymentList.SelectedItem.Text;
			string creditCardNum = CreditNumberBox.Text;
			string priceOfItems = PriceLabel.Text;
			string discounts = DiscountLabel.Text;
			string tax = TaxLabel.Text;
			string shippingCost = ShippingLabel.Text;
			
			string sqlStr = " INSERT INTO phil60_shipping.dbo.invoices " +
				" VALUES (" + invoiceID + ",'" + purchaseDate + "'," + addressID + ",'" + username + "','" + methodofshipping + "'," + SqlMoney.Parse(totalPrice) + ",'" + 
				creditCardType + "','" + paymentType + "','" + creditCardNum + "'," + SqlMoney.Parse(priceOfItems) + "," + SqlMoney.Parse(discounts) + "," + SqlMoney.Parse(tax) + "," + SqlMoney.Parse(shippingCost) + ") ";

			System.Diagnostics.Debug.WriteLine(" VALUES (" + invoiceID + "," + SqlDateTime.Parse(purchaseDate) + "," + addressID + ",'" + username + "','" + methodofshipping + "'," + SqlMoney.Parse(totalPrice) + ",'" + 
				creditCardType + "','" + paymentType + "','" + creditCardNum + "'," + SqlMoney.Parse(priceOfItems) + "," + SqlMoney.Parse(discounts) + "," + SqlMoney.Parse(tax) + "," + SqlMoney.Parse(shippingCost) + ") ");

			QueryHelper.ExecuteNonQuery(sqlStr);

			AddItemsToDB(invoiceID, purchaseDate);
		}

		private void AddItemsToDB(string invoiceID, string shipDate)
		{
			IDictionaryEnumerator enu = packages.GetEnumerator();

			while (enu.MoveNext())
			{
				ArrayList curPackageList = (ArrayList)enu.Value;
				foreach (Object[] package in curPackageList)
				{
					//RemoveFromStock(enu.Key.ToString(), package[0].ToString(), package[1].ToString());

					string itemID = package[0].ToString();
					string name = "";
					string price = "";

					string sqlStr = "SELECT  Distinct Case WHEN Products.ItemType = 'Book' THEN " +
						"Books.Title ELSE CDs.Title END as Title, Case WHEN Products.ItemType = 'Book' THEN " +
						"Books.Price ELSE CDs.Price END as Price " +
						"FROM craigatk_inventory.dbo.Products as Products, craigatk_inventory.dbo.CDs as CDs, " +
						"craigatk_inventory.dbo.Books as Books " +
						"WHERE (Products.ItemID = CDs.ID OR " +
						"Books.ISBN = Products.ItemID) AND " +
						"Products.ItemID = '" + itemID + "' ";

					string sqlString = "server=IISQLSRV; uid=triroot; pwd=changeME";
					SqlConnection sqlConn = new SqlConnection(sqlString);
					sqlConn.Open();

					SqlCommand sqlCom = new SqlCommand(sqlStr, sqlConn);
					SqlDataReader sqlRdr = sqlCom.ExecuteReader();

					sqlRdr.Read();
					if (sqlRdr.HasRows)
					{
						name = sqlRdr.GetValue(0).ToString();
						name = name.Replace("'","''");
						price = sqlRdr.GetValue(1).ToString();
					}

					sqlRdr.Close();
					sqlConn.Close();

					string strSql = " INSERT INTO phil60_shipping.dbo.items " +
						" VALUES ('" + itemID + "'," + invoiceID + ",'" + name + "'," + SqlMoney.Parse(price) + "," + package[1].ToString() + "," + 
						enu.Key.ToString() + ",'" + shipDate + "'," + GetNextTrackingNum() + ") ";

					System.Diagnostics.Debug.WriteLine(" VALUES ('" + itemID + "'," + invoiceID + ",'" + name + "'," + SqlMoney.Parse(price) + "," + package[1].ToString() + "," + 
						enu.Key.ToString() + ",'" + shipDate + "') ");

					QueryHelper.ExecuteNonQuery(strSql);
				}
			}
			
		}

		private int GetNextInvoiceID()
		{
			int id;
			string sqlStr = " SELECT invoiceID " +
				" FROM phil60_shipping.dbo.invoices " +
				" ORDER BY invoiceID DESC ";

			string sqlString = "server=IISQLSRV; uid=triroot; pwd=changeME";
			SqlConnection sqlConn = new SqlConnection(sqlString);
			sqlConn.Open();

			SqlCommand sqlCom = new SqlCommand(sqlStr, sqlConn);
			SqlDataReader sqlRdr = sqlCom.ExecuteReader();

			sqlRdr.Read();
			if (sqlRdr.HasRows)
			{
				id = Int32.Parse(sqlRdr.GetValue(0).ToString()) + 1;
			}
			else
			{
				id = 1;
			}

			sqlRdr.Close();
			sqlConn.Close();

			return id;
		}

		private int GetNextTrackingNum()
		{
			int id;
			string sqlStr = " SELECT packageNum " +
				" FROM phil60_shipping.dbo.items " +
				" ORDER BY packageNum DESC ";

			string sqlString = "server=IISQLSRV; uid=triroot; pwd=changeME";
			SqlConnection sqlConn = new SqlConnection(sqlString);
			sqlConn.Open();

			SqlCommand sqlCom = new SqlCommand(sqlStr, sqlConn);
			SqlDataReader sqlRdr = sqlCom.ExecuteReader();

			sqlRdr.Read();
			if (sqlRdr.HasRows)
			{
				id = Int32.Parse(sqlRdr.GetValue(0).ToString()) + 1;
			}
			else
			{
				id = 1;
			}

			sqlRdr.Close();
			sqlConn.Close();

			return id;
		}

	}
}

