using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace cse444project
{
	/// <summary>
	/// Summary description for DeliveryStatusTracing.
	/// </summary>
	public class DeliveryStatus : Template
	{
		protected System.Web.UI.WebControls.TextBox InvoiceTextBox;
		protected System.Web.UI.WebControls.Label InvoiceLabel;
		protected System.Web.UI.WebControls.Button GoButton;
		protected System.Web.UI.WebControls.Button HistoryButton;
		protected System.Web.UI.WebControls.DataGrid DataGrid;
		protected System.Web.UI.WebControls.Label QueryLabel;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			Title = "Delivery Status Tracing";
			// IF the user Isn't logged in, throw him to the login page
			string username;
			try
			{
				username = Session.Contents["username"].ToString();
			}
			catch(Exception)
			{
				Server.Transfer("Login.aspx");
				username = "";
			} 
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.GoButton.Click += new System.EventHandler(this.GoButton_Click);
			this.HistoryButton.Click += new System.EventHandler(this.HistoryButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		/* Executes and Binds query to the page's DataGrid */
		private void ExecuteQuery(string sqlstr)
		{
			DataGrid.DataSource = QueryHelper.ExecuteQuery(sqlstr);
			DataGrid.DataBind();
			DataGrid.Visible = true;
		}

		/* Executes Query to obtain info about a items in a user's invoice*/
		private void GoButton_Click(object sender, System.EventArgs e)
		{
			if (InvoiceTextBox.Text == "") return;
			// Dont allow the following symbols: ' ; " -- = 
			if (InvoiceTextBox.Text.IndexOf('\'') != -1 || InvoiceTextBox.Text.IndexOf('"')!= -1
				|| InvoiceTextBox.Text.IndexOf(';') != -1|| InvoiceTextBox.Text.IndexOf('=')!= -1
				|| InvoiceTextBox.Text.IndexOf("--")!= -1)
			{
				//Error, Display Problem to user, do not execute Query
				QueryLabel.Text = "Unable to process your request, do not use the following symbols: ' ; -- = \" ";
				DataGrid.Visible = false;
				return;
			}
			string username = (string)Session["username"];
			QueryLabel.Text = "Delivery Status For Items in Invoice " + InvoiceTextBox.Text;
			string strSql = "SELECT 	P.trackingNumber, I.itemId, P.shippingMethod, M.shipOption, P.shippedDate, P.ETA, P.status "+
							"FROM 	phil60_shipping.dbo.Invoices as Iv, triroot_shipping.dbo.Packages as P,  "+
								"phil60_shipping.dbo.Items as I, triroot_shipping.dbo.Methods as M "+
							"WHERE 	"+InvoiceTextBox.Text+" = P.invoice AND  "+
								"Iv.invoiceid = P.invoice AND "+
								"I.packageNum = P.trackingNumber AND "+
								"P.shippingMethod = M.methodID AND "+
								"Iv.buyerid = '"+username+"' ";
			System.Diagnostics.Debug.WriteLine(strSql);
			ExecuteQuery(strSql);
		}

		/* Executes Query that display's the users purchase history */
		private void HistoryButton_Click(object sender, System.EventArgs e)
		{
			if( (string) Session["username"] == "" || Session["username"] == null) return;
			QueryLabel.Text = "Your Shopping History";
			string strSql = "SELECT name, itemid, purchasedate, invoiceid, priceperunit " +
				"FROM phil60_shipping.dbo.Invoices, phil60_shipping.dbo.Items " +
				"WHERE phil60_shipping.dbo.Invoices.invoiceid = phil60_shipping.dbo.Items.invoiceNum AND " +
					"phil60_shipping.dbo.Invoices.invoiceid = ANY " +
					"(SELECT distinct invoiceid " + 
							"FROM phil60_shipping.dbo.Invoices " +
							"WHERE buyerid = '" + Session["username"] + "') " +
				"ORDER BY phil60_shipping.dbo.Invoices.purchasedate ";
			ExecuteQuery(strSql);
		}
	}
}
