using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace cse444project
{
	/// <summary>
	/// Summary description for ManagementInfo.
	/// </summary>
	public class ManagementInfo : Template
	{
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.Button CitySearchBtn;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.TextBox CityTextBox;
		protected System.Web.UI.WebControls.Button WarehouseInfoBtn;
		protected System.Web.UI.WebControls.TextBox StateTextBox;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.Button SalesAmountBtn;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.SalesAmountBtn.Click += new System.EventHandler(this.SalesAmountBtn_Click);
			this.CitySearchBtn.Click += new System.EventHandler(this.CitySearchBtn_Click);
			this.WarehouseInfoBtn.Click += new System.EventHandler(this.WarehouseInfoBtn_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void SalesAmountBtn_Click(object sender, System.EventArgs e)
		{
			string sqlQuery;

			sqlQuery = " SELECT products.itemid, sum(items.quantity) AS TotalQuantitySold, sum(items.priceperunit * items.quantity) AS TotalSales " +
						" FROM craigatk_inventory.dbo.products AS products, phil60_shipping.dbo.items AS items " +
						" WHERE products.itemid = items.itemid " +
						" GROUP BY products.itemid ";

			DataSet dataSet = QueryHelper.ExecuteQuery(sqlQuery);

			DataGrid1.DataSource = dataSet;
			DataGrid1.DataBind();

			DataGrid1.Visible = true;
		}

		private void CitySearchBtn_Click(object sender, System.EventArgs e)
		{
			string sqlQuery;
			string cityText = CityTextBox.Text.ToLower();
			string stateText = StateTextBox.Text.ToLower();

			sqlQuery = " SELECT methods.shipOption, count(methods.methodID) AS NumUsed, methods.vendor, methods.price, methods.priceUnit AS PricePerUnit, methods.maxUnit, methods.maxWeight, methods.maxTime " +
						" FROM triroot_shipping.dbo.methods AS methods, triroot_shipping.dbo.restrictedCities AS restrictedCites, phil60_shipping.dbo.invoices AS invoices " +
						" WHERE methods.methodID = restrictedCites.shippingMethod AND restrictedCites.city LIKE '%" + cityText + "%' AND restrictedCites.state = '" + stateText +"' AND methods.shipOption = invoices.methodOfShipping " +
						" GROUP BY methods.shipOption, methods.vendor, methods.price, methods.priceUnit, methods.maxUnit, methods.maxWeight, methods.maxTime ";

			DataGrid1.DataSource = QueryHelper.ExecuteQuery(sqlQuery);
			DataGrid1.DataBind();
			DataGrid1.Visible = true;
		}

		private void WarehouseInfoBtn_Click(object sender, System.EventArgs e)
		{
			string sqlQuery;

			sqlQuery = " SELECT warehouses.street, warehouses.city, warehouses.state, warehouses.zip, vendorWarehouses.vendor, stock.itemID, sum(items.quantity) AS NumProductsShipped " +
						" FROM craigatk_inventory.dbo.warehouses AS warehouses, triroot_shipping.dbo.vendorWarehouses AS vendorWarehouses, craigatk_inventory.dbo.stock AS stock, phil60_shipping.dbo.items AS items " +
						" WHERE vendorWarehouses.warehouseID = warehouses.ID AND items.warehouse = warehouses.id  AND stock.warehouseID = warehouses.ID " +
						" GROUP BY warehouses.street, warehouses.city, warehouses.state, warehouses.zip, vendorWarehouses.vendor, stock.itemID ";

			DataGrid1.DataSource = QueryHelper.ExecuteQuery(sqlQuery);
			DataGrid1.DataBind();
			DataGrid1.Visible = true;
		}
	}
}
