using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;  // SQL library

namespace cse444project
{
	/// <summary>
	/// Summary description for ShoppingCart.
	/// </summary>
	public class ShoppingCart : Template
	{
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Data.SqlClient.SqlConnection sqlConn;
		protected System.Web.UI.WebControls.TextBox TextBox1;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Button Button1;
		static private string strSqlString = "server=IISQLSRV; uid=phil60; pwd=changeME; database=phil60_shipping";
			
		private void Page_Load(object sender, System.EventArgs e)
		{
			Title = "Shopping Cart";
			// IF the user Isn't logged in, throw him to the login page
			try
			{
				Session.Contents["username"].ToString();
			}
			catch(Exception)
			{
				Server.Transfer("Login.aspx");
			} 
		}

		private void HandleClick(Object sender, DataGridCommandEventArgs e)
		{
			string itemID = e.Item.Cells[4].Text;
			string qty = e.Item.Cells[5].Text;
			if(e.CommandName == "Remove") Remove(itemID);
			else if (e.CommandName == "EditQty") EditQty(itemID,qty);
			// all hell broke loose if we get here...
		}
		
		private void Remove(string itemID)
		{
			/* open a db connection */
			SqlConnection sqlConn = new SqlConnection ( strSqlString );
			sqlConn.Open();

			/* update qty in the shopping cart */
			string strSql = "DELETE FROM ShoppingCartItems " +
				"WHERE " + itemID + " = itemID AND "+
				"username = '" + Session["username"] + "'";
			System.Diagnostics.Debug.WriteLine(strSql);
			SqlCommand sqlCom = new SqlCommand(strSql, sqlConn);
			sqlCom.ExecuteNonQuery();

			/* close db connection */
			sqlConn.Close();
			Server.Transfer("ShoppingCart.aspx");
		}

		private void Button1_Click(object sender, System.EventArgs e)
		{
			DeleteCart((string)Session["username"]);	
		}

		/* deletes the user's cart */
		public static void DeleteCart(string username)
		{
			string strSql = "DELETE FROM phil60_shipping.dbo.ShoppingCartItems "+
				"WHERE '" + username + "' = username";
			QueryHelper.ExecuteNonQuery(strSql);
		}


		private void EditQty(string itemID, string qty)
		{
			/* open a db connection */
			SqlConnection sqlConn = new SqlConnection ( strSqlString );
			sqlConn.Open();
			System.Diagnostics.Debug.WriteLine("EditQty entered with itemID: " + itemID + " and qty: "+ qty);
			if( Int32.Parse(TextBox1.Text) == 0)
			{
				string strSql = "DELETE FROM ShoppingCartItems "+
								"WHERE itemID = " + itemID ;
				System.Diagnostics.Debug.WriteLine(strSql);
				SqlCommand sqlCom = new SqlCommand(strSql, sqlConn);
				sqlCom.ExecuteNonQuery();
			}else
			/* update qty in the shopping cart */
			if(CheckQuant((string)Session["username"], Int32.Parse(itemID), Int32.Parse(TextBox1.Text) ) )
			{
				string strSql = "UPDATE	ShoppingCartItems " +
					"SET	qty = " + TextBox1.Text +
					"WHERE  " + itemID + " IN (SELECT ItemID " +
					" WHERE	username = '" + Session["username"] + "')";
				System.Diagnostics.Debug.WriteLine(strSql);
				SqlCommand sqlCom = new SqlCommand(strSql, sqlConn);
				sqlCom.ExecuteNonQuery();
			}

			/* close db connection */
			sqlConn.Close();
			Server.Transfer("ShoppingCart.aspx");
		} 
		/* check if we have enough in stock */
		public static bool CheckQuant(string username, int itemID, int qtyToAdd)
		{
			if(qtyToAdd < 0) return false;
			/* get the total quantity we have */
			string strSql = "SELECT sum(Stock.NumStock) " +
				"FROM craigatk_inventory.dbo.Stock as Stock " +
				"WHERE Stock.ItemID = " + itemID ;
			int qtyAvail = 0;
			DataSet ds = QueryHelper.ExecuteQuery(strSql);
			if(ds.Tables[0].Rows[0][0] != null)	qtyAvail = (int) ds.Tables[0].Rows[0][0];		

			System.Diagnostics.Debug.WriteLine("We've got "+qtyAvail+" and we need "+qtyToAdd);
			if((qtyToAdd) < qtyAvail )
			{
				return true;
			} 
			else return false;
		}

		public void initFunc()
		{
			/* Grab the user's shopping cart out of table #ShoppingCart that was created when they logged on*/
			string strSql = "SELECT  Distinct Case WHEN Products.ItemType = 'Book' THEN " +
				"Books.Title ELSE CDs.Title END as Title, Products.ItemType, Products.ItemID, cart.qty " +
				"FROM craigatk_inventory.dbo.Products as Products, craigatk_inventory.dbo.CDs as CDs, " +
				"craigatk_inventory.dbo.Books as Books, phil60_shipping.dbo.ShoppingCartItems as cart " +
				"WHERE (Products.ItemID = CDs.ID OR " +
				"Books.ISBN = Products.ItemID) AND	" +
				"cart.username = '" + Session["username"] + "' AND " +
				"cart.itemID = Products.ItemID";
			System.Diagnostics.Debug.WriteLine(strSql);
			DataSet ds = QueryHelper.ExecuteQuery(strSql);
            			
			// Get the answer from the reader and write it to the label.
			DataGrid1.DataSource = ds;
			DataGrid1.DataBind();	
			DataGrid1.Visible = true;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			this.DataGrid1.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.HandleClick);
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
			initFunc();
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.sqlConn = new System.Data.SqlClient.SqlConnection();
			this.DataGrid1.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.Remove);
			this.Button1.Click += new System.EventHandler(this.Button1_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Remove(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			// check if edit or remove button was clicked
			string itemID = e.Item.Cells[4].Text;
			string qty = e.Item.Cells[6].Text;
			
			if(e.CommandName == "Remove") Remove(itemID);
			else if (e.CommandName == "EditQty") EditQty(itemID,qty);
			// all hell broke loose if we get here...
			System.Diagnostics.Debug.WriteLine("Something went really really wrong in ShoppingCart.HandleClick()");
		}
	}
	
}
