using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Data.SqlClient;	// This is the library with the SQL types we're using below



namespace gibble
{
	/// <summary>
	/// Summary description for BrowseInventory.
	/// </summary>
	public class BrowseInventory : System.Web.UI.Page
	{
		private SqlConnection sqlConn;	// Declare a connection object
		private SqlCommand sqlCom;		  // Declare a command object
		private SqlDataReader sqlRdr;	  // Declare a reader to read the query result
		private string strSqlString = "server=IISQLSRV; uid=frewen; pwd=grovVer; database=frewen_inventory";

		protected System.Web.UI.WebControls.Button viewProductsb;
		protected System.Web.UI.WebControls.TextBox firstnametb;
		protected System.Web.UI.WebControls.TextBox lastnametb;
		protected System.Web.UI.WebControls.Button artistb;
		protected System.Web.UI.WebControls.TextBox catalogNumtb;
		protected System.Web.UI.WebControls.Button productDetailsb;
		protected System.Web.UI.WebControls.Panel pnlBookDetail;
		protected System.Web.UI.WebControls.Panel pnlCdDetail;
		protected System.Web.UI.WebControls.Label lblBookTitle;
		protected System.Web.UI.WebControls.Label lblAuthor;
		protected System.Web.UI.WebControls.Label lblCategory;
		protected System.Web.UI.WebControls.Label lblBookYear;
		protected System.Web.UI.WebControls.Label lblPublisher;
		protected System.Web.UI.WebControls.Label lblBinding;
		protected System.Web.UI.WebControls.Label lblISBN;
		protected System.Web.UI.WebControls.Label lblBookPrice;
		protected System.Web.UI.WebControls.Label lblBookDiscount;
		protected System.Web.UI.WebControls.Label lblBookInStock;
		protected System.Web.UI.WebControls.Label lblArtist;
		protected System.Web.UI.WebControls.Label lblGnere;
		protected System.Web.UI.WebControls.Label lblCdYear;
		protected System.Web.UI.WebControls.Label lblRecLabel;
		protected System.Web.UI.WebControls.Label lblFormat;
		protected System.Web.UI.WebControls.Label lblDiskNum;
		protected System.Web.UI.WebControls.Label lblASIN;
		protected System.Web.UI.WebControls.Label lblCdInStock;
		protected System.Web.UI.WebControls.Label lblCdTitle;
		protected System.Web.UI.WebControls.Label lblCdPrice;
		protected System.Web.UI.WebControls.Label lblCdDiscount;
		protected System.Web.UI.WebControls.TextBox txtbBuyBookQuant;
		protected System.Web.UI.WebControls.Button BuyBookbtn;
		protected System.Web.UI.WebControls.Button BuyCDbtn;
		protected System.Web.UI.WebControls.TextBox txtbBuyCdQuat;
		protected System.Web.UI.WebControls.DropDownList ddlKeyWords;
		protected System.Web.UI.WebControls.Button btnKeyword;
		protected System.Web.UI.WebControls.Panel pnlSearch;
		protected System.Web.UI.WebControls.Label lblBookOutOfStock;
		protected System.Web.UI.WebControls.Label lblCdOutOfStock;
		protected System.Web.UI.WebControls.Label lblArtistError;
		protected System.Web.UI.WebControls.Label lblCatNumError;
		protected System.Web.UI.WebControls.Label lblRating;
		protected System.Web.UI.WebControls.Label lblNumRatings;
		protected System.Web.UI.WebControls.TextBox txtRating;
		protected System.Web.UI.WebControls.Label lblKeyWord;
		protected System.Web.UI.WebControls.Button btnRateBook;
		protected System.Web.UI.WebControls.Label lblRatingError;
		protected System.Web.UI.WebControls.DataGrid ProductsGrid;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			this.ProductsGrid.Visible = false;
			this.pnlBookDetail.Visible = false;
			this.pnlCdDetail.Visible = false;
			this.lblBookOutOfStock.Visible = false;
			this.lblCdOutOfStock.Visible = false;
			this.lblArtistError.Visible = false;
			this.lblCatNumError.Visible = false;
			this.lblKeyWord.Visible = false;

			if( this.Session["pending_order_id"] != null)
			{
				string catNum = Session["pending_order_id"].ToString();
				string quant = Session["pending_order_quant"].ToString();
				this.Session["pending_order_id"] = null;
				this.Session["pending_order_quant"] = null;
				AddToCart( catNum, quant );
			}

			if( ! this.IsPostBack )
			{
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	// open the connection
				string strSql = "Select word from keywords order by word";
				sqlCom = new SqlCommand(strSql, sqlConn);	
				sqlRdr = sqlCom.ExecuteReader();

				this.ddlKeyWords.DataTextField = "word";
				this.ddlKeyWords.DataValueField = "word";
				this.ddlKeyWords.DataSource = sqlRdr;
				this.ddlKeyWords.DataBind();

				//fill dropdown

				sqlConn.Close();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ProductsGrid.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.ProductsGrid_ItemCommand);
			this.btnRateBook.Click += new System.EventHandler(this.btnRateBook_Click);
			this.BuyBookbtn.Click += new System.EventHandler(this.BuyBookbtn_Click);
			this.BuyCDbtn.Click += new System.EventHandler(this.BuyCDbtn_Click);
			this.viewProductsb.Click += new System.EventHandler(this.viewProductsb_Click);
			this.artistb.Click += new System.EventHandler(this.artistb_Click);
			this.btnKeyword.Click += new System.EventHandler(this.btnKeyword_Click);
			this.productDetailsb.Click += new System.EventHandler(this.productDetailsb_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void viewProductsb_Click(object sender, System.EventArgs e)
		{
			// Start a new connection to the database specified in strSqlString
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection


			// Execute query 
			string strSql = "SELECT title as Title, firstname as Author, lastname as 'or Artist', price, catalog# as 'Catalog Number'  " +
				"FROM Products ";
						
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			// Get the answer from the reader and write it to the label.
			if (sqlRdr.HasRows) 
			{
				ProductsGrid.DataSource = sqlRdr;
				ProductsGrid.DataBind();
				ProductsGrid.Visible = true;
			}
			

			// Close the sql connection at the end
			sqlRdr.Close();
			sqlConn.Close();	
		}

		/*
		private void Button1_Click(object sender, System.EventArgs e)
		{
			// Start a new connection to the database specified in strSqlString
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection


			// Execute query 
			string strSql = "SELECT title as Title, firstname as Author, lastname as 'or Artist', catalog# as 'Catalog Number' " +
				"FROM Products left outer join stock on catalog#=item " +
				"GROUP BY catalog#, title, firstname, lastname " +
				"HAVING (sum(quantity) = 0) or (sum(quantity) is NULL)";
						
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			// Get the answer from the reader and write it to the label.
			if (sqlRdr.HasRows) 
			{
				ProductsGrid.DataSource = sqlRdr;
				ProductsGrid.DataBind();
				ProductsGrid.Visible = true;
			}
			sqlConn.Close();	
		}
		*/


		private void artistb_Click(object sender, System.EventArgs e)
		{
			// Start a new connection to the database specified in strSqlString
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection

			// Execute query 
			string strSql = "SELECT title as Title, firstname as Author, lastname as 'or Artist', price, "+ 
				"catalog# as 'Catalog Number' " +
				"FROM products " +
				"WHERE firstname = '" + this.firstnametb.Text + "' AND lastname = '" + this.lastnametb.Text + "'";  
										
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			// Get the answer from the reader and write it to the label.
			if (sqlRdr.HasRows) 
			{
				ProductsGrid.DataSource = sqlRdr;
				ProductsGrid.DataBind();
				ProductsGrid.Visible = true;
			}
			else
			{
				ProductsGrid.Visible = false;
				this.lblArtistError.Visible = true;
			}
			this.firstnametb.Text = "";
			this.lastnametb.Text = "";
			sqlRdr.Close();
			sqlConn.Close();	
		}

		private void productDetailsb_Click(object sender, System.EventArgs e)
		{
			string catNum = catalogNumtb.Text;
			ViewProductDetails( catNum );
			this.catalogNumtb.Text = "";
		}

		private void ViewProductDetails( string catNum )
		{
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	

			string strSql = "SELECT title, firstname, lastname, year, [publisher-record_label], catalog#, price, media_type, " + 
				"binding = case binding when 's' then 'soft cover' when 'h' then 'hard cover' end, " +
				"category, genre, type, disk#, sum(quantity), sum(reduction), rating, num_ratings " +
				"FROM (Products left outer join books on ISBN=catalog#) left outer join Music on catalog#=ASIN " + 
				"left outer join stock on catalog#=item left outer join Discounts on catalog#=discounts.item " +
				"left outer join Sales on Discounts.sale=Sales.id " +
				"WHERE catalog#=@catalogNum " +
				"GROUP BY title, firstname, lastname, year, [publisher-record_label], catalog#, price, media_type, binding, category, genre, type, disk#, rating, num_ratings ";
						
			sqlCom = new SqlCommand(strSql, sqlConn);	 
			sqlCom.Parameters.Add("@catalogNum", catNum);
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.Read()) 
			{
				if(sqlRdr.GetSqlString(7).ToString() == "b")
				{
					this.pnlBookDetail.Visible = true;
					this.lblBookTitle.Text = sqlRdr.GetSqlString(0).ToString();
					this.lblAuthor.Text = sqlRdr.GetSqlString(1).ToString() + " " + sqlRdr.GetSqlString(2).ToString();
					this.lblCategory.Text = sqlRdr.GetSqlString(9).ToString();
					this.lblBookYear.Text = sqlRdr.GetSqlDecimal(3).ToString();
					this.lblPublisher.Text = sqlRdr.GetSqlString(4).ToString();
					this.lblBinding.Text = sqlRdr.GetSqlString(8).ToString();
					this.lblISBN.Text = sqlRdr.GetSqlString(5).ToString();
					this.lblBookPrice.Text = sqlRdr.GetSqlMoney(6).ToString();
					this.lblBookDiscount.Text = sqlRdr.GetSqlDecimal(14).ToString() == "Null" ? "None" : sqlRdr.GetSqlDecimal(14).ToString();
					this.lblBookInStock.Text = sqlRdr.GetSqlInt32(13).ToString() == "Null" ? "0" : sqlRdr.GetSqlInt32(13).ToString();
					this.lblRating.Text = sqlRdr.GetSqlValue(15).ToString();
					this.lblNumRatings.Text = sqlRdr.GetSqlValue(16).ToString();
				}
				else if(sqlRdr.GetSqlString(7).ToString() == "c")
				{
					this.pnlCdDetail.Visible = true;
					this.lblCdTitle.Text = sqlRdr.GetSqlString(0).ToString();
					this.lblArtist.Text = (sqlRdr.GetSqlString(1).ToString() == "Null" ? "" : sqlRdr.GetSqlString(1).ToString()) + " " + sqlRdr.GetSqlString(2).ToString();
					this.lblGnere.Text = sqlRdr.GetSqlString(10).ToString();
					this.lblCdYear.Text = sqlRdr.GetSqlDecimal(3).ToString();
					this.lblRecLabel.Text = sqlRdr.GetSqlString(4).ToString();
					this.lblFormat.Text = sqlRdr.GetSqlString(11).ToString();
					this.lblASIN.Text = sqlRdr.GetSqlString(5).ToString();
					this.lblCdPrice.Text = sqlRdr.GetSqlMoney(6).ToString();
					this.lblCdDiscount.Text = sqlRdr.GetSqlDecimal(14).ToString() == "Null" ? "None" : sqlRdr.GetSqlDecimal(14).ToString();
					this.lblCdInStock.Text = sqlRdr.GetSqlInt32(13).ToString() == "Null" ? "0" : sqlRdr.GetSqlInt32(13).ToString();
				}
			}
			else
			{
				this.lblCatNumError.Visible = true;
			}	
			sqlRdr.Close();
			sqlConn.Close();	

		}

		private void ProductsGrid_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			//sources is datagrid, e has usefull information
			if( e.CommandName == "Select" )
			{
				string catNum =  e.Item.Cells[5].Text; //catalog number of row clicked
				ViewProductDetails( catNum );
			}
		}

		private void BuyBookbtn_Click(object sender, System.EventArgs e)
		{
			try
			{
				if (int.Parse(txtbBuyBookQuant.Text) <= 0)
				{
					this.ViewProductDetails(this.lblISBN.Text);
					return;
				}
			}
			catch (Exception)
			{
				this.ViewProductDetails(this.lblISBN.Text);
				return;
			}

			if (this.Session["user"] == null)
			{
				// not logged in
				this.Session["redirect"] = "BrowseInventory.aspx";
				//add info to session about pending order
				this.Session["pending_order_id"] = this.lblISBN.Text;
				this.Session["pending_order_quant"] = this.txtbBuyBookQuant.Text;
				this.Response.Redirect("Login.aspx");
			}
			else if( Convert.ToInt32(lblBookInStock.Text)== 0  || ! isInStock(lblISBN.Text, Convert.ToInt32(txtbBuyBookQuant.Text) )  )
			{
				pnlBookDetail.Visible = true;
				lblBookOutOfStock.Visible = true;
			}
			else 
			{
				AddToCart( lblISBN.Text, txtbBuyBookQuant.Text );
			}
		}

		private void BuyCDbtn_Click(object sender, System.EventArgs e)
		{
			try
			{
				if (int.Parse(txtbBuyCdQuat.Text) <= 0)
				{
					this.ViewProductDetails(this.lblASIN.Text);
					return;
				}
			}
			catch (Exception)
			{
				this.ViewProductDetails(this.lblISBN.Text);
				return;
			}

			if (this.Session["user"] == null)
			{
				// not logged in
				this.Session["redirect"] = "BrowseInventory.aspx";
				//add info to session about pending order
				this.Session["pending_order_id"] = this.lblASIN.Text;
				this.Session["pending_order_quant"] = this.txtbBuyCdQuat.Text;
				this.Response.Redirect("Login.aspx");
			}
			else if( Convert.ToInt32(lblCdInStock.Text) == 0 || ! isInStock(lblASIN.Text, Convert.ToInt32(txtbBuyCdQuat.Text) ))
			{
				pnlCdDetail.Visible = true;
				lblCdOutOfStock.Visible = true;
			}
			else 
			{
				AddToCart( lblASIN.Text, txtbBuyCdQuat.Text );
			}
		}

		private void AddToCart(string catNum, string quant)
		{
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();
			string strSql;
		
			//are there enough in stock?
			if( this.Session["user"] == null || !isInStock(catNum, Convert.ToInt32( quant )) )
			{
				return;
			}
			else if( inCart( catNum) )
			{  //update quantity
				strSql = "UPDATE nauledge_billing..shoppingCart SET quantity=quantity+" + quant + 
						 //"WHERE customer='" + this.Session["user"] + "' AND product='" + catNum + "'";
						"WHERE customer=@user AND product='" + catNum + "'";
				sqlCom = new SqlCommand(strSql, sqlConn);
				sqlCom.Parameters.Add("@user", this.Session["user"]);
				sqlCom.ExecuteNonQuery();	
			}
			else
			{//insert into cart
				//strSql = "INSERT INTO nauledge_billing..shoppingCart VALUES ('" + this.Session["user"] + "', '" + catNum + "', " + quant + ")";
				strSql = "INSERT INTO nauledge_billing..shoppingCart VALUES (@user, @catalogNum, @quantity)";
				SqlCommand sqlCom2 = new SqlCommand(strSql, sqlConn);
				sqlCom2.Parameters.Add("@user", this.Session["user"]);
				sqlCom2.Parameters.Add("@catalogNum", catNum);
				sqlCom2.Parameters.Add("@quantity", quant);
				sqlCom2.ExecuteNonQuery();	
			}
			sqlRdr.Close();
			sqlConn.Close();	
			this.Response.Redirect("ShoppingCart.aspx");

		}

		bool isInStock(string catNum, int quant)
		{
			bool returnMe = false;

			int amtinstock = 0, amtincart = 0;

			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();
			string strSql = "SELECT sum(quantity)" +
				"FROM products, stock " +
				"WHERE catalog#=item AND catalog#=@catNumber" ;
			sqlCom = new SqlCommand(strSql, sqlConn);	
			sqlCom.Parameters.Add("@catNumber", catNum);
			sqlRdr = sqlCom.ExecuteReader();
			if( sqlRdr.Read() )
			{
				amtinstock = int.Parse(sqlRdr.GetSqlInt32(0).ToString());
			}
			sqlRdr.Close();
			
			strSql = "SELECT sum(quantity)" +
				"FROM nauledge_billing..shoppingCart " +
				"WHERE product=@catNumber and customer='" + this.Session["user"].ToString() + "'"  ;
			sqlCom = new SqlCommand(strSql, sqlConn);	
			sqlCom.Parameters.Add("@catNumber", catNum);
			sqlRdr = sqlCom.ExecuteReader();
			if( sqlRdr.Read() )
			{
				if (!sqlRdr.GetSqlInt32(0).IsNull)
				amtincart = sqlRdr.GetInt32(0);
			}
			sqlRdr.Close();

			returnMe = amtinstock >= (quant + amtincart);

			sqlConn.Close();
			return returnMe;
		}

		bool inCart(string catNum)
		{
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();

			string strSql = "SELECT * FROM nauledge_billing..shoppingCart " + 
					//"WHERE customer='" + this.Session["user"] + "' AND product='" + catNum + "'";
							"WHERE customer=@user AND product=@catNumber";
			sqlCom = new SqlCommand(strSql, sqlConn);	
			sqlCom.Parameters.Add("@user", this.Session["user"]);
			sqlCom.Parameters.Add("@catNumber", catNum);
			sqlRdr = sqlCom.ExecuteReader();
			if (sqlRdr.Read()) {
				sqlRdr.Close();
				return true;
			}else{
				sqlRdr.Close();
				return false;
			}
		}

		private void btnKeyword_Click(object sender, System.EventArgs e)
		{
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();
			string strSql = "SELECT title as Title, firstname as Author, lastname as 'or Artist', price, catalog# as 'Catalog Number'  " +
					 "FROM products join bookkeywords on catalog#=book join keywords on keyword=id " +
                     //"WHERE word='" + this.ddlKeyWords.SelectedValue.ToString() + "'";  
					 "WHERE word=@keyword";  
			sqlCom = new SqlCommand(strSql, sqlConn);	
			sqlCom.Parameters.Add("@keyword", this.ddlKeyWords.SelectedValue.ToString());
			sqlRdr = sqlCom.ExecuteReader();
			if (sqlRdr.HasRows) 
			{
				ProductsGrid.DataSource = sqlRdr;
				ProductsGrid.DataBind();
				ProductsGrid.Visible = true;
			}
			else
			{
				this.lblKeyWord.Visible = true;
			}
			sqlConn.Close();				
		}


		private void btnRateBook_Click(object sender, System.EventArgs e)
		{
			try
			{
				if (int.Parse(this.txtRating.Text) < 1 ||
					int.Parse(this.txtRating.Text) > 10)
					throw new Exception();
				this.lblRatingError.Visible = false;
				//calculate new rating
				int newRating = (Convert.ToInt32(lblRating.Text) + Convert.ToInt32(txtRating.Text)) /2;
				int newNumRatings = Convert.ToInt32(lblNumRatings.Text) + 1;
				//update table
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();
				string strSql = "update products set rating=@newR, num_ratings=@newNum where catalog#=@catNum";
				sqlCom = new SqlCommand(strSql, sqlConn);	
				sqlCom.Parameters.Add("@newR", newRating);
				sqlCom.Parameters.Add("@newNum", newNumRatings);
				sqlCom.Parameters.Add("@catNum", lblISBN.Text);
				sqlCom.ExecuteNonQuery();	
				//refresh page
				ViewProductDetails( lblISBN.Text );
			}
			catch (Exception)
			{
				this.lblRatingError.Visible = true;
				ViewProductDetails( lblISBN.Text );
			}

		}


	}
}
