namespace gibble
{
	using System;
	using System.Collections;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Data.SqlClient;

	/// <summary>
	///		Summary description for ShippingMethodChooser.
	/// </summary>
	public class ForeignMethodChooser : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.DropDownList dropShippingOption;
		protected System.Web.UI.WebControls.Label lblCarrier;
		protected System.Web.UI.WebControls.Label lblPrice;
		protected System.Data.SqlClient.SqlConnection sqlConnection1;
		protected System.Data.SqlClient.SqlCommand sqlShippingMethods;
		protected System.Web.UI.WebControls.Label lblMethodID;
		private string city;
		private string company;
		protected System.Web.UI.WebControls.Label lblPackageNumber;
		protected System.Web.UI.WebControls.Label lblCompany;
		private int index;

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		public void Initialize(IEnumerable options, string city, string company, int index)
		{
			this.city = city;
			this.company = company;
			this.index = index;
			this.SetOptions(options);
			this.updateShippingMethodInfo();
			this.lblPackageNumber.Text = (index + 1).ToString();
		}

		private void updateShippingMethodInfo()
		{
			this.sqlConnection1.Open();
			ArrayList p = (ArrayList)this.Session["foreignpackages"];

			this.sqlShippingMethods.Parameters.Clear();
			this.sqlShippingMethods.Parameters.Add("@city", this.City);
			this.sqlShippingMethods.Parameters.Add("@company", this.company);
			this.sqlShippingMethods.Parameters.Add("@OPTION", this.dropShippingOption.SelectedValue);
			this.sqlShippingMethods.Parameters.Add("@weight", ((Package)p[this.index]).Weight(this.sqlConnection1));
			this.sqlShippingMethods.Parameters.Add("@items", ((Package)p[this.index]).ItemCount());
			SqlDataReader reader = this.sqlShippingMethods.ExecuteReader();
			if (reader.Read())
			{
				((Package)p[this.index]).Method = reader.GetInt32(0); // set the package method
				this.lblCarrier.Text = reader.GetString(1); // carrier
				this.lblPrice.Text = string.Format("{0:c}", float.Parse(reader.GetSqlMoney(3).ToString())); // price
				this.lblCompany.Text = this.company;
			}
			reader.Close();

			this.sqlConnection1.Close();
		}

		public void SetOptions(IEnumerable options)
		{
			this.dropShippingOption.Items.Clear();
			foreach (string s in options)
			{
				this.dropShippingOption.Items.Add(s);
			}
		}

		public string Carrier
		{
			get
			{
				return this.lblCarrier.Text;
			}
			set
			{
				this.lblCarrier.Text = value;
			}
		}

		public string Price
		{
			get
			{
				return this.lblPrice.Text;
			}
			set
			{
				this.lblPrice.Text = value;
			}
		}

		public string Company
		{
			get
			{
				return this.lblCompany.Text;
			}
			set
			{
				this.lblCompany.Text = value;
			}
		}

		public string City
		{
			get
			{
				return this.city.ToString();
			}
			set
			{
				this.city = value;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.sqlConnection1 = new System.Data.SqlClient.SqlConnection();
			this.sqlShippingMethods = new System.Data.SqlClient.SqlCommand();
			this.dropShippingOption.SelectedIndexChanged += new System.EventHandler(this.dropShippingOption_SelectedIndexChanged);
			// 
			// sqlConnection1
			// 
			this.sqlConnection1.ConnectionString = "workstation id=CHERRY;packet size=4096;user id=gwu;data source=iisqlsrv;persist s" +
				"ecurity info=True;initial catalog=gwu_shipping;password=uwg";
			// 
			// sqlShippingMethods
			// 
			this.sqlShippingMethods.CommandText = @"SELECT foreign_methods.foreign_id, foreign_agents.name AS Carrier, foreign_methods.shipping_option AS 'Shipping Option', CASE price_type WHEN 'f' THEN price WHEN 'w' THEN price * CONVERT(MONEY, @weight) WHEN 'i' THEN price * CONVERT(MONEY, @items) END AS Price FROM foreign_methods INNER JOIN foreign_agents ON foreign_methods.agent = foreign_agents.id WHERE (CASE price_type WHEN 'f' THEN price WHEN 'w' THEN price * CONVERT(MONEY, @weight) WHEN 'i' THEN price * CONVERT(MONEY, @items) END <= ALL (SELECT CASE price_type WHEN 'f' THEN price WHEN 'w' THEN price * CONVERT(MONEY, @weight) WHEN 'i' THEN price * CONVERT(MONEY, @items) END FROM foreign_methods WHERE company = @company AND NOT EXISTS (SELECT * FROM foreign_unreachable_cities WHERE method = foreign_methods.id AND LOWER(city) = LOWER(@city)) AND foreign_methods.shipping_option = @OPTION)) AND (foreign_methods.company = @company) AND (NOT EXISTS (SELECT * FROM foreign_unreachable_cities WHERE method = foreign_methods.id AND LOWER(city) = LOWER(@city)))";
			this.sqlShippingMethods.Connection = this.sqlConnection1;
			this.sqlShippingMethods.Parameters.Add(new System.Data.SqlClient.SqlParameter("@company", System.Data.SqlDbType.VarChar, 50, "company"));
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void dropShippingOption_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			this.updateShippingMethodInfo();
		}
	}
}
