namespace gibble
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Data.SqlClient;

	/// <summary>
	///		Summary description for LoginStatus.
	/// </summary>
	public class LoginStatus : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.Panel pnlSignedIn;
		protected System.Web.UI.WebControls.Panel pnlSignedOut;
		protected System.Web.UI.WebControls.Label lblUser;
		protected System.Web.UI.WebControls.HyperLink linkMyAccount;
		protected System.Web.UI.WebControls.LinkButton linkSignOut;
		protected System.Web.UI.WebControls.Label lblNumItems;
		protected System.Data.SqlClient.SqlConnection sqlConnection1;
		protected System.Data.SqlClient.SqlCommand sqlCmdNumItems;
		protected System.Web.UI.WebControls.HyperLink linkSignIn;

		public void updateItemCount()
		{
			this.sqlConnection1.Open();
			this.sqlCmdNumItems.Parameters["@user"].Value = this.Session["user"];
			SqlDataReader reader = this.sqlCmdNumItems.ExecuteReader();
			if (reader.Read() && !reader.GetSqlInt32(0).IsNull)
			{
				this.lblNumItems.Text = reader.GetInt32(0).ToString();
			}
			else
			{
				this.lblNumItems.Text = "0";
			}
			this.sqlConnection1.Close();
		}

		private void initializeView()
		{
			if (this.Session["user"] != null)
			{
				this.lblUser.Text = (string)this.Session["user"];
				this.pnlSignedIn.Visible = true;
				this.pnlSignedOut.Visible = false;
				this.updateItemCount();
			}
			else
			{
				this.pnlSignedIn.Visible = false;
				this.pnlSignedOut.Visible = true;
			}
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			this.initializeView();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.sqlConnection1 = new System.Data.SqlClient.SqlConnection();
			this.sqlCmdNumItems = new System.Data.SqlClient.SqlCommand();
			this.linkSignOut.Click += new System.EventHandler(this.linkSignOut_Click);
			// 
			// sqlConnection1
			// 
			this.sqlConnection1.ConnectionString = "server=IISQLSRV; uid=gwu; pwd=uwg; database=gwu_shipping";
			// 
			// sqlCmdNumItems
			// 
			this.sqlCmdNumItems.CommandText = @"SELECT SUM(nauledge_billing.dbo.shoppingCart.quantity) AS numItems, SUM(frewen_inventory.dbo.Products.weight * nauledge_billing.dbo.shoppingCart.quantity) AS totalWeight FROM nauledge_billing.dbo.shoppingCart INNER JOIN frewen_inventory.dbo.Products ON nauledge_billing.dbo.shoppingCart.product = frewen_inventory.dbo.Products.catalog# WHERE (nauledge_billing.dbo.shoppingCart.customer = @user)";
			this.sqlCmdNumItems.Connection = this.sqlConnection1;
			this.sqlCmdNumItems.Parameters.Add(new System.Data.SqlClient.SqlParameter("@user", System.Data.SqlDbType.VarChar, 30, "customer"));
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void linkSignOut_Click(object sender, System.EventArgs e)
		{
			this.Session.Remove("user");
			this.initializeView();
			this.Response.Redirect("BrowseInventory.aspx");
		}
	}
}
