using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace gibble
{
	/// <summary>
	/// Summary description for OrderHistory.
	/// </summary>
	public class OrderHistory : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid PackagesGrid;
		protected System.Data.SqlClient.SqlCommand sqlCommand1;
		protected System.Data.SqlClient.SqlDataAdapter sqlDataAdapter1;
		protected gibble.PackageInfoDataSet packageInfoDataSet1;
		protected System.Data.SqlClient.SqlCommand sqlSelectCommand1;
		protected System.Data.SqlClient.SqlCommand sqlInsertCommand1;
		protected System.Data.DataView dataView1;
		protected System.Web.UI.WebControls.Panel DetailPanel;
		protected System.Web.UI.WebControls.Label lblTracking;
		protected System.Web.UI.WebControls.Label lblItems;
		protected System.Web.UI.WebControls.Label lblWeight;
		protected System.Web.UI.WebControls.Label lblComments;
		protected System.Web.UI.WebControls.Label lblWarehouse;
		protected System.Web.UI.WebControls.Label lblLocation;
		protected System.Web.UI.WebControls.Label lblName;
		protected System.Web.UI.WebControls.Label lblAddress1;
		protected System.Web.UI.WebControls.Label lblAddress2;
		protected System.Web.UI.WebControls.Label lblCity;
		protected System.Web.UI.WebControls.Label lblState;
		protected System.Web.UI.WebControls.Label lblZipcode;
		protected System.Web.UI.WebControls.Label lblPhone;
		protected System.Web.UI.WebControls.Label lblAgent;
		protected System.Web.UI.WebControls.Label lblOption;
		protected System.Web.UI.WebControls.Label lblPrice;
		protected System.Web.UI.WebControls.Label lblStatus;
		protected System.Web.UI.WebControls.Label lblDateExpected;
		protected System.Data.SqlClient.SqlCommand sqlCommand2;
		protected System.Web.UI.WebControls.Button btnBackToOrderHistory;
		protected System.Web.UI.WebControls.Label lblNoPackages;
		protected System.Web.UI.WebControls.Label lblNoInvoices;
		protected System.Web.UI.WebControls.DataGrid InvoicesGrid;
		protected System.Web.UI.WebControls.Label lblErr;
		protected System.Web.UI.WebControls.TextBox txtInvoiceid;
		protected System.Web.UI.WebControls.Button btnInvoiceSubmit;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidator1;
		protected System.Data.SqlClient.SqlConnection sqlConnection1;

		private SqlConnection sqlConn;	// Declare a connection object
		private SqlCommand sqlCom;		  // Declare a command object
		private SqlDataReader sqlRdr;
		private string strSqlString = "server=IISQLSRV; uid=nauledge; pwd=nm,.NM<>; database=nauledge_billing";

		protected System.Web.UI.WebControls.Panel InvoicePanel;
		protected System.Web.UI.WebControls.Panel InvoiceDetailPanel;
		protected System.Web.UI.WebControls.Label lblNotFound;
		protected System.Web.UI.WebControls.Label lblInvoiceid;
		protected System.Web.UI.WebControls.Label lblDate;
		protected System.Web.UI.WebControls.Label lblShipdate;
		protected System.Web.UI.WebControls.Label lblShipAdd;
		protected System.Web.UI.WebControls.Label lblShipCity;
		protected System.Web.UI.WebControls.Label lblShipState;
		protected System.Web.UI.WebControls.Label lblShipZip;
		protected System.Web.UI.WebControls.Label lblSubtotal;
		protected System.Web.UI.WebControls.Label lblTaxes;
		protected System.Web.UI.WebControls.Label lblDiscounts;
		protected System.Web.UI.WebControls.Label lblShipcosts;
		protected System.Web.UI.WebControls.Label lblTotal;
		protected System.Web.UI.WebControls.Label lblPayment;
		protected System.Web.UI.WebControls.Label lblCCnum;
		protected System.Web.UI.WebControls.Label lblCCExp;
		protected System.Web.UI.WebControls.Panel FormPanel;
		
	
		private void fillDataGrid(int id)
		{
			this.sqlDataAdapter1.SelectCommand.Parameters["@user"].Value = this.Session["user"];
			this.sqlDataAdapter1.SelectCommand.Parameters["@id"].Value = id;
			this.sqlDataAdapter1.Fill(packageInfoDataSet1, "package_info");
			PackagesGrid.DataBind();
			if (this.packageInfoDataSet1.Tables["package_info"].Rows.Count == 0)
			{
				this.PackagesGrid.Visible = false;
				this.lblNoPackages.Visible = true;
			}
			else
			{
				this.PackagesGrid.Visible = true;
				this.lblNoPackages.Visible = false;
			}
		}

		private void fillInvoiceGrid()
		{
			// Start a new connection to the database specified in strSqlString
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection


			// Execute query -- Here you could make 'strSql' any query you want
			string strSql = "SELECT invoiceid as InvoiceID, date as Date, shipdate as Shipped  " +
				"FROM invoices " + 
				"WHERE buyer = '" + this.Session["user"].ToString() + "'";
						
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			// Get the answer from the reader and write it to the label.
			if (sqlRdr.HasRows) 
			{
				InvoicesGrid.DataSource = sqlRdr;
				InvoicesGrid.DataBind();
				InvoicesGrid.Visible = true;
				lblNoInvoices.Visible = false;
			}
			else 
			{
				InvoicesGrid.Visible = false;
				lblNoInvoices.Visible = true;

			}
			
			// Close the sql connection at the end
			sqlConn.Close();
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (this.Session["user"] == null)
			{
				this.Session["redirect"] = "OrderHistory.aspx";
				this.Response.Redirect("Login.aspx");
			}
			if (!this.IsPostBack)
			{
				this.InvoiceDetailPanel.Visible = false;
				this.FormPanel.Visible = false;
				this.DetailPanel.Visible = false;
				this.fillInvoiceGrid();
				//this.fillDataGrid();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.sqlDataAdapter1 = new System.Data.SqlClient.SqlDataAdapter();
			this.sqlInsertCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlConnection1 = new System.Data.SqlClient.SqlConnection();
			this.sqlSelectCommand1 = new System.Data.SqlClient.SqlCommand();
			this.packageInfoDataSet1 = new gibble.PackageInfoDataSet();
			this.sqlCommand2 = new System.Data.SqlClient.SqlCommand();
			((System.ComponentModel.ISupportInitialize)(this.packageInfoDataSet1)).BeginInit();
			this.InvoicesGrid.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.InvoicesGrid_ItemCommand);
			this.btnInvoiceSubmit.Click += new System.EventHandler(this.btnInvoiceSubmit_Click);
			this.PackagesGrid.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.PackagesGrid_ItemCommand);
			this.PackagesGrid.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.PackagesGrid_PageIndexChanged);
			this.PackagesGrid.SelectedIndexChanged += new System.EventHandler(this.PackagesGrid_SelectedIndexChanged);
			this.btnBackToOrderHistory.Click += new System.EventHandler(this.btnBackToOrderHistory_Click);
			// 
			// sqlDataAdapter1
			// 
			this.sqlDataAdapter1.InsertCommand = this.sqlInsertCommand1;
			this.sqlDataAdapter1.SelectCommand = this.sqlSelectCommand1;
			this.sqlDataAdapter1.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									  new System.Data.Common.DataTableMapping("Table", "package_info", new System.Data.Common.DataColumnMapping[] {
																																																					  new System.Data.Common.DataColumnMapping("Tracking number", "Tracking number"),
																																																					  new System.Data.Common.DataColumnMapping("Name", "Name"),
																																																					  new System.Data.Common.DataColumnMapping("City", "City"),
																																																					  new System.Data.Common.DataColumnMapping("Weight", "Weight")})});
			// 
			// sqlInsertCommand1
			// 
			this.sqlInsertCommand1.CommandText = "INSERT INTO package_info(trackingid, name, city, total_weight) VALUES (@trackingi" +
				"d, @name, @city, @total_weight); SELECT trackingid AS \'Tracking number\', name AS" +
				" Name, city AS City, total_weight AS Weight FROM package_info";
			this.sqlInsertCommand1.Connection = this.sqlConnection1;
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@trackingid", System.Data.SqlDbType.Int, 4, "Tracking number"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@name", System.Data.SqlDbType.VarChar, 50, "Name"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@city", System.Data.SqlDbType.VarChar, 30, "City"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@total_weight", System.Data.SqlDbType.Float, 8, "Weight"));
			// 
			// sqlConnection1
			// 
			this.sqlConnection1.ConnectionString = "server=IISQLSRV; uid=gwu; pwd=uwg; database=gwu_shipping";
			// 
			// sqlSelectCommand1
			// 
			this.sqlSelectCommand1.CommandText = @"SELECT DISTINCT package_info.trackingid AS 'Tracking number', package_info.name AS Name, package_info.city AS City, package_info.total_weight AS Weight, package_info.invoice FROM package_info INNER JOIN nauledge_billing.dbo.Invoices ON package_info.invoice = @id WHERE (nauledge_billing.dbo.Invoices.buyer = @user)";
			this.sqlSelectCommand1.Connection = this.sqlConnection1;
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@id", System.Data.SqlDbType.Int, 4, "invoice"));
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@user", System.Data.SqlDbType.VarChar, 30, "buyer"));
			// 
			// packageInfoDataSet1
			// 
			this.packageInfoDataSet1.DataSetName = "PackageInfoDataSet";
			this.packageInfoDataSet1.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// sqlCommand2
			// 
			this.sqlCommand2.CommandText = "SELECT trackingid, warehouse, location, name, address1, address2, city, state, zi" +
				"pcode, phone, comments, num_items, total_weight, agent, shipping_option, total_p" +
				"rice, status, date_expected FROM package_info WHERE (trackingid = @id)";
			this.sqlCommand2.Connection = this.sqlConnection1;
			this.sqlCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@id", System.Data.SqlDbType.Int, 4, "trackingid"));
			this.Load += new System.EventHandler(this.Page_Load);
			((System.ComponentModel.ISupportInitialize)(this.packageInfoDataSet1)).EndInit();

		}
		#endregion

		/*
		private void findButton_Click(object sender, System.EventArgs e)
		{
			this.sqlConnection1.Open();
			this.sqlCommand2.Parameters.Clear();
			this.sqlCommand2.Parameters.Add("@id", this.trackingNumber.Text);
			SqlDataReader reader = sqlCommand2.ExecuteReader();
			if (reader.HasRows)
			{
				this.FormPanel.Visible = false;
				this.DetailPanel.Visible = true;
				this.errorInvalid.Visible = false;
				this.FillDetails(reader);
			}
			else
			{
				// bad tracking number
				this.FormPanel.Visible = true;
				this.DetailPanel.Visible = false;
				this.errorInvalid.Visible = true;
			}
			this.sqlConnection1.Close();
		}
		*/

		private void PackagesGrid_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		}

		private void sqlDataAdapter1_RowUpdated(object sender, System.Data.SqlClient.SqlRowUpdatedEventArgs e)
		{
		
		}

		private void PackagesGrid_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			PackagesGrid.CurrentPageIndex = e.NewPageIndex;
			//this.fillDataGrid();
		}

		private void PackagesGrid_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			if (e.CommandName == "Select")
			{
				//this.FormPanel.Visible = false;
				this.DetailPanel.Visible = true;
				this.sqlConnection1.Open();
				this.sqlCommand2.Parameters.Clear();
				this.sqlCommand2.Parameters.Add("@id", e.Item.Cells[1].Text);
				SqlDataReader reader = sqlCommand2.ExecuteReader();
				this.FillDetails(reader);
				this.sqlConnection1.Close();
			}
		}


		private void FillDetails(SqlDataReader reader)
		{
			// get the result from the reader
			if (reader.Read())
			{
				this.lblTracking.Text = reader.GetSqlInt32(0).ToString();
				this.lblWarehouse.Text = reader.GetSqlInt32(1).ToString();
				this.lblLocation.Text = reader.GetSqlString(2).ToString();
				this.lblName.Text = reader.GetSqlString(3).ToString();
				this.lblAddress1.Text = reader.GetSqlString(4).ToString();
				this.lblAddress2.Text = reader.GetSqlString(5).ToString();
				this.lblCity.Text = reader.GetSqlString(6).ToString();
				this.lblState.Text = reader.GetSqlString(7).ToString();
				this.lblZipcode.Text = reader.GetSqlString(8).ToString();
				this.lblPhone.Text = reader.GetSqlString(9).ToString();
				this.lblComments.Text = reader.GetSqlString(10).ToString();
				this.lblItems.Text = reader.GetSqlInt32(11).ToString();
				this.lblWeight.Text = reader.GetValue(12).ToString();//GetSqlDouble(12).ToString();
				this.lblAgent.Text = reader.GetSqlString(13).ToString();
				this.lblOption.Text = reader.GetSqlString(14).ToString();
				this.lblPrice.Text = reader.GetSqlMoney(15).ToString();
				this.lblStatus.Text = reader.GetSqlString(16).ToString();
				this.lblDateExpected.Text = reader.GetSqlDateTime(17).ToString();
			}
		}

		private void btnBackToOrderHistory_Click(object sender, System.EventArgs e)
		{
			this.DetailPanel.Visible = false;
			this.FormPanel.Visible = true;
		}

		private void sqlDataAdapter2_RowUpdated(object sender, System.Data.SqlClient.SqlRowUpdatedEventArgs e)
		{
		
		}

		private void InvoicesGrid_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			if (e.CommandName == "ViewDetails")
			{
				ShowSpecificInvoice(e.Item.Cells[1].Text);
				/*
				this.InvoiceDetailPanel.Visible = true;
				this.InvoicePanel.Visible = false;

				// do stuff if they click on the view button
				// based on:
				// e.Item.Cells[1].Text; gives me the invoice id

				// Start a new connection to the database specified in strSqlString
				sqlConn = new SqlConnection( strSqlString );
				sqlConn.Open();	// open the connection


				// Execute query -- Here you could make 'strSql' any query you want
				string strSql = "SELECT invoiceid, date, shipdate, shiptoadd, shiptocity, shiptostate, shiptozip, " +
					"(totalcost - taxes - shipcost + discounts) as subtotal, " +
					"taxes, discounts, shipcost, totalcost, paymenttype, ccnumber, ccexp " +
					"FROM invoices " + 
					"WHERE invoiceid = '" + e.Item.Cells[1].Text + "'";
						
				// The command needs to know the query and the connection
				sqlCom = new SqlCommand(strSql, sqlConn);	
				// Execute the command
				sqlRdr = sqlCom.ExecuteReader();

				// Get the answer from the reader and write it to the label.
				if (sqlRdr.HasRows) 
				{
					sqlRdr.Read();
					this.lblInvoiceid.Text = sqlRdr.GetInt32(0).ToString();
					this.lblDate.Text = sqlRdr.GetDateTime(1).ToString();
					this.lblShipdate.Text = sqlRdr.GetDateTime(2).ToString();
					this.lblShipAdd.Text = sqlRdr.GetString(3);
					this.lblShipCity.Text = sqlRdr.GetString(4);
					this.lblShipState.Text = sqlRdr.GetString(5);
					this.lblShipZip.Text = sqlRdr.GetString(6);
					this.lblSubtotal.Text = string.Format("{0:c}", sqlRdr.GetValue(7).ToString());
					this.lblTaxes.Text = string.Format("{0:c}", sqlRdr.GetValue(8).ToString());
					this.lblDiscounts.Text = string.Format("{0:c}", sqlRdr.GetValue(9).ToString());
					this.lblShipcosts.Text = string.Format("{0:c}", sqlRdr.GetValue(10).ToString());
					this.lblTotal.Text = string.Format("{0:c}", sqlRdr.GetValue(11).ToString());
					this.lblPayment.Text = sqlRdr.GetString(12);
					this.lblCCnum.Text = sqlRdr.GetString(13);
					this.lblCCExp.Text = sqlRdr.GetDateTime(14).ToString();
					
					this.FormPanel.Visible = true;
					this.fillDataGrid(sqlRdr.GetInt32(0));

					lblNoInvoices.Visible = false;
				}
				else 
				{
					this.lblNotFound.Visible = true;

				}
			
				// Close the sql connection at the end
				sqlConn.Close();
				*/
			}
		}

		private void ShowSpecificInvoice(string strId)
		{
			this.InvoiceDetailPanel.Visible = true;
			this.InvoicePanel.Visible = false;

			// do stuff if they click on the view button
			// based on:
			// e.Item.Cells[1].Text; gives me the invoice id

			// Start a new connection to the database specified in strSqlString
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection


			// Execute query -- Here you could make 'strSql' any query you want
			string strSql = "SELECT invoiceid, date, shipdate, shiptoadd, shiptocity, shiptostate, shiptozip, " +
				"(totalcost - taxes - shipcost + discounts) as subtotal, " +
				"taxes, discounts, shipcost, totalcost, paymenttype, ccnumber, ccexp " +
				"FROM invoices " + 
				//"WHERE invoiceid = '" + e.Item.Cells[1].Text + "'";
				"WHERE invoiceid =@id " + "and buyer = '" + this.Session["user"].ToString() + "'";
						
			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			sqlCom.Parameters.Add("@id", strId);
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			// Get the answer from the reader and write it to the label.
			if (sqlRdr.HasRows) 
			{
				sqlRdr.Read();
				this.lblInvoiceid.Text = sqlRdr.GetInt32(0).ToString();
				this.lblDate.Text = sqlRdr.GetDateTime(1).ToString();
				this.lblShipdate.Text = sqlRdr.GetDateTime(2).ToString();
				this.lblShipAdd.Text = sqlRdr.GetString(3);
				this.lblShipCity.Text = sqlRdr.GetString(4);
				this.lblShipState.Text = sqlRdr.GetString(5);
				this.lblShipZip.Text = sqlRdr.GetString(6);
				this.lblSubtotal.Text = string.Format("{0:c}", sqlRdr.GetValue(7).ToString());
				this.lblTaxes.Text = string.Format("{0:c}", sqlRdr.GetValue(8).ToString());
				this.lblDiscounts.Text = string.Format("{0:c}", sqlRdr.GetValue(9).ToString());
				this.lblShipcosts.Text = string.Format("{0:c}", sqlRdr.GetValue(10).ToString());
				this.lblTotal.Text = string.Format("{0:c}", sqlRdr.GetValue(11).ToString());
				this.lblPayment.Text = sqlRdr.GetString(12);
				this.lblCCnum.Text = sqlRdr.GetString(13);
				this.lblCCExp.Text = sqlRdr.GetDateTime(14).ToString();
					
				this.FormPanel.Visible = true;
				this.fillDataGrid(sqlRdr.GetInt32(0));

				lblNoInvoices.Visible = false;
			}
			else 
			{
				this.lblNotFound.Visible = true;

			}
			
			// Close the sql connection at the end
			sqlConn.Close();

		}

		private void OrderGrid_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

		private void btnInvoiceSubmit_Click(object sender, System.EventArgs e)
		{
			ShowSpecificInvoice( txtInvoiceid.Text );
		}

	}
}
