<%@ Register TagPrefix="gibble" TagName="Navigation" Src="Navigation.ascx" %>
<%@ Page language="c#" Codebehind="ShoppingCart.aspx.cs" AutoEventWireup="false" Inherits="gibble.ShoppingCart" %>
<%@ Register TagPrefix="gibble" TagName="LoginStatus" Src="LoginStatus.ascx" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<HTML>
	<HEAD>
		<title>Gibble.com - Shopping Cart</title>
		<meta content="Microsoft Visual Studio .NET 7.1" name="GENERATOR">
		<meta content="C#" name="CODE_LANGUAGE">
		<meta content="JavaScript" name="vs_defaultClientScript">
		<meta content="http://schemas.microsoft.com/intellisense/ie5" name="vs_targetSchema">
		<LINK href="gibble.css" type="text/css" rel="stylesheet">
	</HEAD>
	<body>
		<form id="Form1" method="post" runat="server">
			<div class="content">
				<h1>Gibble.com</h1>
				<gibble:loginstatus id="loginstatus" runat="server"></gibble:loginstatus>
				<h2>Ordering</h2>
				<gibble:navigation id="nav" runat="server"></gibble:navigation>
				<div class="text"><asp:panel id="pnlCart" runat="server">
						<H3>Your Shopping Cart</H3>
						<asp:Label id="lblEmptyCart" runat="server" Font-Italic="True" Visible="False">Your shopping cart is empty.</asp:Label>
						<asp:Panel id="pnlGrid" runat="server">
							<asp:DataGrid id=cartGrid runat="server" GridLines="None" CellPadding="3" BackColor="White" CellSpacing="1" BorderWidth="2px" BorderStyle="Ridge" BorderColor="White" DataSource="<%# shoppingCartDataSet1 %>" DataMember="shoppingCart" AutoGenerateColumns="False" Font-Size="X-Small" DataKeyField="Product ID">
								<FooterStyle ForeColor="Black" BackColor="#C6C3C6"></FooterStyle>
								<SelectedItemStyle Font-Bold="True" ForeColor="White" BackColor="#9471DE"></SelectedItemStyle>
								<ItemStyle ForeColor="Black" BackColor="#DEDFDE"></ItemStyle>
								<HeaderStyle Font-Bold="True" ForeColor="#E7E7FF" BackColor="#4A3C8C"></HeaderStyle>
								<Columns>
									<asp:BoundColumn DataField="Product ID" SortExpression="Product ID" ReadOnly="True" HeaderText="Product ID"></asp:BoundColumn>
									<asp:BoundColumn DataField="Title" ReadOnly="True" HeaderText="Title"></asp:BoundColumn>
									<asp:BoundColumn DataField="Last Name" ReadOnly="True" HeaderText="Name"></asp:BoundColumn>
									<asp:TemplateColumn HeaderText="Quantity">
										<ItemTemplate>
											<asp:Label id=Label1 runat="server" Text='<%# DataBinder.Eval(Container, "DataItem.Quantity") %>'>
											</asp:Label>
										</ItemTemplate>
										<EditItemTemplate>
											<asp:TextBox id=QuantityTextBox runat="server" Text='<%# DataBinder.Eval(Container, "DataItem.Quantity") %>' Columns="3">
											</asp:TextBox>
											<asp:RangeValidator id="intValidator" runat="server" ErrorMessage="*must be a reasonable positive int"
												ControlToValidate="QuantityTextBox" Display="Dynamic" Type="Integer" MinimumValue="1" MaximumValue="99999"></asp:RangeValidator>
										</EditItemTemplate>
									</asp:TemplateColumn>
									<asp:BoundColumn DataField="Price" ReadOnly="True" HeaderText="Price" DataFormatString="{0:c}">
										<ItemStyle HorizontalAlign="Right"></ItemStyle>
									</asp:BoundColumn>
									<asp:EditCommandColumn ButtonType="LinkButton" UpdateText="Update" CancelText="Cancel" EditText="Edit"></asp:EditCommandColumn>
									<asp:ButtonColumn Text="Remove" CommandName="Delete"></asp:ButtonColumn>
								</Columns>
								<PagerStyle HorizontalAlign="Right" ForeColor="Black" BackColor="#C6C3C6"></PagerStyle>
							</asp:DataGrid>
							<BR>
							<TABLE width="100%">
								<TR>
									<TD><B>Subtotal:</B></TD>
									<TD align="right">
										<asp:Label id="lblCartSubTotal" runat="server">Label</asp:Label></TD>
								</TR>
								<TR>
									<TD><B>Tax:</B></TD>
									<TD align="right">
										<asp:Label id="lblCartTax" runat="server">Label</asp:Label></TD>
								</TR>
								<TR>
									<TD><B>Total (without shipping):</B></TD>
									<TD align="right">
										<asp:Label id="lblTotalWithoutShipping" runat="server">Label</asp:Label></TD>
								</TR>
								<TR>
									<TD colSpan="2">&nbsp;</TD>
								</TR>
								<TR>
									<TD align="right" colSpan="2">
										<asp:Button id="btnCheckOut" runat="server" Text="Check out" CssClass="fancyButton"></asp:Button></TD>
								</TR>
							</TABLE>
						</asp:Panel>
					</asp:panel><asp:panel id="pnlDeliveryAddress" runat="server" Visible="False">
						<H3>Step 1: Delivery Information</H3>
						<P>Please provide the delivery information for the shipping destination, or you may
							<asp:LinkButton id="linkShipToYourself" runat="server">ship to yourself</asp:LinkButton>.
							<asp:Label id="lblAddressError" runat="server" Visible="False" ForeColor="Red">Please fill all required fields</asp:Label></P>
						<TABLE>
							<TR>
								<TD>Name:</TD>
								<TD colSpan="3">
									<asp:TextBox id="txtName" runat="server" Columns="60"></asp:TextBox></TD>
							</TR>
							<TR>
								<TD>Address 1:</TD>
								<TD colSpan="3">
									<asp:TextBox id="txtAddress1" runat="server" Columns="60"></asp:TextBox></TD>
							</TR>
							<TR>
								<TD>Address 2:</TD>
								<TD colSpan="3">
									<asp:TextBox id="txtAddress2" runat="server" Columns="60"></asp:TextBox></TD>
							</TR>
							<TR>
								<TD>City:</TD>
								<TD>
									<asp:TextBox id="txtCity" runat="server"></asp:TextBox></TD>
								<TD>State:</TD>
								<TD>
									<asp:TextBox id="txtState" runat="server" Columns="2" MaxLength="2"></asp:TextBox></TD>
							</TR>
							<TR>
								<TD>Phone:</TD>
								<TD>
									<asp:TextBox id="txtPhone1" runat="server" Columns="3" MaxLength="3"></asp:TextBox>-
									<asp:TextBox id="txtPhone2" runat="server" Columns="3" MaxLength="3"></asp:TextBox>-
									<asp:TextBox id="txtPhone3" runat="server" Columns="4" MaxLength="4"></asp:TextBox></TD>
								<TD>Zipcode:</TD>
								<TD>
									<asp:TextBox id="txtZip" runat="server" Columns="5" MaxLength="5"></asp:TextBox></TD>
							</TR>
							<TR>
								<TD colSpan="4">&nbsp;</TD>
							</TR>
							<TR>
								<TD vAlign="top">Special instructions:</TD>
								<TD colSpan="3">
									<asp:TextBox id="txtSpecialInstructions" runat="server" Columns="45" TextMode="MultiLine" Rows="5"></asp:TextBox></TD>
							</TR>
							<TR>
								<TD colSpan="4">&nbsp;</TD>
							</TR>
							<TR>
								<TD align="left" colSpan="2">
									<asp:Button id="btnBack" runat="server" Text="<< Back to Shopping Cart" CssClass="fancyButton"></asp:Button></TD>
								<TD align="right" colSpan="2">
									<asp:Button id="btnContinue" runat="server" Text="Continue to Shipping Options >>" CssClass="fancyButton"></asp:Button></TD>
							</TR>
						</TABLE>
					</asp:panel><asp:panel id="pnlShippingOptions" runat="server" Visible="False">
						<H3>Step 2: Shipping Method</H3>
						<P>
							<asp:Label id="lblChooseShippingOptions" runat="server">Please choosing shipping options for your package(s) below</asp:Label>
							<asp:Label id="lblOutOfStock" runat="server">We're sorry, your order cannot be shipped at this time.</asp:Label></P>
						<P>
							<asp:PlaceHolder id="holderShippingMethodChoosers" runat="server"></asp:PlaceHolder></P>
						<P>
							<asp:Panel id="pnlForeignMethods" runat="server">
								<P>The following packages will be shipped by our partner companies.&nbsp; Please 
									choose your shipping method(s).</P>
								<P></P>
								<P>
									<asp:PlaceHolder id="holderForeignMethodChoosers" runat="server"></asp:PlaceHolder></P>
								<P>
							</asp:Panel></P>
						<asp:Button id="btnBackToDeliveryInformation" style="FLOAT: left" runat="server" Text="<< Back to Delivery Information"
							CssClass="fancyButton"></asp:Button>
						<asp:Button id="btnPaymentMethod" style="FLOAT: right" runat="server" Text="Continue to Payment Method >>"
							CssClass="fancyButton"></asp:Button>
					</asp:panel><asp:panel id="pnlPaymentMethod" runat="server" Visible="False">
						<H3>Step 3:&nbsp;Payment Method</H3>
						<P>Please confirm your order below and choose a payment method.</P>
						<asp:DataGrid id=confirmGrid runat="server" Visible="False" GridLines="None" CellPadding="3" BackColor="White" CellSpacing="1" BorderWidth="2px" BorderStyle="Ridge" BorderColor="White" DataSource="<%# shoppingCartDataSet1 %>" DataMember="shoppingCart" AutoGenerateColumns="False" Font-Size="X-Small" DataKeyField="Product ID">
							<FooterStyle ForeColor="Black" BackColor="#C6C3C6"></FooterStyle>
							<SelectedItemStyle Font-Bold="True" ForeColor="White" BackColor="#9471DE"></SelectedItemStyle>
							<ItemStyle ForeColor="Black" BackColor="#DEDFDE"></ItemStyle>
							<HeaderStyle Font-Bold="True" ForeColor="#E7E7FF" BackColor="#4A3C8C"></HeaderStyle>
							<Columns>
								<asp:BoundColumn DataField="Product ID" SortExpression="Product ID" HeaderText="Product ID"></asp:BoundColumn>
								<asp:BoundColumn DataField="Title" SortExpression="Title" HeaderText="Title"></asp:BoundColumn>
								<asp:BoundColumn DataField="Quantity" SortExpression="Quantity" HeaderText="Quantity"></asp:BoundColumn>
								<asp:BoundColumn DataField="Last Name" SortExpression="Last Name" HeaderText="Name"></asp:BoundColumn>
								<asp:BoundColumn DataField="Price" SortExpression="Price" HeaderText="Price"></asp:BoundColumn>
							</Columns>
							<PagerStyle HorizontalAlign="Right" ForeColor="Black" BackColor="#C6C3C6"></PagerStyle>
						</asp:DataGrid>
						<BR>
						<TABLE width="100%">
							<TR>
								<TD><B>Subtotal:</B></TD>
								<TD align="right">
									<asp:Label id="lblConfirmSubtotal" runat="server">Label</asp:Label></TD>
							</TR>
							<TR>
								<TD><B>Tax:</B></TD>
								<TD align="right">
									<asp:Label id="lblConfirmTax" runat="server">Label</asp:Label></TD>
							</TR>
							<TR>
								<TD><B>Shipping:</B></TD>
								<TD align="right">
									<asp:Label id="lblConfirmShipping" runat="server">Label</asp:Label></TD>
							</TR>
							<TR>
								<TD><B>Total:</B></TD>
								<TD align="right">
									<asp:Label id="lblConfirmTotal" runat="server">Label</asp:Label></TD>
							</TR>
							<TR>
								<TD><B>Payment Type:</B></TD>
								<TD align="right">
									<asp:LinkButton id="lnkCreditCart" runat="server">Use previous credit card info</asp:LinkButton>
									<asp:DropDownList id="ddPaymenttype" runat="server">
										<asp:ListItem Value="Visa">Visa</asp:ListItem>
										<asp:ListItem Value="Mastercard">Mastercard</asp:ListItem>
										<asp:ListItem Value="Discover">Discover</asp:ListItem>
										<asp:ListItem Value="American Express">American Express</asp:ListItem>
									</asp:DropDownList></TD>
							</TR>
							<TR>
								<TD><B>Credit card #:</B></TD>
								<TD align="right">
									<asp:RegularExpressionValidator id="RegularExpressionValidator1" runat="server" ErrorMessage="Incorrect format"
										ControlToValidate="txtCCnum" ValidationExpression="\d{16}"></asp:RegularExpressionValidator>
									<asp:TextBox id="txtCCnum" runat="server" MaxLength="16"></asp:TextBox></TD>
							</TR>
							<TR>
								<TD><B>Exp. Date:</B></TD>
								<TD align="right">
									<asp:DropDownList id="ddMonth" runat="server">
										<asp:ListItem Value="1">1</asp:ListItem>
										<asp:ListItem Value="2">2</asp:ListItem>
										<asp:ListItem Value="3">3</asp:ListItem>
										<asp:ListItem Value="4">4</asp:ListItem>
										<asp:ListItem Value="5">5</asp:ListItem>
										<asp:ListItem Value="6">6</asp:ListItem>
										<asp:ListItem Value="7">7</asp:ListItem>
										<asp:ListItem Value="8">8</asp:ListItem>
										<asp:ListItem Value="9">9</asp:ListItem>
										<asp:ListItem Value="10">10</asp:ListItem>
										<asp:ListItem Value="11">11</asp:ListItem>
										<asp:ListItem Value="12">12</asp:ListItem>
									</asp:DropDownList>
									<asp:DropDownList id="ddYear" runat="server">
										<asp:ListItem Value="2005">2005</asp:ListItem>
										<asp:ListItem Value="2006">2006</asp:ListItem>
										<asp:ListItem Value="2007">2007</asp:ListItem>
										<asp:ListItem Value="2008">2008</asp:ListItem>
										<asp:ListItem Value="2009">2009</asp:ListItem>
										<asp:ListItem Value="2010">2010</asp:ListItem>
									</asp:DropDownList></TD>
							</TR>
							<TR>
								<TD colSpan="2">&nbsp;</TD>
							</TR>
							<TR>
								<TD align="left">
									<asp:Button id="btnBackToShippingMethod" style="FLOAT: left" runat="server" Text="<< Back to Shipping Method"
										CssClass="fancyButton"></asp:Button></TD>
								<TD align="right">
									<asp:Button id="btnPlaceOrder" style="FLOAT: right" runat="server" Text="Place Order" CssClass="fancyButton"></asp:Button></TD>
							</TR>
						</TABLE>
					</asp:panel><asp:panel id="pnlOrderConfirmation" runat="server" Visible="False">
						<H3>Thank You: Order Confirmed</H3>
						<P><A href="BrowseInventory.aspx">Continue shopping!</A>
						</P>
						<P><A href="OrderHistory.aspx">Order History</A>
						</P>
					</asp:panel></div>
			</div>
		</form>
	</body>
</HTML>
