using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Xml;

namespace gibble
{
	/// <summary>
	/// Summary description for ShoppingCart.
	/// </summary>
	public class ShoppingCart : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid cartGrid;
		protected System.Data.SqlClient.SqlDataAdapter sqlDataAdapter1;
		protected System.Data.SqlClient.SqlCommand sqlSelectCommand1;
		protected gibble.shoppingCartDataSet shoppingCartDataSet1;
		protected System.Data.SqlClient.SqlCommand sqlDeleteFromCart;
		protected System.Web.UI.WebControls.Label lblEmptyCart;
		protected System.Web.UI.WebControls.Button btnCheckOut;
		protected System.Web.UI.WebControls.Panel pnlCart;
		protected System.Web.UI.WebControls.Panel pnlDeliveryAddress;
		protected System.Web.UI.WebControls.TextBox txtName;
		protected System.Web.UI.WebControls.TextBox txtAddress1;
		protected System.Web.UI.WebControls.TextBox txtAddress2;
		protected System.Web.UI.WebControls.TextBox txtCity;
		protected System.Web.UI.WebControls.TextBox txtState;
		protected System.Web.UI.WebControls.TextBox txtPhone1;
		protected System.Web.UI.WebControls.TextBox txtZip;
		protected System.Web.UI.WebControls.TextBox txtSpecialInstructions;
		protected System.Web.UI.WebControls.TextBox txtPhone2;
		protected System.Web.UI.WebControls.TextBox txtPhone3;
		protected System.Web.UI.WebControls.Button btnContinue;
		protected System.Web.UI.WebControls.Button btnBack;
		protected System.Web.UI.WebControls.Panel pnlShippingOptions;
		protected System.Web.UI.WebControls.Button btnPaymentMethod;
		protected System.Web.UI.WebControls.Button btnPlaceOrder;
		protected System.Web.UI.WebControls.Button btnBackToShippingMethod;
		protected System.Web.UI.WebControls.Panel pnlPaymentMethod;
		protected System.Web.UI.WebControls.Panel pnlOrderConfirmation;
		protected System.Data.SqlClient.SqlCommand sqlUpdateQuantity;
		protected System.Data.SqlClient.SqlCommand sqlGetTotals;
		protected System.Web.UI.WebControls.Label lblCartSubTotal;
		protected System.Web.UI.WebControls.Label lblCartTax;
		protected System.Web.UI.WebControls.Label lblTotalWithoutShipping;
		protected System.Web.UI.WebControls.Panel pnlGrid;
		protected System.Web.UI.WebControls.LinkButton linkShipToYourself;
		protected System.Data.SqlClient.SqlCommand sqlCmdUserInfo;
		protected System.Data.SqlClient.SqlCommand sqlShipAllFromDestination;
		protected System.Data.SqlClient.SqlCommand sqlShipAll;
		protected System.Data.SqlClient.SqlCommand sqlQueryPartial;
		protected System.Data.SqlClient.SqlCommand sqlShippingOptions;
		protected System.Web.UI.WebControls.Button btnBackToDeliveryInformation;
		protected System.Web.UI.WebControls.Label lblMethodOption;
		protected System.Web.UI.WebControls.PlaceHolder holderShippingMethodChoosers;
		protected System.Web.UI.WebControls.Label lblChooseShippingOptions;
		protected System.Web.UI.WebControls.Label lblOutOfStock;
		protected System.Web.UI.WebControls.DataGrid confirmGrid;
		protected System.Web.UI.WebControls.Label lblConfirmSubtotal;
		protected System.Web.UI.WebControls.Label lblConfirmTax;
		protected System.Web.UI.WebControls.Label lblConfirmTotal;
		protected System.Web.UI.WebControls.Label lblConfirmShipping;
		protected System.Data.SqlClient.SqlConnection sqlConnection1;
		protected LoginStatus loginstatus;

		private SqlConnection sqlConn;
		private SqlCommand sqlCom;
		private SqlDataReader sqlRdr;
		protected System.Web.UI.WebControls.DropDownList ddPaymenttype;
		protected System.Web.UI.WebControls.TextBox txtCCnum;
		protected System.Web.UI.WebControls.DropDownList ddMonth;
		protected System.Web.UI.WebControls.DropDownList ddYear;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidator1;
		protected System.Web.UI.WebControls.LinkButton lnkCreditCart;
		protected System.Web.UI.WebControls.Label lblAddressError;
		protected System.Data.SqlClient.SqlCommand sqlNumInStock;
		protected System.Web.UI.WebControls.Panel pnlForeignMethods;
		protected System.Web.UI.WebControls.PlaceHolder holderForeignMethodChoosers;
		protected System.Data.SqlClient.SqlCommand sqlForeignItems;
		protected System.Data.SqlClient.SqlCommand sqlGibbleCartItems;
		protected System.Data.SqlClient.SqlCommand sqlForeignShippingOptions;
		private string strSqlString = "server=IISQLSRV; uid=nauledge; pwd=nm,.NM<>; database=nauledge_billing";


		private void fillCartGrid()
		{
			this.shoppingCartDataSet1.Clear();
			this.sqlSelectCommand1.Parameters["@user"].Value = this.Session["user"];
			this.sqlDataAdapter1.Fill(shoppingCartDataSet1, "shoppingCart");
			if (this.shoppingCartDataSet1.shoppingCart.Rows.Count > 0)
			{
				this.cartGrid.DataBind();
				this.lblEmptyCart.Visible = false;
				this.cartGrid.Visible = true;

				// fill totals
				this.sqlConnection1.Open();
				this.sqlGetTotals.Parameters.Clear();
				this.sqlGetTotals.Parameters.Add("@user", this.Session["user"]);
				SqlDataReader reader = this.sqlGetTotals.ExecuteReader();
				if (reader.Read())
				{
					double subtotal = double.Parse(reader.GetValue(0).ToString());
					double total = double.Parse(reader.GetValue(1).ToString());
					this.lblCartSubTotal.Text = string.Format("{0:c}", subtotal);
					this.lblTotalWithoutShipping.Text = string.Format("{0:c}", total);
					double tax = total - subtotal;
					this.lblCartTax.Text = string.Format("{0:c}", tax);
				}
				
				this.sqlConnection1.Close();
			}
			else
			{
				this.pnlGrid.Visible = false;
				this.lblEmptyCart.Visible = true;
			}
		}

		private void fillOptions()
		{
			// fill shipping options
			ArrayList packagesList = (ArrayList)this.Session["packages"];
			if (packagesList != null)
			{
				this.holderShippingMethodChoosers.Controls.Clear();
				this.sqlConnection1.Open();
				foreach (Package p in packagesList)
				{
					ArrayList options = new ArrayList();
					int weight = p.Weight(this.sqlConnection1);
					int items = p.ItemCount();
					int warehouse = p.Warehouse;
					// run a sql query to get the options and intersect them with the options list
					this.sqlShippingOptions.Parameters["@city"].Value = this.txtCity.Text;
					this.sqlShippingOptions.Parameters["@warehouse"].Value = warehouse;
					this.sqlShippingOptions.Parameters["@items"].Value = items;
					this.sqlShippingOptions.Parameters["@weight"].Value = weight;
					SqlDataReader optionsReader = this.sqlShippingOptions.ExecuteReader();
					while (optionsReader.Read())
					{
						// add them all to the options list
						options.Add(optionsReader.GetString(0));
					}
					optionsReader.Close();

					// create a new shippingMethodChooser
					ShippingMethodChooser smc = (ShippingMethodChooser)this.LoadControl("ShippingMethodChooser.ascx");
					this.holderShippingMethodChoosers.Controls.Add(smc);
					smc.Initialize(options, this.txtCity.Text, packagesList.IndexOf(p));
				}
				this.sqlConnection1.Close();

				this.holderShippingMethodChoosers.Visible = true;
				this.btnPaymentMethod.Visible = true;
				this.lblOutOfStock.Visible = false;
				this.lblChooseShippingOptions.Visible = true;
			}
		}

		
		private void fillForeignOptions()
		{
			// fill shipping options
			ArrayList packagesList = (ArrayList)this.Session["foreignpackages"];
			if (packagesList != null)
			{
				this.holderForeignMethodChoosers.Controls.Clear();
				this.sqlConnection1.Open();
				foreach (Package p in packagesList)
				{
					ArrayList options = new ArrayList();
					int weight = p.Weight(this.sqlConnection1);
					int items = p.ItemCount();
					// run a sql query to get the options and intersect them with the options list
					this.sqlForeignShippingOptions.Parameters["@city"].Value = this.txtCity.Text;
					this.sqlForeignShippingOptions.Parameters["@company"].Value = p.Company;
					SqlDataReader optionsReader = this.sqlForeignShippingOptions.ExecuteReader();
					while (optionsReader.Read())
					{
						// add them all to the options list
						options.Add(optionsReader.GetString(0));
					}
					optionsReader.Close();

					// create a new shippingMethodChooser
					ForeignMethodChooser smc = (ForeignMethodChooser)this.LoadControl("ForeignMethodChooser.ascx");
					this.holderForeignMethodChoosers.Controls.Add(smc);
					smc.Initialize(options, this.txtCity.Text, p.Company, packagesList.IndexOf(p));
				}
				this.sqlConnection1.Close();

				this.pnlForeignMethods.Visible = true;
			}
		}

		private void showPanel(Panel p)
		{
			this.pnlCart.Visible = false;
			this.pnlDeliveryAddress.Visible = false;
			this.pnlShippingOptions.Visible = false;
			this.pnlPaymentMethod.Visible = false;
			this.pnlOrderConfirmation.Visible = false;
			p.Visible = true;
		}
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (this.Session["user"] == null)
			{
				// not logged in
				this.Session["redirect"] = "ShoppingCart.aspx";
				this.Response.Redirect("Login.aspx");
			}
			if (!this.IsPostBack)
			{
				this.fillCartGrid();
			}
			
			this.fillOptions();
			this.fillForeignOptions();

			if (this.Session["packages"] == null && this.cartHasPackages() ||
				this.Session["foreignpackages"] == null && this.cartHasForeignPackages())
			{
				// out of stock
			}
			if (this.Session["foreignpackages"] == null)
			{
				this.pnlForeignMethods.Visible = false;
			}
		}

		private bool cartHasPackages()
		{
			this.sqlConnection1.Open();
			this.sqlGibbleCartItems.Parameters["@user"].Value = this.Session["user"];
			SqlDataReader r = this.sqlGibbleCartItems.ExecuteReader();
			bool val;
			if (r.HasRows)
				val = true;
			else
				val = false;
			r.Close();
			this.sqlConnection1.Close();
			return val;
		}

		private bool cartHasForeignPackages()
		{
			this.sqlConnection1.Open();
			this.sqlForeignItems.Parameters["@user"].Value = this.Session["user"];
			SqlDataReader r = this.sqlForeignItems.ExecuteReader();
			bool val;
			if (r.HasRows)
				val = true;
			else
				val = false;
			r.Close();
			this.sqlConnection1.Close();
			return val;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.sqlConnection1 = new System.Data.SqlClient.SqlConnection();
			this.sqlDataAdapter1 = new System.Data.SqlClient.SqlDataAdapter();
			this.sqlSelectCommand1 = new System.Data.SqlClient.SqlCommand();
			this.shoppingCartDataSet1 = new gibble.shoppingCartDataSet();
			this.sqlDeleteFromCart = new System.Data.SqlClient.SqlCommand();
			this.sqlUpdateQuantity = new System.Data.SqlClient.SqlCommand();
			this.sqlGetTotals = new System.Data.SqlClient.SqlCommand();
			this.sqlCmdUserInfo = new System.Data.SqlClient.SqlCommand();
			this.sqlShipAllFromDestination = new System.Data.SqlClient.SqlCommand();
			this.sqlShipAll = new System.Data.SqlClient.SqlCommand();
			this.sqlQueryPartial = new System.Data.SqlClient.SqlCommand();
			this.sqlShippingOptions = new System.Data.SqlClient.SqlCommand();
			this.sqlNumInStock = new System.Data.SqlClient.SqlCommand();
			this.sqlForeignItems = new System.Data.SqlClient.SqlCommand();
			this.sqlGibbleCartItems = new System.Data.SqlClient.SqlCommand();
			this.sqlForeignShippingOptions = new System.Data.SqlClient.SqlCommand();
			((System.ComponentModel.ISupportInitialize)(this.shoppingCartDataSet1)).BeginInit();
			this.cartGrid.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.cartGrid_CancelCommand);
			this.cartGrid.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.cartGrid_EditCommand);
			this.cartGrid.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.cartGrid_UpdateCommand);
			this.cartGrid.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.cartGrid_DeleteCommand);
			this.btnCheckOut.Click += new System.EventHandler(this.btnCheckOut_Click);
			this.linkShipToYourself.Click += new System.EventHandler(this.linkShipToYourself_Click);
			this.btnBack.Click += new System.EventHandler(this.btnBack_Click);
			this.btnContinue.Click += new System.EventHandler(this.btnContinue_Click);
			this.btnBackToDeliveryInformation.Click += new System.EventHandler(this.btnBackToDeliveryInfo_Click);
			this.btnPaymentMethod.Click += new System.EventHandler(this.btnPaymentMethod_Click);
			this.lnkCreditCart.Click += new System.EventHandler(this.lnkCreditCart_Click);
			this.btnBackToShippingMethod.Click += new System.EventHandler(this.btnBackToShippingMethod_Click);
			this.btnPlaceOrder.Click += new System.EventHandler(this.btnPlaceOrder_Click);
			// 
			// sqlConnection1
			// 
			this.sqlConnection1.ConnectionString = "workstation id=CHERRY;packet size=4096;user id=gwu;data source=iisqlsrv;persist s" +
				"ecurity info=True;initial catalog=gwu_shipping;password=uwg";
			// 
			// sqlDataAdapter1
			// 
			this.sqlDataAdapter1.SelectCommand = this.sqlSelectCommand1;
			this.sqlDataAdapter1.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									  new System.Data.Common.DataTableMapping("Table", "shoppingCart", new System.Data.Common.DataColumnMapping[] {
																																																					  new System.Data.Common.DataColumnMapping("customer", "customer"),
																																																					  new System.Data.Common.DataColumnMapping("product", "product"),
																																																					  new System.Data.Common.DataColumnMapping("quantity", "quantity"),
																																																					  new System.Data.Common.DataColumnMapping("catalog#", "catalog#"),
																																																					  new System.Data.Common.DataColumnMapping("title", "title"),
																																																					  new System.Data.Common.DataColumnMapping("lastname", "lastname"),
																																																					  new System.Data.Common.DataColumnMapping("firstname", "firstname"),
																																																					  new System.Data.Common.DataColumnMapping("other_artists", "other_artists"),
																																																					  new System.Data.Common.DataColumnMapping("publisher-record_label", "publisher-record_label"),
																																																					  new System.Data.Common.DataColumnMapping("media_type", "media_type"),
																																																					  new System.Data.Common.DataColumnMapping("rating", "rating"),
																																																					  new System.Data.Common.DataColumnMapping("num_ratings", "num_ratings"),
																																																					  new System.Data.Common.DataColumnMapping("year", "year"),
																																																					  new System.Data.Common.DataColumnMapping("price", "price"),
																																																					  new System.Data.Common.DataColumnMapping("weight", "weight")})});
			// 
			// sqlSelectCommand1
			// 
			this.sqlSelectCommand1.CommandText = @"SELECT nauledge_billing.dbo.shoppingCart.product AS 'Product ID', nauledge_billing.dbo.shoppingCart.quantity AS Quantity, frewen_inventory.dbo.Products.title AS Title, frewen_inventory.dbo.Products.firstname AS 'First Name', frewen_inventory.dbo.Products.lastname AS 'Last Name', frewen_inventory.dbo.Products.media_type AS Type, frewen_inventory.dbo.Products.price * nauledge_billing.dbo.shoppingCart.quantity AS Price FROM nauledge_billing.dbo.shoppingCart INNER JOIN frewen_inventory.dbo.Products ON nauledge_billing.dbo.shoppingCart.product = frewen_inventory.dbo.Products.catalog# WHERE (nauledge_billing.dbo.shoppingCart.customer = @user)";
			this.sqlSelectCommand1.Connection = this.sqlConnection1;
			this.sqlSelectCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@user", System.Data.SqlDbType.VarChar, 30, "customer"));
			// 
			// shoppingCartDataSet1
			// 
			this.shoppingCartDataSet1.DataSetName = "shoppingCartDataSet";
			this.shoppingCartDataSet1.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// sqlDeleteFromCart
			// 
			this.sqlDeleteFromCart.CommandText = "DELETE FROM nauledge_billing.dbo.shoppingCart WHERE (product = @productid)";
			this.sqlDeleteFromCart.Connection = this.sqlConnection1;
			this.sqlDeleteFromCart.Parameters.Add(new System.Data.SqlClient.SqlParameter("@productid", System.Data.SqlDbType.VarChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "product", System.Data.DataRowVersion.Original, null));
			// 
			// sqlUpdateQuantity
			// 
			this.sqlUpdateQuantity.CommandText = "UPDATE nauledge_billing.dbo.shoppingCart SET quantity = @quantity WHERE (customer" +
				" = @user) AND (product = @product)";
			this.sqlUpdateQuantity.Connection = this.sqlConnection1;
			this.sqlUpdateQuantity.Parameters.Add(new System.Data.SqlClient.SqlParameter("@quantity", System.Data.SqlDbType.Int, 4, "quantity"));
			this.sqlUpdateQuantity.Parameters.Add(new System.Data.SqlClient.SqlParameter("@user", System.Data.SqlDbType.VarChar, 30, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "customer", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateQuantity.Parameters.Add(new System.Data.SqlClient.SqlParameter("@product", System.Data.SqlDbType.VarChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "product", System.Data.DataRowVersion.Original, null));
			// 
			// sqlGetTotals
			// 
			this.sqlGetTotals.CommandText = @"SELECT SUM(prods.price * nauledge_billing..shoppingCart.quantity) AS subtotal, SUM(prods.price * nauledge_billing..shoppingCart.quantity) * 1.088 AS total FROM (SELECT item, MIN(price) AS price FROM ((SELECT frewen_inventory..Products.catalog# AS item, frewen_inventory..Products.price FROM frewen_inventory..Products) UNION (SELECT frewen_inventory..Products.catalog# AS item, frewen_inventory..Products.price * (1 - frewen_inventory..Sales.reduction) AS price FROM frewen_inventory..Products LEFT OUTER JOIN frewen_inventory..Discounts ON frewen_inventory..Products.catalog# = frewen_inventory..Discounts.item LEFT OUTER JOIN frewen_inventory..Sales ON frewen_inventory..Discounts.sale = frewen_inventory..Sales.id WHERE ('2/10/05' >= frewen_inventory..Sales.startdate OR frewen_inventory..Sales.startdate IS NULL) AND ('2/10/05' <= frewen_inventory..Sales.enddate OR frewen_inventory..Sales.enddate IS NULL))) AS x GROUP BY item) AS prods, nauledge_billing..shoppingCart WHERE nauledge_billing..shoppingCart.customer = @user AND nauledge_billing..shoppingCart. product = prods.item";
			this.sqlGetTotals.Connection = this.sqlConnection1;
			this.sqlGetTotals.Parameters.Add(new System.Data.SqlClient.SqlParameter("@user", System.Data.SqlDbType.Text));
			// 
			// sqlCmdUserInfo
			// 
			this.sqlCmdUserInfo.CommandText = "SELECT fname, lname, address, city, state, zip, primaryphone FROM nauledge_billin" +
				"g.dbo.Customers WHERE (email = @user)";
			this.sqlCmdUserInfo.Connection = this.sqlConnection1;
			this.sqlCmdUserInfo.Parameters.Add(new System.Data.SqlClient.SqlParameter("@user", System.Data.SqlDbType.VarChar, 30, "email"));
			// 
			// sqlShipAllFromDestination
			// 
			this.sqlShipAllFromDestination.CommandText = @"SELECT s.warehouse FROM frewen_inventory.dbo.Stock s INNER JOIN frewen_inventory.dbo.Warehouses ON s.warehouse = frewen_inventory.dbo.Warehouses.id WHERE (s.item IN (SELECT product FROM nauledge_billing..shoppingCart WHERE customer = @USER AND quantity <= s.quantity)) AND (LOWER(frewen_inventory.dbo.Warehouses.city) = LOWER(@city)) GROUP BY s.warehouse HAVING (COUNT(s.item) = (SELECT COUNT(product) FROM nauledge_billing..shoppingCart WHERE customer = @USER))";
			this.sqlShipAllFromDestination.Connection = this.sqlConnection1;
			this.sqlShipAllFromDestination.Parameters.Add(new System.Data.SqlClient.SqlParameter("@city", System.Data.SqlDbType.VarChar));
			this.sqlShipAllFromDestination.Parameters.Add(new System.Data.SqlClient.SqlParameter("@USER", System.Data.SqlDbType.VarChar));
			// 
			// sqlShipAll
			// 
			this.sqlShipAll.CommandText = @"SELECT s.warehouse FROM frewen_inventory.dbo.Stock s INNER JOIN frewen_inventory.dbo.Warehouses ON s.warehouse = frewen_inventory.dbo.Warehouses.id WHERE (s.item IN (SELECT product FROM nauledge_billing..shoppingCart WHERE customer = @USER AND quantity <= s.quantity)) GROUP BY s.warehouse HAVING (COUNT(s.item) = (SELECT COUNT(product) FROM nauledge_billing..shoppingCart WHERE customer = @USER))";
			this.sqlShipAll.Connection = this.sqlConnection1;
			this.sqlShipAll.Parameters.Add(new System.Data.SqlClient.SqlParameter("@USER", System.Data.SqlDbType.VarChar));
			// 
			// sqlQueryPartial
			// 
			this.sqlQueryPartial.CommandText = @"SELECT s.warehouse, s.item, s.quantity AS warehouse_quantity FROM frewen_inventory.dbo.Stock s INNER JOIN nauledge_billing.dbo.shoppingCart cart ON s.item = cart.product AND s.item = cart.product INNER JOIN frewen_inventory.dbo.Warehouses ON s.warehouse = frewen_inventory.dbo.Warehouses.id WHERE (s.quantity > 0) AND (cart.customer = @USER) ORDER BY s.warehouse";
			this.sqlQueryPartial.Connection = this.sqlConnection1;
			this.sqlQueryPartial.Parameters.Add(new System.Data.SqlClient.SqlParameter("@USER", System.Data.SqlDbType.VarChar, 30, "customer"));
			// 
			// sqlShippingOptions
			// 
			this.sqlShippingOptions.CommandText = @"SELECT DISTINCT shipping_option AS 'Shipping Option' FROM methods, ships_via where not exists (select * from unreachable_cities where unreachable_cities.method = methods.id and LOWER(unreachable_cities.city) = LOWER(@city)) and (max_weight IS NULL OR (@weight <= max_weight)) AND (max_items IS NULL OR (@items <= max_items)) and methods.agent = ships_via.agent and ships_via.warehouse = @warehouse;";
			this.sqlShippingOptions.Connection = this.sqlConnection1;
			this.sqlShippingOptions.Parameters.Add(new System.Data.SqlClient.SqlParameter("@warehouse", System.Data.SqlDbType.Int, 4, "warehouse"));
			this.sqlShippingOptions.Parameters.Add(new System.Data.SqlClient.SqlParameter("@weight", System.Data.SqlDbType.Int));
			this.sqlShippingOptions.Parameters.Add(new System.Data.SqlClient.SqlParameter("@items", System.Data.SqlDbType.Int));
			this.sqlShippingOptions.Parameters.Add(new System.Data.SqlClient.SqlParameter("@city", System.Data.SqlDbType.VarChar));
			// 
			// sqlNumInStock
			// 
			this.sqlNumInStock.CommandText = @"SELECT SUM(frewen_inventory.dbo.Stock.quantity) AS Expr1 FROM frewen_inventory.dbo.Products INNER JOIN frewen_inventory.dbo.Stock ON frewen_inventory.dbo.Products.catalog# = frewen_inventory.dbo.Stock.item WHERE (frewen_inventory.dbo.Products.catalog# = @catNumber)";
			this.sqlNumInStock.Connection = this.sqlConnection1;
			this.sqlNumInStock.Parameters.Add(new System.Data.SqlClient.SqlParameter("@catNumber", System.Data.SqlDbType.VarChar, 10, "catalog#"));
			// 
			// sqlForeignItems
			// 
			this.sqlForeignItems.CommandText = @"SELECT products.company, products.catalog#, products.weight, cart.quantity FROM nauledge_billing.dbo.shoppingCart cart INNER JOIN frewen_inventory.dbo.Products products ON cart.product = products.catalog# WHERE (cart.customer = @user) AND (products.company IS NOT NULL) ORDER BY products.company";
			this.sqlForeignItems.Connection = this.sqlConnection1;
			this.sqlForeignItems.Parameters.Add(new System.Data.SqlClient.SqlParameter("@user", System.Data.SqlDbType.VarChar, 30, "customer"));
			// 
			// sqlGibbleCartItems
			// 
			this.sqlGibbleCartItems.CommandText = @"SELECT nauledge_billing.dbo.shoppingCart.product AS 'Product ID', nauledge_billing.dbo.shoppingCart.quantity AS Quantity, frewen_inventory.dbo.Products.title AS Title, frewen_inventory.dbo.Products.firstname AS 'First Name', frewen_inventory.dbo.Products.lastname AS 'Last Name', frewen_inventory.dbo.Products.media_type AS Type, frewen_inventory.dbo.Products.price * nauledge_billing.dbo.shoppingCart.quantity AS Price FROM nauledge_billing.dbo.shoppingCart INNER JOIN frewen_inventory.dbo.Products ON nauledge_billing.dbo.shoppingCart.product = frewen_inventory.dbo.Products.catalog# WHERE (nauledge_billing.dbo.shoppingCart.customer = @user) AND (frewen_inventory.dbo.Products.company IS NULL)";
			this.sqlGibbleCartItems.Connection = this.sqlConnection1;
			this.sqlGibbleCartItems.Parameters.Add(new System.Data.SqlClient.SqlParameter("@user", System.Data.SqlDbType.VarChar, 30, "customer"));
			// 
			// sqlForeignShippingOptions
			// 
			this.sqlForeignShippingOptions.CommandText = @"SELECT DISTINCT shipping_option AS 'Shipping Option' FROM foreign_methods WHERE (company = @company) AND (NOT EXISTS (SELECT * FROM foreign_unreachable_cities WHERE foreign_unreachable_cities.method = foreign_methods.id AND LOWER(foreign_unreachable_cities.city) = LOWER(@city)))";
			this.sqlForeignShippingOptions.Connection = this.sqlConnection1;
			this.sqlForeignShippingOptions.Parameters.Add(new System.Data.SqlClient.SqlParameter("@company", System.Data.SqlDbType.VarChar, 50, "company"));
			this.sqlForeignShippingOptions.Parameters.Add(new System.Data.SqlClient.SqlParameter("@city", System.Data.SqlDbType.VarChar));
			this.Unload += new System.EventHandler(this.ShoppingCart_Unload);
			this.Load += new System.EventHandler(this.Page_Load);
			((System.ComponentModel.ISupportInitialize)(this.shoppingCartDataSet1)).EndInit();

		}
		#endregion

		private void cartGrid_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			string productID = e.Item.Cells[0].Text;
			this.sqlConnection1.Open();
			this.sqlDeleteFromCart.Parameters["@productid"].Value = productID;
			this.sqlDeleteFromCart.ExecuteNonQuery();
			this.sqlConnection1.Close();
			this.sqlSelectCommand1.Parameters["@user"].Value = this.Session["user"];
			this.Response.Redirect("ShoppingCart.aspx"); // hack to reload the whole page so that user control updates.
		}

		private void btnCheckOut_Click(object sender, System.EventArgs e)
		{
			this.showPanel(this.pnlDeliveryAddress);
		}

		private void btnBack_Click(object sender, System.EventArgs e)
		{
			this.showPanel(this.pnlCart);
		}

		private bool checkFields()
		{
			return (this.txtName.Text != "" &&
				this.txtAddress1.Text != "" &&
				this.txtCity.Text != "" &&
				this.txtState.Text != "" &&
				this.txtZip.Text != "");
		}

		private void btnContinue_Click(object sender, System.EventArgs e)
		{
			if (!this.checkFields())
			{
				this.lblAddressError.Visible = true;
				return;
			}
			this.lblAddressError.Visible = false;
			

			// here we do all the computation required to make the packages
			// 1) check to see if there is a warehouse in the destination city
			//    that can fulfill the entire order
			this.Session.Remove("packages");
			this.sqlConnection1.Open();
			this.sqlShipAllFromDestination.Parameters["@USER"].Value = this.Session["user"].ToString();
			this.sqlShipAllFromDestination.Parameters["@city"].Value = this.txtCity.Text;
			SqlDataReader reader = this.sqlShipAllFromDestination.ExecuteReader();
			if (reader.Read())
			{
				// we can just ship from the returned warehouse
				// 2) insert into packages
				ArrayList packages = new ArrayList();
				// create a new package from that warehouse
				Package p = new Package(reader.GetInt32(0));
				reader.Close();
				this.sqlGibbleCartItems.Parameters["@user"].Value = this.Session["user"];
				reader = this.sqlGibbleCartItems.ExecuteReader();
				while (reader.Read())
				{
					// add the items in shopping cart to the package
					p.AddItem(reader.GetString(0), reader.GetInt32(1));
				}
				reader.Close();
				packages.Add(p);
				// store the package in the session
				this.Session["packages"] = packages;
			}
			else
			{
				reader.Close();
				// check if there are any warehouses with all the packages
				this.sqlShipAll.Parameters["@USER"].Value = this.Session["user"].ToString();
				SqlDataReader reader2 = this.sqlShipAll.ExecuteReader();
				if (reader2.Read())
				{
					// we can just ship from the returned warehouse
					// 3) insert into packages
					ArrayList packages = new ArrayList();
					// create a new pacakge from that warehouse
					Package p = new Package(reader2.GetInt32(0));
					reader2.Close();
					this.sqlGibbleCartItems.Parameters["@user"].Value = this.Session["user"];
					reader2 = this.sqlGibbleCartItems.ExecuteReader();
					while (reader2.Read())
					{
						// add the items in shopping cart to the package
						p.AddItem(reader2.GetString(0), reader2.GetInt32(1));
					}
					reader2.Close();
					packages.Add(p);
					// store the package in the session
					this.Session["packages"] = packages;
				}
				else
				{
					reader2.Close();
					// we need to fill the order in multiple packages

					// fill the dataset to find out what is in the cart
					this.shoppingCartDataSet1.Clear();
					this.sqlGibbleCartItems.Parameters["@user"].Value = this.Session["user"];
					this.sqlDataAdapter1.SelectCommand = this.sqlGibbleCartItems;
					this.sqlDataAdapter1.Fill(shoppingCartDataSet1, "shoppingCart");
					this.sqlDataAdapter1.SelectCommand = this.sqlSelectCommand1;

					// build a hashtable of items and their quantity remaining to be fulfilled
					Hashtable order = new Hashtable();
					foreach (DataRow row in this.shoppingCartDataSet1.Tables["shoppingCart"].Rows)
					{
						order.Add(row["Product ID"].ToString(), row["Quantity"]);
					}

					this.sqlQueryPartial.Parameters["@USER"].Value = this.Session["user"];
					SqlDataReader reader3 = this.sqlQueryPartial.ExecuteReader();
					ArrayList packages = new ArrayList();
					bool outOfStock = false;
					if (reader3.Read())
					{
						bool moreRows = true;
						while (moreRows && order.Count > 0) // while the order has not been fulfilled
						{
							// 4) insert into packages using the min(stock.quantity, cart.quantity) for each item)
							int warehouse = reader3.GetInt32(0);
							Package p = new Package(warehouse);

							do
							{
								string productID = reader3.GetString(1);
								int warehouseQuantity = reader3.GetInt32(2);
								int quantityToPackage = Math.Min(order[productID] == null ? 0 : (int)order[productID],
									warehouseQuantity);

								// insert the item into the package if it helps us
								if (quantityToPackage > 0)
								{
									p.AddItem(productID, quantityToPackage);
									order[productID] = (int)order[productID] - quantityToPackage;

									// remove the item from the hash of things in the cart that still need to be filled
									if ((int)order[productID] == 0)
										order.Remove(productID);
								}

								moreRows = reader3.Read();
							} while (moreRows && reader3.GetInt32(0) == warehouse);

							// add it to the packages list if it had anything in it
							if (p.ItemCount() > 0)
								packages.Add(p);
						}

						if (!moreRows && order.Count > 0)
						{
							// error, we didn't fulfill the order!!!
							outOfStock = true;
						}
					}
					reader3.Close();

					if (outOfStock)
						this.Session.Remove("packages");
					else
						this.Session["packages"] = packages;
				}
			}
			
			this.sqlConnection1.Close();

			// get the shipping options for the packages
			this.fillOptions();

			this.createForeignPackages();
			this.fillForeignOptions();

			if (this.Session["packages"] == null && this.cartHasPackages() ||
				this.Session["foreignpackages"] == null && this.cartHasForeignPackages())
			{
				// out of stock
			}
			if (this.Session["foreignpackages"] == null)
			{
				this.pnlForeignMethods.Visible = false;
			}

			this.showPanel(this.pnlShippingOptions);
		}

		private void createForeignPackages() 
		{
			// create the foreign packages and put them into
			// this.Session["foreignpackages"]
			this.sqlConnection1.Open();

			this.sqlForeignItems.Parameters["@user"].Value = this.Session["user"];

			SqlDataReader reader = this.sqlForeignItems.ExecuteReader();
			string previousCompany = string.Empty;
			ArrayList packages = new ArrayList();
			Package p = null;
			while (reader.Read())
			{
				string company = reader.GetString(0);
				if (company != previousCompany)
				{
					// create a new package
					p = new Package(company);
					packages.Add(p);
					previousCompany = p.Company;
				}
				
				// add to the package p
				p.AddItem(reader.GetString(1), reader.GetInt32(3));
			}
			this.sqlConnection1.Close();

			if (packages.Count > 0)
				this.Session["foreignpackages"] = packages;
			else
				this.Session.Remove("foreignpackages");
		}

		private void btnBackToDeliveryInfo_Click(object sender, System.EventArgs e)
		{
			this.showPanel(this.pnlDeliveryAddress);
		}

		private void btnPaymentMethod_Click(object sender, System.EventArgs e)
		{
			this.shoppingCartDataSet1.Clear();
			this.sqlSelectCommand1.Parameters["@user"].Value = this.Session["user"];
			this.sqlDataAdapter1.Fill(this.shoppingCartDataSet1, "shoppingCart");
			this.confirmGrid.DataBind();
			this.confirmGrid.Visible = true;
			double shippingPrice = 0.0f;
			foreach (ShippingMethodChooser smc in this.holderShippingMethodChoosers.Controls)
			{
				string priceString = smc.Price;
				priceString = priceString.Replace("$", "").Replace(",", "");
				shippingPrice += double.Parse(priceString);
			}
			foreach (ForeignMethodChooser smc in this.holderForeignMethodChoosers.Controls)
			{
				string priceString = smc.Price;
				priceString = priceString.Replace("$", "").Replace(",", "");
				shippingPrice += double.Parse(priceString);
			}
			this.lblConfirmSubtotal.Text = this.lblCartSubTotal.Text;
			this.lblConfirmTax.Text = this.lblCartTax.Text;
			this.lblConfirmShipping.Text = string.Format("{0:c}", shippingPrice);
			this.lblConfirmTotal.Text = string.Format("{0:c}",
				double.Parse(this.lblConfirmSubtotal.Text.Replace("$","").Replace(",","")) +
				double.Parse(this.lblConfirmTax.Text.Replace("$","").Replace(",","")) +
				shippingPrice
				);
			this.showPanel(this.pnlPaymentMethod);
		}

		private void btnBackToShippingMethod_Click(object sender, System.EventArgs e)
		{
			this.showPanel(this.pnlShippingOptions);
		}

		private void btnPlaceOrder_Click(object sender, System.EventArgs e)
		{
			// TODO: put all the queries here for checking out!
			// 1) create an invoice
			int invoiceid = this.createInvoice();

			// 2) create the packages that are associated with the invoice
			// 3) insert into to the tracking table with status "Shipped" for each package
			// 4) remove the items from the warehouse inventories
			
			// everything you need to know to do this is in this.Session["packages"]
			// which is an ArrayList of Packages (see Package.cs)

			ArrayList packages = (ArrayList)this.Session["packages"];

			int trackid = 0;
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection
			string strSql = "";
			ArrayList items;
			
			foreach (Package p in packages)
			{
				// Execute query -- Here you could make 'strSql' any query you want
				strSql = "insert into gwu_shipping..packages(warehouse, method, name, " +
					"address1, address2, city, state, zipcode, phone, " +
					"comments, invoice) " +
					"values( '" + 
					p.Warehouse.ToString() + "', '" +
					p.Method.ToString() + "', '" +
					this.txtName.Text + "', '" +
					this.txtAddress1.Text + "', '" +
					this.txtAddress2.Text + "', '" +
					this.txtCity.Text + "', '" +
					this.txtState.Text + "', '" +
					this.txtZip.Text + "', '" +
					this.txtPhone1.Text + "', '" +
					this.txtSpecialInstructions.Text + "', '" +
					invoiceid.ToString() + "');" +
					"select max(trackingid) from gwu_shipping..packages ";

				sqlCom = new SqlCommand(strSql, sqlConn);	
				sqlRdr = sqlCom.ExecuteReader();

				if (sqlRdr.Read()) 
				{
					trackid = int.Parse(sqlRdr.GetSqlInt32(0).ToString());
				}

				sqlRdr.Close();

				// INSERTED PACKAGE DONE,
				// TRACKID holds trackid for package just created

				strSql = "insert into gwu_shipping..tracking(package, " +
					"time_stamp, status) " +
					"values( '" + 
					trackid.ToString() + "', " +
					"getdate()" + ", '" +
					"Shipped" + "') ";

				sqlCom = new SqlCommand(strSql, sqlConn);	
				sqlRdr = sqlCom.ExecuteReader();
				sqlRdr.Close();

				// TRACKING STATUS SET
				// NOW REMOVE ITEMS FROM INVENTORY

				items = (ArrayList)p.Items;

				foreach (PackageItem r in items) 
				{
					strSql = "insert into gwu_shipping..contents(package, " +
						"item, quantity) " +
						"values( '" + 
						trackid.ToString() + "', '" +
						r.Item.ToString() + "', '" +
						r.Quantity.ToString() + "') ";

					sqlCom = new SqlCommand(strSql, sqlConn);	
					sqlRdr = sqlCom.ExecuteReader();
					sqlRdr.Close();

					// now update quantities in inventory
					strSql = "update frewen_inventory..Stock " +
						"set quantity = quantity - " + r.Quantity.ToString() + 
						" where item = '" + r.Item.ToString() + "' and " +
						"warehouse = '" + p.Warehouse.ToString() + "'";

					sqlCom = new SqlCommand(strSql, sqlConn);	
					sqlRdr = sqlCom.ExecuteReader();
					sqlRdr.Close();
				}
			}

			// The following code creates an XML doc for each foreign_package
			if (this.Session["foreignpackages"] != null) 
			{
				ArrayList foreignpackages = (ArrayList)this.Session["foreignpackages"];
				ArrayList foreignitems;
				foreach (Package f in foreignpackages) 
				{
					foreignitems = (ArrayList)f.Items;
					this.createOrderXML(f.Company, foreignitems, f.Method.ToString());
				}
			}

			// last thing to do is empty their shopping cart!
			strSql = "delete from shoppingCart " +
				"where customer = '" + this.Session["user"].ToString() + "'";

			sqlCom = new SqlCommand(strSql, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();
			sqlRdr.Close();

			sqlConn.Close();


			this.loginstatus.updateItemCount();
			this.showPanel(this.pnlOrderConfirmation);

		}

		private void createOrderXML(string partnerCo, ArrayList items, string method) 
		{
			SqlConnection sqlConnForeign = new SqlConnection( strSqlString );
			SqlCommand sqlComForeign;
			SqlDataReader sqlRdrForeign;
			string file = Server.MapPath(".\\Orders\\") + partnerCo + "-" + System.DateTime.Now.ToString().Replace("/","-").Replace(":","-").Replace(" ","_") + ".xml";
			System.IO.StreamWriter writer = new System.IO.StreamWriter(file);
			writer.Close();
			XmlDocument xml = new XmlDocument();

			StringBuilder builder = new StringBuilder();
			builder.Append("<order>");
			builder.AppendFormat("<issuingCompany>gibble</issuingCompany>");
			builder.AppendFormat("<partnerCompany>{0}</partnerCompany>", partnerCo);

			sqlConnForeign.Open();	// open the connection
			string type = "";
			string name = "";
			string strSql = "";

			foreach (PackageItem i in items)
			{
				strSql = "select media_type, title " +
					"from frewen_inventory..Products " +
					"where catalog# = '" + i.Item.ToString() + "'";
				sqlComForeign = new SqlCommand(strSql, sqlConnForeign);	
				sqlRdrForeign = sqlComForeign.ExecuteReader();
				if (sqlRdrForeign.Read()) 
				{
					type = sqlRdrForeign.GetString(0);
					name = sqlRdrForeign.GetString(1);
					if (type.StartsWith("b")) type = "book";
					else type = "music";
				}
				sqlRdrForeign.Close();

				builder.Append("<product>");
				builder.AppendFormat("<type>{0}</type>", type);
				builder.AppendFormat("<identifier>{0}</identifier>", i.Item);
				builder.AppendFormat("<name>{0}</name>", name);
				builder.AppendFormat("<quantity>{0}</quantity>", i.Quantity);
				builder.Append("</product>");
			}

			sqlConnForeign.Close();
			builder.AppendFormat("<shippingMethod>{0}</shippingMethod>", method);
			builder.Append("<destination>");
				builder.AppendFormat("<address>{0}</address>", this.txtAddress1.Text);
				builder.AppendFormat("<city>{0}</city>", this.txtCity.Text);
				builder.AppendFormat("<state>{0}</state>", this.txtState.Text);
				builder.AppendFormat("<zip>{0}</zip>", this.txtZip.Text);
				builder.Append("<contact>");
					builder.AppendFormat("<tel>{0}-{1}-{2}</tel>", this.txtPhone1.Text, this.txtPhone2.Text, this.txtPhone3.Text);	
					builder.AppendFormat("<fax></fax>");
				builder.Append("</contact>");
			builder.Append("</destination>");
			builder.Append("</order>");

			xml.LoadXml(builder.ToString());
			xml.Save(file);
		}

		private int createInvoice() 
		{
			double discount = this.computeDiscounts();

			// create invoice
			// Start a new connection to the database specified in strSqlString
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection

			// Execute query -- Here you could make 'strSql' any query you want
			string strSql = "insert into invoices(buyer, shiptozip, shiptostate, " +
								"shiptocity, shiptoadd, date, taxes, discounts, shipcost, " +
								"totalcost, shipdate, paymenttype, ccnumber, ccexp) " +
							"values( '" + 
								this.Session["user"].ToString() + "', '" +
								this.txtZip.Text + "', '" +
								this.txtState.Text + "', '" +
								this.txtCity.Text + "', '" +
								this.txtAddress1.Text + " " + this.txtAddress2.Text + "', " +
								"getdate()" + ", '" +
								this.lblConfirmTax.Text.Replace("$", "").Replace(",", "") + "', '" +
								discount.ToString() + "', '" +
								this.lblConfirmShipping.Text.Replace("$", "").Replace(",", "") + "', '" +
								this.lblConfirmTotal.Text.Replace("$", "").Replace(",", "") + "', " +
								"getdate()" + ", '" +
								this.ddPaymenttype.SelectedValue.ToString() + "', '" +
								this.txtCCnum.Text + "', '" +
								this.ddMonth.SelectedValue.ToString() + "/1/" + this.ddYear.SelectedValue.ToString() + "');" +
					"select max(invoiceid) from invoices ";


			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			int invoiceid = 0;
			if (sqlRdr.Read()) 
			{
				invoiceid = int.Parse(sqlRdr.GetSqlInt32(0).ToString());
			}

			sqlConn.Close();

			return invoiceid;
		}

		private double computeDiscounts() 
		{
			// create invoice
		
			// Start a new connection to the database specified in strSqlString
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	// open the connection
		

			// Execute query -- Here you could make 'strSql' any query you want
			string strSql = "SELECT	sum(frewen_inventory..Products.price*nauledge_billing..shoppingCart.quantity) as subtotalWO " +
						"FROM	frewen_inventory..Products, nauledge_billing..shoppingCart " +
						"WHERE	nauledge_billing..shoppingCart.customer = '" + this.Session["user"].ToString() + "' " +
						"and nauledge_billing..shoppingCart.product = frewen_inventory..Products.catalog#";

			// The command needs to know the query and the connection
			sqlCom = new SqlCommand(strSql, sqlConn);	
			// Execute the command
			sqlRdr = sqlCom.ExecuteReader();

			// Get the answer from the reader and write it to the label.
			double subwith = 0, subwithout = 0;

			if (sqlRdr.Read()) 
			{
				subwithout = double.Parse(sqlRdr.GetDecimal(0).ToString());
				subwith = double.Parse(this.lblConfirmSubtotal.Text.Replace("$", "").Replace(",", ""));
			}
			else 
			{
				// Shouldn't happen
			}

		
			// Close the sql connection at the end
			sqlConn.Close();
		

			return subwithout - subwith;
		}


		private void cartGrid_EditCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			this.cartGrid.EditItemIndex = e.Item.ItemIndex;
			this.fillCartGrid();
		}

		private void cartGrid_CancelCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			this.cartGrid.EditItemIndex = -1;
			this.fillCartGrid();
		}

		private int numInStock(string product)
		{
			this.sqlConnection1.Open();
			this.sqlNumInStock.Parameters["@catNumber"].Value = product;
			int result = (int)this.sqlNumInStock.ExecuteScalar();
			this.sqlConnection1.Close();
			return result;
		}

		private void cartGrid_UpdateCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			// extract the new quantity
			RangeValidator validator = (RangeValidator)e.Item.Cells[3].FindControl("intValidator");
			validator.Validate();
			if (validator.IsValid)
			{
				TextBox textbox = (TextBox)e.Item.Cells[3].FindControl("QuantityTextBox");
			
				try
				{
					int quantity = int.Parse(textbox.Text);
					if (quantity > 0 && quantity <= this.numInStock(e.Item.Cells[0].Text))
					{
						// update quantity
						this.sqlConnection1.Open();
						this.sqlUpdateQuantity.Parameters["@user"].Value = this.Session["user"];
						this.sqlUpdateQuantity.Parameters["@product"].Value = e.Item.Cells[0].Text;
						this.sqlUpdateQuantity.Parameters["@quantity"].Value = quantity;
						this.sqlUpdateQuantity.ExecuteNonQuery();
						this.sqlConnection1.Close();

						this.Response.Redirect("ShoppingCart.aspx");
					}
					else
					{
						// error
					}
				}
				catch
				{
					
				}
			}
		}

		private void linkShipToYourself_Click(object sender, System.EventArgs e)
		{
			// fill the form with user info
			this.sqlConnection1.Open();
			this.sqlCmdUserInfo.Parameters["@user"].Value = this.Session["user"];
			SqlDataReader reader = this.sqlCmdUserInfo.ExecuteReader();
			if (reader.Read())
			{
				this.txtName.Text = reader.GetSqlString(0).ToString() + reader.GetSqlString(1).ToString();
				this.txtAddress1.Text = reader.GetSqlString(2).ToString();
				this.txtCity.Text = reader.GetSqlString(3).ToString();
				this.txtState.Text = reader.GetSqlString(4).ToString();
				this.txtZip.Text = reader.GetSqlString(5).ToString();
				string[] phone = reader.GetSqlString(6).ToString().Split(new char[] {'-'});
				if (phone.Length == 3)
				{
					this.txtPhone1.Text = phone[0];
					this.txtPhone2.Text = phone[1];
					this.txtPhone3.Text = phone[2];
				}
			}
			this.sqlConnection1.Close();
		}

		private void ShoppingCart_Unload(object sender, System.EventArgs e)
		{
			// clean up any any packages and invoices that haven't been shipped (null methods)
		}

		private void lnkCreditCart_Click(object sender, System.EventArgs e)
		{
			this.sqlConnection1.Open();
			string cmdString = "select paymenttype, ccnumber, month(ccexp), year(ccexp) " +
				"from nauledge_billing..invoices " +
				"where buyer = @user " +
				"and date >= ALL(select date " +
								"from nauledge_billing..invoices " +
								"where buyer = @user )";
			SqlCommand command = new SqlCommand(cmdString, this.sqlConnection1);
			command.Parameters.Add("@user", this.Session["user"]);

			SqlDataReader reader = command.ExecuteReader();

			if (reader.Read())
			{
				this.ddPaymenttype.SelectedValue = reader.GetString(0);
				this.txtCCnum.Text = reader.GetString(1);
				this.ddMonth.SelectedValue = reader.GetValue(2).ToString();
				this.ddYear.SelectedValue = reader.GetValue(3).ToString();
			}
			else
			{
				this.lnkCreditCart.Visible = false;
			}

			reader.Close();

			this.sqlConnection1.Close();
		}
	}
}
