using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Data.SqlClient;	// This is the library with the SQL types we're using below


namespace gibble
{
	/// <summary>
	/// Summary description for ManagerQueries.
	/// </summary>
	public class ManagerQueries : System.Web.UI.Page
	{
		private SqlConnection sqlConn;	// Declare a connection object
		private SqlCommand sqlCom;		  // Declare a command object
		private SqlDataReader sqlRdr;	  // Declare a reader to read the query result
		private string strSqlString = "server=IISQLSRV; uid=frewen; pwd=grovVer; database=frewen_inventory";

		protected System.Web.UI.WebControls.DataGrid dgSales;
		protected System.Web.UI.WebControls.DataGrid dgWarehouse;
		protected System.Web.UI.WebControls.Button btnWarehouses;
		protected System.Web.UI.WebControls.Label lblWHDetailTitle;
		protected System.Web.UI.WebControls.DataGrid dgWHitems;
		protected System.Web.UI.WebControls.DataGrid dgWHtotalShipped;
		protected System.Web.UI.WebControls.DataGrid dgWHagents;
		protected System.Web.UI.WebControls.DataGrid dgShippingAgents;
		protected System.Web.UI.WebControls.TextBox txtbCity;
		protected System.Web.UI.WebControls.Button btnShipDetail;


		protected System.Web.UI.WebControls.Button btnTotalSales;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			this.dgSales.Visible = false;
			this.dgWarehouse.Visible = false;
			this.dgShippingAgents.Visible = false;
			this.dgWHitems.Visible = false;
			this.dgWHtotalShipped.Visible = false;
			this.dgWHagents.Visible = false;
			this.lblWHDetailTitle.Visible = false;

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnTotalSales.Click += new System.EventHandler(this.btnTotalSales_Click);
			this.btnShipDetail.Click += new System.EventHandler(this.btnShipDetail_Click);
			this.dgWarehouse.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.dgWarehouse_ItemCommand);
			this.btnWarehouses.Click += new System.EventHandler(this.btnWarehouses_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnTotalSales_Click(object sender, System.EventArgs e)
		{
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	

			string strSql = "SELECT Quantities.catalog# as 'Catalog Number', Quantities.title as Title, " + 
									"SalePrice, QuantitySold, SalePrice*QuantitySold as TotalSales " +
							"FROM " +
								"(SELECT catalog#, title, price as SalePrice " +
								 "FROM products " +
								 "WHERE catalog# not in (SELECT item " +
														"FROM discounts) " +
								"UNION " +
								"SELECT catalog#, title, price*(1-reduction) as SalePrice " +
								"FROM products, sales, discounts " +
								"WHERE catalog#=item and sale=id) as Prices, " +

								"(SELECT catalog#, title, sum(quantity) as QuantitySold " +
								"FROM products left outer join nauledge_billing..orders on catalog#=item " +
								"GROUP BY catalog#, title) as Quantities " +
							"WHERE Prices.catalog#=Quantities.catalog#";
										
			sqlCom = new SqlCommand(strSql, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows) 
			{
				dgSales.DataSource = sqlRdr;
				dgSales.DataBind();
				dgSales.Visible = true;
			}

		}

		private void btnWarehouses_Click(object sender, System.EventArgs e)
		{
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	
			string strSql = "SELECT Id, Address, City, State, Zip FROM warehouses";
													
			sqlCom = new SqlCommand(strSql, sqlConn);	
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows) 
			{
				dgWarehouse.DataSource = sqlRdr;
				dgWarehouse.DataBind();
				dgWarehouse.Visible = true;
			}
		
		}

		private void dgWarehouse_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			if( e.CommandName == "InStock" )
			{
				string id =  e.Item.Cells[1].Text; //id number of warehouse
				string address = e.Item.Cells[2].Text;  //address of warehouse
				ShowWarehouseDetails(id, address);
			}
		}

		//display type details about warehouse id
		private void ShowWarehouseDetails(string id, string address)
		{
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	
			//items in stock
			string strSql = "SELECT item as 'Items in Stock' " +
						 "FROM warehouses left outer join stock on id=warehouse " +
						 //"WHERE quantity > 0 AND id='" + id + "'";
						 "WHERE quantity > 0 AND id=@ident";
			//shipping agents
			string strSql2 = "SELECT a.name as 'Shipping Agents' " +
							 "FROM gwu_shipping..agents as a, gwu_shipping..ships_via as sv, frewen_inventory..Warehouses as w " +
							 "WHERE a.name=sv.agent AND sv.warehouse=w.id AND w.id=@ident";
			//total items shippped
			string strSql3 = "SELECT sum(quantity) as 'Total Items Shipped' " +
							 "FROM gwu_shipping..packages AS p, gwu_shipping..contents as c " +
							 "WHERE p.trackingid=c.package AND p.trackingid=@ident";
							 

/*"SELECT  sum(quantity) as 'Total Items Shipped' " +
							 "FROM warehouses as w full outer join gwu_shipping..packages as p on id=warehouse " +
									"full outer join nauledge_billing..orders as o on p.invoice=o.invoice " +
							 "WHERE w.id='" + id + "' " +
							 "GROUP BY warehouse, w.address";*/
													
			sqlCom = new SqlCommand(strSql, sqlConn);	//in stock
			sqlCom.Parameters.Add("@ident", id);
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows) 
			{
				dgWHitems.DataSource = sqlRdr;
				dgWHitems.DataBind();
				dgWHitems.Visible = true;
			}
			sqlRdr.Close();

			sqlCom = new SqlCommand(strSql2, sqlConn);	//agents
			sqlCom.Parameters.Add("@ident", id);
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows) 
			{
				dgWHagents.DataSource = sqlRdr;
				dgWHagents.DataBind();
				dgWHagents.Visible = true;
			}
			sqlRdr.Close();

			sqlCom = new SqlCommand(strSql3, sqlConn);	//total shipped
			sqlCom.Parameters.Add("@ident", id);
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows) 
			{
				dgWHtotalShipped.DataSource = sqlRdr;
				dgWHtotalShipped.DataBind();
				dgWHtotalShipped.Visible = true;
			}
			sqlRdr.Close();

			lblWHDetailTitle.Text = "Details for Warehouse " + id + ", " + address;
			lblWHDetailTitle.Visible = true;
			dgWarehouse.Visible = true;

			sqlConn.Close();

		}

		private void btnShipDetail_Click(object sender, System.EventArgs e)
		{
			sqlConn = new SqlConnection( strSqlString );
			sqlConn.Open();	                                
			string 	strSql = "SELECT Agent, shipMethods.[Option], Price, " +
									 "Pricing = case Pricing when 'f' then 'flat rate' when 'w' then 'per pound' when 'i' then 'per item' end, " +
									 "max_weight, max_items, timesUsed.[times used] " +
							 "FROM " +
								"(SELECT Agent, shipping_option as 'Option', price_type as Pricing, price, max_weight, max_items, id " +
								"FROM gwu_shipping..methods " +
								"WHERE id not in (SELECT method " +
												 "FROM gwu_shipping..unreachable_cities " +
												 //"WHERE city='" + txtbCity.Text + "')) AS shipMethods left outer join " +
												 "WHERE city=@city)) AS shipMethods left outer join " +

								"(SELECT method, count(*) as 'times used' " +
								"FROM gwu_shipping..packages as p, gwu_shipping..methods as m " +
								"WHERE p.method=m.id AND city=@city " +
								"GROUP BY method) as timesUsed on shipMethods.id=timesUsed.method";

			sqlCom = new SqlCommand(strSql, sqlConn);
			sqlCom.Parameters.Add("@city", txtbCity.Text);
			sqlRdr = sqlCom.ExecuteReader();

			if (sqlRdr.HasRows) 
			{
				dgShippingAgents.DataSource = sqlRdr;
				dgShippingAgents.DataBind();
				dgShippingAgents.Visible = true;
			}
			sqlRdr.Close();
		}


	}
}
