namespace gibble
{
	using System;
	using System.Collections;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Data.SqlClient;

	/// <summary>
	///		Summary description for ShippingMethodChooser.
	/// </summary>
	public class ShippingMethodChooser : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.DropDownList dropShippingOption;
		protected System.Web.UI.WebControls.Label lblCarrier;
		protected System.Web.UI.WebControls.Label lblPrice;
		protected System.Data.SqlClient.SqlConnection sqlConnection1;
		protected System.Data.SqlClient.SqlCommand sqlShippingMethods;
		protected System.Web.UI.WebControls.Label lblEstimatedDeliveryTime;
		protected System.Web.UI.WebControls.Label lblMethodID;
		private string city;
		protected System.Web.UI.WebControls.Label lblPackageNumber;
		private int index;

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		public void Initialize(IEnumerable options, string city, int index)
		{
			this.city = city;
			this.index = index;
			this.SetOptions(options);
			this.updateShippingMethodInfo();
			this.lblPackageNumber.Text = (index + 1).ToString();
		}

		private void updateShippingMethodInfo()
		{
			this.sqlConnection1.Open();
			ArrayList p = (ArrayList)this.Session["packages"];

			this.sqlShippingMethods.Parameters["@city"].Value = this.City;
			this.sqlShippingMethods.Parameters["@warehouse"].Value = ((Package)p[this.index]).Warehouse;
			this.sqlShippingMethods.Parameters["@weight"].Value = ((Package)p[this.index]).Weight(this.sqlConnection1);
			this.sqlShippingMethods.Parameters["@items"].Value = ((Package)p[this.index]).ItemCount();
			this.sqlShippingMethods.Parameters["@option"].Value = this.dropShippingOption.SelectedValue;
			SqlDataReader reader = this.sqlShippingMethods.ExecuteReader();
			if (reader.Read())
			{
				((Package)p[this.index]).Method = reader.GetInt32(0); // set the package method
				this.lblCarrier.Text = reader.GetString(1); // carrier
				this.lblPrice.Text = string.Format("{0:c}", float.Parse(reader.GetSqlMoney(3).ToString())); // price
				this.lblEstimatedDeliveryTime.Text = string.Format("{0} days", reader.GetInt32(4)); // estimated delivery time
			}
			reader.Close();

			this.sqlConnection1.Close();
		}

		public void SetOptions(IEnumerable options)
		{
			this.dropShippingOption.Items.Clear();
			foreach (string s in options)
			{
				this.dropShippingOption.Items.Add(s);
			}
		}

		public string Carrier
		{
			get
			{
				return this.lblCarrier.Text;
			}
			set
			{
				this.lblCarrier.Text = value;
			}
		}

		public string Price
		{
			get
			{
				return this.lblPrice.Text;
			}
			set
			{
				this.lblPrice.Text = value;
			}
		}

		public string EstimatedDeliveryTime
		{
			get
			{
				return this.lblEstimatedDeliveryTime.Text;
			}
			set
			{
				this.lblEstimatedDeliveryTime.Text = value;
			}
		}

		public string City
		{
			get
			{
				return this.city.ToString();
			}
			set
			{
				this.city = value;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.sqlConnection1 = new System.Data.SqlClient.SqlConnection();
			this.sqlShippingMethods = new System.Data.SqlClient.SqlCommand();
			// 
			// sqlConnection1
			// 
			this.sqlConnection1.ConnectionString = "workstation id=CHERRY;packet size=4096;user id=gwu;data source=iisqlsrv;persist s" +
				"ecurity info=True;initial catalog=gwu_shipping;password=uwg";
			// 
			// sqlShippingMethods
			// 
			this.sqlShippingMethods.CommandText = "SELECT methods.id, methods.agent AS Carrier, methods.shipping_option AS \'Shipping" +
				" Option\', CASE price_type WHEN \'f\' THEN price WHEN \'w\' THEN price * CONVERT(MONE" +
				"Y, @weight) WHEN \'i\' THEN price * CONVERT(MONEY, @items) END AS Price, methods.d" +
				"ays_promised AS \'Expected Delivery Time\' FROM frewen_inventory.dbo.Warehouses IN" +
				"NER JOIN ships_via ON frewen_inventory.dbo.Warehouses.id = ships_via.warehouse I" +
				"NNER JOIN methods ON ships_via.agent = methods.agent WHERE (frewen_inventory.dbo" +
				".Warehouses.id = @warehouse) AND (methods.max_weight IS NULL) AND (methods.max_i" +
				"tems IS NULL) AND (NOT EXISTS (SELECT * FROM unreachable_cities WHERE method = m" +
				"ethods.id AND LOWER(city) = LOWER(@city))) AND (CASE price_type WHEN \'f\' THEN pr" +
				"ice WHEN \'w\' THEN price * CONVERT(MONEY, @weight) WHEN \'i\' THEN price * CONVERT(" +
				"MONEY, @items) END <= ALL (SELECT CASE price_type WHEN \'f\' THEN price WHEN \'w\' T" +
				"HEN price * CONVERT(MONEY, @weight) WHEN \'i\' THEN price * CONVERT(MONEY, @items)" +
				" END FROM frewen_inventory..Warehouses, ships_via, methods WHERE frewen_inventor" +
				"y..Warehouses.id = @warehouse AND frewen_inventory..Warehouses.id = ships_via.wa" +
				"rehouse AND ships_via.agent = methods.agent AND methods.shipping_option = @OPTIO" +
				"N AND (methods.max_weight IS NULL OR (@weight <= max_weight)) AND (methods.max_i" +
				"tems IS NULL OR (@items <= max_items)) AND NOT EXISTS (SELECT * FROM unreachable" +
				"_cities WHERE method = methods.id AND LOWER(city) = LOWER(@city)))) AND (methods" +
				".shipping_option = @option) OR (frewen_inventory.dbo.Warehouses.id = @warehouse)" +
				" AND (methods.max_items IS NULL) AND (NOT EXISTS (SELECT * FROM unreachable_citi" +
				"es WHERE method = methods.id AND LOWER(city) = LOWER(@city))) AND (CASE price_ty" +
				"pe WHEN \'f\' THEN price WHEN \'w\' THEN price * CONVERT(MONEY, @weight) WHEN \'i\' TH" +
				"EN price * CONVERT(MONEY, @items) END <= ALL (SELECT CASE price_type WHEN \'f\' TH" +
				"EN price WHEN \'w\' THEN price * CONVERT(MONEY, @weight) WHEN \'i\' THEN price * CON" +
				"VERT(MONEY, @items) END FROM frewen_inventory..Warehouses, ships_via, methods WH" +
				"ERE frewen_inventory..Warehouses.id = @warehouse AND frewen_inventory..Warehouse" +
				"s.id = ships_via.warehouse AND ships_via.agent = methods.agent AND methods.shipp" +
				"ing_option = @OPTION AND (methods.max_weight IS NULL OR (@weight <= max_weight))" +
				" AND (methods.max_items IS NULL OR (@items <= max_items)) AND NOT EXISTS (SELECT" +
				" * FROM unreachable_cities WHERE method = methods.id AND LOWER(city) = LOWER(@ci" +
				"ty)))) AND (methods.shipping_option = @option) AND (@weight <= methods.max_weigh" +
				"t) OR (frewen_inventory.dbo.Warehouses.id = @warehouse) AND (methods.max_weight " +
				"IS NULL) AND (NOT EXISTS (SELECT * FROM unreachable_cities WHERE method = method" +
				"s.id AND LOWER(city) = LOWER(@city))) AND (CASE price_type WHEN \'f\' THEN price W" +
				"HEN \'w\' THEN price * CONVERT(MONEY, @weight) WHEN \'i\' THEN price * CONVERT(MONEY" +
				", @items) END <= ALL (SELECT CASE price_type WHEN \'f\' THEN price WHEN \'w\' THEN p" +
				"rice * CONVERT(MONEY, @weight) WHEN \'i\' THEN price * CONVERT(MONEY, @items) END " +
				"FROM frewen_inventory..Warehouses, ships_via, methods WHERE frewen_inventory..Wa" +
				"rehouses.id = @warehouse AND frewen_inventory..Warehouses.id = ships_via.warehou" +
				"se AND ships_via.agent = methods.agent AND methods.shipping_option = @OPTION AND" +
				" (methods.max_weight IS NULL OR (@weight <= max_weight)) AND (methods.max_items " +
				"IS NULL OR (@items <= max_items)) AND NOT EXISTS (SELECT * FROM unreachable_citi" +
				"es WHERE method = methods.id AND LOWER(city) = LOWER(@city)))) AND (methods.ship" +
				"ping_option = @option) AND (@items <= methods.max_items) OR (frewen_inventory.db" +
				"o.Warehouses.id = @warehouse) AND (NOT EXISTS (SELECT * FROM unreachable_cities " +
				"WHERE method = methods.id AND LOWER(city) = LOWER(@city))) AND (CASE price_type " +
				"WHEN \'f\' THEN price WHEN \'w\' THEN price * CONVERT(MONEY, @weight) WHEN \'i\' THEN " +
				"price * CONVERT(MONEY, @items) END <= ALL (SELECT CASE price_type WHEN \'f\' THEN " +
				"price WHEN \'w\' THEN price * CONVERT(MONEY, @weight) WHEN \'i\' THEN price * CONVER" +
				"T(MONEY, @items) END FROM frewen_inventory..Warehouses, ships_via, methods WHERE" +
				" frewen_inventory..Warehouses.id = @warehouse AND frewen_inventory..Warehouses.i" +
				"d = ships_via.warehouse AND ships_via.agent = methods.agent AND methods.shipping" +
				"_option = @OPTION AND (methods.max_weight IS NULL OR (@weight <= max_weight)) AN" +
				"D (methods.max_items IS NULL OR (@items <= max_items)) AND NOT EXISTS (SELECT * " +
				"FROM unreachable_cities WHERE method = methods.id AND LOWER(city) = LOWER(@city)" +
				"))) AND (methods.shipping_option = @option) AND (@weight <= methods.max_weight) " +
				"AND (@items <= methods.max_items)";
			this.sqlShippingMethods.Connection = this.sqlConnection1;
			this.sqlShippingMethods.Parameters.Add(new System.Data.SqlClient.SqlParameter("@warehouse", System.Data.SqlDbType.Int, 4, "id"));
			this.sqlShippingMethods.Parameters.Add(new System.Data.SqlClient.SqlParameter("@weight", System.Data.SqlDbType.Variant));
			this.sqlShippingMethods.Parameters.Add(new System.Data.SqlClient.SqlParameter("@items", System.Data.SqlDbType.Variant));
			this.sqlShippingMethods.Parameters.Add(new System.Data.SqlClient.SqlParameter("@city", System.Data.SqlDbType.VarChar));
			this.sqlShippingMethods.Parameters.Add(new System.Data.SqlClient.SqlParameter("@option", System.Data.SqlDbType.VarChar));
			this.dropShippingOption.SelectedIndexChanged += new System.EventHandler(this.dropShippingOption_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void dropShippingOption_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			this.updateShippingMethodInfo();
		}
	}
}
